-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0,1},{0,0,1,1}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,-1},{1,0,-1,0}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{0,3},{1,2},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 0, nvert: 1
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{3},{4}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0},{0}};
linealitydesired = matrix {{1,0},{0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 11
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0,1,0,1,0,1,0,1,0},{0,0,1,1,0,0,1,1,0,0,1},{1,1,1,1,0,0,0,0,0,0,0},{0,0,0,0,1,1,1,1,0,0,0}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,-1,0,0,-1,0},{0,0,1,-1,0,-1,0,0},{1,0,0,1,0,0,0,-1},{0,0,0,1,1,0,0,-1}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2,4,7},{2,4,6,7},{1,4,5,7},{3,4,5,6,7},{0,1,2,7},{0,2,6,7},{0,1,5,7},{0,3,5,6,7},{0,1,2,4},{0,2,3,4,6},{0,1,3,4,5}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 5, dim: 4, nvert: 11
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0,1,0,1,0,1,0,1,0},{0,0,1,1,0,0,1,1,0,0,1},{1,1,1,1,0,0,0,0,0,0,0},{0,0,0,0,1,1,1,1,0,0,0},{0,0,0,0,0,0,0,0,1,1,1}};
raysP = map(QQ^5, QQ^0, 0);
linealityP = map(QQ^5, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,-1,0,0,-1,0},{0,0,1,-1,0,-1,0,0},{1,0,0,1,0,0,0,-1},{0,0,0,1,1,0,0,-1},{0,0,0,0,0,0,0,0}};
linealitydesired = matrix {{0},{0},{1},{1},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2,4,7},{2,4,6,7},{1,4,5,7},{3,4,5,6,7},{0,1,2,7},{0,2,6,7},{0,1,5,7},{0,3,5,6,7},{0,1,2,4},{0,2,3,4,6},{0,1,3,4,5}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 5, dim: 5, nvert: 7
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0,1,1,1,3},{0,0,1,1,0,0,4},{1,1,1,1,0,0,0},{0,0,0,0,1,0,0},{0,0,0,0,0,1,0}};
raysP = map(QQ^5, QQ^0, 0);
linealityP = map(QQ^5, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,0,-1,0,0,0,0},{0,1,0,-1,0,0,0},{3,4,-2,-3,0,0,-1},{2,4,-2,-4,0,1,-1},{2,4,-2,-4,1,0,-1}};
linealitydesired = map(QQ^5, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,4,5,6},{1,2,4,5,6},{0,3,4,5,6},{2,3,4,5,6},{0,1,2,3,4,6},{0,1,2,3,5,6},{0,1,2,3,4,5}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0},{0,0,1}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,0},{-1,0,1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,2},{0,1}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 5, dim: 4, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0,1,1,3},{0,0,1,1,0,4},{1,1,1,1,0,0},{0,0,0,0,1,0},{0,0,0,0,0,1}};
raysP = map(QQ^5, QQ^0, 0);
linealityP = map(QQ^5, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,0,-1,0,0,0},{0,1,0,-1,0,0},{3,4,-2,-3,0,-1},{2,4,-2,-4,1,-1},{0,0,0,0,0,0}};
linealitydesired = matrix {{0},{0},{1},{1},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,4,5},{1,2,4,5},{0,3,4,5},{2,3,4,5},{0,1,2,3,5},{0,1,2,3,4}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 0, nvert: 1
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1},{0}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0},{0}};
linealitydesired = matrix {{1,0},{0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,1/2},{0,0,11/2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,0,1},{-1/11,1,-1/11}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,1},{0,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 8
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{3/2,-1/2,1/2,1/2,1/2,1/2,1/2,1/2},{1/2,1/2,3/2,-1/2,1/2,1/2,1/2,1/2},{1/2,1/2,1/2,1/2,3/2,-1/2,1/2,1/2},{1/2,1/2,1/2,1/2,1/2,1/2,3/2,-1/2}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1},{-1,-1,-1,-1,1,1,1,1,1,1,1,1,-1,-1,-1,-1},{-1,-1,1,1,1,1,-1,-1,1,1,-1,-1,1,1,-1,-1},{1,-1,1,-1,1,-1,-1,1,-1,1,-1,1,-1,1,-1,1}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{8,9,10,11,12,13,14,15},{0,1,2,3,4,5,6,7},{0,1,2,3,12,13,14,15},{4,5,6,7,8,9,10,11},{0,1,6,7,10,11,14,15},{2,3,4,5,8,9,12,13},{1,3,5,6,8,10,12,14},{0,2,4,7,9,11,13,15}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{3/2,-1/2,1/2,1/2},{1/2,1/2,3/2,-1/2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,-1,-1},{1,-1,-1,1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{2,3},{0,1},{1,2},{0,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 1, nvert: 1
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1},{2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = matrix {{0},{1}};
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = map(QQ^2, QQ^0, 0);
linealitydesired = matrix {{1},{0}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,0,1,3/2,5/2,5/2},{0,1/2,5/2,5/2,0,1/2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,1,0,-1,-1},{1,0,-1/2,-1,-1/2,0}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{1,2},{2,3},{3,4},{0,5},{4,5}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 5
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{5/3,-1/3,-1,1,1/3},{1/3,-5/3,1,-1,5/3}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,1,-1,-1},{2,-2,1/4,-1,1/2}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{3,4},{0,2},{1,2},{0,4},{1,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 1, dim: 1, nvert: 2
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,15}};
raysP = map(QQ^1, QQ^0, 0);
linealityP = map(QQ^1, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1}};
linealitydesired = map(QQ^1, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1},{0}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: -1, nvert: 0
-- Checking normal_fan + several booleans
TEST ///
verticesP = map(QQ^2, QQ^0, 0);
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = map(QQ^2, QQ^0, 0);
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 1, nvert: 1
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0},{0}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = matrix {{1},{1}};
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = map(QQ^2, QQ^0, 0);
linealitydesired = matrix {{-1},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 2, dim: -1, nvert: 0
-- Checking normal_fan + several booleans
TEST ///
verticesP = map(QQ^2, QQ^0, 0);
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = map(QQ^2, QQ^0, 0);
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 10
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{3330883453830711/4503599627370496,853624150927223/2251799813685248,-2356553346050111/18014398509481984,8539723551892617/9007199254740992,-851543628576541/1125899906842624,5316837853882195/9007199254740992,-6538305985494021/9007199254740992,-1749267935005635/4503599627370496,7424579411304029/9007199254740992,-6887392800778413/18014398509481984},{-2298030817950255/18014398509481984,7698990389472477/9007199254740992,5054138723166979/9007199254740992,-4611252879029533/72057594037927936,7431314160210763/36028797018963968,3306083656494553/4503599627370496,-5119504026856145/9007199254740992,3819013085252451/4503599627370496,4143898238679627/9007199254740992,-5765394822723937/9007199254740992},{-5952332624486941/9007199254740992,-1596589986555531/4503599627370496,-7361860108925987/9007199254740992,-1402721951416725/4503599627370496,-1397989901669917/2251799813685248,3023262654016433/9007199254740992,-6977355308041419/18014398509481984,3248144300909891/9007199254740992,-1486048987021867/4503599627370496,-6002567455236229/9007199254740992}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,-1,-1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1},{-44579928701577317537651253200841/51894724291563534050210877879505,-15701373045711447922845966302445/15404771123625084781539131855594,-3501125185278422965270696549633/3122821338739084840792883286866,-55228066624563312478254429271949/6621599294598900589652414097938,120142383507582197243199728437381/8084188145793725279203688369944,-111341809240055664571911808586659/76972177657674540200232550278541,7297571300091599151751392189772/29609553812244423504592728106921,57582004016524483838099502969478/151189885071826254692495399928433,-3307137770655639630104724597440/53700167453247199213158679994849,-116803526287883759434174588839635/34580975135927942243574654312938,13850085013344855522773355887391/6818528060217462587852947510909,480466100874886052369285336969936/115034162003927310112709182839181,213433847422687136167242464209620/58557609979467276556731753822023,63412859354020491413375816259867/28996934811782641661107752550115,-2680744756838196321854157910496/10937629307262539547157488890951,-25570123189749367929383738810624/119597613426197722851154758944867},{184914068801775237924440155455677/103789448583127068100421755759010,26933806422179042513723576438601/15404771123625084781539131855594,2404747912716946201299872316723/21859749371173593885550183008062,-7629217969444610664921388076327/6621599294598900589652414097938,-115580771581373778595914316892651/4042094072896862639601844184972,175792615486297400307821108914777/307888710630698160800930201114164,214868202830604470995803376144337/59219107624488847009185456213842,171320946886386780877737144372595/151189885071826254692495399928433,-197644795365060385047253064036618/590701841985719191344745479943339,36007901243263107943040099596727/34580975135927942243574654312938,197756724530638510637354434024943/13637056120434925175705895021818,-656167539362841137132305487638448/115034162003927310112709182839181,-126921990990208440938039562800373/58557609979467276556731753822023,46126130931291503571272729738481/231975478494261133288862020400920,-19191218393050429781956323408550/76563405150837776830102422236657,76024553602469420731877843786411/119597613426197722851154758944867}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,10,13,15},{1,2,3,9},{0,1,5,6,9,10},{11,12,13,14,15},{5,6,7,8},{2,3,4,11,14},{4,7,8,11,12},{3,4,5,8,9},{0,1,2,14,15},{6,7,10,12,13}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 19
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{3/32,7/64,3/4,-3/16,-5/32,-3/4,-1/4,1/64,-7/8,-1,5/8,5/32,-3/4,3/64,-7/32,-3/8,3/8,-1,-1/32},{5/8,5/8,3/8,-1/2,1,1/2,-3/32,-1/4,7/256,-1/4,-3/4,-7/128,5/8,-3/8,-7/128,-7/8,5/8,3/16,1},{-3/4,-3/4,-5/8,-3/4,1/4,1/4,1,1,-1/2,-3/16,3/8,-1,7/256,7/8,1,-3/8,3/4,5/64,5/16}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,-1,-1,1,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,0,1,-1,-1,-1,-1,-1,-1},{37/344,29/8,604/449,11/7,239/56,-1,-232/327,88/249,-1330/597,-35528/30447,0,-19/16,-19/16,-4/5,704/1013,-544/3447,-228/373,-9056/17109,-16/53,408/979,452/365,144/199,-40/27,217/148,17/10,-145/24,-1,-740/417,-6/5,-143/64,-37/32,-170/151,82/109,-13/115},{-365/344,-31/8,917/898,15/14,-229/112,87/32,475/218,1331/664,216/199,216/199,-1,-2437/1536,-2/3,-13/10,1030/1013,896/3447,-128/373,6208/17109,-48/53,-672/979,-58/73,487/398,-2,-547/592,-29/20,2,3/8,-681/278,-451/80,21/32,-1/16,3471/1208,629/872,-29/115}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{5,6,8,9,26},{5,25,26,29,31},{29,30,31,32,33},{2,3,7,21},{8,11,12,22,25,26},{11,12,13,16,18},{10,13,18,19,20,23,24},{0,1,10,24,28},{6,7,9,14,15,17,21},{14,15,19,20},{0,1,2,3,4,32,33},{2,5,6,7,31,32},{8,9,12,16,17},{1,4,23,24},{10,11,13,22,27,28},{3,4,14,20,21,23},{0,27,28,30,33},{15,16,17,18,19},{22,25,27,29,30}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 5
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,1,0,-1,-1},{0,1,1,-1,0}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,1,0,-1},{2,-1,0,-1,0}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,4},{3,4},{1,3},{0,2},{1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 5
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,1,0,-1,-1},{0,1,1,-1,0}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,1,0,-1},{2,-1,0,-1,0}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,4},{3,4},{1,3},{0,2},{1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,1,0,-1},{0,1,1,-1}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,-1,-1,0},{-1/2,2,0,-1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{2,3},{0,3},{0,1}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{3,5/3,1},{3,1,5/2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,1},{2/3,-4,4/9}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{0,2},{1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 8
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{5200308914369309/9007199254740992,-5200308914369309/9007199254740992,5200308914369309/9007199254740992,-5200308914369309/9007199254740992,5200308914369309/9007199254740992,-5200308914369309/9007199254740992,5200308914369309/9007199254740992,-5200308914369309/9007199254740992},{-5200308914369309/9007199254740992,-5200308914369309/9007199254740992,5200308914369309/9007199254740992,5200308914369309/9007199254740992,-5200308914369309/9007199254740992,-5200308914369309/9007199254740992,5200308914369309/9007199254740992,5200308914369309/9007199254740992},{-5200308914369309/9007199254740992,-5200308914369309/9007199254740992,-5200308914369309/9007199254740992,-5200308914369309/9007199254740992,5200308914369309/9007199254740992,5200308914369309/9007199254740992,5200308914369309/9007199254740992,5200308914369309/9007199254740992}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,0,0,-1},{0,0,1,0,-1,0},{1,0,0,-1,0,0}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,2,5},{0,1,2},{0,4,5},{0,1,4},{2,3,5},{1,2,3},{3,4,5},{1,3,4}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,1,0,-1,-1},{1,1,0,-1,-1,0}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,0,1,1,0,-1},{1,1,0,-1,-1,0}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{3,4},{4,5},{0,5},{0,1},{1,2},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 24
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,-1,0,1,0,0,1,1,0,1,0,-1,-1,0,0,1,0,0,-1,0,-1,0,0,-1},{0,0,0,-1,0,0,0,-1,0,0,-1,0,0,-1,0,-1,0,-1,1,1,1,1,1,1},{-1,1,1,0,0,0,0,0,1,-1,1,1,0,0,-1,-1,-1,0,0,0,1,-1,0,0},{-1,1,-1,-1,-1,1,-1,0,0,0,0,0,1,0,0,0,1,1,1,-1,0,0,0,0}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,-1,-1,0,-1,1,1,0,0,1,1,1,1,-1,0,1,1,1,0,-1,-1,-1,-1,-1},{0,-1,0,1,0,1,0,0,0,1,0,1/2,0,-1,-1,1,1,0,0,-1,0,-1/2,-1,0},{1,0,0,0,-1,1,0,-1,0,0,0,1/2,1,-1,0,0,1,1,0,-1,-1,-1/2,0,0},{0,-1,-1,0,-1,0,1,0,-1,0,0,1/2,0,-1,0,1,1,1,1,0,0,-1/2,0,0}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,16,17,18,22,23},{4,7,8,9,10,13},{6,7,15,18,19,20},{3,15,16,18,20,23},{6,11,15,16,17,18},{1,2,4,8,13,21},{18,19,20,21,22,23},{2,3,4,20,21,23},{4,7,13,19,20,21},{0,1,2,21,22,23},{3,4,7,9,15,20},{6,7,9,10,11,15},{5,8,9,10,11,12},{3,5,9,11,15,16},{0,5,11,12,16,17},{0,2,3,5,16,23},{0,1,2,5,8,12},{2,3,4,5,8,9},{1,8,10,12,13,14},{6,14,17,18,19,22},{6,7,10,13,14,19},{0,1,12,14,17,22},{1,13,14,19,21,22},{6,10,11,12,14,17}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 6, dim: 5, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-5,-5,0,0,5,6},{0,6,-5,5,-5,0},{-5,0,6,-5,0,5},{6,5,0,0,-5,-5},{0,-5,5,-5,6,0},{5,0,-5,6,0,-5}};
raysP = map(QQ^6, QQ^0, 0);
linealityP = map(QQ^6, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,-1,1,-1,-1,1},{-21/211,-231/232,1281/5,-1176/1171,210,105/1276},{-20/211,121/1160,22,-121/1171,-22,25/319},{1176/1055,-105/116,21,-1281/1171,-21,105/116},{1/211,-211/232,232,-1276/1171,1171/5,-5/1276},{0,0,0,0,0,0}};
linealitydesired = matrix {{1},{1},{1},{1},{1},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2,3,4,5},{0,1,3,4,5},{0,2,3,4,5},{0,1,2,4,5},{0,1,2,3,5},{0,1,2,3,4}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 3, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,0,0,1,1,1},{1,1,1,0,0,0},{1,1,2,1,1,2},{1,2,1,1,2,1}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,-1,0,0},{0,0,0,0,0},{1,0,0,0,-1},{0,0,0,1,-1}};
linealitydesired = matrix {{1},{1},{0},{0}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,3},{0,1,4},{1,3,4},{0,2,3},{0,2,4},{2,3,4}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 5, dim: 4, nvert: 10
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,0,0,1,1,0,0,0,1,1},{0,0,1,0,1,0,1,1,0,0},{0,1,1,0,0,1,0,0,0,1},{1,1,0,0,0,0,0,1,1,0},{1,0,0,1,0,1,1,0,0,0}};
raysP = map(QQ^5, QQ^0, 0);
linealityP = map(QQ^5, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,0,1,1,0,0,-1,0,0,-1},{1,0,0,1,0,-1,0,0,0,-1},{0,-1,0,1,0,0,0,1,0,-1},{0,0,0,1,-1,0,0,0,1,-1},{0,0,0,0,0,0,0,0,0,0}};
linealitydesired = matrix {{1},{1},{1},{1},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,2,3,4,7},{0,1,2,4,9},{1,2,5,8,9},{0,3,6,7,8},{5,6,7,8,9},{0,1,2,3,8},{2,3,5,7,8},{2,4,5,7,9},{0,4,6,7,9},{0,1,6,8,9}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,-1,0},{1,0,0,-1}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,-1,-1},{1,-1,-1,1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{2,3},{0,1},{0,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 6, dim: 5, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-5,-5,0,0,5,6},{0,6,-5,5,-5,0},{-5,0,6,-5,0,5},{6,5,0,0,-5,-5},{0,-5,5,-5,6,0},{5,0,-5,6,0,-5}};
raysP = map(QQ^6, QQ^0, 0);
linealityP = map(QQ^6, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,-1,1,-1,-1,1},{-21/211,-231/232,1281/5,-1176/1171,210,105/1276},{-20/211,121/1160,22,-121/1171,-22,25/319},{1176/1055,-105/116,21,-1281/1171,-21,105/116},{1/211,-211/232,232,-1276/1171,1171/5,-5/1276},{0,0,0,0,0,0}};
linealitydesired = matrix {{1},{1},{1},{1},{1},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2,3,4,5},{0,1,3,4,5},{0,2,3,4,5},{0,1,2,4,5},{0,1,2,3,5},{0,1,2,3,4}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,0,1},{0,1,0},{1,0,0}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,0},{-1,0,1},{0,0,0}};
linealitydesired = matrix {{1},{1},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,1},{0,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-1,0,0,1},{0,-1,1,0}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,-1,-1},{1,-1,-1,1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{0,3},{1,2},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,0,1},{0,1,0},{1,0,0}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,0},{-1,0,1},{0,0,0}};
linealitydesired = matrix {{1},{1},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,1},{0,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 0, nvert: 1
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1/2},{1/2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0},{0}};
linealitydesired = matrix {{1,0},{0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0},{0,0,1}};
raysP = matrix {{1},{1}};
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,-1,0},{0,-1,1,1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,3},{2,3},{0,1},{1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(not isPure computed)
assert(not isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{2,1,-1,-2,-1,1},{0,1,1,0,-1,-1}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,1,0,-1,-1},{-1,1,-1,1,1,-1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{4,5},{0,5},{0,2},{1,2},{1,3},{3,4}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,-2,-1},{0,0,-1}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,0,1},{1,-1,1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{1,2},{0,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{2,1,-1,-2,-1,1},{0,1,1,0,-1,-1}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,1,0,-1,-1},{-1,1,-1,1,1,-1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{4,5},{0,5},{0,2},{1,2},{1,3},{3,4}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,-1,-2},{0,1,0}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,0,1},{-1,1,-1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{0,2},{1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 1, nvert: 2
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1},{0,0},{0,0}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1},{0,0},{0,0}};
linealitydesired = matrix {{0,0},{1,0},{0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1},{0}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 1, nvert: 2
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1},{0,0},{0,0}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1},{0,0},{0,0}};
linealitydesired = matrix {{0,0},{1,0},{0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1},{0}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 5
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0,1,0},{1,0,0,1,0},{0,0,1,1,2}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,0,1,1,-1,-1},{1,1,0,-2,1/2,-1},{1,0,0,-1,-1/2,1}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,2,3,5},{0,1,4,5},{0,1,2},{3,4,5},{1,2,3,4}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 1, dim: 1, nvert: 2
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1}};
raysP = matrix {{1}};
linealityP = map(QQ^1, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1}};
linealitydesired = map(QQ^1, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 5
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{2,3/2},{3,2},{4,5/2},{5,3}};
raysP = matrix {{1,-1,0},{3/2,2,0},{2,9/2,1},{3,-7/2,-1}};
linealityP = matrix {{1},{-1},{2},{-2}};
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,1,0,1},{-1,-13/15,1,1,1},{1,1/2,-1/2,0,-3/7},{1,13/30,-1/2,-1/2,-3/7}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{2,3,4},{0,1,3,4}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0},{0}};
raysP = matrix {{0,1},{1,1}};
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,-1},{0,1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 1, dim: 1, nvert: 2
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,2}};
raysP = map(QQ^1, QQ^0, 0);
linealityP = map(QQ^1, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1}};
linealitydesired = map(QQ^1, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1},{0}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 8
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-1,0,0,0,0,0,0,1},{0,1,-1,0,0,0,0,0},{0,0,0,1,-1,0,0,0},{0,0,0,0,0,1,-1,0}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1},{-1,-1,-1,-1,1,1,1,1,1,1,1,1,-1,-1,-1,-1},{-1,-1,1,1,1,1,-1,-1,1,1,-1,-1,1,1,-1,-1},{1,-1,1,-1,1,-1,-1,1,-1,1,-1,1,-1,1,-1,1}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,2,3,4,5,6,7},{0,1,2,3,12,13,14,15},{4,5,6,7,8,9,10,11},{0,1,6,7,10,11,14,15},{2,3,4,5,8,9,12,13},{1,3,5,6,8,10,12,14},{0,2,4,7,9,11,13,15},{8,9,10,11,12,13,14,15}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 5
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{55},{1250},{2800}};
raysP = matrix {{-1,0,1,0},{0,-1,0,1},{-80,0,140,5000}};
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,-1,-1},{0,-125/2,-250/7,0},{1/80,1/80,1/140,1/140}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 7, dim: 4, nvert: 16
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1},{-1,-1,1,1,-1,-1,1,1,-1,-1,1,1,-1,-1,1,1},{-1,-1,-1,-1,1,1,1,1,-1,-1,-1,-1,1,1,1,1},{-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1},{-5/2,-1,-1,1/2,-2,-1/2,-1/2,1,-1,1/2,1/2,2,-1/2,1,1,5/2},{-5/4,1/4,1/4,7/4,-5/4,1/4,1/4,7/4,-1/4,5/4,5/4,11/4,-1/4,5/4,5/4,11/4},{-1,-1,1/2,1/2,-1/2,-1/2,1,1,-1/2,-1/2,1,1,0,0,3/2,3/2}};
raysP = map(QQ^7, QQ^0, 0);
linealityP = map(QQ^7, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,0,0,0,0,-1},{0,0,1,0,0,0,-1,0},{0,0,0,1,0,-1,0,0},{1,0,0,0,-1,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0}};
linealitydesired = matrix {{-3/4,-15/44,603/2192},{-3/4,-15/44,-1041/2192},{-1/4,3/22,-433/2192},{-3/4,-1/11,-31/2192},{1,-6/11,-115/548},{0,1,-43/274},{0,0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,2,3},{0,2,3,7},{0,1,3,6},{0,3,6,7},{0,1,2,5},{0,2,5,7},{0,1,5,6},{0,5,6,7},{1,2,3,4},{2,3,4,7},{1,3,4,6},{3,4,6,7},{1,2,4,5},{2,4,5,7},{1,4,5,6},{4,5,6,7}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 0, nvert: 1
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1},{2},{3}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0},{0},{0}};
linealitydesired = matrix {{1,0,0},{0,1,0},{0,0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 5, dim: 5, nvert: 74
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{6730902641522717314961998953235/104776506286137515566857289990144,-390280997608381835232697072991/1864397174641101581339368357888,-28661454104902942433939732686875/599213099946195397458372881022976,-15406128800245753276724909349157/30099827352902650724266352312320,-1348940276325668500074957593851/2697085334304636491828689895424,-75141446950690149587759747394937/165616557448512116164343317397504,-4127179246096640907403890265885/41904101308994666459112740487168,2163445037703968508482316572317/8272174879337969639020747030528,-450191691851794455064904918875/9911153521006773458158718287872,2279981434851121779512083749439/17676604320812387688659128680448,-27824252277803128204504832190717/58693645000177121121239226646528,432519296535220584799240474927507/1077260866563456139894848957186048,3765428054130167415452303705125/222125502036585245242532474912768,-10521689461745455177822871802093/85753133669755553209037369638912,-1615106097963036509945373835895/10989631586614384549803648352256,-153859104600774931051039606447/20406035371046271441470712971264,4095357961966490213093023541807/10600428188431546152758393438208,-37556954633350929381541664662061/120997085920833975034182430097408,296286671065291413809687610328321/1053538385342145802784220758671360,-10037572016285418472076457697283/34633413130182945354295273324544,997853003413383634343654437239/28057515132355876009082573815808,1582119868326493885513507218639/8407088162979660786601711108096,-81569316783071114122199918965583/121058810132428827263998000889856,1120789335983075619818326397155/4134944818141064063042084405248,7914014844818656873551204740075/22266590606652141677541010178048,25236149475136229335454327319069/79666744713521896378976557858816,34436819126181817978168993557249/82379817115275568750484537737216,1075237021510564600709996702909/17773044687234827937178204504064,-23175127494363607504616048277949/210988502108587902922675355385856,-262546879473029603707919740754503/1622551957453061927871757233946624,-19280515772323983437962092252821/35728275856999840664389622431744,-218131885003462022022715316659/469355616747114736836851793920,-32956926220711635100663405748243/449227965645187879958530102394880,-995867185257037157829295479027/13278017017308155570887822671872,-34890800420277220429041632861991/74325346191872223061463382622208,4881578075620478161802803758307/43604575931687752643748567187456,-20580810229325881370831876823683/230674452417758719947424114147328,-18559593442819017269644306113629/108009397080680772287604176453632,88458460007120463175689674713969/220978085925343540969004637093888,-37800542459003165953439084708129/195948843722016143991203635920896,758858976223275895833211232655/2363840771607767955197225074688,66614867809015005947115586555/1881417544855809094232601264128,9691421936173397280519865426369/48606240382070450486122702176256,-234129344117733669655521557354443/488479183229913383369921964015616,572772271277166369007899321289/4213292614681816007099019165696,-17725253852189936798796711715609/73625179114097004834733902790656,-2467413306791997788510344280955/8988565927180644761690706018304,-85229655145351274060232228811983/280192885126197765903285898706944,-628404180535349928731333609701/3709936664406618205468571467776,-642280552501046512786290404317/6459758645495573539114734059520,-327315657767793243998783766913/3134175500792059494205132636160,3323722793616802310017784382157/8990617413053070246706828804096,1407830498052662806322035048261/2881077377630623370955825610752,35711980245977968636464561209/10093496863672162882410132799488,-1803712978445146309490912595779/48179111502188368715192056414208,-4272000456244429145286834506875/6149444231630612191866909622272,-1899152396436366206979095160857/14913336393539997612264159969280,-79885633539449837090851846233/323468803175407180235067621376,-167630647380197786990945515144791/657217633371141849077965278674944,-749163246137013580167389662235/1658390490567448669885812441088,-5658485928621560047787578053135/20374235221048913858078802182144,21899128469814271135939613863441/45568617888980620247557090574336,8995083771771060735599094535787/24917620553257582720908074680320,-4659018797769907867302859829157/45788183250861295204600509366272,6182761421693475070225869587551/60832267043382222623616446496768,-95181007750031517664768387896297/141956724170309861478622472175616,-2532845396902464879676112717701/9542449889035840280145808064512,-3617307262047392943548475040639/70268006390052649658190697332736,-74121539530598398873606680775621/192839276433825988720292456824832,-49879226967660407713626026523023/584973119586817781864237061111808,-49522201761274099182019521066591/78952935354379874649010377588736,-14421542476081339814983748532481/53054540356761081813775547367424,667312808131112830515958873725/1695014187846971091419750465536,-551749439197412304463264245357805/2671042971747034365646309863456768},{7965064963571047990661974269879/13097063285767189445857161248768,2229088198582871639444364821867/29830354794257625301429893726208,-1151744064633648628088591931673/2340676171664825771321769066496,2145096958654462396472974670829/6019965470580530144853270462464,-10525723290363199551782593673797/86306730697748367738518076653568,-31881212010323691645997977395683/82808278724256058082171658698752,20882301837660656381405878009049/83808202617989332918225480974336,-3247489166253543566073686098855/6204131159503477229265560272896,-48189951258451377090286032216733/2537255301377734005288631881695232,193422173033721230934552429571343/2262605353063985624148368471097344,1664452692166777604995330538197/3668352812511070070077451665408,-349178708316418480086063324531239/1077260866563456139894848957186048,-4137667214039165408457690077963/13882843877286577827658279682048,36628341422630448695173972988305/171506267339511106418074739277824,-104270031989255405946445474888353/703336421543320611187433494544384,-4287408942114899427190338576911/81624141484185085765882851885056,1044531660056480550698210323335/10158743680580231729726793711616,122870349026601083185477506377683/241994171841667950068364860194816,-3064238193395914605517733535229/13169229816776822534802759483392,7121989971065341008516212447887/25975059847637209015721454993408,1607187210814660852458271891653/28057515132355876009082573815808,5974129575653224600489116374775/33628352651918643146406844432384,-27576546548265815473564379749289/242117620264857654527996001779712,10895075389827495465482092520049/33079558545128512504336675241984,29490743568262358155021760113843/66799771819956425032623030534144,22882169707515382444261727501521/79666744713521896378976557858816,-1027137756604630684155139079641/20594954278818892187621134434304,-33787938972684823589097355832555/284368714995757246994851272065024,709700154888250295073392607591/52747125527146975730668838846464,-228753373493680613220504777671/1584523395950255788937262923776,-11609384448259671752805283511119/44660344821249800830487028039680,4951449166715010318244791285653/9011627841544602947267554443264,-5749845985147907118554383737101/14038373926412121248704065699840,-607520463481970650216388406289/3319504254327038892721955667968,1583274583421674849338627977345/5308953299419444504390241615872,-31391449607091359924774996275781/54505719914609690804685708984320,-11555679008077558368969397222637/57668613104439679986856028536832,-2608701412841068154625078007003/6750587317542548267975261028352,1481586222944295658850823100921/55244521481335885242251159273472,-3007045330251727214901715433149/48987210930504035997800908980224,-108240639898642410653474213424931/378214523457242872831556011950080,2075036137626593180757888594613/7525670179423236376930405056512,-5061705390633347433157125601825/48606240382070450486122702176256,-4515290081362007265787106032939/15264974475934793230310061375488,248186171944610231946489491591/1296397727594404925261236666368,382747169834834998861276615505/18406294778524251208683475697664,-479593785294655215245696025383417/2301072877358245058992820740685824,5135289724553075263003159276727/70048221281549441475821474676736,-13279245757276656800060650422041/35244398311862872951951428943872,30325921334999442226877079934151/103356138327929176625835744952320,-107839038677592866986291244713069/401174464101383615258256977428480,8878203957537922206357026747511/35962469652212280986827315216384,674059909643007544673679137861/5762154755261246741911651221504,6669803676586111336491149098487/40373987454688651529640531197952,-13773573518448295337824773687363/192716446008753474860768225656832,-231463636747097253361586597425/12298888463261224383733819244544,52000938440254358608783646009/5592501147577499104599059988480,-23562677087222900245816100187885/66877175056515434513600230719488,-21660451933343641272278053192615/82152204171392731134745659834368,94148550224331818453108899944373/424547965585266859490767984918528,79665672352385144871400198763971/325987763536782621729260834914304,-4046169211321087859962148351051/22784308944490310123778545287168,-4718857893936659579984888877001/24917620553257582720908074680320,-40123600378327465056037029412677/366305466006890361636804074930176,3966006532539263535186966481861/15208066760845555655904111624192,-61744958048349796754460953041/8872295260644366342413904510976,1462184541536367936666149952673/4771224944517920140072904032256,-517523027417861842895135851573499/2248576204481684789062102314647552,29230891278611954387812151423/48209819108456497180073114206208,-5879415085666183789715223121129/9140204993544027841628704079872,-820259240608481307307693487755/19738233838594968662252594397184,3928915770255929627217575343551/53054540356761081813775547367424,-191861865212527600876268409985853/1735694528355298397613824476708864,534768793649473304007534010009/869480134032237749233824825344},{-3342652359699167139022539790471/13097063285767189445857161248768,-1534665979565667194785895009701/3728794349282203162678736715776,8333638905581478487649145193153/37450818746637212341148305063936,227099350507606258171259080649/1881239209556415670266647019520,-2549189918856456235279214270633/21576682674437091934629519163392,-3391055148694122261161421520801/165616557448512116164343317397504,4126594342041522852890080789749/13968033769664888819704246829056,-25553532659770934830940661851423/99266098552055635668248964366336,5611796467550617950615919653593/13214871361342364610878291050496,9117296580989591680997009490247/17676604320812387688659128680448,-1436234466833322011675678050943/7336705625022140140154903330816,6702309251531395125465372072179/16832201040054002185857014956032,-1191375422275600760421122131231/6941421938643288913829139841024,-3714838494133717175410872105647/10719141708719444151129671204864,3601528570793678479734188322871/10989631586614384549803648352256,4124308810249996578507623462813/5101508842761567860367678242816,-8276048895725174667756567107057/15238115520870347594590190567424,7835751045453304933163940987397/15124635740104246879272803762176,8779360110100023196809004789615/26338459633553645069605518966784,-271312425918379852558854083675/811720620238662781741295468544,-654489203874942421078944987163/7014378783088969002270643453952,173707664538688098341627228479/4203544081489830393300855554048,40011078672628179149395582213523/121058810132428827263998000889856,6476870628947590114352801910269/16539779272564256252168337620992,16348225413394055150040310271585/66799771819956425032623030534144,1412423539468898929430913210631/19916686178380474094744139464704,-15560074540843728627741726644121/41189908557637784375242268868608,11413196293167785450985319588221/35546089374469655874356409008128,-311185536419451160233993844703/1198798307435158539333382701056,-183154853190352416769378505685/3169046791900511577874525847552,9527964545234817714684521427921/89320689642499601660974056079360,1579767994401995619705563030509/120155037887261372630234059243520,-58983201425072442429570396645023/112306991411296969989632525598720,7546869778526812900451591245475/53112068069232622283551290687488,-10854321791226946298691499424689/74325346191872223061463382622208,-627983529694430921828919399057/6813214989326211350585713623040,-3601608239468940029746861235859/7208576638054959998357003567104,53825733865033525595133408767513/108009397080680772287604176453632,-363638222449790908339937182019/1649090193472712992306004754432,-2772896998307541263493490388279/12246802732626008999450227245056,78704501027233941700112017267317/236384077160776795519722507468800,-4441638733411078661282566836787/7525670179423236376930405056512,-1753983517695115260870924084057/4418749125642768226011154743296,-1983015490753760259194503607515/30529948951869586460620122750976,29795778558961735941298899667/2808861743121210671399346110464,-821730522190183876889418301579/1150393423657765700542717231104,43622254775655200789644696661961/71908527417445158093525648146432,-2229190949124792244296451655047/35024110640774720737910737338368,75585774919127201135954373455/1958022128436826275108412719104,-99741781664673517904615660281/1291951729099114707822946811904,6483423107591433836871080431083/12536702003168237976820530544640,-108826859649811573355633862181/2247654353263267561676707201024,-3708115436847593006902357490845/23048619021044986967646604886016,3870532237408438547643378079637/20186993727344325764820265598976,23458458620045304127588238297139/48179111502188368715192056414208,-88963458112695015782697589019/878492033090087455980987088896,-3871980035763002169953081979227/11185002295154998209198119976960,-1112963538455023576784955779837/66877175056515434513600230719488,12936122378001387600986836735115/20538051042848182783686414958592,-13388686370365297202034685008483/106136991396316714872691996229632,687461546063083194339580772613/1273389701315557116129925136384,-25805768785268132047843931364717/182274471555922480990228362297344,3035961123884614377973000809937/33223494071010110294544099573760,16833355465486492538105681170713/183152733003445180818402037465088,-1964970727894378894803910954259/5069355586948518551968037208064,-711541546661849495453097131897/8872295260644366342413904510976,2753469344034912002988429924169/14313674833553760420218712096768,163965830150859070435754838739267/281072025560210598632762789330944,-851477847073082923708235893731/24104909554228248590036557103104,8631081558121231969359032165547/73121639948352222733029632638976,12855502019727594208123394296261/78952935354379874649010377588736,46112584465630507570974453164301/212218161427044327255102189469696,12901935126394094592232124130935/27120227005551537462716007448576,-3082081120485313123433067687901/10433761608386852990805897904128},{-12308668566877594927456986443287/52388253143068757783428644995072,12092521140967957947599219546835/29830354794257625301429893726208,-14083213712596794813343921883225/37450818746637212341148305063936,92003761259524493894298939875499/481597237646442411588261636997120,7679610560756775980194537637027/43153365348874183869259038326784,340123136112772266489599412873/20702069681064014520542914674688,-579058088656906051659917785793/2619006331812166653694546280448,1252597485851790063258510952783/3102065579751738614632780136448,1341426339432260279014904680505/19822307042013546916317436575744,1659762896389895632197456817775/70706417283249550754636514721792,4478680683340412049888900924293/117387290000354242242478453293056,-65818921124676081288586434901577/718173911042304093263232638124032,-17504752861222139751849206810273/55531375509146311310633118728192,14649609555556855783947125895503/85753133669755553209037369638912,5568244772200243418893459174713/21979263173228769099607296704512,4200029788309206216566429766083/163248282968370171531765703770112,958594560982315267324351401251/15238115520870347594590190567424,5866249943065863810320309015959/120997085920833975034182430097408,-184317331904959610807944722893841/2107076770684291605568441517342720,30493121432348587108320401197039/207800478781097672125771639947264,1916735419076947913376569417777/3507189391544484501135321726976,3027698756661366163018180830937/8407088162979660786601711108096,-7011527632143303094731617535407/60529405066214413631999000444928,-10482756091357278639441333963869/33079558545128512504336675241984,-965159233335537536425991905875/5566647651663035419385252544512,13376309246470951690545806114677/39833372356760948189488278929408,4564343773297586122039171452141/10297477139409446093810567217152,-15793527673123056144393926185453/71092178748939311748712818016256,-8221354054328067582757245587123/13186781381786743932667209711616,-2437813634252807701634925328085/12676187167602046311498103390208,-5140406134677040923539796454051/22330172410624900415243514019840,2458042923071639438442846292825/12015503788726137263023405924352,-3789094791399207327344993018767/14038373926412121248704065699840,6257144472287756017976805089781/13278017017308155570887822671872,-25783464512443489029188959979481/297301384767488892245853530488832,-3577775900968243460824476776259/13626429978652422701171427246080,-3225170165795349114600139599791/14417153276109919996714007134208,-6432237948330146725059274949787/27002349270170193071901044113408,-21980387199943016908202571578563/55244521481335885242251159273472,-1312598781402932334774240231143/24493605465252017998900454490112,771757724628389191007802759489/2954800964509709943996531343360,9252093020603125071725395118413/30102680717692945507721620226048,-3421517553588920851685218338275/6075780047758806310765337772032,-8036692178797023757605686441179/15264974475934793230310061375488,-1408547819020415528245761608033/8426585229363632014198038331392,-2888163320153565192792228189619/12270863185682834139122317131776,23666511371301369207549433700949/71908527417445158093525648146432,-17078200532190162108467175815925/70048221281549441475821474676736,-241158834857542647841603800665/8811099577965718237987857235968,1756547047062910353758907256195/5167806916396458831291787247616,3779762897251443412558726104807/25073404006336475953641061089280,2643594180021758600993361882637/4495308706526535123353414402048,7610427779577871392135493157/53353284770937469832515289088,-2356843676264837408634841390545/3364498954557387627470044266496,-2177432058634588749259083610997/24089555751094184357596028207104,-4665103526396426826200607265355/12298888463261224383733819244544,3201280806535036264196416067891/6391429882945713262398925701120,-161410608806950031197631073443/33438587528257717256800115359744,-141494208217268747366687361844545/1314435266742283698155930557349888,6021384781784930924475174971111/13267123924539589359086499528704,-1655063961840823909702848247403/20374235221048913858078802182144,8988879397989892264729788732879/22784308944490310123778545287168,17744240311776549859226518620683/49835241106515165441816149360640,3438262254087837165761280257337/5723522906357661900575063670784,15612377421943600808208043925621/60832267043382222623616446496768,-3256399937752352010456499227899/70978362085154930739311236087808,15792262983678394082376576142625/57254699334215041680874848387072,3811510477950869497280327681637/17567001597513162414547674333184,-50068557148236607658434945148185/96419638216912994360146228412416,-13800659133274797838172586886319/73121639948352222733029632638976,-621573735873454894736962112211/19738233838594968662252594397184,6030553951047768716924652303703/13263635089190270453443886841856,1105281663047271165454543376475/13560113502775768731358003724288,-4674699382006748209107495645715/41735046433547411963223591616512},{-327090633368046710171817382863/6548531642883594722928580624384,-1928047323478650571023557651423/7457588698564406325357473431552,-38234825510460434284189486821189/149803274986548849364593220255744,54747255947442246721669274435367/240798618823221205794130818498560,-216360402801461882898321272223/899028444768212163942896631808,4566015640403201130497595752895/20702069681064014520542914674688,-13909016036490644168562640661/25182753190501602439370637312,3141853344303619397229010260155/12408262319006954458531120545792,-18124542204482580065490405959935/39644614084027093832634873151488,-14618519850078241260678126794613/35353208641624775377318257360896,1482277437748954265127115941285/7336705625022140140154903330816,5565741942240903048049263617465/16832201040054002185857014956032,-19316195528464694586189049558627/55531375509146311310633118728192,13226066968572548015649946813/24033950019550323208810921984,-422274162265081296426255910799/1569947369516340649971949764608,-10482044688123605201385002249193/40812070742092542882941425942528,79009004507382614075163551839/5079371840290115864863396855808,-16351177517542272701364681898109/241994171841667950068364860194816,7726833739981561283835420578501/16461537270971028168503449354240,-9577766025658476406273604205847/34633413130182945354295273324544,3806812011997473757560783794885/14028757566177938004541286907904,-29412767781422284820792927730351/67256705303837286292813688864768,453393697925145878680721718811/15132351266553603407999750111232,11084083906989750041877375683/2362825610366322321738333945856,625915513667224567086643593015/2783323825831517709692626272256,9276379344889143309582885882551/19916686178380474094744139464704,73619022840303847331269059147/1287184642426180761726320902144,-55436741810449693628088929205/85447330227090518928741367808,17918628642906192932714862944827/52747125527146975730668838846464,-125315512742708073340229170281/198065424493781973617157865472,-6829019627452042968832442503237/44660344821249800830487028039680,27820155563622905575970201135261/360465113661784117890702177730560,15402786769052944015222277137987/112306991411296969989632525598720,-3009941685238754566062742757929/26556034034616311141775645343744,8441472729460510318066805448919/18581336547968055765365845655552,-16813803054441753609274960402473/54505719914609690804685708984320,19037085525017915915875680386053/57668613104439679986856028536832,627836482731444500857295588945/6750587317542548267975261028352,2335964884941219689184684227051/55244521481335885242251159273472,-26448241258577331568840314535005/48987210930504035997800908980224,-8863733085185177392277640807817/59096019290194198879930626867200,10918244757363458004678526681627/60205361435385891015443240452096,-397534564754024870790283002653/24303120191035225243061351088128,-39405774445668880447962453644741/122119795807478345842480491003904,3798321395834457122561332312559/6319938922022724010648528748544,-1025485779675473928142144807117/18406294778524251208683475697664,-295767610448657779564284015499/17977131854361289523381412036608,37253938373714922339479386493781/70048221281549441475821474676736,-1310013180864663971210484602345/5874066385310478825325238157312,1485082796732771939007534744163/2583903458198229415645893623808,-636137699796072280092797278787/6268351001584118988410265272320,26243836625394543169050790180455/143849878608849123947309260865536,-9672532141615173430492521223657/23048619021044986967646604886016,-1041222262092852620536555515131/10093496863672162882410132799488,9474362114689639953516487011965/24089555751094184357596028207104,-9870434576839988586954657496459/49195553853044897534935276978176,2615880358783174991751526209/6172738573485098349447086080,20777384628099139059579445752377/66877175056515434513600230719488,8171789141744145496993783981963/20538051042848182783686414958592,16147102055873167428354725952079/53068495698158357436345998114816,-1466999801344784960215450971011/20374235221048913858078802182144,1838616233596830228992213630619/22784308944490310123778545287168,-3049329233826455655772343254479/33223494071010110294544099573760,713752394277660764529756261667/45788183250861295204600509366272,1086316353360918510614733210983/2534677793474259275984018604032,-7961259621682300617364187955299/35489181042577465369655618043904,885863592338455966172965004989/2385612472258960070036452016128,285107274827231882339149210485/4391750399378290603636918583296,-13095012353813071510715969444249/48209819108456497180073114206208,10514190166624570382995689741163/146243279896704445466059265277952,6685455902168210414679764080331/19738233838594968662252594397184,510783025398787368764031926989/3315908772297567613360971710464,-7206245859511174300594948413631/108480908022206149850864029794304,-4782249048013131528346721170603/13911682144515803987741197205504}};
raysP = map(QQ^5, QQ^0, 0);
linealityP = map(QQ^5, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,1,-1,-1,-1,1,1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,-1,1,1,-1,-1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,-1,-1,-1,1,-1,-1,-1,-1,-1,-1,-1,1,-1,-1,-1,-1,1,-1,-1,-1,-1,-1,-1,-1,1,1,-1,1,-1,-1,-1,1,1,1,-1,1,1,1,1,1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,1,1,1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,1,1,1,1,1,1,1,-1,-1,1,1,1,1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,1,1,1,1,1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,1,1,1,-1,-1,-1,1,1,1,-1,1,-1,-1,-1,1,1,1,1,-1,1,1,1,1,1,1,-1,1,1,1,1,-1,-1,1,-1,-1,1,-1,-1,-1,-1,1,-1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,-1,-1,-1,-1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},{87895433469963268234129924985414434386853285691913145958704582928849304847905011237855619625663605882214387176816384415524031340228485769251/762173017218125494559443003060956130033960979271945436580285488319580546189671455565433113101766752068836394475903370524262861988270401562112,5755308015690165098556341442614388437393942347707811162877912250601321173305719233955984636611542297889060615924979116176274228478824869707/52569191805033203197018782409894891349133849114279138730186599680768280269626920682310630199861945361835400668727543524845748036508106059712,-211220119453143906605316440984254098477889504072380708289132398531865706408390822076181451257169995811771117109144018506773224754386382966699/991372666371880981130280810066216112484656818782329025191322973621160292992811746561486343993624793507702694268214993030397227672509576687264,890043095105425856270580791754893810669182151665899433327752456143196051328229821248639340409051735661042036833495972303886845371285274529670/1343452152598916679007774471037722437179047399835508707808728288534551328972891141616610287216983366589271186273956581261478183219539289689947,19280375902724365154837895417099416213764956278251029040419071807607916087042356649179314832344936503310781961419665004452495769630797673263/28518523150245032711577490661675225014146314442772719597431974421710783646029293232406465957443357037151215856322597903362066749844733282643,448857549753941380702448299999704619377011740428466823526573021412845223913983654173486702572499089841806271835760993583452601555433376768842/499300928557199164242030975800660350359018448980879251695598680500384659575681902525786919086455597564492294350445307552668374725120098363287,202600001575004448582894685380906759303312417441282648925614874627911157914873794512648881494358638571164927094595108094262638992393734303284/162484713279943965693217235890603872484262899071804458454027025279565512387697038237717546682802868683607788374159465773099479122949826126865,2803530668226748291185807071750556333973551266708283194591242319819664277830518448754148888706742629129499190086743991833772008446305287216128/4234907939976858267164364737662844486843021264301493258955111470464378387915597916573659956211106275123310303759580692924292703314892400782769,-3175275362177494353455418509131354031753330054381471356832238741953539211257045344567451350982012216434630856378095164952989368955730939852239/13678133526390011373643571527243329239781945455687492462098120036046383392998119736983114785215360127078289462926793357354218680609492695260444,-756337347813986671372899969942592928303117145434169545065985748414658784505900574010411283774696090795033062488109274530289441405790939441239/5027090221758993992993726244466118181807331367438271199017281290118083204144555411938557539385568006644787216394541741970811092044348002907692,3634077730060354788151340438810005890299441566021760618320814268721117888282474492977689563854143923139433943035270861867815072563074538078799/6624319098148169728486987394090540423341248588550062286898282696305204313591501042245448457279849366493356201497792046644638778915431590319768,22488623455239498964634561250775135623964750181059998270466152046880117948886388289787996166562478198424536530817179519746022169247839120695425/61947409266988367706940583109256946977269564013853663882525258456070275306380299346012380108572662295225042477731339196906129067910703865171921,1855575684628627973780046836231985269761427519030907601280533672254046568117359966005927703293697354650054388136430882717534189825181739396077/23492477760381795283431368533586110043337492428611443679512396906316321840705778448681978943939603889536516653304827264747896386127578938172316,40453957388561920305477529409306333106588101482660197589591666139493240400279321849503905305325842706755314283690638353062497141578081597970261/70804513287868896841806005373303775129352474010058489733760785924553373249193086734817491376119585370845978241850665504112904980769914691994264,16423216483695081487529545080388471271411847271075820758262081091171218792215939706732509539889118162607695098567878961776557458825010520229243/91954810542927178959477412029622837025377310040103370710261485561050814678896585779597951200932265268140505390908041126643508706469038102164728,-11452190571173920639397659626471890822511504601265137051198328557026807193407736922514546362726659950739920441302356994823003978769214696480405/86178147473408440165863300690811984402371271564966257088252072059674953183137145971222574430536823321589752469963307967527636065719281870960422,-13412906647785732539526853535569649911707849134014336329821150355678964313015122649155151453513388483129351834670898382225176249022776195877075/158936636464161854640268779248469143206192680356267870632783433158486584423030033829505763536164237124074268787488330363873429249554427132573068,-946074187108350899240901817626565066263670261064788485519579178366939163840031717179544067982740555080469361458970344096418674043330554467512928/7098429957929935535358029798253342714162733953979245353015671395481333042994726090236587661250901769358367197374200226029833931544488035316964139,1780070804644788958658019628953129681367082334628353201145431616019959794319544949066185260061239510727044674669577590157918817945045273084927576/2337967303944368034369893084378245233965562714175095123775989274977882342371438357772173566935866582541106559173329270649617032501967081606193681,94320305284260440550326778586254418976909356369672120663304871749504920849771808967558668591370229263926404882378914780935152907962283341031808/335887043615910985377780469573984162017193941445639414540090365696258853512437272786602588540373430344640378185175934194447439476235837292968115,1485953867163977022058709644012692977376829320225377099501682218779192665973268142375930880159835127447769979028047667417576803940824338048936832/2499399215304518112254614970881207317953314405217128226944035950888198940165163038636229087888784911709082265777771803607027237643983323966583231,829445814743541319576727120132856738940948833795716700850898947325236364067567957779631103739147104673289675822741870877811744574251588711077/9522121730531002670130574101606239681658123653964538034098466257006632281898117223099181972482269523689669316442178461148984453420083451324580,5132034487578052019646872180909684745791766013362220176201467550302073992400256034764424807781263383211941728030294329037066776458495959060119/33478718847070222856773030417003751432909310347842263608059273689224382569269799640987316022403764631531986459647056001249623946090905353733974,2541970399878229925829546008785237202824326551041152012729606745862837629942184971242396123788618990900487117202781903881832727967579666629002/17608948054502074545816225129462752751890984715980038856909492677276884697024405877977121179698639632847151748627931305671610667717094296154565,10856053654224980901912001353611578422150096710697717584099188106884885526257190506223122979168606480162409092357497215709508785103212610233/87359409117828130294296477984365297535122521532389814590508563349591384576427291276686481471065239541977621602679042912597865498307563861440,555276805314310581649355930600149597095979054046362753679194528414006488921694362416248098993594646949642544338027809711616868511082157198592/643927176330282282906853147365938823373720613249482198008310418664334553515570133928310068318856867020226917260586525738252909199601817810745,7254536608291517198491636739908194013742711115841418401815766914904602462898732812192183624966791496424704291321049377829672217688281387601152/8157216135986461000023542974093573373916660861882648584408071359725913906438401729374671631354886420956905510290604658648590322805831167974407,48988859161675121713379652913829789970938504936884379209279758908384931528590671716944589731661805031625408867727223265675641901807755204864/52769022303790058234718348565988018958986266130020715839155415150835577344372468686647870925841123738709703158420657337073593086212280077543,-1062327181050042664590540009606909187203251432748267650880665182815635111147047213378912824827010600873667688984705608576086476283159389272673/17380350614490166062210899085637641017166591787329851384067315359294018575230322021277597527031969235952269846062199640451397383428679064841271,4237541599668415517994690038662905138922102185334739078708466563144141930536599592093859815146910127119212156090834640657445730448121671700005/22998100842242539518732123755997033357155001955346942341090888405815161819317932304981115010447454412333370147710678013622106328300674869932649,701005577035922145658637871473454346869098172645622901290580134676092800496412787920651664085103695093768504384279447006310788078672593496369/3382728944426837427641742771931536842697286554832818448193555028452078562910105314792315751376289421124934265298763213616338670559187204609849,22421153460912764049259995100491039709322268699710777510626704542703070185138253039708905264867473212854615840060719886486968805346866415967360/68573862228088365515856191761976748357806929243760512640892711782083558336926689642791934655546521924329942582504352224029525523576402989019391,1630844000004996022707023435165767501989268662907168382443346479175139646697982483567426489041890979789126154516554897819789007097805343128320/4175120277652422616349514524941856745685488813029754782910664272420080004518739633040540578283395216620285502529509713742803498884588375516269,23040528602698794176726581170311005354269040656804538628006241372144832276752381879716488250779849854517600525315159979742217150908124582492921/31861699021245568312335036837916542544746478771105144975750899657016272646298057030169611285908000050532332723184898880329480952413651576721804,61330173251545268069920454682888442952012292348248967929161582935059692881074592212332311765376777386920721082907266358764767568395732108504496/104248574036737708072171938996897434597966829668509169773951308111246965849312130869836291564814692019536293330264954723562203871074356957886579,4385282428666736156384698210197896644417708048985602371247822971412167963679478768072187202084530222297076566146868911703447467443375398726071/53513026902078565013578975511494854313254351571141904416113904719983173345574994053157023519637857875641424469179320676358153541794853544387156,2250987955805298076314950427726442489678312665541236087497175725041142749191622743043449759405367291695189750167273796414054403452996952394713/13210908703668021049951195825704129343701416874708700910913876846604878996672561109405291951622364787768181929282167065866916832290483763821993,9731141975288618709440149212784625388404148441996437469169091790847225237102025896896965800857346359710802716207644663143146618210256306884728/29232818692250274663992738101699622344049321856124077006408059621775306128513424137906965364651834958076179058872713070844412847661151281164675,-4242601116636338954066736994531289146844729161498764451789180376040341509868692269711235177624115311606705483383878928464923090791829739398396/44704021559592115190491896006044939839895626324505439754356178453809959746369027090641645339495343633131183776897221119202356253683969723916353,-32903611558551634172215504678745749092749551401320101695053075260279574750463304488366717438154492265796882547021968567016265475914926431357/397294985291123729719228218875775266657145060817681956552073759710882040781010650668026150592680728708919474050048660709668400415029831171451,-3275463113250432744423709040240587873900387390287045669123728166796872876500999124294321113162725127987592864053233090892733037084448994801436/32993318393628161849051221382680569207578147359725073876363055606307926865361169575935834676528131466842570259459018451138962390951622897541393,590957501118483663576460050583032271622793176515778800392595819131578970437272247951469308820828822516839182942004208185598672396319070356868/2326416304231355514498047392617791564633670367064862039758812216772377154122876053142451433898944234456072177951600352795318549045157710939257,-1437505763167579123346192515143198298636111678836034802874650049087969289628717450980848507531220506716371614213001794737262442560246696719619/14723167889735304246783077221762656018578299214600549190168697599617922170656849418519203071826007544149219123614179112643940412627183061656163,73180842357363716573062824958649223479484623541278472350800317503997647156678985813988284198196179070931048861356955337927073284283393344325/231241596732867479430998405918230997389749824144847565919077031537005583727163815863009720948581198166288858282613556876669893386339544243633,4143661568942169531927599869695718826941236302857094600607778684144760938988229378576399130160391343859367673124097948685151172654577231141668/8390568232172214491324910277022361716852931201000213148890613245427998672569112710860475736010430126319934474081152203445058004959437131618221,1660907054504671748004140678268231389207371709413229397984575125193853891332868582748358420256670519981764807246713808672648231946689052369465/3105289391536659613864272269782135008746456586495606627045543794281504094471503542456426400307353299378943749191490328902977793149935212793909,1407468146904103776802713975629264480766717635832245219970531423506126000499099259731649833717384330772440982649720418632948870155683310279843/2617069372475053779142494624756434155590256000927286451078885256192637598588775441288556502153677606826764474649883681933175308541249059746796,36716228648591662644931450280668477097553315122337143518164938735324490089495673273166562040500528577795794754215319157401041531394449157423728/60936056959026033461059760034469190966287691086893187036026045823806564516480923020561483410625430132168245952991093269816005153459537144347705,-47034073806854094990800147506492436301976332568089630989660451910282167548914138734428563437966161930303269938109597387753449366350056644531/192419135722059605870863193957126061495696769926808261581770816105349764682809984561011228583760874741151854578280744054906380732487449147116,-272642977051710864368504539609023495386914574523438960216483159057134753898288738659444789296322446306234372880453472933461795070657447861526/1409168313992133016171805275246110494378398070682210067114299235587844889339056005507505541488599562344978635414352233045917710579985559398293,3865246633993103454957447985974994231609220732955184001839915634446596100197595974100564757365127535544767848522839773571141733486993373356272/9623315661813732661132399391473993509216556191527634142151213375194005945068216848989368860537978489146797926911089382551280721344413063522621,41549599321806038248207961049640598975263914621376550981933096332080186503238546772229686212514953461806371170218272476718349530566169134721472/48632454378820144643890882398288938500833950004194969131498880071363467345374567560528135899204460163300436634135302882391962634136706839842237,-207394768924047923907118790044942327728546287238141242712013890308651165096533140324432827379460455029620411640460478526646845744199714799156384/1374087140217073429962153320380218715261806701036593809955441246266588439519795451188664257439431235809565847498754080051199301055246998492073039,18627276248470101533401399170756953680466858169311556637378660668234098799252868744607107998910569360489386937090208180066718408595464831596624/49396106479013760619872160861680012595121155495809942514885494495218658169910517504420065577112245760828584940892000761152204805950362273848721,602127552244024823447173393963043517442764760976158897665452608671222931226822481739293462828573984674546337006140204710568974745822605330275296/4029124768502246430870903410738518009840517816972986026489837744518631453953369234010680090977789047823674011868727926043429956342659090972824263,-263409239265222836003355944784135882444442127614357836460559017519399579043782165632198724870385648230441231824117232202070915108293926063198568/488665203331399114309628242747368596853407454392953685940549782437539239010526982139139662173242973512745519248380931476790036634391606555534317,-36010875578280713706188627714790111387758858529830607813869062364022353484088943030721203559263291838822824010973897819299488131797683048971192/96258971789799378706620455211789574844972465382147614085560820893777389445253724424826158621963504182464200215582970955089748956578881460408463,4880489926640755240475632632560859886464800907422376203561417326589669148570786656563095122405860141945309891081712884884954121772042497789808/5425395396362901630210565585515430409149926036879079973230777503005936336050415662280299953390328410145901394885547275286791983770834762716337,2195389561001277981755996488169511124192812345676263828129659765692136341553985665130014287575697971368287762455053508677130457583681051142538940/1772674914456007872442942993634922073473183433161666321466987835141425243016234930235517404542983477390629897211322107965996266327994610906040587,486467471652536088216822474317385792743220863905269379015496114510372807942379729855935848247242711237802264424797662875919339377893250977039560/454551393339753943081798492455930258191249739580623780952527586143861875547032222399752981188320122199857966630369453879156723695730367500947313,-183679320366911128697117780040580529162901065458371381035095684792730562112941581046483547858749436233435616581945494707769506351351632265500008/963417593696416610485504379835575862619684248699765591147058562697478497328853260222156835465485188082396755940978972728159448789510977892006253,36227027869468554377693440083373510073621995427006623677922788497797527494031195288874539561262608038317905461077253395455497942814661357219560/135776896443297688562476641237506318575979935747262972206088946208133591176597071492914618461986695431505608158200756737812570852203751131151883,138243763084935043328987685142499973215203449496760458607783052129187162195699188036600113022292229993508352468682156889059446799914087336034308/152735353255649170898115890651787096616207531908779634306279586319895099008217264442511608798301823017179773871937166636069525776931663634070549,14998099339371877519554565109691407035498975648756743331876508303222733832667189351674605675823149845046938963085138134637289879328645919005036/29274301345931801194247472103016772513042969356967210227219630930389018567786902899114193727646296728168845535504413482136080898495076842310253,1987956390031396074403850504330140710089389234714055719617972421778567100901124367052201311345218876724781654679084192967948241871697556987056/6560243420386735745875341687280954162952915127720153786047069409549817986403650414409353939057445943187886359225515824290867574576211744102051,357240349019049098836882327012630541284908522815824076114140956515940580990246201901964178231672625027116658085449717648393012724864605670404595/167229250362436415788713047528235863653120672787640540279199235764646859709644637492100557753335444562132119488142112349788140582743548056425336,13923616402040739008257983059442841308671745173781118753888049191949454129243617865552537249553567685043327913911560830943434200475749680155879/12787565925930333209867389749230463674702985063089356926568617561799409897173318711055634021018013962328770254186076606847324191178738411445400,8976639066446659717541021053578064419235461766367161952735288556398100200349072458044765892756710254326755942212855783434038982838057038183719/13101809818757972642941804088226456142253030763288191312544310192519289078619984963262315428371599731316821576322126923571577557549585680834018,6231583642728688065196454599992494392362759143290061789518111629828313017252601680297685494540173223354214601566071433839938072269512774244616/37623040919338828885224492120368949821666404004276121573240624436296787578199601602109723625758409652981537787240523897072765771568705392631977,2591610819393990424069502653218799398715763766228342107777970783481617310698531766385388180657551480752721742492867902600846603307628934580523520/3215078369693142403836601762322679894499900320094908347714555062862805956613813617700922529043486039356868849742013270761527089338033600267699141,2348062761357787645719294025802287543751106725590321947716817581399241038480608666920912946839356408891228068594767385610747011898102566943868080/2471297312797322425907286452168412440770850317364035939506106352706753825066665383023545184383356589580830028648341641360834530491625783105294747,171281378864051346597985292352262423424697224978739222869259988277710232756236194104028841950560821848520427745299580404486293136865744966767200/125075051813803994691319891436525563090857012840651861964982795065378530615457681509829564299010498232761160723534840731555924005173320863195963,-26654946034861748620332946074349598710660846650992228131752696451904268940489220538384818092135741495177745377019371195266233622824742820515528/38682144300428907872237688048284800293724968865669368566954245884398906444857991205562923854876701680017696521949372302871891225398970537458231,-45246928813870361095996942972808479198937458222619140149134727877193199821286150467318606345270445231020867072655849608694509222572373319542716/64962504017537856489173202245559062656341505053426091383826429237955930135112264483553249183160677049089885879289329496534104561728836182786225,-2313520266512147275060576375573639111610911730443805256363760267109128401185182572860237517011614265036675882060085030770823570249864607494592/3829339702743153288522529419972053696206093742234902021837647712747837701227708673107838491063113253507169614593510065823165545352882459331619,-6679320943445502698276688934251265450764322832075221458442147770175936538255559082734832547486989838050425088354629725324745863932073337944896/11552859869920799705906740971636365400900944526052409226615551265055937602068048303816325479987393673120996585049122602773350891259115982588083,-278400199391450761669069122182666523403031196656035206463297270443368129406965897159047194790852089501184599438253019806085372839237760965912/1706069634964987279899328274109048418470194605354343328987181087770745569296777880730132213823760183629496936046720049113482199047072599706579,-42609362850134728167095121023589617767844681443099877045088549109874882285349569385939328941892238575798556439051558115998051330993322752247/347347218666540117569026141659219810349062869183087687866579574172537930784060188147904557806358441746162659523322386868347688915687199243660,-2507795376500701134975321657544401224719426819225144757131074286261677954486525402861140404705506231183030409368549461103056906993632282641584/3893079236405138422076914625057088466939759285948633377615350950848381394531874354832678725098557279035096131095085940255501055447736366260851,-31291667834976047095335507766051247265786888956888672156815557161508304313772929738966634776980279948330888307716994694373131607445550665485328/49505275562501263522635086713964404766499832300600897790689566259975737711429734544818055514520302485943091102897508967360666344177870172005919,-93077336587446754686878793239408979297482488503632311271641152286110641866383308535785307529709364918883756015115596804528235700081787521466/813737592867482282541981383851034298820904152914163147693213102568212167587038614332633590287358608057496640595191098547451579890948871155771,2182496787104300759089122327251408530700528050632679691486431894662426536829299384865494347432933018623276917416553777230386884000575283842303980/1112202000708725030995383762821475559927939711600068687443007538101067399271902439219145558692871168328073632082898264293408907683692661767911239,5532936175449616780627135331869741368552032644097590522921066969669966182559601495637036325631783010991566162410249581537619660391172910841170772/1213842023072313566172207963253544432990874674120596798977861644083710029502909979342656838848181878142244070719698142137074905301931115527786697,3037617685156687137752268160403140137921191609511227191971924163333840526271652921323395504473235564478942314914461983012703770853280533658963372/789323388657875740165452605554384587869090298997334268363316110899147255285966494092757967714512419010948438115583715837795747325769200187545855,1677040679940045557935043201664232266378018015163880227267895392131566004020034417481194052140985076774500269942195875548022152134523951193090410/599085100259234551311765841164609490226997768430984984054344612310273142676159236160387735655048085157964435438502278794275395622043318541085129,214986444454438709766859420593693571767274568803811600791660312081920509427826574115986086249475934359382417352072100233852214570333621694989305/68289795482350467367915948858098452367897765394818962938736714005243441727825231337435573079372454549904220454708436030413666487176454301636404,1406690732644833705325871894123655880101600167424988228357520575826973530032063192794060673545731226062292052039043375543818314514440355362690728/236888262733926949726052207672477396873861070517565992831544953898420231352669384906293437238226869948535198359014236072987081871772943366223509,1635078113749943582822249372854466358217575301750945549582703765677855423492964456038558452493740888310322508661426154865273345714655488806666164/386378351212455962680246177300535804935311473921500875846923203456582371943727540702775669795990219714828491468011284602166164119040628075783327,79316543186199850101900210421502723231304228646307407316009253605220959716135919122289564121089849051122020380528841413020035841543578984679136/17561755853409903074649009245612193477902390222275402495570029193558881699962516893701527380683467468340377370169462799010800822169878118258489,-7777444659531077346578080118831153043022214317998166290386897021609738214259675582248977651536028990337931605505404686398600181119096643225552/14269416970059733975224700669041195163036894330346063882142194573521864456234747762513383612739796246514731365137196876693992203789642968463289,-847701623016607682142891347640578398783102747977921484663667083663894801944875704932464381861609346781101922455691569406514336389684715684272/1472568810494361720804805751780217971012407697516076423002442113610370513754932268688559643584427397570662635923056880940841480640413397084063,10191184948184268322987938281652094345194710175013393955865867312035118408556880936473345504777235115123226080962299044418291558062774162232900/17229755720664574570719128681885259282393993715852572556935455043770220731341149333176540183369433531108194383895330506345631572125793432416081,-218347897167586269517132182662517690695152418483313022221210497937381770144261260172800850791617012001053410671156787219593515688722000990853040/601830168862194073185893455144899807351385545727501033865914049899540720275429386661080678599806944793050862506091820397309586195849430225383633,107297286724925558553291307320661680804394575506354731234355151955472555154568009195663903480389869085156152662824967385307136185985681356936920/50557503885558718810211066386688511987423812710772571038872772688968281813245743637706036521632313749335763096103608112636331926829932145246911,-1023643096604984555473143504377780828093351785098641805568380602387881368711877976035313679854726861018504906815957805606281763119816518471664/3854500976700764318667584532197169618223106800592291256174356586427525323011623313759389150231356884366814789938355612863059120349904469683969,55436743536835947562316059985272026219582548552963301919555899387025021116600607010126584582405766068678033846466894656816761422759407078284848/21147507908710755079707333527054756016859404433585338293410236556911185614211220577260577077574579571675364586843242243814743242353813227148527,10263844009460112503423322912437299196750197192146535157770020445699549099173788378607500605879363090202604034315528033342096616200271770743596/13550559431430238650872848988983282993196749351441997658230699269892657187801139709290817794896987613267263705456620546190894169822045841051781,17731311399484905406876321547379699444682310853914097422680943073501729264861564821105605181260797037992882111700203959479594259008410087600812/23959172792297302718042538514699265257559407275039186863763321341457629754408024534178677056901716879571047148874368863970292804110507397214961,107294970753086327932177654788778643819124032687607543968516703422677571047397253159756826552428806816172706126089072630730804740534407828544392/7787486218465488869918654018779231984180144000254570935929036619386535133909269145259074621212689584734698933093344141254036973054402712934073,730873897085043410021426310961507091899329043306818470012546468111687953944987661700888812247629049292262058167489018275787094459037879653135296/291518365024289121990583659711457621063627535591788438950481115300204316003139671648507339806403400408826310221644974339019269989356218774521499,89726367718107787933948757942975134454434899430611112834733888509604796850387749428606961277516893487520197046193343783258454685221872674057572/103780860749152062818500663534820371042474156171199320581354303868997796720605310995658550577931932051033117363054167122014092015186847423976141,4322286068259150005521086805572230992207550818264046418557626157389323452449345096283863374922220851776031308659524517470916836464175460760688/3852447635380702054268506285317218336842480783151912336788518334734485901208717267945074997391754752651775217698179338609247758120765653889197,22302191278261478694461534812495572268459379686091312923212854569367150888686496278919646599480182222921078518717942641964865889739953777322376/3639332072536688524251946896742940256581480062845391815670462514538501729374983642994334357911801463094880431178644200640643275495852099998969,688959801519629503242821459623167176408570930522241035011619730868625305329861124703001423327358564055383296455157641838288315707176562658553816/139636200618454892049121748639260692263406381907136204136542941836571696306935422037659524097060945911851487212856918600341581516370263544759247,9904950937376753876803480984474849748333063828178025945554985214616371091299651240683011487230109970520757852411583659034156363021541735603180/3316299498590704200241728740702945590366355272176854392289647951659797252634927469895730592294646210645507160452767293761410317261440221575917,23366739174001340875629985681420099007391338915350431077985390562831220312879640370941973401076379350989428964838816585482317339589468840256431/8871709776604947147676858311638534575996402803493573474464407844528602654540375268714971854842291907943499230185823692133445855203261207009707,2374917735922636917388692997943480247586940353621903058648904773414765371729337897330300352978148325027827744955954314659234508585040920529488/883360901756920925955489333645216810283959852439834029300269190553166480189571627684220832178754023283824156871924438037378745538868760584365,12111234308524756907529915781565187652611166365545934991677556655358835804620948064083695530448872826833064753217493339487695568743725234265254/8246224653744107002048169694448246652053664533396017873993315302740726234774693469793193579954462296643520649339016133252286651915882104552803,97725943078825811320499469252656689563261452663797032019874066358951248772942274330088256576070194345979782018978750865158412153957825302111153/54400936455802208364678205823704083560650262026171717121747385305521041806113207609343948455224892578980554105910907570848274117268740096793696,31995215699827222816039368656539410545072124634146577004964684786743051708592540664592076509454817882135898226881605989030249226170078156217081/22067396344220126614427107694321099729863974102451824694697557680288358952540076748577763119418540377087551639136927969917066501826619039225600,1166900742809208892335531359793240049996195053456930825147082224083000918934186659974078912831128228026273541823750006769462328730741374187129/653052123315396157542857675320764064721219477875898488956673836903369660573665017502429233003715321160310977573640250787037320308482406380890,3935223724741331566183489128752000379881275845294855363016427498758394001171325494250513514602397025338715993078605705666324065842113916907528648/464372289720569584714789429674115418910841311661084427222861886982398503065109783302505479261280641516304471065240458288073932419364095222575353,7269907145214962565350567806402627491709220011310988724107723535281474372745113092112841199643526320250564324868712300848627716424025110071998/4934565425870382029596379450297293790384618276944579607666191088728984133682538869114765197569074679314759811225377622621847112840279728030425,5583843983076214445846102518957787124763175197285252625838978820029873094412863107322418580348688388398635361984184724640521792491147540087913/3636183036625464773508287746634002983964791231015926169708938533080938864637993562590786527661148930446823967730203497060992241806107628713066,11917132084019872862428616288660878586441087582205447405223783080019489589697007589714383894051389483048987264332735477125949434108695310558999/12996761799198298375322244646520438625818217853783597851327606536839352574468107074695194967150026911815705038230252012226096228130962736543175,6341788183052209936320616244736958244112436992406281365159078976295784447836743098904398184815237446253431592128586208779161475552632243538384/9265137173579710281923017007599243024875788897274332847735543382375036017359022025673569506745121879570403585180285944333094490980783066023615,1688537522295865616850053877515758545500522726102885322988799865205433909777000787229134391794757433877386606928561421684781128412905937590448/7963398124698684241252364694394951543704867963621644064453955809494084551476890630043377667031819241377679620963554583303156496811852725966073,-91211104251365739953935845189094383226385090138369526698680772094601376469731716869452176277396770127230214870063221771355105757593083381593888/109077838690589961788519153009302186393590123116147580025015186706224160736657920230308480754342949370171919155571173381316388114450772691438639,-12129116926299710541820576075340801115979223987240385676055671333225727869224263416228040694450765650235300206635826877859297993892925460316544/13637692825768925046409924353609620314034460834763875290420167917853574128314848178840901073512106619475998684312990425775171116258901412738967,-73960234644351444801024520741177467185604128409400320108794076440479308534023426552574531343437572920328195186802273336341494721339927923812608/262831181202952128632441937200145810194724931740040052619833946014179296426255597017262444249988450204644507566922623349355378355051697305423141,-7867440833864140982643928718969093839759336823460422283118062957368906205085149845319547953385386872092581769283271961155082802592710536132992/18305634187741138616874142178830350560330807317682700005707430836824401697049797628104427512097493339275375136033784877281538671831389704816709,113667739965150961422315355248587325564141648572560690676669736162490024073087342024696767479124440528559230473146796237517951787502191367008/1140717180311719181386760335925735220486488503833674865682462981225137492133195483918446721830079560065563514161429445217151643579241233588657,-59261497365709768072294058788954479246318299361587564409208083933738262970677183042158148356140777953559470669800485342009466763854201122407328/273077850014099585662988531716485541168943249351012429831137102531451827498728929609838720350769053541193974519900899841254809465195742053202119,-1436105159842005640844933486536736304818681340184770957228648870073030814287871789524687092861597493255121375028787339406155477605112436727168/6551324055504242383413607697974047553400835223855536415616868142268203864241069611606219679179533504624937671906849592518975749522277699716591,-2643040418395327902596076335579806932524244497307140152133088879670844829208856516920961629486978575558016746094625552126442564632459625047424/3602096133505325599757108604720598653965625746159133709904673870123669981730161846576170122132642440406805399993820575548808559428192498213731,17783010562224032680436070145813472953401024131947420675847068842543495433741223726142762491846517912859990777497119901206044918413301097810760/17050275941486146331903134351095794882401682961684376203990378013984528073547588710937899580879491818311241884225060934141508505909435035278769,42801471994916956437315862004045953775893077260897900239806200995333944177454136727523518625763396728673821793008323156555737992967567688104440/37106048210574294844875198045982315873526065226384380334132820553637005676829304357830567054549842575453964775395809100995302761535650533896689,1357715817841564841052822961047206529087601140496257918905348895799027944007975802385186094454222515478293533018539572018472357674521568309368/3873127371459753181300423888876176498998087089319062137961770929960863979838456568705263948019607978924048005409319498897832491759934133776055,-1664352205662752078201901486684396037999398392716533425224208060279106846145753933319761724767258333996235356752719671301625334998967531621248/18304594556468900655881500476054775241956422112468133751010858414990749505107286719451334395539818964977256804214834591926322581961451132932639,10699687669379994996960703705620361804381342675631918509275287342438014936279420448672216980043917251253633549308125146127267158932864619090688/23356260232643387583814747141912597114598116705616651938775326484568628040926249878646593344232843098063475364761792151103581287974635355152273,317640232060705880950527129419478004553774329823489882773974382701121779146702226641542774263944364690060061534736407266004403534709905110398/177998441714009666326596579188876725881489511677097365704605904711978468436963551430333421531500960826667062927640617864722776700975431683529,-3029910476546673575433297322629197728175989063923757943340487632510973305600796092846666107664733635068367983103782615787393774138344409397250/2407362916571330418252461838258675555899202372378979606040899782398492925530017236727667957018663189615504866827546450981340315591407140189509,-83564920937758305923151103433027278592932053822058943570681318106243393746321146315884379801617276601435239592228798112373322142127838565056224/67500020241270206667827226849054202014119047983526789344614159027557409136441447509402533856497094136844086860194421802332566556693507206763701,-72742722598734497977445832380546227327701089835549099066653678912911126390840885452827656654943542359958249011020632764685654027730771075811872/49671630982215244142591016982456269616123301752358770768293581169071354639277387467734365022451854884905822990842656489258136028826494484290973,-20631787423661158747725203191567940048086429185286010804005617457570126721540277279842548068002882726752063806905545027357430812361897754166353/10421592638415417197727410387231372110695500978185955056259685859489557714157305286266160873558777412351327727842623958238694805141939878149824,-630158457314077912663278218343589112768006080939988894327316561827528402870610422325547078351830057506243159557471890240750703482622645633977771/281271528565740004197091881605784185232029497013890081004718663578090761601152231370428936410825619957317467092321909567469026277147998244425184,-109972619745416923874933440270658807289937613610997107389649015696136750894574282305767504077757941814029793598128061428626597747576722358300549/42149616418943658589954917642763889139364504563489366371999179740591726044313250054171500695247690879052040311860012341660896894676872304919504,-2000426026770236765604544010139798337152992856254017262401119187939046916503968850435124504625839416153170553151078470899447089207191194419555/428495362601720519473020212279361667283906272722299230207916040889968610140232280724437077325129384781230320953265363486640571338293138208119,-4111856107634957270054442133348740987686391104504447467853957842124175660429984266574853231382888694967171580918879049701438947481298157763605/896868792754830344053398213390166527968537082197850359321624852017391676143242777063596477046194708929561056549382509172655347487451992835066,-72095141054129858431786159498675889382591420459089382011753946468949362690213700973471807278658075648584534105278102918998906603939349636782953/16110963373420360633633927101759870845942103161189798027014634079979434881842820347104669949750648130545024947784378135953937693365832951523455,-3786503662658332275928223051906688776440869277167907270479017203193789637781367917721336177267980227876629588606703754163686588808174558723262/583315343463468346251439154032738781729366076626300772913000718722269991478593486803995928449738619703334122348109553159173868378372514559437,2360398548285130597098950822999902785718878794604546599907979158346640308972572850030272736865884394197908209013584752953549918329612366174080/2265909639673245592876458300611473847896077403574213121743718404197968178992692629259199417808218274887690407589786577542964834536034776056771,-23572715043711233711980351432493009325662832067617576540756127305463289110243929635451636829793972032732061205118919034208840045874708494390528/234299403894804370937121726037468340670176748362784944859471922454518889725132222228224624300314626284727319345260249532076978337983424591601207,660448861176830035923897953399750554829094297287529807969256656645466929783682098360597768231075660118413294143732297954286070868155847522688/6141302417993900719328078688587085628012916920277738238270103187471299772906950412311974114693901375324103413512487645588808863451911364646929,3457802037765769714923152682884966263718123906838472527308141437462484850469815326024484432940937398610042662164666357176197002624769643758848/3394131462916557090710949897382991198775938878183878159412483197620149960148856184616155687204734457106132788110930000445936706150591663246255,-722350650609980806600389372763094252680581877269935655335100637993556168548419988225622730304743223856291689274413199089438533859001466562432/7617644558644676225666074541547101364742751247645670208185712995611923853004554350582021949811650438898110883568911361433584734770292915152315,-5812118172019038763242051717499806307851828487474942147791522439316994326554678512633259428911703170762278045858728832751253842574807979437440/36699682880770892078183506379087099297701089164901896385297331998832523091037966649991453151634760766357331304564016618494830409728452836789523,6461968215592431559266933225951729342723199934383458199001985269182465938634345426148094062266926814481496416756120507454393001216761687712000/5818519086256404971552509452589712097133776544596017389206717266513772812951952632148299371020756776861821739133378476529738673569792588799103,-90479396713566559212027530491288517622509281007250776567248748736382951391966962163556096454520242079777190765406629612816758269242106877350272/173811246554619480568960412225937393336714227535441454109079484262644271613362929942310611289938866814001190849955901889605320345826323957985753,25890379394063236216160009241870411294063918050459182633152802754955431112022260672431654994999220578479026495662677816707621923454678426753/515961660885533598891899313977197341611006066896284418324050286975790988587927970266109678792399799962533459741102886362438156950396091682182,1792155428159415425035595134920951017793486703236172630380888080969537990674096730869386923436064869731538616067580259878758846020081667355/1517517158769736671322417692782097181522806625914242314361718098105024192170753365405820840783205708202929630802472775526407327753882019457,26880529009893094431505777428762791330947661293634709772089066149866652157578894013451379265836705317595136136604155445217385097914344037787664/15542689946665469694270942598400151224489523491172431710907540958727019330823092035348995117657927285873163601502207512807813909752089424643857,19173783669511871279260196049109473165681934374501267734636668586065061487511859539089537114185859954074493433384741649769525544346981935039560/13409852101483985355995977549465285170422983542757782732325690760953578636731987161690117626817301492582234040783108563326146930112425541017557,-20780532005764684874906112201505771555858843059556754321119130368329504600918956974978291409033365544037378580398956389038011685922111449405846/9290209962108012235663871043454542726336361017548040967572679717301059340330101080192601759147781408244649806605282116722341143091472890349935,-282214432996439893802323895473052913116017514676481024759696682428969373229147712615002342223616900488432293623492882641895580432774038911347/49294323277473916068096376254789718644147499539788197128419665608393965692324647034070542519411292896979576412306036917246600494350145662176,-21412714136907300264677299301636437370269618261286983635353937715110635068636307940955336133684789588313092556973932008373731284067114678532/26661457606440671833546573951445889507566957256874267665174235308123413606525826032388832538952843778131602895962188614138297100340503884631,74719425802381184508890110792108660687491831418876481865969225053251026866109019907486928422753941555019972125760716197995730067207931028/78239818377572609354324330203073550108439734050321906259783201019705915772846871089702403291464452693554043013297515883249801606710674911,1793537644977436615260854330248914493666926401685897109793674902156696226637607948749951758264010473956804160674050904314031166645437855576/887494625312507896950859780629697215715685147217133987557584575480163031855024024201323479004900104100703922907750303618626060033618036199,240675513037331826162953450044558023611293968121758222600860278322526598573248906572734034256089311535286708961234085295135101091240815251352/52685642891257730836399071182945503224513587342685870683414397432448675112289137620786033449310441875721118506606060988474849758600123516591,1952401011396842705059916660619029856997000158843914197017555831339689742909343415682830737213143918577687932328778754372005870803142116147/807551817007571805678633878919088038895589998502741413350818420352233431944657057754682246722119324894609633369364159038950009701501777586,-5462136157799516987401257770465244938622319081291743054071994472357727861451307966862116243011163582208589804272314925964707305959301001819026/97086368045238900838813337219295441795410494004831411772322231175994494828127325061940430166082762999567483019897924270976361769205844609125,-1222357372351241469796971591878171001987401633079858520486111306884763356374987425675521303274205760408291977208377861281733948996024344939328/30711891941687681711981947056012834451477549050773388063644024750965282621723861757636307260717639638488494530450075533208798457546123975479,-657181815376964499319968015220695926946787090445598262348755107062778922695515278275014134175772446971453526014084803234683107356800839922496/123838656364777004299730215678671348992057814558259628231177730804204384947751420680531423266127538950635331676709162312484604798450149092647,-19963492286380224011784851541721148356358718149408890872415921657761193527275853374444764809887187190373374306624601661547382552945262774198208/228807701220394122717118900646793593241426302224923738451422507463537694072959031636205179058072560164564831956117922746368928299530458460111,-4238874906476578648911299892823237890384852496278039461173852725063394000319917613994646103136473428298565939093600339344793883383580950983080/332743079949254254459110637990804098769770308163242944882496682764470003358003614117229975298326354110443165108189459449061343588238269728249,-68368604936351709092279473391671439333206751294965134351009141903042097279408717746896703294204213071250657089432915092799043388193921637309632/1112400680796060158764704321574998507014641553948605792590450036338659883578231553422220916661059436561172670266750910864609349891981571423745,-745391298280169248887172839331346139132638498480068734525885123939240301984003197555649250769441277949978467299014022695420039632089211884320/138063299609204232263883026768479812228052730891570295291850939170986695910182190465930201579522850564594649825182706070889925698350185639197,-28428409813183695735229260324448346606185195055339907412093637949027637189566269149002540259915319368242111266000522602382032517157617291265824/2776741146112394898686654637009760368062925195841633821257548882382004868979671315961350711538194852497797796902158939374944299464510381794213,-289665897942603530563694815339545323678081726262984271942952293821352096315642973565681599226398194277396263346606131105338532415754074814464/106917406642657897868391369935982320935551227406957489982787421586743085718455800863666817515835128053972199211476119491450129817090136672103,-1703888466076572367969102069500385761963203441951451635487002507934712005957324743908138335143411865744823286213375241725394430119589664788096/343424347558280674143253699771693605601420070752249794814232658801981009033355140442898741498505380947211803908352256474567626838376899384067,-1099875064978386121994393705136575982116037710076701567586146107682864982737521667191776732885487537744957676690676599792635273887075610869643/327862544776643080167540018389049138202896702656045886183752470720012892990705091475043278710399265420526040825600438910747279093164842500546,-167973183577528804758043195062295847497539568300631478140284691034685508682095563160592381937985047923757819714805743991854444930384614601136/50964344032090449122596317470788687019561519263952449594386919424774315714127115597474243707631680944449273148961408151480707796138266747319,-3488494721464351550288297187557730164803823659750084697404410295916324305651177882413164593470180170830567735900001841826711295775288081188696/1276175972425627350965439509687445943430935799206072875525016876102322760913872014293652922122055327147057959460819323039327173256069531354843,-6813584273175320277699561307017607102572364622311674930915715597765030218568938622143814760397459946336636790393948006168771396828787301544/5694092639068320865862936391655364367905534623318396802631036545582647963193962924949888799002813503443070528010471046934395671455960545291,15215435292599382325402820625149621193864328622842282555587943708107329655388461249683502147228528027870742749996481581630855080855011456223/2962935811441440619891401215146154110413813352851032193803569816451847521763514301394520621558659082492195776107824239614681526992987332899,-42383520191592755723375846941008784910933063010652798187466535882386958364522954400324940742805656806165595537952193759951791666810757110716/8408780730773052847771384706570294611675048881053019774732932633088497037649302554756823063300147433781762114745338643004930564406342875633,-206411783773269075571743974053679801103926411276745755586909076287352668819853290087533351770939242610600722271272322740209075721110086006298/32701817707239355874131514923909723183770399253820671840611422969437725734470050554753233849284903414103757145484867163640705944514568041519,-31703615689456931221574238109607878569351475043338985909896271467056070531205326538381787584663384098961423660875017153400561933172387834917918/4552094779184476842489223170267672317670508628241094722015733332082950644015963125058225249736828479474831277481753999125303440765964361676079,-90694506837197462544419629791984333575256354447907514467058280592566530566200258447019857886923624438541999307249999636509060845804092599663117/12465425789714622330718503330990034349537896851094205769055953993034892743927745108055677656974553431887383125319726778101204177899772402368384,-207997361547714348003932223355617170633364600037474828678380593887969965223003969291245806038976994385135890795716341829401276719279064013272543/45438488998191131927240427836643124213765476727113036576130994345324133392684517808372557604880827803284671303505460219455570276786963106233136,-153475575596853325255807072618182240209147306554837780851900840481981379527105691408015176797795652897780708197377145193036769108959949803936180/51355179674368847784776508756045849907026942959443691189582134151410712480164299160595906505951809460638646434829709839007427352954193908812027,-103686478665096840233449617568696934029243671632630873583855740863262708113870315658324201164776760370505651362212972709290498205501764946319139/12400554182635155791081502974299337794024411791873128252680075524691576061960875708894897800679643505042030957429956552081785521719255300599008,-22434188533129729944443925133951790479899097499087578084300907102931258785382609325148635769651896186381177646861754374613096452869105684611984/13776699698415774191204517184692197722804372189243075780822473769176357017071571783302958259404722559004792868629401478851648943202613134333091,111654015636819318171064523727572448896078729496939972594684435718546849463279676966074704924763478073450310582800032352372915768442658096042/42076110250123310145213874601119358853267501114984383874344271639039765731275608413463822147554683047153554869932680181308254528283099287049,-4947310102040512559872483078501545138521951103409305122248383220748750617757453365902986523995506944037478718551876398843109193023308467303720/2163660671806953483760727351104805856146894916856567014013365300448141304777064815509103541636489957277693991657183568843309720667267121428741,-398231035417848331977290036312329532296555045067794533227586498435404932377232144350818888240417761219678473592719874188177986557080659124059809/33302025243876509174161925836347406632315143840734240939304720043319138506000522489717727879751306317871151180107772410397388141524382849557248,-2922071417086067240439753120676148529309976259881199264888537915238165342014871527326561199897028249139014523167967281332254742972299995573025/882149560368883912890650038758183085386631122579582538769841088820548804272646667721659342627267473052126454849150218978307094049428037192064,-47850423923229644564105403776143241737736532347800857491974426974103254434856900985302745468027677903778762396595888304844742157754245435585348/6472646946167899677656603095622603602168029734864328697166073163914946953686572827963730521396569623296434640540789739465068927316465094462155,-274065140733530897351927223256513232187850204652732450315707668895262187355037068459337670821373985805282811941667503205163260508812202965651808/9639529764876602515157339905215122640681760639525302962187255813538400035791531070129382727139459634523482712804991313079617170665272743409975,-12673070016630966536099533524150250611834485126929926732840213323803007762560498833815461127831497190215074860311138833656544866510440108122560/2914303882679868419242236722718907232919335393394188131947008831938776882271757217031325940656103750106469546841725115712309173685967006823603,-375159244791782100895973897917887354545160135852785545961286874154022133234968757742868871165868265857955794778123686040486630778129924648753593/32704446440134894552162659921291831640618096924394139975845397681097939911820096745775123755871832836539435230757394818986779102889052659884416,-620412999566760988103228553948240473508718189261302549226250331704202108283940351100714009804481884439527902042075962759040855993298744463448/281966151208827480269932326744752415547208293995736710938086902738982035667718864596324322513964268301154145717790690266898844698147269150197,-2109846385428229574365306941545773337576863718906517103909588843786644733767362365964585044939804182802105548860288737545115520177214473698/1375136786272788461205869527996183542036407597383651386284208069336474969621064781909253487885123766888651437787710734391762621106507981261,-82468395615300414532025547683603332951254575406434082680400086811572719173456483617132132484175473841545077205026176536310745733923508417768/93937644431575545647113811340896406345756440374346216399769919619422947225472343485474729280819934686312991218743463521315983751024321931765,-1087206044338337422009592972726755902209773186855051171987056989780072250003185000802004935488009272602948045383368790391700006102896916654/1039701258304079398411907990883889252306235244772966055458789461120154379364782808856492737957719782877035264175141129572692477769233570111,-1437291487780829255574368908018326526489815250939943314398430785184013021619525333055254308465537528729832841418189508636320892464112806374862/631001362372166469248612312271739021335281801616146648242409607781489904655957900690324817027027341060799020542100245237721572996280832511281,-1018718248064840326146820617761093246747232347678510100422025864686063031199903372170913293981465102794960523767324981930186532078049182798272/863710298510529042406340324825919903484082015977300192264310580815954800817860176895176917783412816484572236418222440280595597408123172186323,-146308111907569930969844984721683731628324773338525974510644502724521714738237804688589690435420456389697328339326393707123196813216762885241/52681732041217933643792538475145978958491302278352735189357887418274691981032997004138293366784478687636023275909339842462341540041122654788,-1683876538747326574496986775565159148429451536930450395971398148690845988723560389718034173481591325513948945936071953329320266300395358636292/189906653277104968198553608275098154837758533398953235669140132120531040516975059117152304318135943831317396372890051610166624802033280231029,-261142293988159537609898058035626120696745817251125675471187288641879041462261171033665820059120999788710044384286950823857881342827042655044/225704818916195762007674345279257476219675532311511824484796821793234238844325407971110860980354591374960636547101025007539203530019592096109,-34441038415664834576047271794495474126530958841760084107203240565548344571293587826460072403114084775223749733080663330656557049884719270550608/21033786404997494205318500940315775565742199431625291715264632540857288522811464552177449592425566992895002838839644624207923040566811068987975,-97290749840875544176615803398112975201518265062681965058477573768630184947655184502258715670024034840222718625892895509971600579419258963793/26025636833375127688562800529286118887596251582827851266438076332560969036507074355692108477906754084260965899682904988944100834930901795484,-36581098823428929264773595486772474658920343090729974796522090408721692834164806131723989024664220607462211483595699872698636308873596007393/14920792072438231711933517204237456806738882469665565343814696918836170650373297403166888629945514064534000419659659176627851638631192886738,-14577775205128675778168126092900732994136894147574586530471014347343371798396491366911440636964284464486666072344919055833524028745527537437472/737510672099579671572515244764608535999470528337060026550649546046964270542180883514335994020584209207195867206334799246110266652390419591071,-1211197914625974266494563305214163239434348424521835654845209884965992224189805683728570526294835924177724353894037687586019660594901797153202/134078894999223184755276874227799102584292863534563106199259294534815775574576422655991461425723853735743465847366260988107801826895139865451,-196512445326003074339569141440153054126049087282023380405844022273218262596761447067139211108164011422069123696388573974019142933673700266084/8853695310906317110292414879248615984065688392397094528701168778088296559555675773320881902769792658130166809889718863942843765357219628395,-6313035524348866653085124578932013708597567474444484069286069086317042365615897686706726522478045719326501588284628150338613951686560684448768/438270768413188118587551878050810070032113579900923803959397310871446080694636513337983867998145988647438488903610740410156987382977842067315,-37422018057028506058569006424758804487666902796434086429744498612116358261039586942454319916106102723672440383700386049543847380915291691124/668696740332193134773470949755481965553457210033301086291717266197326696236076345283193717003672687354506186442201503936765662039463948327,-1083078450398676121139439327790224746346423476038344803350947017033289194897437691334160727313004543054661977119995863025917365136315472894192/16068556820204490086748094609623042976713408875432002083303664751305182077426909544663955445461605829510889427013408536912449201530160218691,-65552599097238223850754080436013574332611124363019770470941043509042128371647285813818296803067197176910277093495773426852006746571688093344/7947612398014547383329401438039499731887385257776602445085546258302292073204667610984098453245703545692362532591096906135130086407385703873,-207784605088722908495734613569101503947711460980376052304491260569123323101515884356249546888078242657410959911314801184344653881148169870512/10332945072102827903887475475096074673295631603635189932776668875745075385246621317904026156414990116475770443689857582662100565065118875965,-20092561754423107578630561908203506499009776607566392701041118093483616767648006307856771253531485507220229234735482530270120988707932099120188/10614262405351745894765881003889835423258464016077662692497630610061593918373846535978682403778921426532800574494291071882816188651861979094871,-21604571052617342512675885967785944693558042738695994656075869415697318187398783914895365964918348255815022076206942918467872661928139530199296/15836069533997721377847690951664153500598828130491308299319735090426277516553846314541988900872753944574881866434670175599110710131228479976169,-294359078080578862372242366054263300727251797297292393390629226558358988450343828193237279410291886417452504829494976637317045745729940188546/317607593185518773947845274651700627812163682347127673330380981336828729137452026376410199682990891461079659957973083915435283179833354078525,-4623336401443027151430609930847303575282000427255809363067090925041906832449612886812399273424200697507130208602066447513698819065517762062/8051198134321079099974300179507964099446830104010948807615004833478222387152467552508316950329536786425734686755138720116667250796868486823,-856393666451970430076693996665149779501998608909497592793919886349591537999958617824850391310419870970585725764524497166856345846855788547258/1097638851360386387320310662618216086991863389635574297870867385250120309579927620380667620508743385983109774588127288378871013916227865769019,-57526844643450927407431380519351495657766118558388082100343564379414371119946347352978701869442026800817355442908276861926516699073976932338/28269928695672478847043862183024139273242212583459783382890709177649833685878154313653935833091964023631892679494244272828157018169990985209,-21849596121523126247425971118871122377128342535288233162280598721406595609206028624441167915712467925776713338589575702931217296665764812313920/11809606923585102006108555700193484696681833288665075812058049287068270053390144861319951972387464292017128784435249502220769555719164059801727,-2335687430998100222780579064659190029082022114871451768129294248129424945999479769378891717620261556133858727879666625608324103986436357895232/1267199718596307935215117445433001733958256208158658008632797311259409719105570050893878094472104095639644463058663289361169896632249039807711,-8290269769121331390450368841539936778831562684549119964959469109016750198501933701961727962636591669359394544179686881553711744616259117378801/4221349769623939250473732954339857094786544348244987172770312245838263489318381550666232490981221030136282808936908650713253884057956794801296,-4586106177068720760936826708672742890649322741138520950120411871093321895623830427343692686554630545765145110201110250906220583895680299216449/1836272747253764000119367508896111980366528395574894440174256912637954495305448635671645647918686341983396607496450204901557161491738103225624,-214039036926481206570409198656243098207124253738978919507391235781045112197889462232839668086329182937393744651581935573525004601906445443037/6574672077149611157580905768780803529850147921959111840171850775235995556782706893738231029851899566805680709159429189729068104785721575138,-446290273326595290770693587216242131869771145973551932363514938663366919895490835719288188473324774726006349151579907554611516396242289982798/124361222108020482774963838991065804941353667433136449658791145352129071353230430951545549761290266774603230500336580422711787873673002369857,-26564148773962462304459943916566918570232943936835837316484836241466097896801160807724208774634149104264622739392712700681726195943585162860417/10960314506725305533485166073915615569953195923397293742674101928088158578586559230160211803750935027839283020255031715264617731019797250438745,-10776743964958896886012550552334007174169443302153000113807128898296166699403098854175534466548454449971133936976892964829431322123641809962928/1012247467158620035441415418353771806647448294730802016386732993749602474360443888364205506353226101042546355697505350493975065544755132129389,-14973469757039926668618380517693433898984982206468678594087263235505519065832746056064386601686483572526755056765255494398252854050832316949660/5069579902571923735512588368596540834587309791965691646571011482254508469001491872623636735954934944893988693841263483605443443898780668071303,-154370406469058028558541520527063294319500009346753589170278013517417296657206614757375988346699632176429247945978676029079471382905253809594503/80987153602111675598114451010879975403593358033688394705989588117027449221346677523835696815397490066048153807149401586091517809215597138243136,-68350314496557065834126957307683357852320781176169959629195786400350708482174697237141240241321112044646222822221820554770182361586972232376160/36941603665136113910643841935934658603665012688617019278271853135277278149447570232728294962396271977713085970929266430184195414150774889888811,-1962634009612075006309151996381671014195576796916880423771826414543846123528410003063285390670375642426804363009132877070411553453978182788882/652098969721742260715740579604058820922290864333186367344934171864816440715365502882591982982689395629325252710533957775485604967086303964781,-2222946115272268517528969719699981712709033151819964242467386789836798117255089812194036523802954871826963355272445553764733825999382246608919/283540348677543490292119327809274383121978977483791619328278646135147906662952312757400734010985404827159397423941186085203739094373392710359,-536176590547059474224756793698047946637394574151311614199672707257039890075358759493300802079313812662802658791847867504317794628554570171071/106755207195443454352957987232306017450061967719896237581185268416368248760870152879707972668395548351290049235659988697572135704571482862144,-599518094070836608927160588764289979298766301101535585225640940948513791958880525649024497362793708765543890826959633086454644703697815396127/2867316695415662938852395583563293951478614675675409046568365319442947410034922190840360602781162554041669588196700716982494368738985408284,-657398711943153985063525455296484390225115263487003326976923912317562847255511555303592137662748978570165936002012115832147019929809490153864/99644340945338954078522855563944670016200284922927886886073222058699983325284315456494104468000747588662256135965241773346804536610921467513,-14566382264657804496064527886654315215708627760041962834908888552247137375850792027021758964607580958289670253188187431404146329870029874440792/1862588446125032641902154449785948948980366200191817112096766624658744083474644804982676241102864387716701131344221131138020620526019021389859,-66427867394871705144549051748466903800026059494753184717097725899551258505090400804250806510899974044024155514404956268728195035209616549357237/9960453366824978655896826451811156860207781967168506187174346203809606108187426851258634943138311362186044837281686807928535354261529607113028,-55211764328616968671118618398296856985389188359015938512394779421937525824495863665256960996915795139840319915567351727784810720830559489436016/2546706658883938920260371387135305401019131567951541754981111917914408019160754208775175559614413020028332750969689991899533511499309976573247,-3546413184772542308464554243843444698421130647872744801456445725581719436448628654672381814223398850334159949153778143098204371102222683891862/613213588379178751092587237656138430105936780162389177866076854012021398116154707694602831298224578243488535115590216065706544520257088245315,-8811415055181736522387558587819362368117812406384889500042668909914267674183063637928796735927074215538883353378277326130429367937467398855771/2127265827027423979635017950639561691472929853387671430638936512910076441619099244482743425994538544458821102493726027532249246761724292737631,1316309940381917541690041035619276115727598355919180543017741330520511947452702951206591765117129270377629886476613765853423438807109332670926/1646087261766914994112053129375701055307114255537104774077568678518631514570528724476238696576134515502213982497042646384853505790272244718927,1571060995380750088965974288033805144716113789311483483345345604080330129561895661114332403281731871552629905100414614445456328490855404884962/430547204031677809338231651452831827313801204333814459982631206669811724295737785629675609668690743602817538377939132069620608851505583767789,394742364819191989032839586059044853335817686378874503773519548689518508921640138648724510619688707952918910950691696035448486894397602541569040/204548269685288050892614179526567758857838919432556091853955313232377680974818234787457141102563672018540848291550558804208825464318145152580751,-527111712388827578063360202595515570703870343080319568910504874819041233712099908970867692755182981020419310575106592883712835506072092932066/559361205405473499109451988084499870415934133530523121972059822798530808156734932840911982168772810546623407462680107018292833725867859277003,-923120328548317941111556897396765469402734296090870512926480181036913057203317973417763856858577443439186181695135615953732966332452873146754/719010498091351346175251096300639616379749090502215295013398186501139916391629206696317407593723786471160824435751496518252821580932315317671,-43864903662197799272656210333138092205621833640836757936506276023094132979191630664439351702188817142433205870980182829772594906122911406012/826768132611563900172175082088986264575497636229933146482169429150935092572508833701197841209805754378834440288770044290150660817023214509,33692521133755926161925534343554813142227058546717278882259697270412538295807340631821207178717705851382710429165553723598330989830229121528/75603555735677041498359932405163424033735605053271926430012540313577702899719403308318437592896609983904575656310382444028858236958579713001,1910934970124453624008844084719016765522294986690437380119085663026406876194801586467685879842870874867910923574239864120464499576920767407204/288872267134479027866985296019019743240803659514308700203500742956498324001323349033555526577890450069026441530135809114929579121841070347243,2453890367716660105899759106059939708503201966747193739348080198786981095716593688833922408665286897018926503716598887958866197741654820547/4307765033099818012146025463372046582810267171468998488112643046696551176250190914833560701127397566058032505653159846185766625076063552555,-29503178187319450970614147265919503913214986870450127607779715592427142292642909033220752257640372896258522053585585216986581537005319126251497/16441086846981442169038194984584401883259855034971147640783354636665833909064697931785970875845526415488435322732422178739169254814180418856641,-113564057336801144176919243206464674107703422612030151133199676702986826348613282913569424573427182047059786650242093041051893362668360344857/32373763564002188636570970711294251157873037743441923165455313937793701560848422637242182459152969116884784459229261685177316657851461883006,3127021856040912822407267477641724553885725235982853355701764589467164032497563415623563246627832914826754910142408479101554049510327176664/9316047705260071463249805151821010112332530106336567330374502730572852378593659573836347529737742100951222185791811151831462669743942457421,2246215670769198207717662087022810742924205066224286475290160231144003196495666700029643811467863392952324262350759336216068123107148558568/6511784333095150623914098957329803731490041511065471703027614982383208091930218860919830601806250500876615935588712325886568751924344536011,2971818039624948948731712474253430780051229499866077578522908262684227705955662144678024295256188925943395410506234540579304057617372305228/1039471319013403012887492285699777455636201383667892057652611489245054296756338368888975668909266910515876410725487602288779173661424656931,42081265548485466107263751934681121460102554317431015522734123793198936068304856472641292774806714720027445291931303182303636955953092084672/21932875549471277414777579974837541909439710531928422538833398332161739076035583781880470890289846655098635193518975122663303425183804354471,17034581792358698790634436532983216286926830885555170862597730033502147517385001607982626889093226915300831004616504453872506271685617583323840/3231223613210954795972786819746626950767604460364409117906379035693543101692419253517772578314602593650078472993331918793118245208544358130979,895658766566635947886504295155904219394447045154429341062329699216814271524589386141671918812770926831744627287147494955273281424685799573016/366868241046812859143446534283513513509478238590792790388037333235508289086644998898817338708827061304922836895419654725716964317148606132521,47489745341449531322123798732663272096846491342469942752534477887897655233457772630277438482099491298163989312530116815686314896237782639/213309503879568969022461387188514726068390968011474616857950612772507561381383013795103845034249429634433110490549598099313779957630344313,-4189500586921919229200228252789387019104360903655924575575673237878429785689018917975338651915721181894975324420350568278338127128956126996/4260703708774455880526244117937853890690218583957765574829125779560668508041487895551251502024242467605839934115113239393694204456129287643,-25263964296306017561942105149502402144902542394120246665500119505571520248690784926877037220952582890632856884635353947400544670082868399468/244433852760018287972424768685601715861544045123156683130720765771199126104359160938258972760873807849637521591315023304020056749974819749,-299880846478676106332125243294429505056104648402418712480353701734419289752016436550290758577031114902503421284805707574083444398067929330408/2466033954905447665380463591518463457002455690090563074294324708533761484698247915232797002086051701326193154511204978601900767128336878359,-10561358751020147756777501370564004663697498601609970285459784467857684772427597705764675780386140361306501563883433396903382870091838487840696/883613809145846494089882823507740517916961167173816833361671211122119445565000524315073066253741857691779043809568592585176248305775701376141,802955823547399968604819135660623146188477161332842953752549824177776022617769024186799526122516015816619665812403208371871846535496096595964/103702794207012537045873214231335829617693249959556442351408647381074096406031530406053411843269275651610201145873294155949090856963425158733,99363182041339318333797413139349318269192836076053758563185244176785772319542117203911383922306882002941864622223491941911400067778298396448/4947308212813691557214412804449728480038501309885078814725627365612754378975348097586505552803553510407427872604864488630718007348630266069,-259157959817416014728837824685319563482583843367528022945853503856554438751419907233380087273354653686540442008718581498364724892130620891984/4576762905889819925464628192756787679728993591290646286053088424727442480440443306982465007861796596760471087896203630040142591294864501951,-712106604801408661397843001501895328821399505964382013887811960082055524436036483455099896554660140326938988453208916211543598649705252835392/292444207488246373647849181291660081254980302886934029170857362885676282899348860258775317778386155056100567757250576311138808638686862496719,-384933726636226069772302185956646797312883343579735577771433034313917630434480928430311952702917468817246986879953407776895928094321018375083136/280933913714803636479247111201691158249841613036126918090088416036288087242386945536744850769693911976710702223101262886331949229261989837593521,-477315057305131002606193378113360838568036218959082595093214917778067895514150928559932282434508886746075683275330462786852949531316302085169028/163499272960999630476453856336368546130528792894446424476446519575838176999802228408716960546934493845003088587498560655638228795715949909433285,-97483744999111254706391978024972378499082352054238116918059199796650788050701396501026271660633394172185688040956515051921780494623721897474240/14938258852254253934974058508175661690823938773802434382744405587438801042577229872465188497012140494841119781133332399865181867044875854631577,-437059379624164383588058323502966441497449995409713400613183156076194023312441961613835141298776866446604370372965836858485971991838849997760/251466836471966061501331179758945452731655423197577504152241942619844325757731203945762930761544911827612676274733159893613141776678051143813,-52507430370734163280264297474172968069928258187556294803376670064527461541818651713717992681668096399787461384354850418902694972811699083512064/22711451942361541131790605428299638982504349928138465227115376149048695973829531785510133154262148714754985588501545851255700762812203440936321,-1335609106159485738492443445381704379176098793219387796696211674942348494186657224858156510425133172223316751584381280920014118922433555953952/1542378086466228799555342896617943276600374816494216264419120363920863440029487155049813551175682397039694300469915201568156284394411076465869,-178691397822837285803031522168292006948256369993206555010582418407166127660868883918091838475555811739175776448055470087585910630114624629296/184005197404564635309908901425218002602162224189895278205724431488240417786029161365963662815163615994019403599817483444094390133778082468353,-270726977729351419511503668101629154650928692180281809845664526602521437583243006920203775823979496699005540507970104970156818003500830248173/11448731627858411494752283131026959227703700555532142569699459008563920801473549447237257957581091054404873904081966353236188364481905818304,-2820916333347298056790263550677222126357595131035692591500540670641102371567412888196439415029581245409290058825743423626434809851055182585801/189213168258352052040318253477922245146372114639586192236438688922443424864286675314220360885289360404187303364684125046932106934008381758496,-70950227936424627978300168088900214713219834908347208071549347047500763000760520745185851839447369792205314045483485852075922880656316778183/9420791858131460068754706136792448414687357279048952307302499550662688292907764014606457298083070985601258853647349053739977878819500556768,-11761633345570465359589094354412800210390867979314571681185416762864688338526334745594255070076288198985753970887454626876555841274646542949/846938993396150658485895621526265395489115267447142030709880278121800621731355644048770331277339514278261616534387645815506745292751477064,-4555416696921883607384788973267197733584987948303431156030334396027399464457135343418006060111237700840853772169565915955242649114531626565563/1250093810958126053653459845747442279164072256503541448323615664087823630841597755560582443679737455174891238528251292280710846393537007497319,172756272517540249545031601667420742901498971498654035148591415132825762759067229662625311307196050976962874972246088480581052676164393273321/167555238329276295800757665587958274036595763499603794283033504459444614718640102068276686303752659110792794629510395141439304758057019337110,5030327335223147422543767713055379719058744010006497884348101766498767148866694425228850008338269093623309562244197103148449489156721365616243/5079139775303668189182589252365721871162225973796657164220662270185381892232263615434362470078125476135010422124926699475426329591651984162816,188655478185755852593946494536583502114659862511048855985142263623106496082996240954389138913455891105506294824751688147827421221170455254435/124920491000612369105512864108121880364474860007430375393987390212408871388078410426040962810898205062003324822637980978157675870998720126768,501837682471576955968830899986014553433924428527377632469961456799629759750281375922868748417596499646049758198374950883000863437353907543179/61264789134812564917110090901745734867127543212586937624565946207136766995459514395309419206743511266046462288019946717458585312943240044038,743917568274241154086159652578155129691109210098564716329158282230454619523352183443360835978506239577479084212553067878518589866388827925453/6752542670246775200058078802971067747410743225876802700816770380783127203254508698089149968280839170305075168591773595026608095175436980734,25512624548952652479909769070204434056497277198865646486348638098203703035250095873158510600798986679885018984063400067200201936341166744701/16954963503184226677088584484425594919093535946217346673650450292407645428915193206039911123264558743717289132819392108553580856997347229362,57074779085496814731891808180369151916364096074475950907619092467761218126763928431585287299556150693448682243026496288578193251754011057253/2978204932468872542182842213441062607087983153641024485877362627942533471704342564065672873916180119660364353692150431382815636841712369386,35315701592016457998201981536349805289359014683691302409633116007601082007349316126206416749511286112502166301694251321191771155017097653711/1455058069908094085285317198139421587792698374573466910795795685607853906450136882100606485228126393000078002046086665621627481634332122024,593365168427102193565637099917089461833120607516016617808517997331314308212562669963694175396821710055673968475595870751384279218037744301193/15495435531045358626324260191989307805439108303869790299863692294114841740676223105813537883442900104025387145608716912435127273910107525950,2170836592330884992334922938310921700177717528702652213226087636294390130913591976196728646300925885161131963305831962940530977578002704617741/100511763843035647204924217746227313014334285707123918692914040581258552770790864326607736278783681291069483732132401620059565184211802527342,21951658828247856881773024980936628701715115611717027581950383728957646972584340536553463889601026022658339004092329010995381391970561606327/3543423808864738490564733402960651934559311192105341871315586576129530750872693875884547707621758077008455036484668362353795944916049402389,6957998045672946586143027720704133876174093486234627490573940531341440468812930021830384639871491785106403916299484382005982613160499497567211/1112902399746341340652917700945209446991763812683078967686043620804211076392852821585549365731336531160716565619268145850559632608914459836288,-941789288630205650528458589440434142269801137294536759190601428251741766533188983026163573359924057216473141825375064068777641186085754764157/190973767170286055217417435068515634114443674061369571369298323647287283793401744536050170148564782447342416362857090035988407632874935553908,-9881904984615317293565749957347976575101540971745402690120286180773660390428154565367211686062023278321893486360782498660574315595089310074291/2089541611493643897560803714769329594627868930290572767876801985103399447728072871508350852964030201994893913055448329108486717230730817356352,7071341124579230495307851439085753212712216676440990243447826816988506562764998447830996673054071220354939767692097455059098409700517148681/8120512947907250173570216304296706458163131025244655533986888883440672043087305896977855880251055229447954848002208827738429702245911517670,-1993813486635114724473789902515231942359551633720036173417260439076906706509811478437580034724132501529935423243079260135699460564257457476473/781981859635830013851694302417679420008548231649576140014251122454590128789054723284452310757876437394961384646953852383459840225247299885088,-1051103737867919747608428375147270672016321823497341016354239156377166379893984223336468195129428850009661836274906644395699466234107634882861/1169055987639317468502477927225155935881989007744045879150688902201975274854338588765981027478023778545698655363130942614385840860050844156416,356869981099405002926406433738430005396244023152128324150219666452123410999171709309633707619903370844165207274195456005598201411811825203753/1201196475362188991580846558388438841118032714289791517393243326938978287493556120472579480451475048013861512744121321728271331094259440377008,-832973090403332252554687813125177379508538450308388872410195612471239269770209753035042777630930087985779034302052897897504405186596310060225/390966030462041770646585807289198406659685823345715483562531197856660176307736530634891992464672703649146981461609325752431390090187148880056,347772623108704644342921298266438268091385325973066365716728684873155755580889298906293499993245241746628667265375599898335510714492962524341/281380296502818350673816325417259231337388097215653442933458204903100779015976714126409239042574630159452043118452353661933888943659049394010,-61012449663732757831346748534830585896055100583521865909827397956787279870205571510377738385902309413629018465019918931138416063289085167720/29902697275123712705968849879836622895522042923282141035101946046120767546325567050945331777353201163118381441771207577433880733815256756169,-6818233922877543720767557614700305978959995750128439007510125938872451064243393988776919436643769274059410315480573205550835240966618629990/7904946254332849720336247789014355246837049127701874062590439504452460235406940895849157116801458577257392277827497160961760644181607296999,-274244338632116725286552002693374383752985358448882227687105618312577119031237807208159494519993274002599669350746737053557607673941440374057/80538605725059753696710468359407128381977676853263277160505323169209763144793136124792491732623745251430291791280012985465616224324822801656,-52700113644891683587594293475584599500856110264908231176874756565999063289810710365030898030949846672408207359125528591016540358548297487250/22617817294728569576485694275893646600392257976063914278384513996057152464531344376836913394058510063761633493659077401511949291245164796137,-223210206932896089408777476129600721258401039862449089398020052870412437945568670647382982844379140347498932549769225822194582831876383306719/284369958353411816617348170763251535084097551398262303203756718158234784131821111472192565153162802615443484044879097652465724985262286891006,-768416753856451496188186702225974625910484508077549969644306872376641720789182365118761195480357571333451600524555234103385970346062706510929/49774127202114735170262283806358968901848837386569106125113991055565769476414063546908897797953477536653728995453651802834464746535953351648,-11045530099328563304355867859326895742785315836475184647455962635790267739988359295352199036486227734346008549158094053672675944365275008330445/1672767863389452668526216290453635056427004761112147927916007826057177553980640464319394177878018227402546985942599266090370150680386052802432,-91495748922329899801245510862508817139336335167683761444704139605252355766943411977784700124900980110266502597076181797774603063407046572205/23635511100107166494955548651431953393867755621415080115347201291664009821318318236487648848024841568692360212036439184823299791610749383552,-141439588364683917844129375642201350461281285497094009755129738807642526952988193741886357880253241423631571181654543529476576760304555040686/60888209431732215471518093195198002112160529610216627554094758576130278871451373228798356808265119232688699919061012356405416309653773353225,-32128108313143210911405554353243314648416868665905644607225561613329496991055409168232317197596561952375656118062904127128485387194371735432/6171386986669145785877043626350466985938484081838510491358072902142392470332727662887752137338354338222838107502868580135069731627017794681,-46416797454607948959032835430117363672425845450582595829587295381028840872078978047719299693907734842762932837319956788480260319563196346336/104689677029804319554250145510927779657888706036825097813373675205875812994925654996671300871955878701017951730714957790621475121764206332699,-3328832311569930371900167474607706831897997826326178908937634234495971200897375175732901367068566338901574837983737965475309358342608541464809/113160817941882096689157475447887727290029980813826805816774632475385896242751959562055505748411047243133731624499694985236496622459017289101,-84551631545585828177687831591148803719532298230192006692300584251211473465275204612511933669469978514877280953907539717430462085804202515897/2685723392439678390790195875887800110205536912978771817299619755944688980502130953634039248665743219842580202205871361611915812013008631451,-130192430687582775175219117296755998192398794387849168592720266126630535764768187916719469616615265676610947672463462647680133944246940198139/41133711919608983579443554838362909620932474565535846175384918893017797344949997900569119314560742436206253193353859130454560673791698398984,-1019735259171107959430311982428419832418117853363720498617829008333155321230976716307320215585346753909652734500737037009140805181473642000447/378091308347592986767783165815256727224932151850842269419843693706382700223579345182477160556654265238056899113006649541883308153299534822716,-1864446429433150372995891869620084936712263643150292157516131253339289421998182492280695569391400667968396361682603524530583754611643701764619/803254446708555673006580091778980088416002329311535939113585511036051084442279042544564548247770815280095326984844753382854118259312575311556,-7243811414232707913807314339006958198619185280043089623969373722641252722512077108379447223268022984867721430810646928643863014999625803230157/2984394896034137645095542635472407559060796875261563128976974694398201094419405124024674749286610966238623682094295470236015479239042305030124,-6390986833119097887967805733972491705921862698572924229521388763966285164282695854991742601965878053682017832231333683723639707297182289511851/2980452175247454212396729203586134976106524936702775608310597152606230418878239918408930021796682270871337772104727449361578376769004960319668,-5278331703536750467195353682750861544021735435592546699819804477938591631339121953843010345688081508365567089312736685482142697939565310868040/561216593099092631572988554992881769964629715771971622836825031036315607149021831944952564349649370283458089727045263401019441638455056953741,-35481069318478938490472660109432226808929129448617439659224959754750356194769893049593593505881887500803747117936285320397195889619963173912/156081454999529880675553281864954474546952358796802071988943762853421795809891393574882003227227259252663804091051134286750994213723690119,-17299564598857393851464763271919118753200697835928841350888008293082756019622069520633987377934705119930679005223797526897308227021398693784517/7668141462730279335999633433802224016620309038143603277607971915545088101224159408689357345685451970687402534308195716413733771589181687691312,-408402700014702346393070712603260726039283578661759993640240735199814818103375205417911788109432455697368475616337761707332933289647710862314/80183088302054804301475709703667966851094845040781572148010923623581518092153451640543867757512083605553265690345977306182540915044459234613,-195030262946999920265850885989813754850691706236451375700809869290801329402999896303217018379892420127489365405615294284019283379016916394078/115477548943083019848467781644311012111710894326286679990278086494381511397168478987683570044551254074685195917192399419271297618449001990691,-292292654457236036434708735494540056628135294061904191234875311196923060633736078964136137736132935488392946654739418973303298930042048555334/263681401549729693365461065435042287268589238701185260897331155935746691506823932592147622801914400541705393160350443742575324306724931929343,43752029423436642226546671268097070141461280627771761348763311869963166988495637025830555654706072004410686075783191921556023693741581067484/3401257741632475577135301383945161184158412663552420204305850715801341894638643923769353222553318949418317473637286949214697388877546192065,-183022857473262319044616031510097403764939897929422393994487753307321240373582117632114161090441430264911703056660434751024404872445462343148/55927884778438800486566143513775262980375533474865242554518291430725274625478686602809638786085336946884300335197226050769209279444580079019,-25653279824360757322074014789215111218492184285059357882081726316113536300976958520780039307184169363526080401018206958796070753129959565842/20096415774880147738615293368740101060071849651754579651437429780274822702001720678103079522971078426508710908220339298162341941133248224859,153039875171290439935149219251524776459349454581986622126318947847159916899268681828634699434524770395112742064445890372733225134487190970177/121579815975658400846646344689905040649584147373309534776290332620623359765372929338429305268137292731567052462514728906025745264581152692970,1546754028512941160772455058332994158698981840785732995406310129595022621585900160642804053309720120324090685953802923799326138662375562910709/507922469091435940083977662085698343831536687242247479178838315184327880250340287482039704234358015256337787032346231657375148341830396925712,2965231499483626809595047199936648335303025049551571809708306344386453514051102701507738003142192240429238603200665454960216814824649195926548/259206153481629876409874934948724280757204232193374428261196899699901518430965703011674037843361295761360981857882208997806434950454160085875,10679563384164398143895191794257621489317165335147936267880993155358819474108871465491546893618476932576292802810194228880963207810077409130651/4709578982167401110040208175022103439086080445946949385228631909371553512787545767569146857991710949295643760144963459909083360110802332609035,7120217171569676381333773357808809969866575286018341771810960429087085339010617953456585063453854780708478458623900529818406437840433150009913/2639966973720940745891441964029036903876064805687626452516850059160187813061007451393508645923444824728819527488083445205520510734682019401702,3935544905204854786130020652277692207279621145310063958482001995301390911880311386037093943625658313156005910928422912870207106803826892558687/364938707773382864345467605997164124044878713112189153494651686338489095919609401430644156256815584551999624096787043681381594831621613995090,174275613542961768029778742445346138631925201032867564885436257313303106024898672746330931160031626512053174099770685615678095834752559739137/76578693568538313632344269582925872319457333190243291813892928815148617630634757049102206725043921313248352486128118920763476489827495957763,2233972010636352212097222770103337793920889131811127797655600467021067833700652397249306442316869436216670704503496982954316407122489267951367/1177198900668435577149814657470154467332178608589506045189394926605161290723837400694996792697648732044183910113239883126302046448198790880380,130577050252692658481309470783881378523741055460810288607752164026924855870999902813525306037241464881184355754096974845068505173901781853727/7918303411198316407362252612480807673556681391790159690226933700104119925349802178762958932694463548075675586198877046804673075031189818560,130562885457421845312595586602186316977901364492674491079461586188800080945502858240882872777090360549377607842419594061973855955302533175683/47947045442958646631814412804532739447914446262664625926546638100729971979728900008744883705132750921198541593134302874066465093647364682138,436674099047393953409810501602923752352281438137458091363934985200919448859157334939131985883882996941985664769053946578920900585975695388176/17566475232775552421139801695605824885846330217025194430981556805897465006536813552272421762999512487790742342364551713512086399720831630807,34898793087822431506408992573139563897374984879737960316884696965691943595744147737760266212456946633569289268213383747113611995841737276389/10919081748712364838591786855712463674245409584989828693298596456877777670468972040047338088660735254856508683447969345419531717305437817488,1213293709812656691652598533771463002475273467913552149665128434921515183676176686660839289363587432866481760369522717652117696140295935109725/707325777411829154098987355734890281377709909632910287723805083911645562976580097474703782656234411743390415541839940985396748706325183324304,258377836089559151410678125010105153388290302142351986511008520877489986175043481011903301401529461302270958300115782105280190927393021984912/135205938118379859613369507479318478867818545848135288110414327916781903561484576489781979842092316900483522521229085703423056328382642264759,690812783060804022270303988701699473724320820873493141626393659488423817773271162186238524157158718727916378748294082711800057871424021222667/388193989502727589446901408841876411785848346073287395721827888580741782390963163264145173145271924480325855204604116285627658685392328456754,46760023049033633571209329157725024487674085327852811614746870554258361680391703452542793625408717092696592541289973423693717873039079612609/26455126381698158801393029494150802520832940703867573091500726828113900941822320778052356723466468222910485607380448115082228181969772796238,37409912659365829381955799693608451271982253665233456209320041579940395768706355723610523396531407062858527804268285018745009583152740118149/21770373565098317293613804887442013148966172772531789487493698926196097423799423432245647170952478780204260844958868605965011901697488689318,443122370511515648128562343899776040897482636825856197418846402396025172285990091914848890181190339239341098807314485003186616946093212834223/247863051472490185955604379274936059785540996804754039152672383150311876399264183434839595358201614700963006833690679005312012643359549095530,861010676002883264211142762672502300202552087854434145142137895363691985473731621841746365592846849714517434718250012826204157960446868266661/509019001456672209967209957958387084972582709452485480582937987228148860358610490932936524644279886191645278123229593667056602837712701662298,92588133563940580955226393505915655330087443392998294928416414856921029216230122603770454691373542276913408115629897432914504484776655747557/49054669804380279249512555399085636214409596337463847200100966728404286910718531269242742925667816317267891783312871130153433691723659117434,939062665206739586503407759774925568463788508120934299169103170339984241386096410548730260824726121847962820326103873613226229374142486619975/534802824881664117761337715745557858523680938309182575642059511174347318341999224359640898265164055700504925232669030258165797320708010227922,521201191442350729477287200418055245897313117183028917666997633475605750834575535305066478089831894362113017516325349197194520755413278483647/315964781993470226792548874582632366535255269549224045469553945575634407440129156070833319928807955507933069491861346498773242888212737168696,170827716109040464824718205142174069107230054015118381917896594880961670637561002336699378051621027425484392383477330279168415780035660208683/103585311529316976743661231953942120484719809313364407691312325887523377635748841581293071709915183041671987597867913620919052987500944965104,153881921117848752229337003989031627258693970992345775808284171801693039090119541440982781630465656625850365400186028279665394544769677620901/91577232777612514436922238706897278995153990141355015056354260689519675204411609344237759446500830277799061070504651278620694567859157713818,85069845680938862126581746705597907380797920438774189601947885330849569096272535807560815732128391183812028676653123704663685517746659549723/35729484899632161284981979323611350331215157188455360985428064714793368826545585520818582810834325548528574155904457293064367928732510339616,2900330666083144867678228829661604204181508405545621217341145395209530280252904713105501843594012675286682306912803200629480059380102929344293/1711257989678698167610659667453401617166863944392795106932020553002669050230096803268688063513360642664604113974083850062206189905502209113724,5365143521593075649046554042218778494149157438289866191977995890643175367431334267792377704942972936334419249534423890564129624478123800992872/1970923926036831765007748275091865181227025754884308380403087658012434469597443000380155267245891242681761570346065699255204620947102020325699,33372460893402256087285216822487994090430577387462962652260961994462670913594852570505315482019617393991577513459724077292733462587659516264/12582459557492480717989179859348876088997746617556172238250584582769257158497359001613827339195439157946667703993157373406094859465465558035,5052684113159077100564361505768157249456237035388747424225027939114195102632554135192948305547646155727976746733316603461690105037253103118183/1310521158104161060822868102036753614828107065433132704321949396809620969162598369910377342701117860511124846432350552641862549193572095229776,3913575517811025855734597156676802718415785198490114045880370912915558294895594107164702553478268926059224282832741826526234844688898091877951/1469983250742044992128707674422281219242193827943464919893759689544392332281554185232186949462841464570298263038875045847331842574670427578870,76759317846581213275349463748211925833203553666235830926668758561081779957718114864243949425661599994650073924565305698498177211188852687584/29881054571389093060780369227210424274255275719849896658713987440219720512378756036514695765580408247956248652745535489169489348862959540489,383074198710514302505193691796386567093694583980464664421547902006887835228584385565173567941846395177678517427610965358786334438080726906317/159445067056050088630580812058354647571679239604630703233532305397534029174867464453232740295539879823393604883826402394989546237879078100578,354048810380969427594389072226392959644642722228516059828676880059502728279742116853787249729538300262861604063398719898514888197596305409097/206665239692813146177319089992804422940047003907539771945990955872018150800354788462120695417081053851030942613339438986532656367487716579148,309719749971249254395880646738605867724633712726874669297443234365257789494018586286767891946401470008345123375398378883377609116747714265311/183174798332322637833300233450068678506739382159613193983465819564072057274253248435595004501618812819897959323106416648383231878924282570348,102395805751639925587351681401080832148563651597641006210302489650733837962826023895877747009563257848069132003236041349249135793436865463521/60752542619227315936992670648995245725973455593798078341444408003025132931819723025446949655316398814841709638796948800387140459041195127478,-499545481037147951972430247579433428304722686399805774317711373682094715200330015495871573943088893945566129249389280590905696467642504031313/94517905848028376838835460629595012898815286611288396288647866693936273546753718442326245791412080668363339055140508864978470538328923380222,-994104148124163282450634113492074976660959523166633861328676913662712159291305063360297369288910693034225465741628008799764183697835279543952/30357698140663126003817437387331575117640828755403164423452842244298806280137402263362800529750799234117345020783293898503949156834946252399,-207526643026629617311479656784501760073184740414145079840192521191994587067913793204454101620064253671635473988685576831882375743715477872732615/21781926743301588843956343761435041212397073039315610195218297403603793544244483382573072591624253599434265313742842926639526560479243402639232,-59697044899266360447791110212225372826021320922438178869526947375212074878930625825953708625011456144402961707696291140122769793327534462966/17157043263895333453817775432814329731470391515422481756740498727810573778341374140683817917321507062418299675125107109173684245869347867411,-5712344682289490574037398689309793963267245741990436293009381024986408961884257957835045431797558133589270820600651717008520910656648720021493/1926384865427328044389409664252323867468160865484350862526608472926721986403596182823525318476845899989994718396055801725141390185874916623488,-41169349014046534285679616030567098819159793037168563407045958886580808216833187815836020978777145636532794223171586943974719211193471822352641/27295293178287579855319156603680073810373074639869371399289981005110418360639348140738791635461995692866894694495621177861995866466602740176064,-2157032349176147238338820724501829084049637576472756059533918934315090667179304604923451338572550913556797596033713692671629136973661419498217/1254701202185742714903666466003602395906282083186549117946474953415235949167200944969550728337419668889056884673479809638862799025397685226320,-106517063837977466417887199094855406838959889282467435012080795446364473976588218846336493899283300476485937638891414847953871861941331702219809/60080000275412634500189965848739788961689106608301574187919211894440291872164090274322523536586172756139821018648453397341726185756530070433536,-1167560665070319346682865127470149489256402827682158696826357959306169445648569068376503075053980612451349513097492762343506945054120402030252/648788569216819935549553400108130032565871135408700363041920178702948535371584102914533729241587703777309686414684898871644523572715743537461,-3071263858249695257758489691193435809759659173980510230392666358605386080769519948063238099915857381289743999556284568335142366476963552477175/629836602841995925071334836092997738664360975895370801774097374131363330959629179607675060406140661146192206427448194958712875453451005687154,-365760455459757749603571317225304787965447965732103900135955609611323421760267416003686168017588129074505994283418974943375419589652392301449/20649296292555391108713356586121011627582065784459380868816383988254018755136373303826494169948607929063611111763580878552833574809071130333,-5528003882818630410777014493640217110607411942624049977850737883483430774817880591991759736635380542446978640169649156717931987836164851844068/359675590205501724882489980419286727130502277501906227639456925509963181801925036866973238317455385563372974032880710137571638698818714868631,-1186009544527731782890583057467770831174350805615319862016693487508944220126949867989472068215638336694669547909388174478221645601015367903925/761707038705531113899692516673662258301252326516243776863546267355540732524158968284037165252430883280283662488991693482244356792734564953536,-4420798241062911486830090155451751546136473921844150616485295500448665580355614879699326873578999106640982317758249622223686780658349206096951/2834361050149672581620969982530601627357938182247596838033937832962379347610108153166351976525785313401407420326444355819981862013256987979008,-168325285509025437042425107920892209549070755870914463113661195256887895874462295317391051601213584142026649661058492942240739226178945026543/49087218665684036809476406565227173621471310154418684611146816393760223504809826281474537147338088179377159846875538292278378599766242885559,-499395200354136824890418510227309885603819885465879060022194439259046029095779436669028347227513438976127951744593339125629854571154629011201885/226873830259852906671892853883506101350703299838151627082197527921503387853018060007766565109165370287386632008131775852966761087004929697184448,-2197709545288861898194964402029971199166669493419278357455631981712596695696310944649951147332734154440086193361035384900882133592199122466193/742239544357532089490360991714071661479844077576117367969314334580915630267788453142082744733472300344615033936031482749037689863859647403797,11285525731139821349692807808281889296377923138981656355656209657435157534841474353949726781371730075183625324558877471065368476004911606560/5570112473928007904153245861021435741692436075483217094190089131674960747008431634482110773158751947742653891606677100285176120051053200271,73368395600595678564785186703690877718038747696172538755847765352612341551601453223452949681839533167343688641146205089326870176021229606752/34205330958702868424231027480447142396440976449954280032140293760691690606573046982739406000963017097374204054397068560027749043360530376001,214883699437916641261653611109861470637121922679417919342538641701392318099209292966615534539138287809365760319498057992022368323690520856788/25926927521372402652899240149264081304593792259654838153038638883108392648108827265647493784259669650717908045977837748855764597022154422053,893249876623896393914428516405479209241283010032311115949225284454298799617292295075930247138160546541352927881686975553984694979767366036/677710083548648091855075408635256504166125494339719373840368379353234925332777533459729006338697200301698994991561437125855707448972660821,15249024135067881725817799743923878088786351601640647581404583317247720427270314757368412489482118484920662368830551268965450758292016390876/37921386645605151942404875669314035697989159408008337108273374158145551973423089023451408057847875387865850119150943591327407920669055907893,9073648404043687545282732148210996098835951440640985797201651504884190494014706124593634728252039941853576788864324979435077624902230177696/21532615724102409210852349567110384071306364384964436111826361723022395449866494277890792849966659846439582008105356878990708851624623997577,-7878404480011571020642333171236751358098997969636368822532937765727111552829634541950071200956157964798067570670708608305380441332236965480336/52859336211494686830971446920125157398754149554816566376892711995469415985733950541017521130074162614495466612016497440600611791940360244421849,155884708165832355682167868247936047064646319369810358100848239391538845320742554291333344536008437390643308518692403943414694446402167633424/2397365886990677939758445511029662093541485480883910199119164107742889326829354183114936256943809076190831907192565893631150137118922322812163,-6137145807673774807913922493846631784522764142775307884699954469927853691814105319767406156171905334089512721709469127845729387254074666014096/46042709317561406447189263075635934470683513261594027070358659264706408535622036213539943150475438616738642251932382727018245535134658628150823,92131018584764557926127997153433643506556055954788402315362813110943627685249362930702435284672431645764830265021616557110281735647633099536/982832052948427509870414441253989467207426745271089646104246698875904295826151514670050124029839269244724014254127811629969053602369004868927,-16281677041975803573748066939226274738369245651935461218683253746261096717646027689096582445687343156764461427596181163961714603261841065749824/133228514373621738224792916716731154834209700946863416118852813562939796792400494685417787559072303808330844720814397846597366430379005023375993,-2268052863263620575638709485389142763772696200783767739737542602559582832687316328338844455904421055954065471923809874440079836698062368571816/7278345203190068789196849460329597131961326230938833559940273226243731316968282487920383219367517803304846780087480774225066605006444378974973,-50271412661493916874353852057141778750215762857754964276602966344789013457954072232410735303949345968882193759009584694640556581128772016021/352314672659866765326433804871702348237806096447498614830526694263549583074286688106910510543953429097296844722406341750511149892322291728679,77337541275433830470498870348065038853336114264586085128455376593313765195541114004302349505516927712137830604454836408226114784431047624272128/6233294102505206301394172796139780965144437895805670528368851054906598104439205521775515976508183276512527171397836998889852841023795351140587,55080784979234365142663323482495728281107838250761508508838080309568570881314453177097622728741900243019055527630325002900606592791214294324928/43437824128349037977879844304354268528999528636387970923427673155781991024767407989465164679174728877939138981546682154276653194959789855263701,40769033255933016415197021873514596214986830873756178763865138290574707861555339032215592708069424742779524885098031808315996965024362284894208/3980434185262638194000474002719304689211326105978785832475958986638959931534330017088949207893797158146408468683302582743995062105632920910939,5659659233444135776922446408523669078466708307820634083604089977900031167473336416518817098969703340293514631410578940814774110236900312194320/122032792754996294780034447792892172732311150189211208179174952462227108223842035133484063845636531804589388415865876832398587904394579855807,9016162191995257641032190858548377941359908751219735639087784082785335164531153795924150317838285010896906596972922415984540121150453907165736/8368387444160524150558539284941823630429594401617123049852166985982380109206615354273142339556715304806277429257073359651645061027623420394963,83195263262625622198432977401117910590148828985943612581855293603642197057366257102539490688415745100161542413514409287537810304077261014975264/71397961102207354360596193481293996394778380647929199670149455566326414395799308619199092634000746540788350557742496921126516734216721150758703,4941585549415772540359484128924196213913848006322402032938171818774361698138043280060374111735170287013756920752499426814875224848627900625244/4293057086887179700330316333650809535803348690727018440337519614818280945855244440037501114581339852848317873884358721575248218421082669561513,277125513256466275584995388924970813740374018758303838845486584214932203226950710752233016257173912815246742338024402193164088209926022797344/236856708253622351149292872997139739224659363800702933311299702165681056708542254298339816315779952676286016764559680505083068501846178444463,5150943572385493200495259353112607746099829837107296063664098849854364876404896887183503220782158987507771054812510864467560103801007882444416/570097923813556358813807335631817495631216457372630551940735347878717651994387732814876655808441275142302871277984175597491957789155661465313,17675796661605223564961882214213029363417634234693223112548156516721064411949898964856426533294597877859042440439730821832737038876288727994624/2517001692494869683157364248923569434483891843570013368425463676243775875271322594212528216812776569320819318230219049386400884759615722450751,76164560740306142660784743441017249921644704857261596790859224373436476984469192981180799680540417006442404584510654089952843123253278491438496/75988363023244815583398457661417392667995909704655961215589591637010608765707388448197935970618502909864172213751553811831475420323069580640071,-26042259651973773861173494047989431800892894831562535923517134817777611881943081184033307847841116548734894717504024183445179520938060787364156/96938065962162996550969503125462017585634132378390791680219112024354973203992917044748710853465445260854470090254782711675125945563366284616673,-488950317668209508707576560572778885210958164241998042207295121732347278602540883758258250443405256017134044990199967976569742841446938796435712/3143231779135632266363188215310436207704510383989861561521061322605312097601139316869344966104320223064153076972273238489223268889873787697569935,-17323906698245691274087283563781032375447066315037461578746404653562817757208819746858196367492135513183584824228662053627138387856209898117/62629952173648756635680903238206455721576633609710429423837256159005154693921246203194670429191958269215535101151892307433494050549472916331,-31794031278871235785071296522478208988972746331383119462703156771921995877583746258618943913665877320745862386571677180365052669795517544033/59513752152076986336866146793243374347234422791030972198082208825890145461186136709626611683509070462001629339804460144581731001553806761976,482241144626258609009895013869850585095769067262704170772586180915642223622294767566672890583018827322372633371611946105515901836456084112239/744366502344526907716146476710291537242379061934087408616176899090621857225485960785198864029501903469464021931332317257791617680262919877056,-250430847240612987981048305053475150942428428185924790363577256771625394759750296262507518280813713838169426677514774729802465794774443774637/868029463299596161973657506210990632880150561308495594485268747388172197134044129953729890944817268271230054153447356076030572474148906216283,1594358513887100061771018361357570753999777934239717851975058842002798424467869318986267370283355740912855989896317165566024832039367592860653/3455814918881632253022006229015749270675241555479030353671854904145692518434307610713394490865284993260015787638319379063831364876689430084541,1403617738359272506454031250680482577247943375553421630648609643351657160957777602507825536907820906753658359230121203065976323193239831770137184/90407723505933996199877893065451612655840355315146303639044194280703044763854479031060571642211944450477782236087536754595264923721354034740277,12133115004696718175916502135834992862712982776840814573906185688045134512353752629227723881694763020810941829917914339501362780133855688676304/5017259321741376316683573790966381024011110236010568033251563845685087369281575760277877237326947853660501017846504068905730516438183408841995,141939868144855591705751728417472504695936251928532945185392560294472340730558752413876316442767398672209875803248275642577603397226037858665/105724897502888470793970676196272563081942165010206821800382892712550793679100346904263013576582778232084899885936887771128829169218124168256,56625238225233475438557292158861195662816625753463614112689267193492434212157451712391071980237733224683887850607948739356657356282120907072/199928462687911630950395667413418188066270243630853023694025410418747972234643538012634062418428997201956272934440431990909622757359943045127,334613526078515326005610870397016668507077246015895798074818336907736399799421689243200603982248392464124308246334138175604336299477644766720/854254612688005411413183945985270792643875218394218727789815082160932671336671733263962173445167743832854840186015173782798251278645137613031,1035900635905583494469772519815977060229271343066347426726907716685661349616334820908156098816979017155812478154430480523991169286200063260304/421480479123742809104546962414601528996747882485726946211284318075754246631220857735955472526032184164535610257217099089034897021536709115263,-49881521305712438931659658259151029426439310134936629908350834050723297433964640023546295313674733987342982932613319760930599657176547663102/560293473447986112674489180418474124756922364481137137365085814079631815101776291934195575299221767539564986778542829883576604227680173105577,-371475465801901296398565876768107199030599654425383751636878688718755232526480935011412562467337690901493287567698063503426267277584062466626/654869703996949118543317493412373196232426032967288099576442358310316770437123158761133089179173242282854709146137335310578408152399397091379,887683986988917849240422069180168461400585109311665779207374405778417486010236443801223193413146811371242086742868969287043998047034516991829/3266256142954098684738105596893084899952698561963194018436005984308411866767170565699034876389480551540318399340123397485312283547655490424036,164218891207888339330328516036871211024161980346213735735249467223131729297108848429074730037716472770380565683892687769433012149554549647121/443984853880171281675259219916677898290618757840523826712158479293925193650246445326269332794906590055980851259191916090812475116988406318836,87193870259220619076712115699716276248747467173383759334783041525649936548932880544675933953792981567211327498118281679672118921464013341173/151564377510257784512480921290622401098927900498434036582745299463491225451807583167357067202446170419146008622840464432162504618604304004874,653069269930309040915194917806930446857247452306429499153048881602414938769762140346833609241283954452845973417523048340979411472343597838695/1207309293534025956711683001520847603404008987378038004104883581498177281332787656883728520503252934059343263667747264521229244979958609993612,407963553615455159654561716575069384697294727652323152759765553183037517255109839204716763013821467573779186420440107044643065623039370179049/916127887849195411980809264025100374793766931625685164720812562289762726717072977309756116709562279288851172747863443857806972539689038167124,275945119947796000768523590467047389358379467260008745608125911608540546144948902698057011776630392347277789711493535293646773079579736346080/334686305547907893974960822122154958737403005021550990374501612470156074902381945816556371283527983425166001514947449213292085167974555630077,145557355482398314517564329225900823007609457052992239655908922843991906780579353535967362695774825828382176517927754254418985792821258457681/554043738804361401175605812043586309108110024892625385531475581793119694402915061216649470582548496559396127794790755679166206307939020112893,2803558530672063677128323903571222650063452964216698367387999039633741617626122037683373211298858491302608431757048477641576282889891789888704/4922298853755594953916161366071634508447290492448519708062936398471843433334257016078045264365855683065274959405232632132955244922397549503197,3321286213219950522606947873039270928708043519957872031135777226475972254116815529076148580457972305011777499859370095590616069872351990217153/5529401407199982911701384158357813388028069570798460548994330356362449522966558503904985947158509730162446541627217569776420380541808234207697,74591794236477442260309811543261351131967548147597064383821070091717710526783283390982266454029672106167702260280279560723366433209678591183/137904095646666971494937384612282170843075096000237818206923683219006374388523699939713042170395102559570292055856803578942282289709510889378,4746521827065348917877345965429274055933531350941830671035582553102254738692586019763672310888312748886498327971746007296506834504076660067787/12761382153126413292692562112296270870081130990461565223796269144259989054941605843577270268437004777119646634781192515587651858471157682640944,86488640517941216378314599581185087507223448214013218503849077381869182416116116205259691780595696932352932831268469977326456313279494964210/52338572097035165717558580504952593158868884724085169459088813336600812586721958253048530862233456541150837447377668937328751665114875591297,13960967939220405610097957201548435607111065714696673034164737486099362606337505051382334328330380439619156598239600970844501296438881249925811/37783843895864847488403266829035052783228787235592321252269224668344456277782190887266490587190842098416813201181387475612759221166462304817436,27373289405627632435598867531806378728120989089052908155808663307193901850227932166980603420340530503811476751481486605250192909202260709387/73462181944395708334271732231456930212754978177362255085433713749202190548761306847537895831365122157339332154326448541224883837289691642124,601825710101591882851589172062081613204857979158835349759567984907883897715446983239001927389891607761480255978438758598366788388127648625007/1550637750266774440558569166293280777438053111569598846659992044233700280378414387365386476451356366063059154701278332991160079115170359437772,238918181776243846423583103017203469847435064525971158650998941450481177878604592932340137373688133677421713745049147877216195600852277312320/133597543005017793076614125572084943171887715476413384702390361574427594467751781612885497725097330070948179240983858701802566392191304354979,1008928856015531407112975720666296756986045046024142241237340632052044069835040234121717790631382678984360773995313698318330983946824620291008/5220161908399906327705892812037224798804584204547470984924330108601972189611906872028863961222616009563016954576086958030960753700368238848239,1694164124640687517620100023778067519766137435959462374810993878755113944253290782254165880482358599862639025999657667170696430831832745539392/1929806546986045334096120506069833793614238094654769891995110191818930566593378136191889708104170177610942786788355104612762108315920485127981,23744443534224911310135277533605277993062221759184795887315518034469380709938948590155299893652099100576994861301090653187641151839890405368/32802394962750159912851525094751683453466332084208060537694219722534666808067065130757934793920019514072123606347106055571197566345077729039,16258473914132823359005103179826388104264832247524963363028780997176874479541533269862868563329233691691026895469002590736470182798993867704/68400993462952804431553552776968436885175838631539277990873501762457416748268824110361501239442895977686724263344438495972015752561154719107,22944009554552042640312180825130440340215245786557355577153856792034591327394353674119106366034889836473119235627489823146531007207584372528/89289677985718789440498334130035562911254168286656065166898656287569527812572335903316135707179177365748279607059982765667927115060095168749,205220718561247447426977165676547488967968423638265842350166485866138425793604154344273842296266008898929212622272541913685706371649253204306/592967563226866612372372013052902903829883962623796830936048692144314862994071755707457931289991962533010801689258323097157670160261593678613,-285045821659822060041386367773247313142684518312874047427911745426377534172258283311117924927407924200188689946327941153015607125444331541629/205315986056391387000221690649957846995100464545025968668905175675532903770427428023128683645304428514707098889873038903088884905800896284548,-1447651720503438833325303892082048592220695851099872208314114788224160672242071002423429270782014195323404842884748030083531362137907441386828/1032476511460897565466490580873783440503252735041330953823733188294608987734979256534993782217496477957134367505921722862099768940477206078861,-682254006719285380107263550787608778422494420965103183059234620902388241166793265925112120934488447974043017275405160790841501466539789024242/2788753077817557310921333200108344444664146489475728364907653640633870978507619765718974861463934548988222910873398509404159867134656860149709,-242876059215297085389152437860853716468210550496048225035459488003891117761493365061009194653057935140501519502303357313760464774398740123766/390197624753153133276724642311497694319002509167946571337374645793141503223642228557124445639856537444639333705733617634931950379876986810687,-407859799502626869005346323145012900967852888264801928544853676323884229347271358436991068585872287826935323450987315645571625267554040598562/106176339406316823323185807353114203298981960448028341932508351565383358838052399379531704174794601698821183414074423801986518577346621645649,-2308010170976200700265111613590365681578056102496330166626829242152629220432338039381011954009439936946801702169692728142329431707724316978/88329968734662186311304039195301668085226683338897383850122466144657619868491913203336856445740777090388302668238108492240605759894186366141,33265647389629306758082079645501652779332283980627990313407504623463926088082888146647463185717160195823838947705735485090121171845857385109/133692740195501687818713571697136442785597513179288539196119190918671932357195702511953106014920302771876467634164673205625131800220820534837,4622968263226385749131152458110468970393140877662107955270527527911499558509701381149000749153582075736523396304801819174317308701172899151386/4105656630042006416695807164258088273219952172064141885414825466765094200840967014889074531599173906169935231563363683391908278422811518922553,138602577367883242959335301897170482139823934983537392753072392854788197421135164995320585318866268216321192585112787851542727617985707916499/207535588829024370119687987671179751064744171168577070519927672403363107597354317328250261402213794826768971774971851394669453610639227028617,49148638883164733797025353833339065210116637459698602040956918487091849581759440153741634465845139810970918899664389798733770285976465344269632/55621907840631011782228262932707117296574683389561601145374184353821310249192070401984100025818247880286325880651470532835966112435468214422021,568652011595642058474683774561671310050198006455028531586018747481829765636413474429044932950603137437757705508694855250129836978254998866/2888206603043360560955777544699142786837919743341726293974046171199410948072178422756011417466583758067168529855825733307731406474616191183,1998775178083139753208622032090366313107355157543067451808705824207204358505704548699972038079376082169723141827265109430892019771625433121984/5118853962979511230116088639396002563000568961145450474173582239954448875720016890883396935492363942633269663276948158052327490122002215304947,-5676326055234980000990829353894081452402367634138515240022367715334164583746788518949394981732327715191628698617045953410400366737363010574/10992351218201325512388217824661354104647337649782178833620953077204221244667815704776678157772795467144252055334844881367669678540501603023,-258151183572924231535723293489575818948041975975870722933435108139143149558256956514593510542640978191377023935952969638585454319274806119052/608653183431181881699016838202827441965915849060405986071144442853116217908828174552637813421655357254357595040221306104706703972948405650169,-76795001868835457141314897783778695026604055564064607589097698576317681707892820511094385193169659114297021873936469670912911211567691746393/52176060142684099050322417591853484783242993936905102671327367480917818727790851744764409454757887360926592161281574743175905052749165552776,-1363679286233744368800266224006023329737492269399131141062023313739136554886926186082526036057362051542352309922810228233276432414713695345474/623774363628274738783249466481221073631411117529025327858358008767357331083703678655913326102134662887002774294685102334848155010247100028073,-291885693752406273211216744342242478432277950065915244159518582007154864627599111546713192549425144294235875871352139620755939876284136062188/248376671764068568844682659760350973547007436178309482822323699021294293074098997563634278136015458761062384091706221832053361814284427257551,-1102099715938615316883416139125794177340196473203265579165353880501076430119582549625081775459428933512196850891709443660991435349568283938236/2462691019082084175664334386290794286357820719822218240133444913121709260287815623247221282842921878496304612664470833129583969884561989388587,-32107932658016385886185589647717679452324127236818947042332176943948117456257521180105062771053803265460484394597573390346015063856782553792/1034983208146232221170581803544027364669811273637705245266356233388726100655922089766800151083974988028083184940250600100141950000413061814673,15815435535456862593744898391368503621886488430471740745490039279260976077340958950063910648976364644472362290477696741791372386018708818224/27282907190218090828311733541089705399621890981108098613715162864886669398663926477716119540303546592029345279160235591791929790576542710167,2419351607872346591940896575401934722842762897422896426151133454434414551820080047360521653502910036042506916476168407092751799929311834760/3764196668305092978476455512936879792439782005129480200107087375299655508733005085488472933824652748741826293341859380079076722873127304927,61395723197723432379926557964483241816002859830094412067611525664212215194163522664273110346342151552244732940685172339212367438333537751763/103143569497646093219248968930677177376659677957050860290316166815449591288061102243832821240663944741045819826767213496103358770131491733340,-365678651637263260342761642921463170731758617503409050144509442770959026527247127176035332434901228308834477811368057204682445238074316678927/1058434534889060688834657072703314518823928781822851351861324992429202150521070139823347922418540081862435995938805222443727010605016310058865,857624378873958339805634829278958473621323450218076508622759219730904389188511982586174862875854228448314722566105095088308296719243652395089/408596041432926927648623050219832496423730925087179036882505029322885826639558591246156347090858509144843429667334743174028122303884624484786,-145334743083118376233304250836978108883524134031919893743298360627263298658678539687339885419073478536522708239766507708068592512310776811555/520950708108239987574763560965039851957712499090876222517985077317938466243413959841965846309833256668497065241808812394855245266208746769984,-642307201268549151784973886943140279350228966729653013792118559199732410725815388016350886441547071004643003417259692193059342597834481927367/3149809705324220801501527587522122600798196844124879765452450669724800692584760046059845028970359310302098342636906831380756205816513909303616,-1114574977518284716117923634010785010253057938866992061514014773203213267149355918871942113719006338446832989814576539589155677402399644603953/5494137877535002877186244459487337010289658156251910204456218730882745860486781792932463391678829021919713891347843427605671500109950592136128,19518710998425776012973861875216167653522082968052978600427868539116505937767548909541317105397955919473862265451793046096126962265436780572/41530670383711672853088471427470228195527813713712368903030941728031846123552338496417746832790389486791831017753972565741504894228035441175,-20031127574917433190896436827715767140252858060714093800086228309946217797216674949430689233620365472233931941116028644911663603261237783743/165426755745030357051913929220664156495738957408019973062955895976814018356404342658117274122283211440400000546796800139212939447223065745610,101418799621283119607101129607360381586758284043642919626545869588362791658332468671766515476147855225816503704141537791234057760995375649267/193368039602748836954185059970298081265426215459944170483043734001020187145071805788003975806433208231781354451633418431298482354554288133970,341002384890338956562945559894648460908644079888431083532516150250714577647025558335445819777348445183388359991312623914485858287803924273799/499521322727542852590766642842156432874784187514437976670953872848989984087708527145570367958484149676803786389125630869372376575887922102062,-264846517628187556586111407301483461263772223103354410450079143949763144311179121028731936183310995328177559202818748907709560467291820496751/982564066900064268491846106171641415215943020696725229975642451288943109894659927658513580542175373896485848751714094106560427700769122180065,-99661356107824037473506884159385603327040620854213845595068647855426353359917721001423544890634422365693734998587631308878799245576336256451/291439400500916685276345460152623260234935140184587626354335346501771288452233494147551514723515053679090052534844749918559242091453390592634,48914765714698691078130029621118129805867223439527664189566746207804694387083078367902553960905375729693222294515204597748711616529970293176/165785269674577790609942835268892414677296567878039262904880616102495248660637456409158794980624840796205841361246063132536419700753843146893,-70648337081185098104819047610192576598208143907276706152947217632278065949215396114454197541646282502794287297448023323350683019805701906083392/155473355972301760823245322096420369673739783116948185381602480851836737491811913569671828481438903703581408729270565354173437886333164845279361,-2146006073092992746924621463962562340045301188470806858282440401159432585897622757290352981828603985113260013891810169181757566681247250246959/3584355053315890794047194672151058987141166032227379124090543903958702288088087900606844960799953249584227208626043757743286788209166180032999,-497243950379140294334874185327433839171667980189748041140736947567882323647605981285818953043806013687674791608154016069128886144982857606197/1722634652179591224886817087768565772351275997344474407665140532968760577521888534094226324115258018627236684246801671077114041009059400805509,-8990284582766551535175155752527309001896628827415724883256640442299089540843123545867360716673168855507514409591524699938486430963010789104192/13860313793842768278003085674135546658453979176673154753604084673218092087488509490669391177622534635922927050814838161373962304936234575620565,-1156758597684676090356133109727059645737726998722984052283643043960554536467924139723847955533680331183304815947034071471001633775142291002302/2816027215368830612659511321960238018735535993041898542482528254321098225727482855676043361768314033115304727678286024768980756506334998304125,-1118090416569775788700097012034124594994169352140053233812359718337127391808653172076781678290041575476159590908061988501424431628657133696251/2731812887702433998014027116391506556144290386026539131220840239223535863444735905564071539354417287466510820049941754253793675004216533515247,-77542704810305237780911686988630061196511667007913256937224141300597820813686913285650061333971125567871470681679148014482055856988705335652288/116675936323592949008405434158524580460807987798661983268152469463888716650535533197008817519594650713036742877360523833726426651546938359252341,-1076774255741562032042347755687775510578293636824067011146380916799565735711791699231558438809296909714792103102187870610568611362722890369568/2346545191370017556315687249933580820931648649443114761629417954260830734707981211708564853917151064541787285214716646148682557576859974755971,-7227798006093985149192008719720411254507334730069881388752183503232955922680392596738830791748887242771207129848189392267788340067944034350024/8201565383116588618634128438781291057455094273871236390295092375846275552881700924474146499541526050550556964042727921689232838224451552056193,-879898430923683862474033305192427472372728258877799923941867591800786654600100399954256586297014411306987144094287279699546672128678405740520/328286227085159774388220287867685423037156916807442732758132044558567451467381411728201858003116053950114677710123903989132370067613979322959,-954684894615073856614244487401348978482410947817090279909635419823871575485777067246516097360358215020903477665915430618245834566862273279936/6640175694263721035952334813163085263265209071814700103125126286463423243974560513776635845611839204303435903805095582123103526915353425071123,-13898104345367400074184731684825744970529789359111609268654238076437321364683127518767522880354044013445573547703215010890736510691413939073176/11717557032452428445219008907945508742598963922589863793748020305075464783877171187129695424310492152430395964470018744787205431320782591858197,-1328355744001631560955138467874058372050898564792683965405331976867101011582123709044296021008905740777069169619926334417275992371144623064497/546367261165376383684245597501105948831533295796221923679247242665238411665596350806307526240314005938934845905435859893793932338287377940104,4343285448209614254596948265458931513696884994756604250323998408827677271615869273870087312163288167513800663506542976257934260436753033761244/8303144901608156546563505437803548737084203663014483010118101535008490587485296475139957652871536506609714515535203654003039413541349019377653,858228907399359819315591223346131038517796787600700026039482307443682197482571401976746065092459940204212835227740538096906979262294366238054/1656899923837288283382622022789573556137629668098651343240839669389870922511228776472755455763883302375182712472392423858362214753182807099827,2549362230800951331737551844563676225529178600967865240732273734552394239326600812055828011093806504722874641451412294848932214705694391839828/2296034015622773035927763502501265674467880492646589028167402865393206056935606026661576987467406156852351720356149049625928734700620093018679,171519301642898532050117396626222143656123784072122674830866568170208109628545752308777585097062309856131707733675800638204915155500593302688/231343789522554711120538524866444100105051312330880489085367771862840841513720799310254910086250555869371279891241522563592836206335360551947,-1715868995957989555633198354431478355523508067364092829121587665305392902470562571586934551770027971464678199785673418963166141678942238229737/9623617504952081091666675394987196914428707759242814978764828433597964536602298182290628867114400201487221332033618768687708349080411946494914,-4897437061819849904545083434545788100657089276071294219349747296052667664931525123007318241752007361361679656937299920652607708988831926229739/15941365484014603289856695520240913897814162974768335533468339122306749791808994446189122749596701383336887429410864311205946228719423632207366,-6271095926583403113350633360040122389623929472724853412025760340142302391314918088574363633848314769109797492379185203731822071617669608165896/27710015862505382008601664095291253188595094669634269418947232075035045711413241670373808155428107165741624782585571645042809534266945370714127,-119521781755923233298924034055154185984442705365297517388865995162873219331461306092374144966620126480346443586819373547452203588674689529145440/447255066828503425617069358634425762552625228871298416855151876948824950234927570578440314039566328698812926942921948260222447885532859388991739,-565927709769049013337756728759584214534270611142892499229663016431797295787672832890602675300402814828085528517348506747936691987309983231025344/2381438764278606404471453374556916112226345785904671917821312777785120545837597822014927634385300220059621392102493595413630079406052432358414175,-54525014993546786561688366885367151367953407543725162535512515304982377340786252739402835088197265618079480561189505581003422831371607303703680/118258907454198946035208099629053477677499272928266173735123362719834132255207450722711716594606115797894664908050577143445501266148350825986733,-4906499102635098438503718197783377233115523466218079410719833182418645132591748066589782184639078966807617526694194222668572345243404693401280/101913074878249015388462919556329944057920133703248338935350740973578097427453905093650640739027288244124699450610858019351767346165931120876919,-82007391210920527830680159780909251699610266126347155147777553596731219870083007531859168518265064129595751710029295229312378566273112083428352/528832125706598950407194119620906268620737840215251833794621641909766063454989118772370594677906770207749297670318240565628896660299075412163601,-3269321057269927953523358272836769369003723383744388234258953464028447848459433921890719015909710455534745688841893851886481765652793367986432/21205692467514900852963650884244064065390683924700578049432355380801683922803661764415074317626056841597275605792438341834745571263877056653845,104702903832461227005509145405406874945886362274882648969664559259908008335539399549456211532194487302957372623178144970101293873391969946679/902058168053370798329677478600462102780464444568659581082608993486263417522965476497990935240380070878967710659270883336548052396835776371735,-165406771081147970548466621447812286173287022673279035307052459959094657511549227660329905759806475837344900154554715921107732120570779650841472/1062656695936341702673896911318816459259598516216619098675259376048538109217273249452166134872678523474328071821780906390008173369441984491029241,-4662732780063414119375861525754752584616612540147274406479693127818556880998038943466453121632469273525820479735609794264237879474527808465216/10239866849006366683211904859844278867666745511649341512323606258714425968226724215432558198400940728308813035606079841985480128242927650526269,-145015752203417740627814602824879699201424741525266330972585853778148773144011948595071426531501764931494892707462335751679226422664091472996322/229910961375688283788593621906344306190983999226125278116317074323358180693574258482117750377844230725235399180626928435807028671008383952137005,-95202327339080909540858446542810840712477960636161069162088667547932469720402213519389090761601590885764598749305122322351146622743315006121618/150210298062783744746389779400662485629337570377972014819405458160891489347284451579858101691473353822227257083969790031777330883920638802920503,-5944879476751938660658504187540645039269325444938876076100345579803246945663001400244485719235265841708784129787271196192152661207968162595361/6801322499825926831463836182266452558818066248963736218487707232071720325279615257058442576427647423592098148765047367734767427806148474431121,-1005594369349923285882991293831042996087882004859079220755260426797837482476931689656177177214139263410879655164084527855021273920763668265288/1610142765312486602201088596964346533300043686417149358185015438333785482725102267044279866728634636693170383734991533062604764624339671045483,119773459053033083278343313002825307436107205800187941759980610023480419795655348602493612040415257568664236736643959467190410050628185447932/462756158029856443747146196639244249365944105374124823979199205373335052380843118733631999689289837014038072086801768027458788686697869270485,25159121833697986099005603169987500756547676742283937109106676683346431908951939419060125646277862546191865666954345422320718929832468634487/61178869717374688158658103381399069653422425912498639490967598708741873437680263880216976431075899690266021733490020620762288506557935019512,41908632283613617738774996886543402138865135772517517852377012529192034931802645898629046581472916620383516039920644702573980136861941734556/99029888066168402867539225843142892946420690770878789755617880024140687519232123751850508184108696087761921693464000384125424955979891288261,33301471712511974369190185029353964013598326724128788743735515684742964462378709222058176555494778803895486199237604065747980847479881289966/82892899862067016372022165004949581408701236975506624408455015786533854198326174131569390891435015786644617762817731051052071860695124784301,15153652133802492866112560794683537723826202940708356076598646646787410353645153940179128775113407126789010242047930554199045805862920892748/742712742461537718210901701563841426890716675248283990798525867607092800549114638299964425636111895900954061915313503075336435858452719348037,-1174131267248132185459931674313517572583775380470667586883786720130631794831824550673678923651786308091369819100306449746769071031750696020508/4360110342147155416066525419532690100039432132443458821508208922502098090915657767847419023949917559651252044775075474731635708420984787101167,-6393066891070423654068160234058064015431985631956137279391819267776275863208026372197861427903128177129490137570936734710218990925993258670780/11292348080041017080289500202100999873522452089028734359126682666210493132542633253948476540332720790874157438415827632482176965461312134815101,-6649178512245117545208949001415280079800076370820870792534366408325986332254591701695106823117367082774146856028659725171862530763634049216868/27119514293674520370136160658510127618938814684276316715373327042807587284008701332743297560646200562903264268075794528983039177258536768701279,-25271192269647775559041942027315851679365389383312972277755567795966008894814670752825547737558784783707813546989862103259898090851014301696/203897306416655110648711035021019571101011722451587110545805567207321869943773550675546349115442201689987145103518928455411308510227089869793,-20260035580036205684769464933784444477723043471921316205354413448275675888584282106262577428534910093802816945257984562160914878261736567776/407868219477745149690540258341155944281751521210367133082758206724930554439560443707584937854598377079892846615846517136022095280614580775031,-2461233947016205941914550700746469731794139036003882505141308017136671186151990026445349271591191548801802716262890980878768318773632188102028/11010884508094970821104347306848851315763752394805267707577685960655247313340489529944662429776190610242740907643542859895538938082288633294747,-438431402379531501394496429851636228202486142605285893270650189474888238368329885525793546889616751265694561460249235292426423802174928881810/3350473767149539754816596653052196729890192744257072596878174741705340225779215781642751085989133025295500989050709569295393449651511058743661,-655705946702723891550840837980153422075709454953004723465484076628989660861995577107203108641149261006862152195011706346039053034556486806455/1419491217437126630803400950384833024401447695554631126123743865974291299048419667427255659240433745835066510933648055989092191800559933715648,-408599035972537227835892286079809364311774048854125056845787199769826423521253940573493322481315344791759615790317812283488314698416974038919/682760113697947718471570603989613034423386204662250188095238131270500053527281817529257701709082341968166254864002558539162063729966013629758,-457351903244127222359441158214677194207519215414245631892083761256562530557351665611148466353692648610238369391279294519471886721982899025210/1600198852237743448590892240952702347243855940231049886681020348948876400286102999250688278913137438964912666564714687084443165898027808410527,-8020000597436372047097059033712661162288174813327045307810751026304946677954700262024893705671310913245356749768420847224950082835503361085342/26158582156825723675423085970606059583092950019161126135012244078761704320868685225777008207416158018999173913132930280117185101880722782067883,-153617813704706548697995601923771791784326975380153627300160935994820544719832148683003868097909920880858992094578859101452756513315877326938/561051317878748417714859912756940455320332171809578221572612680491472062008725996208711220513669845301059807825564863816642067180187373168731,-909701896262308667697247425961787539211252325655951218643168749044360804906752425582424456032008270184873647013417291872999667785235649665190/3271523885872725152821471000757220149654322841216234302453262499511995649129904713619323941602350254358728865486096279119677570357203648284253,40606713224071812781485093515044332544188149033938729620186128259926538028889168734505703790052821921717894905731240263658542265492355692430/68936233045012756289348309211952164983562443187482643860083258355275290250183134779139745152918159493833051601566628890843546487700687389771,-172661373259425610360074182036328062695936439798714305889600724143425746285831396504420781940512134081657948776418844557486046677299996864536/316234907129675116023557163272933779835606291709805971114498863991560871067864218336045659444246028715721193235442676847780373018277253899357,-18392574328382513911228545094589236256495783462479234259908549534701195374626544809129523212190557311545986787355866444952253208499799915469/134683133189731367871338601530851145032154216339198563199717510976943601792533647510603666326806884024098792071172644850078352461846387358054,-70219066835352295990924980711759577069734053695035234163645114349099636948027570296127005235073388096073426887448126649454305898832564144023/162363174377211642044231739411159400702699634404619106741343711999648272041051625652477073570297944216551931751876289065273688548106421292428,95083191900877673041152652044676560414171824245883489129424345921474336168895892145490476500804240684123026318622497239853285735685228826754/217727876654834421579987637485236428585456578648049809328279400447044965891873912110771949458798913861229645612862527340167109858947887130401,12260519348063351964561362646954320155706524698200933515682815472175191600214355412269690771184738746744912717976816352495760299839383104012/29361858217888723457671560167736770685389286724444401248011008972879687483225905205402095027032038853950686674666128580306778497283873253853,46021282625969024587056732181076753905706368294456075925166258381552396853263209168239843222045042518754069347171182740598902277653176041316/55634936553003314550045098634011184232967741682473100474288773545193894890850698551968271987960626084742817423723962467667636022451037443443,217816997467114792454591827261685282087529016949434547291328494025446823343826063062174647878911892282190009002209150927590358042384505710336/312325828863949348743201448152828457555862816315366122275125332572713404025464477485969175768230891855283039156216016610207768471285985458315,96268820945258788999151684240087036124950056375101180715611286455989341529772152445857734679822735855055622166632704128344871818357119815161/128329822880173000228071573431338087484140837316284336474684262180778566863866692257869743544891808149338691731994885875496339794739860973667,19370590217680297222121910635535027051574974079823425584174387686815077804141905643807118032232205774867946448294433894420934363590950726408/20726277016521895517134522195675247392196205825105920341701056633253926954096466045840219176532914124380126085816425342188573323485578366439,157298014652125444817856075492246522074984285525381303653361481022306506034676782183806748378216640484440279598286097114271738435463754622187/200644097177784029737631236106066192551040032945869518788303983538932890244266434070918842743810481611862615998998280197602940352151515404532,33210707193922536414403511821453568518064380724495862491860803884572305555471228940786296273901404314665991943260665300105922457996757433311/46961008792679121114727763871358695520244905299934539848563946018336014062877956255408895219551428193205723600606989023986023667628238912391,-33039335863129357635172631205747797745139432338071189131863404515051159108160214046822607971047529422889215164839765714738936970595893975517184/65819526768905153446825781025174501640009358282688365906316315476669332207887774180130387006543183986904164391687322074040406335558753745549895,-4166237019634330660221449344239328162414350351345763097844379984275253494684577235678627280673137542979543194196677696762541208456226300109208/8493550326331127502236751069630782224606348262183539816581342707003152739035473474429890813462806280379250111988814703669259049057806334431219,16330848762320743034771869522361222701697882542887223024340150723814397563354807299901347299525137303929932011380956750154759092641588032681695/17749788383302792525904935688944121388730460104511797737928909708285131016275802978301299869951321092277626639585304307327065610264460835005661,229785979741418868509136245451137687847995333399573574248317268286057246268672938516838583462812828947013065585739870906748634721354398897902688/280744616506621812856360160154650071462725812015727861918364152292745403480397251074448899616767116521719769940429279325519422448396684877261839,-695230460637798322855422922376840055313751172282353453595790708431469323102570443380972327711746823577098565509046713586830207502474582261644512/2613814347670171864479760937092643776112101013983895042244019623520927401189352062276913696060910079626947887551872385231479973261005936358320765,243591434352828813190372427598628852008914870759918756302176123689420130278398834523716849959616388691613611224731158324711195638296033834423392/257239706801075287615040012641709499926505707814695788540902421783095418403998783106250154785551402946202097103793587296453348915520749771264291,-55562723420230730079115589200525017280020776448021040978676197135113154518107392526423831060020155341918028686490570549280174247826515282146784/199168648496853704538829998222180191133080579919704925746011277210978331856069982312322238631952574216832301806944856662648546164974625624299225,-36975329909748259321712932648621087674065514012774689841665794810570597696575186078661410937720827030090564648193491960754001651896962429695061/40615827396329339794503270783289785654350515834106960556265437512040354600854306641642015416543233478430387915170958975107785639132457985475555,-1841475023658990432571006590800153366810879871774292148605168382408170199093054945730198791524782021991015807835409247775883264425799224145903/2177828254280864889848651187617956961830894375048955898965706277224447421735578878527231485877232624011795711113975328080416256368382973442630,-4287762717126996637217248933777944591884408713741636397467993826725253084049245628304137955549738952221942770839984253318521199855035559297604/3791604480843102697851550235548941232153458362555247741032011772383756661120397695281347827765830578287749443110548887082420612179385264499683,-430888527668366985758829692492080681847995533643535290298495270514636917705344344391064284048051156854314759076606516966400282592704821611296/2371359524127604312579090597473127086352397295075267540968511617615168697115565782962533792767695216677257302026372919544694931000570721131371,-45976603032456449075338721973322581989252717621513072920728451540061695431528127036644352138738946003609952723648195766634972181351084136734056/101967893930253169662081489818282491556613104766756539557008258644499797545593506548307432057661137991307987689374757959001918745156078284653045,-1611494345693871634470329501388603214611212337663169713100133398586858265754169488224008706178939929414899343570872199135341679403483895395296/18969971932341436951600082344020623614298328590501812454011564726969412456198519916340226338223392450700107209534270627871700861459018508708841,4861324094287735783089623868672425495466789826975687293524488169269400407113953808408312518541325349531670480598879374999813819128739328377536/26632580213190208549453476564742614251994068469162368506069583832670018015145625998223204168753721339926695764600488674762403196814410022295243,3144999291463454126545766481316631481703811610687520957705196019309413623459442724234898851148526146094548453756582307078853898227108981720562/7007467874883828712076105539646669129136878545659005075487475487976777705696038085850639820449045743266306599869505285362104568634050905202013,4078334180047302768836615971549877983649512771716745246490799946147244640561547758512652777605158766175178823582111741710649425223624227492516/15673440766559405270981231637657419902917427248394581917449111118292373863886490900564507567293623971778386109157326554357501831258629025674821,2625856386458921773160663700865048905909100139157508280882380749738194807462961648919154363946317906857297015913968023452148773226899384690220/11968331509370981095882076849420144358285560254606405998526743112603004913759436955046994613742837049405635209790913210771740960876251076033011,1340618563736747208686521173144734162926701916056741367407051966985460080268641066633927990028726766627034419303457822570956289180733422495796/5196564076012217622090586328707034370165959946224644449897072087892419447760872429189257368759624596389177930405658523097491065966470501420445,1525246907426862845020986230117275765105276094609902994532238087186932287817551851883582342594049149744114040677805406274517444559164926762116/5703687952966315023811621699002679531936031250013167904957712616494052253758139238709745513366805063086446121764502522203435832187604678488197,80581700599260353962465957544546366919448668410464279451779971708887636156873917023678441729355059491602964175396627919499768398438939595576/230098692891745408519078943959265694784449239921142253927278923803448682742132054411061090012901331462760961517847539966257010287539983322071,-103004056574708550833616714111589500198479111611940366866077760170320164825532719084510747996411992430231686619888226442478215492300496386403/2998326004789534544697055896273180037039118288757076081911582930384573200189869970602322262646046888491006952479269413987600088879862309620740,-394455119122118454463630280259975903383767768364844384918356802897341752217173251591909310397058398380990398798951842590044642832184963963502/12656840572542950583039818335910343675093877289883353290534790540744194965549257481429611454783838687162498828385583246122810235360031875192445,-367065521669929031649416034650529636996140927328394353538676138375574688521499270490122474997800461782961988485346918081366373833566812572581895/314695416157719432476023504597578188656167472208440245702661770801538074376977531333070691319692386066317715867848249800611994585853440656853648,-103935901169573525451021592002011203122756160686500498142331504078086728799575652882913990192960449870930932640115527916185411239131569466974269/151597350603343448855663890757651036815774971121183911040284888403032510593802614812061278316171833086805121328822865649625428118966593915471912,-78037214334405439873557351431397600927129326044536381108577594333757232372494204314868930334342217642579572130639542284826908529252459221217019/140159626451475898735479653179584503329523737119389231321042719333960721459509797538501621941765277773851520564043129427194891875489642487069440,-4247443821345539662921564012917604902200830942471040823670108934173825088251376576729534729317767273854090132275003129812037060061887876081831/9459738949521338811312573142696395289100978523704243990500762373434083931331076030105146958638448680300959707104561715838717576332566277355776,-2904787954024244261819337943486336360771507056208725863685064826090272591307655503952653487329526518893682023209049333081027127687051213903995/3647587376345910659555162519736880468802789469109463871001337546607172542500619476257252010903707147933933704066762572811599914312099558000768,-130507565701108027153585327078440041215840902555343065315238345532457655549870845516640476931216561349599564066442854432974988448177812192839/295799909738701228962298029056524357634977759080560602491183330030049589907659200539214250691744717713219542412221093232888791012514152179968,-334826698934105273422109960616970116364058084504768967215155358665407718073087943623408946149055462798482288702898446066398617905366363043243239/505011863738338385194059146524546906436965767142313649932749275164684428798678013181260766795962493574996020803532240631208458103073055772106176,-162852329851739661374263391924188548363466631209647165118387200274823324027058115027071021091262417384041855291113425759969137202506922350033067/325161820706149412117625323568963215095747803668998329350900036757343479176327329777834680687735991735288858390520424450168340387711892809011968,-1031319422831677471282386531621359942186657312331506609656144679478119106287993511983292958964832538327394876192074755334588039418163723115691/1286796547184540653394139140262038070217817112228452634883216690225781133575163616218489350196470545010342868413878844461062015665262112134652,349260282505684096747378691813792407634462378016913794342016948817832207725041686662852254302522547586337219606576241551856999326253508087530/429427751425308089732644455783662843721786617073742870163003704126226519727893639712647267617927927213296917722004819763026922867896463239849,604684185749584935984795759279524710816126342083902138593141293146358527413164608682598335895071674474110901838815687710136613956922443648749/1134115110048592057523257613840176798347317081701933563304352137512450632894801058122644752940155431816831917623041847587823147526502374910735,6880397359434943582596859185947478221961221914160351366509578502842810831696629167444811203654247653877302037815806080770759575455425270770941/10939945239497018592602703751849347296361023318246162494319277136907807715713385997703476027002138539190153699721020819428530502985976187593965,4074412746439296789568488270622672627570466457485708151973100043641373385830331486219429894839287054020711711054918060291242839751218298350853/5455067159291440662156176642805153321679567007351932710786064538161260085967936840698785905999005145951475909433438115004644128904828643785749,-792993353101373364900014395710602145180294310629661177014268384399024627174087276013193517953278069254971558665347624982588587059547098752365/2617854593275718593987328348150356451568140705738332187064007375329857608932497914613893642771137202945589162819218825793163590988482571958144,-88702732286767931114280590124731850569379218369221108207705287588128814819703920481724709149692763255876614250745649119816923199656977068133/120782362339259362578136967322659007138541555316508565654461423549498395435377049448874888496547442388313018460310642880003383506280709962720,49690070939025799343923136128648168240050306608902880161724825189352477359077590350653242880431107727514370437647493865921543391780388510879/72443270932573201126818350540367775392975505567698635895864519560342413236688719919822435431300772615240454267077623006679538059667896772536,55594073097473882828954488416129036952266104163178863240815102918963923432416571676582186796697755200747582068734298990448995607333568620181/153421265962240779503931563158606887903512729860819424024146577881044116484418904997107641479769055747221782752109570038241401655244957325672,-193126469147515509022354537123466204834018660973137968655539780865216012794769335344792169564464260177872316861990714788223820341985330238999/575161111082858134055026162790894368424945267224644989552160622059844248165132265065540335221297554074586844444509398721801655941639432127392,-80716488140548048521081862281556747515395988722606269511255855775321071859646803355627250209674789250471410468874892970673531573131759272967/300657256942531318701220752090921982782243006195271905806396000791360590511961787080532904339752244891601493960240404910226710325031057030624,-243954959308747649557448181372471719115349054225342422043273273399573455922999913646184068715747373637382901775008537071237622297298791781377/821610081359631908887408133139105810553645846329274727366307571348919625689557504198106412556308804138261802042435108078355252987372469555264,1178696730978322662895530133543162577977748760389819699000129643589892245505726320644238492302928278726862609087202886190771627953682694857669/715155649554785503797674682741160395261241488837299896596682897110873277201674276492162585639003914625427160697629800678078951434201378671840,4639495214915162056268418290954806952421849284812718919061188317519970694868959700057966414619765597295815775870626155605160858570100102803732/2864908555432445500689914517663115885743862402559878533494448235144400897645757769863309497154928708899784340172945257170239401484641204808851,2347257041075611221601561902660057513716875663631421227132550588949319574768467423276965433451807140381672327739214428500284220228200615493036/2437690128223777311144694793589850149976921745437131088753799861063719189691481354128967117201770383121984819740424505461777953695153233873995,9822938284449570138367199872631833711489623987913374263713860914539727562769003950488187475152408780434960563323018078295464757232277103238313/7262926717326970376731523937854246840375595328117954100066537406371208319648771732328312509793014772453006670346503801474614109527748459372050,880991400080774233351739416946291920004826292077556823071351288664966226746247222959149541429674764082675294792032768319407158936572563921096224/890908963107551097360893721266458218561090123436286958150921497773813154202892004730138629679006903906394814849585337701960044755609022344731215,6116148967672412978973790640952000826054702606259141784732780737363834185257966812030478354944334618985611977554979311851402781384418066781961/4393507943487306690139559990478668212275843917338655593080369438352784000204425673528361988458419150811677573208757403502587717620563540787425,13422264893121343888683025677821118652263873087283248535788248066801935778103213716997844659442812472411788861229846882320282029533771917068/36603928800707071859593256563159646119551238099832341525583965235776561835805421692796087620568282298347453759503788966825748249800882777859,1005824221624477380432316331953762654878121208786353434692611936290835245664379389878153827805518318234372534961561727228727991265606280607512/2959932360041107280798921667078405923542059341888855949937290104992494880877389171644876578118214193754034076146925029126605395640804118124919,1312200166699217618598111011918524668387895737896113693572806711971784043597450750332643367211950976169169761788983807091632039295578198028626/2680837822147136020128085998349046637566136454547988076879493660402610963072486889339379359203362154174120699632817319013038564985974769878051,10047063535962167416779206957739500260178416279083631857769737476811037581923747844546929796992660374687100991207203332021245514104584835587/22558174890244467877730715969778817045212922539714457235153177733102331615755711204664789582705466287910128697592762716095940264885385883087,1462438596332289424266904992548502920333975897105938058873899424184077442985949067528322197075150492902121763291877844772037945036315043198813/2032163571076668709538737701321070136376800041367877047210923696668494873356595188530340806009595847025652263636585997723947935630474154460696,729004196264103169177477648790151676619916737782288945789272348593458193884166511565394026205911388611789175976104396873293816613903853581967/1545923948880623289645948945797444914276950371696495767198625202204762549862859474797036785777059728968244988720767923727933923485775351254564,11974203743282143623044148514413843797238604601910487833596018354868178672038252420960810893646842083012660855782290783130711595511258319772008/22080775590811613345055717682344364414270968911053168733206053130898188342621533914329339071567488617551571452909316296682250674249964618036269,41954187327811809738549208840327900917388021752723052697633365707183936975757354292574460408771550970114354118881631096940212958632128385018509/42847815583092120710749218583989778649164598002665474333995529610252994259544760287187241659003400444710432217100849385253775643625498567002450,-6629667616933692146619662547473273523536456338304026303956682250732030886522253783235039783566132716840332229402909661373508653787954751141/10817186933739009418245194814097310784713001566153473015854517257738867491990962434464736895140979659588723469147294821318713185967952239146,-3339667412573537242515224609653758729505806871390983801614813933715449739637332983905436811600434329693974735222506274786999102820380842735481/3284777548626873457018843821492033480843436434435243156543491005968260638442883953714889193308176218840898722717695735317014763746466433980036,-6763083139977580146819170194285822658770800687669123361174788898446181959268260593984498483392297207836455573544268061160292401708350767768301/5311232872630062035057111886911123539080721346259125000291679240295147576526450216470113591270963630956330538038011329029250714067818174038976,-2025202709667210570496661603373160156114841521147755067413454767992848310899872366812875607137320531712157649225973994716837588893094991701405/1925980208640546872435083129277755432481598481714743069754568452922215143029115932373668097353173086042645346762897102578447837941640714417248,-21772788935605366084309303971288020024388375841338821065395838802563671672704839782245160460651008808578922997033843986817451183696601003073631/21186394853075177034767022459554518155708828435079720091876411668949380760211527303949775619256574406920534491275693955116270730481819150410176,1113445243187913667255829652348419477468676596748988739271325775459772932564884342953377773090063280914365107095398137302005345761989655028529/1057654352521204053643921416761038425934271151774699575176813636843215844364972751873145205886305624438825552986583342981561759954162567082250,-513448661090422057461426142387666975056269049154115598782292515826547409192345848659884487204263183001753181785310682273696962596663670503109/355640865613463193112070081933069550485832381301344009395234591474916382225692306241603749954559541005133607502846100134474379507985796580800,-225049536713624036686065085861268480210400769685652211146222486826487817803350672403973735254022520010251716626627512031367008809934467285552/645910565873564265387053131653358036911331886784343655679015149831991074677785026798574284054793850468302804288569566111272965059857585576731,-433678369214018197764870146521047343496809467520665600381060792896527603890000470077858140331515913566651625982431792336699077559334229681612/667057561374526483442603772851832305007465886729617611036418145070527382452792896297130441629242698767824568174215728628302430912542375636411,-1222551362179519624014787390109869096563655428754526262776957071293378716888248326248287464839456845176214115482223502243157499197395307580904/4554817093052547395689483763218807934547342751110407903131345305228579445920286734869856849088052564630076090403307426001606318173607005503993,-1296930513293894617752543776712253121886112672301502060195418832052803068835511551544041232836502509442683143836663230214460762319038834407728/4229626135840597135270809490511863002018209452338318654918649443446178534778273037792044172577471954913072987568089043644994300726095953874507,-26341551800277598910570751142482538443774176629877882208945356500237760425884136800533422041667420812857514926578714838033712590382500811263616/64825574826724550586298040899720659366198505083466593343221132842165946843602113286269295719589081740720920530814260525440517316265952526136837,6570432017107188121277872255215747860986940413049019761700998969845543081775003735366082935455634660946534852711701105025639864036278035632970/9897550592944472009111221587739215661143107088145834900783631297184830356783130845568252250642173542106099997672294625866733225276023090807067,3773839629872670380299452714613105406562919694935394300719946551517890251584921414487694849353219403596095876876887143347898814363821615604050/3716457061580069688666826396538334980735207457475535651028884493893774043305620146976094665746007627671561992118212095714256500590666730605953,407549032638208750425999779316808180958771356319722881781257757624113534683778864296025705358235954766809667663297525253627065817741763381585/470253075777881341623944461599348608219915392776653490782938193436704352388633097025640033179544069962143511826120003778962979404578325527298,388503106759112958889612907844774190544737512253890080677956191256249635534354962958471454957014567979678918467343086011101590773684283563358/510696581870049491121555742668799127862518088523030754508579877342919659086458359651283482752442124107061609466427314307450448890563125898403,559744805179412368287191188456406451912165864011577790532747477400392286319305407034129577428741997979352577288349327923681587861471295338256/611081203427635088951182221229432078846557516488191793802942261313637311230052020143992335705304297904639617585344443672629356266602541506827,-56841002496280516575866690182438194103540582806302116747347299531662403946083028833690784299932760671628407904712828670988165935611265275883697/86015053898291413891942531417939756062823369588140910994535539717978837624615715017850356038341000037859422202588951301697537953526917812078912,-1124480728740148810463763819333355699574306065654608008026940166044338550719227258479486958266785065679544006095457340226386077678392344693/2093792026082855161252518003923909401856217792180371230048508597875162962222529437184237925778472884407471037578699222646936511784626928570,-38792619542180205722484787204760565259679337820774767453094002137377512027827572318657464913153586765233942987306195025853639621427536104098/79817517754689206047168870508633264361634646754159466337455362937644275542754769838435958671608445042508662586838033010644429083427556996225,-4681193719349545785831949766003078404087217167762651055495176246442889268009779052893899785230947397672170397507528810370174115709062738278711/8583900832627430923744031943610691632313998063229860279388110868981503898224142798349290273283639774885375621891627624114036023912823286353728,-528145689157753431478357610243311984017774801738271237138125067821144167204028339485474724027859429427543575792979760484900201607240871118495/920364484037584622720614588371154880834372270650736557896620987228710510395137808036017537864508254941243128068637727425451899837198418808776,-15718093989632403640735167511185173628912209419050340116576115162091129697441373722262215123861145651953792199301722365997512119734338009042827/23677525840815643536395633730905721550481224996414047929592096456473249147356536600356103492115016345399991310353184797404461887442046545516856,-182690275346620828342642750338046926628705408388377168577916432945971404596990828251148531577122166818932672211405353669241725688962360209739/636172179007656701208006650652675035084660066030777718588897726319509119390838259119437409136708373232847146057831398099262710532457558550777,-179155582258313896922417367586543069670515787916150328246643020697765093558831581035846678108108253105162562514266710515581089053592067908369/240433518216728177338215567136489197978990624963870933459801977833652271847006234099850997243678347456806051634919126526401698124473452440480,-2869656683360701617088176713836479600783716575644609438304199968384731727293835521217565321404188169538166614898052111006620874709311252705805/6163918305200613174888359939144236911203373862807272615721430079416986299463622792263007571663684752127643955118742737812246849274018551273408,-13359941786557681680173775839678271333681225676300295875330659020281106441029658394358998595199002854700159890797171902265970215031046506193/18505479697604304072335903685154765712544006682479086846706755274538432975339269720771262398698449729572509097473127805227342644587130896853,-19218164491155556721457921726837827808639735031179319705586444853592869329079271634935817804288270284223988722514908925794838716262980165099/46974142422562944821106414692655762840877062193288267505176221588450958376301532083805569755171393059567140974061532072107934459715694525874,-2154783606392408382481662450455798062381915144874344561681711479942598222645804879754132770585936145056124924566316938548514548560181837865/4239058495968748839513679493765825789185752399587618875562907228542249018551869477241604820468864916928619364097096846169017788758504470624,-37498710473924412339629747878207353338568032048142017377661298790432827909701012865770839166603398564816154007375230260183858141446806265448/90398571049233263259687520277349730750863841305825603578074682578225667665361237966673495604712949777411244573060426042472703479644926959539,3954940439436680484359644089940396789200146399140912124515928474460206460657538446963342840829494097140921348561579535162364296387782396570225024/2880528656608147548228748514066707948325733921319778424095240564359189641103375843288323268355245263996764814949652978360595629550341171938572683,30595383248229748583135669781609966810516323273629553002699292273511965548066346937700216300781697746437138791789240101059492198291046945036813/28611911353349491364691057949431877823478256742279623936512680191135365339720963859129401583507795548752596646426086691403887558893818975068641,51304873328896982539727586213276755920672756745734364133983442638278768139624381872831656704108855675456428484938995234147535776531767154174/44086172049170820733575104122700893188732942486708421230173992946238649130948702932896547744289893177890335020942695314786184670191830024603,31255405908899786177804226045682611954920819978519696043693234011624950511907537191200196711762402953230985577883441464447217291632845863980352/23493110494556749591190479964122124710585571477382637451849584924813505756048233021182832087837192532881475370679243437606706608779051753965219,32242443650151399136553252494945147162093633695518326802584996551377718678131004597803732690514711074638205672054905319991967156376510461063392/21742489184532119788508553130321276127988596833290633465759306398485537248660458107778650364664499487282111999987621924685479097990415543425325,1054092790243165614916314988260695504545823554131292673006971706144133527413911139177950468715353036583924609531827946401478882835830707621846/765216864349626658679174044755756780016752809403973474069837077254393638697654546896853952657436108111027703323641928856494202451497066647529,9525336453051561018267256167118236458289454147861462977373373543460651747955303657521000403605844695023197783714811950876123616900411391008082/7981056240610405460488130123361483275607482866374804222262336747210514673263031765527791861819750214676812818497757926583149180625225846400431,192236490647722161196039522080013542780102397666411727091307874217370860051160647932953703126049049695135238413064826988793901858123843265365064/133622875536387995782041836354882744639880216273386090423227434503737821294093447610043972142265620571663200985024825671886231807042574654890061,42702312596744501843663045204574939019952770203081498578240728339667845829708226034042920202962935869441666437158604452363498934838095439938912/29440082186335968398414041421508578579922043631168953170405315718167828470722943581533403661167177518803235844953514833445401898581487239392075,46243665286696319379193776325600104417688254270770178912601306227000490333294475131582726281438746616144569378194085527863586340986497908097/31116612495967173993476623911133846950991317218618962901245115680905801379030567577478782187872634429440335543422613656010962950974556095375,6515683616167860883442105565806561276334389009268481098970455289445047886311890299152518274822746830646106896777747978586214506519441835754464/3868500325757434566807274639364240731694051090829644327335100434049301638065398029242153654943405867411420989112529639314014953054865173297949,22059154521999675271650731123510866844936141850652117310629177975677387415482899406340361594619750031601553434916063919045320136213628114428757/9579336063799606267258485627027714099118687252861185796606154821165248253550239892055802800860803223934334480021700569899538664296658899317794,64352569562650863929141101593767621881258306484353369360789469255158404550785051796800586706959087050069576247291692122802807211527919845904167/36306208442479257898743498761869906081947618582900061154894173264521844371601752406603812428524417297170881262753053829145077180222061003462616,96919532112460102238647494939573299309902777782823231561529667391021757141115626988474758400830963782047230061669713174096430078774704725529991/89145282124065048828250912180445229908507013246696516311168500167777880744452725288176364561732294435436729844392996542578932433442978425600784,26397297879530349926543213177224258837894126708268401680584191899862764323631986745606923654317025941055684104121605141618111411284613867826211/15317701405130056470279609907922441462107307851787953383425371057183383699000592947672525140659543937844014053451945296807537990319201461511726,995207214469032773476401626707234330865000547721499368134542462506662590862888185976424621840362242999812302917094665644322002586519763706903/195871760557563986330958739906913951095971221102555345694074580752809777137559613437098218418227145231448534483787965992194870142349722911476,156341383153394074279231314220828288813507705582795706812327166092055468473849814048062685270404822837505834131759935236257716549216479308369/66547841955039262996193048771708482691846001007143415148635291958666780678381901121048449091008599317005408336845082932275832367890542518782,67058725484809443011308407076027703260847983537046602749264123470935607617632834573609240186691227628489646458116051044354308190844825870509/76629834079994116035937527073625893997109855305501517968146044662696211002606859516250189192717990938701345909529288016187323172068123097248,192398607668447628844514860162059618891538725126413790773538418294674812707926394077218801012901464405673977383528927867197687858763685323272/214591304963540515889078482263630171074241939928738589324786386313650723255765569560822086168389726033644674470185876298199030450756282374685,1912954034601301877768638088350741664165884535032800203404037970238941754874053619583137914622440965785862646780510420273783458747612493244708/2349496712421256250243747018928573058478881126438043976825596781004744904364133617777748820783162543019529015373631892597640741815055657249003,4507200468315290758958401269920231581099942241299531244478913413889892052460139917655615214991148534123005434515224050808527381355290330848521/5730459339266197009466866703510472110529940965964548519850835379398299295989957601106918976850293118328475863743992412654969139476839919762216,4006177415362606932353738762187707897142246159127408193600582859968880373178677543511564114111521197421534770702931552019923575423008874682543/4660989883020277959966263446429628030360903727607047797089806774662715523798632696586342915382098107162511618976592674867617566751567817380880,2160203532804406524214868066738399881686846483419497105706181620171648803460217141719182559562061127492781634158951598123291282309404197692124/2466961611034066745266147143517135501911888647810090997871588835960210625036318113031632985771364227555047986307346271412265945675972353236769,3499942994484926959562615595167774239305041211002146625556188165494546072487145543737696003560133331171451041860492926509078237913715351229998/3896715132260390820033851045058618529306491379388921359370110867196994045194670723874397559540990340611816155146103329710552221103023992383293,43345087858995546803534970761385173841191423921110210473407878995286279852395223155596442516309872583662809073626137826535321332220258122541/48201417154094650182104219704765446760825648356893719523192737243382478045588303554921086604914233609701649678485988537801700030098093486131,32707837037134857130852016982325180253693723340027587414188216985350985849970822199012247749988493048640296318019499957479977396315157958438/36101909874888367085608313406682817379943439237895404771918640470187767274845763303686747480643751508981753596896372718239543153203964048705,501750515996455705218524801811989655437943082058111764650450621453025175693945872732869423012505381367619872257945170417799853335469157497429/935074770227648173380016484464232030398545438808651935539071413193914584600287421242230813864892330822976138008235679923233532145367083173016,99841638102795301134125712824376955680288501859880997494328445121693718144060315557694730572021599626276291950638107126953438130026025694301/133297237024388649751045758493874814315937583590634709535291296686866855469449686413424758484386026848441512885316556325894657225588436065612,1915702000691773602706498218565227930242682604786831571046822463836305726146557887747044816144780019913764918729525154646461720509219902737317/3411892673944057807379502732077167017061358696329923754531326024153302406261644473853746422105846498667766027279282088387583797820235394267514,19423721730987356580434810619976869430140480381987844241298328825647176041071328977944127679049804530446358558077944736647333791283589800289/44552407546854233652794759176159405891092406648473711453320559824816004219312342435244955433832989864685008978819639171852042693322198869788,247271967901680339246788564393173804434175365544673976045463888504932788471747422922412407494059758101523689932950954590530265634105406449177/452401376288425019152613752467007089972943028222479144990004443021605032113505403338548151548068503336869563118686036338194268458059759670116,141616875619217932961648747420707428028102360473710515319300700250540118024461684382412310479102367357817111749559796080870935361657590021349/349193134007709681399016313676290109093587266713216993871512316940540293031281257510831308273801859665050280185063250345741012780437299379716,859019686241877422672843605308881702200782412981540097319179603570858192805686070584515406890238951233555090784656196951752228255547062157/676136834345103826197285101206353972431414982188868789344340182098716611939561244412221188999547799671001553483278554688034433333974217234,1250501290117595581433013802389774661936940410672035200859446582112180459176083824667944218956095086910721242700263458090259329841746215468937/812462889546635908174415885844585588102630435449010412640550348337637081658692610909443182680106578733099612584237914763981979255558124499868,227116675820920146557973083816562732469779180633605340971329547619173687641119055256032729667418007925716452348659482395181320830549509918172/134333524795024029533831982563669070793230866778053795506272420913843482358675455220628204890839247748684756866239521838435082465254064484927,1677482990176279938615952129858096808547995583031792757934957550287689567211153945612703392056168917395432920149591885997256383525581871966319/1343108591905015982359090537961247044221227423496991974809610386819521173021847443213112219016930891233294487058278975768367173383912946402898,327071840153294878019024436440746650112609478396494666446326026542926034315444267432235476872397144375850849101079330051214797467564564093779/141825797671844919444099635100496397698417010724465204751537980653364409130050193787718847189787219743577801793611328336892692672576043149410,55684042198151759334668257587162855980551175842259349788367029042958884299867565442616564662516016605050212259472200617958121346006133294843/27428395990082206583226494267577909734384318535978304971337634118309661461665451933072050731199172904873055093574595756368322654267566760363,529186519458875136340103469159406827146763735529385534795674198076847214982785147901104849107223751114963626698420642364075919510957764743451/241664909051622778634786273516512830274570423764620199692342486300853325652426058928777911648984671848731288534978242244433129813017196587898,160526881006620183247940192822929831520594833741858817842664383641250022790511492656611037707786675696721582464045610836143977955828235597057/64407815232597359248542607620925065709085067022389675055091505210815082865994964670887041368286422644132054142695584611074220059464370178986,11824836243943510631904339383477071137632780737841856892719726455633374759497296109136003599127526088212623451156138807675153523044170782746721/8183494479260965113309857125851651329001522726833039042336768951150828463281040122320535620675852939234612395008534052945731582704287634838662,5187434163063650911929687171850264591707273272461448234884919956464194029079384294616490093411951768531103847138521407285338360154678782776299/3048211379279381448814701680513415276107456237877170645412218599453542316633657815224556715901890955497737744202306485768480284028180062815008,32096395445143884507541572864793192644343031960367281096886618750460669366967343306963064206200900502958373765668197449903966378093379177160285/19115688074142431942483093839147598938073112876532075632831381660316851681937682219268426399230229075210321585063996626928214073666974890630016,56359047416176514755362123418343336699348234928068047857659189690741180009606396094567235698001292874772165595365046249102084329123960770790/41432281444092055444145603201616764568474376244165584020255566343855702031945631756125482917127241732049178683501897746091984317927580163581,2491215488839752866862880192489071095485975320157001031983174924959210921014719826013253507629102900194605563605148296090670655814713821184416/1683229902682679799536777750627646107827832948238716268037877609118156344008668239711263188171044351372374789430295817333114908788153358149213,7413842426904703349198203265383958119913921416776078399989589026390082401018482392102976269231040796112337373911385926912234840947581980781712/4993054330213822115031185332700932329622323999265374135053672301080466208708444688745821550944455914553000221944992080338207316179730478758527,6353440926974593045883752270135302730241199016175848823456024341370219080069693465268187811661815400612102989157160276829669834713252004634/4436412073042752586374373396130293240373803498521772090494122077315523163507778625356810409851294559092904096761680663377585240292633794829,13511349674586591310060420415311707355666681639992771400822011831068743061742891304717283067947402017522728817854899481200814285293306096695728/7627504375185592999238126353421268839947197135008859939450713390603434495505521672980125625361187395781202710121236496199259878322335566294061,1392953504526353227462248606728692404371796397445853068742414753244652431829215784488778851703399685419413472711359740080052583116032682916103/365063908077898246410006648579090442529325013361242720956693685199104212114712366723036344536124608004755929912221798271153981059446364466494,-72537752444422289410189311796026649094894339652179705817102684835187432547702427905316598390153381633805629173051750185579990795311195132367/131368870890621262453679604377582790415244758766171977695720032005706806945070392229547441985406383817748427148743825551484531015510921468786,-727759596867359128690519307298847267434749481732398526193316221803473248251808097968109153581265350669944788002592043982367596296913050397035/957381323179394144317697383309467260456865119729058756865540198788131431467861061365179872703574448567656910161443133562613974954361275757117,-22856749635110685341720122528288914958399492728773093866022303941182798294578546571080291676041706642165506203882931104101725384622182406686163/30279582936516255242070493628109761916395693364834192686223633745908217560979309125265717567093961319436596211430827743682845848911835609378381,-21976156419458823526965987533262414120996624078712971187306028936367953473472138456295774000576835190146585873352802805735548609896957983398624/27922334594175441069034707790484285380082757846208905796354265118262771330088422938769741584520960709665585201147906931934644937812892568739519,-2433722973386256255492680395621523524764312430535740763979267101229276804874742134558525339448911703774990800662237865325000322467291757215329/1838568143999714663995726189628260165609379667529224063592610026067124587511776485399757175578786059294822209675012595392275271852661100449322,-87059858082896182613350841265656253986546886353125062030393067355147271481169664248023000473090213996744264015928174546269177824702886505827539/64022397751807362434089055456485020649144571003914934985878575176860275184388090687333683477495660594229360036064219221563975805910373647672336,-8528470199201940153884244449531493540791870557111393353956459380766868648558387552171910831258474684918686253513465431844101411157622759936155/6219950657289360379667469187430965387590222875697085718295749630412154319481520022378097345170746404601983004000035637507517104727144987674736,-478582736224134184139371926873160231318498099022153604617495982187010604227162447728495343599121655440329860830604952519625658964452750093429/631137134083746043367568855618467105562263586947056737822128435711419217934847163230985570624922939860153002745690977667382490347221776669859,-39123644826464624118029578259394309979152991192026370577537570024911463408905700311717539107363664377946643244872326546188278482578477355309/83189689702403809666627804295546551349463302562172102023986361315079008263531447135617520434922980838989659044393682561394455308227204235162,27739924332729091416463481796197674346155854710119346126824518042423450247991488970456965670026180720017739474887216856166160431532443375997/182558742389499063172939813901509453650325731953792917366415014502882061282221579964967304505970321901309452175397820795610904851347556123764,7803858547378046720762922051371705849391108812466823498978391716756456610321502148961045988918055782305684200848316017679111102595551177872399/48797380219058813853745642824010175427384333998661910998640418324596259908084389386612030137526958813035156364518989019170528637225130825669682,-2469104281494791206992955407601084322935064456506779096198309432926461239241322500598110733243851236023655767437610373725734565486842659014871/6467798509205739887567724870953350920998303975698329452470385876631512081507214176804455367652887738347954417464859252701922292978863110730147,-2673116751599434835146865732721927245408205099008925771796133247166428971734227253091611468956165580212994073185442410755181428914359804846353/6962572026606739328025731317456142508821089462394293785345159210561189376078834945074420650898384908547563366855120017038458030090658445239937,-4312065688547770728580640802207690543122853941293963741771323485289428280583659780714790640699991553183960316587817569855700710111266670941/10105738367821849821332766139245444417703860121394159089065158939524279958416781409127440431668613045890655213778245725179801240280884668296,-77295620238201870652081505216894273816637246518222199137929785853211782101097099720584556614587212340225611247442737178770815028229059544105695/55494939920922926073944597909922450927971352575707053781911916948246287069805220617546149264880536248673319017671000332837664486880895873289056,-4661302294606129786642572927449053546831930791966824092740860076268633772353691352659019329308885231148966327610423388174545947925633408927177/3348804703123461497567020941437391151589690038642337542868997753791700666043943480444892244108076403982024455585752197014056523744984493926944,-8276798361988154160070897368670137892223440429653076151281504076914837968761283847851663147316493667931436214592746727590168155860321406176481/4066561135863794546655961449908355848157394632075598137388930273451716790100195457000455381344975378568257436918355517635870994030756525470400,-1797233291941711285830402999431270358305910022646033639808383030555948375650598669810094421392764541299667612147799550715627907244296654177761/2455962565594654687668609223702078326225991411681447706308145544895475613137865179138236860851610097672460791013056004724606103952721425457319,-5337003030015869252035694669811169665103320251520472860921412766388926494250257566847163610218814063937805299712345296045140287753770027137/10745626564292692048501936979931586869815549994337916096251651688211839396985825255942264708520619510917926505322596669779904928221026467896,-12132410655295498121977823528565665475209707676482029319376360387020260243677940628110143872771101658075887184572720023945470245936852245491/31118488279710234492673026883731724164677647486291455617938757678132716467256941513609748177791426109554714057621163445507945846894042939896,-15236103637923106933675826804489659958816070725658665285364078125413332127867753071095322633844273505765543205639287218289847070939953976383/53825923789866779709362493327052267101000475236253718264539716960718973873834122846216871563310488098011221150173909644908664729022208792489,-15184112850017475529055769749071775802780771976401495853457483374127336602817089553979678353245831094900713503421002902767426447927797696027/41406168321882012549789162305094922260239711426506662365897399126951622723900248131713441808049778918156934437375354180407447428881504549581,-2163190804846832584459100137182462746282567629572388926740367037396537997131534536458791222460214547873430222001528216414657078939830907143657/1700224459084083731537461390172279156691249075669688899442669846737746469397811139873851063882422122512429615300268179582202254572358814566248,-610461553911439241590670022141010963752892918521063591590109793593971272331823691181774535028938959909652175389682493287167792259189178399027/484050862111524945879764699696389775213670998823535311991026918917676822220055107483779537533983956998400608685410569093539612677923206704544,-109634144122003543379726531007343430211178357049440361343187130704642747205844506459593321812068991690261600974557353876472820227226624178314/214751887369933988692237651069413560308659948591224919031713618630046864998155246193993154999280321334780561287174867438684046194900866885287,-272867741775062255512479069657181289215710748306472680864803921996151949677555342010911092732510544991442237480974075566445626850854672591867/4995594503979217205392897652341522301171189376326863224997696201969507477496913239117829982301757923940350400332708160388659002129801950752,-1095917119185783067305615269795527191453601463397195468748396634989771509995074553181870317243900700274644870280040827782767091402477048870573/2101082172835426059677045449859317391040033077691299493840561316964318130435617823949296871201325561928604926070017110066469267216226296403232,-79202125052465283432335586262006657882350292491199784087334451080325586014654029572256331563792460359761086645963430966898076255294830515376/154013654981591238380349420505511527686898282953676189163681010195451132020725049457325077575154307449985902378286927520920886005381203442059,-276432444533084342534029720889388217658198398052845973260792502508863064973316181114595273167933330534358112483594708464188598539721584758393/530545522356928011460056511716634307241634742262617194479740329408509150887439265950927214734883220571956779714564789117677509673681431314062,2143198412291857244702292179802444194818131272155541100166301274586719921223254021333410171055129493131118118626266522173450636939847710001201/1756965227787141183824705325051834164022309080114279477961709618502618081251964230533445416297137707092236762212221338682843715542892518834583,313300539992273750340236561308541622515591036108450417956212486567098057423018350210053655937882573977404684623312951317201677012374784155648/1069302920436447623431799524983497155309314010145787824677823293038056531074878955732760588080173840778348485384859878344870866821911024369735,16378162604791766199412268927822631640417488639918499829191873730057170681699033499485638668685517295680166297164936118764883485583761783716/4230016825732187535321630604768210867275779884821963621620009044184556754008306986156448102985740292392669224454073189692459687864500728073,-37709601319963354996381038578533948125606944258559899555919358733811467173230041048400492081347354390547107700300697271031302666143567864238673/34974488653825593056688169582793513594615485079374367590374793113122623011693031543437447887459061673747418694765615230719434287890552275183892,-5725028636394289729683826573963766259670085140567989218619693073828007050353146172624848227872613293428703001880488309674005170329395926478561/9615790748750231856912887364012117936033144300991052309928645442571687075050866716317893486886012620812770516765963985324083451088948663256763,-3032691404963337263934896019662706799416029235720917537709723116883837349901634238181766399918403746386143936505790141070910026550512458286832/14747214503250273782014945940597104556875888795107066622602600809435029863413719197780171151056250366458856787875984022244049518203707742011921,256878614106687466821197508945907623663349967350056812008871556730507932692163691854086197645151393434559136812082839219807318785276300207680/1746075159928631351640818459033829113480483105119701106822620607125030144188173620423923781960249689796545205476830969411766399971315569861931,572685239785953419044123748527078342371696743461254732689694305310230622579293314195338279241303866651921109457300471056385391132302798115458/2383800296988500148578892701780963443530496841271669917064758904342855674768576367439479325928742385801038225018062923462889481858598855451857,-99442191371718059852065523531340787248633632074501480324080380405235744080610688751839824314597209601156166187156794065196270302802942864199/462543171495842922783393243837480132768322417808154544426509076783156468663547683914637112711892385555461990619003487502382585352172982364794,-247756919513849610421790601585290076093456589890944993141512781681604461929643590109425318590241259064635648942575586002638323365833998199136/932670348801146850225579212099745523844065027921903291315063274012352363032508147880572627923957404345457070967871361186313421440816433309705,146969221993181309931594324129430569541764902185789405580536155899044953178048461044618695789758197929270404601510829805948115422863530546005/168455189232555735957337500171097835792603445039026822701675420125170866641678980741686761054305006677958991533921216217706265899303214497283,-103390157418516856176854493665712890479918587074071383512132794281618709437131452765020195698475685358678315734385857411965026893213196644796/119679162070159637746720361439954466484305952997789292139437957443200370679579540971167601435690580831573529871595202301628883785471123740463,-512607946663678124915811221160261470857277483407239845097876077969998619547207534961756209218966545570721414583816561417886968837840580116028/177845090054802530202150087768833499821837357894723238457777134181692941637191370186104402387919719301802094686517031887963719570533256643441,-53474609738329601201733879361469598504681613538824213009597994508033043928056523449034286592159698024372219734909690031729945061379772490127/71313559918409429196163403135230847027146540308496182553809610408156411662786109491180483087859550988687929569923754319566199326055219224052,-1174947136766186133045396061572634186198220179489289927246111705303920512333378524456733338633701611849795902708907835818278265714833524841563/1221255939053271040564457154556481465690148969880655031199052281233519431359314197112521080795428041303529495457041269243109636030979387426771,-21784842112944512751735141879239693725110619983939112054738452600636244569354166118254664233723864006033715552360383064342413791695527897719379/21713532147637888883586804866516540359762341866354971609771512146215406216196824007540334004455215801767217345418910850392952770631980386402248,-48385258723382975065870923123501898903280605642076939391588897502317453036902918326007695115454100204648445397284501292382488837027771627313/64470824877210326401733982649213175596623257503752122767514912100195142575160396063190888375473277331660430235365989229022430017956507717952,-432270111455351665315894510982298959079010331565598244625007169317438685977892805961063565157893111206311333067544834828144829431484171054191/575153921285481071113128495643802305703123477912755699761140599143469357365278628722577274428299520316929994509968067376599852164714200047008,-1068360716546528898344979982637052535180982520120520621902797278034598863100192263425500283489554189525401260107020872215510656430247129170151/1422873105228862882696076699534964727896699617177294166097717823476750314458009251624422485956790705217912146004378846608567090039318904111136,-16060420773620155844466200552855411710786460934779125861889683545017336980312445789675429312492913475035484015000574809064639865118079572450/31085948497627765872289497047693212699529975069500731888281946199660663123151897552815989845854545675216731739281664411610406022610533855097,-12382356974066922388461364755666720426976587357841707021900598763316981660793777138637261567538409538772654765622990081633684365843005229311/181056415074824404441394653833992062250689378491564857969600096164362969726563316084256353750184222113318138881486623814257838022710347704591,-408356378706965484983247140715208387602263313660603208022500056869417171043465157612367006283506137864940460833082210702595916255262331321272/1006104695938378938515812088485874391472950581503349574685412256124584802444420234471427263568224509116123955929729606047597353413832036052469,-415328321217032572456210657622068094391467154306242233381146249484635144572100125794845665928495303072232847645731693877376857685985292938552/1497530262777783450439711057552827849752140835487540927423885832417589250908639310043548471890805139383142051174551776482759463337347216511387,-413607435280392573097829379443042829414029757981982056733918640796480096422481892787229957876493539687149019521660733601534611820582729378424/145267817502722359353955643385120623610797420164309942980874251973036311755938079124927224875541302175712874210136839532738171401657443894653,-14783392089297085518947252236304785746525716536121493822401967800403837136694150333502516171413994056807383365231865534944489210680399644984/6143063012887462540109029187266480100454066108823945451503616098027731915299453420941846010977161638744142531619000922536134098212324016877,-26812120368524578389586619558340772760087066887210431274528806125878675533769709603381067514972074311107608782814977326305396316527634694888/13026625095157353083522903989556857953456521345144869833591625639862321582030488809263712711353407404721792509623289665388909588839635524081,46694145162821282421526080373377043931202326470210078803887587326951171728749604983445840488155683468994971918536658324932357409943754571377/107677779946911651654361087337171628419738537019945551899776556384583119287062142273083742266996611444908410976829853528749644553923217349788,-205127854941413671557374132779376912213395438748984055290390413726018587568638282845920127242087037830298667485443631324740356405215576923567/133757880797617182884669324579566101410565655641940070922903668881592410962514693357758858940213569551602170533890198711768303760437914001468,558515422552711090900371369317667025108507703173689209162215640063212118336231566283174353668343514291184213847305495981388542108494707271389/163370627212417109895955786787301094593459464011788315534098875671219702379314234289499506742212579766360155517145075399861195654360191263956,387109611428332411097910747412398535126612194402298468246783187581552493481010982272123572834759763128868218305101204965582137973907230424675/2105931696019239288467245872619302171207120788911018114613962380936863441629947155297619357182187635489941956229199163352455001625936091505448,7735564795849177516720600906278893076133380207723088830364636253842024183812128111326734096019599612158388942909673130721835804204017299434791/17287643471529324854103539137241580729314566983494027213900793036594203585727214243452721063186396435786233629007784587120082740207062685838712,1015350527978014779006169352828630429562110842546240100539415569916477046545766034932159119875672087611281359530250148494684779546065971610709/5016608023209251352767576163113731197918390056706869256617505288994384949484074595764806851123596789218924743091778877186139923235154922184532,62266949750854659270795853327532983318006013764122751462869920453740998221968178549385983741957512865199916278341229535491999702090864275295/598194054351453598178072608346961826635345475897792715450369645836419756270698008066113047995829032231124958839462691552083795323001984160109,366707085354358218058117860287737384049659280574243780697451256670707543394264058375340938560459850427342790700587793040742722709746749546435/4207011782569394983697381116009953796802372379874063668205399814655129835376501078205336927991712391759499757336879367484268466525603869154136,5576294911013284591241871813010934451948502754162385417867749393317288908730013688312573830273287284816351371829318581304940101685016260973/78554879382570087264692658694691917147353558161359160166653036024516147443776055998132663765653259919890950052491854290455855771029900563998,5149475233187686180333516293603272170812824269191702570769831534662738806332105065842551082327142695772423668915851214659178131414459186556760/9348713296354461599412318720457024271443026632784876943256257222497748671316325664539823995662087731377322013029235526061551811171340592791727,1975474875495869400752535722700232592218248443556411574887170978929422092434492597958723064011700057602508408768467340854169456503149614940466/4200930898225363278136820086959515276835435239604037775408851785721299849647691243947606512525160956355280416306537380728304377120768840577783,16166658680070442043919038959293762628123733995232812298123565314796946432900284636262501310865212738910368865390081165366119915411807926314/324322473441683433329871200992098710135049681578711301496508674931313973821350495058146599492449049849571239806604612787407131097023658961939,607701974418615895767780831990194342567005890267102504829994556308007746717401681718712781930088294036835282307753417033186098635286701113307/641399118700613490592029344034112982078819864261677577417826643291935390279820243947227458555386898481639419703826656587272905950343755142728,203121094171707128044173629061287790775102118127454684185363039337316004498729149495831766097657716426244384696242607778154442436198246851824/2200905699514422053600286121950427475099840294712810327307538531752541921686746392632255841271613973655696864621530494914628565589233410534399,1041959044735094381999105003618934118182403182030301128358783040048379347927977770253517259529808478783790464317429722875332947804252195823616/2560369233447101155368154020801288722162295536533060017363847604545187239658710136217313210167177535712283110684245084397645608389044804619887,49107866311068059331267188655440288223069624214998410347753636051009313489259777819697623711262595897625439461943382928550056036998611932397737/34323963285000261199912807852872397782094247789711208805110239194022341430669296818083355495823036419252260584908057919461001697132059160633932,7647313262487897818408760931478380881228824099634485693191024293888180692469671716696409746975937821129265629374731781087018265457781077216308/5539497429900134356353123331247111044212264192300686314333447188599212179800413418122742091196612879056400865940481732200442353767914047479273,7476890482904885893021515124383197736680285017968034055236774373276448598757870730693680210001842439647409545056666442489273936609913397276378/11648897637971333120394999322748925172053050472629520886574064094675866648018736841459427057299978391685850615192667920243948922519640479215819,5167955363431541199005114895969377259171327108543169839417905604489018813422601483017845185188088994618389937306981325413547851410639611122723/9306053141447709128406441208673078684170718906447149604780764277840993538052933700316048124884488825930881940504611564880966084417467137540752,2834824959031506057534007382092027166640356669800300080277610722498343733777828500870090266614647975262293821035290505493621434698475665122724/3283697829986830606657917194545009747742240536205845035825032930899728918950094966673934882568823190762646199742386711308602861578162743761001,12165746543191579502795551818455032238407849446411665392369708619030302738897299441388922883319687198075814136853972766743824539696642241347/14091531427351170296211075570278573673471553669413080419206291722220993071731642262485219315809699626041084804911948165143767100353159818311,3206483662106351738068913674240185179382320022305556497947659088931118523680597445497227561915459731651120931737028744548482018808728149324464/3061782873210481069485355259831867111628407057997697463802548223955401428512246338774214043121652718122799746738213960719311980101878193699519,26845747063530365648514544877450209957808101117314601410138163645505102086219561638210712126216729869545801149151956701692333912973713180468688/22436572740268448829781987934239023597022718406844941765493885591002022305269217193577301141700789128613067428816206246176042703976745080164103,6595536659538992377027311060344198944685396893117977648929871633684364299871904961862270328135064417310882319330509071215211353939082128591456/16938116538754861582398944827906266697154520306695373848094278785563941648874896089411477601275615729649582471293763134765456451427541417910107,641075830159086833298607080994801090071412748711593563692486468252167523587922385942210242692603508896445422849792544571003205016433962536512/6965344267989757738907506426238166702253707814335410446736814815278803384520425784180787112236458451935207328527247044706820860777137260572935,9735895166162142124725519038986666070704395502426918736122146266090561866254498717206422397071428509245749038490952017084558652043646159329/29259762283296555935301448947265618460654610449567508498560439521561543767854551572241991010232194640738424007005680617018091893777771427,16133136663643816190830008723497085118644493102778420568650113756544701392385095060301522267873567956540170418438524726268353892854048666416784/1473692105387686787763688306181107542255974505903819283294840468820178340154856994230699382546092121139998873257985786158676911942729635624683,486545219970286777499314287677277640153698461930317244511277551562521083683739793827560140901855076962970743902655032772662116555812913423932/4974719255883026409652319130931051065975618549272152322387837987684702345079220356160931908087487264909442843278045637381714180684035662673899,-381355665756654922368604552470933221608082285008178977818143173480527967380031052183784822510221690000221359193998348093120085550782550621995/119681510212785837435161016567117592433221687304211796511546475670315016286996591866028775432239227518876383156377784123757953879726993036346,97232261749847372183300572642898128763728825625064389425215697160153173907884808079266757760022314910450101551514066015074795178708799683001/935243776213981614327598494124390027603232950205987561726380101518270079908436758990129329976042632241881540590629022244789441990900889301092,-139134488421814668794306782595205832016775723078353965935292407440857499303621256856830456719672903290426834487914549975049884225214227248973/35016232727035973017115833296205877849327778602341811890204520287232967513149299004983706532632026599981745100203830916625124013987677713617,-32703134214931709059733223445167179269417472661820883860316635292098056010780408077364222158290153529179272449173147055101341220333199766504/10766352093662994256606102023119751782841403439238435990001847399521933186490956289538199282027985314427270701745898682258963079859731530747,-139340423041082556675641474466308161096384976954607477995555707447281466675869221867883826095336436873112855724640391143053630116926761029567/34835422375626375735460979304713384048349400138371552872246504905817670501621039504582999997032484456887352699497963420266595549156016720844,-19572082844432183626040363882385076730547079018146583174551536469023815261717550909360290187086396611937220825792764057281741885551316435148/1381281548120009011881834904191544341074089383646732518375256476518321543050949572343914425387125591572751728068822870971740020827528117817813,114696639531485940574830396607784226182590352399162934160934687238139674089117951791530634445345176040487269459592873714444180548108150520608/124307117593721228143403054055052462271476108971490791409103712840875113476008705440322767306825424686894312317541652984146754637577511217837,-103046125052541342835366792076878423111747328683706670201134474841022084155091077446434747699371533215742217427747433148366425913780251058751/89724816837852143344965599709305341143236398396547051468591742814895352758875299682705364644345105906466431683556105518792153542423339024160,-90259914854343332893329500508040199579841194551827706556048055783786131086603634955747016674186690359223957399605897403616844732970201997483/59868081928506330136485185517482648261957937566843069644396284183232943019187388445207778409732433322045901764063001931072212726701411165266,1671805071208358999374532863949190182428618514181535935986280375997749389948928372706583794397532104577248063128878037815354755448221368640/1792654421487481394492542932157435165417038093967906079084932335716593465700117449238723005828337456185343142274070010602129698637139668517,-644621211829035886121825800505057014787092630825185401798699711895293300846460616392402329086083170071662059862857726496112311571908809546/107385734505900799320977695446609958610730962268668412626360978786809876747173227855500393365126993178441557493870657013484370593844821207,-4008747504808401918500560642038863089445861080468605837524704060234764928322856669985271226566531045504738276635526543121542119321069421728/393268394315082987868080129905284432268322914298083777520406067622648086375103215463071367586378064288035722478195671052994214750773262265,-49084606425283772515053524907489935081824573620494049841569185094890636843393187527527287954814456552424396074383324761313717401951180197409/1926111611090413448486241237031467741078871357063406083253504295100455890098141756365474749393689986856076705314515116444776683150995994128,-196318253548625920634780016429188597254409505104690497301981057032813086201887473487513138820429734497746328235357099727376913340645388046183/12177360307983335926703107282181825552583494266834016306903963127822276748999336066407368457621150217179414746626551733126292451021559862132,-25579692244933095604028422995241379406551687653428149515970138575390899300358988038652297882601988264152990861605993983891635666069153126893/787255048966315939240084144157936049673768409134565878090804414564282419863614549450921709588568092403624413583941185745298318653375844286,-15366483456826954896103541627069224868896337593736181527377485117128701958090757872710382983749355000675340335317525931493765703109270421903/4983874681577806803069445670446972907294712346994730040082064692288142295649625645987512264988148893896273843914553016683460235485207222426,-72640308201859644329846363899220367308138646972158017761471228654943953106299311702970939726127806465830063169237488391889068589638086213472/36956840907039791366587908274465057300881815479252083826129472906660514212842214008495363533489496097954551782154114075828724859119901623779,-65540048539958290475744195221488020107988932685888596504986086587559522542740709051260178900421657753681042673505894552568996133780809803264/32730881638743912135182113686914392195334447684933487056968649984297157814157533437822969631453159141752683687065909611037614575166808218309,-4920885468474456927475351869994563282203846957818678394765479414950514217821598927698565290073330575279924768765645435893631505182360701324922/7367329828243302568655483477622484190504375340585665143713354290016714305566149429019652092171338949281606236141695211825240876538793039398027,-905200569346915589369107424370022158698698668883854882655812308479335891832149481456127513694784543157786970293876087312338662866974458797137975/1307242702325361550210537827277096607806666733648014365703369786670604051059307619934380654353976210419372717402125866683273492437948522212976992,-6805274389326036801714795892156008932883959030387168189492555980138147505529539755516838116030013329431222985180624506052457970732768819027929/9493429834290330194899140516954743428034883116799836507026478234163173057211896544366848692099549895433304318884581400049290399436418566329168,-81634478076750014128247649699940160303971292244888230251404984774196946336198083393796946680704977771375799276604585495293047276828014104495936/169940321842266570859990221953265694860042317322607767320355545656510117643941573771748412169599701011424159090065799159857074349122874264087653,-38744450339501873461615172727770390961286945053120459569252607846534014379903895651458514751690630815759551004289009883390739372463509292715632/76169679282906613939327733360910326611768735238214024496018504676976914384783075059002427734184077724735442095617118681907613239007192354451049,-115271410668369595803571150807631529316539266575643521785640788485260331688089589413441774933276198006356724678871699997070804233018176539373696/235909206088905284652279165343159369079234150222284563298282992772508475541797012845614896876075333244849084379418423375604081261322765711105909,-601878810630502313530280837297349263606764677596604557114536161486532714169762944460579421425136821985950868354389526819070199730593357296000/2870569644632863123896468329050121589688586622184058430091682691546481738779199987119459101937283562063146787925160404424538650924078817841559,-244688892766444371649938575887327612338709960701126491409974981633821649076850341503812161039561410196467888959832264811819118352413952449645/404802695377259696489739348115798205522785541722565512539098473364153778755308257137274498219146383473374791314538192451364875689934837446444,-466654715946190236105574007178827850177266410854667096089263062092563408504915205953071295055417843892282579352615713165356766810653445573417/720040491378189768514808704986113368104115712226493506833268664687225420549477497273896515667310370320245983833443212520663585421885666069916,-1205920384874470991254987798803789521870690254986516418581275146159886783217399743721695823676124834993713560523451397736181249062847389956451/1842080349627368009567259987674209624526440582457573876569522382567728687089876751571380954209259159599560467211197180418416070435230887875174,-92903162086735481727837152257260198721235617317746550427096827145437828537247325330564159951847102840668402637128512691866889719864565912273/147875347035696942136502256149883498346326869365354488060999106440037683570656371516933669170313980946111588666420765991773272390431583647987,-24029275411406302599206494528095195839389625987163590423893387937065178898079823572875889510168327544850118621792383892716560722860723343539/43151894777281704239563133501702761806662641680029339371826098272358145878527534175764429363513801205546609365984443507735282669935975034839,-60412147933540052804225798671028266511756734484978245589025392993776000915415019370364699114757331397772662153244454852504225508436265757957675/90166844329207718099399680415040987088035721643416103412842226389400969492810246645476034599588848948432711889981663660781476304375832706542688,-742138742338980087351986484598933626869313803550821673151170541153138198414659230850928682230657354179718598794436253462780056935328211305473/1154677494238050597385478601588190319217956513301028104494553795070742540380707468026203206759283832479799740503044603155916984871382667329744,-62164963816112171907478191731362499280246857835282286650551589965573590064184282490305268883377521426678829067493422937883833017371117494592/560656828806118911449780238544305145134621169255766175353554807619647744633070819925243741428362973833844507475866534498838272621516309766441,-1248647564831701941088761955329201283001712328700696403305633813915178269096632623666961243363669872015642549907376794581340910599716687672320/7915769771917219752941471062128716543437528847858597010090180482905017833203004612964012155643527207991363944598276591743535210663347558392873,90609647205688694723345761585722638407389930479930101032191505239478591562203228581545889438595400876742131179004866416101611628180651826240/241511239099209785601075636328456075887586509874489931193350368137692696574321640851805179077371976036115200362282234532863842097528061439581,103647251775602751526448044833683754948648706744317804698510980149976776314123589413140246351429848802664368467243484219800481456293211339328/409075726972193773781960417516263495618273433801784899094785660123013577833745794276511751851090488076903313257160982234247538993296970094029,1183404931184954810957623897064791056660986105536507904252377420574040537373774187935037862816689572629324437418340830673808543090324911026269/840331448514714995380310940341019442413175128694893534197248076739190921344016602168310773220354988704508943788305153030696781937805176258142,263335887497385433451742903484996195930304676659010992299766124374923507103327905525492051411458533891220445218701879110286143621547145057833/283746172409472259789690686912928932599117334747496472098074500689196928147647640421207438554206007799412727508239284834470992023880388725026,-191869064616113280358878895600626590660695883267083513710929400348169335764821669326873253897147966217902742602350809269286394279814707829337/345550427651711343810288410244057750545392343954692888205866083996887625175340040750170531591933061629610344153397289133835497400403870946067,-251696931947989349673187650031884504176107586666135630955151091190125518972861513489845381146419372544416727305449780659380065652025701040911/620074505263988011820003351609183060890898519920120687307134274792767796543699026458401925933561778625281770602793262190109742930832178078656,-90113353657921356632779619840040210556591502261595816309044668062313080718007814939269286484358000257746530364831006887071308627467933783449/196269667191075220997979488282468702663261306854223392067940735169881285589713669041190613744504156927919953907592554982579239413117145754638,-8037195371977430172285128318019212712988438450812411194284235683850800372619897846971189130659653306411162855131438978865296073323475987223520/17617203139278102987296383205843167470722044071485503618693934529793401868497064638611986833144186369886477781967922770745162461657759573986463,-10469553869832835700153606300099646668968270975814654514548808267933189167294128872164118910963593408208862882572887301337758689045653469127744/25314831000874155100647585480481613434273156717220329021387367772209672339002069427250362440804164860009325086962084991918156619877892028316105,-856798831403444795839847257812376736111921370226292948553318699716900857255134481949476421583649476701989483094433415201753473095173672344448/2702239977019587622414371610736575863435358317301525101746444411812531390340477025024300331688681292515546159748210275598634325262599615691929,-826497749420458720350882232765095492182113883799429702598781548790330191693599793899511449890864164665311649397009966221238105172286050527271/2224185135926786937024295066080197752964698329087771873837999360415374673552010374903307766841254398203145986378442145755561129197164874056807,-10215305926620905637160282148763197538596553994090441868366140809644038497459414094606100364231717632563330933914683583077894556123355156711552/18823410073191893541431942265178609016828817215048324622129660050439882766940083850178048401014139639722439011183514724721651128024244617908263,546116879591389718385909464929225528318359368928628741463697185580069644724278924567456426350378435261857342540051270095462080775106250092341/1106548572059931970866252737107984501821024353560745519652165880544237762097685045996087791653302440268301974336412109888292796295033220701338,-107597926583675792227011447607113427730939909169134557141060006602390719942131418793475629258027496519630673230603115314333172209019642959506624/115031346536282580594932693242084392966591007128192831492839814411294549486346643616737664838621311933651602955980081730749990782521302043852467,-177713648114289022853517674692994684783461662453178205343974642955798078648682685834466602353834871099403693152300101473723025334146709273061/173121755083550529704973354225217203656591489992585642505981919890893882554195846964415176879786410571069177003618542161561514748118853232352,-2497698036357069078407991024466535091194816063611703167983290199996500564637756050151372589128492611922688629722017513010371063775910370007639/3977902495297626427046078909516663649868292812022214345763668612501475441428453130977793639760103346157021845608375349710562713079316143166368,1055372098487854290062639207284407852400242525472996485851929767804388274769644926339995894971817281716704164268684257906245514612033970112537/437900650596312393352623424373169303710198307432684637255863741060951892841503272583111375152926288006731383977827263405851686490486589475826,-1361026421014291389358231890959095720736449283546886488989131915475500899785252476331213585737678337720052571934492745512801545687425840642871/3070345802045836267653451797078836338822217837175678913133516879738968075292076538616635376215082628173170835723936571011513317706472299769007,2688694754940141318639666606978874162831061213663118072585420199456819046487623412291722826741238215511476440172406097321908779386164455357923/337992041496074614753354426556573866276412453714492224977072845734121888391510439554429453290378618442815762994155451010224649347988898752962,-7096916965979144228042017158416619526179185127576719731287551192353713079978032777703489324172874551118067563613912653662307147122304893491/33714008073284202330913190238406378738455008899971275640497579072520595756302114892881154544872012811991735097110069175958792412679131254528,8173255333078729203307051597107554077303040031845828080004261238117645704435688365945151847407695792131161466028187101556125760311932021656851/1083545329086175851933744849355659015376189495407477670631586127068203278045178257910044996701170249165439315181486362379766987888333998890272,-24662504094800864643723972041493626077953877654723020669727001073731796535304595049057305928857717402339004113968717730632787052105982584679424/10444533386301524973448658458644901267945188187261176204883738148813873216434285108305349541419308527006449726311128229072035763699024750370289,-2159717387437105589439415171002597468916608225324064946012778381234296332335011701966013553866930055693439784157510559178721253954412262349248/150738539083035908321597544631568035964635333043019705968302894577806792915386600426873470325727348347515957713770108556812650881117103660011,-23623060071053341712896214116328000662106901610874656259011251938940117826710976396268866501213759418863451847502489256635512933031131889488768/9451796955374159617993412218714379226724022366845006154057517340280201569635387858395718867247520308249183873645970570673035280099302584869667,198925697896591281606769802030891987619239564097992486107274227040001054587635640046017690693715432860104916990652601887307948130825581436308216/143437042053752484743034436223183212405077601591995579521020514038808701823632400621912089537213505125364048830194638974186390293679217707509285,23221883782118460042597320214903801143872927799068107462329654287143761470780246000326644364111634271396537126473649858076301126930862386752048/18458818944422271388178236496116032137203800411379639990337487814279498988948944919770673899192755002262354968993506187008328002243680422203423,1252364980428917745378750110822155744353612987129026121623750166069655873970367090783725495635010199770890908675866959402339704103358115615682/1212214458889200141148940194221096813464731547349821804947744232044123329341668112391962065058137874622382581150316084295946891134704488342457,389262395701537175146933257232140309288188965254759089078523660596997513737002926431787203738854118806871050621740877956050782236551105390762/371408849756776090547027295263530105087452408845216922711534665241532312421172176352644576485457000169681889374738888151230572041759026964785,506249629391342569272725164079538405816471586673006552643060481377856991279976084800185652828720280029069453433897664498197401477082055772705/217299687023391630559895561369344612128114662824133128619516312054408369670592659396972564777301014458097340429586109513575146614549257517632,876647669718492952227012931454138277820231043704099892233211715654662933225705186812429530158557197231102976808138851426015014271690516608360/343767326034206620821302376196468533876140517557107668343226072413642231398084859394672851680591916102711075707705898249304796385113318350809,19033673282874262637185630624981167890653519847237597835148870796136661080403097618225076242680016636141726763636868565722882460866528990731811/9924287478716637380735895006222186652712060122057353309824974006935525471715126447033245851279322384865882913025954862894694188989141226394370,34033198208136096471207568041441359280129459192447758291183285515158687337180723969695626352351789302575823118210010750436808016645348485166017/9159162177332456096295186663734625012717015109746019733333008154484984341546818252759554170956049722052239708545626400094170778076418633630694,5930909216180879771713970433261818409017450099168821387849224611943679152696221994378916492594477455022983244858129778125063743825035127873588160/2258900555565966209472598954019238989157942390788170189943054163037626336409716654363047460791237611673919052652081225947811633149355432851274917,210759669419341896916346825543075365667303409090595818603449509306713397157184958378769915810035190957048818676864897268967014994193431810365904/105158608511097251250683906714032777466215204288642788817270634051246169018001899530314545961178425686006237868287737363007007906521365781719939,33047521806083596568513749988322070590568737714185192242511401327453488827882579748317617141560158579616924010215544560552903468388961613053968/19441132694539299172387649585129370937215180462407585948901217097539974129371054439164285771652514007610856828252454065560184435441725256557143,1274624405707854308297912414979371998352579084085718887677894137456057896296943601940309156980244345738237905757756056076083514694842927609984/713090499953476046738667194056915458364826029928043890070856674366026298504953735839275963928288517159438436553951754140131173190956435967039,29203342469888574843743121218635188222589498715830243078839135355636910626024700942392885792117503552509488407868317368390945321970213869282632/13038267379008120789279381986321541907277488730315145852466817025367879143436711167502745731248725771305642412165607881779599473309202251182177,870186933585374628816868729710954560903168989994876106607239059126842264690503844645565610397346620440141923530131902099870288535775140846321/448371574876504711029884522396064033086908431649574043438753685907824026322903563686071445654177245587725709929260967427443533233331938237158,62211538691108420430164695164317175869819274756370361530392465428570482286278405486276195205412209463385182357056804260208251520216831649342/58744305942449364370414735790339927058802829643267678292537135125474576217150780516207045741261122456088700892238998947260130866113335751721,1865943662039933221178036672778405200319654833393438246123565132539534248447926533112430310743969686275580437326147318254189815688331134643535/1219737699653408590947314396873125282303246956201796551153642417903425522889166165611559715759176058961542261706677514460986305347924751349454,198664017462250905900516510097868939879290315006302352099992699843990730554772302149139615342940068739726946123361894790555507696129098335337/65305585606486873514045753679002299862092141797624239668088233018750928834342895737575320847702433469461922652473770929359891147853648399066,3735116913385619884163274433685822160054141808953559261982070475860272811053507399805699279942384780249462395769020569649292888873380406414153/3504145091536768481943930948007162624987329495452377208688171499613341872121276191677338876805658871220857269881010754802633104441912198301092,1561875356999692376230061384498586303390984487889954579616085742539343090182139061757996356482823437365685822653527479898055126432752810612653/229925309540094062213175728426314848427736776655964116121818585637816313443802614964428110403681122923474841846818213314637118868851085107634,88459118131565987452466590770868469098411837341016361257849963734867702241004657840202919259992136463001686408609553417858433891246280019553/23808460008482189976738124505747662205892524417427368310226379656162829964821930392436471772955946579923812102811400511554756523322135603574,4086484833526775817214675714434990757942113385293146604617131304859427994827445691324972285799689853017962248111992469490345025882477064905047584/273575186010043871354293206579119589346516069336118768617158409385370073981276303684264932432258457896883446548486751700900347873969879460992329,14896262634701960780957344272444127907274027957072388077999761380342110120286498669704487184077366159164170523122210371617879834001201454086/12407207443496124123455208124519670695339473056090002122880462983361720369742372523241320255282105202028340600383073429329988970763674150181,329676887709602201874283411583791952281789515212379814348105634563083462965937039819853304369292007505370013972430981008357584174259288075702/160789449672181475892479548162844643511861609671499785261688128724074608761526126809979611202318069062603083357576052826545911476897283142643,335335090500642582945532499248325503851047972180915371037387073981155158881949734268298337896984636188213180701595579260684225590596630039241/75608163651903756026829469451533143985674321324812139149255003194500340142337141266215210026009923243453698511037947464604446568128015837936,23283971407451434325780581847700423804150047144080106892977084185262270081800209597777421116511402014020115990915268745171107812228762610891456/2611640079074353375584348302395053539203475098843072739524111382685959744504069977754659644452556026447865287000271122664428237546996880662067,675511454494377885946454098273980448385738293875562027358867025976917015097009400538946053002801659382187965229828596961892173842301322829952/108125221956450017532673989407552802469503555906731306759216084677956950668079713406736629975741609279333844863101180724893684281708401927549,557318707358026018124361483881813391892992060073819442689000988261181007577822432001408178245425194288831276670762269798021835618093771719867/31478368094454466440261873448374183683058105645248877708756055936361421308835732734857595252475766939640827237590576892451776272769977524514,595579631772880153152459775309319609182430427687571714357688649417770871684335129744047789451194619475943235373254257347740738491812227609/687408683887874259789088096796498374630969207283719837290112156880618010200544887381929246949079231710483975955661821404106611219909891951,437837692738358088842784960327975585004842109305676736353684357716668192726260917339576392732192553636646588820530409075808628453258302926805/399967247613949091675170469193172054912257934377968600357271890836879167192669713572041632130446409918920466846757835324855869819596342613469,369081385894014697486140755260162567604769203097516084593037117446099969864007132383822262133219510438920437998827721571982251194621222579520/168653295086819606487527718714329559767551294990482270476195847440597494259528767798868373159170142017461512898619623143843853814618205495411,1169106892275167040078704776860331340968391840420041874482613089997273852987650020272617775373617932872590287944297247795947196584638839525443/452373674939643378820798946846784866894155678368084789443473658686886378345924643879617841927886156655309662940852601293275710947098532349772,3227974138662478950816310865768586812369291364428470660417529850805541842803840824458912526959267611501142837972686351169252818029455652954061/1593669185242576738898469434570935881002449776087372676524572948118165516808257853500179983440596109675111548352897255226724917672008391861420,875495632795850291285008177530117910857002865089798911717982777079442148393792269255104668765453153753365414125067732823916795256720778262051/338462632509667083685503438362150562284408995637624439706630064634109238402024149613777436087702564560919903078062414210129051388987828205124,99958074672055423350892971611362327949525594313197357403971666367399768626293642604339621278958107545031768117994212648484860075690140772813/38398256353230265358982891545439613788198403336233170299284833085640894982465083002791677211799473330085795277917013206197889711388669337988,537945238722248837533916482648767093701931470326453396354874368986387232108352460019498766255366817043004342992906896150195155936173381790115/205736812033533365143381189529817311224905467197188949384031072044791597651269963428280721092234482046638073751091632300827085957611785177228,282274571499188688179129934247200025152487016578428536592929224838612738356962558243042965711277545168207313899562552136360271169552894680363/73921531645342034144047173944590996628648211604566713133914668483037678645759085651524730338977732190495043369932400003598429696836132075210,2603709935402237386205770959458511813520623997749593601764562614695782809608506615334848742603619335613536061933791824580988737914903393005191/1174201688077732018819749936707779288143639101690023513689260635330820547724428292749917361565314678985164433386477985504282672491567724147544,8342970083210771792994181493803753293213864416464254818241564012363436794361739115003093169842756933014058396493730888922205017175896858254279/4314430680702654907579306757243376989957885164716277792189326435710695277821158799762020747342897227765854184721305651628889997578472439085198,382363089888390167298053873827315534050570832085720282121452253333065218810751505577501283353532175883922143689132190511355812530922074317153/182984478366698610631937919742248263856757020645662588637020439975687154550475697792028132017974074600608696724775697456283606944171423746406,11256354329846719993855166448968062508919246065901445163006579303463019998586758170157616690795019174918301125999973197832273892843144229795344/2804173641570054529654056659398126022511203262674204740499618460979598027263234082416471806681024960178158901241697645516761876147230275614473,357293012579616325478400434096152438845752205639381982765099306519313397414826006546588084703433382578424299652391797517622627244153879172393/72784004471047905605422998144604650446279130884392618556647886458684721784217746043132456907585736762259297568819632074673509836934701954378,1132751542175764798092490845265043029709247140538382160395825682936177879460129226787475756853347013735772791654268588849723489860517747646/1246028682336154501632344980822928405676168357245484532576367678823457554179441584809478141026275120386367629286472850360746628368298374931,1935187889320745401708657361539859537512611774667435762377796069350410260849111930265549443976328980277156814773209861540371267790001981807548/194836758742485055296825213331061096889682348047705552391826880303132717591209100695335916520845598090239599734727743735242783340244053242859,30582305671921714923056445526038145988740221048798659680396750002557336177612150275428216029566635480036513667831471270266770718513118218161/11076950244562462103927294453170792903461328246043281201272589199056211259107114245458601556624592026681949814719786987900808104397241546368,852480305353975897302355724220976240073758500098806089692899983595059373698579576573276916691299367571855595723598493583906126483741061824140/6182641768225426404028490099420716339043450111027813302803547903771577219166824661998097702602052318411075052799939466873059448705966717899,241546453860820474686180038398361642478314560785682226342622326715074665033176972089272010402946034593104474761656614684113577969217714572640/540592068019553457256835515196716819939893110031190494038470489666715384459279017148112419564610617589005969713635277847248787149473026608187,110809920738260745137347734476713462449086798707813498029476760320894708247180985082540134704267678541923121986539113198599746463811702300696/36299904212168498871488845930102451063381732747860016711689501664434941416463418991196868320488046679865838026571302675396643357219723496817,74840149660644519190604281411693594697765504956259149410478461981576109360850512111014376275874219988414201578253145712331962166198832498651/12428900593819030376835531887873495147173784022912149837679723409134314534121569847244323996767209581502625060949229963304913904680558978472,52538078013178629712611781331211986057570349256475350347901714631228515325604461303906470873738716107988031146637145891072014228588473918588681/8299529508207224183626006079754863453576837448582134981441507761335544008090342329436960035453725176086459731783419658919143691749742378506306,6104604899802647525089392330034256518802792213391807730034145578849569685562950071150116228828814138751700100951104205488713184396963682117437/1041518584751190308174397586923838995605328856874731293480737150114655044008550092777833752321961209159273125072942824852645618240633318501530,6311075799793514530903937328392409613617500693845668063463837326665066830654016862236884158093844881450682827935674377577981808510619257861205/961273160850992657843008917664831592203862342244057642951373896516709653294424966102463015950313218989465750425253530388730969207563074979706,1391699276781632309769522909321110858987659658381019914446729769900141747950088729348714251728135373867648296200716477545960548309515210637265/154167266576170173150878323867760550771989024761313566885224203028576184985889336825563330978588505633203590276612081810822240927928615186141,1538680102236590455480952190728605089865203138233014417015368167760673223594245896010591782555523328097717275706269111041524149525990635959798/47199557807763109370468640735914560125799452120243733166330727847748461330820260972939039951106613886649395258988936550872265706356920387863,-444957967085474743601618784603878186187845702510335206224096176330095400232299517327840142937780838374163646058026210117466956794090582976289/1441780579305747603722107887367395579533418031862525549006787430414530170760921497176524940641162238575001064890792387380906472968408046181934,1005588550691456554864582337663526866864325547433470800509467964337032119909732789151371766828043964209448937408759784058649011019425340587157/1251673888084623767319986764202202236403652242360127079483094673589928503003870356978222205563355589094782912601973840930647527579607700822634,1784196879756713469011870750668493349944945854518801483938677903135345621776770358855526724445276744477196794612712326086820190451455125564391/3189081692480321021560861474997932594477462924144681257320435878687547109770859969714329069538389082128983858305489566657352224192759350633941,1142297129514104989918429377410394949583104504400014733914016409748943300255716661811852398771039211453677421684465813193402039596080706048694/369182251943054205351623636397035513999906327542074484221720621273950036144195584928823835149205962896785666252669699682311877653358035470287,1802536349695873121710784553629719801951155427965378895380457099911216193080520196513933442692505653248782660753566018400427229761783732471086/381433304092697093855639106977563859399769471387621435757641113585496796455514098824947208039458553391050142512791184556712437458519840231303,4158575286960787223389140568934759192719783169190067730148528756161703008671439700859820916366964660683918884923593978201912919562886102056833/738042703365062703311530218471446642793234206174877490312824000174877632123581699347158359967885639434905888450558051998878338437812737240244,28612930073970412477171340138903785542886342518897502425464489735985185399606422909617499654266535533106222006953906423107433495546001116369677/4982396203059648267278152824341239671392107738404257689839077245440627585783105814972322103129899689460963855842727375431104886853275566960234,2406145412178994237796997729263071950775218188394749061402488615153002776473389336782688095637729604649600896532184924593557399067112229428429/56000858073052041017392173841399769925680985092032201741855937434464375855216694423758082029125541218215532656716846631139320010864980208378,356679176842261629495346683411751017165878740918603244213192894490159220176899411038648461421523296509331485231850547613964068908979107318942/102897304055588059081667516145967394449710772929127604043338469311226041658978172338501621429305673914729721789103110974301421719418610476591,4027198452225020169055913945828407538951761947940560450182180384988801347611583585173961968497322456395999876163288716870812837663624423693174/1236839964828327537565976544735459066404797985223581548236705304621841996381295909076846994017367135705342724801983486377287335943852741874927,878581442708003465372375449890837851052651543703024102053014978101505271706801622044366543418491685773277612382338052861744718812729039469294/201707389911338635108297786325387520995558961798217691931232014529706436958290668484076905273764433019515110783225668289184842099842562961357,14854086183415247911357117150035588235731606943248407720892475140772780271298592259013304327506914264254693072431036369066115610582672789179616/4442366732708514754480185924174765736457070508400416530458702541711513108501252774703955867617969599955301985487184341734215697778485654577149,412992276234571098237901695117656502605222188079486117256107737986784417451634078170778531950940268216467506299231277755954781628095165064/59451731894317882030527761669435970210986695692490528420907729543332082342417194277069025883543518170510678255658508496953094314670328817,11628148358074677457290622280022974085506842434430180768901106564763413883843489371128285190703875009795209108419062560669807623025571875711160/3038585659674855108277332170988503281968030031633715441930526040616075142092862678464912140650334314877004160248791800691398323573641645006853,43545270020298894886055419873345714219188336937514860360920233186575001460428145460070111136099379554065009699550609315007287197499644441100287/1580792854415054612852117498372630196603826239887980889837256563938584783842650073861051594584462117970437230324120658335241679455227550371750,108774470927583077902047905667233642711818287567379786663302418986268214570330090818146786833286823579433176474359474076089070615583767615711292/13445464187436786247281170582812123656984188133835251910575251572390066758152862682412798147233378209165336369691382430377842728271456199112789,230353745791927762068920728721769578069685706896363604873570138405496084453240155786551305824136440267375436625010073626047624930362082660211997/17421244638054118246139687400105786331626636094037964084893667158501713170408430018335247994611852255757739954160239695024430772917088349890254,28568837954852410886464327388584461656486478500041253699126853923469975427962105810799920794116066975633934434114355256539407872758439906424769/4222452492494781668518747450352843229122466737816632173307903230326532125655735560270668078679143628494334080886385190448492800918341607628468,23940254563645916586486483057832572493007320453112368167880001021095035404978733184500234284015631949802836226322200033627067910766972657533948/6505978976504464847252102627035368233635025955718464252732454472200758060292129992540032815755769370838542276430608497170035540080083950052087,9856681405356571951356677425792357666103692451192840383106185845230932784691037757221688709397287324813155443908636404482904644775213428791980/50033647261599369540111167072303959027175456358803941650134789501632153066009786698538420446367473208309802283167232167271744347401139691211,220227035645891616457154880325219487626345179916397835145009927480852449277667825836769749950610498659026678277531738139778531928704956765566/60437818227364298043253124448146502014148897038885985326924692308768491600066573783305436870995385869222550628057015060283771546516364596817,4780825656669316719142773458807593475613872617992595487996712675526721103344365229217673992093107628961159300455104190598396453814729267834250/203998779623475050959282548553773848653088405134307531929283489324385460806511860127935529707028290256404018596996561200700436842096011710613,-779892292107975239176103638348263472751578430869635190459215046263488084282110329550098174539636783150344935941876921730490621313216552918126/1058446603018604166986965463659323698452993060774531873748896137966445382324883565837348901582367866513491477655886701817173730824152918343061,3764518873387766670576312260325354453580616823791661549503529300623976949196348536241292813685364761305339520748026080197412483248538131654912/12903457983763591598767116261389460488957818105134759943621728158233926895171226095243164253217848482579334945195162070690047335908621092771,1722570079632266963646818407442685346066409425042669640246607741657160181561598655984402817390356419829350124671124245341919906975267420585728/16967071466009440045135412373826998835326950435940790667266257458610126298636179402317356300948382218568598771365359406173658300858274800099,9511437168535819001441109795589690224116962735582658761031137000798667204076865211500192978159124820362782118845402571516752195508685210535744/33789115090623646241884407936239655874783315884202404015818161042553697825221460901392584724606464117033933530533950839542104333484379622077,10608083249912180411932404940342814880870552142570347362275585788457500143274456127191590831925007227711906549461933052820730259747823034390665/188734961311117145975195514578106597754985809567690758150974339422085129311793186098938588287935641882562817770067785594060764250403579444836,23048280926734954632144718765333429935731256349158115648931607312776497311149462878635270068887577116283885368453633439016079332714661218678436/4062476417924259097384453011439777493963583395875202249896234908207088956274234944641741120835355936441314967161785109844473303310247915192953,7883864529031235149242700569707228782188549519045215564906971375552994731499730082108530300702579934589249253798540087811178670909075424354226/910884240602045834361810026499877059641327795618388458655577542242272754732645234296957627631979204076528638071707002700968610029435955773683,574303564850474664877326365544161708862315886463112126164851300478090766000726488309320150635016470239617517911038453211709182388543249878681/66375787004118835670131327373980000074392717643242390839888089535089519923399266070450834935309091256189479230671679884574489190431741856015,3970761613556634683887503407639669995710562079928920881907488840154504872557210333025505721766338317266218916211410780813534093940239407875377/119920321663015165959951468977465059819982305690704368316215886996717969954302475453683872528289499934394350950445942722111658338174066968302,4978054309110020823538430491847589243909950534397361735940609768461996686668045294022364715338525899974041128765284843833413982697782389119692/226518470263894129062443851711619408344936751853561453112855416925361266387388140612588686665900360516793587462725969610327905938018137746985,2611645603209111878180201945628796261033657159657669856493483773007467646728803838669229878611550582140094263948107647861310773578062344836736/247204195836556354237660374891735836205821843605495681479745065291249507895800392023095944417696962845384723353911573670884724220715784449679,2955452879030162039867961515091341840278894033133970095785535678827885251637824821033750727231700675546113548951979857843684385588683359714688/117795310048735816109121286046832958208935306222285615174167282199740065156292577916892390147843183280354885460196339739079663148659732775695,5342842403360193923035920785893080732024811789029596188150215084655614902038877716307979218674539264688201098188984649589538138466385872559693/79784504108137121709230653959098577047055288961338199431183486670975775463289690416062234444753012782275572646762227639323342684242640192510,790381450361096020262302551250462688471210344061805416640971963884687531843969520982721219150864739373130755510765879231025001538215037696192/830418115928182567108181958721198210162344792228823921294411734754410101784488461619626709921438152802456939973062664785225012143934331889799,4842930041539855168687038988064672735299822426110477068456048664905860352357714516947904490608028837909248553441379667434556094182419426407119/265893343472451258324636077669494024928426108010678372017778107080967897437322685458958197998756063193943398691196213942301025776047715843431,72542185415248625496426397841475880749262878597593418266923264362752364758624696443102923218482052621946801956929875779085516725420179711616/315659051864642761306983115132316095632110779869130961375555866251241442095467394347974688218612544312496392858420449028729998728890282243,313099245326485134784924369665142221854576218523147468608508080045845131431577160730187440542058160329841807834336760067455961875226664117152/58480375858089060273353513187057644540566102636958713419347013485151318351731879212050642419339726397966730595629810251668791791230495939665,-29655049031565870152249693139778156037578856438607084457586614428447851286447158395551594007819098806724663607407406004386478024039652510752/390205553484677759274938186880285588316896536951099490126159693420627123059160584403364645003664020856057849032665565138389709610641586295805,110689989709252389988104205141648310589107008659712215371986863678670526797673704409654360975567977562091015358051347180854421833996518271232/75386640353766517128588966486686450456915640311343804017587807314067380558198742456476114196854674924948350911532702667644091808887750437331,739321559754069707609455174076322916075866959871435448089822261411514677797057235425578822596195485059749976792656426877240176081854209502848/153872514897805482420971391899161924091772006031127107781631703356510218035700568333099310276055429480690103148518750589430337003387877337907,26226295959086160689653498713386558709099662210793773979829067288603315501186089540632457357217595504255491054708663446459749505990411368523904/6364639163199692710981713186972077585660109492726665622737192802121779089804549155613206736738180083116025540149455411047118669956979533513407,18564104559440061136487498296292663569172187071496769970170073197230510385883090550045751205051466121392989366038833466754609567710526187460480/2011355276106377564611395365461707168814928884020375241274659261578875414427957772809375443718214113317305093145027748712972277497871436138943,1597807488369672025900121559648936220138941905812279739500219749930240893768867344784535270575874752832464208444903858879837003486311141449184/129112691897903040468734523478467958705384579619483674911331451040642979654042161225970030154621426838126949417797422866299247097598219968709,18071075502556212277725793904951139084942109710106468200545370216189313466292549139746340398802530138479948069686870290936259223504389365896557/2293734411275141305338095916009997772991756907947930173916005286813848335597666177860258639046687336199189732170251605435449853080399440404094,1325695943444129981581776492974357739230799148264606891910049633762937295597943096199181459916979607917370793706254597097440840732149370233383/219294559611528207647685937593130115300456289141863320080330737712041709981490733772286061353967986069673799126239527996262241527556265232896,21536725416141567579087391946652377975464148722776870003201880108744392916413359889556095470046283024824121196843124991791974222836680958646400/22658182796958838339859052663821573686875091056251691422495504943839014016333921826830238678374403135420868172101722352310634373158938094533147,17401739390020187593679036449312811891446816164693992732758408622396717698867005800888580994477806042660042038502787784906572270412347894268416/18310316399163725945534887690700076722397661822014791492706892791304294013638555723016480996091426475377680543733303454430067505772077273732849,31806000114840879302083868708285327780307398080625500019335498317595133019988916108000007123261636945981284632512358580194799549893064706538955/7908658324611578478594354191276635666523724643843749658101094239201723998807895996254896042762106121416563948234593760716036997794906733826752,2375968785873126134087927481326473480021771235770440440809350438114462652856838629943804279341599094700615642460149303628399021683375269921912/4147026654255370266840980478408507795555470836220563182402525938337340721215492789380862741963274086819419902542820889529820822410327036619,8567877262196256867508115967196856963155271531429397006013122507135374220558742982716016711879115749067164578570076392189276346728515572496256/1460923797636494097510607587323089005623811885510024711069651379215653741485358301300540241790064157856750381089054644328168779508935404461741,2490817300101260018569755131116271923645769151394567626550385637581218195164053660870445243897766562852606948647303167143740186864923883783106/399112255204963677669238280834084838917356980942524306857014408806222027734054480451455350548142306453021813138412130816824130104797318264221,732171498954821179002074732286994018217334618914168425836455542932517122089384785874121694598633169741758742241994819427925445852331251693824/73753486784869476001595526506074798962743781168108191222809271175049993326036017132064544923919169198434860143557409961420980722770938093187,2703584358239569269181644965593540204618781113049515338255319909362783770501356267600004216194138988959982925362398161542851389321027808797802/426177340648027576953800630616298192008328326699572636433844127261945907773291639544456784725696239096241575634929792058329535128737147252293,3901173958582864058410045214060087524765330887748900855638182348864864479647150221608905447250338432514344652943796107592182488690919732400806/354439495181924910914453751655887993964730399766037044447571055388859656312484393844039097862070282314471817504711182706932676513087172074319,42315516163126944433215323310838663468323850144643450076103735154099039178148431361394045307483401575664904439742318943717852808521557951044728/2634166188119441650456706605539882024716047982757724874216189280720983351918198787710935847802021931478162740580193142514485069985613027384821,8892558598330708335521611776896755655750966286800483292696777918849162768859837203854901931376159561342553301026917966580530121518325172327740/2164117472936990197844405528325368630271012822660151861287685806348720503502289935965999456773293538656492865986927297125056068519510290918707,3154762655691889251682318650282432239777517095032977963765199394318232693406574160113613238036593670726637810126947216221237220640972061744896/2895474799043733819780580188191306328078520764376814686597767055024828931055177684450360231696214550707174556865568510765809219488870591201573,315563039224343307888259689566397322273672519085399970948515493276504419648652016079941643341679821119512893292416767878720581727708588794112/163761130776031835300375258817819103585899120472890627565694391717705531085340669002142279214539638013326324240761722861113791698662325889779,582128963269556024891145899448884262393150754033264728512640614998710892711764311588378012436814318068411162360155788007215656070512865431808/383425428723993202058798905138965726436451214720848335777397509264857593847634582876896516427538761366356492883792660631412873058539731130411,172974796302742597496039745169927669641913546117494738129830421020684088048701462025101569427903360044958301445822228178086952425724511268096/83513753329805455354731594626196458671045436060160715925286903010330538585673156545281037932739986794505783616796667443438525659034061025807,545851964839383900760977049817734278185892973215973685600733264300471046692003468756932147388960552944427297760603810204512599906617263802112/187807692456474619592480920592299856965860540338566369190495848578533841630371103915809959842327503773100382913929562026407469263526332684029,-2506247620409398291081814218937969701245662313235570644746909389084896550677455506292104662346689990724399730078048494100244313554017553965009/1320169179306174940254856540401359433277165819119468015264218772384228697394354841230508994311008402939262572225809193823768650161869963878016,-5176730477759277767841319080699310360045567305341730166487836047532993579902112938604907775295608552746456073926591212801981366254748289067989/2222093035021780344638248824099918896542074273771624005125923655291342331128904014476720201908820819462628334186158519656915758640662316814336,-4949838769802613090391238924716521684779614160418267570811416756357752074554227596333267029494594360653551091585378177291451098943599775579/16441490474968740749209074523063473671229437314858053778776490371637656261009218543886534962543392530243212910011845182343922773316250669280,-185527836266932738445318307358266465877255830396777989442430889328904989042201635037268990570414011440435989128325237408245332030127193678667/178081628112198581641958572175298108361806889380228227303366141016700856689907376026368030580960899639960678168144320318799278388228728798868,-3618297791629385035466898265853689878303853171761093783165764100333599905938894838343967601195325080650488625817460801128593554204255081417/2365221937159540134783256477488419532215760700290095791083968278228033470401487382778600913062621185752292915647470736375981262641246574730,-120832395996806139701249368953689384779981400669124667560547899311501764267512744770768365871425259647208602903624704141638229346155478704799/113776307188308386915845211217050675914022306688299779621453396163602206028436318668962792522775840728471516299355097597978913500122729148336,-48445556690964981696471788508852573984762118891685505671076408014132485665723418429957693453484281454829504581354616066588281302361275487003/29539793004457899487536755659249529560537755737877419812271220192978974774996411781958576933982094827936160246338591138463269056135137620657,-58148815239680698987121632098976364282364142397892478319673780579884967601998505400306104716952096458986762461075209425396914605249723295399/53491795759531534439835711385541757477469043206572606565616547649312416541948792478241786680525972346096476285382327820854855075543266300956,262022541352164088122037373360380819853267235878928741756828044715255004915122653804121478216126050035573564024256409750165799982627957056759/319865360687306188073603688253169872463523261108380761636739072238480573672062083720696409310628455939462139820089368722774580735278822674964,36054458424738320447422814867267481240390399365452373781606845393564063269446019219456519662020973336998335685211741226916036953173189083647/153697134206621770042813082546827694768107516744156320425287739955050283644073403031371941903976598372128099445971987098334087910571226817958,-216684706679505250465280034554144635376656540278563452736418938129723171266599038572230638238387531224531970232226519826422809125963310067213/328407327378328890783191242171867448754405263766523805974840855555932687138015944714918019529174280473234841723475587352468188664207559777392,-1490949646802977659083402382981751506817796341871682317315850262898713908412316880332083025613277309925328711599466164187500955137782448016783/1106109034955455007426171043379710435694897648061028945559276399392861526960228044308508412497016786524020586713822920956388072650394847410312,-1484050344364597911456493043448706520404562425616976676433805342983065924475655654745338270209569299898225619997252975989506159118250964812833/1497153637144033043951087163393413828623055800578027788000658967608924313218217659780429972020400059472969726347979152214790609404259764456336,682373793520034926998039451975898782638513417389293800781217515519269542869842379725850153290560098071860092030254737069646800835052262836137/680603178368862689471234804819107362154287326162823998056120469916376332819937909836880712317442966369526430942380489228721866800295459992624,417121626159595359833315809985005715081729752540365711758640073610033348894646344744771652332977712052922894880609756052493217037301155688103/433141429405418199564742880016301875575143363052790541704076057120342715339889292108596863483949632744345525816754051283530525647683952014970,8583939881674072139945622978942476398192560063344905785575790648540217549401493832950545384210559418737550644903859350053197552037705089183/17967018390371415024429802969652830909278696143966159311348102391266695937635187496822967289721311462852613160396670063596395909563711597650,1181318182035840414584145765807397754942709004436111733753219468959771923155174332830750484186135685668448204876030889008257212360845980885293/709051436110862069354605375745141599720351311300888345584903942623163377298629070665713781201775229164666551190359228959605361342929472444448,119827769014383540728645596660184877764573612190922185348117295082635416313121100030232380807003043425405465222557433131830156595565968808037/482322543641033798116389577697576324819018521094499628874112704813312523923828269646159228664523491039747154754863505402533368200923549860190,289038590435747177520968630410550937785551618599370002981749649259387666913706040371436870428900971423727269526134071324583329993339839544972/352096043149537577292280044955296478455131278423568982440377566638565552273479317221404481249658944232847152119177012225052020579942257420417,9039276245802232393755739120989537203095814245864821663179675800276206091026921648020100895078208602582274937100648706038276430576213314844/18544290072860555126391524559844543489082657474172361194359281232181712303684309935664647479811220494973311131247928146388690847164599318183,-2825568515012113344773074622795431582286712718281640431062237081024572186505717652534375385847445710324657925937733807356964111608662021881/61087837451692909233109186374433788238208181591518679599188764548535309699992297143230367050416089369981295950453796992832422980664182896472,20111100829236154221451035525616301918193401004383620808707970963916288814450167601429985509774996743596061201192227624260522382634522554057/201767498523959503648863283657096701095682527828968503538759381676811971925976785506174780063443088581583894665368750331662891909960325799369,-17432788700968379738212936117479466660285971434344528935079454655805984574159442489942473515231795063244324208009417476077514016162823825559/19488007535777654335067582366627925238482989095164545592681571988719663969128520911942083490610583737686538890421586147568711242567765201389,-58158281038783720758958780630464275349891520173231966706241023433283706671613668247548429234309872109087233537825309748831476002113965391401/82309442800283115566886198468324067093115373408388191430497503708942566092396228481120576363437943781230291076624655482450246531860678550608,-9296429363361300083053609291513071358907108052645015559988878323215713223524513568451164949319415493134274605541704312372974866584883362999/9510528171656777138291675112525859945187896594578834882996240181179575596415209656817153673231113557975910114278137903354746080590435535604,-25796780481961827696354043257087655130451986399106619868394039970840127009860416392797226533888491305317376782058402062635660297647215510921/21750961832124827689882968925416282161701434856616389399038675623751242300117902372086004660097279380960080136246379167931971055738848000066,-354060151958627531008886016879568016079298466836599633906721261723619884448172369787984979519548776881361190185595814987074974316906066561981/316400086129440683078240471978227357613983690888403377372359963513415014352159526368103444475525277069377475041181105029063484491793757706076,-6315728854911815263721396978728703756137701107849494212314061319742236168196664405072114999358442394068393796677197063228390700564047950997889/6507701210089629671176235301713641934382248858480278027039647640988039099114914713536160313998511626270622834207438946112816302548857775838444,5582128758173811403242128918491584703765628001107840263346643644762422410050616186662941455921268523206601664500872913109294595521928672539641/9518639532967075051839180170556452996982364434005644967436631697369612792143540886138448351321597400298647834587140204006281051294244632281693,989364517835180291798837885349868666061327006839291567684467216329887035404663317192969947407503893729094706143894505130777388506783346119551/1857280962402419644925118490436413964855595132471408566556748836315588505404784432775208403583156080536863902999053989114899371292579736473551,3272697031188628148476048772312927989494756371550967529403094811827942190070264834896333846181826817161518336657743211955231609669820607610517/6566378595748070868620076143995951627632085400349937023240228889188088153313877593665603519930207602683314749324256112686228251474035821626509,135953225842081701910742203965689976396550915344382802590644455484717953616245090781450396105452067334447797406934441016390838949955631924004/270058168524173478067779318962815558687046902189990685220891154631487350452410822589310387295575300713947125600623667652681520914797388267569,-20802385579953271582750825974064425711234478573785285541949708252197940045747264451463477934827210218042043382224709048098395062716707353015/19111847314141983056003169472778096567864012315093511041915238980400243463650354509850210270338848719667372387338254417670085641501698193563,-732031303797986375875389556578472510156810603312316357697764619557755161350076336375565497550790456855351933768357939001963673741478843131705/679527017098489280201737731986164288515338335855843549190283786521469229731522081615410589349937382051047514053528474308100213933582772098437,-111655641090321255880573584521231578555473913922565884176584005892076078086801229445487764164748721939965414154097323987476416962017680183595/114144357412211187285443901015793038465931210842909040624716602928346644638109532712678205973887393890853092582264064912820378993926810094831,-70240695308941634110957862826749645070297888865423020430021408973596412696488273125160080155370904552915461014626493647943528510079681762227/87843369844664853638953538050053149377118266270705355719783228146613255263436661687158110828110489686804446069535201526378763871978540081415,86485059503819193865465071023787833568917701515677982995274978203689383559464021378638428885326227426910010582202997353062273508016234142493/270488851008647232752023379725956464859238367726669725777607464639961385925979390869503242462507861559737147290878257914789589433081865038581,195322352169574549337319972507412827711228009370692969907132929281386059592417901430504534431563509745979919106437225270083368862756065821529/461491215997801510227178276749021335714326421028819578882052238105172661562413461723856010972423379401086799363309342175346433159498202028447,59110639567636949755083011841742171131691773223468023789710003665314897789269119660154451917069298128860172739314364099918789880622045294/8189490301894538345033676478750140944517001290204982269337149585586426203615321990526294802818691854095072439727969153334779142637993064805,-1359235682327875088657096303737199791363595935652977024186746381985707287995957666819598313560581906891938570084145216044089748258612372604285/1509752864749177987944164185231941434014986555875585489870125064000918208895046544923900226469253025993350665779498357290614497654530171440138,-187203484379101501384937646560485855894367435523352153432522758774469025427649532899591976726054937924576602617835814723842122807123670028855/206567253403451712673912365853554300426893795548855593167316336168163460171020900003457298743281296715849815541826698943732440210503567580594,-705841699924820469735332300166035570723320219498103232067334056952339362544012720292489157082322877470750821909514970402576824317423441093/6697067918861160156998708049979978521852127899730532969720862201056792346606396737549167592042068481550621172762051988314569784674308012743,-406761566530957167206045090811502332576565781957034921089143016321407338997309838101535158988850221980562897878547294851596415327945551178155/510205387303974425833028404482369049154396813418844236101826719897234590275447417621777651421184514741924939523490775366094275253395616054979,-319497647264275544129092657874614467645097099749582513466217312862564634807123469686188077044405574079396538918506861317832276620892883856505/958112232555936299490417663926442286233453225726745459079967127273506130166648181706653523784270516209845856396965433243138390041834763114072,414916041147500176985687800971453449988198580474578315401935178172285351307973435191475170484137063174504679357446255145030537729533289458722/724859687198824419445878412067721831121757884286150267294012595545631548018772494510461317533914410880725127459667878990088835911777452515407,27808098097162531066838523460698162226568081587246241152089508198312089665964998208696464441119101489157228914367773105767383653648100678045/77745349617566538206019896928669163830242106173220615974619866350900337602249646703838760312129873298229792970866250300915591572725354726141,432716537847993224860547591049994157739228332189729057817005980964636318541395980625365884286143117139515161551416096014692436331544024100067/278715830438365591982789026476471578490745730677585510403584736146378649622805752782507092510072084621717123711651083853002264308300149256359,5614599136851523492024294294743562998735926973238047878121648069433592507421219576835427639434113425086569671870035171227677645870254171207/20151164692508455809111709277517722325118060220925180549536729731576905915986646241252308951906028935141021878457603074818619602867705956452,622851997163934387723672609197657276850750595121769693274382633462248510764385581485657416913533956961935353388217747836015830868422926173489/252964417111506079401777755358225209675669460247263291927180785641809123850295895597645055208599435790177609555680416243908794792478161989262,136673410607438577566793299167753921050120123820050819735620630021763542361638891772462450413862946890793826616344124861856268468994603903423/13979848129608024885218173687055270914684486494783320886249554812084981625955558777429606561170153984866798518066058556742702441936281803366,3116376590229387561717083261384569757791247155895106756692575463221785678268563691817639800960778927944004201176834387568327177616489801437/357896362418432701584675193131434492077549692475270858645020858182403446427470122475345855495375767483885300320887946644820319330527484724,-58324061054206979095514524323483713703062097090345709606453254328127677668127820163809810424570633245428912792852597805208492672620433091493/15004954476557667132030694776120284152224672340602847250053656799808260431485010895959024073515101299069504572870803943259713330723740483401,165493203852634982418327752103641546745520354208484887837789623063123749923857122345937677460369250108346640057038998595909332441124327143787/12600058646972090691524265465129714705593416364471191115201232807764744715159567603960912238077188694090420583724128172988502063359401849413,696900893717489532923357955399353625077106710199325938872914747489314597064973987537298444225154588559880044487040295206580968466741897077653/299951527652630931054134420525492241998289184349410293454902996038076471827086762106231005384646148588669633527117578092159252400791262200296,221585645968041913301147561923426923134383439467434155049398341488317870291080900024850026196220242594186965623462764089171982582787176051085/687216427637022846749073151396017298099046694911393835311859713945636904131640999135966966693615983525779770565051069562128096984095558817363,-2442905983044320435372569105593693502533584494675250573473928092692830033677527121852614188879701340243746802164060220427083576149788615517/5727838643652807775316686571131466818046609444150665658577545035722086911060211303652128723605834396724249780881063836071160277274914209270,2451653965561928552608406209316134502353861426825927568640830494300388262063192850455699869187859351440725045184601088869871668409308420681/54419241292541925423178915679069680978843138538651183367233923585739074245358987359701122461550979654605690780564849343324748948233930918232,52784983122173687547038571208861313023045840761563889669855652719952147239320596422522949150686300256167304621708966414873870705574001749341/1261497121393283123884074287472435313364499874928817732249703547957238920163256922857887277040768379832267118105096299899818056517007545821916,20046722711700111243799518741418370122391902402014083532860193132857388325149206131939241648654643145039416602070651112592144915502564858869/9171155713704306765112840695161081279140549512961764272105794917160200700933677609601318087081696973393825916888912667803695825995864340298,138801528402644374871354886263776200838728893823265460848591960606220031245429765129912905586610843621670221936742028599561588946094728784197/53136938696541373521432652157187735989595654814632430124591873351827838320601387288933282135802230223274679609374158540408626606257098203796,10213631032306578278289516385253172595873416898951665575392567003160523196259581625261376343371090720312479696157040540887352158846557532467/890188396743772821522907102441691164605765512309081331930088860106474594612841106760103949966011894082577515610499249187602293142560007244,3679716150577280450848128195836034418488269237839878107305966922074050059847467291845977596042037799469264259460694846206951572489883193127/2950097705949738038357310028915113157511635217382031603316989771745312826187510991847834028246959103601093964862791697008016037999329649408,8947276597795950939846723868662017608179257170600282434281317760510926538177920327446480862711439404348558305584634594987821800219476857126/4837977426235291722143423880292898699470650846890344424721021453533973496377342332499745904421794212909305163834243451521602805298258451913,201915480851972347677285416934172951813005374658299445900548544785991346541054847504295387294363573344582561424000254667087164525272058431545/109979366304581212405738556148095696218771326531427979645826510788245850611119729289631805446346847335096730359465673049279427922606798162048,595752770953426444492020582236724015605134240536710600066106547693110342006724419562148709473721573441749758454400860588695220874963603671383/305160053051598516412266564293370118211777700452067262543813252807165284623505962267791490097718914161571074327336856482953880669283700513026,1787250002915400758442770810700335525390653855519785586343804635875892352102827462143658242382127422401336240017975130090503818920298307/916443391021192011433289409437953176624976403070142508599683857280192057308045749451462656963680063789623152658319556548775099144051853,177906134392569810509763037981304818217754790289178702731232662896938058341258819547963294461057873856058670053730591755531625917163947654209/99595582316516944473479122826987843544819147501387641417815176264127813775236981230958629193876970332947240148146104329836833948634869176110,100512255898543788398492589448912094996232404022855278208300644527658250168464643863677809158863538359643671078010576403991006777696705280851/339878630471322462373894858374377643192824330875494122454792684494442668797192372760547853082357719997224369197999545021948388481679191901012,-667377019685172388018086519579784918539233961769755127651075505845606057698775737769809840204050681399681205682918262248630664606755535885583/1070463669901027389572617163191356053081534240737340251387852991488359406050972689191272680870195985534566346416493207632603868821288537436920,28761552783880880443474867223485381259640615397907534040417836753634186390810406336143643388489758554048789137906960197189011207531077638363/324315802989358330172593428434040636400358103407251982734502117381085054375616778613990270510950256008541702417280981708749944510327271439180,-15797605823898539684886341517562465560978551025861250296580807604419230556688160862434822090454982888146647136006081416595166500925411368227/37369776715519868126408597245310765718398802156518205569662638257080186313990536798420631616497746383173290089793491764294162443959032488772,-473090568253905051322616733294709935676232535222836178526016422808115093881522697624880406770365542155868016967542137962297879665444271314607/573333471300146280217853128869635924798822064915445892922155401207947902687894404330088877390610634080888142698524778237044106949902079119760,507832190926746913575473143072607581341717338979625711282099239978680906303419141258158049293713877085830719615219996483687509980510126827/622679511154983478322863204919580192893691904422286363903608242336602744320970609131397855516455853423924880382144482941407531767178822656,31357908446995932575462458349767892462937078430661304413382439603500082460893243070793076587523883548994340558805575536314457849236868313223/44223371412075755836084315023389348708554069114234449675453331393470620074985650045366868562064528588577104049939462623230470179985118252352,251063085000971953103029090455332666107793995575152641838648354340203332859087700761722408565409703684684255043784012579000712002989828309891/72056114738729981263106579205257170196134006704265194397346948678295956357112461856552112801384807589042273151870765965713089825457104740768,-482656561268987315916228091629187374883653645234375812526965843962711249986253048788915068199673914762470706119952366241252353555424275263591/306355550802414094910147115891339083703638461324848543089857545870209207234326947692083109871725923652773235413961467678488727250148134466064,-1283813721817775580883046243600521589943491362901917726962911895524672679284775367524125148476207620135235643098403196953244714027061164222037/434807366282935511411944974281994858753775443520271802337036831262191936223645715160613209303813198043252709620271246456611619924207385251424,-2868676762720382949170722431448474217708148461663139282495267428616726026963882469790801400734057041485629523178072188466830812023727376058817/1151184601450839004488328600062330055467167617501084770819392505616436348731328511824666480069069417084972023349603090386548090073399321493504,216990727477159660672766117128986165337721179256470373581943645876730536115766650013895991784354239207438111779083827118955714995627224736493/62821778151889738200661183098585045986639604793854033842140015981126039298221861453480277255451587277971109376858816333202875896440088343648,2726123819634063672758703235496821657447725005390847297465655281770546246551884809011680951942977956604825555127798321759713079773605660066577/757440357886968437717727794433359986968374670185491325354406766329215038219689951898135778476477864545334488574203206985396298860152535752672,-69800071226051708575049324715324390508330803822145252447727882022622748264100496177046911048290848064826794666873565749528731636035084626087/128986547478692632631758641197210648292839252300372832950477597247430010260436111913470529046297699494047631569795098065196747412352246645568,-25168714459292348437246171301784836838391489491811407728496822925809774202008303667024677232924689420885192848764375746379421127366776394065/49245442295724311323628552053705354016600333684759201272935677826043935202174114387497421438156757194690373508277752673294290734676648170378,-348380565298499500604288165027599256394023249469992385997737212603323243847618127745020081418824962854807780538329912718411304529817555485507/452228156808183938751638478393044536117025573966199996720436848556760704327782479106231652345220547395823591302633122282267139299721439056512,-1173301901313110025502476526379500192757370760535090217170739286739754292506370083167576634331365455156496380096658255532134087610386347973227/1442561273801823047280957871196511614436040574344276595367821968877197357454534544299308272103519032846909608961326552678012946988197834935392,57184567727647124719319254884831303422415325668242023961383721595063176827143540556757804472206833508077028982970034581619535794794528727735/86446492361201299373660107663399551334693954499590767509770630558249943197225356168617219665472263650507038557524813346016157162624056745928,-123223938721857108755884298601160599987808412994555128873288744253984179302112911996373119368240792233579618217739852597247295579071497845824/121473684717542666084764436092215640771277353504515667776096118902838240355173874721308180010125673158611096571734872350585062644206640304959,-405512101128529188695142757067210604538435794044924509891596000319426847340523916824822226506413111349261450228438378803748082310594244401049/432544195158141474578508710917625623380964530317449404605016526424590200639285267105823191605585108151189160983376984390210670369221458311264,-72010783970220390842969460117156606156210866674549162163948906292814366839302371598501477068011229301586392126781570898422399438868661253209/77077004474060883790391475044677403584341746274522364224330641008748478113170711171872427793462376214305638604402985229250598054861956370744,-95182460889509420368454733061150606575966177577658329585731707553110119687586762426055229132852841241734934492539343774520718452990443362512/137920690107714037293504778525879956941957969779526700137038879293604434679988156537662109094298019059584387611412949036393779555950895787721,-1592867494459342052863664019830705266777617490666066079959319329618281782256609827785802832765619298342107100610682732277553752984631535040819/989204742626192332457115177296576667689785324613733308985250288749503676007747650617754695544345318510365694043893547737043169991978337455904,-343912758545011614874997349445644917445758989740004398070560955840184557510655421213600459656982530042115459922842108834967285596180762178848/484833001705828107107526761930540942805965648390719452642229908507676294380893657102895335554208916602827255435968459373857468975314258116013,-5805595934740131400866345129002600608002621891069764150781515283523135954068070936638228871330583136635621190143377191167108194113205629951616/3338506963924372504564268650259404754005455973512315740948290573652475985720445204687951213980945668251032404853429488095524386203046431739689,-3303491796337922579053903722875193747754620262044690213460577158837688257597740403223281915186183023650892057284878304660517018964088484849039/1957881856256778741961677402478525611056157627157476280954112794262269580245777004069748168769051595886745998502770833107494380411845323525824,-1430001747560500234577241646488288670605249226900699547687144373026643439514389992278618122447725563234804241738492285029667185933614101510863/783818601159184240240479699349380692765228642178054320519065624975771571949443608673943763414419429065373164163669559628669183676551190125848,-2549147593035203739363222618261276508859005223741590938260080109699236276485293913022989237592824159952772550078054192121473691622917659287477/1420578216458334666790735378817298755525243503289113353152138020511451980292177805831321049238624343536029956896876780050601965313245760823072,-200375203081397756591518792693750146025572646775733124654075234952488769439021714345408692493275357843097999403501789427378616370307549077708/112284319621912947876735095527436976077983479087562327545942407756764719267231456985667979931308449601940845593289050215311012906473979810809,7510654862991442954448251270533605742195511275169267791224421847830934149426863069969282041627319933542167447558405442936476615527580436415893/3414211011537676784611294864812362885096938816408270316318524140123008039504126878426012100501519157429249615059118990029114626231827309428637,7760156255799261058545897694668914108379097913494236562233411233172881639972324878105140048574769651218902918623257202350058574294747035407560/3117090431297659443344492179668119078946390809703048946372803772598208679538188312603018139028931447755729911826841258932493069102089181672669,1320749429373647700839177260542011124463174925326600431718515565903094598216355697098050885963905210953614389344703096988633238381606496380928/555479102171525687044468671929323947590836013273595404825356467305164922820100174290039884926815552676984713482087021335047853434145155956461,-8186455349646280598190370763778580159260183307381769814822590032138027874827037133799380801048861812825218315982743699256434881256872070110619/4442714133385665600202149235037557807378964206731366323005270576260051251075222951918697898027932134799426339181844540348861162459593453300672,-1145103809021902624882790980430367523936847823234936451687724267092348896526882032496108876664039839566212293714476581687327729935965086647643/629830972509951837364737488737358471395337097522263850642927462820376562932602824082235175840942628813130099116802945529373105370415480642086,-17986585875957141590356222081597565608690657802506418460035333887882656515844696890452192842505715688477129815995755539234853995126471940306607/9673294710774978469536971701489573536382094588789858242739059301531780757976742207619909345083572057176268686247366308229697651697895049476416,-34737304056131787769600908073775650207084807100911969910748094663344665025344589752021116457335187518246610138956496048590453818046327353741409/22022585739130039470848534724578286244932831336582201405168083582465787229488809579386538391314087175588417615572392338545503206282755305795968,-14115103763267632660886619344405310465934251494753724060605092947642513972980651024959532463047718997393486214798120228649694408448911137821265/6212680213084468546549960321563410045655161752799040966565607964669960988649334669478620055979983835265617350500524661748351900687076789751424,-641253376299142993783606563649185424594104526565285934455782224699903656882888269963274102051245977868092902575600061685413859472484325885693/270514210698905245810713123005489338219698581937323361003687947231898507117257235159347582746655390546459791232849245917495086862776225696816,4534967664283931425034661911803122116272553367654232696529073564739166778106748692835098772942406325718657627735767357968580346360539851443923/1872456330832390807434789709888304074509782060425505630306134660355635046699642770246415800781687312596597455534692601404165444886380750529824,3363812887080664199320277477011356170488514010534820918788499898527185830455198088728088829194888618517140744088798538641085751085340503870139/11133955522385317530672691854189752322989648157618697368382910548198996385523713846018871498669726217556513493458858119639146173054590314878432,-6950611319677304884815533511976885592017421427035368485217788518838586230642034837327219415227966559677284450634488633735337563575951096413167/9769392500057332514611682115393469768558010102426338790461740666475429375484100398086904401224979957116099032188660515557065652329020734628112,159414267042316861698701087665831347506010875309833171811921657044337469483409585518987291876232172875334278850318405446780473426441820522189/273286970368435099956394450544235725799875784728991029230735519989679986248065630929807342401965698194924334665352557936520725052283424041472,20697936362899171678203216210306188630497257128953859431682906752525832983770706918494582834479510555789575380945078255959892250047999840263/30123205792501142607966765075774692091403918014443714956564386491791136037717376636814409905836939067813735539423224841980216257262420108276,-270140480387419326326637869578133546550914595189747475507089013940406045767272592709500130425814202561029990875675259541608821280708678291765/70860898039808464143301835384677182148868779595607717633665598778166656492345517946657401371978895906698359680599704093954058322492559130784,-1805717622356575952327954866981346508144879435250097148153925277037693198190455618600385366368971389216541406273011082084120373163533225014367/332028364296981015949860567388667514395666148664760320328563785883960047834223796421507125215216329477238449046377798149682460717186449719776,-720233826806117696200610808478102835707663892909532042503595619756905995945304415590684683799865740909338903118456550326319143693754993009525/649474548829967691393352412161203091856800744296798063737248200699121303971893895382621918374666922538871737063997000849674351924749628414912,6264236366587673191120923329179228687628564114898841568851140628482333749474026640292855569626256052376874869261341599515277511196570248083/3534200944347505745451820709189072692937797834010745537919783043950127783356319641866215774891885326692646527016986748813168669755833356565,-260588416761261833022256159053063111692119784168277124965771546510444340483521480220805396418679377620965770662923705941618689044844203554575/223165498350813436755414777097271018644017049980173402757017380648515364342956293694381757053137278463835334070739695150643044777932968949696,18517917145860854253309723185780800887471058663038287934466997333032053721637179192368285976956277265912643740605421620250605792637506762711/25188138811166152285732798165312125517593240854525544178978735371626485716577353083976940258673393664290076119805247047540129854757359960152,-976339615597189143877118151438864458044918356678567157889068488591316776950061195977417682522218070847478228062218927988535678778060485682459/1428567843867328987854451579627799667160618541567215134365523981175765820137188981874925446753422428191517854408374592129258272031572614707328,-2343076232946077584822503462617001145549316004790698519235344397805171544308919849759982777360193513250813865174378514152784522067922654660831/1524998907339021170915752101679422789278916860882386345583993460292259815173462194404759717777104350871299637594570213283681315428105984398592,-6126945765150527932219106043851884919610774231267807081091611334012235897250972310159163595452613673462106398745501559614018709127775058324439/4149880114553908967499370590717558347761965964908885639820267830586998443046934519177802134522240725674678895430550463923124375205910855485760,-2233503244580030465793196911723204970010550689696264013400955496896157110655691487308768319797978884160529057634072529331222778177782727483577/1622375433807406427363005118008825919636454873071839353658821092614884119347132196135290966114262609673322609246162335194965306038502032025640,-7698845404387371027500939839997326564681259653507148441426226913758009250856595312772026821344829326241496655540507169929722007047324974124347/8916347029966908257527389056418779599179696785488268078516215500473641903450499344446196872710995072065869023546277371193356109489746271395040,57517377444172661796836593551055885099025532923037844187751547478683179692145277455474513817450132555375912596500883470019748549531996550464/1282545483901267319812332825722315953274428714844934304463603381501761890625568085067111841947752632347893947576469001520697150144811767059009,-119275391590371986350056895228938204104808622475932129791393035329715571105323781529057699474581600805158014086404735900545646221852734392044/122981970582914559258966754889349236780898007887386751645472402271997285388720527432260897138255459028747207646180043134032150704544230175013,-3084753180717581958528862278499735918040889634083907523764076726200772488956818075765118462445114909423516079620783006780020209315570339346304/1826364055884736338146401612955306218886872031187327515633740175700441809955380765398647722105041472702401267408919496305659073925178955420443,12365568205856547160252090769611715024112767464246996286053779359614803215477502681733256408707499643430623350235497279851157837208110402980352/41936555493231021587660059773324793924812953686181246305031125564645104597282204396914110192548215784154594474352005229491097454520217212402203,-2167618156307548572381375955713604643065978753634000045823383613712500581029215611250510752308241327369376956096249105694321337398684478073216/11456724038086870841596326060542792128626347431619399736898388753356445527998959731428894900946272375376652026178366544705455297146628322146081,14720959919756529282727077210058229402111640092829541230906185840369666215749661345085756475018766586731821729535017908829011180903439339291136/70719502732441701473958505977458179917577354061939696675401501782211583252203798181962946853949710353801688269163754740230540882829383561953899,-1937329170117871774868100832540604731994645492368030289030700635476442897932647660613933089769774091338746518510902339823455910334584818914304/20095086734173004841254419606812558943590360071764463614264710823346524429476628772198404699112422469407641553981023777645871213982731671124911,-6659168478822850607764461990759101033843341172071724564893764769933453216953335333868454277972453628659434514288056645234738171992005803068416/11313422905855691689575929503162074375168113045834773591930258954161248684141103648193208197438606122353916691359999940500857823282219538622279,-4940509031736168939293354356860942093493568117744632084252234625502724800982446145389732874816580454596214475421178730183635454843180776714496/8927341892662102484997891598953326502268077629038177958530513887560842033217586023663352144590583073862800821611441996373162182634425652966717,-17787960253571055163000364664164907422715835170103039231574001241207080162032697337021313658735155449813082305449783313720120070456563608378624/25349724460723831486698965235851340665572913528560702467038595457631578966174633497955340494813516592130226142270025719187917175288103788094873,-623929560466135824420356093015912907703414151651733620402626363003068059058761655307435058863591195831625711577378625944163439776440093049856/3911833647786773472124295914582302775650973607266751486579707636655504208049037762646365598061149850989713210571828307096686911981022837868207,-4790174058941749754994889156079330979041543228084577285994285407663787329393326592073601167418960486465119689467121787995236003942320667965019/6136658587341508037117214926582393262241351135331680275846503628878641631790408829469132776568852580769750984846274904299722459666100092968000,-20186425919009690784380954171512487872809133740518428264724284063101511737442898579359538445573790130598362431286423444079124691078397716293/28874259231924590080416451163421443301925749281853464121678156468079265976406327500848857596810880756677516456322935673605489644709797496539,-9865901531121961520013012248614949836654979430377858757777251116348098560811165780904297344257599524115449148204974001439956987627321957877/39667606709327383794140131990916704374653162774027657721551249073509692819591430205001863192172518595527437606692607655590954979327749435611,-3970801304510528946839817559280071727400179097922776691811424607679447637500423720803572324172773504218636697716929908638879890651997640481/5676158039020845185449609302925971239406463214076334682708686998032746485111713855170219968154261534818743150174655740273946527487282622445,-354612354472097889814589032718750033647232380743297699655676500332577502465540563208587012310633209610920739648696558108765356257460279613367/521038016961988161790729698738736253036185274643266984742355768076876665909131110967476911805612724946135977625624112113423902530292507408742,-19576835248239181455595981728029624169345217378225397391734365579569896932569991791678293929557190014909415520594147516709981204961183308123/31235383697876015117577280123539248933026056554258970071485112124004669517660598911083498710115340171450351726735173187381616801008568564115,-862978433901592250868167876389569322500988660254972267090674019711606498694934927596797052903559153421010734951744893486969249457766303008659/1367458738522973925165367697195309034329015070729309054477197693950527355759554062168268964245626137378150857550932155711979710238785863739950,27957587299231922411416944206403529227220106902847190061038892716118125980097330039480781846437678832334449276775632424441954553993936701121/56807667042386414499944260425451791316102126009197504550398800805429518236480157561608394413883979382378731478394625214035748562357557264496,377453240750977684142248551106154523258242016228516019872153758189411595713427630146842691719776467541446403107973301484491388160313774984243/1467285626659881324995549663302614695518300241693550315532725750415323598334096391934379928881445424124763625736994893012073441997152006496183,-387545046302671491810058985827729345432476785554058540714847433142708792649474923609343320577965370379357160338964392312061984833397420464742/5061855287715358593319318225821315289221356604380434160562178125672826292178527308049222341491044972187440031984469472162573891312365737610269,215095688427936770945847665034784379368574195238322643410646378854332454050982396967727753477562126493537762346068172699095349712620573418412/3232009576446500943398403737256722856127726389822942995961641321905678671299457610210793979874914874766827466880028495848080543588574883585643,-426483330728973289096278880208755804376376303437613766093510797592364089449974070967952464591643932286337187957834775666969276533217517907/2184275980593397737133814864948530779647657564801047378254300481457037846009056406513174450025182858176320632438899029480306914968963548738,20118406064957403316363629601851602964842627663398838432363482339758176549271822031270136743124190525673212178940331377409406848540760802999/11486002297632505357201529972692483520049318295033244125315849739680941943453662112297226227431076341822906537766117473676305388749209688320,215428845434295246443898441443236706777387598095486508472071597455127467720849153414990481620370323767977198920102380535835526502896950120985/63980468913976847049234682692031289389382551171053819292531766380384523790710300236277780903388853870443950747965259171271348941294957977084,-28593767605639793199412871754090556019769172829648075960354123137924367248346219114014956884898259915175768060401637540713673122371204983990/15065265059191852528881041928145676069026326882489928792512816900713657164285353791354770313206870146074710647958008602759235823704025407261,-252099584879901310138996681457605919017516248541839888215130666003512145546624532249234947595960975354871106271711826241323722356410028023283/161701616017482091285258395968103127580039270346019837526149760443900989436506472110183930598787681226557007424221090525869748931041532418734,-15876249275056710058593917088048091787872597796201539864327654822182596170979414201949554527207405976635284166423693198296402065015770185057/11142700595254619867064736893220608653917553592563294821825512062834522602783488118518043487195293275244354067603335034485188924514472039638,213186812039676704241126497662106698911581479839060949812305833724266866066433801413060779275748069043209536480211243752930400515765773919489/148405521206792804431132991549809433280401802075953119064856685910399002362929814840397788696270406251413305053960668013459175967317342858068,306886523414519887315865880567650350248799118951832033758913754758484087999455984051352595903684301904858946946236264407197558824797955842443/141336554693961825220152646874314339188176646281640077547394752735003171727136794656007183295047873686806219648776289202173480954536178446844,86602250557137664297303903753800094085890016722825715338370803396921672113882049110573578936063718310631229554502375716721256378348501405007/38393638332600314419308155630472479634810475343604224118917973038550802860384825006005615340245777047492866078542151601502157468520358129676,196556145701844773869495408785564538279095586077489162975433590794180510344616781852828228467643817184994366333140452332260251107869125342099/112349355704450945542817449359240671557206883672485268112543317139314190411239045064477049491266328607887040801921096449430239294819316692800,-113812676959394270624117306535987992675004087125368594988521257183997511079607648870977372756594807129275342157831071685638145960139650450693/138654974527653624327815508103148872696978243339394725437376851039853379782654582498700819040306264524973557537592904968948193352998856370088,-8291667018915429596398572614798369985883529093573956521865514389072602024215734204387007590679689606943851827666084621662266627023656876441/7951671279135608923404193474110414516970927509368456711588167108645417687057962597778424440661473912977042430877967519256080741276622466440,74435443447420168368182991011536393819394016801135417708277519061981048551436022655665241261624545716729975863770559537017167188578716175887/110440699481759709183581919633019828642554553951579069724775513653403493904949251046035372205296098057716842429537878709899721516236892641368,-17269323588312120596431810523230731871997797253441224523252820370656631697673784850978059327420247834693266282847206017504917217803432722592518/276057340623525132497327336819023344626137942374404633269757059164806112300787391537297234866190848515375020382928403960854924390229720901152363,122756562159778079663593552306676725528705346978604091862456279879400173995747748612331811183125945866476185068669120879371906677371664466735084/369400886739182592963174468667704952246691717551232998548613543863686669655010817087851623561259085488758694389756505872133485116677428045229699,272655045220131930398681378216524106713593389407184410390320680554919640825881137966072571496872865553995774878421318329130697001125711935486508/540035539988262043371831039540569282132008151287033053470408591558445000202414611365276537101891915221357549613458114491799588060458518051835059,8028402035334859936056790991192342095311494984049663965609757319293507044568273541155032584630541788223128371849011438879780524621635932099228/25421983853486362341614542198445159260897992125014256887204001768420300241282949882876659670221879526803877585188067171244447257232292738628415,11912006404500223370534395316007137301191529784228771555567587452874013290021445863004156699956645537030826590205519666779981374349880009658380/23050988328340664674215379347020340031947885089165860798839309480222185575321017104507864078493367585031965299081903348958463731533357423303307,-1867872802851107691549744973908031099476219426252209224669474559765120200999399460696535809611936626530594693397757617722884419589652100671299/7759151652615257877014782880362209979025372339765178568380894873644101650003891792700251198965656240191715057170311605487660939022726199943508,-9055505514561227715691947875505115588696098465003946762752922944210637494847934799664642216750415768009903296897287649639005392367935285484704/55663630058132989247295267264820433120948839264692821502752073101324916038794790299918210947459074725398017392759272908037058666448779183740557,603800692671580090019200710859404280332253418983184102674449416661104852314735197939603248197626528430982245048294398257805026174520042497755/1194936353613283261821535229331888067457579399632129703643617861354966100238552892518112915824780904499946424898736709742203336519987170686368,148852944469026469955542414294263774623356059303553990134633022202753942074022634875397245628806291953506089114515813776047136979590625230592/138380524440244307379603372353814740860569775250384276004483479917492966532803457876125199113879186169323241403116500766121707081622751914015,3221021704280394592771829847137953755651720871976725346514455552951550833656084373100998733635803186896115628540042989859508171604835743782208/3311036490104173840579661179740228477061320836643735189629813919464368494361128148047010106610259977290679440819346054813624256607602640112935,584905650142690677505523811382595049447310957143587897470491988186377701340657307501440060319180706112264052603164535438983071493550355804416/11083480836283121229127781289286156136185562560507240408547560441098251512893269508991725788001616618865935222975072334933628534623263824495095,99799841183563401321804867951535770931241960886456836550587346525932896352259814193381407148764621422354256529893403102008476624741538427648/32827946430409619642742568322824593210396836766548469576422289755869335004526562827270888695166082274661816782244769001370916902668603980433549,204912209885358096898025099868229384904455501744849833549626553171080600705142357127973701632447931471339394770994148930388028348141945043722624/486109212485537145597996055257184326274119300454187627207254884361355698786667681259402882846097348838905168213495160912814051462740575392899377,8261123615357598030351662997047731281864343445588543389318497030885275251390628899583797734112473979391502829811231372433442002631911599960744/15293494409885114759112621015152171297062651408087565827338839034329281379975358222583244067074364060273238253153028622713231124615207702290135,9362200810930182218433759772930660672644365919296302754402363184937122505450778788540114791326722982611048896625292243494468160309011786444721/20452758999266645372493517078946422387305453619843689230974298673853161994266305334465858356860246266133459644716948581055834887456102287215327,-42904819668827343021294924220341705017068794405255604069112091877110939030839168301443559235504059667352276665174353719365495398905921777887096/429833805528558951127119434095113882158534458318485266868948921867684440480735675859765314222559256610991043492648978774796493992177209169750119,-20161837111725791332432271147617367831782417482755515806310539623345093007307543499907857847686715986966067147423582674427528676634670209725117/280448487185117198748368968910073413277986704259135906314760292429640687445894298705711946329242834045105080542267461534544328095956705207224298,-995899529255599682858788266246500223322780165909661581718119383260411795507682744559503548261566218354470020899948087306972025807817325677485/5694763943810610668544795556744349750343546018133539088596268625197146522082151266115039996411879823323443724732528710373368196462306058130748,42807559698965807797931172565526553106679984975305014116508354493571176556908358009333153246505079150232085223455152516057491069741919442040/267803039602623364439620668865054390831919467491042317830470349059574050384313454310985214703546437990911221272601458334482805773285826039341,48829795519624807484085519007058894875206353877188278641665822873135163807085810629440736480308666960692888858239665682740662869434385073037/59137687303766395464890512487511518364306356513174309455084529349643724431662336402127885044260081777874180935520718089225887675520524264564,29540212675773235318124908983381768051220849541204188611568540070507926524180448827205176472866106359443383918985349437488787234543416269493/167442937253129137711762622143291601995123172365420776756641166258088595199887833036659489803074484735368417124764738960995490838061238410466,-929466098859746800361235639521916402090688818690320212215864190386838500505264055790636020444380059967305210493016245473634316623093695227/3964543634956621707593449948636815743765698008933495460996339204133235197267492614322428747010134820511617559481900097414096408495884555312,386937567480399139924919068064942951812117744949076446389570254899845579653408526889689553512040141569166483636730564539665642951241030151517/655076403583221575391022782564175521848524444859950699480609906924073923489296813901888578568687589696325528118158998728575133996183773888488,2563285368387739522452853263870785782844961610732483864958731192665493995392819583615475259213420160044613521940724435699269263267154567329/4352906032955199616732660117693652277631555061256315953996416257810463504569745901064668938424936773173153209608796221718045153813115193160,2362000219623362433244758829348918421712080749249769176035826051908712144617164307174924141584009125940997481020476241416592531378192269687/1929912501148520795706849464938148744313398004847358029326204574191701538593645629711933220604669094375231067274541391337599933676633523329},{56400684827675954347469035003237096364553308784946925415067181542091905309306308133184697264323511300485939151331240616322995627883760567817/190543254304531373639860750765239032508490244817986359145071372079895136547417863891358278275441688017209098618975842631065715497067600390528,2684932918446628539771776695975430016273611486104556401357046121541556497311879411213932686302728967699445212089230261221525512207250567775/6571148975629150399627347801236861418641731139284892341273324960096035033703365085288828774982743170229425083590942940605718504563513257464,41347149119364361729510940104598482213573088025823065228423521679167250191612247874923724888516629622706496345842306599407662035337503535671/247843166592970245282570202516554028121164204695582256297830743405290073248202936640371585998406198376925673567053748257599306918127394171816,-49261165690875404675721149536516939754168667801235744436016365435694207260158514262151095850416989770049361665302346929479109491001467728509/1343452152598916679007774471037722437179047399835508707808728288534551328972891141616610287216983366589271186273956581261478183219539289689947,-1813259658211008230938568790216476941813111494158933520887024170211518089645926491841834512424042775121513166798128849918316960523060158465/57037046300490065423154981323350450028292628885545439194863948843421567292058586464812931914886714074302431712645195806724133499689466565286,33102659548272859036994354938560828520871148088705104674724101144577593682471832822314611266815040617437278175850514794397916817788449027455/499300928557199164242030975800660350359018448980879251695598680500384659575681902525786919086455597564492294350445307552668374725120098363287,28934873175599670896359169913333042902262061294774651292697617988023651584637548947078824946897565685118155309635011583377543756374700500823/162484713279943965693217235890603872484262899071804458454027025279565512387697038237717546682802868683607788374159465773099479122949826126865,-172638818634702971283314353454392237674563499862303404773473603053502588509432330423600707252044689839935174832730351637682492964682624533524/4234907939976858267164364737662844486843021264301493258955111470464378387915597916573659956211106275123310303759580692924292703314892400782769,388289733864156607763139243923886836343844104602474564703721721184034757239728208814306438159588989032905606435677869716820657002007781941319/3419533381597502843410892881810832309945486363921873115524530009011595848249529934245778696303840031769572365731698339338554670152373173815111,157553362686468193813593084975576546460216690365710672265991666182790240219431397248098031502884909832501017547217731910775579335151209572653/1256772555439748498248431561116529545451832841859567799754320322529520801036138852984639384846392001661196804098635435492702773011087000726923,363823177281774702093585668881713746677665121088813117982317713120884211222012306940344690517690699904469998400033637373418502483721095633116/828039887268521216060873424261317552917656073568757785862285337038150539198937630280681057159981170811669525187224005830579847364428948789971,-24406969960046441820380095337011944163473108408073787754226700345100172733947073241927227118200882710679348442057551516985190517082407314418908/61947409266988367706940583109256946977269564013853663882525258456070275306380299346012380108572662295225042477731339196906129067910703865171921,1731402516194013800316751888800550482919436994969906368509256645691096969887844588026731675362829005967643829752823673628610702378780044998385/5873119440095448820857842133396527510834373107152860919878099226579080460176444612170494735984900972384129163326206816186974096531894734543079,5603434286356295766552571066811071065470162520248126143843608885151657267771340556967555762665643647213910626931288449929705649109819544343680/26551692482950836315677252014988915673507177753771933650160294721707514968447407525556559266044844514067241840693999564042339367788718009497849,447170957285486210346011535205189140018080451410360107238126283307015073923248557754164263794094406455984219142570384144864175662263556133036/1277150146429544152214964055966983847574684861668102370975853966125705759429119246938860433346281462057507019318167237870048732034292195863399,-8175812782623585375758054736079728817351827852591755121823042232626433947121969515330119427973629103259564448308617445889872498123904407653758/43089073736704220082931650345405992201185635782483128544126036029837476591568572985611287215268411660794876234981653983763818032859640935480211,2907571701732101573165175669946086222953210797288959735120957223365825431414539057814832822588873223034946055893397590414638151579141427799289/39734159116040463660067194812117285801548170089066967658195858289621646105757508457376440884041059281018567196872082590968357312388606783143267,-1509948692125213740655037161482772966008621088552343311572699368047929518496293088931796561812138829148230784748166531647606668981525879525325488/7098429957929935535358029798253342714162733953979245353015671395481333042994726090236587661250901769358367197374200226029833931544488035316964139,-157296392303807585528586913997305144821678914675221814023499813114386993166861009916595997514031669867905546536736268332149296885232822359248174/2337967303944368034369893084378245233965562714175095123775989274977882342371438357772173566935866582541106559173329270649617032501967081606193681,-206873174929544211591161069936511121120992011848458083067708255972289986569367430487361612147128793970903365290399242369809589920537910490871644/335887043615910985377780469573984162017193941445639414540090365696258853512437272786602588540373430344640378185175934194447439476235837292968115,-2015064079641143384012973959394761413190163228403104102582155935672117399564489315460426538439870337978104032845591806908073158097609247147889084/2499399215304518112254614970881207317953314405217128226944035950888198940165163038636229087888784911709082265777771803607027237643983323966583231,577557390269460797126383354765380522317345512032415603915127105988417533781077757931835741556628299010344088735016997506888623222947315531819/1904424346106200534026114820321247936331624730792907606819693251401326456379623444619836394496453904737933863288435692229796890684016690264916,11799304475698000686092877388036664113851595369753948700124662956688460343770088783322722852592996976205986671601178015509323670969941560338951/33478718847070222856773030417003751432909310347842263608059273689224382569269799640987316022403764631531986459647056001249623946090905353733974,5737389653774084165505582690422733022799103464461436941016453395440762787948443328509767606580334786624676128354242194673415993100137230886446/17608948054502074545816225129462752751890984715980038856909492677276884697024405877977121179698639632847151748627931305671610667717094296154565,4126897077320392688662040684858253680029005363225847095964053666967275955140593328078875662164183234792341957403924757262396712428577123661/10919926139728516286787059748045662191890315191548726823813570418698923072053411409585810183883154942747202700334880364074733187288445482680,-84324724437126654649266425590302313658761077320243289589326333375414927234562943357737082431054237786217014252798466390625838441307651012052/128785435266056456581370629473187764674744122649896439601662083732866910703114026785662013663771373404045383452117305147650581839920363562149,-5627848212587648360627493780032028433416745843463123976790382822710971571093159711455171594077738252659952431217706575083104677389122505113804/8157216135986461000023542974093573373916660861882648584408071359725913906438401729374671631354886420956905510290604658648590322805831167974407,-435403348753219507975040765701561995585259468920855090449970838995745382318888825582229895332502588340768942607981148132737034836712168780188/685997289949270757051338531357844246466821459690269305909020396960862505476842092926422322035934608603226141059468545381956710120759641008059,-150122408798581372035453931421991918547105397575418283694265302179746965502963302560215945632392498721822736016419908084615577807604068265154841/695214024579606642488435963425505640686663671493194055362692614371760743009212880851103901081278769438090793842487985618055895337147162593650840,-202948986996999280492813386748332198882039381181782308283567229058977476624416269418973516870291622912767504372975876094213211240007881599306885/551954420213820948449570970143928800571720046928326616186181321739563883663630375319546760250738905896000883545056272326930551879216196878383576,-10519673354782278469475850543055303031820600996494931126883062186257485301279991025568788780088200028986358728848509242702667772975180488930075/27061831555414699421133942175452294741578292438662547585548440227616628503280842518338526011010315368999474122390105708930709364473497636878792,-63570512013552584300458212864834239854769610938084135336050941367733378548150646504650533869254346442363082876986175887012639975005733539773835/274295448912353462063424767047906993431227716975042050563570847128334233347706758571167738622186087697319770330017408896118102094305611956077564,-5912683116107929551337947774477126095661735789602461338831946411556815435550069789724482511278908931731153491770254447922539886850111290056309/16700481110609690465398058099767426982741955252119019131642657089680320018074958532162162313133580866481142010118038854971213995538353502065076,9570329248746804236063867847042275635747562167999246571253289473944239338819601420005715551456252313247522762019996816512801128340768435585239/31861699021245568312335036837916542544746478771105144975750899657016272646298057030169611285908000050532332723184898880329480952413651576721804,114549399606794644733858223269588414535526187162866750793910946800605157237182182704202068080473786345480990516011634680284585062025761779408653/208497148073475416144343877993794869195933659337018339547902616222493931698624261739672583129629384039072586660529909447124407742148713915773158,32065165348655189353772858335434275516250768659465349729042652047973650870214891263314872829553630863438131804852500135888038140925580965829185/107026053804157130027157951022989708626508703142283808832227809439966346691149988106314047039275715751282848938358641352716307083589707088774312,9675931984913871885587573315687178381240205966447068215775248992403146835477998510740815125207770587618053199837954819754671123027054406090429/26421817407336042099902391651408258687402833749417401821827753693209757993345122218810583903244729575536363858564334131733833664580967527643986,13165943937418404358433756436302537456983508482974380475339299351326055156114469128365508059239188659822893891632850648891803975529342191707273/29232818692250274663992738101699622344049321856124077006408059621775306128513424137906965364651834958076179058872713070844412847661151281164675,5129004669930302482105546384591590274014934175917106982361171726010579497040105584576574481319208977619304056424536854403385551200637473087949/44704021559592115190491896006044939839895626324505439754356178453809959746369027090641645339495343633131183776897221119202356253683969723916353,-82594456388368359483998315182659759731265038942733060470906841633523740732111411014618090831335097065683427961792255501788301672890113695829/244489221717614602904140442385092471789012345118573511724353082899004332788314246564939169595495833051642753261568406590565169486172203797816,-8758452583644967078266240746108271130535640538356685152701672367802482248842265448925450727548527659410096188114190077991777690010278988266483/32993318393628161849051221382680569207578147359725073876363055606307926865361169575935834676528131466842570259459018451138962390951622897541393,359513016141594482346076507730613837274789144926115552633868517177659975848149252534391766204110347081124072589557622291742945128456684172953/2326416304231355514498047392617791564633670367064862039758812216772377154122876053142451433898944234456072177951600352795318549045157710939257,-4358688565599881730140083967044130358655443650232533120564503262183800330465566349031061104870136553518863133089151112888834389941092195270665/14723167889735304246783077221762656018578299214600549190168697599617922170656849418519203071826007544149219123614179112643940412627183061656163,-6038600666309686178203600887339032397232125260188912730969219570760594213578814168504411276582724970152457083766585430537398282233167446303/25693510748096386603444267324247888598861091571649729546564114615222842636351535095889968994286799796254317586957061875185543709593282693737,3140772158104958285357395768012946081496526430005958364747116858999464922101542115189762974949449478995250598556270680450175750588470841671901/8390568232172214491324910277022361716852931201000213148890613245427998672569112710860475736010430126319934474081152203445058004959437131618221,-1889241847977768564139931958998665652546349039660259676842247734912172240132387831996991961283200785684922777394938381603545698439705634495317/6210578783073319227728544539564270017492913172991213254091087588563008188943007084912852800614706598757887498382980657805955586299870425587818,-199489096130081527769618003536500942773199256283352141771622494318780657379323522800175484078861766724933866259382358406574504646639463282785/654267343118763444785623656189108538897564000231821612769721314048159399647193860322139125538419401706691118662470920483293827135312264936699,67295140813591492931984591702838505084196372725777142366333023115266109407207868176913519526814685627590006423034338650553053864043412743913323/121872113918052066922119520068938381932575382173786374072052091647613129032961846041122966821250860264336491905982186539632010306919074288695410,-114063382772819801616373033587387678060957083876764348684755426231561745748242301777059799517251762668876155892302738305218944198172806067329/118411775828959757458992734742846807074274935339574314819551271449446009035575375114468448359237461379170372048172765572250080450761507167456,-1087432563487413321017009629576826961726567122697474639665320792167814455469029070835238324894286005839766747307859311356546044609482395982849/5636673255968532064687221100984441977513592282728840268457196942351379557356224022030022165954398249379914541657408932183670842319942237593172,-14088923704544046327153444000424098424672227097609946035902482003932402620612578404981641679245570739629127581768251314766666021352461532296057/38493262647254930644529597565895974036866224766110536568604853500776023780272867395957475442151913956587191707644357530205122885377652254090484,-131613678345731701025061135922693157433333724139268914905582514641926303549048576791293977970912407253102515227579938428434344539171961464262705/194529817515280578575563529593155754003335800016779876525995520285453869381498270242112543596817840653201746536541211529567850536546827359368948,-364347377665827420774263150498492342681196641021774059377107411078265531041710564371182353686016048966231541969671080237668355989404821296804050/1374087140217073429962153320380218715261806701036593809955441246266588439519795451188664257439431235809565847498754080051199301055246998492073039,-63376137511660076728879548791118287179482154783819610865719635865944425668877505194719677181626070385240386386957836845506688207719179034854680/49396106479013760619872160861680012595121155495809942514885494495218658169910517504420065577112245760828584940892000761152204805950362273848721,-5828751620835305232797727204270357009550153676180510454561547792551135333032095709412156024132097211177321943884166790870492002201787626640759972/4029124768502246430870903410738518009840517816972986026489837744518631453953369234010680090977789047823674011868727926043429956342659090972824263,-795096765021497715836240910876084123313971527809093388543498226054802535447504129484904827724123877835122698256297050094173477426671769258502660/488665203331399114309628242747368596853407454392953685940549782437539239010526982139139662173242973512745519248380931476790036634391606555534317,-129955903575979384663147876639850856806750324280013618189283041944136710508553629435006497036493602666471095805405824207489199035390607008405320/96258971789799378706620455211789574844972465382147614085560820893777389445253724424826158621963504182464200215582970955089748956578881460408463,-206621563214033415777263297099920618671467031669417884575245975112498567203350177257740680254250810211303793310340832100853719046946664891018240/124784094116346737494843008466854899410448298848218839384307882569136535729159560232446898927977553433355732082367587331596215626729199542475751,-3675898348910094007253589854445373880682552263147426995103683448079637868615886450146307887981825857572239898386318619081500782889827288779005519/3545349828912015744885885987269844146946366866323332642933975670282850486032469860471034809085966954781259794422644215931992532655989221812081174,-716598513623849664843617381127583490753920530683015582501220087078162776993640940986481746413209796159576576071385865461835144920498116338139491/909102786679507886163596984911860516382499479161247561905055172287723751094064444799505962376640244399715933260738907758313447391460735001894626,-1808999162412567913238262676300375562427675174044313415039044087856222256285123922484228535437781199525190499267454153609453846217987991330818253/963417593696416610485504379835575862619684248699765591147058562697478497328853260222156835465485188082396755940978972728159448789510977892006253,-11135957735183260413730068634197480405407904658881605277141061831722061158448071247728842009773727252979276913892637678245211906974802492658180/12343354222117971687497876476136938052361812340660270200553540564375781016054279226628601678362426857409600741654614248892051895654886466468353,-147382638652958278828592330376250319989247713585808699751158894337096343556589023618765024126076089877417833882112814187180641752560401363395284/152735353255649170898115890651787096616207531908779634306279586319895099008217264442511608798301823017179773871937166636069525776931663634070549,-32633469305441280568716281308691299809815833483129308774804836628297611085052311255850049129802912005295123691876817510420867179886088396573469/29274301345931801194247472103016772513042969356967210227219630930389018567786902899114193727646296728168845535504413482136080898495076842310253,-485086578557094202117860241273847673879751435330946775589072303496777405191011124414987932879328723240425322364162193303808458614619669317245/504634109260518134298103206713919550996378086747704137388236108426909075877203878031488764542880457168298950709655063406989813428939364930927,-1550379463273978182437267340527050489311155451020433588382134832815560339495823907043227893288418741316756191459048146304771892158302900951491883/1337834002899491326309704380225886909224965382301124322233593886117174877677157099936804462026683556497056955905136898798305124661948384451402688,4967981467896385637771061860388515279081709229070919350469308249563341978906904851723140856866666837118615716883161291117820754872443117708011/12787565925930333209867389749230463674702985063089356926568617561799409897173318711055634021018013962328770254186076606847324191178738411445400,3654623800788924798551009647926735966490287472608896755124808268502205471592102191092869398585031412663971124096305419210833734385492337929906/6550904909378986321470902044113228071126515381644095656272155096259644539309992481631157714185799865658410788161063461785788778774792840417009,11735631864895290044401565591256458796086800075762510638954907446844770315149302399388758776147293199078930354685189898911696447017276302809298/37623040919338828885224492120368949821666404004276121573240624436296787578199601602109723625758409652981537787240523897072765771568705392631977,-3952715657199677469785996480751667845204556498981949671610826279672161715760009165368045054953853350308557868064511599743034353836667886108685988/3215078369693142403836601762322679894499900320094908347714555062862805956613813617700922529043486039356868849742013270761527089338033600267699141,-3882486669346673001045621897353805257123560647011240235791827275597711641220923541085649943493508478122340086872796152685437855806056203171595546/2471297312797322425907286452168412440770850317364035939506106352706753825066665383023545184383356589580830028648341641360834530491625783105294747,-261986218290157859793857702901629225854491507920212859225509699728883012134011021389150644121240409463654452497307162646402586966289392265143834/125075051813803994691319891436525563090857012840651861964982795065378530615457681509829564299010498232761160723534840731555924005173320863195963,-78410876577628541174296044673660417632065688050640909833944532829309602714213680371984377639267167821848746183201566555217432801456490737647294/38682144300428907872237688048284800293724968865669368566954245884398906444857991205562923854876701680017696521949372302871891225398970537458231,-137451404390340095636978741544788881620038904997522736235353038129603920189925900433287786945991297759457762927706516729215575235289888080735988/64962504017537856489173202245559062656341505053426091383826429237955930135112264483553249183160677049089885879289329496534104561728836182786225,-8318847114260818268882962096511967603814952195519144648764923630437087782083988441940777103514574878375538126492287842223083762878693976592891/3829339702743153288522529419972053696206093742234902021837647712747837701227708673107838491063113253507169614593510065823165545352882459331619,-24927158950495627438397614449760302907051486014205517312594731229762405727793701603857313374264021117183437967877543611871365582638151155658971/11552859869920799705906740971636365400900944526052409226615551265055937602068048303816325479987393673120996585049122602773350891259115982588083,-961083366392441589762351377103786733622027139587829904033612173183419203303222003381454772263440437761712865982571747301035790317439281612688/1706069634964987279899328274109048418470194605354343328987181087770745569296777880730132213823760183629496936046720049113482199047072599706579,-270690979608400884157815477295384542199437247822344026264696594808421986396332539555988507707769312657228257981103859950632806121600784826607/694694437333080235138052283318439620698125738366175375733159148345075861568120376295809115612716883492325319046644773736695377831374398487320,-35965311435038444869257532811826916962739926458504751282005638236539426066104905318351962058265449001726045841513275438192802103400764412669703/15572316945620553688307658500228353867759037143794533510461403803393525578127497419330714900394229116140384524380343761022004221790945465043404,-114490704226513805905190277174538711024197420325939292350020278739063926535696780667015750069570922493508179183019312363095437534622569278627640/49505275562501263522635086713964404766499832300600897790689566259975737711429734544818055514520302485943091102897508967360666344177870172005919,-413864216334247351540980459561634492331170362150444339811492554303400543671389100670711268701912184722800190485528224872277887564803640863006/813737592867482282541981383851034298820904152914163147693213102568212167587038614332633590287358608057496640595191098547451579890948871155771,-1345340617647472763237259573445096222368254314366876395264398590480928203045908782086760709594211808074906372240328693009321060725667160166263615/2224404001417450061990767525642951119855879423200137374886015076202134798543804878438291117385742336656147264165796528586817815367385323535822478,-5945068736687235256086013184958216746626504836344878647220010894514047673047965147949099229548765426768695962074307129706746201150411026551426897/2427684046144627132344415926507088865981749348241193597955723288167420059005819958685313677696363756284488141439396284274149810603862231055573394,-4418501445432130754885287994727980057468423687082627422869883848073030084354456423703435353407827149892623408984654109264549439098067535490062539/1578646777315751480330905211108769175738180597994668536726632221798294510571932988185515935429024838021896876231167431675591494651538400375091710,-4728654103728739590890495504625182306332761692802310256174066310034342908252692098450221234295883803373270608325948735849236642225170764799385241/2396340401036938205247063364658437960907991073723939936217378449241092570704636944641550942620192340631857741754009115177101582488173274164340516,-40424759064779979090115598381612801157518636974882397085815628306272902427899651446756346610011215341182958670021005994671376164434605982889311/17072448870587616841978987214524613091974441348704740734684178501310860431956307834358893269843113637476055113677109007603416621794113575409101,-1029344763978647688412279402617664326385210890033696727047628373039506531997761797395656489170114766832577097462269267148648786736486843142686819/236888262733926949726052207672477396873861070517565992831544953898420231352669384906293437238226869948535198359014236072987081871772943366223509,-2455625553269162509363742961772145477947542852323409355182533934612937297139237929759127553553161458447249180849594092473128704200357724343916329/772756702424911925360492354601071609870622947843001751693846406913164743887455081405551339591980439429656982936022569204332328238081256151566654,-70484275894501097372544113959566993127375695438835746155283479487206498532821760754942524080481746535590865723756600587437007619380916638423906/17561755853409903074649009245612193477902390222275402495570029193558881699962516893701527380683467468340377370169462799010800822169878118258489,-32632174012601341345834291113142357609320379429530336108759406470782181299801480882115711244909183342685996938361571334369947454095656696643961/14269416970059733975224700669041195163036894330346063882142194573521864456234747762513383612739796246514731365137196876693992203789642968463289,-37938002340710521217134767885873412709655313327126503396977750852456325333478062058509968428957876477361155945434397298650013712123964029175285/16198256915437978928852863269582397681136484672676840653026863249714075651304254955574156079428701373277288995153625690349256287044547367924693,-84773078777031499195640379040852513403161067386426049552561384628294436537327778789937298870565644805134425841103510178177621339411368333802251/34459511441329149141438257363770518564787987431705145113870910087540441462682298666353080366738867062216388767790661012691263144251586864832162,-1453600798217381686836631415891553385457835329166324316974160424136211281489616524106257395888815326645420500877476578030023928344854011724409934/601830168862194073185893455144899807351385545727501033865914049899540720275429386661080678599806944793050862506091820397309586195849430225383633,-133513736946964953078832578601152573314043155263973586433364752415308627277226400251040267870703450605514749757032625061165162807910508129879423/50557503885558718810211066386688511987423812710772571038872772688968281813245743637706036521632313749335763096103608112636331926829932145246911,-2690170999225289881626982412260092785634363721735933573753479355626900257595116498701534549987518613922162310798095147165725224789848384079303/1284833658900254772889194844065723206074368933530763752058118862142508441003874437919796383410452294788938263312785204287686373449968156561323,23287516266618018644872153349503806202211105340469630399949553283690469935380840556141980939144250675173255311829308621681862849780962659387685/42295015817421510159414667054109512033718808867170676586820473113822371228422441154521154155149159143350729173686484487629486484707626454297054,30587568742203203250851877119847766339951819556025589794871503359313613524591745246028701773326780914480258388749898174024084691242000103262685/54202237725720954603491395955933131972786997405767990632922797079570628751204558837163271179587950453069054821826482184763576679288183364207124,26412961868362735219598774807192227524910096182078286170154419839126987442884039335704058933147014405857003254061934528534091847971944559510363/47918345584594605436085077029398530515118814550078373727526642682915259508816049068357354113803433759142094297748737727940585608221014794429922,-8226376353473426921760475864333841961452863915772755943634745132942679526079692052212508140247297029316662000701129653759743601009145506022449/2595828739488496289972884672926410661393381333418190311976345539795511711303089715086358207070896528244899644364448047084678991018134237644691,114712223041657501855234264896263975380123983035269614114566826442790345988722688025452047126061641736822819565883107764806752758240619114125496/291518365024289121990583659711457621063627535591788438950481115300204316003139671648507339806403400408826310221644974339019269989356218774521499,109455068926058094665386579557609127918563468597746148070704577721250714111078189124660714482102016561702362454835037531477516614653306056670339/207561721498304125637001327069640742084948312342398641162708607737995593441210621991317101155863864102066234726108334244028184030373694847952282,-5283119562868283255660299043461851079487296456488543248519523085169945814220660887151886950794780237390922623578044176421772678123818081805953/2568298423587134702845670856878145557894987188767941557859012223156323934139144845296716664927836501767850145132119559072831838747177102592798,-7800822353118697282877683805067011859907558417712558803969150413378727150736681093071073883994881520018682300721911621773609995819780037265459/3639332072536688524251946896742940256581480062845391815670462514538501729374983642994334357911801463094880431178644200640643275495852099998969,-337023221448321403408183112777427516997637661638790336641991954275372892856026349391119126367322878594923510122805043605043615810327956990673304/139636200618454892049121748639260692263406381907136204136542941836571696306935422037659524097060945911851487212856918600341581516370263544759247,-45518677852352233202654774991897990407998057992579080010147571208200727834861052729780805574738945641873293997373704720954696203872000706344288/29846695487316337802175558666326510313297197449591689530606831564938175273714347229061575330651815895809564444074905643852692855352961994183253,-13734276224308012410209262969811722351842586008714176441415419014096446570358891448593171098165357041476320248803994169465407661581306632402942/8871709776604947147676858311638534575996402803493573474464407844528602654540375268714971854842291907943499230185823692133445855203261207009707,-4179858218187190810945600387637937073026379020623097408396388698304059707199725622054329886184338191561135940540471876173072583988027046246043/1766721803513841851910978667290433620567919704879668058600538381106332960379143255368441664357508046567648313743848876074757491077737521168730,-8605906638968006384680684000223275537498438219410971970838732674056169645011270538746766956348345122676944598088207977404608639180140839785021/16492449307488214004096339388896493304107329066792035747986630605481452469549386939586387159908924593287041298678032266504573303831764209105606,-21087434106672498018601208794980143122406159291400040517397307164886791754452443419002786401854257059798387600096346861965561919347941198652623/54400936455802208364678205823704083560650262026171717121747385305521041806113207609343948455224892578980554105910907570848274117268740096793696,6863411643839252814526630830809768185639286094149048344779931124692417565698761436694988638295800006145853018079606672955304796367922282247629/22067396344220126614427107694321099729863974102451824694697557680288358952540076748577763119418540377087551639136927969917066501826619039225600,12689983278038613126824602774717300012654153001379695151391665163293790581943762817336340704253552460483154482949798411950015196302425088799827/44734070447104636791685750759472338433403534234499046493532157827880821749296053698916402460754499499481301963794357178912056441131044837090965,-2132621991757172329908514192462660773238793909658302201713643203311521103476587711859355189237389307708112647317387993259716102998519222851472789/464372289720569584714789429674115418910841311661084427222861886982398503065109783302505479261280641516304471065240458288073932419364095222575353,3625813881558078856015529162501319563357936762874258245955813727584092357556388421594801048456947705205659549480186482103229626274608637537739/9869130851740764059192758900594587580769236553889159215332382177457968267365077738229530395138149358629519622450755245243694225680559456060850,-324038362376968693871127407910666057055033512110444710282693535371327529916297362502858340546390874067671450502170318720792382850306760757349/1818091518312732386754143873317001491982395615507963084854469266540469432318996781295393263830574465223411983865101748530496120903053814356533,-50874362981187753017369563041601949084140084661679704849062301224546825547371471177126534582114602123911874558798276003091905705129330189696307/25993523598396596750644489293040877251636435707567195702655213073678705148936214149390389934300053823631410076460504024452192456261925473086350,-245305869242195980532433375383266346437986819198277963711201148826651926022074771231506044873480545250671713771173146011105695368222440121787/89952788093006895941000165122322747814328047546352746094519838663835301139407980831782228220826426015246636749323164508088296028939641417705,-6834317451418865587705572176118136979973463944665951941787597443932353132313345582943217040479135123460912962129767988093104690898319447041785/2654466041566228080417454898131650514568289321207214688151318603164694850492296876681125889010606413792559873654518194434385498937284241988691,-137587388974729956124668736959596423273419844493116773754095017338532638407118123486612050662721695007466489653239945065956233160976302886742126/109077838690589961788519153009302186393590123116147580025015186706224160736657920230308480754342949370171919155571173381316388114450772691438639,-13782589216134654908099210345585410328005275500654779203910335293516141538716150058262766931683792338708300592280939305595305636788138110193563/13637692825768925046409924353609620314034460834763875290420167917853574128314848178840901073512106619475998684312990425775171116258901412738967,-263741605480956016581834675340189666180016257588448840132290099773375644617478659654624399632774795136193546089406431909448988054528791326494820/262831181202952128632441937200145810194724931740040052619833946014179296426255597017262444249988450204644507566922623349355378355051697305423141,-17795553719753724383739601564972059830903120101553797535662450350883931072181287982270391144557692355523511900154656231115784811980834308192810/18305634187741138616874142178830350560330807317682700005707430836824401697049797628104427512097493339275375136033784877281538671831389704816709,-1858184767941513454045858116731072566598394061568476214511113454453565006651111039773995920861496404924000460941216620197701025656971434305420/1140717180311719181386760335925735220486488503833674865682462981225137492133195483918446721830079560065563514161429445217151643579241233588657,-487568418003357169947373232511522887039436482841351285484464971925589299361963423824371158147199017172532259113210266838225365735230139684581636/273077850014099585662988531716485541168943249351012429831137102531451827498728929609838720350769053541193974519900899841254809465195742053202119,-6149813692238011270605092976769006254458335043284736685085078353850196911183938036662017143524895110959714517560888204353876076583120192257180/6551324055504242383413607697974047553400835223855536415616868142268203864241069611606219679179533504624937671906849592518975749522277699716591,-3458194838945385164805958248597919825842726078546154655096724284672056924707389038348990414834495568028876740566528019677580385717815962266975/3602096133505325599757108604720598653965625746159133709904673870123669981730161846576170122132642440406805399993820575548808559428192498213731,-26996043939524538074172448144868813560345801105122748678922560429338255497045811039755430472614021210824215928294365302541520904000356734681531/34100551882972292663806268702191589764803365923368752407980756027969056147095177421875799161758983636622483768450121868283017011818870070557538,-72373059205342463820693609324234974096332025201805485377292785516119661019369592346713029548594239373583744250020701684888369118684340153068995/74212096421148589689750396091964631747052130452768760668265641107274011353658608715661134109099685150907929550791618201990605523071301067793378,-6106043516128253188706769784198600951253226952447179880751123053802687831842765689341011476732056908026668430741498040461010218446686881234383/7746254742919506362600847777752352997996174178638124275923541859921727959676913137410527896039215957848096010818638997795664983519868267552110,-14678342663797393955776897138536288924793272268713005205879771777297357614750919944978506879443251969654534134288479684296472437794313032277486/18304594556468900655881500476054775241956422112468133751010858414990749505107286719451334395539818964977256804214834591926322581961451132932639,-16582928339294543991480848873113462574453244428819104812069594131191558837577598415509349979127009940370840192595269086560285437217157897016340/23356260232643387583814747141912597114598116705616651938775326484568628040926249878646593344232843098063475364761792151103581287974635355152273,-10796393216976411900449769954921902224870359470119726160871116396319281972092619766395917799331606594163571372016691850069273667502735482761/3787200887532120560140352748699504805989138546321220546906508610893158902914118115539008968755339592056746019737034422653676100020753865607,-3763124043695185761475316228967292926238679178899576290908928751611109734501233785524711560452661138825897259346853359905824199963794712651722/2407362916571330418252461838258675555899202372378979606040899782398492925530017236727667957018663189615504866827546450981340315591407140189509,-162902490031706932517559578496489900703802647620484664231716328692431023531098658465056667780587113512462536853653664549880727290970046360237133/135000040482540413335654453698108404028238095967053578689228318055114818272882895018805067712994188273688173720388843604665133113387014413527402,-45627285655338153886588600171632478164371089439405756406782760681163711244679823784353627597244416919471436853033616881712634387966903063371087/49671630982215244142591016982456269616123301752358770768293581169071354639277387467734365022451854884905822990842656489258136028826494484290973,-3929987436139884031604032693021908455899043534100610114585158490034526296982972564455158240565535903560638328524393263125368822901553471806727/10421592638415417197727410387231372110695500978185955056259685859489557714157305286266160873558777412351327727842623958238694805141939878149824,-4805083510860574366189732318013694928541341022209973580699533354046542044825676078669853772122331880679946552450377483394870069025199179166525/9073275115023871103131996180831747910710628935931938096926408502519056825843620366788030206800826450236047325558771276369968589585419298207264,-43168072957359708949897263528933557822377260114489905250528653101005108185600841825566529815144916241166260677573638572812152499453873494726389/84299232837887317179909835285527778278729009126978732743998359481183452088626500108343001390495381758104080623720024683321793789353744609839008,-295334886143721174814181633584220050530621397045453182055973581306613001617302631820728881998866982750020445157756651370139558522404476020637/428495362601720519473020212279361667283906272722299230207916040889968610140232280724437077325129384781230320953265363486640571338293138208119,-213062814151759372389383753779234888596955042277047070159493839485781548641481985978338367377928824451683909630848310413051661103662890705008/448434396377415172026699106695083263984268541098925179660812426008695838071621388531798238523097354464780528274691254586327673743725996417533,-9233089383149244413459180077448127954905709817079088349149857782662409604692573824945724470652494035534345953788237307053885497312467617557803/16110963373420360633633927101759870845942103161189798027014634079979434881842820347104669949750648130545024947784378135953937693365832951523455,681841217005048618119174158456430219899587279438384033230334469604514557368861287952539656096970770188145316836222949374282473961411201216769/583315343463468346251439154032738781729366076626300772913000718722269991478593486803995928449738619703334122348109553159173868378372514559437,-3298695517492007108929521490599308271500163419824612613699262223590151665505994255158663146370440485392888712900275596634682810207105566132316/2265909639673245592876458300611473847896077403574213121743718404197968178992692629259199417808218274887690407589786577542964834536034776056771,-452368220233062412218120446164758331670862767346487219364854866991617311835358347131997528404326437743779940526033766293099605879450665730569100/234299403894804370937121726037468340670176748362784944859471922454518889725132222228224624300314626284727319345260249532076978337983424591601207,-10273506317701258944221185900276760104758032913820152267319629186218346599877963361921680359757636405631938527622846059077208559317681783860980/6141302417993900719328078688587085628012916920277738238270103187471299772906950412311974114693901375324103413512487645588808863451911364646929,-1003582744938231256291093587201736874552073657630078722593355969284243460851930173398883404472926238174861537580426261139007075806124346617916/678826292583311418142189979476598239755187775636775631882496639524029992029771236923231137440946891421226557622186000089187341230118332649251,-2951006586746121967084917151521971962051643274704033006479805137407152838918825151554323514149446707436228397065912384183331899745724510123112/1523528911728935245133214908309420272948550249529134041637142599122384770600910870116404389962330087779622176713782272286716946954058583030463,-73956206389000629184774023114602242353643792310820983641984212101360245149525016653751028237311307899165154600310717429159136930169933587897084/36699682880770892078183506379087099297701089164901896385297331998832523091037966649991453151634760766357331304564016618494830409728452836789523,-9286465469350080763871447302866806505772498497822495207507753310836224486391545365183624161841931522374747122662814165403647626506510440913964/5818519086256404971552509452589712097133776544596017389206717266513772812951952632148299371020756776861821739133378476529738673569792588799103,-422156049810627722322269142405354901180982468841360600465430198030943800334478629701486898605788364977463107197049961109992422373860483024771840/173811246554619480568960412225937393336714227535441454109079484262644271613362929942310611289938866814001190849955901889605320345826323957985753,197013130717339639667752474128214072410742145043906645113413420775831547266652708839451341090343211784917762908652298043506662216649057731253/257980830442766799445949656988598670805503033448142209162025143487895494293963985133054839396199899981266729870551443181219078475198045841091,-1724467322686613304995938534081272684934580132655496706581403981035141123804015296128677088440729618227289271881023602851026822516970937444/1517517158769736671322417692782097181522806625914242314361718098105024192170753365405820840783205708202929630802472775526407327753882019457,-43338839220771390607773338011121396749700488855669478070154723142993695038854132987748790107958790799481607263766859542833840512529017305375756/15542689946665469694270942598400151224489523491172431710907540958727019330823092035348995117657927285873163601502207512807813909752089424643857,-31407867721618421739207801398480540524052064342291250195143044412288832934545102086495235168619580912557811793595047303910394176462017905499533/13409852101483985355995977549465285170422983542757782732325690760953578636731987161690117626817301492582234040783108563326146930112425541017557,-670899695403340265499109986100116246132728198014222434878406185462865010326529602021806308224424356004606054222385756673517818566137628141020683/148643359393728195770621936695272683621381776280768655481162875476816949445281617283081628146364502531914396905684513867557458289463566245598960,1008700074223696022876658769351414945194575263322924532626119650426001685355436987739122033513399726301794544764194979044968446670215666020719/788709172439582657089542020076635498306359992636611154054714649734303451077194352545128680310580686351673222596896590675945607909602330594816,111268466164473735752767569447687609336054539961389267570046247511224966246959695494516843088680516160599525629296559392392567573182785515211/106645830425762687334186295805783558030267829027497070660696941232493654426103304129555330155811375112526411583848754456553188401362015538524,-600267986019280531432831791559817110815084559078379212840450565179727957478454113753543417385295794874664524750426978589628580302290688775/312959273510290437417297320812294200433758936201287625039132804078823663091387484358809613165857810774216172053190063532999206426842699644,-5095991728375732298713351418100436756539205242544572279565512625139590538780805622080298742847056647742164850564647484392293697906849501342/887494625312507896950859780629697215715685147217133987557584575480163031855024024201323479004900104100703922907750303618626060033618036199,-6078873247734223596243525826599983653479049678511760100148127371910097021971315957099654247640802161056769053456028551727065551132892245443974/158056928673773192509197213548836509673540762028057612050243192297346025336867412862358100347931325627163355519818182965424549275800370549773,-77409342257084319100112451594154366035540901835164208042554071455341319274636249867062085704853687130663073767746218211047161567030839431605/1211327725511357708517950818378632058343384997754112120026227630528350147916985586632023370083178987341914450054046238558425014552252666379,-12064866992241753747540968363773848535627053718495023056675352394168603692730058384699634558916630539220969244278040146030636863001907293733936/485431840226194504194066686096477208977052470024157058861611155879972474140636625309702150830413814997837415099489621354881808846029223045625,-2581086657258805838963261019760767083518509240284580403809643766648455689776165382431859404809293218698280834070424931394977908396516424958208/153559459708438408559909735280064172257387745253866940318220123754826413108619308788181536303588198192442472652250377666043992287730619877395,-64867287558345488898217520208553336109968501739514796438829408354283042701876091693303649816145302246388466185680237405571608300251860334688/5897078874513190680939534079936730904383705455155220391960844324009732616559591460977686822196549473839777698890912491070695466592864242507,-5831876694880024675212422066469115386782351272685196340566000215718629341810058974351464814995375074239489042282815501655561211415111615405024/32686814460056303245302700092399084748775186032131962635917501066219670581851290233743597008296080023509261708016846106624132614218636922873,-21094053012264561356262970584252702301380101824508565216620550763918994541431115935940286585958475425742888127810016432123907381148996187471987/950694514140726441311744679973725996485058023323551271092847665041342866737153183192085643709503868886980471737684169854460981680680770652140,-16054088528166371706437957886361275343307864946857068550148334672842246029871287544867206169328697413170302485759489498230274314962394566722006/158914382970865736966386331653571215287805936278372256084350005191237126225461650488888702380151348080167524323821558694944192841711653060535,-10552092950347842576949489584452122162870744601465721188240340071475754651739588990228586822360667276055687627255228414863194638865821557326020/1518696295701246554902713294453277934508580039807273248210360330880853655012004095125232217374751356210541148077009766779789182681852042031167,1368080247851249989682134835301566954291381294315035198547777698146300187384177551154773374332738671847316681445631705509269535451433317771320/396677306587484985526664948144251481151846456548804831608221268911714981282810187994478673076884978928256828128879848482134899923501483113459,-103088034036170040919435099275678538165074621097305392040341979778472690577384125455713111496728984277667409705544955808058401066414742044160/35639135547552632622797123311994106978517075802319163327595807195581028572818600287888939171945042684657399737158706497150043272363378890701,-2166589183714913792349581535523514259840113709893609229117260459478157558408423907524697977879048752152080258868318612928766480699881324066080/1030273042674842022429761099315080816804260212256749384442697976405943027100065421328696224495516142841635411725056769423702880515130698152201,-771678911478528231619369573282621795274646427439405821485227407424937663989701973102368420072796309098137123711912719614868176974566235945425/327862544776643080167540018389049138202896702656045886183752470720012892990705091475043278710399265420526040825600438910747279093164842500546,-349593687043735562745413189743281575741899906807440062290246811771548979666763743350599315829927002047120686952405497723899052700279253269068/152893032096271347367788952412366061058684557791857348783160758274322947142381346792422731122895042833347819446884224454442123388414800241957,-24062904465149452346836376047204355811441483297190329542073758993143240958787801555433097526303327865355198089622713141076812682090587312429202/14037935696681900860619834606561905377740293791266801630775185637125550370052592157230182143342608598617637554069012553432598905816764844903273,-54362032515509533225619846832179640546432969481188899461949070062226865271992830219329496604073515996673831354793080899645094695874453760778/20336045139529717378081915684483444171091195083279988580825130519938028439978439017678174282152905369439537600037396596194270255199859090325,-125036775018284309183869724320989779577492357738688640340176428752170550232787380442238807290477839724786307119465742158096044755920629706192/2962935811441440619891401215146154110413813352851032193803569816451847521763514301394520621558659082492195776107824239614681526992987332899,132045725676232774339081490246367723402458171550747959990281997873375011934778754148867101215853309810012105447216049739761245998476456912285/33635122923092211391085538826281178446700195524212079098931730532353988150597210219027292253200589735127048458981354572019722257625371502532,762986000956966322509239234623246443019587699467402177813092443690166733027171589557251573955456263023582637393085302728990730556115343955053/523229083315829693986104238782555570940326388061130749449782767511003611751520808876051741588558454625660114327757874618251295112233088664304,7160193045547308876861344322227719791366421392041967297531025511275218966291261792991092957505020124080063366576680992526210082343897743855833/4552094779184476842489223170267672317670508628241094722015733332082950644015963125058225249736828479474831277481753999125303440765964361676079,5660590407205511023533986047543926763794947268105734271320234266610100259760663222961145862588699395277209903110806002831934493672178168290611/3116356447428655582679625832747508587384474212773551442263988498258723185981936277013919414243638357971845781329931694525301044474943100592096,-7512268130539279310400920123681524747431486849741428068429233491493866983435605566791336919234030255967281066878152397144560534322289690679133/15146162999397043975746809278881041404588492242371012192043664781774711130894839269457519201626942601094890434501820073151856758928987702077712,-86622726655444118857378038242995307545191666326868586926014794731602684401159345236026304436148816935609751042477386741000463865508028904306838/51355179674368847784776508756045849907026942959443691189582134151410712480164299160595906505951809460638646434829709839007427352954193908812027,-83869727865684165293832578015447880822055499467603241066864938199097847107408484495580473597498357992993581010042471297765279889085872156957221/70269807034932549482795183521029580832805000153947726765187094639918931017778295683737754203851313195238175425436420461796784623075780036727712,-184780017709002315013649770472410574012632055993243737580878929631329384102039304425094278687127017231590725224233554011437947863317497076135847/110213597587326193529636137477537581782434977513944606246579790153410856136572574266423666075237780472038342949035211830813191545620905074664728,4150564745433110162281858952317362722151038497980229068902401250154445069770933796030787191349195073885553588635978873179930365248195419411/42076110250123310145213874601119358853267501114984383874344271639039765731275608413463822147554683047153554869932680181308254528283099287049,-394163979822095241466841924550248881456338068434484707663097659035884964837594080931444326133188759066143225938776599735691943469002817803808/2163660671806953483760727351104805856146894916856567014013365300448141304777064815509103541636489957277693991657183568843309720667267121428741,50026863094988170597315708318047282411935278359324868084743312108008526761317611488145213261020377407262017505545937195516547218123301137832577/16651012621938254587080962918173703316157571920367120469652360021659569253000261244858863939875653158935575590053886205198694070762191424778624,1274670092262930483073738849324603783897333930690010111014490643287971188177515444994848401973235722271023471318853139186790791709769347896803/588099706912589275260433359172122056924420748386388359179894059213699202848431111814439561751511648701417636566100145985538062699618691461376,-563771193328545112880858878188596497655228756174336944389839476503777330405504365978270287276141736113624399795412293570367431262881643463172449/51781175569343197421252824764980828817344237878914629577328585311319575629492582623709844171172556986371477124326317915720551418531720755697240,-14608285529261032018538964196868705528632792236341531386465419924013378399769411418704874693651808809459208719243481825606165500188012256299844/385581190595064100606293596208604905627270425581012118487490232541536001431661242805175309085578385380939308512199652523184686826610909736399,5916524774888439317696589065692993553115010015067293218135963263293279236085037848278584538659382747596811992968850739193903230454814140093456/2914303882679868419242236722718907232919335393394188131947008831938776882271757217031325940656103750106469546841725115712309173685967006823603,77828962555117344108229216828848618425347082989860619854921135251495785967682926486126664539688349851598185411510959677211723901188194537172401/16352223220067447276081329960645915820309048462197069987922698840548969955910048372887561877935916418269717615378697409493389551444526329942208,-11727738946673841077782431256059317881641055493517918813301894149985151095122460024598785537418927710505555139915457962148635701871244977366/93988717069609160089977442248250805182402764665245570312695634246327345222572954865441440837988089433718048572596896755632948232715756383399,-50271226052817848296550478048132757192213325962764313750714321990642141140718185052111876131088256223216966141801101024879069733772964304931/35753556443092499991352607727900772092946597531974936043389409802748349210147684329640590685013217939104937382480479094185828148769207512786,-11433073454360609214938502982569518796837890461048376572992298305070837764155152312829327819456369231634821142049749979379323130230573149218/93937644431575545647113811340896406345756440374346216399769919619422947225472343485474729280819934686312991218743463521315983751024321931765,-12009262957705224337875546780441017189879441237776603005552290001267743906623441884530850374346904926680304288432163363295276755502168662858/5198506291520396992059539954419446261531176223864830277293947305600771896823914044282463689788598914385176320875705647863462388846167850555,-1488148209010569647318121642909910468393322036751023240913467344637849390710875738734596641855388154340315474894803320075533603279534047686517/1262002724744332938497224624543478042670563603232293296484819215562979809311915801380649634054054682121598041084200490475443145992561665022562,1326084309690797159098260939623566053626979970581191824970065962381212908963676570886093152568977871644050220973420675350455408140174366333408/863710298510529042406340324825919903484082015977300192264310580815954800817860176895176917783412816484572236418222440280595597408123172186323,598535155045475764082551926788998279464808647145639032675045160731838570665731806505779131156956522019789410395242058137357011875503671164209/210726928164871734575170153900583915833965209113410940757431549673098767924131988016553173467137914750544093103637359369849366160164490619152,941856488646406486816512012730118081015142792510029393791375662226336436380409494336231902652989625809763571584820025140378332782777673469025/189906653277104968198553608275098154837758533398953235669140132120531040516975059117152304318135943831317396372890051610166624802033280231029,-499156802141424771950910269173076324124611551332659695549560139970801675075550137764022194564178699023649458159762210052879578059869742786096/225704818916195762007674345279257476219675532311511824484796821793234238844325407971110860980354591374960636547101025007539203530019592096109,-72597858138652332723733907364410667466240341223627311090969189197859230166516601935413818546125674546503649846429540629323224468613136463079894/21033786404997494205318500940315775565742199431625291715264632540857288522811464552177449592425566992895002838839644624207923040566811068987975,38433392205527872910414698812105817904708196838389607999876312698765734955815017682418948889916630077344026258987700177723527733118112036059/52051273666750255377125601058572237775192503165655702532876152665121938073014148711384216955813508168521931799365809977888201669861803590968,21159061747750319419693470333086135708014135534965165316849689665495345201540664350365813311205526685930099977255689953389908188543604012761/29841584144876463423867034408474913613477764939331130687629393837672341300746594806333777259891028129068000839319318353255703277262385773476,-3734424104650097535776102932950483401872666766357192563860114954073689635435699846114120977181883892228540091417580455132496694531656981021346/737510672099579671572515244764608535999470528337060026550649546046964270542180883514335994020584209207195867206334799246110266652390419591071,-37638000041760566316778974835083571614924594797813191877806998991675541990963698432283928206115327577136968119799271726343070111352659208357/134078894999223184755276874227799102584292863534563106199259294534815775574576422655991461425723853735743465847366260988107801826895139865451,-233000134636253061397303354596989869149193289053863656105686722037843895771149342502740351918473075559232221107273698922738327274957560800012/8853695310906317110292414879248615984065688392397094528701168778088296559555675773320881902769792658130166809889718863942843765357219628395,-7989513163154884422229902261412661119386598972655536005607516598519053767307372547109244314287305622134327165603247551547249938442702402570674/438270768413188118587551878050810070032113579900923803959397310871446080694636513337983867998145988647438488903610740410156987382977842067315,-33749178936481902317740542396772594194368070285673490277152472957192497527993096808461701306070959994932738039032438289979520558380832378924/668696740332193134773470949755481965553457210033301086291717266197326696236076345283193717003672687354506186442201503936765662039463948327,-711600654183293922083416960836533369021916394756246189563372750297573317081394778754640619580379364452615212947304541621641526669679623889298/16068556820204490086748094609623042976713408875432002083303664751305182077426909544663955445461605829510889427013408536912449201530160218691,-185642361160857738664843395776591590220520224651412868215138895179119877568625028993991563684844888604734618575566005117713234942637254581956/39738061990072736916647007190197498659436926288883012225427731291511460366023338054920492266228517728461812662955484530675650432036928519365,-234869993098580718393422977721161022923710369339159186721492505894857365252955140075164108606845131485511119826319684354295194261181076622316/10332945072102827903887475475096074673295631603635189932776668875745075385246621317904026156414990116475770443689857582662100565065118875965,-85641241524624881070411351887446698131746211833814946384704224040536043696381468890801363452266952741769124495853808557648412406249104084362245/21228524810703491789531762007779670846516928032155325384995261220123187836747693071957364807557842853065601148988582143765632377303723958189742,-21185096647095576971219241262029547139105032647177972647537507389929886597042442979371282728394820814757830774753745496572924826942313440890785/15836069533997721377847690951664153500598828130491308299319735090426277516553846314541988900872753944574881866434670175599110710131228479976169,-768422178311160403511638794499613969414180511439220201205402932805312574847499911077902088645842965484613840775029899125895182247793270327006/317607593185518773947845274651700627812163682347127673330380981336828729137452026376410199682990891461079659957973083915435283179833354078525,-14264019047303203714881815218269681185677804124480442897125119703056368515058600727128674930204681497534242879609438249764630029809128715799/8051198134321079099974300179507964099446830104010948807615004833478222387152467552508316950329536786425734686755138720116667250796868486823,-2552585615507593413031912828798583204523065921443178429668224376874276845189581427812114936132799318949014090402192859377384703724175655072593/1097638851360386387320310662618216086991863389635574297870867385250120309579927620380667620508743385983109774588127288378871013916227865769019,-116129872246754707862867682546079907968084008132900865046530577013730355699898488617492541958945645589895585581598280585009791278040338144201/28269928695672478847043862183024139273242212583459783382890709177649833685878154313653935833091964023631892679494244272828157018169990985209,-8375098903146193132267227763428700316626764044943748729796066280731429115309506707521581214018027614082722490006755554975946520356765727069293/11809606923585102006108555700193484696681833288665075812058049287068270053390144861319951972387464292017128784435249502220769555719164059801727,-892983371327109277787452765087738996187819719133767038756425002973102011420287914442441251709444995575677004870536860063316629973006573454925/1267199718596307935215117445433001733958256208158658008632797311259409719105570050893878094472104095639644463058663289361169896632249039807711,-5925182235985303172547220914593776483334470263876539445087016723468321385024820590334871694868105063191740965310356506803611702096491484132941/8442699539247878500947465908679714189573088696489974345540624491676526978636763101332464981962442060272565617873817301426507768115913589602592,-6085450755139368557659121577289009162096815126936806069127913482797454627147653075188006894087519054042361450756477456991384457244484991882813/7345090989015056000477470035584447921466113582299577760697027650551817981221794542686582591674745367933586429985800819606228645966952412902496,-149345091827338107178327029353995938065164226258939216552325377470359944020043592488994787163444075827441656771098623972583091140980890828497/13149344154299222315161811537561607059700295843918223680343701550471991113565413787476462059703799133611361418318858379458136209571443150276,-492797373757685870124632071274318037849897492414135873397719635815276833499154441664929652683118805243562151883989649416425259372766089169549/124361222108020482774963838991065804941353667433136449658791145352129071353230430951545549761290266774603230500336580422711787873673002369857,-56001783607072434245060983923115953612576341906342870146761142020979809871824451893187615328741996637464589200018811302761406115537172643523473/10960314506725305533485166073915615569953195923397293742674101928088158578586559230160211803750935027839283020255031715264617731019797250438745,-12183560924793749830141244727503324361913357998209047164065644869799145348787671395151858637016947607024707488224688475734676188006897333644372/1012247467158620035441415418353771806647448294730802016386732993749602474360443888364205506353226101042546355697505350493975065544755132129389,-14753300649070896598354683406062085132297196021987866479763931491288918414594912891765609826547781962148375126447844492579591094850724877412594/5069579902571923735512588368596540834587309791965691646571011482254508469001491872623636735954934944893988693841263483605443443898780668071303,-110112414961760130331713014208595886924469597575059659548688341975662273940420079146166765599773908877134532379349261042903412470503689696839979/161974307204223351196228902021759950807186716067376789411979176234054898442693355047671393630794980132096307614298803172183035618431194276486272,-26155734323305631228954286015391271628784455645845607019511927181595444786820474718264406599480535922049680898450395801800512605256201364023937/36941603665136113910643841935934658603665012688617019278271853135277278149447570232728294962396271977713085970929266430184195414150774889888811,-1284311395336822359296580326285458043148497535576021998019630214287736532992611337432501572070423010353999896888309006623996348988340625201519/652098969721742260715740579604058820922290864333186367344934171864816440715365502882591982982689395629325252710533957775485604967086303964781,-81946430024685766179437498923470554919752898827263933543851469746317479256818160209824277000569243888988733015044067659462821805771112046943/81011528193583854369176950802649823749136850709654748379508184610042259046557803644971638288852972807759827835411767452915354026963826488674,-317455021566246490943600699581424725537662418971428254856165865610612491964889128499215551838226436891272106598179397930764527655993635000579/213510414390886908705915974464612034900123935439792475162370536832736497521740305759415945336791096702580098471319977395144271409142965724288,3716141228889137485586513407106524463238070220405958082111812560648932949133485920695654900059386703003316429114182649017024182460432460831/2867316695415662938852395583563293951478614675675409046568365319442947410034922190840360602781162554041669588196700716982494368738985408284,-267530478246663480148333994220897759711631470513936051747216469128309058054707906176627959223859599035946425155265628898467706367324435026258/99644340945338954078522855563944670016200284922927886886073222058699983325284315456494104468000747588662256135965241773346804536610921467513,-4127643789966141853754873888803621971952788361457600576233515067978508695493847706575256704459922665409011252745782464366739495808006245622950/1862588446125032641902154449785948948980366200191817112096766624658744083474644804982676241102864387716701131344221131138020620526019021389859,-11945759643573539729769758898832879422317931310019374784929183227642661443648448128198180444327408014307729592055057588956876164335281825221431/9960453366824978655896826451811156860207781967168506187174346203809606108187426851258634943138311362186044837281686807928535354261529607113028,-5572002428718210946612852170187831147028567589891180996743055911617559531843496992526827338472181840543796643492127479646185567760877645907763/5093413317767877840520742774270610802038263135903083509962223835828816038321508417550351119228826040056665501939379983799067022998619953146494,-1330452529681751129400130671727969661857564804127635998092116240164496452781316115792861089760079546221164673097187655765061671294903826279171/1226427176758357502185174475312276860211873560324778355732153708024042796232309415389205662596449156486977070231180432131413089040514176490630,-453612040270171996192244366609018027939473515532171813077849763350570111746612105924697498563921299021332988167753166342467143602487947095883/386775604914077087206366900116283943904169064252303896479806638710922989385290771724135168362643371719785654998859277733136226683949871406842,455760488728427866813764184654769654636002787421175566320425855434036423466918799501021824033654359858769995858512842996856631652015479809498/1646087261766914994112053129375701055307114255537104774077568678518631514570528724476238696576134515502213982497042646384853505790272244718927,-5408830884510531146197675844067355797446979341789568017507221971918872018642325907591426362367857564274657935981565310896325455653161587911878/1291641612095033428014694954358495481941403613001443379947893620009435172887213356889026829006072230808452615133817396208861826554516751303367,-583080913522523228113226836654313419695975731555910331254338616293664133723779967434305131101572198947065469895522081932016755153447246033753138/204548269685288050892614179526567758857838919432556091853955313232377680974818234787457141102563672018540848291550558804208825464318145152580751,-2416602081346914661636583458809145351761961475951975757658170120377613715443629769095076420275673592728823843009851904214497359072123134649286/559361205405473499109451988084499870415934133530523121972059822798530808156734932840911982168772810546623407462680107018292833725867859277003,-2251805871270334764522340270599260267160711475320871883281080030449238823913148793915637580010445498340287915552397607967627015004647600081704/719010498091351346175251096300639616379749090502215295013398186501139916391629206696317407593723786471160824435751496518252821580932315317671,-291848053153975150546924240792755522349074566557473115108950512848943125714131527777052423122238443934029715123356614707877890872392124877216/4133840663057819500860875410444931322877488181149665732410847145754675462862544168505989206049028771894172201443850221450753304085116072545,54947231015201968847477834447994857528256405734216294125120639992752471215474239678344156183629580017060878108403124437187587440180429836930/75603555735677041498359932405163424033735605053271926430012540313577702899719403308318437592896609983904575656310382444028858236958579713001,-7904590702469324882337087479592399029581702124447072974528342462082281575977018514674540012872443028058462917955202888914805764746076878784662/866616801403437083600955888057059229722410978542926100610502228869494972003970047100666579733671350207079324590407427344788737365523211041729,12699474185129008092491022755188676584350898756727733687923884497105296743714020408298594898490294963646755509221105682458721024906131560848/21538825165499090060730127316860232914051335857344992440563215233482755881250954574167803505636987830290162528265799230928833125380317762775,-263277724418123373809507882194167008309109973572045888192287197952289030641380627967353536666642886376986294192386719908368391253360785269476761/65764347387925768676152779938337607533039420139884590563133418546663335636258791727143883503382105661953741290929688714956677019256721675426564,53749413332587066737374038810027302428750409263260727130771836488524507886182035604276811951662793536903833900801447347378440047516120656369/64747527128004377273141941422588502315746075486883846330910627875587403121696845274484364918305938233769568918458523370354633315702923766012,6484585055078924572289951232539115423934148171868777122552159726760457052902107492292829900549404922013506106140738782110463120184606889566/9316047705260071463249805151821010112332530106336567330374502730572852378593659573836347529737742100951222185791811151831462669743942457421,5112642975021167122854219798691306413528276170397043619347855867457977410095958758818785629119496880948163281227739835866525576494546170930/6511784333095150623914098957329803731490041511065471703027614982383208091930218860919830601806250500876615935588712325886568751924344536011,-31086270943083628439254323053372432656696477056938063327957176463249706173356531552162671019878428012278749076118425581123708629882865717866/9355241871120627115987430571297997100725812453011028518873503403205488670807045320000781020183402194642887696529388420599012562952821912379,-66915298910418598189177122283245899298000572686730754451089987004051253491597437353680675691329074315247556838454252268030900627436229746338/21932875549471277414777579974837541909439710531928422538833398332161739076035583781880470890289846655098635193518975122663303425183804354471,-72769195913219006358920671445877345317003375525708604705672695988640556634946903663023061257527784940210642486954224253093654944024653811202622/9693670839632864387918360459239880852302813381093227353719137107080629305077257760553317734943807780950235418979995756379354735625633074392937,-104814828611463762783057925816742265090152633655859026843053634643997674460575093688286229096734357032527711600668571515615347799106932584895442/28982591042698215872332276208397567567248780848672630440654949325605154837844954913006569757997337843088904114738152723331640181054739884469159,1413945004628719057850211051487081623447289057034995912296540467164575146770512840213790499725268764439687382148226499950117560843553646643/1706476031036551752179691097508117808547127744091796934863604902180060491051064110360830760273995437075464883924396784794510239661042754504,3363929593573796868965642423696194309471477411949694222471827010646308320633158965052781767958545555068266960446148339377188286508058231896/4260703708774455880526244117937853890690218583957765574829125779560668508041487895551251502024242467605839934115113239393694204456129287643,-32634285901937977719738135712801939359292559671822800939458559741222775695988198338913700600965154021719371597158641577653219168003130667204/244433852760018287972424768685601715861544045123156683130720765771199126104359160938258972760873807849637521591315023304020056749974819749,-394966039184327907211045691368274544664023830474475126150094671208776549628518894029827025945677136202693370222870682830484572989877442221530/2466033954905447665380463591518463457002455690090563074294324708533761484698247915232797002086051701326193154511204978601900767128336878359,-15427166560471885856574525511579053700500403409734057058780738309263684117124909175004432214386469735603606103745272618361104797792989746916524/883613809145846494089882823507740517916961167173816833361671211122119445565000524315073066253741857691779043809568592585176248305775701376141,-29650682715636351015297787953142323664077564341822648511107186238926554293718128041715797416852329075508762413992765208120754911301766135855707/2488867060968300889100957141552059910824637999029354616433807537145778313744756729745281884238462615638644827500959059742778180567122203809592,-1764522907104045356859594596544473475273102894234638223054302011498560768603265311667274771293349589019356228246685107513758372481420238180768/14841924638441074671643238413349185440115503929655236444176882096838263136926044292759516658410660531222283617814593465892154022045890798207,-541865227883952144656183310620749478846445329690743083402545473816717151275267644597830578840217971853872377873467498222276146080510909458518/22883814529449099627323140963783938398644967956453231430265442123637212402202216534912325039308982983802355439481018150200712956474322509755,-516248670890862934685117834224292980955483711094014934539280039580355546475348794870290524715450342838395613049200777540285135376562438380064/41777743926892339092549883041665725893568614698133432738693908983668040414192694322682188254055165008014366822464368044448401234098123213817,-1352206758938749120563154875177745224669925236536846840143549420379779552679475188226371733350279580079873031129227822276043631914913420199300696/280933913714803636479247111201691158249841613036126918090088416036288087242386945536744850769693911976710702223101262886331949229261989837593521,-10054385245143857954590271721636852819461190353660253915910821463538171661854356542202486933628711831733591694101077177580645921973084560360908417/1307994183687997043811630850690948369044230343155571395811572156606705415998417827269735684375475950760024708699988485245105830365727599275466280,-404906789719931489532085979205163244304708749391502094856740004275999027849345977630571010608565702039826369781331836682475343357506749777477476/24897098087090423224956764180292769484706564623004057304574009312398001737628716454108647495020234158068532968555553999775303111741459757719295,-18891110689419233022110620727808282854190408933382702946299330283743899870589539960226573586234654245503975356902002335534526516213835659372648/1257334182359830307506655898794727263658277115987887520761209713099221628788656019728814653807724559138063381373665799468065708883390255719065,-53949106443244975700486417264945140053307344250671260600988666585769083073070721870529020153868038605560283320070964328827831498209777074827403/22711451942361541131790605428299638982504349928138465227115376149048695973829531785510133154262148714754985588501545851255700762812203440936321,-2380091429119959925780647437862928522356881367355176566404495081627534422810622701205743849157959496364423967020831841325642199461753867532435/1542378086466228799555342896617943276600374816494216264419120363920863440029487155049813551175682397039694300469915201568156284394411076465869,-129314201628813357413536639219818569561690358258180806376489263016263307360679486587771426740318802636664348710334465791811756604870428184837/61335065801521545103302967141739334200720741396631759401908143829413472595343053788654554271721205331339801199939161148031463377926027489451,-767625738335527259784732287055727512482195181692666543302237590304911852936112527676619314189382056431746737871295159514474490658697408418741/22897463255716822989504566262053918455407401111064285139398918017127841602947098894474515915162182108809747808163932706472376728963811636608,-2057800108561230899581330385770163434575349591285111580446587009764834232920909878703552134424417476541802829419056711660112621177376560009081/378426336516704104080636506955844490292744229279172384472877377844886849728573350628440721770578720808374606729368250093864213868016763516992,-49237867132560709503000751544773590746690729066797002166692476962692393297095111487476031844497564074366506923053783281932241618347467862423/18841583716262920137509412273584896829374714558097904614604999101325376585815528029212914596166141971202517707294698107479955757639001113536,-8817191639158470418755875566622703376622415603452644200973541234931488794030300999489507408483648039798777204528526640878988054855652284279/1693877986792301316971791243052530790978230534894284061419760556243601243462711288097540662554679028556523233068775291631013490585502954128,-22243364802772657992783595645522362737701800152414354370601777705002356140188030898958801799114653801006036937243139465874749747157421508037671/2500187621916252107306919691494884558328144513007082896647231328175647261683195511121164887359474910349782477056502584561421692787074014994638,24019361337536808751622425530530592802267450947997586436967636419916475755231865489585951673610025972769537837169155610816888770668945170633/83777619164638147900378832793979137018297881749801897141516752229722307359320051034138343151876329555396397314755197570719652379028509668555,4568810523235181392478836128743032850112330669453565039369446610536123750338362916317279144139561766199819605178716657991527419137483942912029/5079139775303668189182589252365721871162225973796657164220662270185381892232263615434362470078125476135010422124926699475426329591651984162816,249938554736135492967436497431723685793582582657597447277434586887783467547368519111440474468567284933459785605364630216008350129925984250155/124920491000612369105512864108121880364474860007430375393987390212408871388078410426040962810898205062003324822637980978157675870998720126768,455390965650686877499225920014971867290661099909039596527924271782499411806079386059512072400951735455136008530779000922441420265790403385237/30632394567406282458555045450872867433563771606293468812282973103568383497729757197654709603371755633023231144009973358729292656471620022019,529149446991982435674840011021224828521341750275750527888720767864317407829589410299602548175380499382033078967521017995986876303533540874279/3376271335123387600029039401485533873705371612938401350408385190391563601627254349044574984140419585152537584295886797513304047587718490367,1090316273730597610267948996668374832707753863372896707375065861476517392158565759448992211216146207146882401653951234039927073058030678146/8477481751592113338544292242212797459546767973108673336825225146203822714457596603019955561632279371858644566409696054276790428498673614681,152264824761850836262224683690231526349400659638614340050150727734526018441200336596039691561242893473661451219588287287596783782578804065553/46162176453267524403834054308336470409863738881435879531099120733109268811417309743017929545700791854735647482228331686433642371046541725483,213160100095597800760555399956969445035850010438158511131542332103206821710556317144418144219826728417386882371214254582756119244710930070313/45106800167150916643844833142322069221573649611777474234669666253843471099954243345118801042071918183002418063428686634270451930664295782744,500090730894754231400892300028871282593612498869693775351305089538284758042533650678254655096647596813038265482599891830347419000456305060398/69729459889704113818459170863951885124475987367414056349386615323516787833043003976160920475493050468114242155239226105958072732595483866775,158769408305502420124009762240620516646448258256670773357076715706156992325587397655772534339065212843931974900557151647228313422155918862356/50255881921517823602462108873113656507167142853561959346457020290629276385395432163303868139391840645534741866066200810029782592105901263671,-3144410231280218328033818506603195702829250553740286185272532226827456916403254974922942236010090809360786900930101542269306571703436921033/7086847617729476981129466805921303869118622384210683742631173152259061501745387751769095415243516154016910072969336724707591889832098804778,14721170457448995008833737996502663453267361574972798018290288958998183058311308114973359105237875934955856840683143107935798511642740965103839/1112902399746341340652917700945209446991763812683078967686043620804211076392852821585549365731336531160716565619268145850559632608914459836288,3846900568620632464352007152057098758287686832165253609908189141327694131516263287407003474546737977744194712864860028687929515884177695560321/763895068681144220869669740274062536457774696245478285477193294589149135173606978144200680594259129789369665451428360143953630531499742215632,11191223207537372650182988334199990215988171945201972103501853316919871758539163525084498800740287215671851143932298462156158764908408963181335/2089541611493643897560803714769329594627868930290572767876801985103399447728072871508350852964030201994893913055448329108486717230730817356352,27380674087923483023308409407339230094067487369171425721103381839185876957244719003807687572801398324382765097789570207533021291198511868068/4060256473953625086785108152148353229081565512622327766993444441720336021543652948488927940125527614723977424001104413869214851122955758835,1160764617391083644998471551734520171849301636528559740095089757156724546142192623824796334531871808425611917137432334996645661154134740453337/390990929817915006925847151208839710004274115824788070007125561227295064394527361642226155378938218697480692323476926191729920112623649942544,304231228162785313185934825702255872793226978911560936539513420872033286228929049184485803452310109678195257803291857160351461969133104288297/334015996468376419572136550635758838823425430784013108328768257771992935672668168218851722136578222441628187246608840746967383102871669758976,421891723880659277563201994207977295764185798844414066805019195165601106561230387840029819451180933497938570239971077125094300173783595871541/400398825120729663860282186129479613706010904763263839131081108979659429164518706824193160150491682671287170914707107242757110364753146792336,1832382462312002056646153370129478011730745608884639358909719400751028921885475833062664828039843939405739873396311005742075572675675240552359/390966030462041770646585807289198406659685823345715483562531197856660176307736530634891992464672703649146981461609325752431390090187148880056,94287235771261305782060729440026841062312488765130724046252142809655447395799094571845831018397917306802479812986875561988559907427716499654/38370040432202502364611317102353531546007467802134560400017027941331924411269551926328532596714722294470733152516230044809166674135324917365,463341734420021179576860078332764190545903103887369875217410431220922278423267712128226415414573823010113479151352310982923520106777110388295/179416183650742276235813099279019737373132257539692846210611676276724605277953402305671990664119206978710288650627245464603284402891540537014,165853329270568102812503158645886730369511780631648846477313258981108886272110719598914024757323972026503913510607164756659594017721345102097/79049462543328497203362477890143552468370491277018740625904395044524602354069408958491571168014585772573922778274971609617606441816072969990,209819265730738789623848463596759917947830958148881747891427506208262167567915719863501215961348072287692207928688350130508929370215423332091/40269302862529876848355234179703564190988838426631638580252661584604881572396568062396245866311872625715145895640006492732808112162411400828,6228955087167525546402337063207146418988708140582292072591506590189873241310808882989977119975712962169698474852734212351724842504971834803851/2171310460293942679342626650485790073637656765702135770724913343621486636595009060176343685829616966121116815391271430545147131959535820429152,294044137945690990522008876377868423017403572554095282584667278462538891673014684714387726683474290841416705494490840147127315610283154297079/142184979176705908308674085381625767542048775699131151601878359079117392065910555736096282576581401307721742022439548826232862492631143445503,1950528165060715308320689364753798804202614658637525672759276002634243914225299438082033321480530653669471430379611120640757978060359166346131/49774127202114735170262283806358968901848837386569106125113991055565769476414063546908897797953477536653728995453651802834464746535953351648,33106328480424707543861121670853574434426666657726658706345106838585591760207135051448244947671577632502638448470501560003174159976796669392743/1672767863389452668526216290453635056427004761112147927916007826057177553980640464319394177878018227402546985942599266090370150680386052802432,237670229407773699784277793031411927881338820883399280174187948709449474496709273440478062267142605618697165340713207136562949557534956950391/23635511100107166494955548651431953393867755621415080115347201291664009821318318236487648848024841568692360212036439184823299791610749383552,189780249461442387829471617889081061789150194177914272277015959875119054188289489523190987588133344034029203033634943114858463902718196411003/81184279242309620628690790926930669482880706146955503405459678101507038495268497638397809077686825643584933225414683141873888412871697804300,38933894527751887534419236658003939100079830822490432457451972452969321689864380924189388187122870949861502090986346288472167651595632087023/24685547946676583143508174505401867943753936327354041965432291608569569881330910651551008549353417352891352430011474320540278926508071178724,20552683628548173664123739457316029114706438086032659554115924867135415658202071148329507327864961159271132446723191628014033320582896056602/11632186336644924394916682834547531073098745115202788645930408356208423666102850555185700096883986522335327970079439754513497235751578481411,4289417455287807889804564172081913832891258715280525622060489797571084138401930066911768685029271068713944408494195979876387962815506423852589/226321635883764193378314950895775454580059961627653611633549264950771792485503919124111011496822094486267463248999389970472993244918034578202,21017864844524640572666197095922240338610518440798383663694482172476650090404932242941235569666691563497938597624019683591679870609217355957/2685723392439678390790195875887800110205536912978771817299619755944688980502130953634039248665743219842580202205871361611915812013008631451,-126607296821035122472961884173965109600960155323543500161896643965683071273167632527854235977616105247550078407313879043455189845367815777379/82267423839217967158887109676725819241864949131071692350769837786035594689899995801138238629121484872412506386707718260909121347583396797968,-210167932031066621498657231456398667858446285194975259637884093276283847773945596881239743401098129223401853120874502676437041648434041051929/108026088099312281933652333090073350635694900528812076977098198201823628635308384337850617301901218639444828318001899869109516615228438520776,-4712808969957458390600662486266923770532731187566896347786006192321346026404260279029620705478147984438626994461685051221155205023265599040943/1606508893417111346013160183557960176832004658623071878227171022072102168884558085089129096495541630560190653969689506765708236518625150623112,-68439380072884862378060547764312848405412215453730631104314010749055110422330407847139371339416430182505921716608416163880852702529405046330541/29843948960341376450955426354724075590607968752615631289769746943982010944194051240246747492866109662386236820942954702360154792390423050301240,-35208440851039990708073397150779604139089292095915258065155596880945153750215569241529606236521230119330006136445466407581811209647330306838801/17882713051484725274380375221516809856639149620216653649863582915637382513269439510453580130780093625228026632628364696169470260614029761918008,-5939976626359427474576910451127695863105109091839109533605467689071637809181783857786674919299685347361670785982655017796926258376901120194504/561216593099092631572988554992881769964629715771971622836825031036315607149021831944952564349649370283458089727045263401019441638455056953741,-45949343059527342716580235049951184336249586652882862850625774397474198218895042922367547980451074822925727281765172379344307177913084224844/156081454999529880675553281864954474546952358796802071988943762853421795809891393574882003227227259252663804091051134286750994213723690119,-32434809800206741907579863109498721450833752672361168274176673621474707588782992778266125480484743286695932317955555666476435988158820125490181/15336282925460558671999266867604448033240618076287206555215943831090176202448318817378714691370903941374805068616391432827467543178363375382624,-200747776339493446647699627778465914156157292959856758333333890946526111926651443310909119473573413974418685844378697996116867278153747821779/80183088302054804301475709703667966851094845040781572148010923623581518092153451640543867757512083605553265690345977306182540915044459234613,-600063203961241554885768603606474096317501920845329149546184804857220449812996074395366618896200499043702119928227792623960125129539057637826/346432646829249059545403344932933036335132682978860039970834259483144534191505436963050710133653762224055587751577198257813892855347005972073,-1041420400186778126898208046767549188056226021152101103632208566745677195495103817644114457512778753520799628899851346024404830089922087473626/791044204649189080096383196305126861805767716103555782691993467807240074520471797776442868405743201625116179481051331227725972920174795788029,158435599070444518576020527166950321458817039831589650853620782461187602194694393046899884039734528317656270705204326920322183328997460484846/3401257741632475577135301383945161184158412663552420204305850715801341894638643923769353222553318949418317473637286949214697388877546192065,197302578425877479064495191315416097343428257535588280326866892592734590769976512760839247851651099575075413506665811804837532549951831292691/55927884778438800486566143513775262980375533474865242554518291430725274625478686602809638786085336946884300335197226050769209279444580079019,26346438963144744156643355685592587702261058275618864494483086798859583206899592015751161869163397746828912997879290685635043269469605857048/60289247324640443215845880106220303180215548955263738954312289340824468106005162034309238568913235279526132724661017894487025823399744674577,368729415555500728067860231441723231488961383852793215989351245527348451257791782508898875428142244158339085596125413536484043853089518969/20263302662609733474441057448317506774930691228884922462715055436770559960895488223071550878022882121927842077085788151004290877430192115495,-1203408565044553097364095554954680823279241516362036380043285602986145411229569777546768511270723726548958435832963213657802914110951542184387/2031689876365743760335910648342793375326146748968989916715353260737311521001361149928158816937432061025351148129384926629500593367321587702848,-11202959732884844488032563342180694812438495012103018536995240681844895681416130954567905173455876456208908460192878420345559572923830011788497/2073649227853039011278999479589794246057633857546995426089575197599212147447725624093392302746890366090887854863057671982451479603633280687000,-109244769137132500105498383645295160931808623368094180886536973308839826964334290345493634377239971174525480497556274206595793297992023519393691/150706527429356835521286661600707310050754574270302380327316221099889712409201464562212699455734750377460600324638830717090667523545674643489120,-64969505409760048479609513830828055932622187057004866687784170270720332844603472908835528943387710289343976684575077627881342931029552400096117/84478943159070103868526142848929180924034073782004046480539201893126010017952238444592276669550234391322224879618670246576656343509824620854464,-533761177069229404761318383770045857658852992130198827983814798669480919815438433390906309218014932581478246101424918277642180540508743804179/364938707773382864345467605997164124044878713112189153494651686338489095919609401430644156256815584551999624096787043681381594831621613995090,-718415391081766177779878229657893171460324064699242190510620940469840478476818001448696032163570232521741342930399141187673623146043605106853/1633678796128817357490011084435751942815089774725190225363049148056503842786874817047513743467603654682631519704066536976287498449653247098944,-9278539752607244592013716438588611799178456215877730074209314694068972962005665277609542009320117775657946672190352839419192920515353723870769/18835182410694969234397034519522471477314857737432096723030318825682580651581398411119948683162379712706942561811838130020832743171180654086080,3450767243680197111862389906585920506363009737056684994686583886706204870993729465413500296095481039700387139088994244167484045890936488142599/116135116697575307307979704983051845878831327079589008789995027601527092238463765288523397679518798705109908597583530019801871767124117338880,69438826111144691927201701952564016791143070054554587169423624924513410655658846052609600317869541888838536216505738012319362763481477020602/23973522721479323315907206402266369723957223131332312963273319050364985989864450004372441852566375460599270796567151437033232546823682341069,-7794680268654303273924460513014804188507280072288478089570389218326401720748757294024523263253620843595403453541844588139122573700179889970321/702659009311022096845592067824232995433853208681007777239262272235898600261472542090896870519980499511629693694582068540483455988833265232280,25417393821333716028292841176115498371020766513010556016151258187053174113849848242791026474209172078376261152121862602352454972436707232077/21838163497424729677183573711424927348490819169979657386597192913755555340937944080094676177321470509713017366895938690839063434610875634976,-1009389863394663445980733880991378544807494708435574724388149306152375101661077947083769379841974357327310220670651992162889714473654083075291/2829303109647316616395949422939561125510839638531641150895220335646582251906320389898815130624937646973561662167359763941586994825300733297216,-467648839067772702904826322113749330478601593614481721537733651337850482435841350017549705070851489936543978856954347473944976941782750781533/1081647504947038876906956059834547830942548366785082304883314623334255228491876611918255838736738535203868180169832685627384450627061138118072,-67451308804717950537223371252437208499268835708624640976271391310469192490665843968822378491380335543606549176895407897644405932129665940078/194096994751363794723450704420938205892924173036643697860913944290370891195481581632072586572635962240162927602302058142813829342696164228377,-4130644672434371276713050141327493449797313943079639983929139353017225633562245660580013862737916648307237241359473431143213317385579318526/13227563190849079400696514747075401260416470351933786545750363414056950470911160389026178361733234111455242803690224057541114090984886398119,-3807494177422465001777996491517706124571323316292452623990495607594400892516741807799232151651102754789764061957442069576730866333565719371/10885186782549158646806902443721006574483086386265894743746849463098048711899711716122823585476239390102130422479434302982505950848744344659,93299858292061532881589113148672675383324224746096722060346246314616109427220616724291801874923395566851735592481658267646919070274415405936/123931525736245092977802189637468029892770498402377019576336191575155938199632091717419797679100807350481503416845339502656006321679774547765,204022441762075681347032591941338611537180345888813145948826450910175986338170451683712099468180760755103506863908317193117409410252244660648/254509500728336104983604978979193542486291354726242740291468993614074430179305245466468262322139943095822639061614796833528301418856350831149,40819124432160973048150050346829663180843613321413151073338760237909397126767958491459991641836659422981031922275597259349237071797960648262/24527334902190139624756277699542818107204798168731923600050483364202143455359265634621371462833908158633945891656435565076716845861829558717,444426383743308746408866395463831737561887202099056981736324636078195849479844755237326368671599826664443638806176779281193964771119840225314/267401412440832058880668857872778929261840469154591287821029755587173659170999612179820449132582027850252462616334515129082898660354005113961,445868292711889594050759768308777825344067785770318676710403136774344314613382054042138129069008131412098820947471381467750464133867439074367/315964781993470226792548874582632366535255269549224045469553945575634407440129156070833319928807955507933069491861346498773242888212737168696,257697548467238882959047777059341019063083280835750899914385684078384623197120566095879392770425130928786605099528041462060224100551284402571/258963278823292441859153079884855301211799523283411019228280814718808444089372103953232679274787957604179968994669784052297632468752362412760,-36598901324392905897486433708625600555329763847495623508033036308961685293417910540796812725156155574406503292947353253483640573139259797927/154235339414926340104290086243195417254996193922282130621228228529717347712693236790295173804632977309977366013481517942940117166920686675904,4466054560674862921404560063959492050985002789104835293967544091708397443222063011505730409088252428655897460131194974342520594110569296229645/1572097335583815096539207090238899414573466916292035883358834847450908228368005762916017643676710324135257262859796120894832188864230454943104,226832095619316456862896930952141829931625021267854777800083776549059138376569970693349574561985462611364678356771347068267102482456972798802/427814497419674541902664916863350404291715986098198776733005138250667262557524200817172015878340160666151028493520962515551547476375552278431,-693767532940965789898386941729226126442414973464616560341048175713402361179145951693243346862273402658593529328988146340441824434873729057119/3941847852073663530015496550183730362454051509768616760806175316024868939194886000760310534491782485363523140692131398510409241894204040651398,-105067003877009416076486743802721001441913495538543284335198112211543530729573911176009474903591665799611703708643155504546983648322912404739/327143948494804498667718676343070778313941412056460478194515199152000686120931334041959510819081418106613360303822091708558466346102104508910,620143741293515094579904591193271212352983988697031987621620090437230633009461711456600021096640158564760667447059114723242363487411005414873/655260579052080530411434051018376807414053532716566352160974698404810484581299184955188671350558930255562423216175276320931274596786047614888,-1163041071484374085642996868958718590486233107807064976668257206863419323212810900375105477172913722711444483670402885540300483871391016756951/5879933002968179968514830697689124876968775311773859679575038758177569329126216740928747797851365858281193052155500183389327370298681710315480,-14499082997769391792332050629876582284065211898001602783050711791237866377268829218026875709197660850253937769730992143283486961340195494235/59762109142778186121560738454420848548510551439699793317427974880439441024757512073029391531160816495912497305491070978338978697725919080978,-1445666386591746091191481007315098621456570475803549477210259072564011181650477337795891116214360757751702708123577384903407581359532957613417/5102242145793602836178585985867348722293735667348182503473033772721088933595758862503447689457276154348595356282444876639665479612130499218496,-15001922682951888741320117609027483413612733800132695484887994598234489100070481424629422770949245926947961249710231863477824778081553762563/103332619846406573088659544996402211470023501953769885972995477936009075400177394231060347708540526925515471306669719493266328183743858289574,-21416282011945648952780356007952453381987036395611985720074554670926587202005898216278370896590047245839921425487844812193550880075259820523/274762197498483956749950350175103017760109073239419790975198729346108085911379872653392506752428219229846938984659624972574847818386423855522,-5855057496164933040840543318937391664376935766436617961855170141204983168388493231122344006660626009207570439696886161187726967019308907557/30376271309613657968496335324497622862986727796899039170722204001512566465909861512723474827658199407420854819398474400193570229520597563739,5660343201626799874040721345674106679582373542658668249656057430735330115534142443192718977064249833312214458554547410277886421447500687040505/756143246784227014710683685036760103190522292890307170309182933551490188374029747538609966331296645346906712441124070919827764306631387041776,8150964427649297447946532671831422495349871993956638906434771823432731729428108928593513493980386197437923144127485068241112032431488450966781/667869359094588772083983622521294652588098232618869617315962529374573738163022849793981611654517583150581590457232465767086881450368817552778,23783437122122211804995573644096874327973252644566726103351818444588973358084877125437623644825482206929030502132964156304841819956872808132917/5445481685825397210989085940358760303099268259828902548804574350900948386061120845643268147906063399858566328435710731659881640119810850659808,523517480247921815305486249779601609054950909034648285257529519011693745366292395839462528368670301559135883387273389475120310119509549782837/137256346111162667630542203462514637851763132123379854053923989822484590226730993125470543338572056499346397401000856873389473966954782939288,189225736021698892107286281496550294787443740103481876594826495856659520485981513577069525352888351384723267296186075952437133529389689150467/60199527044604001387169052007885120858380027046385964453956514778960062075112380713235166202401434374687334949876743803910668443308591144484,9326748150199041023866216734750034118429244906333464733408474861115732101766828712789179562594582591881711468666184191233244639039302521816919/54590586356575159710638313207360147620746149279738742798579962010220836721278696281477583270923991385733789388991242355723991732933205480352128,-11353175506430582752322126223806875176602147083241688514888720970262532830035828077947408055647065242573665595118435961484046988290946395145/62735060109287135745183323300180119795314104159327455897323747670761797458360047248477536416870983444452844233673990481943139951269884261316,-30185638768560163890997332339844716692986160006377952193534093841287729851589932807602479892914860962996037620139509167696883997805517989051729/120160000550825269000379931697479577923378213216603148375838423788880583744328180548645047073172345512279642037296906794683452371513060140867072,-170164966926783544984790108199987678318485925802564674060232475944845702239562949341179753830670714047850502293764135972246003473068115973571/648788569216819935549553400108130032565871135408700363041920178702948535371584102914533729241587703777309686414684898871644523572715743537461,28328949394512637512813610029774525373899664462221276955818190882997993864555192001962864987384198131013035950317949127917163990018019000754323/5038692822735967400570678688743981909314887807162966414192778993050906647677033436861400483249125289169537651419585559669703003627608045497232,111446324286923866023896202426935897292329626414349891556577327821533255361598650272428151796272460041831932554031221382903679904628306446592/20649296292555391108713356586121011627582065784459380868816383988254018755136373303826494169948607929063611111763580878552833574809071130333,202693195103465646844818289586248376606345954770416373945201584835329038988739235730218781358459834309179933139627666673480500595009749519319/359675590205501724882489980419286727130502277501906227639456925509963181801925036866973238317455385563372974032880710137571638698818714868631,2032007838522550739132834010289729570507019890239810626298084487052238657201409505130742181870045753581911241987760082545608506652797983000447/1523414077411062227799385033347324516602504653032487553727092534711081465048317936568074330504861766560567324977983386964488713585469129907072,1895189470241220263383012597351060181185089233530199988400349214191896018525383434647086631982608199094417383239167498285651381975637874698781/1417180525074836290810484991265300813678969091123798419016968916481189673805054076583175988262892656700703710163222177909990931006628493989504,184071134021432861401650665022842310066229919574202079424093802568163888322550118039033656825475290977581456797350438244713141497715801401626/49087218665684036809476406565227173621471310154418684611146816393760223504809826281474537147338088179377159846875538292278378599766242885559,-56033987259046629089759772207750463898678304788102546755963576010490098996824275657080643307329286350108228008843110828646320364136395599270359/226873830259852906671892853883506101350703299838151627082197527921503387853018060007766565109165370287386632008131775852966761087004929697184448,-319946657526449833666084769185150015504317272238402299696460440288236651467271438145604762423553879266388343009908982779578324434646612822077/742239544357532089490360991714071661479844077576117367969314334580915630267788453142082744733472300344615033936031482749037689863859647403797,-108208977601725649929004615519971463075556268961327409164030689586070609763206785019560137304176263968633705984113728443400979027072352051346/27850562369640039520766229305107178708462180377416085470950445658374803735042158172410553865793759738713269458033385501425880600255266001355,-337072188022482309246095853989809900420489255420949425930296314176202164977721558738797383116063593642288790554202940381762171126194556047582/102615992876108605272693082441341427189322929349862840096420881282075071819719140948218218002889051292122612163191205680083247130081591128003,-10259810322530018068205561680115520492146534879294910317909501197161690293090284483516148908765917649452206815936216797991635682785614081065231/1037077100854896106115969605970563252183751690386193526121545555324335705924353090625899751370386786028716321839113509954230583880886176882120,-1712093072811039936257435881386150836913498811171458166694350831517388349096357806789138018132914816766045368541062599415558561866505679232/677710083548648091855075408635256504166125494339719373840368379353234925332777533459729006338697200301698994991561437125855707448972660821,-66414703022531421244620805688851941489066099759318314990032007935437163311858110723317364414446653291954513076784752696690102255507959856840/37921386645605151942404875669314035697989159408008337108273374158145551973423089023451408057847875387865850119150943591327407920669055907893,-36263537331774951441714445752831620353448369128404279757368792050573328681810021345099340727216896265217162011793818486302771812882894512686/21532615724102409210852349567110384071306364384964436111826361723022395449866494277890792849966659846439582008105356878990708851624623997577,-109027749587779026307029883726893658289606619081335545786823472035154741054594984968688644909754142098479263877184647913299939811681721742126513/158578008634484060492914340760375472196262448664449699130678135986408247957201851623052563390222487843486399836049492321801835375821080733265547,-1649305531839274272349561876768931504842889559637992497680851452413971022221971345804742071038334061878071350149175509568902143554892475940851/2397365886990677939758445511029662093541485480883910199119164107742889326829354183114936256943809076190831907192565893631150137118922322812163,-439032659880697872170797957538816104136039423529943911022047076168119600748162389952179195200422753012613833086254681078005697797499347970312603/644597930445859690260649683058903082589569185662316378985021229705889719498708506989559204106656140634340991527053358178255437491885220794111522,-1326393808941639756713695896995009150085300906385882978177026238684011014151397413047137438446840841306681415690419856431918989543342547136317/1965664105896855019740828882507978934414853490542179292208493397751808591652303029340100248059678538489448028508255623259938107204738009737854,-91280170967641977738503754918746175303197663679327692028517733816600723278990745201626260230101481523531930944806515372181347409213366346468488/133228514373621738224792916716731154834209700946863416118852813562939796792400494685417787559072303808330844720814397846597366430379005023375993,-8078038102850236229696213282921812087903218530526745889860500345414291999664108535977517851529585404008072622965408167791684702966355813575745/7278345203190068789196849460329597131961326230938833559940273226243731316968282487920383219367517803304846780087480774225066605006444378974973,-25722745436631278972013931309647535288905183566900420126050621725767746419630172183719221106956027075499641151153960251511920370457627443581/37085755016828080560677242618073931393453273310263012087423862554057850849924914537569527425679308326031246812884878079001173672876030708282,-67825275990494012776114959761888281611281283566287272129604662404029828785970491426852241372233361979070479833941899965524286728196499639945362/6233294102505206301394172796139780965144437895805670528368851054906598104439205521775515976508183276512527171397836998889852841023795351140587,-48724136372477746626535378848194495055905967767845341173393789731655315164269002251291857537790565950108633089417218704759956685800604975641156/43437824128349037977879844304354268528999528636387970923427673155781991024767407989465164679174728877939138981546682154276653194959789855263701,-83676095886392344608974594025546213452270390609081598270419924161608099587444434447960597013733612167622393652071460101267863983902874897843646/11941302555787914582001422008157914067633978317936357497427876959916879794602990051266847623681391474439225406049907748231985186316898762732817,-21425607706008817478420792909248311390943338692335796748134733836052827791923035405838943181743853123834695024716288841991911195127210162414533/732196756529977768680206686757353036393866901135267249075049714773362649343052210800904383073819190827536330495195260994391527426367479134842,-10012529171555651325216250509320752768031196227555134198360388550151990322981089395540309909592496987422393908986441126080090076213813815428121/8368387444160524150558539284941823630429594401617123049852166985982380109206615354273142339556715304806277429257073359651645061027623420394963,-70066408304687816412761983849225214444191928372683454179057843733884201015954435589489458143788486395286926138899426777644956129468424160879671/71397961102207354360596193481293996394778380647929199670149455566326414395799308619199092634000746540788350557742496921126516734216721150758703,-4223249716210178890755900800187057311300442179929121246117674712391671970056570306984948371887666021562875537947390575979300757283323411178741/4293057086887179700330316333650809535803348690727018440337519614818280945855244440037501114581339852848317873884358721575248218421082669561513,-75525051052474932761888714972136530193417365584243687801912481122094811757646764926573780760606025583119740823144964166431164547534444949897/78952236084540783716430957665713246408219787933567644437099900721893685569514084766113272105259984225428672254853226835027689500615392814821,-11275044707938454771106367951085425569728178756495135075570348008136547700507484697029900307406352657618103333046975943367357357768443205629554/1710293771440669076441422006895452486893649372117891655822206043636152955983163198444629967425323825426908613833952526792475873367466984395939,-36749431356455390373938913606332604121628623653078184822632326989737395541034550306109627282077800753161947564390778286796426379725272754303956/7551005077484609049472092746770708303451675530710040105276391028731327625813967782637584650438329707962457954690657148159202654278847167352253,-103239236104484446572302432324643915611113865025306951339453298816613327874931201433042667386363857585820345317957207785588643368600684655186679/75988363023244815583398457661417392667995909704655961215589591637010608765707388448197935970618502909864172213751553811831475420323069580640071,-148221391770581208852199267525976106476771155473066062983222951568867526092615732538017703911829683398636404881881827995314645856263005505215496/96938065962162996550969503125462017585634132378390791680219112024354973203992917044748710853465445260854470090254782711675125945563366284616673,-4376838138603873715157145934481060557867023657389457419023648682826125493446420362818482743978901799620595951002030567951891878745043816480447614/3143231779135632266363188215310436207704510383989861561521061322605312097601139316869344966104320223064153076972273238489223268889873787697569935,-463513986231482829693956627796151983065822935677307315558204588227026290092012299832570363970991942261035672135517324757095167350832226721797/1503118852167570159256341677716954937317839206633050306172094147816123712654109908876672090300606998461172842427645415378403857213187349991944,-518923207830569474115433724453474330981495742747129229811772772355802436238613362668272303307627266896191649754992106925624856600810474661161/1428330051649847672084787523037840984333626146984743332753973011821363491068467281031038680404217691088039104155307043469961544037291362287424,-12604199746235348546393181023476739485385951790366125139816757214681216725596417251114567768400288439002412732302837621081031468090642241021125/23819728075024861046916687254729329191756129981890797075717660770899899431215550745126363648944060911022848701802634152249331765768413436065792,-3545342263578477350487919862377035887910572837262450455284864507718834313027647481068160777813459011464969334517710686028102672187880026377981/6944235706396769295789260049687925063041204490467964755882149979105377577072353039629839127558538146169840433227578848608244579793191249730264,-14748120779415069984052004465446396914452763465738563826616931145056492923811583705438340851962728954185306512523453325382467527352420756702307/27646519351053058024176049832125994165401932443832242829374839233165540147474460885707155926922279946080126301106555032510650919013515440676328,-1001704556983867958903060883606709720485676627926034435178315348452321140854997071746621470307311144323278081015521438206874272918107122679388482/90407723505933996199877893065451612655840355315146303639044194280703044763854479031060571642211944450477782236087536754595264923721354034740277,-1028877895834542236901141277920607541261360924189619954878297966084779923827192462311560156010999546250226357373319802566416745482087163643527/10034518643482752633367147581932762048022220472021136066503127691370174738563151520555754474653895707321002035693008137811461032876366817683990,-416218222351136341040816063652901784624619054214061662552418680690148658972303028321961686255576600400527997524044483607439723992716194917699/3383196720092431065407061638280722018622149280326618297612252566801625397731211100936416434450648903426716796349980408676122533414979973384192,-70504271589671686533170744326398740447023375564917506392797427309603657745166539795719194912639545347621299144523137001179771466031722832692/199928462687911630950395667413418188066270243630853023694025410418747972234643538012634062418428997201956272934440431990909622757359943045127,-329657039169567692278533399314634159940704973390758501439046954633753291173312900967575702289098273551792186566608862069240902178459681302532/854254612688005411413183945985270792643875218394218727789815082160932671336671733263962173445167743832854840186015173782798251278645137613031,-234050603179479121018575500181145022080195093337017994605605651033058744916610042424578642660457855206710078114718965390673612116297570167339/842960958247485618209093924829203057993495764971453892422568636151508493262441715471910945052064368329071220514434198178069794043073418230526,1927845883543202914038877815156867021341319366507415554826643005154536226559786587531484665920068830379039314955208203544370954913099835686365/1120586946895972225348978360836948249513844728962274274730171628159263630203552583868391150598443535079129973557085659767153208455360346211154,1447790627683704278251355288608260233812024097154454923901616937880673095726982275742382308358892580900285154246806646719350893186790325562016/654869703996949118543317493412373196232426032967288099576442358310316770437123158761133089179173242282854709146137335310578408152399397091379,4726617293355891433527532026834635282642838640542534778328726300244766210922625514754681222869406724333189704926885602717064462616109926027969/6532512285908197369476211193786169799905397123926388036872011968616823733534341131398069752778961103080636798680246794970624567095310980848072,945911980564918759728197707627662611687429495777098053493473415995778544365049779028580636353510426695297549758653495444345772723927343738253/1553946988580599485863407269708372644017165652441833393492554677528738177775862558641942664782173065195932979407171706317843662909459422115926,119211718042365250121701350649255684488428930190650214370540199876183391714038013113476670740823149770229386957245839436831608995488489398882/227346566265386676768721381935933601648391850747651054874117949195236838177711374751035600803669255628719012934260696648243756927906456007311,322691578079711911350055852708942294674907538178442161789716083931205901558108006166093849631747947026378343024355273311289222999778260429195/603654646767012978355841500760423801702004493689019002052441790749088640666393828441864260251626467029671631833873632260614622489979304996806,129795095617674289703716003478560282854241356856809943119525380103983372616198163920468208812202563292710143334454845985741110926074485621098/229031971962298852995202316006275093698441732906421291180203140572440681679268244327439029177390569822212793186965860964451743134922259541781,252391053340712367087128723667975087644547795639847528568349043620690313786353428220827036134952894792762163973968407508563064626591163751421/334686305547907893974960822122154958737403005021550990374501612470156074902381945816556371283527983425166001514947449213292085167974555630077,4639928449491464646015638051427145236153301011925950986637889389753090782017981728015550572638824680269193401320291464895112877798314827258141/4432349910434891209404846496348690472864880199141003084251804654344957555223320489733195764660387972475169022358326045433329650463512160903144,3699055214315940841378434782696960075050765195603787340312651158833688888772955245597474078251938783169627640918358645110972055426511041321585/4922298853755594953916161366071634508447290492448519708062936398471843433334257016078045264365855683065274959405232632132955244922397549503197,1344051408291923015655149764512380860507008246362609135907371590254201252550201581887641820628979769972231888121924421369287947014959200688515/1843133802399994303900461386119271129342689856932820182998110118787483174322186167968328649052836576720815513875739189925473460180602744735899,46460383983326024594850669965634848774608246851177784529597444575744025470826432974184584701196898609649781156101310679266164178458444675830/68952047823333485747468692306141085421537548000118909103461841609503187194261849969856521085197551279785146027928401789471141144854755444689,5312887717851988556889092738950622695135512521374264697147375502357268159772543728948640972859885027999106895760047881048791106429426610219275/6380691076563206646346281056148135435040565495230782611898134572129994527470802921788635134218502388559823317390596257793825929235578841320472,129390637754272461198808969886166826510379827881013973431788810380659413328427700131326697801132268061086435743695917110905583241413870125391/157015716291105497152675741514857779476606654172255508377266440009802437760165874759145592586700369623452512342133006811986254995344626773891,12786504300840053916653044561540102405185781785384815176121170372528478453641155584261729959856415301459850706740960145776889836205949622824985/18891921947932423744201633414517526391614393617796160626134612334172228138891095443633245293595421049208406600590693737806379610583231152408718,12311225287006900952734590325012024805178723807730474772070045691401398500490453346934116178845882950243406530305122311028513022806518164115/18365545486098927083567933057864232553188744544340563771358428437300547637190326711884473957841280539334833038581612135306220959322422910531,230185979544444927664406987340093099343748467072611654146224155067948719426501197028816583418920634136609417667359581995134724681766205728590/387659437566693610139642291573320194359513277892399711664998011058425070094603596841346619112839091515764788675319583247790019778792589859443,-1888034036906085779037205272014336717157459989104409530368642477278841356646790975320234768756369629161278864434774386619412828265933057029648/667987715025088965383070627860424715859438577382066923511951807872137972338758908064427488625486650354740896204919293509012831960956521774895,-6936214812680767523500470660571930115104616185282407991145321237949032609708594067005583706393356856697173587578803116990070377641494573572736/5220161908399906327705892812037224798804584204547470984924330108601972189611906872028863961222616009563016954576086958030960753700368238848239,-2252781263675942367653442581918340683646043818628018927918763956492055105225937080306061386926463577760310808114287541432421442161497241667840/1929806546986045334096120506069833793614238094654769891995110191818930566593378136191889708104170177610942786788355104612762108315920485127981,19012714349907672229697226056436389236239591936174458317341338223349922584208617553238392955171175822561448246140958263736301909542498829350/98407184888250479738554575284255050360398996252624181613082659167604000424201195392273804381760058542216370819041318166713592699035233187117,18787627441798080365186503390622601786389053974651721788003885938732444969440894691333746928834458797760382902343127807559982493781792557094/68400993462952804431553552776968436885175838631539277990873501762457416748268824110361501239442895977686724263344438495972015752561154719107,7936517923117611302660720123989299946328152195901563523811662503517703886727114498393270976672003904221754207769587140800341964673266284505/29763225995239596480166111376678520970418056095552021722299552095856509270857445301105378569059725788582759869019994255222642371686698389583,118377960670821899997855792199015978634646188837067503132052429702396395057902240614070390446898695686696429771374431200140996451219485356254/592967563226866612372372013052902903829883962623796830936048692144314862994071755707457931289991962533010801689258323097157670160261593678613,348171166327593018078806630527233972028255922146064863665384725890853175535358865903433655073175966853955743600594145258731403265463320147753/410631972112782774000443381299915693990200929090051937337810351351065807540854856046257367290608857029414197779746077806177769811601792569096,336165342160859370599154944047118826643470551551924975127969137300637460720523517349152243204681405910519830800847759949759057967459730763393/1032476511460897565466490580873783440503252735041330953823733188294608987734979256534993782217496477957134367505921722862099768940477206078861,-1753134019962769321016782279982490929940497288009578691077692983848628779505988937154775079544534239448041257975407026790687330318861467018778/2788753077817557310921333200108344444664146489475728364907653640633870978507619765718974861463934548988222910873398509404159867134656860149709,-341134577693886842885861935015831832469295028124193032361444414109901826229407248403121668616749482628717892723847512177725008680053336537126/390197624753153133276724642311497694319002509167946571337374645793141503223642228557124445639856537444639333705733617634931950379876986810687,-152343767727863682169412349725519190293556464488729638081219824615841517445964863382568997284362666214472439687372070443503891596251127523900/106176339406316823323185807353114203298981960448028341932508351565383358838052399379531704174794601698821183414074423801986518577346621645649,-606173227489623788275082653826298620484011850507181715064000660436858581522569111260636469023169837088319746401151912118365724557311518714058/794969718611959676801736352757715012767040150050076454651102195301918578816427218830031708011666993813494724014142976430165451839047677295269,23546702518002585100994294544452913969040571264618007794783600174185910124205340406272723482548412576641842695192425045626412443892552956371/89128493463667791879142381131424295190398342119525692797412793945781288238130468341302070676613535181250978422776448803750087866813880356558,237342352008573852004352078573229727276471810284082851268934222425472078930158683297834366517859002757217286719224122398907001918515437471634/12316969890126019250087421492774264819659856516192425656244476400295282602522901044667223594797521718509805694690091050175724835268434556767659,-1580508230037626342832470635384392389674356682503581617512688612296384427787510854509055436282692958269947201275791247582881481112893363005357/3735640598922438662154383778081235519165395081034387269358698103260535936752377711908504705239848306881841491949493325104050164991506086515106,-62753783578820004795147092589848271768623524866581609289006645218186815196099698531439545439657101656140036449529253083352017509522443140977760/55621907840631011782228262932707117296574683389561601145374184353821310249192070401984100025818247880286325880651470532835966112435468214422021,-1219555657214760334941422078419832794741080813220684526321049824753912178084051893072193270399424414623733103546334326922375485050752040866/962735534347786853651925848233047595612639914447242097991348723733136982690726140918670472488861252689056176618608577769243802158205397061,-6319847948528194594269531986236542476622364905583336447846823646433328130392973937656814071195832696019195361464315189837682458775926086190528/5118853962979511230116088639396002563000568961145450474173582239954448875720016890883396935492363942633269663276948158052327490122002215304947,-61890994907711506599954287738359664676449305986302492204576225780687587887872224056758635642723508773635378815125833759319881929375570185811/120915863400214580636270396071274895151120714147603967169830483849246433691345972752543459735500750138586772608683293695044366463945517633253,-292191208474126352654614068684119417740280473687888521154959212936881373255588347146141370856527758301734737480517591713564104002151364261573/608653183431181881699016838202827441965915849060405986071144442853116217908828174552637813421655357254357595040221306104706703972948405650169,-114858817822561656564656789092994994766398922673911190300984794476362179070337535321342215259100662463067671085754389555683492607792560645837/208704240570736396201289670367413939132971975747620410685309469923671274911163406979057637819031549443706368645126298972703620210996662211104,-994901612162317916137545337206706192378397449089768338243640454476187576836575118443973851138754588282493450844121538068541065688007380980455/1247548727256549477566498932962442147262822235058050655716716017534714662167407357311826652204269325774005548589370204669696310020494200056146,-183705336313658521720734277451657415760048129559728766102791044743121542820484093436555202964778677170068948217993734496900519276139722511355/3228896732932891394980874576884562656111096670318023276690208087276825809963286968327245615768200963893810993192180883816693703585697554348163,-319192046911904898351827629748755506793233304507150198060726073144035037089649722277872464962209347741180612795003275123349581757278542546585/820897006360694725221444795430264762119273573274072746711148304373903086762605207749073760947640626165434870888156944376527989961520663129529,374495647311245727828011295559374931427298258259059457703215039322155879629852733926795317923783511934823481183943389140724736333728986709979/344994402715410740390193934514675788223270424545901748422118744462908700218640696588933383694658329342694394980083533366713983333471020604891,203409978148765876408801453637403325232247978909265935133006919265935724426437079502540004570424397134433909844876097619634073081030728231095/300111979092398999111429068951986759395840800792189084750866791513753363385303191254877314943339012512322798070762591509711227696341969811837,80212961920017164370194986963587058508221909993293022312035031741107021714479092665176772467597414415184052692570429728475771641209850242638/124218490054068068289723031926917033150512806169272846603533883384888631788189167821119606816213540708480267680281359542609531854813201062591,192191458432457230389042861075937099310220078405267143145430081103020997734751296404663036281522855103105072191903773629399282728988572923316/283644816118526756352934664559362237785814114381889865798369458742486376042168031170540258411825848037876004523609837114284236617861602266685,254059046306778671843841663663210346398968962001951323815848848688410568638298584963213581589625482716220572061681474361123056759878298668877/211686906977812137766931414540662903764785756364570270372264998485840430104214027964669584483708016372487199187761044488745402121003262011773,-4802248083616821782778659979863874611599954192179848448419418316209666270794423713490275655482485101184154104694552479663892591824713574314839/13075073325853661684755937607034639885559389602789729180240160938332346452465874919877003106907472292634989749354711781568899913724307983513152,11465785875956901660569599901271917201319521787128194101699436494435281434397133838128249599378331925139122339946213433085821249314716824120637/8335211329731839801196216975440637631323399985454019560287761237087015459894623357471453540957332106695953043868940998317683924259339948319744,18609242108536213232194792477290748359351817344311202818424506357775437778390683080647472079917946833378451154217360007835790119513247270673551/18898858231945324809009165525132735604789181064749278592714704018348804155508560276359070173822155861812590055821440988284537234899083455821696,7145000307082420077677235599434845302437871219253995156568204125038114823215272935430255656027040852627447205874673638937333581008213620732775/7325517170046670502914992612649782680386210875002546939274958307843661147315709057243284522238438695892951855130457903474228666813267456181504,1211150846224531843566710332541013819653986334288039988438770516687186177793777841685545980887346477495719042311670648771466557857438997537/1169878038977793601495449899365358540719093344048235743747350471212164679536685591448387234726489844698361437119830213119479011105015082850,1336702872582738390914659543950892916415545487399764185130148858548036218115143327846859765699834252783824282945242101015023379761560050663261/1323414045960242856415311433765313251965911659264159784503647167814512146851234741264938192978265691523200004374374401113703515577784525964880,1521666169459418629923071451537881063500143512250893812299024398964546256927446960568325664667065227868965053456968188040014125356258327187217/1546944316821990695633480479762384650123409723679553363864349872008161497160574446304031806451465665854250835613067347450387858836434305071760,2012077454743830087946374543495722499234487461369968186765921859338056619546169238849145233455267107886618206099264608232807818679963764732349/1998085290910171410363066571368625731499136750057751906683815491395959936350834108582281471833936598707215145556502523477489506303551688408248,3179709151543397740720591631808523422990059281324492690264108494640705882472208351646563298549194755534915701137307335161261966996056904709089/3930256267600257073967384424686565660863772082786900919902569805155772439578639710634054322168701495585943395006856376426241710803076488720260,1907935095899848309061275143542245745582264197420343120355159925045647072474391038331027255652609329094792643353541951233423373457989910685653/2331515204007333482210763681220986081879481121476701010834682772014170307617867953180412117788120429432720420278757999348473936731627124741072,273560226497322871838463846161413425949840160599807268288523646079296742673380665777144406139889730908181386229134359475056798404731142273959/331570539349155581219885670537784829354593135756078525809761232204990497321274912818317589961249681592411682722492126265072839401507686293786,-67728032788099564274106643737648376994212825536483325333604054888228643892864685405086899647866327167802845311758562462475529898282195842876586/155473355972301760823245322096420369673739783116948185381602480851836737491811913569671828481438903703581408729270565354173437886333164845279361,-1008321806262824283878201690426208298595573176700649618948885533639081753452522866201562260838532898416066430654075397906357443235258554857903/3584355053315890794047194672151058987141166032227379124090543903958702288088087900606844960799953249584227208626043757743286788209166180032999,718414794798159659347651925869625902008359417780527602218918842394394051072235067974385044693011504365461402418833688380004438522113323061619/6890538608718364899547268351074263089405103989377897630660562131875042310087554136376905296461032074508946736987206684308456164036237603222036,-211069802430899267292485145636176254962093805729020588826284728252742502745788165951305445812859212713095424430482126266611997416236605423746/815312576108398134000181510243267450497292892745479691388475569012828946322853499451140657507207919760172179459696362433762488525660857389445,366700712758824412528151708193875464905875401805137796971180021527931924132430884635194377865506593677531873266613515419286281761215009015333/563205443073766122531902264392047603747107198608379708496505650864219645145496571135208672353662806623060945535657204953796151301266999660825,7105378198035329865833094095322779872830831790290024589209992462343421561259776538215185416128552509285336465046348974593495727419477203776413/10927251550809735992056108465566026224577161544106156524883360956894143453778943622256286157417669149866043280199767017015174700016866134060988,-135365903046385845835545584621677467748276033435922327654801481973530861543670728068464312967295263632029218008178390364953367093776804100147590/116675936323592949008405434158524580460807987798661983268152469463888716650535533197008817519594650713036742877360523833726426651546938359252341,-4714925309608045305727949204327132676185392986052705966755626329641993590798211561138834006781791327813595683714868931786910536874794030757823/4693090382740035112631374499867161641863297298886229523258835908521661469415962423417129707834302129083574570429433292297365115153719949511942,-9245890930692163625348137304015075259736784138160251142062443820251545482262892765372305375459667267976568744259827136818935469439847975453630/8201565383116588618634128438781291057455094273871236390295092375846275552881700924474146499541526050550556964042727921689232838224451552056193,-649205372908838175547205768199385596444619298685646696352116333370746519504693836314325254818547778438161668496260139024497738729034530549838/328286227085159774388220287867685423037156916807442732758132044558567451467381411728201858003116053950114677710123903989132370067613979322959,-1521653017539012176458124073361519181442129454254518264527000573256782808771235943862351393410651209860804606821788414147404742798667381890797/1810957007526469373441545858135386889981420655949463664488670805399115430174880140120900685166865237537300701037753340579028234613278206837579,-12814531871516669570230258400925078790966871018437225576468945021725782356862522174919867156160551158294988972531470227954126373151318878065770/11717557032452428445219008907945508742598963922589863793748020305075464783877171187129695424310492152430395964470018744787205431320782591858197,-196637852316036558433429018864381142628767924157729038070835737220337389011138492314988576124876530560143898935583456878863612717869309885705/182122420388458794561415199167035316277177765265407307893082414221746137221865450268769175413438001979644948635145286631264644112762459313368,-1337242719092754522893884251315532667438760973266816123276384130166427763649077115225575221835137017201477090507779283646586933845453618991187/16606289803216313093127010875607097474168407326028966020236203070016981174970592950279915305743073013219429031070407308006078827082698038755306,-74041279271645790742913601090870882585632762557078930561730271124812102406132639951636281408076785339288337088507395955234439530514866167171/602509063213559375775498917378026747686410788399509579360305334323589426367719555081001983914139382681884622717233608675768078092066475309028,-916378388292619628538996789469388660642063370371341451152273065894658058393470692429271114854564704946711372015054919450667007820530681283477/4592068031245546071855527005002531348935760985293178056334805730786412113871212053323153974934812313704703440712298099251857469401240186037358,-97107121167038307770627077180232989120499279931302666187679951267661060293870804631286859216432997849092142626855365860232727896858411019871/231343789522554711120538524866444100105051312330880489085367771862840841513720799310254910086250555869371279891241522563592836206335360551947,-7530713191432633399326997852212251103087831179164245436609195884387290612166765068152520104062740668886765514635986284389095731872659616604859/25662980013205549577777801053299191771809887357980839943372875822927905430939461819441676978971733870632590218756316716500555597547765190653104,-50383206141800446911606743239624005993181200048742000142331385527851173224238493037270297540635727357700995920161866685556774079975810821134837/127530923872116826318853564161927311182513303798146684267746712978453998334471955569512981996773611066695099435286914489647569829755389057658928,-79525177255122405054834002193036350445053583224176166444251392487275775314863263572362993175576878211403472250136906288244381728487837585092139/193970111037537674060211648667038772320165662687439885932630624525245319979892691692616657087996750160191373478099001515299666739868617594998889,-134724569089204876486519953405073855327845086647868390100424882000748326433320690779952358852624031313096643301292493780402652032573725522143325/149085022276167808539023119544808587517541742957099472285050625649608316744975856859480104679855442899604308980973982753407482628510953129663913,-354502321937173337582980951132824290104128689107552430186204377168727614574820742684759104937333529093315030806801264912328550300525678553997026/793812921426202134823817791518972037408781928634890639273770925928373515279199274004975878128433406686540464034164531804543359802017477452804725,-78164146114508517913007036799050426385496824542504643614872456486357068270922005382404419692137921485284670152855918554760632090339249745287058/118258907454198946035208099629053477677499272928266173735123362719834132255207450722711716594606115797894664908050577143445501266148350825986733,-4416484157690983495303207620714817953736895160428587203771562063480249079579678927757928463321251226174619825505351385195151916581809933424539/9264824988931728671678447232393631277992739427568030812304612815779827038859445917604603703547935294920427222782805274486524304196902829170629,-172896932223105098288149399002356845810518186827837661574716783898443383149784445754138084254980508937453776992721522136946707088242624172602148/528832125706598950407194119620906268620737840215251833794621641909766063454989118772370594677906770207749297670318240565628896660299075412163601,-6930263711694186263670826301897315161907305903537847336686826512717310094295970352362633815999362762840814911717735534875026298418471816800352/21205692467514900852963650884244064065390683924700578049432355380801683922803661764415074317626056841597275605792438341834745571263877056653845,-137043136014738806548456716909365798165856082202070364974684388978475811066955240318085758844064204060422921674813318142424135277420091394943/656042304038815126057947257163972438385792323322661513514624722535464303653065801089447952902094597002885607752197006062944038106789655543080,-348531045996109559243675350228502995267857967882621882852737155412879015200444920186843178082915999893121068351163763972687453995459765396292888/1062656695936341702673896911318816459259598516216619098675259376048538109217273249452166134872678523474328071821780906390008173369441984491029241,-2816736943570340182156164909222865730428046681382872570984545322593960604191912640911830663455830718966976367330956886028622830871592401236833/10239866849006366683211904859844278867666745511649341512323606258714425968226724215432558198400940728308813035606079841985480128242927650526269,-23653836138896730289774657205900531708643179624396292177330307340621054331510812067235132439367390853860257151128582140089214812258922405601656/76636987125229427929531207302114768730327999742041759372105691441119393564524752827372583459281410241745133060208976145269009557002794650712335,-15188880754111583337771520946155279574886484852483575966433388028321202055222587164001424893712262677240949621704195117236803916952798648052068/50070099354261248248796593133554161876445856792657338273135152720297163115761483859952700563824451274075752361323263343925776961306879600973501,-1704057965169765885252827365644686879467406785341535406947508372182620774291575183293869084726049641344950850671757650578922903535802209236965/6801322499825926831463836182266452558818066248963736218487707232071720325279615257058442576427647423592098148765047367734767427806148474431121,-4024091820367942273133826984171288048849609480799211059780051759901502050533365609870760217990875431692601760532984946562552016633488021060753/11270999357187406215407620178750425733100305804920045507295108068336498379075715869309959067100442456852192686144940731438233352370377697318381,590483854705826177844024980153027435768503699587319773658729671357777427247972122865854226319379512725037814147913674889694543233451135977291/925512316059712887494292393278488498731888210748249647958398410746670104761686237467263999378579674028076144173603536054917577373395738540970,40006695057505495657783004660872400435227325364447514879579903440428614143411759980496735722982497650685489520635520335849124944240047316343/489430957738997505269264827051192557227379407299989115927740789669934987501442111041735811448607197522128173867920164966098308052463480156096,4919156115020767727033620217529167884393395401567637384541621461862086555049942790549492359617839161204220432644238232108755356597721761155/99029888066168402867539225843142892946420690770878789755617880024140687519232123751850508184108696087761921693464000384125424955979891288261,438798472503958305098702612298709306418743353541883323211511815240617854303423281040390940393962535454820083793582631850769458576326255818/7535718169278819670183833182268143764427385179591511309859546889684895836211470375597217353766819616967692523892521004641097441881374980391,337550350547303571060595107398542120620401242806853531548308498297947466682438612138957590124138587171653685612764713662181632984563806342675/742712742461537718210901701563841426890716675248283990798525867607092800549114638299964425636111895900954061915313503075336435858452719348037,587476292497725601653141449838820684183053884756912016528375810627205316746844603548825584596644998180098647911866693673207602168620041209001/4360110342147155416066525419532690100039432132443458821508208922502098090915657767847419023949917559651252044775075474731635708420984787101167,1272223120685328949862028148305443654443217673930264639951619093411152879206581576688204780078522764024760945245431854038774190496595192915301/11292348080041017080289500202100999873522452089028734359126682666210493132542633253948476540332720790874157438415827632482176965461312134815101,3872721196373217506638138377980055376928046956686459335184018137603458147840977717311898075990559343184546951170033013820480494208705703217947/27119514293674520370136160658510127618938814684276316715373327042807587284008701332743297560646200562903264268075794528983039177258536768701279,64244733409442563083958662997940922380559058517838988163889052350510524987131990560707331054789825190390442515236756510997905199463261093613/203897306416655110648711035021019571101011722451587110545805567207321869943773550675546349115442201689987145103518928455411308510227089869793,237455478574975736954526999331565156486583592774618778348218594713284909838061689606264824213394134957050607419078676885140533664250741999570/407868219477745149690540258341155944281751521210367133082758206724930554439560443707584937854598377079892846615846517136022095280614580775031,1569658150382750701111728275073927083524320356422702756348502126417467132967950125768826479420659684311506116815982409767550129754484682421981/11010884508094970821104347306848851315763752394805267707577685960655247313340489529944662429776190610242740907643542859895538938082288633294747,-152595230160198248272283684809514828848581538663126568463177347312963329021547929019969296212788049032556029481463233700419891687782197982696/3350473767149539754816596653052196729890192744257072596878174741705340225779215781642751085989133025295500989050709569295393449651511058743661,-15678890714652785474637928355401532707337959310088421113797075458536731894004256264122490692048757426048114168074111789677516678447218377457/177436402179640828850425118798104128050180961944328890765467983246786412381052458428406957405054218229383313866706006998636523975069991714456,-742271231152288013677496677768332968063772033630637433501414962984045041038851553167203570792512655554666457924302879986591557594515797260859/2731040454791790873886282415958452137693544818649000752380952525082000214109127270117030806836329367872665019456010234156648254919864054519032,123508605038242516086876294090945323265153024047628961752175323690187226959662535160938160654354709959790648942926267026885610565476196337691/1600198852237743448590892240952702347243855940231049886681020348948876400286102999250688278913137438964912666564714687084443165898027808410527,-1358005336087098334218173556523753194937097888750289483261421980145208419739632523985447531116958129336829209783099846220829159292434742536825/26158582156825723675423085970606059583092950019161126135012244078761704320868685225777008207416158018999173913132930280117185101880722782067883,46303684595587985074385653689493717883455195545187774820403872885542407531911182740830255517500434930322656135584299599985671220796241811093/561051317878748417714859912756940455320332171809578221572612680491472062008725996208711220513669845301059807825564863816642067180187373168731,-83275785342235888065779987863527382624322678349918800787364612269297430131655673739617424745211866658680579304117632748548586925323642932493/3271523885872725152821471000757220149654322841216234302453262499511995649129904713619323941602350254358728865486096279119677570357203648284253,-35477278894714238310731183744320445070128055745954336781097006153820336695876346218544858678376545164027763914797423333048693151792315663611/275744932180051025157393236847808659934249772749930575440333033421101161000732539116558980611672637975332206406266515563374185950802749559084,-72443397634600657272944918190872565036094736202727427557103265863470957871105629682386328549408581756112013173898909008591618873176519810945/316234907129675116023557163272933779835606291709805971114498863991560871067864218336045659444246028715721193235442676847780373018277253899357,20173103101972311553406015846377949751599840381664859491403745869276426014070187104355441880675878380361417974435709277236802091163814086375/67341566594865683935669300765425572516077108169599281599858755488471800896266823755301833163403442012049396035586322425039176230923193679027,-2668487990296885634719502718319577136074245967851471947400595928591127256126403250595838916331636277157630621369336850516526390043092333020/40590793594302910511057934852789850175674908601154776685335927999912068010262906413119268392574486054137982937969072266318422137026605323107,78752942497578228300104792136852320153255398594019211352114196313923468609356937838839640130648657236573070078813967255596737868874087520433/435455753309668843159975274970472857170913157296099618656558800894089931783747824221543898917597827722459291225725054680334219717895774260802,15352735103833894598284807267848783566916836447943531057890934725762998468513181147830776822495912283828754831016114304332617057137742298221/234894865743109787661372481341894165483114293795555209984088071783037499865807241643216760216256310831605493397329028642454227978270986030824,534772298342600539765343817751969951166200932280682030149742660344484561089532245441108296497274557378151141511095366193025808859019089432/55634936553003314550045098634011184232967741682473100474288773545193894890850698551968271987960626084742817423723962467667636022451037443443,135608264371253008720152381971041774276468713355054732808774264630442405328065849405245186885913974822349485900535523038915159051593903194451/1249303315455797394972805792611313830223451265261464489100501330290853616101857909943876703072923567421132156624864066440831073885143941833260,38011246566904017218620629256465064417474399423930084943091714540216984668276823033685522292173713106170455243857114799731918188034005107733/513319291520692000912286293725352349936563349265137345898737048723114267455466769031478974179567232597354766927979543501985359178959443894668,9603520235689028032432318458158065525164347657981517060761023345854050119273632275866503384645906553703222730183053580649089443994383766407/41452554033043791034269044391350494784392411650211840683402113266507853908192932091680438353065828248760252171632850684377146646971156732878,39674039931926777883830278606949585109384700261398959857075230913026451518200890801824809741149568426886778460293070746460567639362215921449/200644097177784029737631236106066192551040032945869518788303983538932890244266434070918842743810481611862615998998280197602940352151515404532,6301707130329626903617252582162610051401112976339887879837032905944397485616505573242271579079268675771877708558661417141368704569197433305/187844035170716484458911055485434782080979621199738159394255784073344056251511825021635580878205712772822894402427956095944094670512955649564,-48402801233158901997539328445907417844963618446678726290802712463602747635264290592883267472113855491878056067034724445574577727677519453316524/65819526768905153446825781025174501640009358282688365906316315476669332207887774180130387006543183986904164391687322074040406335558753745549895,-5760214517258045026856316065415209109036791973229058235884400921526860245864845193640613355525606607219351871171490466882559265235591165771811/8493550326331127502236751069630782224606348262183539816581342707003152739035473474429890813462806280379250111988814703669259049057806334431219,-7946111916367976706374925806674906062326605637815390695474410673533439144432732297559024135151352566324339033499940877633299914557124245271874/53249365149908377577714807066832364166191380313535393213786729124855393048827408934903899609853963276832879918755912921981196830793382505016983,-121665298341298462612801429548244563116542144363771772038280087202308602486399128420199138027451140700610251599978088872163570744846216334161443/280744616506621812856360160154650071462725812015727861918364152292745403480397251074448899616767116521719769940429279325519422448396684877261839,-2436348942833440870904259201652408783212052492317411089326505847363795386828111750775274073854267693600931234979796538981714292468953283981976009/2613814347670171864479760937092643776112101013983895042244019623520927401189352062276913696060910079626947887551872385231479973261005936358320765,-101498624397148217976616153223010607122604355580773446055478541328859708475598138269007167935630643081514446855036770491444976220155669309789097/257239706801075287615040012641709499926505707814695788540902421783095418403998783106250154785551402946202097103793587296453348915520749771264291,-1682945260645198863743346876973523503124814028119531045302632729331674358769821972711431684625410221507122308628286564920426376669641906466508793/1792517836471683340849469983999621720197725219277344331714101494898804986704629840810900147687573167951490716262503709963836915484771630618693025,-41518233758490778865642016324678779915472393899548770074035264340908125038931346770393331308273629523292473899918536771754232272048198734214183/40615827396329339794503270783289785654350515834106960556265437512040354600854306641642015416543233478430387915170958975107785639132457985475555,-1087631381566915172131845966851835364998824386939840164709692788638593583929682626975617371009334815291663141123631562702191640298285002733661/1088914127140432444924325593808978480915447187524477949482853138612223710867789439263615742938616312005897855556987664040208128184191486721315,-54957875537281601428131412491541776025025897299888868948768194932394834708022976419662152538163935531618617865758246697474395536661251100746485/45499253770117232374218602826587294785841500350662972892384141268605079933444772343376173933189966939452993317326586644989047346152623173996196,-173661645995385575531791370103960220541686481962665257001467345188504311995682182128645155096440517515383412605161780335632157764447061766180499/192080121454335949318906338395323293994544180901096670818449441026828664466360828419965237214183312550857841464136206483120289411046228411641051,-297187996844034019561462414536701015066742725656295967963831133489654122933852291014449153521121221562823146385641027976342813269814223900057283/244722945432607607188995575563877979735871451440215694936819820746799514109424415715937836938386731179139170454499419101604604988374587883167308,-49083532029411364398113237971036106492929000395158323906407571718018483669133697901940086967662914548333641694206906749501730744194336661032129/56909915797024310854800247032061870842894985771505437362034694180908237368595559749020679014670177352100321628602811883615102584377055526126523,-33268833561355334725413116386498071700410681658841853552745461033900754157769334896582308022054788454408353103399732223894756512169543671444992/26632580213190208549453476564742614251994068469162368506069583832670018015145625998223204168753721339926695764600488674762403196814410022295243,5458985085361100861618518522292465547997124433532584609513339593758529359904478512990883335211688767836128113458487532651851489352120244007073/7007467874883828712076105539646669129136878545659005075487475487976777705696038085850639820449045743266306599869505285362104568634050905202013,10100698964627975032945452179307648245184248798024138043001423091375997768952752519988271296015070784495110646085817543653394506641887153483447/15673440766559405270981231637657419902917427248394581917449111118292373863886490900564507567293623971778386109157326554357501831258629025674821,7692826490161806180229352713045627825767719447910966851835505490871080125069954242645178912937726759921428367965962300952839477814156738635505/11968331509370981095882076849420144358285560254606405998526743112603004913759436955046994613742837049405635209790913210771740960876251076033011,3346175770930308400475021332419049148059555663633354588090750125503114403721759757285139616347885531128615477139708485601968085310572547449031/5196564076012217622090586328707034370165959946224644449897072087892419447760872429189257368759624596389177930405658523097491065966470501420445,3851977870785564913514876749488443914835325904728515905041394041969313294450923260941985492813977283793238442250979657849868412436617035916719/5703687952966315023811621699002679531936031250013167904957712616494052253758139238709745513366805063086446121764502522203435832187604678488197,154449471979016646351504240126071137276278471906781222475961288802381189372507221217062313603406525483918646029199205874847892285003430923405/230098692891745408519078943959265694784449239921142253927278923803448682742132054411061090012901331462760961517847539966257010287539983322071,1573473321680026262567509317280619441394906543706502825924232605185098118012158342107250561137901738828095136573591354743788772163859721920095/2398660803831627635757644717018544029631294631005660865529266344307658560151895976481857810116837510792805561983415531190080071103889847696592,16586019824456880907731467147361908310391958736924862306404084832362420617943310374199431680682618374909561762849652685926619237083922619034823/25313681145085901166079636671820687350187754579766706581069581081488389931098514962859222909567677374324997656771166492245620470720063750384890,-53049032932882520478155889873347167515173597012348068264094824876263614656375100318419078907015058969517200771352284470035042394289351128362629/314695416157719432476023504597578188656167472208440245702661770801538074376977531333070691319692386066317715867848249800611994585853440656853648,-13553293313294942367619373683828302380333049271613645280320095687502475658252687722500472910652150049280706487643159906117047783371496786164919/75798675301671724427831945378825518407887485560591955520142444201516255296901307406030639158085916543402560664411432824812714059483296957735956,4876071234602666349737307374315462322428816372846867501130070380672998375058974443972963057456144140466780644647841916866891195805553626204669/11679968870956324894623304431632041944126978093282435943420226611163393454959149794875135161813773147820960047003594118932907656290803540589120,1574408840730290166893414045229543674201380811745524538534783701760093008366041488279966924141027510703667690500454063601562692211317102225999/2102164211004741958069460698376976730911328560823165331222391638540907540295794673356699324141877484511324379356569270186381683629459172745728,5616734951957350472108843451260780672346233159446471367542484429568631300921729281111843711732278073050128085656834541974168274367144515971711/3647587376345910659555162519736880468802789469109463871001337546607172542500619476257252010903707147933933704066762572811599914312099558000768,26775729593644589986625001043961094610020839202906021681960520738691797866005205794361928971976118838407757938843203927093779263513575619727635/33721189710211940101701975312443776770387464535183908683994899623425653249473148861470424578858897819307027834993204628549322175426613348516352,-1891678510744174102062734723561822275886533209038748356797912850982700346975374460238368949272868710499021698353353890372698961075328785996127/7537490503557289331254614127232043379656205479736024625861929480069916847741462883302399504417350650373074937366152845241917285120493369732928,51435355959106394232147811258727511790769645543106432996791982351224346946679309072566701876255913399049470241946791316969079163422108023307601/81290455176537353029406330892240803773936950917249582337725009189335869794081832444458670171933997933822214597630106112542085096927973202252992,15302988457586512922891415271575155629384213935456072173307854546235467887308664353401436234199367493740001123962533580484246466980776234719825/15441558566214487840729669683144456842613805346741431618598600282709373602901963394621872202357646540124114420966546133532744187983145345615824,-1110730932106122842319515445785957024303087726747885862535328396803344626328199450718803172887467820674579442645549310704771142103996244285435/3435422011402464717861155646269302749774292936589942961304029633009812157823149117701178140943423417706375341776038558104215382943171705918792,-5069823819886305255385428787693888656515549911871042018636035676755891275403429145170671976559542828716235050462778000499230357132457724741277/9072920880388736460186060910721414386778536653615468506434817100099605063158408464981158023521243454534655340984334780702585180212018999285880,-49511326526870651833857666029983760799636823187714826491796511022320179256244095500216193152621859371932321298804198679598855335253706763709023/87519561915976148740821630014794778370888186545969299954554217095262461725707087981627808216017108313521229597768166555428244023887809500751720,-21147840276186941585120751876473037063519254708701859441534717694895793319160786973469502227582499867078649178023002693491942373074402747898459/43640537274331525297249413142441226573436536058815461686288516305290080687743494725590287247992041167611807275467504920037153031238629150285992,3541860610686548298568616003214451586518891840879756528019673775622249326755680187056742498257611961765922285737806084474280002346266541119951/2617854593275718593987328348150356451568140705738332187064007375329857608932497914613893642771137202945589162819218825793163590988482571958144,42241416468482145960146619739413925569267053446968152101124178632120608867671175220217572312841556052445014860784809550286965898072425696301/120782362339259362578136967322659007138541555316508565654461423549498395435377049448874888496547442388313018460310642880003383506280709962720,851345834337380584520904162998306360841704847768737435919295383250533182565283730801561554151198662604361934712233888594419844526225127341501/1448865418651464022536367010807355507859510111353972717917290391206848264733774398396448708626015452304809085341552460133590761193357935450720,371434800755905657910592382237016862734578187522385897411621189301164864071670404783393435833564949868969626656721770167963355727689518327319/613685063848963118015726252634427551614050919443277696096586311524176465937675619988430565919076222988887131008438280152965606620979829302688,320098962736995407277999087758696516544564680164658691052369512551766393500588736869841323678988221593363730363837566190021543500651725241313/766881481443810845406701550387859157899927022966193319402880829413125664220176353420720446961730072099449125926012531629068874588852576169856,804453036516107676005065542365618281044185201742674177461700780934809793866098871631790419072054796090295997073857509063347513955345828668847/601314513885062637402441504181843965564486012390543811612792001582721181023923574161065808679504489783202987920480809820453420650062114061248,163401719317860787082911874739680477324318122274774595139273726296606825281497651225321688046870508184479597312432932154904744849916861232025/121720012053278801316653056761349008970910495752485144795008529088728833435490000621941690749082785798261007709990386381978555998129254748928,-50195135200529675577379426165993272996074886700228986434848375124387364149227506574324269038558517947878550536626259982222980399400300159239/178788912388696375949418670685290098815310372209324974149170724277718319300418569123040646409750978656356790174407450169519737858550344667960,-35479724100247847511493358961144748440009043114403862381313506647662566108685318997181981542355635209597432922779958390870510223383115041303971/91677073773838256022077264565219708343803596881916113071822343524620828724664248635625903908957718684793098885534248229447660847508518553883232,-8301616508199744720082430342297703129056171557593313384472296433040073802404577719948168564671321769153394457319314421282749196080389345975047/21939211154013995800302253142308651349792295708934179798784198749573472707223332187160704054815933448097863377663820549156001583256379104865955,281921102834279608944215504466805410457569441824364351345174331834300919569117072324183571277127106673747189272358297081354086016073041364706/2178878015198091113019457181356274052112678598435386230019961221911362495894631519698493752937904431735902001103951140442384232858324537811615,-355587572439488300256105413553220642293647245127773468445583309663872857393761812384188199545007239156307439509569103232832152384109342671957183/890908963107551097360893721266458218561090123436286958150921497773813154202892004730138629679006903906394814849585337701960044755609022344731215,120963504181710430089119850201543360758743585116434339530604191294091011297181156629127961347207827522894728903380808507958657142322071209691/878701588697461338027911998095733642455168783467731118616073887670556800040885134705672397691683830162335514641751480700517543524112708157485,24795731269674255012074582787506391616216999160620913522345133578434674231525774477636090704987943078954215280637675064150085467892442738673/36603928800707071859593256563159646119551238099832341525583965235776561835805421692796087620568282298347453759503788966825748249800882777859,2359797081942893994938402171032342839342827302696536151081431924316142223302793743416564662808495070612447160785965941511556159829854848899625/2959932360041107280798921667078405923542059341888855949937290104992494880877389171644876578118214193754034076146925029126605395640804118124919,2198886218494533263398021890412772774480351972785124230817356969455124604230189648169181167588533463018748701473312440473519420907685922830795/2680837822147136020128085998349046637566136454547988076879493660402610963072486889339379359203362154174120699632817319013038564985974769878051,79680191203101475270102984806949947834029530759799546240731714601851565785302837481898418841399910639625849856130884118045617111943429588513/90232699560977871510922863879115268180851690158857828940612710932409326463022844818659158330821865151640514790371050864383761059541543532348,257310864114342822995839081007520650441421935016321017066307884930333175328521896553028868810503191987671884400279758906502615571353544176033/1016081785538334354769368850660535068188400020683938523605461848334247436678297594265170403004797923512826131818292998861973967815237077230348,-371881606156368597786716204507685947273819090162167546584806723229013610813253045158300506792850614894479436173101964705753216543084160401721/1545923948880623289645948945797444914276950371696495767198625202204762549862859474797036785777059728968244988720767923727933923485775351254564,-5863647991564207703080957989070794065805995132594792533692486241095974444290093406617931011483206916295950528890938307534861912217573604796464/22080775590811613345055717682344364414270968911053168733206053130898188342621533914329339071567488617551571452909316296682250674249964618036269,-238228050475989271891375737539613458141452981922951671102769884857788133351368731864186255958950958810159535722251953743283080800841487775406/4284781558309212071074921858398977864916459800266547433399552961025299425954476028718724165900340044471043221710084938525377564362549856700245,2579017314705303310896777760537929007804238680540721454816818283669293710261035344954280404483616026231988489762522082177420131425717567583605/1817287404868153582265192728768348211831784263113783466663558899300129738654481688990075798383684582810905542816745529981543815242615976176528,709587413380799654957304329950641004503663725461966952400702508017365559156954216531191843716058010940667433911804872716452045844189408452945/821194387156718364254710955373008370210859108608810789135872751492065159610720988428722298327044054710224680679423933829253690936616608495009,9507819933265514735344055833875355675383405876475563088422947749199833431903568781838290466813115341095766437085528589630969579033703413816107/7081643830173416046742815849214831385440961795012166667055572320393530102035266955293484788361284841275107384050681772039000952090424232051968,1576456173619927580172718286986048631655895995442001581641273967871779812028335003477958988725684351044685405406730521286862836159847017998589/1925980208640546872435083129277755432481598481714743069754568452922215143029115932373668097353173086042645346762897102578447837941640714417248,73429894282845250387815185954460341719054497080151272264547131304951539542058698039902147592526728474463402129361922256711802809431829593611257/84745579412300708139068089838218072622835313740318880367505646675797523040846109215799102477026297627682137965102775820465082921927276601640704,34498243914165123592159191739823727790801958356330340011275725365382612630257423099580946163336993760740095293791523688431194202827967671526/2221074140294528512652234975198180694461969418726869107871308637370753273166442778933604932361241811321533661271825020261279695903741390872725,219369962415859407807150633239712319551692061722361010080100349527466754952185041996996774285639471061609491989038783586975872476515361678697/177820432806731596556035040966534775242916190650672004697617295737458191112846153120801874977279770502566803751423050067237189753992898290400,-2245960240608002940958718007040486605528081661932161917334889989008077297042253637015112644855167971235768529876284207677052515960812692085326/5813195092862078388483478184880222332201986981059092901111136348487919672100065241187168556493144654214725238597126095001456685538718270190579,-9573682334395025125613310417998448896169013578429157689919894432624966988882949322166258766944377926628091556063511420150835546514201983645443/14675266350239582635737283002740310710164249508051587442801199191551602413961443718536869715843339372892140499832746029822653480075932264001042,-9715776099524022013484583790729041491440486446968675077124575269088061187416890304919960581793629829060947214832545284291776971080249871802851/31883719651367831769826386342531655541831399257772855321919417136600056121442007144088997943616367952410532632823151982011244227215249038527951,-1010729208003774801856967746034500728623003129149340358212167853851218821939529967115683949380232533544215271083851904868766956766263799209068/4229626135840597135270809490511863002018209452338318654918649443446178534778273037792044172577471954913072987568089043644994300726095953874507,-25522059829101584324731933845362941001162637007781529344460821785203048768005280418666945496519361367767277463210307980408375162853218829701452/64825574826724550586298040899720659366198505083466593343221132842165946843602113286269295719589081740720920530814260525440517316265952526136837,-1068818259957947138258410462309993484867606756432888434324930121857801293941566452426934747130874234693725959032703798749911061332122760588359/39590202371777888036444886350956862644572428352583339603134525188739321427132523382273009002568694168424399990689178503466932901104092363228268,-3145704489210083532732801553763510569764489836154320211866892635524403100219815997836414096837004995708559281963538289893425696721678274135367/14865828246320278754667305586153339922940829829902142604115537975575096173222480587904378662984030510686247968472848382857026002362666922423812,341398147437132039947919615048335110628756569177106518243854688229366540212552240753359275878103265659830653008216884052399237795643394758521/940506151555762683247888923198697216439830785553306981565876386873408704777266194051280066359088139924287023652240007557925958809156651054596,261872016254449352200924275055538900113023105771257350789956128301197850932363639705411214113637560423161049654670961330225681417531256104138/510696581870049491121555742668799127862518088523030754508579877342919659086458359651283482752442124107061609466427314307450448890563125898403,-549473734436062405176349713757185382052285735115243983271582320845213708951420566188840552265461546138666131163049860627702590229923739061374/611081203427635088951182221229432078846557516488191793802942261313637311230052020143992335705304297904639617585344443672629356266602541506827,-44728750677717838419820867553135528769403703592048225351942133901794775439557872512928177045378915122094447151441447840078422044173555962196489/172030107796582827783885062835879512125646739176281821989071079435957675249231430035700712076682000075718844405177902603395075907053835624157824,-84998299940788622052764317200356335597368873209283848688721790763685769565068989899298256430335940103139692900342891882450792661543637109/837516810433142064501007201569563760742487116872148492019403439150065184889011774873695170311389153762988415031479689058774604713850771428,-460870128504850465266188755616176227950419688685032634869086340675530419984053163434123211859548078957411360782111614644150193277240070502/3192700710187568241886754820345330574465385870166378653498214517505771021710190793537438346864337801700346503473521320425777163337102279849,-4497268858143530334933690739275780098141997722385038883476355107920063939530393899900270183331649432576892212884608956609021851686582394921437/51503404995764585542464191661664149793883988379379161676328665213889023389344856790095741639701838649312253731349765744684216143476939718122368,-160557005856769145781134635071690155063072585696368370475178823143368263409643240306764478174263090884135769833917419895411350416807754996425/1840728968075169245441229176742309761668744541301473115793241974457421020790275616072035075729016509882486256137275454850903799674396837617552,-12838831450182619977901755324866301667553378815917415278168044577226312043648914815511371255818816128587624654349070505963550410129613779558701/47355051681631287072791267461811443100962449992828095859184192912946498294713073200712206984230032690799982620706369594808923774884093091033712,-737552069305747879099193283760914497340024747821555720009975156965840427410285154952031932976419135828305661720982312706220500055797412252377/1272344358015313402416013301305350070169320132061555437177795452639018238781676518238874818273416746465694292115662796198525421064915117101554,141064619172079507338430322529246211609840077908421964055554000168927578828094758105068734753331780532190838574879476583594583603707309931471/480867036433456354676431134272978395957981249927741866919603955667304543694012468199701994487356694913612103269838253052803396248946904880960,329028031495945076535147750780111024827093638743620654305010892608847374387743962734404476255805765434493144099614716373176699565277951068139/12327836610401226349776719878288473822406747725614545231442860158833972598927245584526015143327369504255287910237485475624493698548037102546816,39918612842499710249108153427344985818733844787754539142072646736370380026851712559696118611558324398565915202916071837647843640606109055247/148043837580834432578687229481238125700352053459832694773654042196307463802714157766170099189587597836580072779785022441818741156697047174824,-101030268821040116532102635709940445692730484428001515069023433625818320743429809850773002635047632747712361849573120246669266018925343072117/563689709070755337853276976311869154090524746319459210062114659061411500515618385005666837062056716714805691688738384865295213516588334310488,-110886063569729767397446440401123893686955120535735887774090948291031663005600156515965285789066559468413420368327733217742581227001821820161/3331899977831436587857752082099939070300001386075868436192445081634207728581769409111901388888527824705894820180318121088847981964184513910464,-92636791901470202404528044221781001577975937429977383845141231263167040075336539321177998845866473282157090897317988424732242780720595161343/90398571049233263259687520277349730750863841305825603578074682578225667665361237966673495604712949777411244573060426042472703479644926959539,-1679582406178145308096012883198402101609982549869531258081859688684441184864333499182470986843080505372712562194833914668706966553632443401695645/2880528656608147548228748514066707948325733921319778424095240564359189641103375843288323268355245263996764814949652978360595629550341171938572683,-640233897345117567493538478879126756537815495535227320906233569425249265534666294643564295958516567676691262839493511295537291188408086028904/2768894647098337874002360446719213982917250652478673284178646470109874065134286825077038862920109246653477094815427744329408473441337320167933,-205529638361832840567659671557392033579251098290617595096070748866804509065904625922114827414357212564009412599350076579234371836576247391197/925809613032587235405077186576718756963391792220876845833653851871011631749922761590827502630087756735697035439796601610509878074028430516663,-8362403056186788859412499064956308589853310448392765266073224822771082399453865884299735884035790774770093911349323210583998507273301804269421/23493110494556749591190479964122124710585571477382637451849584924813505756048233021182832087837192532881475370679243437606706608779051753965219,-17556648927378292728965796524041992482706766925952329936991379391957360615437624377260384098380412741967959218053212209192361438849355308998307/21742489184532119788508553130321276127988596833290633465759306398485537248660458107778650364664499487282111999987621924685479097990415543425325,-525694120383603202115590029452239772063276590560581865771720960402901219368283011620942653870697585381137278424901357147065953426881675868587/765216864349626658679174044755756780016752809403973474069837077254393638697654546896853952657436108111027703323641928856494202451497066647529,-30592774252109954431332527686733603793709025113715693510779059856138320828044708871989810197838180890066589599991625681092623929118955528227043/63848449924883243683905040986891866204859862930998433778098693977684117386104254124222334894558001717414502547982063412665193445001806771203448,-407408922529672045275800937609970453833399858996445619094622485545781619642930264610904951661975981849504369859042086469154994058529271266578447/534491502145551983128167345419530978559520865093544361692909738014951285176373790440175888569062482286652803940099302687544927228170298619560244,-5723875342763171825093207202872020438940304564226766934872981405264671567692612454426502315129114056459241930838749512833259970315104670060821/29440082186335968398414041421508578579922043631168953170405315718167828470722943581533403661167177518803235844953514833445401898581487239392075,97030966997472085634825652424008018221813342204256415242837434637663331731279360646575105051266762301866229019357567712276338333113265633649/653448862415310653863009102133810785970817661590998220926147429299021828959641919127054425945325323018247046411874886776230221970465678002875,-1102935135083582806776092730593618830619481569077702963484526640517973021793838506650953377293536458122529995868951508732117319972155473966723/3868500325757434566807274639364240731694051090829644327335100434049301638065398029242153654943405867411420989112529639314014953054865173297949,3841035828234494371449860794226858734848395009985984305802854998892982973739602837858212957718620410406755151714570817317582460262212982720882/14369004095699409400887728440541571148678030879291778694909232231747872380325359838083704201291204835901501720032550854849307996444988348976691,-1533356420960903904409522065533827995219587243260114838509341799265740735508567531373444922795652093046984827956961083479460996514424662709379/2593300603034232707053107054419279005853401327350004368206726661751560312257268029043129459180315521226491518768075273510362655730147214533044,-7129833546612030863488484104080368142700261054132651770178114732028342398785410370503703098736041546188984215231793141637764693979403573183073/133717923186097573242376368270667844862760519870044774466752750251666821116679087932264546842598441653155094766589494813868398650164467638401176,3363730504453455942966479841063366811931988317026086831001139608393248634880318716931623445360780490324216838547818771970973552872969807637854/22976552107695084705419414861883662193160961777681930075138056585775075548500889421508787710989315906766021080177917945211306985478802192267589,239976005859992814799179455260726946286036872242182223425976294637561338210728672215068417838638028436894462635786249022324231796551347781449/391743521115127972661917479813827902191942442205110691388149161505619554275119226874196436836454290462897068967575931984389740284699445822952,40539868362415864794528946372808718382973706822149902246989079834618645610695578115429736503959164209444991594950257529897955516776184633780/99821762932558894494289573157562724037769001510715122722952937938000171017572851681572673636512898975508112505267624398413748551835813778173,4167537315772689815277010866237907411444014418714595360525201219262234927639753035165756845883727111900496461023252380372115079437432518385/5473559577142436859709823362401849571222132521821536997724717475906872214471918536875013513765570781335810422109234858299094512290580221232,164505703944826242144927750624650760008994045852646890163747039285995287972136101624261640861612904338272379479044380105833078618614163807391/214591304963540515889078482263630171074241939928738589324786386313650723255765569560822086168389726033644674470185876298199030450756282374685,1891962313322466897283244778385457084169327267443584927905920146962266501328054083348910731975937817119915341303871162181114511277898496107487/2349496712421256250243747018928573058478881126438043976825596781004744904364133617777748820783162543019529015373631892597640741815055657249003,2236315014862774936991879047017639110699097992941971195666757968957277432495867741186150536017169718313274630263311621093118195332868041254601/2865229669633098504733433351755236055264970482982274259925417689699149647994978800553459488425146559164237931871996206327484569738419959881108,95146853132437825206103394506025681099065874155713010028066767784478775980239224185849206258018101376551952615858348465466484095610711524203/116524747075506948999156586160740700759022593190176194927245169366567888094965817414658572884552452679062790474414816871690439168789195434522,2041379938437274732336177682921983884166846574888445606092004477462625133046688315578079079925596346985206416393845362232746105900626594251556/2466961611034066745266147143517135501911888647810090997871588835960210625036318113031632985771364227555047986307346271412265945675972353236769,4240515383496808513683306317549886711571391818472386391554830781925946522673099080957453403323187042217620704817321608702566374944656163781997/3896715132260390820033851045058618529306491379388921359370110867196994045194670723874397559540990340611816155146103329710552221103023992383293,210078334726683691821596338223401180014813642561361986424465831865411224393732463423658831465563281428413951353346868654668595704795556428459/192805668616378600728416878819061787043302593427574878092770948973529912182353214219684346419656934438806598713943954151206800120392373944524,13125065285916749613426425273461462256235505248698765780945716415705307415313429998110937273123638189903309396221688579933803869251283008299/12033969958296122361869437802227605793314479745965134923972880156729255758281921101228915826881250502993917865632124239413181051067988016235,1288463082426716020205000753276123663877341995837253787991700363592893094031454981848852566749285968016157014437804751010299596937279828929097/1402612155341472260070024726696348045597818158212977903308607119790871876900431131863346220797338496234464207012353519884850298218050624759524,14014800142626637769975740927079353481604209120891066931878539366700727508047920467041741653779216760550455878197590946655268311246698495123/33324309256097162437761439623468703578984395897658677383822824171716713867362421603356189621096506712110378221329139081473664306397109016403,1635356768577870052157083595872767412414084590763198541203840805076132789271448665833427049346157178424177048780831899211994932289889809549810/1705946336972028903689751366038583508530679348164961877265663012076651203130822236926873211052923249333883013639641044193791898910117697133757,92805141190788709403127126209276957199797981120818418439895121429667303033545660119564121343697362982956689392452079605124257912590209508977/133657222640562700958384277528478217673277219945421134359961679474448012657937027305734866301498969594055026936458917515556128079966596609364,181633465189550555586270632253091607058929611014165418067008316750746886274733497407318232458384557450490692147759084008930999974038759803172/339301032216318764364460314350255317479707271166859358742503332266203774085129052503911113661051377502652172339014527253645701343544819752587,803613360028801831383739382644639036023229141803295457169216850829923000898786559658900665463579523904155345435894842612763847803878351561621/1047579402023129044197048941028870327280761800139650981614536950821620879093843772532493924821405578995150840555189751037223038341311898139148,7909846967847252452447522637078765343729190489030797760029184418539472791862654320361951627034335537640613296171579544264093529080111745142/17241489275800147568030770080762026297001082045816154128280674643517273604458811732511640319488468891610539613823603144544878050016342539467,572630754694584188321363712464012521247755947937438732727195691220244842034573298464923323733309728868592591550001293511043237616560437302447/406231444773317954087207942922292794051315217724505206320275174168818540829346305454721591340053289366549806292118957381990989627779062249934,432973877396570007635719701604614747655902525354615457112425227010272315929514669197870785358722558379368390413488276559675650091006069652639/268667049590048059067663965127338141586461733556107591012544841827686964717350910441256409781678495497369513732479043676870164930508128969854,165613965165134617061533361037946207958613712295199568001236255923426288974639247675985487139064710628350831691781701701821217486666309863884/671554295952507991179545268980623522110613711748495987404805193409760586510923721606556109508465445616647243529139487884183586691956473201449,85414406743743814028433682820223119671407919149767688285761387255877094331606850320986951960404289855313890130045151934237794079629293482499/212738696507767379166149452650744596547625516086697807127306970980046613695075290681578270784680829615366702690416992505339039008864064724115,29503517975442878543247606358721752146622426553122508670652733595255700519964410694518199397856246796668180259505480275567608858176116577269/82285187970246619749679482802733729203152955607934914914012902354928984384996355799216152193597518714619165280723787269104967962802700281089,142625525472876931400043506547584047985244664716083115255614803790121931548427860800520490561774403993633519725740105355682235762676010594050/362497363577434167952179410274769245411855635646930299538513729451279988478639088393166867473477007773096932802467363366649694719525794881847,46612310270483178998178902409341764890769191697731041149047567732095404715967300322212850858958925909758828972718590319921791090449816644550/96611722848896038872813911431387598563627600533584512582637257816222624298992447006330562052429633966198081214043376916611330089196555268479,-41624479609501528182872957457743733788394121095552242201308494243467603192376470879277380952668966983160406116395959389052554381359597161931485/65467955834087720906478857006813210632012181814664312338694151609206627706248320978564284965406823513876899160068272423565852661634301078709296,-278114892288076602958460107264394397860988863436661283315077307778756744241410696518509310960923721842820742683805337577503673518872651004379/762052844819845362203675420128353819026864059469292661353054649863385579158414453806139178975472738874434436050576621442120071007045015703752,-66580651040527279054640008194392765447352281887992301141225212448401225189445755621828060606446770952081373808098758605019890672234583128102223/152925504593139455539864750713180791504584903012256605062651053282534813455501457754147411193841832601682572680511973015425712589335799125040128,-166639111925784671429857747991737103177112662007180622978038778088863910325081764129521121071761475681400610188416158280632383023324286412379/207161407220460277220728016008083822842371881220827920101277831719278510159728158780627414585636208660245893417509488730459921589637900817905,-6836828571729981996723785048863336754583262294439966917511666722987352258185520134935363670109935762420876049248729607834061024461009770479913/8416149513413398997683888753138230539139164741193581340189388045590781720043341198556315940855221756861873947151479086665574543940766790746065,-36350435664394126104629090336040883970156159245407475117499981342848703150826123327005907865098657431348318617897891625728430721016741223267857/44937488971924399035280667994308390966600915993388367215483050709724195878376002198712393958500103230977001997504928723043865845617574308826743,-342132227793734561827078374436321058720412687898390867467645031498136463719353473873086497029752904539873702457813109090598760651073531096103/465823267669489021569309206593680790239249367344786069501882818118129932168316755662465093034385928704754930159976469654646450230726548457045,-9178327690387910881605683151730981818827116910373482414189072922284112297213337398980782026798932624469242365935692794539043537002097282198657/22882513125556778997714379060263806519841591405026579818352140171810303486516565018940376876083562187343608130363709488597779634967006698882183,-813699465186700015911676843713627813096934257445392582486043363372493297306576077921349520408197925820639994445398169473619473694708787787531/547595862116847369615009972868635663793987520041864081435040527798656318172068550084554516804186912007133894868332697406730971589169546699741,-35701102312597913821824706762523567749294298753872378781566633770150170370478963880880297436282977750300834569653767921935433769651876778300/65684435445310631226839802188791395207622379383085988847860016002853403472535196114773720992703191908874213574371912775742265507755460734393,-767152189794992788588628833902025011016088594523358876123595316456732609223498301031655268576017807296839246678859657109709869971559483260353/957381323179394144317697383309467260456865119729058756865540198788131431467861061365179872703574448567656910161443133562613974954361275757117,-26240096587170308055363282911369494272243468666073196633278724337378148480135394585906011808617471380530491774234920951961292379829554615899309/30279582936516255242070493628109761916395693364834192686223633745908217560979309125265717567093961319436596211430827743682845848911835609378381,-24375281916583422048734016205044049443554028790254566717960312862334921447460181556853429488467625745590687345217378883452342861658712676150651/27922334594175441069034707790484285380082757846208905796354265118262771330088422938769741584520960709665585201147906931934644937812892568739519,-849720027601651387211651674635088261538912947567978485227911848370867738070155498392453995565156496937707506659125592829783397579100498585067/3677136287999429327991452379256520331218759335058448127185220052134249175023552970799514351157572118589644419350025190784550543705322200898644,-27358495859184319999282446037025135503332989053237054960238515091166083885825760988510210489020392297431236138398776339657343434874731056235329/128044795503614724868178110912970041298289142007829869971757150353720550368776181374667366954991321188458720072128438443127951611820747295344672,-1186576650854393942828669478836668762226055558285811397395828272811218568885330677677835785372124499082987834844678925344590556142756203678549/12439901314578720759334938374861930775180445751394171436591499260824308638963040044756194690341492809203966008000071275015034209454289975349472,-8270585808288054252089184865197072483288604223554989940327786011922040199820773970831622035911599804546772380764485811282436718448065812595989/13885016949842412954086514823606276322369798912835248232086825585651222794566637591081682553748304676923366060405201508682414787638879086736898,-44709522939166325234743797646088445790693802298522379295689719601246934280357914772159816862243713107331915397595720903301917820650486110213/83189689702403809666627804295546551349463302562172102023986361315079008263531447135617520434922980838989659044393682561394455308227204235162,-28440602307282015170421698505793474850876132071240400484136184233295928090066244013260278347741556152380501344560080739827913702022142781749/45639685597374765793234953475377363412581432988448229341603753625720515320555394991241826126492580475327363043849455198902726212836889030941,-61413428658738420551543758827879323883081213309179481308518937171744024129298904026866677396918638052354375321672140807614160569464456580219959/97594760438117627707491285648020350854768667997323821997280836649192519816168778773224060275053917626070312729037978038341057274450261651339364,-4304240485845633604707576631742736896796837484788514954536178177051408629123332515588838106651206003641121598829866752459730284329414668220007/6467798509205739887567724870953350920998303975698329452470385876631512081507214176804455367652887738347954417464859252701922292978863110730147,-4638899838232732184265659147952698806605844480585848023633033602840483537480954993554172266279216296646038943154857398644857824278159767932570/6962572026606739328025731317456142508821089462394293785345159210561189376078834945074420650898384908547563366855120017038458030090658445239937,51592987500445688835438940588966324013872225573952081653595664110197807580856580858508508234519125130121851181699029093523143403734606836165/141480337149505897498658725949436221847854041699518227246912225153339919417834939727784166043360582642469172992895440152517217363932385356144,18610463105520377692155708725210940574562621565137234056896160255089903626189899448803036471097173796824646587285123523066371204835713448617521/110989879841845852147889195819844901855942705151414107563823833896492574139610441235092298529761072497346638035342000665675328973761791746578112,6081505062830552471367691089245909888176740339724497946770994636958682817765881592950634529371483184646280878068191511495839706978950493305439/6697609406246922995134041882874782303179380077284675085737995507583401332087886960889784488216152807964048911171504394028113047489968987853888,3819543997207215391424472534790812850944430594703011113819097890606648151007989623247742053254933746138733543174143844188824373737867334853867/1626624454345517818662384579963342339262957852830239254955572109380686716040078182800182152537990151427302974767342207054348397612302610188160,-2049661387799527838511493066719645121618053079529717427814717920736438095926295190283200306754283270324831664127753911878178986334282284320030/2455962565594654687668609223702078326225991411681447706308145544895475613137865179138236860851610097672460791013056004724606103952721425457319,-242488765926559995316497594581792259101828334109386669501144825719332354168747964917130244498359393941966977880636327895967353875879538743403/236403784414439225067042613558494911135942099875434154117536337140660466733688155630729823587453629240194383117097126735157908420862582293712,-63510647907563575019349850832377968217049814504280159504613721913832816655508343021322895275725372517635343566808233278566899020273647781555/62236976559420468985346053767463448329355294972582911235877515356265432934513883027219496355582852219109428115242326891015891693788085879792,-252212076239526748607038217479339014300632609330689501795282319019331976612609845221667508372682745157944988380516200736588183337162448369229/215303695159467118837449973308209068404001900945014873058158867842875895495336491384867486253241952392044884600695638579634658916088835169956,-47309641557519215882986305134081933551133225764303975158023583250927608531120387881975794143444169168945444841949435971093343616020717300044/41406168321882012549789162305094922260239711426506662365897399126951622723900248131713441808049778918156934437375354180407447428881504549581,-1728754257465942727118195944706245055539790846177552073960722699814340597826046972562156597587071126125886563740885624503229532511839385796447/3400448918168167463074922780344558313382498151339377798885339693475492938795622279747702127764844245024859230600536359164404509144717629132496,-365376034961779149436024925183068333039770000134843729180720620715001618690661849205025593804222863942614416139828267811890885842823316062211/968101724223049891759529399392779550427341997647070623982053837835353644440110214967559075067967913996801217370821138187079225355846413409088,-228956810729915838613346601880517171356902789922941613731344349364420560646112494443896999584754853397094925227418747985112549877638543839793/214751887369933988692237651069413560308659948591224919031713618630046864998155246193993154999280321334780561287174867438684046194900866885287,396264020423554579251304279566288723726611518132792233875920333330886357494853459309611873749687944629593087319206613275334628918060806696597/9991189007958434410785795304683044602342378752653726449995392403939014954993826478235659964603515847880700800665416320777318004259603901504,-2190644081325152769765507941785238937122766012519264490523829148889834827187973236146892094159007279558522929643439979925432533077756904311165/4202164345670852119354090899718634782080066155382598987681122633928636260871235647898593742402651123857209852140034220132938534432452592806464,-80785784410178903934661188146555516022878547090183773854167577950827815392734592003248652501607075097175457627739926109788607004584382057650/154013654981591238380349420505511527686898282953676189163681010195451132020725049457325077575154307449985902378286927520920886005381203442059,-139004343065556125765448027567899610322779774470464892898433244207865156038982699506876111725793613221309515235963759599636889284576855972780/265272761178464005730028255858317153620817371131308597239870164704254575443719632975463607367441610285978389857282394558838754836840715657031,-2013422242483423418220626086565617851297766789017589683258437049773628898468762913690377241268696460377346644810448473483662538025953662262628/1756965227787141183824705325051834164022309080114279477961709618502618081251964230533445416297137707092236762212221338682843715542892518834583,-1164679245739433128411154332973994331370343391452331610906964077485039236199218355842503584216533815387135727376924617360986556069724101858503/855442336349158098745439619986797724247451208116630259742258634430445224859903164586208470464139072622678788307887902675896693457528819495788,-9388915641912683411946142816337294046490334987043760963505325586206786305032787849908907005673052662623840369586981967874026333323643062207/4230016825732187535321630604768210867275779884821963621620009044184556754008306986156448102985740292392669224454073189692459687864500728073,-77090509596876153735436585183961225704753199199905153244385241546096499670925655144686246239968180513808950269797652822453244460679487166078807/69948977307651186113376339165587027189230970158748735180749586226245246023386063086874895774918123347494837389531230461438868575781104550367784,-48686189620396290088070148150490404973388541284105261272948422019472492158283345817284546012947963468976131942480330493873771314894737158012679/38463162995000927427651549456048471744132577203964209239714581770286748300203466865271573947544050483251082067063855941296333804355794653027052,-25218747269032290739341710409428797183360900526968399040122433127304929636469662855113908110935758991370375760742909982564630809502694634076717/14747214503250273782014945940597104556875888795107066622602600809435029863413719197780171151056250366458856787875984022244049518203707742011921,-2987511566135209308376868259807927558163548671847578804509572295916895000667467147776146096087923056303537982217862866239114982043796270760135/1746075159928631351640818459033829113480483105119701106822620607125030144188173620423923781960249689796545205476830969411766399971315569861931,-15507012747817410477634781105346148913312654447521229094300024800760851288915082584825457107041688664740147877523975445372792814746000096312653/9535201187954000594315570807123853774121987365086679668259035617371422699074305469757917303714969543204152900072251693851557927434395421807428,-5979908653497201215604482290310612078092377027131046306249731291983333017214330720966229408067225152770904020591038567343582629882443451838851/4625431714958429227833932438374801327683224178081545444265090767831564686635476839146371127118923855554619906190034875023825853521729823647940,-1211013406427512478177671701495065861210935465690926204858565556365770815985133371924483807481714392289780109559410920243712149776269539819753/932670348801146850225579212099745523844065027921903291315063274012352363032508147880572627923957404345457070967871361186313421440816433309705,-2143720576593097426096821338896453664678687510120563865944632742936739331378986004766220437747572797232102870517638759719599816025369261686277/842275946162778679786687500855489178963017225195134113508377100625854333208394903708433805271525033389794957669606081088531329496516072486415,-238603507399558880357720661279667371968670287000788555841458735574568481673631247189385521285048478359903346533368659830747711391073615191587/119679162070159637746720361439954466484305952997789292139437957443200370679579540971167601435690580831573529871595202301628883785471123740463,-6402069073237045395963219214621395593949762902777426113096860909613042112296864869904360357992126564117498042771917845210338538550234146910083/889225450274012651010750438844167499109186789473616192288885670908464708185956850930522011939598596509010473432585159439818597852666283217205,720180878363704810905823045873551314579004691026510353631201024031308291290327543047504139395544579247796813715697149478504175199157999807517/570508479347275433569307225081846776217172322467969460430476883265251293302288875929443864702876407909503436559390034556529594608441753792416,5636761431277510711819224446505751990652267586243497596370783624892894848727389305818677712011361619416868024595276827157270982185262727927269/4885023756213084162257828618225925862760595879522620124796209124934077725437256788450084323181712165214117981828165076972438544123917549707084,34185422824733788401188460086899488432117524023167364852247619740955039738019723500957784247271533900792294166590658466813571822466318622998449/28951376196850518511449073155355387146349789155139962146362016194953874954929098676720445339273621069022956460558547800523937027509307181869664,976911585939736385877165463315695263631877797333279704388703936046633197428952593913900198122618834088313099596929045938476845296347441417889/773649898526523916820807791790558107159479090045025473210178945202341710901924752758290660505679327979925162824391870748269160215478092615424,5807391186639322943090911308927531637546571119278374522127987754317641838396824079839856904652062487103641081776154021618041113838681964036053/4601231370283848568905027965150418445624987823302045598089124793147754858922229029780618195426396162535439956079744539012798817317713600376064,14387760284746560084753214936148063359451379273752141525224897305739418797911936274019581312954056974361503547609161424931833742425234187055621/11382984841830903061568613596279717823173596937418353328781742587814002515664074012995379887654325641743297168035030772868536720314551232889088,358581433423137140336078917179090227971582201018916924410737586379413507390141865744982815140268827874289833970363146177552998219306321123849/310859484976277658722894970476932126995299750695007318882819461996606631231518975528159898458545456752167317392816644116104060226105338550970,945834765332453665966596677331259356773241767189459306918905462594290392872129835913368236029877420358343358450176775185379322843442446097599/724225660299297617765578615335968249002757513966259431878400384657451878906253264337025415000736888453272555525946495257031352090841390818364,6398437687295657071808902936562112237307435439794616923263102435264012531818154134586982301498129018277802086848198818861067842639933509351428/5030523479691894692579060442429371957364752907516747873427061280622924012222101172357136317841122545580619779648648030237986767069160180262345,655016840633152250364042472813648414511126507438638229618073029406448072719806975212755267062607641971503063906706282219143762548020997586264/499176754259261150146570352517609283250713611829180309141295277472529750302879770014516157296935046461047350391517258827586487779115738837129,1162551407738354819455094733580277311920594633352385860605032911842648638235325226807916989416393024737883272684052616391741024897248876989842/726339087513611796769778216925603118053987100821549714904371259865181558779690395624636124377706510878564371050684197663690857008287219473265,11509837021259492270626680218424816035162512958626505896274100451405397714333189648932415250838604660887637116946429754242603458075070317108/7313170253437455404891701413412476310064364415266601727980495354794918946785063596359340489258525760409693490022620145876350116919433353425,8536452909841268478298648786271255248455110269586970735943639749985348099335284702282539280469441950568536006914605376462041821081340480880/4342208365052451027840967996518952651152173781714956611197208546620773860676829603087904237117802468240597503207763221796303196279878508027,3356509880728234647511896195743137313398404165330242383590457689633102130151769784100769789994866254015991513924349127516799020648048668039189/861422239575293213234888698697373027357908296159564415198212451076664954296497138184669938135972891559267287814638828229997156431385738798304,2095463932081093929789330104692329825743640927563840760111157144061777392252622962966619051350014484069168757869269016105519262327684624496181/535031523190468731538677298318264405642262622567760283691614675526369643850058773431035435760854278206408682135560794847073215041751656005872,1784770365588493073010276726069004400229881324636944350898253801874103005957635010072236636777306604034497084255191276217795821604677483084791/163370627212417109895955786787301094593459464011788315534098875671219702379314234289499506742212579766360155517145075399861195654360191263956,-4614954753822956400692712335028405930712200505349819456480381267278191894619632972694158506033236991961852455313516217172397931707675728954569/8423726784076957153868983490477208684828483155644072458455849523747453766519788621190477428728750541959767824916796653409820006503744366021792,-20023720595437743267231488997238081117831249048792021147435493276602807434971841023490434692670162570929421109583777791681925585779963134822541/34575286943058649708207078274483161458629133966988054427801586073188407171454428486905442126372792871572467258015569174240165480414125371677424,-6059236224193908555881752416607940155016147266787433982416360193838220513806241943768413589024126340736648578493405027823514275754573231223455/10033216046418502705535152326227462395836780113413738513235010577988769898968149191529613702247193578437849486183557754372279846470309844369064,-752299847589181297247639164157238086656142448268218618806693191601192202555086296293741370173228624534914278115399649805739379135502054028933/1196388108702907196356145216693923653270690951795585430900739291672839512541396016132226095991658064462249917678925383104167590646003968320218,-4540275980844763458981188363018624065494618773764027185573991737932985840735974503214633398522256944139842325163341118895340182964440514264347/8414023565138789967394762232019907593604744759748127336410799629310259670753002156410673855983424783518999514673758734968536933051207738308272,-165045338724497153947453289230388098383325836803609282098085123285590769890853775908606788769009112088539608903852230144339334510361970988013/314219517530280349058770634778767668589414232645436640666612144098064589775104223992530655062613039679563800209967417161823423084119602255992,-89561786084776884884102644226785388201202260726593312225166784525590908837993155063226396412630099493315379078275389621849738416971965767339727/149579412741671385590597099527312388343088426124558031092100115559963978741061210632637183930593403702037152208467768416984828978741449484667632,-10032598192572026903780105559465020377854708715358102206813922084761689849799267991247508251437449801407218689775737819442564328483240631454137/16803723592901453112547280347838061107341740958416151101635407142885199398590764975790426050100643825421121665226149522913217508483075362311132,-1451827026891327973285941929346257591478184093605158693599018929330015165145061734939798519710867221150554594407180252513747134026572934425059/2594579787533467466638969607936789681080397452629690411972069399450511790570803960465172795939592398796569918452836902299257048776189271695512,-13253769850904359073241811850768017388773208199813292592173227710214159879315976929979716870444489792666072601578814984385435767830553091331133/20524771798419631698944939009091615426522235656373682477370452585341932488954247806311278673772380751412461430522453010792732990411000164567296,-1509121673501607680702519994129202596129316594008646321361188696380785487187203374519478646315024246063235952132838191623263164267756756009763/2200905699514422053600286121950427475099840294712810327307538531752541921686746392632255841271613973655696864621530494914628565589233410534399,-9811589876918706761104206199778895164794300722487232995274547212856725948787850026351412096798115510086419136493029032653055454462773111159427/15362215400682606932208924124807732332973773219198360104183085627271123437952260817303879261003065214273698664105470506385873650334268827719322,-718506434298375039650078295969677506243310031282911713578102325246719732325428338922274536530606095688805040728908124152109055495281119269836253/1098366825120008358397209851291916729027015929270758681763527654208714925781417498178667375866337165416072338717057853422752054308225893140285824,-14420435520118759185991690675336971010816535688340297266990889085112002683344008006501132723707155602980308899285140664722872317576345648022027/22157989719600537425412493324988444176849056769202745257333788754396848719201653672490968364786451516225603463761926928801769415071656189917092,-112454096154848216050772887180113346842139903763592058014894326246733223254781972973731458784629148468528799314056110706644545105627389586559361/186382362207541329926319989163982802752848807562072334185185025514813866368299789463350832916799654266973609843082686723903182760314247667453104,-5486255545813580451045054118235684153640392078639668303539104742367511325777766519017046772663422157741583971413138810408775128024811381259837/9306053141447709128406441208673078684170718906447149604780764277840993538052933700316048124884488825930881940504611564880966084417467137540752,-2743223847242472958861106737057514732812148454557483003466114011234851634655797487061940707376434612850926685578521276533015073271220515234741/3283697829986830606657917194545009747742240536205845035825032930899728918950094966673934882568823190762646199742386711308602861578162743761001,-10678959923191270409361663590825309438186599693112650342037707497282277472455717650448639525404361192746205652074986554784439175919687214209923/13076941164581886034883878129218516368981601805215338629023438718221081570566964019586283525071401252966126698958287897253415869127732311392608,-897102507582299737489529703933812829723233761588651763314221171290903717345549874850364379426067997397889182404861958842336671823276662556380/1020594291070160356495118419943955703876135685999232487934182741318467142837415446258071347707217572707599915579404653573103993367292731233173,-41860426223913022900872377386498583204817700544276838597918308473286961307451389053855559798013016099383648566436741660206433448094001436733579/44873145480536897659563975868478047194045436813689883530987771182004044610538434387154602283401578257226134857632412492352085407953490160328206,-11599368750719566710857078805337990523141206145406605506094855060268281847710005731776225267546747934921897600832642981981445766174038452800077/16938116538754861582398944827906266697154520306695373848094278785563941648874896089411477601275615729649582471293763134765456451427541417910107,-961273735324934913595692672726156278791899562141454561372896256468560016389403963075639584495516326494366820311523903940528658195945554475179/1393068853597951547781501285247633340450741562867082089347362963055760676904085156836157422447291690387041465705449408941364172155427452114587,-210445748864021393487683438394857978856081595992360104194316443804219324407110957274938597771031861574148887058847658375588402779527206080615/936312393065489789929646366312499790740947534386160271953934064689969400571345650311743712327430228503629568224181779744578940600888685664,-17159056866454078703696175281459052630981870166711982848908574250782002786276767332070149428951678341344224795955243909784445730253126374443871/2947384210775373575527376612362215084511949011807638566589680937640356680309713988461398765092184242279997746515971572317353823885459271249366,-4577365668657997769252098354939161656472008628228458235302351946457014496183345966619486572904960808144726242093233183579179882966783830684589/4974719255883026409652319130931051065975618549272152322387837987684702345079220356160931908087487264909442843278045637381714180684035662673899,613693104083219729052530212257035599943381696428512134012153882231495498882983058622964401958651457055994783813148918384213973103344902098309/478726040851143349740644066268470369732886749216847186046185902681260065147986367464115101728956910075505532625511136495031815518907972145384,-1347469774900884880236549270101988688030941225657283101679107241966079717249149368554706696294104039894814286143532782514649599432088334011493/1870487552427963228655196988248780055206465900411975123452760203036540159816873517980258659952085264483763081181258044489578883981801778602184,1004912160166978300380923768345229220710439027974457605645685476823783754453839811271977995055995856375832852027849354926015548058409457178443/560259723632575568273853332739294045589244457637468990243272324595727480210388784079739304522112425599707921603261294666001984223802843417872,10705911268443559521537666069473871316987140153231681815883144521255442484084637651229149791502413726254571833988853784687434620252455974884/10766352093662994256606102023119751782841403439238435990001847399521933186490956289538199282027985314427270701745898682258963079859731530747,60026369117929877976975300811050665812097890942801477651776712815792715800496962920611603241512871432520435063771378196216668679777977990143/34835422375626375735460979304713384048349400138371552872246504905817670501621039504582999997032484456887352699497963420266595549156016720844,-794655608923147232717466985021915620020624263447218825295060985384592447135908094902797399229025087537457879735774890473875456200525476989198/460427182706669670627278301397181447024696461215577506125085492172773847683649857447971475129041863857583909356274290323913340275842705939271,-236793532939006538042338653005985389578379717349757567137732421322756683184692652168078070278816458740160895914870864266659323593015294993687/82871411729147485428935369370034974847650739314327194272735808560583408984005803626881844871216949791262874878361101989431169758385007478558,35585064006902978376866151032020276604366796280389658455627317384878753963683747229884229828304975780542832334163021133545830827209125671341/35889926735140857337986239883722136457294559358618820587436697125958141103550119873082145857738042362586572673422442207516861416969335609664,205026146295348157688191217938456719388582743305517583544648850179894591372097787499174735924039081946839088651930987177869558574530856576711/53216072825338960121320164904429020677295944503860506350574474829540393794833234173518025253095496286263023790278223938730855757067921035792,917317752903717303180169382431411967083440739368023727905278697921352107101755174815935289399318377062559727090225441981144335369984377425/199183824609720154943615881350826129490782010440878453231659148412954829522235272137635889536481939576149238030452223400236633181904407613,917812410865397693646240696962800635414758283650193168755403768209249710997205488116381433512522910111418919891139065541968043085851988273/143180979341201065761303593928813278147641283024891216835147971715746502329564303807333857820169324237922076658494209351312494125126428276,92953381239744890691731729144060718923924857182211536400853923462346474478118966326974722401784179370178626790100827770099697884697535366901/19663419715754149393404006495264221613416145714904188876020303381132404318755160773153568379318903214401786123909783552649710737538663113250,157364941630615824748271340264547088960005970917977278339002715966012664632723212972569059275375172583681232489158519484862057101503859599491/15408892888723307587889929896251741928630970856507248666028034360803647120785134050923797995149519894848613642516120931558213465207967953024,782387917980465419507281952681568779160440985465638575291257082655382067564855034627134602304867502848581394437250157205996985434442805862371/97418882463866687413624858257454604420667954134672130455231705022578213991994688531258947660969201737435317973012413865010339608172478897056,153766095424844498395637588918050359482735636017868094797929470265055897540594845676939777120091667472109583773736144357895136438533477003073/12596080783461055027841346306526976794780294546153054049452870633028518717817832791214747353417089478457990617343058971924773098454013508576,44948458725353547547898496650261717733424402804726293423278151788879453266799497558537434451681418465544282178422001726950571732050888994855/10336925265494710406366257686852980844759403386359440083133171213634665502088112450937062475530975483636716120711665516084213821747096461328,-519432547331782460212446077135452973294994497910569757052506986474531380785236724793583348159542197868565085181489265867941061209988862770813/110870522721119374099763724823395171902645446437756251478388418719981542638526642025486090600468488293863655346462342227486174577359704871337,-249690303278903177701930287299411940988821714204949974614105804463994393719736950144058901676230563531994538194681580846614448344539372522475/98192644916231736405546341060743176586003343054800461170905949952891473442472600313468908894359477425258051061197728833112843725500424654927,-1916694391921375676827832671631804569293115008275781669173589737583518996289620509238210864151451462222709095636686310314151297922288663866820/7367329828243302568655483477622484190504375340585665143713354290016714305566149429019652092171338949281606236141695211825240876538793039398027,-337143006259035204250775742493064808320391479540913457515539006864046704366831745252809841908854039576393850497004056770702354659026891020819517/1307242702325361550210537827277096607806666733648014365703369786670604051059307619934380654353976210419372717402125866683273492437948522212976992,-13795578664992790375333334395622147446811694475708383531701406531205301559712351407754361405861617810737530732491297399006454133567482440600307/56960579005741981169394843101728460568209298700799019042158869404979038343271379266201092152597299372599825913307488400295742396618511397975008,-76851189547316593843778948681742145343223157908717212938674755567981712591504640379391123328170696735476497541868845061614531852513949737214290/169940321842266570859990221953265694860042317322607767320355545656510117643941573771748412169599701011424159090065799159857074349122874264087653,-108491379472421179266750060718745174516873015208478136294506849601610059662700252954252523462545734961268767681701244667992560765261320411904268/228509037848719841817983200082730979835306205714642073488055514030930743154349225177007283202552233174206326286851356045722839717021577063353147,-107574084747336118698935545637648719353661823978969240495572209770390098503429070791779733195291996788426447695095066441427822545480357258814172/235909206088905284652279165343159369079234150222284563298282992772508475541797012845614896876075333244849084379418423375604081261322765711105909,-1261931844796495850208800337232620417117189338588018591135316522969080688535266593631856315035800324551337157647691426374212899134121701828916/2870569644632863123896468329050121589688586622184058430091682691546481738779199987119459101937283562063146787925160404424538650924078817841559,-467340723975926819045704813160910115587573883709216058034399351446009549712624494731004387771055234243086421403210717280114816984644036832259/1619210781509038785958957392463192822091142166890262050156393893456615115021233028549097992876585533893499165258152769805459502759739349785776,-1518853428961247481512291275102764480540711889628688409524437077809361828858214881852647554949909636952892212012270712771739611136085441235961/5760323931025518148118469639888906944832925697811948054666149317497803364395819978191172125338482962561967870667545700165308683375085328559328,-2927545951518390978369666408226515007529045106651943259821878608271574341084781909747902104520344755758386266133238432722303489968032305211181/11052482097764208057403559926045257747158643494745443259417134295406372122539260509428285725255554957597362803267183082510496422611385327251044,-71403868698979550807686826252969829249113958083536758036086988167071799473855285304707554729937313508260741638336031469343307741190775476219/295750694071393884273004512299766996692653738730708976121998212880075367141312743033867338340627961892223177332841531983546544780863167295974,-19925098002947614038501779555218799330151099159636838307628547904459997645687259108508519063087779159121745324300099413686064967671504066613/86303789554563408479126267003405523613325283360058678743652196544716291757055068351528858727027602411093218731968887015470565339871950069678,-47471350606838846592744720057002286938096598376605180732689932355799641812240263335154645810201282507518932101831373966439244522783102237134619/180333688658415436198799360830081974176071443286832206825684452778801938985620493290952069199177697896865423779963327321562952608751665413085376,-429804164416393611331149966829262935218260157407272806757012105236289181196905634535589808538046762779569219540930749048909600411602232681781/2309354988476101194770957203176380638435913026602056208989107590141485080761414936052406413518567664959599481006089206311833969742765334659488,-80450693102096102341094018178719164965221490377556023239870911161405728344572540343439970960597053498389525876356726752537578906419222616036/186885609602039637149926746181435048378207056418588725117851602539882581544356939975081247142787657944614835825288844832946090873838769922147,-3501720167042666994095499393790850812970860608250751608947970497357050894109623124684168867911790336183862125327198770306650384226404825416076/7915769771917219752941471062128716543437528847858597010090180482905017833203004612964012155643527207991363944598276591743535210663347558392873,-231040292045368804919538414405435512865393924805330176539344918860221150858612839430378528097804476229096518711627777653751734361792151744092/241511239099209785601075636328456075887586509874489931193350368137692696574321640851805179077371976036115200362282234532863842097528061439581,-157914659166076540413132428915851776168068624167132896791271879229481209210998515319729130864186201295576760903562708590461199206344139077916/409075726972193773781960417516263495618273433801784899094785660123013577833745794276511751851090488076903313257160982234247538993296970094029,-993221017430261280697151651414709837608344094647345659618636091494060431847324880450413315873313825708441347563489084035849096453520725608207/6722651588117719963042487522728155539305401029559148273577984613913527370752132817346486185762839909636071550306441224245574255502441410065136,-1831485856805279545512619688396918442806049671217438221064958251640693110953904482531148575532948476461826702463925800862198129250860659279911/9079877517103112313270101981213725843171754711919887107138384022054301700724724493478638033734592249581207280263657114703071744764172439200832,-717330603268873143937940546457073438797391296940508108171306176551206519663425611123588522236182890100663304977504632980420754814641542492125/2073302565910268062861730461464346503272354063728157329235196503981325751052040244501023189551598369777662064920383734803012984402423225676402,-266550067636080998497346476040579141302691436718101420075698137930896123185323969044997260245179380118889609521965962886861684156115552201543/1240149010527976023640006703218366121781797039840241374614268549585535593087398052916803851867123557250563541205586524380219485861664356157312,-70206154511785043042261613426870450418366464800152554196229300573062813881083228813992061597825691837819223736437775246078949398452222820505/392539334382150441995958976564937405326522613708446784135881470339762571179427338082381227489008313855839907815185109965158478826234291509276,-7845717303456636878326011424374095486839185652202045415552442118303537693637982529463339151796397320645792208038576328395698029277697655280927/17617203139278102987296383205843167470722044071485503618693934529793401868497064638611986833144186369886477781967922770745162461657759573986463,-12620274749009578415289955965847325235112806208166013585658236551759345725345713561758355247367381471610310048152211685176722332296078179503636/25314831000874155100647585480481613434273156717220329021387367772209672339002069427250362440804164860009325086962084991918156619877892028316105,-1345820005703376222130624881002250741447123710945503242047883913051770379867111144896181891412332016807805475552511476776051626625035363000488/2702239977019587622414371610736575863435358317301525101746444411812531390340477025024300331688681292515546159748210275598634325262599615691929,-13646813780836579718043592805061071736639687231996921817629578665827281918238296932512406060177027169499907577551537967051832703192282054457297/53380443262242886488583081585924746071152759898106524972111984649968992165248248997679386404190105556875503673082611498133467100731956977363368,-20342363729022131597117442481295787782858104310644247467196785891703043516541840458278889908206275082655646235645960418834162741620152339134585/56470230219575680624295826795535827050486451645144973866388980151319648300820251550534145203042418919167317033550544174164953384072733853724789,-22702219877957877366776538102535111395229521376633195351398590667398723992482734347831701605275606776330561318354819422198491476302978002892023/70819108611835646135440175174911008116545558627887713257738616354831216774251842943749618665811356177171326357530375032850738962882126124885632,-26246435678128041146321683464043726398870481113770025036942218372093725881621414800111713821403566255768519869218626217433935736388228904932082/16433049505183225799276099034583484709513001018313261641834259201613507069478091945248237834088758847664514707997154532964284397503043149121781,121480792092051006948417330464052166528843486553009853113318136840597278790084639481602095980896954142664975086506144626704504596126590389601/1038730530501303178229840125351303221939548939955513855035891519345363295325175081786491061278718463426415062021711252969369088488713119394112,-614791319903546703477674355047503935256034101809855065016702230107719258720916416627927172317763850805849371845147349552040524286533114378055/7955804990595252854092157819033327299736585624044428691527337225002950882856906261955587279520206692314043691216750699421125426158632286332736,-22887352732345085160478333877765420172302284257402687552863201183253311789788038956670949403527051488157769290758675089610186550270111386279571/28025641638163993174567899159882835437452691675691816784375279427900921141856209445319128009787282432430808574580944857974507935391141726452864,-13066931548051563522332074553684960579326512583274706674328824965205397457749751385430147231636782903240074595681366619948969751935440009759219/24562766416366690141227614376630690710577742697405431305068135037911744602336612308933083009720661025385366685791492568092106541651778398152056,-3578550058846394166490922614872493373492997164533883065812903507807220256256171337723039442812069288048110787455533579196413314551933706733105/2703936331968596918026835412452590930211299629715937799816582765872975107132083516435435626323028947542526103953243608081797194783911190023696,-23704405537301359174178021508965457716465921801165746624323456109995909286254264546064166470831374205912115247748516849991657270606314798771/134856032293136809323652760953625514953820035599885102561990316290082383025208459571524618179488051247966940388440276703835169650716525018112,1169685573127548252283669047887264568943906908375935414877834591983676957598829674053366594253663986809397796309046964718088191555628863236489/541772664543087925966872424677829507688094747703738835315793063534101639022589128955022498350585124582719657590743181189883493944166999445136,-31193455499830068360331859344504675942763074446705190858073658453703646801169078246214670452177949257586071479784250504465746844078012473767139/10444533386301524973448658458644901267945188187261176204883738148813873216434285108305349541419308527006449726311128229072035763699024750370289,-3060874484269143648492578054274417616047396461716942549189338687873219935158800108621503128848264485029437568459857988119964994917621933491439/150738539083035908321597544631568035964635333043019705968302894577806792915386600426873470325727348347515957713770108556812650881117103660011,-24594087587830731039496573470093753793182952738439997659520428427921127116273339956704620580894133404269403276532597013867776815343085352501535/9451796955374159617993412218714379226724022366845006154057517340280201569635387858395718867247520308249183873645970570673035280099302584869667,-132725702968796271008429503605639852952592745784704450232278469074496526134688553438356317934124695881648818731680580726856023814042467811719083/286874084107504969486068872446366424810155203183991159042041028077617403647264801243824179074427010250728097660389277948372780587358435415018570,-4811736982965407788779980649634350794417108502802563458415325678141185282728000895033392166756666092987916107324345838822829944603872129436643/18458818944422271388178236496116032137203800411379639990337487814279498988948944919770673899192755002262354968993506187008328002243680422203423,567000271623132286434201804785198611020008570624779989779005157056514266610808829059245344694917409605610562802797383214930685179122288324413/1212214458889200141148940194221096813464731547349821804947744232044123329341668112391962065058137874622382581150316084295946891134704488342457,78792711172863646390319459963474054705974369881025845467486645530742069125311411561732226630945167952819375866471598488197496447935440066826/123802949918925363515675765087843368362484136281738974237178221747177437473724058784214858828485666723227296458246296050410190680586342321595,13749181536003173644882508518303489059286844899643703738736390538260417019920827203093392040984373962908648450781073374550227151957834871037/13581230438961976909993472585584038258007166426508320538719769503400523104412041212310785298581313403631083776849131844598446663409328594852,396607617071251324186779662932652784470020563187822970340778186162201339299073629903544952586152424326649479123390278329469492869770327192782/343767326034206620821302376196468533876140517557107668343226072413642231398084859394672851680591916102711075707705898249304796385113318350809,19333116322507320718834459196680466691952610991653563260678187298653525167969074237231633711282060919229771504438477436729250907994114317768/451103976305301699124358863919190302396002732820788786810226091224342066896142111228783902330878290221176496046634311949758826772233692108835,-161332039579144093091162981874551788296281448963474440874470071317876786490259924789389769723698619374430544414204161861287247804202472055328/4579581088666228048147593331867312506358507554873009866666504077242492170773409126379777085478024861026119854272813200047085389038209316815347,-1727945392250566174981477994370491456948421615669992713050803475460039681632825188338853304073723438685589822260236911839141161988673771128547229/2258900555565966209472598954019238989157942390788170189943054163037626336409716654363047460791237611673919052652081225947811633149355432851274917,-1841578617337221223868035173546823304945943940316330694444340015732512733005309867726676713571607528637698724680146415865879016217237222667559/105158608511097251250683906714032777466215204288642788817270634051246169018001899530314545961178425686006237868287737363007007906521365781719939,458401953404257903012873017333982940175815364077662774111865253235168619949704834190833444682253294764711703524415871511069356785260177387037/19441132694539299172387649585129370937215180462407585948901217097539974129371054439164285771652514007610856828252454065560184435441725256557143,11714186459677972608171860342482105221192147736362397269853924390016146010562250452993757111783528811127572816601683725215589961730965777356/713090499953476046738667194056915458364826029928043890070856674366026298504953735839275963928288517159438436553951754140131173190956435967039,-984076808719795807557577819645073345591795119311716092107727278449749203509021885744931356773519867287203852471967781554161813980395277511419/26076534758016241578558763972643083814554977460630291704933634050735758286873422335005491462497451542611284824331215763559198946618404502364354,213375246216660913194761003318607444480165080620690754499388301889901332873939428435748929611778521249914902164863058084992954619217852140880/224185787438252355514942261198032016543454215824787021719376842953912013161451781843035722827088622793862854964630483713721766616665969118579,63026608508728569662086432635270139594282285160272726372848043772462614782119638450547070620037708747317571366581862493599418686429812498410/58744305942449364370414735790339927058802829643267678292537135125474576217150780516207045741261122456088700892238998947260130866113335751721,728012222672232552464252180961073975203007174221911566833308013568078550670801943920135864824334558298213131718267640501855392644853149652246/609868849826704295473657198436562641151623478100898275576821208951712761444583082805779857879588029480771130853338757230493152673962375674727,104388718328492152153937810456365338334657026113535661342312127008365236205969253211523643033861219507290586792214832698109802770861328489510/97958378409730310271068630518503449793138212696436359502132349528126393251514343606362981271553650204192883978710656394039836721780472598599,153621971225092093849998903304261253278099049428610799884939596149390105708428931965122162080428798110143537443122125831145752209025099115289/134774811212952633920920421077198562499512672902014508026468134600513148927741391987589956800217648893109894995423490569332042478535084550042,174414629374950506530233224485220435055129454579917446087952064552984187511404559116511829074578026476382451850213236339954512097119111871470/114962654770047031106587864213157424213868388327982058060909292818908156721901307482214055201840561461737420923409106657318559434425542553817,11391207709060645329461266197200043205042655457451144477421550016084790587320944812071479869614725815881428440764293804651224834098987262460/11904230004241094988369062252873831102946262208713684155113189828081414982410965196218235886477973289961906051405700255777378261661067801787,-2150282673435541461724449011267358954965417524004525083716211213147783212188971101378105830580617044971610353225463322400015303630892772201643972/273575186010043871354293206579119589346516069336118768617158409385370073981276303684264932432258457896883446548486751700900347873969879460992329,613355171943369853157964005871580856708416720263238901943697291465563063329077517532457161089256484244005218141344785641411760754361946416134/359809015861387599580201035611070450164844718626610061563533426517489890722528803173998287403181050858821877411109129450569680152146550355249,804980731039314066272364586845713172617174537127674240371118986831651230731724330222557692512562084180164033902969233724207158946547014344978/160789449672181475892479548162844643511861609671499785261688128724074608761526126809979611202318069062603083357576052826545911476897283142643,557277829949695576428679057685171759552276112302256887341393888949972827115624047742287238172781845678358938056842851678083651173909905572507/47255102282439847516768418407208214991046450828007586968284376996562712588960713291384506266256202027158561569398717165377779105080009898710,-27341788911702462666955000532034488418084155286794715616703623318805265810895733190425696085091115842590550255487815416637905552139263640794866/2611640079074353375584348302395053539203475098843072739524111382685959744504069977754659644452556026447865287000271122664428237546996880662067,-738950491427259261303904905823233265104094499903967419241969832967086964602707381829596859429846079761516442536229684730600613752716391467242/108125221956450017532673989407552802469503555906731306759216084677956950668079713406736629975741609279333844863101180724893684281708401927549,1636710479077880282768619478420509770850247153065062793190429915032632914490333130615475612919452898506263997695360419773169316887457136737413/31478368094454466440261873448374183683058105645248877708756055936361421308835732734857595252475766939640827237590576892451776272769977524514,4887077858246971175872136062197927134770798619124632315296159016592127153400206736824968984278454238108423199518696219229502448334651072777/1374817367775748519578176193592996749261938414567439674580224313761236020401089774763858493898158463420967951911323642808213222439819783902,452488863224422318822236242182479364771340627914831360531647032342275475264688780755003213514860286299498538178679426881148809311707995022657/399967247613949091675170469193172054912257934377968600357271890836879167192669713572041632130446409918920466846757835324855869819596342613469,111800637124414293347784995489333093889455789163372355632165877849966466596266899990172157011709931652795582818968302509789588951521441364668/168653295086819606487527718714329559767551294990482270476195847440597494259528767798868373159170142017461512898619623143843853814618205495411,5592397323119048459844894401186726493062926818481074329284196179019340798255980603643024283470179150855847754567169334703950550253720001327/226186837469821689410399473423392433447077839184042394721736829343443189172962321939808920963943078327654831470426300646637855473549266174886,547546569793612507318508660132680987748292008000777430946137697124793988473473810326215445529775772803322146550399026794106111513427567230123/796834592621288369449234717285467940501224888043686338262286474059082758404128926750089991720298054837555774176448627613362458836004195930710,6115647773921801819857357219473359342298690213958428714722861407483241577513832463154022243837507649542757598310602812218794553881118645791/169231316254833541842751719181075281142204497818812219853315032317054619201012074806888718043851282280459951539031207105064525694493914102562,644067008102811148784433745739950176752689260411687916562237149168583595392014772746948478295108448117601164273235176099921820013334627081/19199128176615132679491445772719806894099201668116585149642416542820447491232541501395838605899736665042897638958506603098944855694334668994,2065340064077741575180522552340601209443716391986791372169089438107925145711342330561437948920785934884482189158534595663462449432368724575/102868406016766682571690594764908655612452733598594474692015536022395798825634981714140360546117241023319036875545816150413542978805892588614,77265315769630863366809202514938582417270778914191482235007205451014488171736313764647544004428502495486889733391705053971509544428551449883/73921531645342034144047173944590996628648211604566713133914668483037678645759085651524730338977732190495043369932400003598429696836132075210,1934157913175879771568880626802025029370956928969661990427095066797567216149817301098965606336645911949619100054917945145755589353655425790735/1174201688077732018819749936707779288143639101690023513689260635330820547724428292749917361565314678985164433386477985504282672491567724147544,1996091970219394631320621827036688125165157343903860003143121519106496619183373510176701625376148424357721619494322677957764618239994938917244/2157215340351327453789653378621688494978942582358138896094663217855347638910579399881010373671448613882927092360652825814444998789236219542599,82626574891249453197355187020316889622401724426825170625403194265905056538383013961062532915555320305871219974261074538561851567859670839588/91492239183349305315968959871124131928378510322831294318510219987843577275237848896014066008987037300304348362387848728141803472085711873203,-2478042931193209482651127011411094041391750738616111300020892090829666278443591816820737807848769981898548408912699355384658221177423140153027/5608347283140109059308113318796252045022406525348409480999236921959196054526468164832943613362049920356317802483395291033523752294460551228946,255485085022667080314985355410106158162176259780822895727255435894917942376594338145733725520809391883803345732656191275204529472732015030260/36392002235523952802711499072302325223139565442196309278323943229342360892108873021566228453792868381129648784409816037336754918467350977189,16480772351262100028285873050886797642189596588405781097853304076234590366799649855376788302070089037175180868409719507510540405344729300307/4984114729344618006529379923291713622704673428981938130305470715293830216717766339237912564105100481545470517145891401442986513473193499724,-2285394306089584520348719009964231526437888858326666051655722039120431667772190129183192066810040692428025209196989991615114635570430047885746/194836758742485055296825213331061096889682348047705552391826880303132717591209100695335916520845598090239599734727743735242783340244053242859,64688037355169120975411770606161620641979491448509671796157975797260111138497642088454926174992207410104943192204526461079577464080375458937/217385148549538318789573153643476810730428566828599393574974563031478145959977117067125055548757618523633265113875819637553359048795865347472,374379996962908366550299244998397584385598570079722275543373880064688461337551891744210136014432652726287461883950016859535315950691410605462/6182641768225426404028490099420716339043450111027813302803547903771577219166824661998097702602052318411075052799939466873059448705966717899,613653579621452956692266555724734803966425282561338278236765819993902010743981609499626052977291274709855304842340246898848029296433579806274/540592068019553457256835515196716819939893110031190494038470489666715384459279017148112419564610617589005969713635277847248787149473026608187,45300526621740146019009707244383757386127699266622213052661314143259715628462621168479635780686582671606030763329884772288571655546090365896/36299904212168498871488845930102451063381732747860016711689501664434941416463418991196868320488046679865838026571302675396643357219723496817,56696379482834710138530295957170220869227222551859111748108309405068204672982225799473693996011920269145027150282754268334784040363342430579/31072251484547575942088829719683737867934460057280374594199308522835786335303924618110809991918023953756562652373074908262284761701397446180,2185788792051014634549781513723642169487363876112320213758622144729736321025165268904778874526562067421735167189822270963564318928915986320549/3556941217803096078696859748466370051532930335106629277760646183429518860610146712615840015194453646894197027907179853822490153607032447931274,418593107222832704285673461472318495573967994374040464468071904953428834146547227743900053975507043846410827496858776645823221459932469099403/624911150850714184904638552154303397363197314124838776088442290068793026405130055666700251393176725495563875043765694911587370944379991100918,2071882841529059205180855341238507293792604159802214698568095869730934143840417350015657013686842305524190425964420401269351481165011696627747/2883819482552977973529026752994494776611587026732172928854121689550128959883274898307389047850939656968397251275760591166192907622689224939118,2754795764479350115483101863844075589855620821089505193153082424711989461027302485666820444558485255998016239552903412742307330276698452940521/925003599457021038905269943206563304631934148567881401311345218171457109915336020953379985871531033799221541659672490864933445567571691116846,-2437385770869475991841059310276575257927934029377216989007614112525952650220489846032349335018837975168169338918014624106089342432844431786146/141598673423289328111405922207743680377398356360731199498992183543245383992460782918817119853319841659948185776966809652616797119070761163589,-78209671494038139961494497366007645427016894274927573317751070338537338831634074432236069227577220986144674323682287477026634944159829097457/32399563579904440533081076120615631000750967008146641550714324278978206084515089824191571699801398619662945278444772750132729729627147105212,1034084660721204284553508198661707317920373469020012620558315317885420803327113392221831215641692923538089181002636725296217477468973096882651/1877510832126935650979980146303303354605478363540190619224642010384892754505805535467333308345033383642174368902960761395971291369411551233951,1174696682347437832030797001435561778716560174638632796811939328126741492675908790391598325378728970393493094511141639475983146515319778707307/2126054461653547347707240983331955062984975282763120838213623919125031406513906646476219379692259388085989238870326377771568149461839567089294,-460951782827214317231675798366439487017445737463198295675196677258549917045971807884222336484301290227711065774781308734738453278948314986538/1107546755829162616054870909191106541999718982626223452665161863821850108432586754786471505447617888690356998758009099046935632960074106410861,520478609196362266960484606199652890458179038518098502116854731287643730129881609741195908646864206776350416830363024595501555117364598033286/1144299912278091281566917320932691578199308414162864307272923340756490389366542296474841624118375660173150427538373553670137312375559520693909,1506751604145594772654160019229605597344152736915570121223617241369652262228702539844726792463946012722219034042013316094230289201867415087085/2214128110095188109934590655414339928379702618524632470938472000524632896370745098041475079903656918304717665351674155996635015313438211720732,3403959153273255441917427919334177190139306196963166102967733173375738017945801413532205833913453861418379524498438447583012366672742635830683/4982396203059648267278152824341239671392107738404257689839077245440627585783105814972322103129899689460963855842727375431104886853275566960234,1731371195566442329214475507054281528226397168607683494193082870249038021887974481604005434228408378200312044246869035071455317355433222453169/252003861328734184578264782286298964665564432914144907838351718455089691348475124906911369131064935481969896955225809840126940048892410937701,121070371764638634669353295165708451806900339438862317031325088696559254592151376707255781623559267925702829165057654622203792721198896894935/411589216222352236326670064583869577798843091716510416173353877244904166635912689354006485717222695658918887156412443897205686877674441906364,779434942383023459659336517442120056652529048622215294621096541148733737373687815890452977000585672881422153149961735037590674264888890974774/3710519894484982612697929634206377199214393955670744644710115913865525989143887727230540982052101407116028174405950459131862007831558225624781,-71063878653957730309720860906468511842103601942215195231352119006416834605651599358384656729058928029098615863997056682095320422548626568008/201707389911338635108297786325387520995558961798217691931232014529706436958290668484076905273764433019515110783225668289184842099842562961357,1288054551931727896825108075588551610987479940221732245452509679584795781735225045797272920643239673372512614857775787603726009797615644350132/4442366732708514754480185924174765736457070508400416530458702541711513108501252774703955867617969599955301985487184341734215697778485654577149,15575380125150872282603503947375754380990581499622312148544250758241229745455520907946627092504885088722736777706425325210877965345376006/16214108698450331462871207728027991875723644279770144114793017148181477002477416621018825240966414046502912251543229590078116631273726041,4384842030252923149068033924311536792166575687220325095304849252340640988105470280840470674506288748471185396267956652129820049556657610486972/9115756979024565324831996512965509845904090094901146325791578121848225426278588035394736421951002944631012480746375402074194970720924935020559,8828955713774478778179365608622591160767422814223951143990557555771717981927135922045022039484704437186744273968594858593107384093212412612621/1580792854415054612852117498372630196603826239887980889837256563938584783842650073861051594584462117970437230324120658335241679455227550371750,5031821020883859300964028988937738921909279394734034113268975819439765307690689419174388768974948890289436901571105296518656561239896266682413/13445464187436786247281170582812123656984188133835251910575251572390066758152862682412798147233378209165336369691382430377842728271456199112789,20164753731830197774081550535065466191856444797356894478516490428932227254147417010218497724185495462577147510662438139694221911067182963893184/8710622319027059123069843700052893165813318047018982042446833579250856585204215009167623997305926127878869977080119847512215386458544174945127,1669688457237406028661915844684643914840836562420353262406425297327248203320707814569889087819661808980445594346582588508763798131847830424264/1055613123123695417129686862588210807280616684454158043326975807581633031413933890067667019669785907123583520221596297612123200229585401907117,2668055888143595014271700937208960363158742817338787241820952822687355573389615701461709477141753165994834716190025516308507351380635415465314/6505978976504464847252102627035368233635025955718464252732454472200758060292129992540032815755769370838542276430608497170035540080083950052087,3883284600804554450624104099571025371645699927222409264968991989196902965391640426706707984400066665538108133956413740602762311351736680221097/50033647261599369540111167072303959027175456358803941650134789501632153066009786698538420446367473208309802283167232167271744347401139691211,14433459171992175192444205645066696450161468413830720676013939684762895971817102069541091642520398231630886762569107709503111323918400664302/13947188821699453394596874872649192772495899316665996613905698225100421138476901642301254662537396739051357837243926552373178049196084137727,4978113466538379489728710491756063371485338894491822530537582597472988213645118239609457394914998998888509442014514427887619252688488475213202/611996338870425152877847645661321545959265215402922595787850467973156382419535580383806589121084870769212055790989683602101310526288035131839,-2451297727656574128500484834622567978918057863201548803921894190723763198750599930866736012441050290326162463995668236815149187177921605747391/1058446603018604166986965463659323698452993060774531873748896137966445382324883565837348901582367866513491477655886701817173730824152918343061,-2541807307091666288681631190668295883605194023006294148464465741884116874638566678668382558648369991495702904187449820655312229184598900196440/12903457983763591598767116261389460488957818105134759943621728158233926895171226095243164253217848482579334945195162070690047335908621092771,-2716153078509714837201101858260532171322907498633294996617586192275880958657014882116683298507632974077078104476622445479245247056432313465624/50901214398028320135406237121480996505980851307822372001798772375830378895908538206952068902845146655705796314096078218520974902574824400297,-6424059632508332209392876586637162779084767173892347875130938277452463588997893512008759959581642896514151594149750011526141478713299177291360/33789115090623646241884407936239655874783315884202404015818161042553697825221460901392584724606464117033933530533950839542104333484379622077,-43846529645034401003018712748645516926483738587003322618781169187278260274069648169210979157489766703197068083335703965237281022764373887997305/1509879690488937167801564116624852782039886476541526065207794715376681034494345488791508706303485135060502542160542284752486114003228635558688,-94166889599848893360381642326916840097797638298135634116595922765672690269408811177917208959634938901401709280011335043077629836120737583829641/24374858507545554584306718068638664963781500375251213499377409449242533737645409667850446725012135618647889802970710659066839819861487491157718,-56043866080743204488135024655331555576835844939781248800653595398252436994255031908486610105068749451242290818513368121642760134490107706150655/10930610887224550012341720317998524715695933547420661503866930506907273056791742811563491531583750448918343656860484032411623320353231469284196,-1129906048589178322592344723006439039712747354702482587254537317326916387315517943113741859189162609363403282711304798430195917090633302357661/531006296032950685361050618991840000595141741145939126719104716280716159387194128563606679482472730049515833845373439076595913523453934848120,-15013690296241763133831142994358761020159568304558859743768902143470286503691967229534290406562441318581152203114121028758473969282969595552801/959362573304121327679611751819720478559858445525634946529727095973743759634419803629470980226315999475154807603567541776893266705392535746416,-1729714205789224428702042937516308664519174963002324806920299889909555642014759495093756932523639897657352825586728359327624159587239358759619/453036940527788258124887703423238816689873503707122906225710833850722532774776281225177373331800721033587174925451939220655811876036275493970,-909212899597866398548360015629863827886402984146735549738616962362218477652929981172623612617418394102613958963043707830203267376007929113987/247204195836556354237660374891735836205821843605495681479745065291249507895800392023095944417696962845384723353911573670884724220715784449679,-4006149199930806083347000565901448875385048364531229390747641354576978246744818413161383529592341942565667246564419578591433391678658618826877/353385930146207448327363858140498874626805918666856845522501846599220195468877733750677170443529549841064656380589019217238989445979198327085,-1287042696666337134277599411675834090521720483053597072246357476579895194550262153813058094212607507467096403257918033029271294077392141185661/37545648992064527863167366568987565669202488922982682085262817256929776688606913136970463268119064838717916539652813006740396557290654208240,-11391666098344073163586930361631991427580795533942137624620631364152528730948245413558584005270296102581256312916313442590938587169763762510240/7473763043353643103973637628490783891461103130059415291649705612789690916060396154576640389292943375222112459757563983067025109295408987008191,-250102647592012788144199077014862964809785811336244259633913799506513098787815978949898463311922378314057388005780226065977696967837226010766/265893343472451258324636077669494024928426108010678372017778107080967897437322685458958197998756063193943398691196213942301025776047715843431,-49168039575513640970759022082277035755807716889131822798832689484179777381923569170333479898059055101106592484593898244099930690583034618732/315659051864642761306983115132316095632110779869130961375555866251241442095467394347974688218612544312496392858420449028729998728890282243,-360734943763793097937507712763884020347386832008005240419303109777997892422371724678525504149786840725805607937617521908697676670297729904584/58480375858089060273353513187057644540566102636958713419347013485151318351731879212050642419339726397966730595629810251668791791230495939665,-58844333258772822635944664333754805737078996994679316507791919927766789427134592804548419838538282606090771234567384730809827076558793514932/30015811806513673790379860529252737562838195150084576163550745647740547927627737261797280384897232373542911464051197318337669970049352791985,-1563028146571158686557807370609374012142194431631370208798781531904253105652224304561139031928058038312212898360769930359686795660712656065316/527706482476365619900122765406805153198409482179406628123114651198471663907391197195332799377982724474638456380728918673508642662214253061317,-43549882160756293221110430180949180115169457483553618693124394162609180695152862295050663966857834264777730739630629654118030925443452234364/7327262614181213448617685328531520194846286001482243227696747778881438954080979444433300489335972832413814435643750028068111285875613206567,-681360211631441781148337227063813872220742909165687618342808801386190463940192674293419960879544615271551170167788352713031880643657343502516/124796846337248876685915944842589756581570774367189522014454760825917237054991159913984445818395687904235794904891282569551346469744696735557,-8940934645767895832577367752046331751648223857589159568624441284342854334917769768622190397453847934511836219966982693032065968803632248670332/2011355276106377564611395365461707168814928884020375241274659261578875414427957772809375443718214113317305093145027748712972277497871436138943,-539843408343619029084993788370308396356863243692223586199342422666689784357894415317238273843119713826793376016202155771945611706655471322736/129112691897903040468734523478467958705384579619483674911331451040642979654042161225970030154621426838126949417797422866299247097598219968709,-1829963580970709713648769494020643526414529714591277656210043649856025019839480430039221797352267553288449531186825400542632753598010218508833/18349875290201130442704767328079982183934055263583441391328042294510786684781329422882069112373498689593517857362012843483598824643195523232752,6578604536791521142966830073692947793612263789296217207761511341751681272978038517998215633030129550144656157145912862590218167886372270573639/12280495338245579628270412505215286456825552191944345924498521311874335758963481091248019435822207219901732751069413567790685525543150853042176,-34564245049309193466338568067527224661165965164203113566942337707891255264636728238670802548714294713147616812929896246912331819057903225102476/22658182796958838339859052663821573686875091056251691422495504943839014016333921826830238678374403135420868172101722352310634373158938094533147,-27870740567486651691516214158369746961594403015923446738816764044052689530506087839494842402519492173752225646709102733733332720558581090300276/18310316399163725945534887690700076722397661822014791492706892791304294013638555723016480996091426475377680543733303454430067505772077273732849,16225114979324144413378347036932852550687336038357514299641108939349231993590732735709958419557462424279425447122873159943720961102814839016081/63269266596892627828754833530213085332189797150749997264808753913613791990463167970039168342096848971332511585876750085728295982359253870614016,-3055542975824756382594157807399164930810267576841785709581975022595693249634161033840762595972692072997059150629681926629985155528070089561992/12441079962766110800522941435225523386666412508661689547207577815012022163646478368142588225889822260458259707628462668589462467230981109857,-5899392892184926631741601362503159391800317586104246773633548277842248784853601787976845967668776870586544120646713789750064011975774428470740/1460923797636494097510607587323089005623811885510024711069651379215653741485358301300540241790064157856750381089054644328168779508935404461741,-6565708767457064163690662894383710354900712533322274863413829343133203889998256918096663491174040922657231170142066836433819299345476454928917/1596449020819854710676953123336339355669427923770097227428057635224888110936217921805821402192569225812087252553648523267296520419189273056884,-298415475269090391094679289178284234221639061129394973472851085723055440277591860348887116682738598144012494203504606850881833812521286088316/73753486784869476001595526506074798962743781168108191222809271175049993326036017132064544923919169198434860143557409961420980722770938093187,-5493634330606269778392319178399173595766793464753289155292940422109984724810983249099562385086913104738926312360766088184741318830540983235789/1704709362592110307815202522465192768033313306798290545735376509047783631093166558177827138902784956384966302539719168233318140514948589009172,-3054074857255517826043863581949378671141923191170681899887040945161241197072476927118772857809571238168780029112158662054707465395192029108405/1417757980727699643657815006623551975858921599064148177790284221555438625249937575376156391448281129257887270018844730827730706052348688297276,-9893678994260523350097034350097987881123758208914300549662805306788810727866743777577749311750421070299426825306125367344371677698103711522204/2634166188119441650456706605539882024716047982757724874216189280720983351918198787710935847802021931478162740580193142514485069985613027384821,3531626536474700236007484341608789209293437551290977347927874156074796284135832610876452687985298331242684054148570224502532840134894843606445/4328234945873980395688811056650737260542025645320303722575371612697441007004579871931998913546587077312985731973854594250112137039020581837414,-4288631109469315247371970563467335128953742382860682261977381635949834989279573170923549452195238382838338612256712882672049654511875638579748/2895474799043733819780580188191306328078520764376814686597767055024828931055177684450360231696214550707174556865568510765809219488870591201573,60804768817243492410433448452782346841694301680164512602267339141853948938759364192328485937148127028495585310817885143536787182866570492612/163761130776031835300375258817819103585899120472890627565694391717705531085340669002142279214539638013326324240761722861113791698662325889779,-133555825468486730503327245274322683205508517463364783990943479752344293720935803441037950183917176259786678238927315846759760270847130452892/383425428723993202058798905138965726436451214720848335777397509264857593847634582876896516427538761366356492883792660631412873058539731130411,-17317707961028370052865934799702782983753363744155123778987855058086396143734992384127304163447175177100777772854343999854984378953065917804/83513753329805455354731594626196458671045436060160715925286903010330538585673156545281037932739986794505783616796667443438525659034061025807,23742724216940290465004135156981952122588596823253998708215525092255362551058287605872211140341646301208032290052969834566836646045442925276/51220279760856714434312978343354506445234692819609009779226140521418320444646664704311807229725682847209195340162607825383855253688999822917,400822178693751401059058368129295177149445667228970144849891598687139259371731172740408421220119203010810051212975029108863532310171094429017/73342732183676385569714252244519968515398101062192667514678820688012705410797491179472721906167133496625698456989399656876036120103886882112,16164219036907232332796092483105457421604589298283492949627580853593925559886022478113371464036234887601636900175419109429284311070118957822971/4444186070043560689276497648199837793084148547543248010251847310582684662257808028953440403817641638925256668372317039313831517281324633628672,219547757016452802886181972293028530548580151960996829125297597520110218925352454769117023957214375440302853429839964837089854609709992223601/164414904749687407492090745230634736712294373148580537787764903716376562610092185438865349625433925302432129100118451823439227733162506692800,467923129881687704145955178226768989712613943025656992669662690684012765581616173368165509663208673609294993963983768285293211958633676921683/356163256224397163283917144350596216723613778760456454606732282033401713379814752052736061161921799279921356336288640637598556776457457597736,46019439073061075627164524942214156641803805282293154860489593629574803907784733946874029916758071214453624297023025616948610296834965109783/18921775497276321078266051819907356257726085602320766328671746225824267763211899062228807304500969486018343325179765891007850101129972597840,1291384027476411005733344880335831412814798196435281789778555934113117639238182084796876833872138421269066246655549383568381953840309258797167/455105228753233547663380844868202703656089226753199118485813584654408824113745274675851170091103362913886065197420390391915654000490916593344,3943676170261358794363162037910546492604237655543635199724305925926017709240086271987488791553597423005849897048343395688050926119648306028063/1417910064213979175401764271643977418905812275418116150989018569262990789199827765534011692831140551740935691824252374646236914694486605791536,1249184518925280522445646826348406545844848136394988578212055120608989283034418827299993486194595354106811261593219443899574150445259389331689/427934366076252275518685691084334059819752345652580852524932381194499332335590339825934293444207778768771810283058622566838840604346130407648,1352125621347864623540025491435696896495880345992368686208771580173324023135757622867126113955939373661599125152310639601869229206145850604461/319865360687306188073603688253169872463523261108380761636739072238480573672062083720696409310628455939462139820089368722774580735278822674964,188335558955895515126677879206644424150153699024145478021063415372834640588307276015398610225867160276912647178574325729610775917366288426451/76848567103310885021406541273413847384053758372078160212643869977525141822036701515685970951988299186064049722985993549167043955285613408979,827547888311265981636816712295958747466701559942877854688236990138218062127670485965410280860288356417822607956250166699887601915911355188061/328407327378328890783191242171867448754405263766523805974840855555932687138015944714918019529174280473234841723475587352468188664207559777392,2656579524963844101925060275400745244509979827896702849113664088863918781601307256906449326017487659923002662395520223003809452993026392060351/1106109034955455007426171043379710435694897648061028945559276399392861526960228044308508412497016786524020586713822920956388072650394847410312,638220596261508554798070490263251097950255104402493758165109422196600929925371526701882884583403541199916508486949377226051067235980244175605/332700808254229565322463814087425295249567955684006175111257548357538736270715035506762216004533346549548828077328700492175690978724392101408,1379552723343068319841672407974367661161938405804281494603522025538368122635347675035671370508371150412654824314029654961920487599011639089027/680603178368862689471234804819107362154287326162823998056120469916376332819937909836880712317442966369526430942380489228721866800295459992624,1490917768004722475527383088748931262849264165752224504813190136502549922390087001396045322869272617090157906799750177187524101225667849730073/433141429405418199564742880016301875575143363052790541704076057120342715339889292108596863483949632744345525816754051283530525647683952014970,40361247568966408144282899349015322296301304490188035933125692870480102123519366400194184733421181858533357568074118533016814317703852003381/17967018390371415024429802969652830909278696143966159311348102391266695937635187496822967289721311462852613160396670063596395909563711597650,915249858420147681098541555915966162791971731242623153465387906519219195293358416411915617083812517957161303215438347529742356284916723798769/177262859027715517338651343936285399930087827825222086396225985655790844324657267666428445300443807291166637797589807239901340335732368111112,418998887774104902124741658667181141097513577296984131716253805286977962427590640340663004167969931251008494852931646796242275155552812457939/482322543641033798116389577697576324819018521094499628874112704813312523923828269646159228664523491039747154754863505402533368200923549860190,654268550068613897267991048689979204336253652428183222713156775385733895864824238335088265969381340280391439980977450383472119159352217446065/704192086299075154584560089910592956910262556847137964880755133277131104546958634442808962499317888465694304238354024450104041159884514840834,10597410918798296424841554841023069504395572114170655254986172371411821889976729456426417354844242732986401246017786621864024384450652054915/12362860048573703417594349706563028992721771649448240796239520821454474869122873290443098319874146996648874087498618764259127231443066212122,62032221895833135785742632666297822759503365220739752679110907984041431851767622748040825331938620367080080634942032410484689892748231983981/61087837451692909233109186374433788238208181591518679599188764548535309699992297143230367050416089369981295950453796992832422980664182896472,216131071576230917450192688762149455280220144671414769763123812835677315501476186098814281435651008890030615382131448383577762084147099454009/403534997047919007297726567314193402191365055657937007077518763353623943851953571012349560126886177163167789330737500663325783819920651598738,51644060675660836541192957268128852697976956535098411527702797221434200492034252070819606456273345309827274013839893345226852836417223448129/77952030143110617340270329466511700953931956380658182370726287954878655876514083647768333962442334950746155561686344590274844970271060805556,86986659170251993385689459408816555613272187249410526961458259992154250996568486703365166399754663761444942550855346445923106134848734357113/164618885600566231133772396936648134186230746816776382860995007417885132184792456962241152726875887562460582153249310964900493063721357101216,2646946812423207550606269606257652399200544008964918949123750768295589919025437880328641529610549907060820436636224134083669941654416161643/4755264085828388569145837556262929972593948297289417441498120090589787798207604828408576836615556778987955057139068951677373040295217767802,115092895592861159299034427004510444509853940933215049797148529450120996021170599030262059111113318228371067011555651105463895336416893487427/174007694656998621519063751403330257293611478852931115192309404990009938400943218976688037280778235047680641089971033343455768445910784000528,187798687275102412717380784907248016443687096544785429012502492216451758384895304446385879662502637635392425748132847116908440256236058895659/316400086129440683078240471978227357613983690888403377372359963513415014352159526368103444475525277069377475041181105029063484491793757706076,1413650548897840741322310122648616836468105877426388252834634465493622577856114091762809212807883121689960694317251555105811338263876765888073/3253850605044814835588117650856820967191124429240139013519823820494019549557457356768080156999255813135311417103719473056408151274428887919222,10514173820899940841378562408538240738734382998983932442867975019502746852813341874546173390262987991809549513080433443000580660390202512405333/19037279065934150103678360341112905993964728868011289934873263394739225584287081772276896702643194800597295669174280408012562102588489264563386,2053056747792063962417755628470827417296013198116853705685886191350479290435610709919440356055846501844411031168141009318264805284984336793407/3714561924804839289850236980872827929711190264942817133113497672631177010809568865550416807166312161073727805998107978229798742585159472947102,7382932570735648369281993937481505320243595805254017260578495064795345043956956146471116729457197348958919576230720268784494318304639127103173/13132757191496141737240152287991903255264170800699874046480457778376176306627755187331207039860415205366629498648512225372456502948071643253018,397475139686895822055192223538101437211522783037585823892101428435971783160977541373123042233426243062151628744803867664737102046888022518051/810174505572520434203337956888446676061140706569972055662673463894462051357232467767931161886725902141841376801871002958044562744392164802707,38154549787402936970640767647558043866374702911845420709092297534100280782339951858078471390551984435546564328265441371712337949073573719067/76447389256567932224012677891112386271456049260374044167660955921600973854601418039400841081355394878669489549353017670680342566006792774252,228446849998462751183013752509234332013225459036314168432459302431895576761446331931744277464544119477517809717843816433998713966645516365092/679527017098489280201737731986164288515338335855843549190283786521469229731522081615410589349937382051047514053528474308100213933582772098437,69176245358323799429452594850611565760300467269975096328395194854399543243350521852147016864233912433856761328080829588321572234393505151916/114144357412211187285443901015793038465931210842909040624716602928346644638109532712678205973887393890853092582264064912820378993926810094831,6526690157103755303738876635493759935740906642850656668658084624709957066598666751230269253087447508648273601780189916176013910814996596454/87843369844664853638953538050053149377118266270705355719783228146613255263436661687158110828110489686804446069535201526378763871978540081415,369942930616602682940718236732408015550119477939654497364587492454536715388457855812802479619359768557511345200240536611945409172702634783737/540977702017294465504046759451912929718476735453339451555214929279922771851958781739006484925015723119474294581756515829579178866163730077162,232645741888796168018666949702314610880597060034039423350137626372340868183048638520616558822110378446543159297005305361729507488586797800905/307660810665201006818118851166014223809550947352546385921368158736781774374942307815904007314948919600724532908872894783564288772998801352298,15755828342287866912827436240197504719353959013989958512240760874162549864614599062160267210884545349599255179836529602875272638971558272867/16378980603789076690067352957500281889034002580409964538674299171172852407230643981052589605637383708190144879455938306669558285275986129610,1633260525051575530642003850354181029278738682362956971636171915106832003554412095692944097319268364306179072986275185537214066418452803983493/1509752864749177987944164185231941434014986555875585489870125064000918208895046544923900226469253025993350665779498357290614497654530171440138,254863751727897822805563494570154323672315008419814168086236642451640320943912263842460633326056484676247928558558793250132625849017927200089/206567253403451712673912365853554300426893795548855593167316336168163460171020900003457298743281296715849815541826698943732440210503567580594,6714666054846066415173914836550494898673071800446124782653517784660056892651430177287976985423364013136969263754219171792943453823853434534/6697067918861160156998708049979978521852127899730532969720862201056792346606396737549167592042068481550621172762051988314569784674308012743,1323121926345840425381084037068419472442968470305306515181067048519200850064102298758273986218427413992950882937174005099453716882364215480651/2040821549215897703332113617929476196617587253675376944407306879588938361101789670487110605684738058967699758093963101464377101013582464219916,316816109921572828868098555665024736186830985542044795337113236177377717909891153309539997161378573155887414816277653002687516897619103510443/958112232555936299490417663926442286233453225726745459079967127273506130166648181706653523784270516209845856396965433243138390041834763114072,694446429841394311705889289368189634579647819467811601379087042231203920549065689541742721650365946735597891333619462119024647698381640161515/1449719374397648838891756824135443662243515768572300534588025191091263096037544989020922635067828821761450254919335757980177671823554905030814,-30626617329821972206142927022175430470209725738783831645223211819036559947450199956918851346460463629008592971548419546373819137490216379303/155490699235133076412039793857338327660484212346441231949239732701800675204499293407677520624259746596459585941732500601831183145450709452282,211438949820562916752424669329040400945941934402932626558125093488102583623080562236433983426231941032904169558973307000186929740160354881999/557431660876731183965578052952943156981491461355171020807169472292757299245611505565014185020144169243434247423302167706004528616600298512718,39827653288913936540102652509856526974796987647204106526321310303423157073452683070312089203646003402030995251707330313567101535695780376369/20151164692508455809111709277517722325118060220925180549536729731576905915986646241252308951906028935141021878457603074818619602867705956452,594702723093290276740983144115479553765860244617402460101690248680520031117567886911399346260697079535828528337217833728409287154731590760893/505928834223012158803555510716450419351338920494526583854361571283618247700591791195290110417198871580355219111360832487817589584956323978524,120418844293439240168037794366661706460686359818895722587256881340711264376329140679744831715540109729572612216776797718752768831479867686359/6989924064804012442609086843527635457342243247391660443124777406042490812977779388714803280585076992433399259033029278371351220968140901683,4709397160020666930215934927553809696918274481482359468907544998324127967504758437692802177017294908242790591137272634857900962034614395689/178948181209216350792337596565717246038774846237635429322510429091201723213735061237672927747687883741942650160443973322410159665263742362,62042784544948716801162419080987923897906533288019069753062051713882450634071348201131167002588087353755166867171746353326488636284816867013/4287129850445047752008769936034366900635620668743670642872473371373788694710003113131149735290028942591287020820229698074203808778211566686,303046119640315347907666213387796322471068137294565240382766938190702167678149859864308543316695888656954457948576713949057158637756782053137/3600016756277740197578361561465632773026690389848911747200352230789927061474162172560260639450625341168691595349750906568143446674114814118,2179466232489016554271210550860097370270498804253779473020468265525171769513775695302830414109359939749305352499876860380230677510911502006439/599903055305261862108268841050984483996578368698820586909805992076152943654173524212462010769292297177339267054235156184318504801582524400592,1730895712195502746817594427704538519120311232248664350891626923507836340773192144505930898449061057696356348402668109610068305554197491610113/1374432855274045693498146302792034596198093389822787670623719427891273808263281998271933933387231967051559541130102139124256193968191117634726,36012590291539007244295072539399157955459432480690275058077740655944880741963235458846925080183605076220534045302040393348156309017050787681/24820634122495500359705641808236356211535307591319551187169361821462376614594248982492557802291949052471749050484609956308361201524628240170,29346492281448852777052671018068291520848263698955963331122173778059407792037753315953976099003486155397704132870122272674397607523340183101/36279494195027950282119277119379787319228759025767455578155949057159382830239324906467414974367319769737127187043232895549832632155953945488,465062121802078281994393012502150886031216008296136152858645338178181783423011541703591601081557578690499274447629055524176646180567607596551/630748560696641561942037143736217656682249937464408866124851773978619460081628461428943638520384189916133559052548149949909028258503772910958,96282435379049987492447053310310447547799767858780330789565050966995616101715000079416672000454953141851686383832784678490919643965919701467/27513467141112920295338522085483243837421648538885292816317384751480602102801032828803954261245090920181477750666738003411087477987593020894,493219202418680234979234513440482027311675081734246836382619977738959859475457974119618526132318412335163608778178555497701573701976101378315/119558112067218090423223467353672405976590223332922967780331715041612636221353121400099884805555018002368029121091856715919409864078470958541,313329465311162631519812649405329131543179137000091816588238730689099620295131192296679731356965102274887740371490738222048683061683051448689/10014619463367444242132704902469025601814862013477164984213499676197839189394462451051169437117633808428997050618116553360525797853800081495,48016547762449885908641459890979001927150406458098413754275344490577320053555886805836068702054258126061161932575272349113402574850176408761/7375244264874345095893275072287782893779088043455079008292474429363282065468777479619585070617397759002734912156979242520040094998324123520,271168552069374944671190800622409966860964128180186114172668430335348926512241652671045920649447555655942029569320411588202222867921280884703/48379774262352917221434238802928986994706508468903444247210214535339734963773423324997459044217942129093051638342434515216028052982584519130,542880829118939914005383849656193345440702842988211623228006153288270068218319252167693358231797920160199986936620346128514382051428687458333/164969049456871818608607834222143544328156989797141969468739766182368775916679593934447708169520271002645095539198509573919141883910197243072,976784465582420270570386445655272486108929285014149732731579288598789860395832525021215126638457317219363992528999476533669413652462637710153/305160053051598516412266564293370118211777700452067262543813252807165284623505962267791490097718914161571074327336856482953880669283700513026,6628905438339871221353247582325399368909152391438915330169088216450361455410441870081822373693182883025304768901659174676622338376082503/1832886782042384022866578818875906353249952806140285017199367714560384114616091498902925313927360127579246305316639113097550198288103706,93943214272024940452285275451585881249587078572780320340678062424120716788130816354314236827522876829219974064926281987959151407088403133127/33198527438838981491159707608995947848273049167129213805938392088042604591745660410319543064625656777649080049382034776612277982878289725370,304371189228513651209835901705548543467804399256395587991005174415672673685459809951996323250351222712550329178171973113198655805144641705287/169939315235661231186947429187188821596412165437747061227396342247221334398596186380273926541178859998612184598999772510974194240839595950506,442569307284784763195440542460763331101054823585171830908200411608117589773976424323338626524862927907831916664489654354351414077557222162997/535231834950513694786308581595678026540767120368670125693926495744179703025486344595636340435097992767283173208246603816301934410644268718460,17556852352611098110129782150768150587504303514435232253359292541629227993366317356224231379128091107373681371276201269382801330805967861793/32431580298935833017259342843404063640035810340725198273450211738108505437561677861399027051095025600854170241728098170874994451032727143918,475227389032710801408973769967984176692286532695515289451834523955067262096936063540184534434681043906137496137118778780463069631633650304103/803450199383677164717784840774181462945574246365141419747746722527224005750796541166043579754701547238225736930560072932324492545119198508598,112217967016505449949321056137190713734451391837675973769941506619276470194387972941156749021512918020512678431940617109957304257032029100417/229333388520058512087141251547854369919528825966178357168862160483179161075157761732035550956244253632355257079409911294817642779960831647904,552777288478746356321454940179781690974488729484373120253011260936166323757253453671387012115604438301673921010482312290289883997530950720359/239731611794668639154302333894038374264071383202580250102889173299592056563573684515588174373835503568211078947125625932441899730363846722560,262139699197768215068357296931970974841801686686310848959405453306946176894985931863334963906914126551306970615840088875176571643149294013215/121614271383208328549231866314320708948523690064144736607496661332044205206210537624758888545677453618587036137333522213883792994959075193968,269051105776187909252629189556118191869556448031056392662050194376204632326450924857838219614785221235019769970031304669266522329115360854909/144112229477459962526213158410514340392268013408530388794693897356591912714224923713104225602769615178084546303741531931426179650914209481536,569911761689648446401178569775444279795669260861336010579848750071209821983796241061493759895299302982619736497480180807683482515740888624853/612711101604828189820294231782678167407276922649697086179715091740418414468653895384166219743451847305546470827922935356977454500296268932128,165741560026504737028384419412802784701192432909547571611277105212381458492773087272600503154265293172199594054222633379760398068508545315645/124230676080838717546269992651998531072507269577220514953439094646340553206755918617318059801089485155215059891506070416174748549773538643264,214226178771987368531239678754874154114060894705847051370375669718361075919443907762399889498009265996426740287264440166528538252763729342869/209306291172879818997877927284060010084939566818379049239889546475715699769332456695393905467103530379085822427200561888463289104254422089728,237747987643497682310692684396402328260429066582931768453183309418205531803238135602633741375793175129838654499896942053582761658031904909939/125643556303779476401322366197170091973279209587708067684280031962252078596443722906960554510903174555942218753717632666405751792880176687296,2570024619021429764392805433606084167186124784458935773903793089472421979821835345475587874098998916726549190587550511136886489296667443350543/1514880715773936875435455588866719973936749340370982650708813532658430076439379903796271556952955729090668977148406413970792597720305071505344,31514889928719805467965438673439040926834266255996998619202143591943584172371728622957265232667808606795073306574962595587905388237970422909/12092488826127434309227372612238498277453679903159953089107274741946563461915885491887862098090409327566965459668290443612195069908023123022,1764643190923657023734061705736508085122342135748282772039576070718000512076910780849334436726442466499065483846602417319960668590962255472943/787927076731588981178056832859285664265605338956147220366970845216702963234785830199958743010508115115045976132444042772708651754826370726048,460993974353325035955199510024131062706113778184511289516182512610776546752445060816851313889243918719493432630250713401253341916380983372349/775248268814029609288523105816647776200615269656342851520748883240161207419055678467825689734663795535697585090228209626743667370951038382592,3081625871381895039810333658595753534141187802259251652068984159978939776213130649219331733745912961422063674255499177278226573892367033953771/5770245095207292189123831484786046457744162297377106381471287875508789429818138177197233088414076131387638435845306210712051787952791339741568,733713489462024165434143543422883005387543182688160958915895576119352050208035729880642772705508271556322384471647906931013523465548945140159/345785969444805197494640430653598205338775817998363070039082522232999772788901424674468878661889054602028154230099253384064628650496226983712,-79490117196586661829552114793092251901334625623321921788710752477566696462213474098281810027974594877182319626105093660467306814655574374373/121473684717542666084764436092215640771277353504515667776096118902838240355173874721308180010125673158611096571734872350585062644206640304959,247818347367408311424785013219568542530462323312721429860717674747800502312673075195279632005373881251988103708683912133780189603603689098471/865088390316282949157017421835251246761929060634898809210033052849180401278570534211646383211170216302378321966753968780421340738442916622528,-8479160971097533666781336456628938504509067154796208296343572918212721922804357934800948345414410446665692522660645753716542308866544807529/154154008948121767580782950089354807168683492549044728448661282017496956226341422343744855586924752428611277208805970458501196109723912741488,-22744761121466669811514855073400967611241112643251199639969840057498154691350592062211073465159093627332340298555957347475908371884891487927/137920690107714037293504778525879956941957969779526700137038879293604434679988156537662109094298019059584387611412949036393779555950895787721,-878478609703940499065240346689131305966358069802362770972947070691981098435024641250143459359165929870309093420638902209985311712354984856339/1978409485252384664914230354593153335379570649227466617970500577499007352015495301235509391088690637020731388087787095474086339983956674911808,-244628584929675555003360648268069771392987974724716840352112265556339890810389621943775136512512810094016025773386039737379961390076166370739/484833001705828107107526761930540942805965648390719452642229908507676294380893657102895335554208916602827255435968459373857468975314258116013,-2195086670189849738722720109439059916400031214368718257068571993306826813138694176718148694057439733396627920435679932821431632843539243370835/3338506963924372504564268650259404754005455973512315740948290573652475985720445204687951213980945668251032404853429488095524386203046431739689,-480298798268575948243494304214809833154773550747402334732430139648381995840884305034941564396341542330427751657268446180385019117522535140321/978940928128389370980838701239262805528078813578738140477056397131134790122888502034874084384525797943372999251385416553747190205922661762912,-986576963155994888702096736620165227976168944749012757864750642210061837424598342390699342673225478441785957959916220552172901477503203667315/1567637202318368480480959398698761385530457284356108641038131249951543143898887217347887526828838858130746328327339119257338367353102380251696,-1721049576575296636320825498808842494608486684017580402229185855948247935779724054897554645047101985775867419435650682715771459784335116330257/2841156432916669333581470757634597511050487006578226706304276041022903960584355611662642098477248687072059913793753560101203930626491521646144,-72229960406753474148929223248879537235012603425642645144909861830234623446781139170257815312717314462832764320644597177763049924259166368873/112284319621912947876735095527436976077983479087562327545942407756764719267231456985667979931308449601940845593289050215311012906473979810809,5762955933362585492953988257832942894622341168497152513724640827021853084027423532041570284404670636754360527948952552838123664655872717187471/27313688092301414276890358918498903080775510531266162530548193120984064316033015027408096804012153259433996920472951920232917009854618475429096,1880691934023630508905634097975526012004128993011797810433651247497581384426901929259002383517945399362825222087612371935381995917501367017516/3117090431297659443344492179668119078946390809703048946372803772598208679538188312603018139028931447755729911826841258932493069102089181672669,951962379368556367830846169488879655682135150105550985413292036326258970831042910003803488447164707455842141740915360488754720627301130238676/1666437306514577061133406015787971842772508039820786214476069401915494768460300522870119654780446658030954140446261064005143560302435467869383,-1711559400798096783243589155759422361845248803163620840560676878780488069911860548071877646407010758060856298321376277183042549110538017986025/4442714133385665600202149235037557807378964206731366323005270576260051251075222951918697898027932134799426339181844540348861162459593453300672,-197337303331007054811717475670841633219249687883800685657534978189185351046171543324843115334188211099272215345645856354621761204935529908587/629830972509951837364737488737358471395337097522263850642927462820376562932602824082235175840942628813130099116802945529373105370415480642086,-820741857761834602570356908933435325441952403832993776820960235713945468596539675273841424362150249803617089521692657701783527993651033532505/3224431570258326156512323900496524512127364862929952747579686433843926919325580735873303115027857352392089562082455436076565883899298349825472,9731527523743424930157141402619028470690385804811695392050323001693559448615727873638287674041146535878340275219408318281519310303541310780467/11011292869565019735424267362289143122466415668291100702584041791232893614744404789693269195657043587794208807786196169272751603141377652897984,9775252288141084411254800263212279892122052829717359635212528589262092837747738696181038924365090513165347926915660667581226940999629131684735/6212680213084468546549960321563410045655161752799040966565607964669960988649334669478620055979983835265617350500524661748351900687076789751424,2087989147628027153029545317496949374252542444980131503296067799579431326309247924094126914616582707682329123011347580824222393207361793166085/1082056842795620983242852492021957352878794327749293444014751788927594028469028940637390330986621562185839164931396983669980347451104902787264,191743062589984653082296581705310656675281618308701585582621034534803891385864592210503516860822082157300296101712377242808827928142894562413/468114082708097701858697427472076018627445515106376407576533665088908761674910692561603950195421828149149363883673150351041361221595187632456,7862979422791344519359704050897850116304883711578174503849820301960890305296824771838620870544871091876437343567415453449650731510729286763561/11133955522385317530672691854189752322989648157618697368382910548198996385523713846018871498669726217556513493458858119639146173054590314878432,2334860989205718737326280088306575411172067596385239141547002514775863777866226162180804341007481957474852656042262016867107345078577055723119/2791255000016380718460480604398134219588002886407525368703354476135836964424028685167686971778565702033171152053903004444875900665434495608032,477672978050021652455868714173298656749032140543607681700780868238220357172915798679613368066667358944804414681004680669514643952538840150383/273286970368435099956394450544235725799875784728991029230735519989679986248065630929807342401965698194924334665352557936520725052283424041472,190365703104960440739584787577260995066186869622374939826444932551275739566855174936745416364935848893873062244894939068457655904464991378521/90369617377503427823900295227324076274211754043331144869693159475373408113152129910443229717510817203441206618269674525940648771787260324828,1548945646352621083460110428502945281183221314223304727699905644646951612056669445285115495635106847486827735663804546652832346933502701619935/425165388238850784859811012308063092893212677573646305801993592668999938954073107679944408231873375440190158083598224563724349934955354784704,6164380615421576254995771655499207581446785552708384972077638984200419528535057794411150345240955097994979094530778290511462196744694092401215/664056728593962031899721134777335028791332297329520640657127571767920095668447592843014250430432658954476898092755596299364921434372899439552,922546374526588687911619140248280514617066231367484286539409038041770012899906842856028810168156905468392137902917853712692909286585540183341/162368637207491922848338103040300772964200186074199515934312050174780325992973473845655479593666730634717934265999250212418587981187407103728,46477567117477833043174414847766840642728813568280636306004916335288327898905103784955224211021968218244595212242703143451988996830014158499/14136803777390022981807282836756290771751191336042982151679132175800511133425278567464863099567541306770586108067946995252674679023333426260,475402260178427340702678670473117205508660528669805876078204142433790639622497462927119714443392935323961875502538064677070246336839355358669/111582749175406718377707388548635509322008524990086701378508690324257682171478146847190878526568639231917667035369847575321522388966484474848,145275722863639742935586029888139864211020197336727523853464202178760839209447257456692278324494857388013381119529881781043298486162937425299/75564416433498456857198394495936376552779722563576632536936206114879457149732059251930820776020180992870228359415741142620389564272079880456,2620622490402413192781129917158291408116370958903035590626829671014736997033535077436444724077546584402074935526194701481095250019052240078401/1428567843867328987854451579627799667160618541567215134365523981175765820137188981874925446753422428191517854408374592129258272031572614707328,535791989661619481576452614052640041446267605930573682368292801041727826213802962497152481496905599615814918220810324602439501642619521244021/169444323037669018990639122408824754364324095653598482842665940032473312797051354933862190864122705652366626399396690364853479492011776044288,4260037040505207235985403449478550941070526167993689850635083121191972344333053801862266113585035585734528791944643527856523863518455089217017/4149880114553908967499370590717558347761965964908885639820267830586998443046934519177802134522240725674678895430550463923124375205910855485760,665870866344870209249410491415085017898014995365380565528969162824280747274331438998098832694105628902921816713281829338887642578362532176033/811187716903703213681502559004412959818227436535919676829410546307442059673566098067645483057131304836661304623081167597482653019251016012820,2753447826984204746603812813802935769324073330616603972727341496610107642512076565769794013372628272067559592301455105702147411088585662486111/8916347029966908257527389056418779599179696785488268078516215500473641903450499344446196872710995072065869023546277371193356109489746271395040,-500935237197942278447091489345399936868051014019891392142624267887814109377261890119650994554724055333492455857305571457728449038774822785596/1282545483901267319812332825722315953274428714844934304463603381501761890625568085067111841947752632347893947576469001520697150144811767059009,-162712658359349406488931518329136798227798387415206186293941507985555075237008288230820530743158423805424886544812966020141313086758443542117/245963941165829118517933509778698473561796015774773503290944804543994570777441054864521794276510918057494415292360086268064301409088460350026,-1201399625690252139660617923551488417835110990749004528327865740932801458743296602824159304866823937104590101812485044068219704073368846552143/1826364055884736338146401612955306218886872031187327515633740175700441809955380765398647722105041472702401267408919496305659073925178955420443,-27695108272484986577789577223987177311174585716519753213691766453048262896265156157673599768062856696961925908697551893414917516429940504210172/41936555493231021587660059773324793924812953686181246305031125564645104597282204396914110192548215784154594474352005229491097454520217212402203,-5640630496270875459540293100388970851156204516357769484693731860592212510122329978561776432326901275194855271437461474204573235019136609909238/11456724038086870841596326060542792128626347431619399736898388753356445527998959731428894900946272375376652026178366544705455297146628322146081,-40686778934205091970620577270982032628413653514993259708487412777459755427603861116991662418849939143363323782100629241484970136330143192906684/70719502732441701473958505977458179917577354061939696675401501782211583252203798181962946853949710353801688269163754740230540882829383561953899,-13308092261793700548236968512909996808731579866654708624142576705243369139173986958097527341223058883212948857644858437279235629632214612217932/20095086734173004841254419606812558943590360071764463614264710823346524429476628772198404699112422469407641553981023777645871213982731671124911,-605396520843136688032135031182884778288393474778650765556666982196459768668897194064687906958068478662918951696298258154592746680395307896925/1028492991441426517234175409378370397742555731439524871993659904923749880376463968017564381585327829304901517396363630954623438480201776238389,-5914128720307071500679795624871100266206885943400221467120089969390539941992570743709096900896881720764420536552187120972719863971667385866364/8927341892662102484997891598953326502268077629038177958530513887560842033217586023663352144590583073862800821611441996373162182634425652966717,-16104265982362957118782767928197685296767277592658431251373898098676660169191721690950270480684715713751676114354395172501798101283276271462241/25349724460723831486698965235851340665572913528560702467038595457631578966174633497955340494813516592130226142270025719187917175288103788094873,-2207995052475616502817386911065462928253967946828224210820418204415210240989853768860111987755843839776493349385928704407351738784405137596588/3911833647786773472124295914582302775650973607266751486579707636655504208049037762646365598061149850989713210571828307096686911981022837868207,2731671335645193498048504582599156043617076635801375089819364320906122222719431665597745472996523859764806503284020919885020309178982957854119/2045552862447169345705738308860797754080450378443893425282167876292880543930136276489710925522950860256583661615424968099907486555366697656000,127841162878540212409584034989875441014614634368382241706032009537886681406526003080268480614259274796221540192604602495394236440118844130335/346491110783095080964997413961057319623108991382241569460137877616951191716875930010186291161730569080130197475875228083265875736517569958468,764144834167033314973732589095169932430783494615035331277946079303739324906277925225485479859435696754626610140559165232100227811156389985/5666800958475340542020018855845243482093308967718236817364464153358527545655918600714551884596074085075348229527515379370136425618249919373,381415308340785493546305812878582181506495973167237320654986247359218538303778796448913751484910192633705999809208177228950023412572492797/5676158039020845185449609302925971239406463214076334682708686998032746485111713855170219968154261534818743150174655740273946527487282622445,36306636556451700655676859608510447408708267486235593098884003899083551374330210899070607860773267181108600695775455283531856746804609799459/521038016961988161790729698738736253036185274643266984742355768076876665909131110967476911805612724946135977625624112113423902530292507408742,695732513930372180600671859746039775008545874939042539414429418728720262235229219112735561034072184590076557922068510756863174826957703595367/874590743540528423292163843459098970124729583519251162001583139472130746494496769510337963883229524800609848348584849246685270428239919795220,826054116017798099563600938812271129333442060829119821820897048265400720815995921740157204065173784036555128586787551476079682339497606240149/2734917477045947850330735394390618068658030141458618108954395387901054711519108124336537928491252274756301715101864311423959420477571727479900,457844059459722866013727750247996510607010218131945207261905943700648963940618805191433378254247326052987450736918397024973718482470369279235/965730339720569046499052427232680452373736142156357577356779613692301810020162678547342705036027649500438435132708628638607725560078473496432,7997682805966626625244823490750846576751088869609254928396264204221018672475580653124266422484412703411641938350301704132027115517317708583/101192112183440091379003425055352737621951740806451745898808672442436110229937682202371029578030718905156112119792751242211961517044965965254,-4146530012965849531182963864034687051026214564522461187533557662337372497181987993520797222775928010341947990589779093069783601252628738754341/20247421150861434373277272903285261156885426417521736642248712502691305168714109232196889365964179888749760127937877888650295565249462950441076,-2793656432084427289865410057822162176028464847954786617969707120793586078840616416010541870283622301195576543933929755965531071516696804773822/9696028729339502830195211211770168568383179169468828987884923965717036013898372830632381939624744624300482400640085487544241630765724650756929,-18131625696852019996163791759586552536106896664139064973500898417114049631191872019515652903971930004677747365306754545267420617737561955265/104845247068483091382423113517529477423087563110450274156206423109937816608434707512632373601208777192463390357067153415054731918510250339424,55622682306449702755752232348939805947044043938811548667306600777574004307516596088939527422908943330800243607781175608333098420361360209327/17229003446448758035802294959038725280073977442549866187973774609521412915180493168445839341146614512734359806649176210514458083123814532480,327475799941478644245232661412392468441990582082545311775834310200949960026622712048056851644130307938359758024631187362782135617693696090/216949802112745165703323523308367504094700389297654750991938788589466634308820376880103449425794510658102175779167031715161787408830005471,25775528771853240335610875710557707453689648755833694283145438136005734986153060560778591905982881580274951933383272979939629484941936905838/15065265059191852528881041928145676069026326882489928792512816900713657164285353791354770313206870146074710647958008602759235823704025407261,270564913440408163922112960100202863516243610998151779110700567913673021430136150683937221197509826016636630935957209896528355141020043269167/161701616017482091285258395968103127580039270346019837526149760443900989436506472110183930598787681226557007424221090525869748931041532418734,17552981767875626188551247374022522217862256748528341326001700262281530015265337644745979398200322267111279289092197349081216848517010959343/11142700595254619867064736893220608653917553592563294821825512062834522602783488118518043487195293275244354067603335034485188924514472039638,19447557631499842105793565278043763823899771586079223582536439692902147473087400556332807443136169478161294055948245138857550208576565527058/37101380301698201107783247887452358320100450518988279766214171477599750590732453710099447174067601562853326263490167003364793991829335714517,45841760785804204548541131064484600232400807933494906712253730852462549835334080371016700712875660829683349801539299146804712717462987868390/35334138673490456305038161718578584797044161570410019386848688183750792931784198664001795823761968421701554912194072300543370238634044611711,68939804760462934664810304076479378274380330759485109721936605767066623844076258733645211187678888850749829005085920205488465670487098829288/28795228749450235814481116722854359726107856507703168089188479778913102145288618754504211505184332785619649558906613701126618101390268597257,532780442818611142168644666072884079917799418692101623831780524168844335008661178658109307413195494299248473774034589222713332616289162747327/168524033556676418314226174038861007335810325508727902168814975708971285616858567596715574236899492911830561202881644674145358942228975039200,166668990459239719490553122674136061243589826310790226101915186546472973854298040055461228535738964467490227195088368208135873415078166512269/69327487263826812163907754051574436348489121669697362718688425519926689891327291249350409520153132262486778768796452484474096676499428185044,89645001781174959655775502131454209534965221695863331037050752645310762025199785865505960824468532369283563211673882215208236405235721734037/91444219710059502619148224952269766945165666357737252183263921749422303401166569874451881067606949999235987955096626471444928524681158364060,19302772534540810801772163128588478714961115230125130146212846453702408039998712360910850671995220828342002376483547396605169740387134343017/27610174870439927295895479908254957160638638487894767431193878413350873476237312761508843051324024514429210607384469677474930379059223160342,-198314114452570922303485854170217962252434037981215220838746471047578511299105203846940185932094075159920067380783742792324541218504076247024933/1104229362494100529989309347276093378504551769497618533079028236659224449203149566149188939464763394061500081531713615843419697560918883604609452,-67539815202866375943276783231862001751225414717827151391656897003893320777609947636273143947214875418488954293599881472218677986388208525615356/369400886739182592963174468667704952246691717551232998548613543863686669655010817087851623561259085488758694389756505872133485116677428045229699,-145739226820093658222031826497962262007891121196909763039180163236177768036142556572510573245910257739373454734556053352928974594595064269952093/1080071079976524086743662079081138564264016302574066106940817183116890000404829222730553074203783830442715099226916228983599176120917036103670118,-5189715059189499096767706682748518118657961317690890915744755175877063442057697824542929733386813083932517565804619448751027435275081800288286/25421983853486362341614542198445159260897992125014256887204001768420300241282949882876659670221879526803877585188067171244447257232292738628415,-11812436304757421083382544553871278491771024175754698059131440864839998020576587007070849651978597790331902105460623672665252055911514374853093/46101976656681329348430758694040680063895770178331721597678618960444371150642034209015728156986735170063930598163806697916927463066714846606614,395408205069371944828610916036467333570609081982371784065320116012899908203326023937173859228467163038404855984658829496772157684840909849203/3879575826307628938507391440181104989512686169882589284190447436822050825001945896350125599482828120095857528585155802743830469511363099971754,-10340315647991197462223967776137492224552549995013495236129894158102717811757282283703116327273500177861409184724289279647598814599577415740510/55663630058132989247295267264820433120948839264692821502752073101324916038794790299918210947459074725398017392759272908037058666448779183740557,427259106566173744225451416927543552007692511918957977846224395180074397641555570428215540993381799965283464088577928781175603609924155209751/1045569309411622854093843325665402059025381974678113490688165628685595337708733780953348801346683291437453121786394621024427919454988774350572,24206664605706422073270290966274329806235453703037227467703642524696406741696065689641808158701876211331431817664530853348938105543807079048/138380524440244307379603372353814740860569775250384276004483479917492966532803457876125199113879186169323241403116500766121707081622751914015,452309829117579915960387304658897993900482986093281377078159172249608839939290714861638163480893210894371531073327486176731359526814680413877/3311036490104173840579661179740228477061320836643735189629813919464368494361128148047010106610259977290679440819346054813624256607602640112935,-747542063282369363263934847297510754036939483595145293139991129314856646801219418147998593816494094239036556276267396675619375189578522343132/2216696167256624245825556257857231227237112512101448081709512088219650302578653901798345157600323323773187044595014466986725706924652764899019,-11684640478315242866832424467694248227719855274615900940114577026030813618545364613356039524641167389791337934152014171162685711687796784006916/32827946430409619642742568322824593210396836766548469576422289755869335004526562827270888695166082274661816782244769001370916902668603980433549,-60305283012769117751985605204691270215616736350200047983350999481193443875949623167863693986417027621545160856975318283073501201742920598129508/486109212485537145597996055257184326274119300454187627207254884361355698786667681259402882846097348838905168213495160912814051462740575392899377,-6866266507732933508083563829538683324480965161452051370269306906984514680548839493425180776912080133458880421742349481803904993130630235914256/110453015182503606593591151776099014923230260169521308753002726359044809966488698274212318262203740435306720717216317830706669233332055627650975,5663900710110484426707133057462733996048720814690407632997255807840036595867853886920524047730125316788538797895920259399497306516250276002440/61358276997799936117480551236839267161916360859531067692922896021559485982798916003397575070580738798400378934150845743167504662368306861645981,-4922512966434824788117525534682558302027681055961442410535192549710757116936492353292828001866789255766507244576225685260253218141378687036260/33064138886812227009778418007316452473733419870652712836072993989821880036979667373828101094043019739307003345588382982676653384013631474596163,-5051960786896192802653428680977051442057981179267230673121412180031003161355057286507244134390425779656803045296843871382117643206986143649892/140224243592558599374184484455036706638993352129567953157380146214820343722947149352855973164621417022552540271133730767272164047978352603612149,131060995416762030846070110000220127603136601706406531951419774188274753359671210327281890399432688135290468951931871037972361941470451128911/1423690985952652667136198889186087437585886504533384772149067156299286630520537816528759999102969955830860931183132177593342049115576514532687,-52236607180805416644996955887884248885590243071905571930884770455705058533303301985589464285031511865936344296070683915361698543898020350660/267803039602623364439620668865054390831919467491042317830470349059574050384313454310985214703546437990911221272601458334482805773285826039341,3339351399013956881507073584941489002379103579775897674198765538402906695345477009516150986936875748817894825892606507151191053764988340824/14784421825941598866222628121877879591076589128293577363771132337410931107915584100531971261065020444468545233880179522306471918880131066141,56676038250060744971482568861425683591899597408575795466732818695660982259341227748672295223754569958525357029496091327865362005327805647/83721468626564568855881311071645800997561586182710388378320583129044297599943916518329744901537242367684208562382369480497745419030619205233,1518790132225766737010562751372503846195626295282532880588184044183615158525580257982326323754429964305852916543299069733591368164681454393/10902494996130709695881987358751243295355669524567112517739932811366396792485604689386679054277870756406948288575225267888765123363682527108,87497765503266583175582171089007812927777135233912958861634793371037505372786011961204639216322067198089017532102634818441696252335198809947/163769100895805393847755695641043880462131111214987674870152476731018480872324203475472144642171897424081382029539749682143783499045943472122,613338725517355869520054094707384958465894091388522949032238430367088676710912546215274893216322143581685537369798138330828688321639224707/1088226508238799904183165029423413069407888765314078988499104064452615876142436475266167234606234193293288302402199055429511288453278798290,2409327872296317718436811992233918435543172233151196834449207842084956820607083371537142887897087087221198679757447426855528465337962889273/5789737503445562387120548394814446232940194014542074087978613722575104615780936889135799661814007283125693201823624174012799801029900569987},{-826427346634531578677771698955140687411984403696268063170758940539980197183382551131693180914950020550609702285817214135308722506393622946565/1524346034436250989118886006121912260067921958543890873160570976639161092379342911130866226203533504137672788951806741048525723976540803124224,3655921415878529061189820473610851748768371276310759425114379382999005796499988349528430220443249323986269312694602198958947147203785841309/105138383610066406394037564819789782698267698228558277460373199361536560539253841364621260399723890723670801337455087049691496073016212119424,-90214503009636510166510389485349136304217563318880365189518557632979200630412440170813559523761459492335646411285065624168669983688400538365/1982745332743761962260561620132432224969313637564658050382645947242320585985623493122972687987249587015405388536429986060794455345019153374528,-28249831127247768594945451939195662991314540198970990435983022198456381881165756495783862940379522253501553526880884702887202755703228842553415/10747617220791333432062195768301779497432379198684069662469826308276410631783129132932882297735866932714169490191652650091825465756314317519576,-2404551562150861892333410136253137625829610137047122503170108190296736357243789114094273163790733383566344324991072500759028684674237900359041/912592740807841046770479701173607200452682062168727027117823181494745076672937383437006910638187425188838907402323132907586135995031465044576,-11836459539928840095406659712616161002700670504040213285930356599172169738798177021415337970091673107771352272905929778268476299461207578064857/3994407428457593313936247806405282802872147591847034013564789444003077276605455220206295352691644780515938354803562460421346997800960786906296,-769721445667337110952499473537899936827348918338722155591010207045296892933754491842786115010894669535862284952423031308229690964608150343519/259975541247910345109147577424966195974820638514887133526443240447304819820315261180348074692484589893772461398655145236959166596719721802984,-11113757298700986195027199384120355694890122006257127234033734284860466260100066000743870853951827840713158002364272713968682988637643171977660/4234907939976858267164364737662844486843021264301493258955111470464378387915597916573659956211106275123310303759580692924292703314892400782769,-29180015638634034506554488542890736815583273856580377965252713743426827033047450084846292943549161439027438077957241765137267711456586235925/3419533381597502843410892881810832309945486363921873115524530009011595848249529934245778696303840031769572365731698339338554670152373173815111,162617058242006650737756830632924672942080952042086551093477387705342906914044323914152599751783149158252908343538456185308899472185782329787/2513545110879496996496863122233059090903665683719135599508640645059041602072277705969278769692784003322393608197270870985405546022174001453846,640852712021457616541880367464927817414678946770403488696427528706953962283372292473682421694857507155099051872052801853421295717711677786993/3312159549074084864243493697045270211670624294275031143449141348152602156795750521122724228639924683246678100748896023322319389457715795159884,-16052362061395274521795407515022053212344355017063314702417180518744443290951695421322254199317922788503125130558058493746299872734700901257620/20649136422329455902313527703085648992423188004617887960841752818690091768793433115337460036190887431741680825910446398968709689303567955057307,1462641037809552405271036806536264580725906319775176989754372680106409060866588770863027346590598472349351145386119834285934956671310704153427/11746238880190897641715684266793055021668746214305721839756198453158160920352889224340989471969801944768258326652413632373948193063789469086158,8050816796613329175399431609099176605562474926291088100973351270809469591986811915264446511276253072953820588295857342467360726840410747434463/35402256643934448420903002686651887564676237005029244866880392962276686624596543367408745688059792685422989120925332752056452490384957345997132,2232529579151671627786772952130645293405982888154468333645083873361896408846665661342952708204603406831720163471948391839523664215431195432363/15325801757154529826579568671603806170896218340017228451710247593508469113149430963266325200155377544690084231818006854440584784411506350360788,-4224496936262532865244604972696355275237714833411088535030584205210519439428081171498853875258536002374366688163751727185363734965692749969085/43089073736704220082931650345405992201185635782483128544126036029837476591568572985611287215268411660794876234981653983763818032859640935480211,7090476102475596044923199777453734650227273110905454955248956783783129824251689181748474750418317630919232278010483668546799795838811475231395/79468318232080927320134389624234571603096340178133935316391716579243292211515016914752881768082118562037134393744165181936714624777213566286534,-745234022449252382730360151309574690659241425052544839136866679712236146167604167992647245391273947946666191533470323745249446607763535119117862/7098429957929935535358029798253342714162733953979245353015671395481333042994726090236587661250901769358367197374200226029833931544488035316964139,-74626519465236309327569020299246991593607069277825031859817779356145234615807362529229042295010656199663724760895643844996189818429980741637314/2337967303944368034369893084378245233965562714175095123775989274977882342371438357772173566935866582541106559173329270649617032501967081606193681,-50211023552077160209646902616253542975994612239965103576266950289678186618039559104999911994050409624442674118720817834002811296440861356503646/67177408723182197075556093914796832403438788289127882908018073139251770702487454557320517708074686068928075637035186838889487895247167458593623,-2991641084573657153356578759984106641826832040535788876755699101227808677971677853566992514865527175687127321153172886022891152774328200274454318/2499399215304518112254614970881207317953314405217128226944035950888198940165163038636229087888784911709082265777771803607027237643983323966583231,590327279797421757919015883943772758724430340273893772768441320264185211132179269945758176517631112391688678448745544799774577234413189339843/4761060865265501335065287050803119840829061826982269017049233128503316140949058611549590986241134761844834658221089230574492226710041725662290,2192537305543592970363479413685334609589587783362658916724350004799180155055860167757224863580240330167683522904513112780219115754436740591887/16739359423535111428386515208501875716454655173921131804029636844612191284634899820493658011201882315765993229823528000624811973045452676866987,1530854427213567859036802516384594806795237903241348418799804858967014605021465092383047462728906023350195475973867530369926942749379491880802/17608948054502074545816225129462752751890984715980038856909492677276884697024405877977121179698639632847151748627931305671610667717094296154565,14527515202854840559501526712475442468253141817878404756454346497434425475966327887210857863965927746326909974494696175537870676127543386783/174718818235656260588592955968730595070245043064779629181017126699182769152854582553372962942130479083955243205358085825195730996615127722880,-1471528689261178330453802276179345420971053159359502929975354810443869789241982744477701135458505189301677329028492595457755483104094657490052/643927176330282282906853147365938823373720613249482198008310418664334553515570133928310068318856867020226917260586525738252909199601817810745,-18613314914653759056794701336366773817893257242174268188403818730830080526634819464705255329744994404400088982701185347183757253435861403630132/8157216135986461000023542974093573373916660861882648584408071359725913906438401729374671631354886420956905510290604658648590322805831167974407,-93625095079739180166901764067490112301069540901513491254926558438489541386342158125112998551821994733635223912724143914049916461272381045388/40352781761721809238314031256343779203930674099427606229942376291815441498637770172142489531525565211954478885851090904820982948279978882827,26014380674017040984637542745483506487403634839859467408705082448073268012294890206044609172874065423608291030615707953673552752972334600048056/86901753072450830311054495428188205085832958936649256920336576796470092876151610106387987635159846179761349230310998202256986917143395324206355,14896481271770698353144754851748170863154424623589094432428837269248962029070437901987824382509133622817534390102519147412765410458665871809936/22998100842242539518732123755997033357155001955346942341090888405815161819317932304981115010447454412333370147710678013622106328300674869932649,811250237057561963672823041082208137559005768964756009070618969910947406916915442546307694124785651815773940888259253488002487459865597491384/1127576314808945809213914257310512280899095518277606149397851676150692854303368438264105250458763140374978088432921071205446223519729068203283,34287921225227339737615207582122780941893093287687944372727444651120675605477188994177043289970184078177942154221340404427047585245428690772934/68573862228088365515856191761976748357806929243760512640892711782083558336926689642791934655546521924329942582504352224029525523576402989019391,1170699973878234651066127156645220587229395098948757289077627333936907353070211141660444038573009903989310635394654970532551771915812818524022/1391706759217474205449838174980618915228496271009918260970221424140026668172913211013513526094465072206761834176503237914267832961529458505423,2019141115184883822427213391568638260380245285233339566780387383502507757794868294466402147562511000388478334026249279920913891381921593086341/5310283170207594718722506139652757090791079795184190829291816609502712107716342838361601880984666675088722120530816480054913492068941929453634,18163652334854629285066788096919976143567638116109488007731742192481640867532284716458402027057289360296719749311394524299507913310527405612582/34749524678912569357390646332299144865988943222836389924650436037082321949770710289945430521604897339845431110088318241187401290358118985962193,3394325569477342413278541267552414104455379926253602156365225497967493352035365120494618567126654892493393679180111342740424021698224699452649/26756513451039282506789487755747427156627175785570952208056952359991586672787497026578511759818928937820712234589660338179076770897426772193578,2049273944596401371158386118982216131346588377270278046792802443955814139783232986689415597830675162636402190981521802321778447135048571231948/13210908703668021049951195825704129343701416874708700910913876846604878996672561109405291951622364787768181929282167065866916832290483763821993,3011064563863187575044132474281647684015408955424761473917597792629586730491251145689494118870718531246783456764690116327203450927638438316366/9744272897416758221330912700566540781349773952041359002136019873925102042837808045968988454883944986025393019624237690281470949220383760388225,3103111761461285477824273741940206344622202028912828152272178476910079915131273753162315414283787292916541496844900003849029208580039881591522/14901340519864038396830632002014979946631875441501813251452059484603319915456342363547215113165114544377061258965740373067452084561323241305451,414718691545504424804152187934952602252121114160485667927751512658584708105072281596933420128762434108737234460982671842030145085507910390648/397294985291123729719228218875775266657145060817681956552073759710882040781010650668026150592680728708919474050048660709668400415029831171451,13336192512296086119898271790345943277668104360034092747922659361183291774487752845247681634459106074141532068682399294605382787835623696910274/10997772797876053949683740460893523069192715786575024625454351868769308955120389858645278225509377155614190086486339483712987463650540965847131,7627913363326542699929071877834080771348938499123931223028145060438266776882370967097558852660321260261878477902613679126512235042143583794/8338409692585503636193718253110364030945055079085527024225133393449380480727154312338535605372559980129290960400001264499349638154687135983,18432420994593042040278040960292363013017321533082800994259685122632467000474331929946730630030671033271533371458618615171954229696529446842408/14723167889735304246783077221762656018578299214600549190168697599617922170656849418519203071826007544149219123614179112643940412627183061656163,111168971535567988088023888468238455129995037622737674872757488772863651304700713601943933270825900701088138772040551882259086919953108277724/77080532244289159810332801972743665796583274714949188639692343845668527909054605287669906982860399388762952760871185625556631128779848081211,6664722321840375986067557430863193318842943159402295838125573012770080319967420712517630723559313657893862258642396881829497976626290167651286/8390568232172214491324910277022361716852931201000213148890613245427998672569112710860475736010430126319934474081152203445058004959437131618221,3251947844963051880716644600727598453077857352966983537828141456214262779324827082973864217502048772428385098359554857020304068482910636819476/3105289391536659613864272269782135008746456586495606627045543794281504094471503542456426400307353299378943749191490328902977793149935212793909,1375250163628618546138226054691439315597202899936051687980225855316145190143740914739327780137877295045904781405650632311189047229725435623585/1308534686237526889571247312378217077795128000463643225539442628096318799294387720644278251076838803413382237324941840966587654270624529873398,10781505120938109752860876962278224379785923655736373319741703689342155999051834962537038734452294820226891321285365033658193082717070019783506/20312018986342011153686586678156396988762563695631062345342015274602188172160307673520494470208476710722748650997031089938668384486512381449235,158049759650937296290782187025623112287495986431137362693354835528172023861208039999555931573353514023385608363537254665755547732482718582729/96209567861029802935431596978563030747848384963404130790885408052674882341404992280505614291880437370575927289140372027453190366243724573558,91524731967452540264639568843467484378460002003320388702361561712038755502122285706234322212688661268080315002861992299432787381688797034982/469722771330711005390601758415370164792799356894070022371433078529281629779685335169168513829533187448326211804784077681972570193328519799431,8207956477869383652531174017702278566607231451541751591106338181447902360972872408894272145599373519674647621928840591532998611809196299666162/9623315661813732661132399391473993509216556191527634142151213375194005945068216848989368860537978489146797926911089382551280721344413063522621,19939054968206859465709137312738950190585607782861234936141825956576977258508690554575584903543459622003044336228030055703886500773553542154386/48632454378820144643890882398288938500833950004194969131498880071363467345374567560528135899204460163300436634135302882391962634136706839842237,-180594827072419658803655373683454409178866614881736920430984013982030080567376847130276863649020626585868372021058658491986085770332512230322286/1374087140217073429962153320380218715261806701036593809955441246266588439519795451188664257439431235809565847498754080051199301055246998492073039,-66196631979671142460171480418196042923490072143347307917739092290298874984770700436382761618451059443210796992192590318965406761269227020663458/49396106479013760619872160861680012595121155495809942514885494495218658169910517504420065577112245760828584940892000761152204805950362273848721,-5176615032591252738283775262667542072884434720957485904960669827837035438931280599804389022437325117785470347975363996177842986124042627335800542/4029124768502246430870903410738518009840517816972986026489837744518631453953369234010680090977789047823674011868727926043429956342659090972824263,-209211614068120044040104382290355652645064099999863078225911037543031226559760385840328347165409855182646381384962978472785925434037614389172858/488665203331399114309628242747368596853407454392953685940549782437539239010526982139139662173242973512745519248380931476790036634391606555534317,10479609486984992441735692718457906012884428528623603611288407664317810206294895982892059261602730589994411419799350859335340637422499540222978/96258971789799378706620455211789574844972465382147614085560820893777389445253724424826158621963504182464200215582970955089748956578881460408463,-118493062244242861102422278765264266063462411660614161699869783441593991722609632817591128996627953052970783364054352112765762335956640469003118/124784094116346737494843008466854899410448298848218839384307882569136535729159560232446898927977553433355732082367587331596215626729199542475751,460668450743351488586602873521004930343754216104145455486492468221911356907736213950020976609965529880178184000539480661375285969421732976733226/1772674914456007872442942993634922073473183433161666321466987835141425243016234930235517404542983477390629897211322107965996266327994610906040587,125845380154610537311285712321248250470090004410427287902466198603003718604106903348510355652207367969433399612493291948234095312764510758337634/454551393339753943081798492455930258191249739580623780952527586143861875547032222399752981188320122199857966630369453879156723695730367500947313,-1033878537419430307261657976207664398613279182379788061207515698427193446867411294385404014369986076196072689218393304839890465902843939669042042/963417593696416610485504379835575862619684248699765591147058562697478497328853260222156835465485188082396755940978972728159448789510977892006253,116411330478169623241951998615535049124329212807029961812888188298425179382406080063651551669389466805871224329078009101150619593368955821037962/135776896443297688562476641237506318575979935747262972206088946208133591176597071492914618461986695431505608158200756737812570852203751131151883,79349493252752135653176501654982526303957241479247284357970798569775310498623758418314180951099974085974508819290587068426646849636039701047958/152735353255649170898115890651787096616207531908779634306279586319895099008217264442511608798301823017179773871937166636069525776931663634070549,34164593027351801368784578498976115258037758102895568964406126364600781399510132051463781488217480743214679754397523882782780276975000043467926/29274301345931801194247472103016772513042969356967210227219630930389018567786902899114193727646296728168845535504413482136080898495076842310253,6348624774827274312224469117566729337413916155256776571442229820428079505102018911532484062638995678175279926753587908849000107529531557681098/6560243420386735745875341687280954162952915127720153786047069409549817986403650414409353939057445943187886359225515824290867574576211744102051,600296666064867859362019946197322440456989109181489920387721118017455412915100812859858711948688661876822288336357145953005049082046171600799/83614625181218207894356523764117931826560336393820270139599617882323429854822318746050278876667722281066059744071056174894070291371774028212668,1282200664676870461434868097384601661853698176698438773585477627809182850208598667586236262058668493958556742342123690416312267760405096149919/2131260987655055534977898291538410612450497510514892821094769593633234982862219785175939003503002327054795042364346101141220698529789735240900,1243570400296850351965755996753041907992061512417269912961716420223733767981540211142346996884524309357536093524077715916421478959383570062489/2183634969792995440490300681371076023708838460548031885424051698753214846436664160543719238061933288552803596053687820595262926258264280139003,837348722425634265854175533964489566026278199054020393755911581565176330289331487070877386033010220944463377802276749018438118657041506588282/12541013639779609628408164040122983273888801334758707191080208145432262526066533867369907875252803217660512595746841299024255257189568464210659,-5531035109481598441876657147611781638960116561572825809292427812326558001306598372385686145207071216563666375800363456268844856422204828508802330/3215078369693142403836601762322679894499900320094908347714555062862805956613813617700922529043486039356868849742013270761527089338033600267699141,-1843244786594336318689650246114142782649696487134275365584460086863467567515520982524197888347019323970610857891230857203182540409282035146416930/823765770932440808635762150722804146923616772454678646502035450902251275022221794341181728127785529860276676216113880453611510163875261035098249,-121716038502219269619297770604154859286593296077624002398800935045984851681999786873498301848969445433783719833871637320508719317158491666679010/41691683937934664897106630478841854363619004280217287321660931688459510205152560503276521433003499410920386907844946910518641335057773621065321,-13070641255474545561667726836532797104865910939714456972792546666711169369128380678165276010373626388993781624412428518277479841579563552191022/38682144300428907872237688048284800293724968865669368566954245884398906444857991205562923854876701680017696521949372302871891225398970537458231,-28919052876460859562701528903194786509184474926236766589702979658970884224571467175359558190659337798957778844315990628413093112446809208911866/64962504017537856489173202245559062656341505053426091383826429237955930135112264483553249183160677049089885879289329496534104561728836182786225,3601732988819823653264794417906935733826218294625614934161353923301780161267748855279183509015094935206277924695181417213357609822371220405002/3829339702743153288522529419972053696206093742234902021837647712747837701227708673107838491063113253507169614593510065823165545352882459331619,4540366183317380941303910064535791884927506596670397996017194336869349304370485795854201628721680773618141549707594127902018181504475428820302/3850953289973599901968913657212121800300314842017469742205183755018645867356016101272108493329131224373665528349707534257783630419705327529361,2514367485564445240156575623682722992378851730136826463780955938271377525764160122410422294633585921917992145667438674102892550132629725676858/1706069634964987279899328274109048418470194605354343328987181087770745569296777880730132213823760183629496936046720049113482199047072599706579,703256244647142813620703082103117666893067127511604358380013614969252976392360487828139822726297446592741899367227218571747170027426909486797/521020827999810176353539212488829715523594303774631531799869361258806896176090282221856836709537662619243989284983580302521533373530798865490,1353095782133874218781630907412260997236618605879976010593674590940692723412634647929809384994560038618073422097813501201737933944858343048642/3893079236405138422076914625057088466939759285948633377615350950848381394531874354832678725098557279035096131095085940255501055447736366260851,21715267656601164735036055346048799829160198632884336443099676739343679213698722277229166962450519639138274673751560178430322371881301235256914/49505275562501263522635086713964404766499832300600897790689566259975737711429734544818055514520302485943091102897508967360666344177870172005919,1220348583477362010264396969843347937656913144310013813212399479373391008050514173680894965819597588434728109363336502317808866611817506380138/813737592867482282541981383851034298820904152914163147693213102568212167587038614332633590287358608057496640595191098547451579890948871155771,-289246729079542854957873925033807858375629566684966070828536287820685728222208876201471361236140118578895878648929227247943171305871175618830510/1112202000708725030995383762821475559927939711600068687443007538101067399271902439219145558692871168328073632082898264293408907683692661767911239,-2132216007027551428375021037689367223472843864921961854985427214152900169811828547656221283064317678684716423042480106000808088344419827853360498/1213842023072313566172207963253544432990874674120596798977861644083710029502909979342656838848181878142244070719698142137074905301931115527786697,-97580436229518971418059469429721788637623620552665704438026137838336040360068234084761164987266292590411377514974787484023889196644759886468694/157864677731575148033090521110876917573818059799466853672663222179829451057193298818551593542902483802189687623116743167559149465153840037509171,-49126301164548940469370987676493105144338544113070966806763579671873689133202085577453040134029148700852150904029834822198620652941354712545198/599085100259234551311765841164609490226997768430984984054344612310273142676159236160387735655048085157964435438502278794275395622043318541085129,1269085531899538525126156363260611547106800551566597950096057225898928379692636422280186659400152632241581625937707110138754743721163396689957/11381632580391744561319324809683075394649627565803160489789452334207240287970871889572595513228742424984036742451406005068944414529409050272734,-25941048673306333543521257301067420498819031687644178284675230296018543609001879444679379553545944540007972840455516111387470446149573032006906/26320918081547438858450245296941932985984563390840665870171661544268914594741042767365937470914096660948355373223804008109675763530327040691501,-74105917310915387519826595529678503816676391238032804515992267624887446668838639047575550790858756482639943667875849801328232931572550285099434/128792783737485320893415392433511934978437157973833625282307734485527457314575846900925223265330073238276163822670428200722054706346876025261109,-3187630219919984227666464195976714229373508802902043269622575368066461328221125300482987617317461022889484929340057273970384770242537771588326/5853918617803301024883003081870731159300796740758467498523343064519627233320838964567175793561155822780125790056487599670266940723292706086163,-3223189824140910662095558331464951901771322474012768479200750032081021370805671356827347113006095197193769537704824484809328639039403095307286/4756472323353244658408233556347065054345631443448687960714064857840621485411582587504461204246598748838243788379065625564664067929880989487763,-3997239561812655198349805793075023829750173039213967687186844491251668878856653212740394953939054957920154561338800128767808115385138484914622/5399418971812659642950954423194132560378828224225613551008954416571358550434751651858052026476233791092429665051208563449752095681515789308231,-12564642283577190270324948465939685135732205844137000760849980049515953401034369344635381928705968627662546187377954266876560815372490509796830/5743251906888191523573042893961753094131331238617524185645151681256740243780383111058846727789811177036064794631776835448543857375264477472027,-219353401004379488735207729705122592064272819336691216740106606215886398758001565299956564736043029011226023344292924562877219540424136917389670/200610056287398024395297818381633269117128515242500344621971349966513573425143128887026892866602314931016954168697273465769862065283143408461211,-58214320757338061167528817960357984307870947248968141740015418264748902696802184318411590827592074752794231259853926905632374777729279764058330/16852501295186239603403688795562837329141270903590857012957590896322760604415247879235345507210771249778587698701202704212110642276644048415637,9219238338063368364166642389273458016844742764044486212257575618262262345532851969984622567277209941286460138312171983902890564939445481335662/3854500976700764318667584532197169618223106800592291256174356586427525323011623313759389150231356884366814789938355612863059120349904469683969,7964521588754313706407325893694849412339054296710691776316888443031941089630862277144958586529521317973742937772851850168234618552463526937086/7049169302903585026569111175684918672286468144528446097803412185637061871403740192420192359191526523891788195614414081271581080784604409049509,2682143902345560527301554314338233897224377019315653432720314356530035040906712445808712427618952272027604789657010559135963501519616109860822/4516853143810079550290949662994427664398916450480665886076899756630885729267046569763605931632329204422421235152206848730298056607348613683927,5324290960641326659736335307275368367425965112104259525261826534094914197888413057865042816442301819686584567735899312265270270909649880396962/7986390930765767572680846171566421752519802425013062287921107113819209918136008178059559018967238959857015716291456287990097601370169132404987,-1862025354498351420934863932619891504810107930409947487251152189278522023759048620335969235050790400235294693113164562819903053919677604795286/2595828739488496289972884672926410661393381333418190311976345539795511711303089715086358207070896528244899644364448047084678991018134237644691,196829584982343047831863383107343098738691957672831258936927519753281025795625601381664186664644688028383922023599660243540840842790150925846574/97172788341429707330194553237152540354542511863929479650160371766734772001046557216169113268801133469608770073881658113006423329785406258173833,28969680751118802297921105810652710306434572242868980598919988313671590612730627226630298230578719045366038110537576691362822396349588305850298/34593620249717354272833554511606790347491385390399773527118101289665932240201770331886183525977310683677705787684722374004697338395615807992047,16073053940360678429750650783618243930760388971743865777976980470723332412744042348505540952243431714165731643834687149342176725861013993734366/3852447635380702054268506285317218336842480783151912336788518334734485901208717267945074997391754752651775217698179338609247758120765653889197,8975165322189098400947311346209650526022948733689979737497194517572128593450083282235002554702339276038234651997482703750990289083991781109994/1213110690845562841417315632247646752193826687615130605223487504846167243124994547664778119303933821031626810392881400213547758498617366666323,978436505597071998916781298369222112818007195877209824637480232232581883086134152960520343669623046834172245486868243751189515775679075046029106/139636200618454892049121748639260692263406381907136204136542941836571696306935422037659524097060945911851487212856918600341581516370263544759247,140612429997509803968884398021466718240370717574315427685668957827377698492238270744477590799295257609171855039707642551536027588162695228381854/29846695487316337802175558666326510313297197449591689530606831564938175273714347229061575330651815895809564444074905643852692855352961994183253,40091493274550858562195694748930001492302928767969752707276055233807995879334006470876863097368347870466819913430557721583529808666064945905204/8871709776604947147676858311638534575996402803493573474464407844528602654540375268714971854842291907943499230185823692133445855203261207009707,2721346249878824900636768259332595102859378922108153219923317295617947801537279325300615740313468742414960421812961641575009272119509345678/490483565661810619631032389586461304988317519400240993503758573322135746912588355182798907372989463233661386380857544718144778200371327365,1096714779784122761421630351503021846588623376483863052353135629636959946492695601929528493198036909851933437479705155673279509818423782626634/434011823881268789581482615497276139581771817547158835473332384354775064988141761568062819997603278770711613123106112276436139574520110765937,69806763831156492677998337024580869132901954340117170595715639707403155787035139802858644330107362666047883315163678817510478570444721837300059/27200468227901104182339102911852041780325131013085858560873692652760520903056603804671974227612446289490277052955453785424137058634370048396848,3861462895638956008317825098778551145275436127160179289072449755826017691396589596983814303576995032354788730645513687004091044419857618837641/3677899390703354435737851282386849954977329017075304115782926280048059825423346124762960519903090062847925273189487994986177750304436506537600,5139125140484124647447254354582691460197647425540674026125248529224537262631136840781080074203269129139901912369528041290958671746197906380879/2982271363140309119445716717298155895560235615633269766235477188525388116619736913261093497383633299965420130919623811927470429408736322472731,-171220008527857709030970233611727621590734722206721826567290838578271535162356272644292465463314149984880547937826091183610753608069756630550098/51596921080063287190532158852679490990093479073453825246984654109155389229456642589167275473475626835144941229471162032008214713262677246952817,3468717706162772158077992189324662037715303972975244603200808448352619815461548025265373021721185482639874514236307310342547236392535204008618/4934565425870382029596379450297293790384618276944579607666191088728984133682538869114765197569074679314759811225377622621847112840279728030425,3297960100685904982572458297279602743867149608713197441733461345790260522533850745664619889406836502399116351755686250119515650657050257785769/1818091518312732386754143873317001491982395615507963084854469266540469432318996781295393263830574465223411983865101748530496120903053814356533,25370116472942849501568719155564912262339744144028127440930831249263109712433889350497824070597026048008588500343402100425027751921898590453028/12996761799198298375322244646520438625818217853783597851327606536839352574468107074695194967150026911815705038230252012226096228130962736543175,22415672839920013666444802704620880968222970785190242530401676791303299481617576797089713575110581168044466972679783186772738954521247909955858/9265137173579710281923017007599243024875788897274332847735543382375036017359022025673569506745121879570403585180285944333094490980783066023615,16815406547962358971204630284655182550805436670575235222971197556903674777939581217209900277201897859383255135203798742950328876509916803577854/7963398124698684241252364694394951543704867963621644064453955809494084551476890630043377667031819241377679620963554583303156496811852725966073,-75147291301553643965179296101859620639582538580360393791613491374491764530085575367908888831444951314617213787321498339055435330641193196447900/109077838690589961788519153009302186393590123116147580025015186706224160736657920230308480754342949370171919155571173381316388114450772691438639,-7966908057750336390941387416803594536413807049892365734962913669308589185392070119370291163213514167879487001116766881274049819871056896905120/13637692825768925046409924353609620314034460834763875290420167917853574128314848178840901073512106619475998684312990425775171116258901412738967,-312795051939381530763743230215825314941921715688598503021304379404264523249655394276775164967926903350790843972299829527825896023269697454474920/262831181202952128632441937200145810194724931740040052619833946014179296426255597017262444249988450204644507566922623349355378355051697305423141,-18953830024818016510282135068671452679292828358955119725339245625097459798022510475614491249770937124845913142113371995057743395283758816820200/18305634187741138616874142178830350560330807317682700005707430836824401697049797628104427512097493339275375136033784877281538671831389704816709,-1938699762928193173496211497671320271363518180942536223922480305988697462169610761216209290302825706170540973502434316973789888857676438228556/1140717180311719181386760335925735220486488503833674865682462981225137492133195483918446721830079560065563514161429445217151643579241233588657,-386517896095077129447491996730174326194984418287506280938391707825522175934690255203348214913291115117950304972982063455663362015718192411030940/273077850014099585662988531716485541168943249351012429831137102531451827498728929609838720350769053541193974519900899841254809465195742053202119,-74748570305931296298345185856824397174146493804289562828962223459790055832688143402540493040602795092657804499900664467720326457677013651632680/72064564610546666217549684677714523087409187462410900571785549564950242506651765727668416470974868550874314390975345517708733244745054696882501,-899621242584472579340376309810915763603239343288181336005087754494762920938629113779177434528355712205181803176348690850502310834779353285504/3602096133505325599757108604720598653965625746159133709904673870123669981730161846576170122132642440406805399993820575548808559428192498213731,9415070833500381291476978865341012215419080426530553196333250714544487160224070024254605947728761830693500644733934316173638069153238537504233/34100551882972292663806268702191589764803365923368752407980756027969056147095177421875799161758983636622483768450121868283017011818870070557538,19540866971573784934913469345056261790588610074899546135638986314769860664348698154085238771547463605339966105656588074447250662238341888549069/74212096421148589689750396091964631747052130452768760668265641107274011353658608715661134109099685150907929550791618201990605523071301067793378,-2038594579204714938959619758751126458660787743564855635247966573140399444079489202077558805607343714930161523440519748177250676830872788719799/7746254742919506362600847777752352997996174178638124275923541859921727959676913137410527896039215957848096010818638997795664983519868267552110,8660224395983300476403715725294468774950405148097766058023963453600355581076724198349274243568018315996542259888088345597662202926878991656120/18304594556468900655881500476054775241956422112468133751010858414990749505107286719451334395539818964977256804214834591926322581961451132932639,-58494759913792852515432406609804676652070087899948806620243884931645740322823227446118392786601009498986725887694705948754225221121145192996604/23356260232643387583814747141912597114598116705616651938775326484568628040926249878646593344232843098063475364761792151103581287974635355152273,-3621750947400482420852686525395299718975387239578312255574096129767571515577140935066945317746502487152016226537653874559454680051529625099741/711993766856038665306386316755506903525958046708389462818423618847913873747854205721333686126003843306668251710562471458891106803901726734116,-6599522669423819280576622595443383021714150773389673400564879755689171842867042218276162303751068584003625956195216939863238719989374736791520/7222088749713991254757385514776026667697607117136938818122699347195478776590051710183003871055989568846514600482639352944020946774221420568527,-50309994325035905370052778195370075691268426458187650489224180251231640234252706765152428469024946434502035617047587632472205026728197236697374/67500020241270206667827226849054202014119047983526789344614159027557409136441447509402533856497094136844086860194421802332566556693507206763701,-11213671271888590325832389882827677831290871836237412027209022468316358291951570922634200706525826812058863384165093081844940493585414525431829/16557210327405081380863672327485423205374433917452923589431193723023784879759129155911455007483951628301940996947552163086045342942164828096991,-3098354905388375938153105603957128795124989924860708098770049397420368488373871560002894428712597725508205419844929398634529799908294638811783/5210796319207708598863705193615686055347750489092977528129842929744778857078652643133080436779388706175663863921311979119347402570969939074912,-403358608054157508952020499202275094155126355610757112278593780288194876393813236077375005983451822595733240766422155989418314459481809409422285/562543057131480008394183763211568370464058994027780162009437327156181523202304462740857872821651239914634934184643819134938052554295996488850368,-68475505673632934025786935021719012717671215730642173856768292748950635065675440245305529523292701239321847528460863395362610838628803212058121/84299232837887317179909835285527778278729009126978732743998359481183452088626500108343001390495381758104080623720024683321793789353744609839008,-3778941802779726438910307267813703317530467171755736266370463996056719124956907409770505917689655850930116372580667135883837493789200500270185/2570972175610323116838121273676170003703437636333795381247496245339811660841393684346622463950776308687381925719592180919843428029758829248714,-612815286428105131966779551486586779648905471053472486628586273514200506026274225931696117380795876253086330618110225514808131379646021415524/448434396377415172026699106695083263984268541098925179660812426008695838071621388531798238523097354464780528274691254586327673743725996417533,-43906710319345196341887732363189017228673292590355685328554648542579907237198410637991042302019435305018391352513173359203260651325178695508413/32221926746840721267267854203519741691884206322379596054029268159958869763685640694209339899501296261090049895568756271907875386731665903046910,-13244248217938499208994166257073744496348029471570188507006953854626664964856082180073018715573053918062598774657383287694456925485952136984621/5833153434634683462514391540327387817293660766263007729130007187222699914785934868039959284497386197033341223481095531591738683783725145594370,-5498510961390891211223672130929893359983241218969046325136225775132492216601969855620490556599070904440097955118951344725444417564216410571431/2265909639673245592876458300611473847896077403574213121743718404197968178992692629259199417808218274887690407589786577542964834536034776056771,-735302094132655908616656518503163068457069184986139293799532397087005967093987750971481944255658888791392896128662131236631698870161113925317176/234299403894804370937121726037468340670176748362784944859471922454518889725132222228224624300314626284727319345260249532076978337983424591601207,-11016385674026824624819964744884058936500651352867888643666878924796668297296413743348625316455226143016862163025821744356525915905671307994104/6141302417993900719328078688587085628012916920277738238270103187471299772906950412311974114693901375324103413512487645588808863451911364646929,-8297624805299409153562952769268766281977069525481657330515405983110281278718551727693228974464005522615828924241997136961563233705192587398948/3394131462916557090710949897382991198775938878183878159412483197620149960148856184616155687204734457106132788110930000445936706150591663246255,-23898025559272521363256570312241090071394963614333515696904287748740674348460444066397864611825534079658331228369020786549922635186537490856508/7617644558644676225666074541547101364742751247645670208185712995611923853004554350582021949811650438898110883568911361433584734770292915152315,-119984557875768108319642078955632205107079089861693618697308164350593668852250338882781210323655353505440172232320332693928332772249981195013144/36699682880770892078183506379087099297701089164901896385297331998832523091037966649991453151634760766357331304564016618494830409728452836789523,-15501958822489539417453928209035163387815063864513790929199398104130653364570266996012483259859960105479237490360085009247358916252125205596740/5818519086256404971552509452589712097133776544596017389206717266513772812951952632148299371020756776861821739133378476529738673569792588799103,-355100897821754478483669650511239008779869953076104867800030691832973929380395176926480358668208383629381225183900995337577701812952182335937380/173811246554619480568960412225937393336714227535441454109079484262644271613362929942310611289938866814001190849955901889605320345826323957985753,-538621054548980968772529709549713743721825958408213183755073800692306582955002871577680434774280210806019719899334736778348270441091506559275/515961660885533598891899313977197341611006066896284418324050286975790988587927970266109678792399799962533459741102886362438156950396091682182,-6948771974870246699926459684723462209889130714202105744512953114609744570667045267589424124489920467511477653080592274663915092074348427311/1517517158769736671322417692782097181522806625914242314361718098105024192170753365405820840783205708202929630802472775526407327753882019457,-150931666451691473770185326294828700066101476660308558190978162010076977289955459551251377384678459087574575214109289638117020113839061513388899/31085379893330939388541885196800302448979046982344863421815081917454038661646184070697990235315854571746327203004415025615627819504178849287714,-204148156662475260610855637435017872407635261754151866331934654786955768849465059310290933646477620226905327670381214695214451688408523110112511/53639408405935941423983910197861140681691934171031130929302763043814314546927948646760470507269205970328936163132434253304587720449702164070228,-36182252959977502100238206137093033360155437431106104428269868581026166363466991953078026409467665971626333594117786632176300323543369652023773/9290209962108012235663871043454542726336361017548040967572679717301059340330101080192601759147781408244649806605282116722341143091472890349935,-196067101195650948807890224075674765937607046655919588985483124584330755679550907705971497336046250274400155400038253772017459656066819949177/98588646554947832136192752509579437288294999079576394256839331216787931384649294068141085038822585793959152824612073834493200988700291324352,-52962497940741001653108013323839372014755696258916137835478340656352912975474631943539968990534117728237046719037743393757498699903230372206/26661457606440671833546573951445889507566957256874267665174235308123413606525826032388832538952843778131602895962188614138297100340503884631,-587224592953831382892436358082933310434086876075320902532124578847140837239899582189881846759054318937306074944095133427019259625534482350/78239818377572609354324330203073550108439734050321906259783201019705915772846871089702403291464452693554043013297515883249801606710674911,-36015283221044813759866863386024298813044161329761719072880588430882907191204249946112535148974611531930284878754805923676993635834242282529/3549978501250031587803439122518788862862740588868535950230338301920652127420096096805293916019600416402815691631001214474504240134472144796,-14346305089416655300721464520436449342271982754053202680951047913962343973433413858969951950347767641377286317001164941345013033983400340039849/210742571565030923345596284731782012898054349370743482733657589729794700449156550483144133797241767502884474026424243953899399034400494066364,-382647893257225406315399467821708364170155207877128163847596155006271936996570618033131680081326787008353911666490154882159039396989220800375/3230207268030287222714535515676352155582359994010965653403273681408933727778628231018728986888477299578438533477456636155800038806007110344,-21719633090946658683395650233291120565271266572288485612399138587195641030065571757077415472713736847630296312827669822123572463457267310070094/485431840226194504194066686096477208977052470024157058861611155879972474140636625309702150830413814997837415099489621354881808846029223045625,-4914603935766115410032692915047762710905952293266105635829262278247907477242968537086424694621109183036396695935537784153062502152808486289002/153559459708438408559909735280064172257387745253866940318220123754826413108619308788181536303588198192442472652250377666043992287730619877395,-729751586876499010165698091712550447425801008781429888543788368112526889994396057540326807141291498543648919818132881197339601221976495591638/41279552121592334766576738559557116330685938186086542743725910268068128315917140226843807755375846316878443892236387437494868266150049697549,-1589140395738758719111187974381953378974315066106459468382298108593039699693778591344467893894051124444402393301271151197577981427038432085746/7380893587754649119907061311186890104562138781449152853271693789146377228159968762458231582518469682727897805036062024076417041920337369681,-39193624275258534057004008285183797951231095054280135465089747634053337601593381556905295678907488556256567626680939099948150436041564295407089/1663715399746271272295553189954020493848851540816214724412483413822350016790018070586149876491631770552215825540947297245306717941191348641245,-130546328726628577847720740636756030689935896682194446499944368351990713941715391204437931739756547608732553502647789276909312086889529935388572/1112400680796060158764704321574998507014641553948605792590450036338659883578231553422220916661059436561172670266750910864609349891981571423745,-91637385643773624267352902536782216748026423679452578952460174753564894346601202155223306551342622102773796334901091497812593410409810974399807/7593481478506232774513566472266389672542900199036366241051801654404268275060020475626161086873756781052705740385048833898945913409260210155835,-3525495729632019925654603496100535124451077001263072848844431775563671871527547963071774201668185879857663561177894324263467375192694071256884/396677306587484985526664948144251481151846456548804831608221268911714981282810187994478673076884978928256828128879848482134899923501483113459,-230474342710009007159532939052067237485547697057776571375156323421060920169475963261699459870927478760374594682131894155550547428226373737334/35639135547552632622797123311994106978517075802319163327595807195581028572818600287888939171945042684657399737158706497150043272363378890701,-6035463864645230932054702629801243859913329004774042238488841712058165316569604204765248494744118797063674204182328765081691013778693515562494/1030273042674842022429761099315080816804260212256749384442697976405943027100065421328696224495516142841635411725056769423702880515130698152201,-1632232809097133158356568068590053109054054599658474479276477683585863314833764833094765578345541126079311302568034678344479372675358874188999/327862544776643080167540018389049138202896702656045886183752470720012892990705091475043278710399265420526040825600438910747279093164842500546,-752145884903341712871879105310321152488350929985337352562404735452942973777625479857674273573542079758983697248290881254039304879131298526762/152893032096271347367788952412366061058684557791857348783160758274322947142381346792422731122895042833347819446884224454442123388414800241957,-69297731539263523195863802597063997710726787435767839273003472760237570124464921461527868624052461357832070850175032559605782114825371346121628/14037935696681900860619834606561905377740293791266801630775185637125550370052592157230182143342608598617637554069012553432598905816764844903273,-6327052050718858093008941014041006554743264355374335955126381192756385394652206669348401942155879649908545521065295622209781315810911700781/813441805581188695123276627379337766843647803331199543233005220797521137599137560707126971286116214777581504001495863847770810207994363613,-376196372038141615092343359098861630017458204302794414356464604823406030303267226167308144193470488577632063055590404196168736376230497758167/4990207682427689465080254678140891133328527752170159484300749164550480036654339876032876836309320559986856043971072403561568887567136560672,-57900466038343903941137703957751995510151475853259273589128304359416685840611331445861958745238608978422631362927444557633443601372962098906/8408780730773052847771384706570294611675048881053019774732932633088497037649302554756823063300147433781762114745338643004930564406342875633,-296325386054587061180163340081740176971208470053964840808255743574124389621073173063054929998778912167883629501982117796288001126543351449543/130807270828957423496526059695638892735081597015282687362445691877750902937880202219012935397139613656415028581939468654562823778058272166076,-23247248148566304619578250222285387227049943975525438906246332581292092961274352980236138566282905814857585019793977603580737121696358573735269/9104189558368953684978446340535344635341017256482189444031466664165901288031926250116450499473656958949662554963507998250606881531928723352158,-2383661306118899590610379190070023142359045989673150868001396647351757356768754365162211480381924756051801996325881279514082307427601688397649/779089111857163895669906458186877146846118553193387860565997124564680796495484069253479853560909589492961445332482923631325261118735775148024,-47755322712932419383742299025968751725298350485648751258164869107030183694356927244560967851998225646451256377619280803343530471815527371872249/30292325998794087951493618557762082809176984484742024384087329563549422261789678538915038403253885202189780869003640146303713517857975404155424,-271249850600162878556671437069954061143328079728443986559681811501091620482965490661161757468611219629344385460254686244331988125495383868520181/51355179674368847784776508756045849907026942959443691189582134151410712480164299160595906505951809460638646434829709839007427352954193908812027,-766285930600543913432314073147288583329984985719834560197982527943356146449239061251800848681984370845592562028509547715290764707839746263624503/140539614069865098965590367042059161665610000307895453530374189279837862035556591367475508407702626390476350850872840923593569246151560073455424,-23158164725761242330632150226674336649940268603609468546605938563246286791129630325867180996058513339925410655523024848133369294064776180398044/13776699698415774191204517184692197722804372189243075780822473769176357017071571783302958259404722559004792868629401478851648943202613134333091,-1012110153254218904059110736658352781562554558616783779270715405489659747910997436604322161724200265201465796340282198830889522776523131734005/84152220500246620290427749202238717706535002229968767748688543278079531462551216826927644295109366094307109739865360362616509056566198574098,-9606094650224939767363334994545246348039058686301270424226611448951181833882469640226423207763994750357491304167492807645429195662363006835400/2163660671806953483760727351104805856146894916856567014013365300448141304777064815509103541636489957277693991657183568843309720667267121428741,-427226963684031191337580295743071296655045771250777517359895308734046892492242713422881252517124137361434661730076387190842612162342499097619063/33302025243876509174161925836347406632315143840734240939304720043319138506000522489717727879751306317871151180107772410397388141524382849557248,-982486198927026666377196019798675965888743807025798191271600594468000238335561779407536393927921389643175986428265537738734304632261370823289/294049853456294637630216679586061028462210374193194179589947029606849601424215555907219780875755824350708818283050072992769031349809345730688,-105577682740300039334305774384518871605196911889835068423980928409110499548608817364455467942356618393288753797889354548587126778122022508109596/6472646946167899677656603095622603602168029734864328697166073163914946953686572827963730521396569623296434640540789739465068927316465094462155,-622512800983188530522393208256983399999948608714414419341948359249387522741823266369311508679671536168252955498340045519083895166980960105506603/9639529764876602515157339905215122640681760639525302962187255813538400035791531070129382727139459634523482712804991313079617170665272743409975,-5400903248285163779390904523967262550412606683530758785267453537343628920879266248688296326731062359870870223309121736261113682556264390315440/971434627559956139747412240906302410973111797798062710649002943979592294090585739010441980218701250035489848947241705237436391228655668941201,-378422284849697147232240154488710330985440186116711812439403137075915085990043133140006561221296688608653471655701416501629269153519398774155615/32704446440134894552162659921291831640618096924394139975845397681097939911820096745775123755871832836539435230757394818986779102889052659884416,-1220212428205743841652541831949518410236070730932426341329455818847015956447912670934507189555470062789819054894867540925698784007463927762288/281966151208827480269932326744752415547208293995736710938086902738982035667718864596324322513964268301154145717790690266898844698147269150197,-6899329682011366406386634417733426675893291006834805520586909299418416009228428546594190900885336263448637891798359470234955490698594057995/760713966874308510454310802721293023254182926212232681774242761760603174683993283609374269893898254023509306010222959450762301037642713038,-1380140032704159061387865053378755453717479138115926075062898610004571672355001426271138710493760487713646882656127611235754702040943599355741/187875288863151091294227622681792812691512880748692432799539839238845894450944686970949458561639869372625982437486927042631967502048643863530,-123035399188044593032237915848363570459071259392902642928899287859460815895573014845458599497876080466064601644745722181262197285147550261071/16635220132865270374590527854142228036899763916367456887340631377922470069836524941703883807323516526032564226802258073163079644307737121776,-5501430678636107785157572103556786243841733039119609598725728047869150144872815585619918589762812420166398904170433064912988753626192919689479/1262002724744332938497224624543478042670563603232293296484819215562979809311915801380649634054054682121598041084200490475443145992561665022562,-5466959206530055682114717305498703695691549353430335184284589648822780556278598272719968843752985008095577154546562147019718825972026655170432/863710298510529042406340324825919903484082015977300192264310580815954800817860176895176917783412816484572236418222440280595597408123172186323,-366614765640987173405522644428584913916545658962379334788060688143395146299915441182532201191792645502569708217021371560856811321301248727873/52681732041217933643792538475145978958491302278352735189357887418274691981032997004138293366784478687636023275909339842462341540041122654788,-116494917032178844058367005926890569482823437260230833727359649071435679303035162499746835235677777965226436922960192119186705386258732635121/9995087014584472010450189909215692359882028073629117666796849058975317921946055743008016016743997043753547177520529032114032884317541064791,24971626889899112848027779459883918591390572437517030456685317571145993674299444958898978296723479078328215937338474354947354603652392431366/225704818916195762007674345279257476219675532311511824484796821793234238844325407971110860980354591374960636547101025007539203530019592096109,-17422329079646386402016734946518618557990483405530966068988430714021936737950694115121170312186705838751953669025693361092415382858263094383908/21033786404997494205318500940315775565742199431625291715264632540857288522811464552177449592425566992895002838839644624207923040566811068987975,14578122282665280778794464697232200230977078109598711461694407386781134868056059805108041000537219901437542361169222285716835428274226418799/52051273666750255377125601058572237775192503165655702532876152665121938073014148711384216955813508168521931799365809977888201669861803590968,7870130692611218201991210151250610115982827001344803389934819511993214372436155777312985783372484839138803028055143671799855787095490892455/29841584144876463423867034408474913613477764939331130687629393837672341300746594806333777259891028129068000839319318353255703277262385773476,-2448796638145233808833416698511758432005940309036958965316096296431220066895479867926646616883618672248040050343900628945186615671095006362426/737510672099579671572515244764608535999470528337060026550649546046964270542180883514335994020584209207195867206334799246110266652390419591071,-317776521786201631473488643740635049294565378856727399557893049489500242688499467286740656060793392063340122291526698876336074523826429961839/268157789998446369510553748455598205168585727069126212398518589069631551149152845311982922851447707471486931694732521976215603653790279730902,-6942470447320380906538549804536845203827496702763193044828605925882661689202236275544488940504922984489894410295465262903444333997989253114/8853695310906317110292414879248615984065688392397094528701168778088296559555675773320881902769792658130166809889718863942843765357219628395,-688671747943321303605430538914584553064496033046050531999578781093528900400650752155771275836750709822538650429610823221491952447413852413278/438270768413188118587551878050810070032113579900923803959397310871446080694636513337983867998145988647438488903610740410156987382977842067315,-1025258970846002927112629490275770686778690465660413626418491637961802403266187396529273830287676887151311323709617174244103499164643168610/668696740332193134773470949755481965553457210033301086291717266197326696236076345283193717003672687354506186442201503936765662039463948327,-116877839068526397738327222847767683759012381794340288383262228238480932019210292763089821753718560903303391829077919476881927495071861425790/16068556820204490086748094609623042976713408875432002083303664751305182077426909544663955445461605829510889427013408536912449201530160218691,36110184628269000366878763403222089973446706163604081981874858004685010218116889357188211648209796855537973098796117976413119300694016973122/39738061990072736916647007190197498659436926288883012225427731291511460366023338054920492266228517728461812662955484530675650432036928519365,15261535281059947414935554012545797794919175767526112581086925696310361184033952195665034213312235485211247912675561573740420610944968718898/10332945072102827903887475475096074673295631603635189932776668875745075385246621317904026156414990116475770443689857582662100565065118875965,-3175376285292256478865414847539872475502431125397707622409339316439594393719598895634396965026174406706342891486183566209577295325289810630478/10614262405351745894765881003889835423258464016077662692497630610061593918373846535978682403778921426532800574494291071882816188651861979094871,-17906846518724269825558900598613533166334262150374193634190621986037276735921376687180385519818678607348190195337544745928093219468786802638408/47508208601993164133543072854992460501796484391473924897959205271278832549661538943625966702618261833724645599304010526797332130393685439928507,686308359390936193211521735052698215115331505143668755251245926550348534844772850394824705290728369743557587096759814686233761676752016722406/317607593185518773947845274651700627812163682347127673330380981336828729137452026376410199682990891461079659957973083915435283179833354078525,6599316413275649056089372061814565976016796595089218946530604085961435197951818115078061115650656696042538080130243650097761436678892727638/2683732711440359699991433393169321366482276701336982935871668277826074129050822517502772316776512262141911562251712906705555750265622828941,1024784039083096124883286266873184082097615928677090363198208384036780405666772333789838364023015916860111045719760934693236808214386726168446/365879617120128795773436887539405362330621129878524765956955795083373436526642540126889206836247795327703258196042429459623671305409288589673,47068446983688597051924493683148479463727187329039443978077168386294417497020940102411821876466812397165938703581781684007963070753869779594/9423309565224159615681287394341379757747404194486594460963569725883277895292718104551311944363988007877297559831414757609385672723330328403,-2866885057905815764623437949368606159849062076276894925072480820361329389112752948362091530915832290532119391464958473475241524229173357971074/11809606923585102006108555700193484696681833288665075812058049287068270053390144861319951972387464292017128784435249502220769555719164059801727,-305743108883741658356417196518989411434348651123711509967376143870074934061358252838486147153345798249236067445638567258792895002433666164926/1267199718596307935215117445433001733958256208158658008632797311259409719105570050893878094472104095639644463058663289361169896632249039807711,-1560412472814927027096334789576201929916898827819607467552383812732926154335887515568993097357770095074214770304709082376025375805431044308519/8442699539247878500947465908679714189573088696489974345540624491676526978636763101332464981962442060272565617873817301426507768115913589602592,863752292693517631500485857514826042451383357355893591334340853501131110098827168009752883882286572488625790728060675367731004803242443939733/7345090989015056000477470035584447921466113582299577760697027650551817981221794542686582591674745367933586429985800819606228645966952412902496,269315730142007425973009661131999943193374976394610132528851963461517281049382525535681083558047405932702676890467137927210011190515581979537/13149344154299222315161811537561607059700295843918223680343701550471991113565413787476462059703799133611361418318858379458136209571443150276,493312064918977129462569081537593657396882729272851216933777977636614395753618348503629194451320893509105012427530090414851760802495248242034/124361222108020482774963838991065804941353667433136449658791145352129071353230430951545549761290266774603230500336580422711787873673002369857,9772642115500881617616449294659505764275899504432075543555622093899530709950066397652091444517487445985917677298092431459724030420245660279438/10960314506725305533485166073915615569953195923397293742674101928088158578586559230160211803750935027839283020255031715264617731019797250438745,2549841880023592619813324871666099053727750088990400560175639659825661992612941331139401514678406805832022222884951969838150401911128210589130/1012247467158620035441415418353771806647448294730802016386732993749602474360443888364205506353226101042546355697505350493975065544755132129389,5394195067017362248018420929601289511495799135677440934335132236650622413471931559887904940942905262236333715080097875569350106240327617515594/1689859967523974578504196122865513611529103263988563882190337160751502823000497290874545578651644981631329564613754494535147814632926889357101,-78248483000752324038984818370187918945270752393957984516691434776146162440984893435282074374287990623118799678098647308193588982279664264851703/323948614408446702392457804043519901614373432134753578823958352468109796885386710095342787261589960264192615228597606344366071236862388552972544,-9011314770523814730081602563023248696947988627250245026797828981746867485973333713841810698472340247413037812606963063068316319455353316688277/36941603665136113910643841935934658603665012688617019278271853135277278149447570232728294962396271977713085970929266430184195414150774889888811,1813834612558620779709030207785199261468621443231319105256322257295463687912177650075591804171784213347857982987676526086206079058086603380672/652098969721742260715740579604058820922290864333186367344934171864816440715365502882591982982689395629325252710533957775485604967086303964781,1754556627909965665526203049766467623632099961559006124682801803983462024061619236061356744517185784877331213338901567933872759911821011508144/283540348677543490292119327809274383121978977483791619328278646135147906662952312757400734010985404827159397423941186085203739094373392710359,118788084880248476224719340807953852388885330113050058142088368959244324299422704375836734451412804513028011810709530051533764669628182630117/26688801798860863588239496808076504362515491929974059395296317104092062190217538219926993167098887087822512308914997174393033926142870715536,51007318689894296844748693154176637589399168127031777543541625996314785167239221820693758604892004150841857142596787001754577376067856148793/1433658347707831469426197791781646975739307337837704523284182659721473705017461095420180301390581277020834794098350358491247184369492704142,103789657401610626296493758315268378899620665836285867238442563255960671569305370991940724520050073642202504019928660433806004719974898652632/99644340945338954078522855563944670016200284922927886886073222058699983325284315456494104468000747588662256135965241773346804536610921467513,1733125909396768903234768236560164433239452484886243294309976770017984273684621188779441942621877556675020758834386459530501487666489164194504/1862588446125032641902154449785948948980366200191817112096766624658744083474644804982676241102864387716701131344221131138020620526019021389859,1677774002800249560882039183735777176780006942173720107465460725676288588892254261471132639387966220506260510997687413271367427336399010161437/830037780568748221324735537650929738350648497264042182264528850317467175682285570938219578594859280182170403106807233994044612855127467259419,6834142571832496679714758270506312209996514511841680215832432366268461158400279235944486055519755477389170525978338686585260386137650149371448/2546706658883938920260371387135305401019131567951541754981111917914408019160754208775175559614413020028332750969689991899533511499309976573247,2911996438498598311314255917935764678514685408089690466356122901739256438668693585156152777490588632063031047186716197662847869506708967603188/613213588379178751092587237656138430105936780162389177866076854012021398116154707694602831298224578243488535115590216065706544520257088245315,565459908157821042649860000556595036452335840496298957676348314003374003795558539279647886960845819245983583736090021834648214492965921003996/193387802457038543603183450058141971952084532126151948239903319355461494692645385862067584181321685859892827499429638866568113341974935703421,-414944502987810838335744556303478141303847828182216404788889660938381973979715882781528781376562085539467422053331927678440875957660215588138/548695753922304998037351043125233685102371418512368258025856226172877171523509574825412898858711505167404660832347548794951168596757414906309,-3046143882404121401141527874836954471923895271183277022419573346563146767877954350428715073564030611531912859870759903900047609894253055677434/430547204031677809338231651452831827313801204333814459982631206669811724295737785629675609668690743602817538377939132069620608851505583767789,-278725000517281075274732429929801125833099587576494502922883031151318733294703026822498883457624860043112600739139952628760704982749555667172970/68182756561762683630871393175522586285946306477518697284651771077459226991606078262485713700854557339513616097183519601402941821439381717526917,-283229231682532086311438100881700146408201534642540347201442885997445833601231134630422097345544779170966168524079799985410381374657303135058/186453735135157833036483996028166623471978044510174373990686607599510269385578310946970660722924270182207802487560035672764277908622619759001,-77204811976381002305147078989295876693646207142137638819339227292430151180136551574092630290994611626811279913399244850824647299932941863706/239670166030450448725083698766879872126583030167405098337799395500379972130543068898772469197907928823720274811917165506084273860310771772557,-29013616039977356340940662987007051727476725075415671450831768720658451617970617498003792471822884611567862250604191331915600273977178044434/4133840663057819500860875410444931322877488181149665732410847145754675462862544168505989206049028771894172201443850221450753304085116072545,-62172443542528166679044447791375691325426679793775321800279051678334309127864848778371603185403478935889658357006894322872389537654540258046/75603555735677041498359932405163424033735605053271926430012540313577702899719403308318437592896609983904575656310382444028858236958579713001,-4615458124118467977887628370830726548610433437652699432908492918461841031649323899715424240471397088986562726878348788776023965358352885938566/288872267134479027866985296019019743240803659514308700203500742956498324001323349033555526577890450069026441530135809114929579121841070347243,-13642103812046335536208481410157954481579368624279424113161155926502709509708256287760389450987400646477715620892167239056314164400308686683/21538825165499090060730127316860232914051335857344992440563215233482755881250954574167803505636987830290162528265799230928833125380317762775,-19350876397950320778475452855474216816930672799669369380649347951374970538703511921327808863903602784134477372121106583392476088360866898622706/16441086846981442169038194984584401883259855034971147640783354636665833909064697931785970875845526415488435322732422178739169254814180418856641,16540890168342528727758269739844248860184368822583092867664333697204571024369715539986735978430667051049837541066878258144370799981979758953/64747527128004377273141941422588502315746075486883846330910627875587403121696845274484364918305938233769568918458523370354633315702923766012,-3581277095361781664445619631159455937613282573281955908083062897710302159066521142952710966016662244903856610534477840751346127210016347025/9316047705260071463249805151821010112332530106336567330374502730572852378593659573836347529737742100951222185791811151831462669743942457421,-4981722336794839066831722017217139951545683899523876631435859686715148821064420115840801820460144758564833771670469287969663079922008344711/6511784333095150623914098957329803731490041511065471703027614982383208091930218860919830601806250500876615935588712325886568751924344536011,-78157623569514973789192043216288329318997075397648594806681948547963804614786571041991954844111189597590945303140391527884741510387161093872/9355241871120627115987430571297997100725812453011028518873503403205488670807045320000781020183402194642887696529388420599012562952821912379,-117676417987752102921860842355638617950367946729200189707870283712002842358255433233903437930342288351980220654107622511182229679597916434046/21932875549471277414777579974837541909439710531928422538833398332161739076035583781880470890289846655098635193518975122663303425183804354471,-41458391250855887245712249461351569666496202873139035889620698604893986727374616360689754771520987205078688999958506958650579015474652465993398/3231223613210954795972786819746626950767604460364409117906379035693543101692419253517772578314602593650078472993331918793118245208544358130979,-159461794156476929275657651741157759495949094393876733458717159676983949522770485739949589701390542754581189218009963413838699992992582962800826/28982591042698215872332276208397567567248780848672630440654949325605154837844954913006569757997337843088904114738152723331640181054739884469159,-384581743357998997165997765760108487386036725354820166547646483134773532853624817168448817531067521903376468780331191477468631721142205831/426619007759137938044922774377029452136781936022949233715901225545015122762766027590207690068498859268866220981099196198627559915260688626,-1144121565137747668022522749865823039905870939670094803225504439300409135235609981742897966814252861548490093431850944429082315391174037358/4260703708774455880526244117937853890690218583957765574829125779560668508041487895551251502024242467605839934115113239393694204456129287643,-2949841900227034605235989123294238777270739570090929098009266509037362749302365597104241966032040509667641783979450258316411581975164857622/244433852760018287972424768685601715861544045123156683130720765771199126104359160938258972760873807849637521591315023304020056749974819749,-41361316556305593901735151365701691471035608088548777393633750310862137279058376171459576867275051226804221339891467289910208865671922888830/2466033954905447665380463591518463457002455690090563074294324708533761484698247915232797002086051701326193154511204978601900767128336878359,-2938779175419603350404394142617861003753471089508920340344227906036407515707438517606306900307612633862712480951705130228545151696983042894410/883613809145846494089882823507740517916961167173816833361671211122119445565000524315073066253741857691779043809568592585176248305775701376141,-2108499016380796353766340719316542729474306519471863201115367566016096725543492016417105364060488239446729700423247575610733245088275374123522/103702794207012537045873214231335829617693249959556442351408647381074096406031530406053411843269275651610201145873294155949090856963425158733,-344284368523047836408193416910704758045933439786228757893552811055169119713957963538027130024348706955724058477129678654475359047394557262123/1649102737604563852404804268149909493346167103295026271575209121870918126325116032528835184267851170135809290868288162876906002449543422023,-881023052255477673490286462655488423710091552784994560940183964086822515382545685089081155952512850790096753686595070198583911719448176861042/22883814529449099627323140963783938398644967956453231430265442123637212402202216534912325039308982983802355439481018150200712956474322509755,-4755493494477786085865006425780016503360040534836382511088038278901395774307696079971823939384655560626761286365330402276887077470438671476658/292444207488246373647849181291660081254980302886934029170857362885676282899348860258775317778386155056100567757250576311138808638686862496719,-249619794008876536008117670878662020499630193584079896936060180211261286199713963960848859705646643183283315744906512345500003069885075027630886/93644637904934545493082370400563719416613871012042306030029472012096029080795648512248283589897970658903567407700420962110649743087329945864507,-673830767034722842581489056103908546070997338760390643584353214051166198243511686853309388056115510641036037207812485993330006682144915265060674/163499272960999630476453856336368546130528792894446424476446519575838176999802228408716960546934493845003088587498560655638228795715949909433285,-238308462806349458061284914671763381291986817673733794859722292645220002045078329664233971610391517441471245065854635997429479717343451049134734/24897098087090423224956764180292769484706564623004057304574009312398001737628716454108647495020234158068532968555553999775303111741459757719295,-19654947501375360302792890667282930273389876991171979869890145530648857160856469860204120869467639555573430187696712328855586353663172269445982/1257334182359830307506655898794727263658277115987887520761209713099221628788656019728814653807724559138063381373665799468065708883390255719065,14995237506796128730853118238434177989438749531185560932748645486104420648320257277806485759201511195270141057600104393430298170124665229095160/22711451942361541131790605428299638982504349928138465227115376149048695973829531785510133154262148714754985588501545851255700762812203440936321,1605169126878150191278869785422848114821712609706040505968261247599013044103907483838759716055153160284010549300849325527638705680929922041578/1542378086466228799555342896617943276600374816494216264419120363920863440029487155049813551175682397039694300469915201568156284394411076465869,110179943904450344339462039527094972786610895070470348062207971785230143880882995921675276619252180248763760651304730042839131581149201890898/61335065801521545103302967141739334200720741396631759401908143829413472595343053788654554271721205331339801199939161148031463377926027489451,139305082541307812701237691330132266361483220230057669017431944657870994854054132743378036525648319364944040111828816838576417504876672803321/5724365813929205747376141565513479613851850277766071284849729504281960400736774723618628978790545527202436952040983176618094182240952909152,1615170381306924558192114364763095183210145395299405994250670259351202518954948798503923101665042598717405851757679451103661966618854421150723/189213168258352052040318253477922245146372114639586192236438688922443424864286675314220360885289360404187303364684125046932106934008381758496,41908063769411195952202535640318095871596535449779707200124977655796852514272793477870403347107098389383521286311442065657606096328351060109/9420791858131460068754706136792448414687357279048952307302499550662688292907764014606457298083070985601258853647349053739977878819500556768,26985989677670076531367686637645575694810531721384902435113668965075422112877293486103501850295623059931683494001039176054515253583920263253/3387755973584602633943582486105061581956461069788568122839521112487202486925422576195081325109358057113046466137550583262026981171005908256,7571432321322287072630019228896949058050546604018071397109359334267877112788968694172075326401467810194632021223875784799757918978464224013358/1250093810958126053653459845747442279164072256503541448323615664087823630841597755560582443679737455174891238528251292280710846393537007497319,2172946444979190560614394838169482049960688396727622077579103885509766172384136193741315564655613921017015651420948258074925902900934585809497/670220953317105183203030662351833096146383053998415177132134017837778458874560408273106745215010636443171178518041580565757219032228077348440,65524621316771368241502436110373546891795621726616747836945069945061716919112508490401851337918211733124569147756460850009615452314013646585091/20316559101214672756730357009462887484648903895186628656882649080741527568929054461737449880312501904540041688499706797901705318366607936651264,959345894855470487953959081260628283115898650670709721645205359337218738850511628008578608533731575879276843998583964644859277525912964223211/249840982001224738211025728216243760728949720014860750787974780424817742776156820852081925621796410124006649645275961956315351741997440253536,715716737977212998825218686095485358800344602319805772590605931645143687085936732435276439046494127343501852035008968829584581469838887083655/61264789134812564917110090901745734867127543212586937624565946207136766995459514395309419206743511266046462288019946717458585312943240044038,1684697715306230796521698466392980323675617758852354104012880084335446824373258826751050009234030288778487718301872361627607046998459882027265/13505085340493550400116157605942135494821486451753605401633540761566254406509017396178299936561678340610150337183547190053216190350873961468,254359917357053694855687660539053441440554778737840808139031954113618678001121695555158230044516999743738350756865119723247699863200669699401/67819854012736906708354337937702379676374143784869386694601801169630581715660772824159644493058234974869156531277568434214323427989388917448,2133347088069803748140512436144234964905548133613460612646192497488093501464134955356245670161119771946471055559063027397243636581958232176867/92324352906535048807668108616672940819727477762871759062198241466218537622834619486035859091401583709471294964456663372867284742093083450966,161975368671439098087373888685398178896180622482491895069635118452413651908815958453795452434216481927110350622096552275786769127966464531940/5638350020893864580480604142790258652696706201472184279333708281730433887494280418139850130258989772875302257928585829283806491333036972843,259365325315173451712802168945223593198643311067300438531342917841995943121418295228849482537458429219030017622179516231052329858554915003317/5578356791176329105476733669116150809958078989393124507950929225881343026643440318092873638039444037449139372419138088476645818607638709342,2722380060600290834194814948504445023947264136893797580933635154154408427098290011674266807664378899311031676713859482418967554834496721871769/100511763843035647204924217746227313014334285707123918692914040581258552770790864326607736278783681291069483732132401620059565184211802527342,171625056024747690232930344423538287371791825921364034374263390505444380420465707805996761051130364330313557173369994322902452705044642592767/14173695235458953962258933611842607738237244768421367485262346304518123003490775503538190830487032308033820145938673449415183779664197609556,2992045841146547707236000312020684683127424742645257470729900536941951647603769636168114341311652068787469319544633184626062335604967906773193/278225599936585335163229425236302361747940953170769741921510905201052769098213205396387341432834132790179141404817036462639908152228614959072,13988258182586814657880441935013214716647804494835077868093792586087819920152406811426109207329999104003014898392376711969540689050467302568963/1527790137362288441739339480548125072915549392490956570954386589178298270347213956288401361188518259578739330902856720287907261062999484431264,2232853889585343183542002306315863247307117914016446255335901382820342091131298877330300929276062833032528212144635323905095329900471748553791/261192701436705487195100464346166199328483616286321595984600248137924930966009108938543856620503775249361739131931041138560839653841352169544,7300237144730910353779256298862290672312400209237894127568048389427543655022425702953220729755183860941660840440581004725303719851015600425/1624102589581450034714043260859341291632626205048931106797377776688134408617461179395571176050211045889590969600441765547685940449182303534,16784855194199608159034410070362410617926518558740484654221560689356606231836894676042449709713381804104692495811792837544651844732139470434395/3127927438543320055406777209670717680034192926598304560057004489818360515156218893137809243031505749579845538587815409533839360900989199540352,9629372278112825939767780185435900597393999828679495368116481347971501971798087014330246757085576487688095861008528756461484225070296561402167/4676223950557269874009911708900623743527956030976183516602755608807901099417354355063924109912095114182794621452523770457543363440203376625664,20189316747200197987487685718935182573483577391904568019855193037329760799943345550095802776787077266598236645714013372625250999560223539203617/4804785901448755966323386233553755364472130857159166069572973307755913149974224481890317921805900192055446050976485286913085324377037761508032,2159349934585506806552414573707783820269522954391022451350767934918738819446790881150933849798867745932283720747793494865292266037557644911889/195483015231020885323292903644599203329842911672857741781265598928330088153868265317445996232336351824573490730804662876215695045093574440028,183387557209980552149470389095142594568794179845977439647362023526336327923536418415233839401639162717443870759639173293780183693177320661481/56276059300563670134763265083451846267477619443130688586691640980620155803195342825281847808514926031890408623690470732386777788731809878802,143049637207520452201805560926641936086245193773056493038537768824610572159494156840458238652108667424593680687227110020085145235210263835444/29902697275123712705968849879836622895522042923282141035101946046120767546325567050945331777353201163118381441771207577433880733815256756169,40395653094972931547631699354167846939875778706283210154501213125636928231385184573846359054611189736885720473676123774385813054652234502057/7904946254332849720336247789014355246837049127701874062590439504452460235406940895849157116801458577257392277827497160961760644181607296999,4305303219098812208822253950579950806245715267662315653992271332060324033284752400572228028793972906789210952450273439722919970433626950468523/402693028625298768483552341797035641909888384266316385802526615846048815723965680623962458663118726257151458956400064927328081121624114008280,11322770302481987689090019700828237056878842294797024711323545265262147908431738327932519324731293305585972176815541454701144742835784436320649/2171310460293942679342626650485790073637656765702135770724913343621486636595009060176343685829616966121116815391271430545147131959535820429152,534677820531917703793147771594119453261008186838006768642690107785566440245318118888276279505042960140782872071293367583026562759865559279554/142184979176705908308674085381625767542048775699131151601878359079117392065910555736096282576581401307721742022439548826232862492631143445503,1442142614616286813522256537432189877762903267918493418532183648577172960722538221150227149767305146938461677129679411576513203700388283359211/24887063601057367585131141903179484450924418693284553062556995527782884738207031773454448898976738768326864497726825901417232373267976675824,1369812649163038047923089943620268705144346547684223796636025338798941225113188098307503413742353973015943728764164546167863264262436902005961/52273995730920395891444259076676095513343898784754622747375244564286798561895014509981068058688069606329593310706227065324067208762064150076,166516903504343829505787416311202851077547335920178732913309153228999375261633317499009476349461492422952213319952774644571553795375008256887/11817755550053583247477774325715976696933877810707540057673600645832004910659159118243824424012420784346180106018219592411649895805374691776,361484401380488972061046008441438028570096560083194030616927273770432003907081564170845166553041474831657479177498742871257325966911696914161/243552837726928861886072372780792008448642118440866510216379034304521115485805492915193427233060476930754799676244049425621665238615093412900,16096967223762748566027128570713575555811371932789469384796360615887813014678535084361691374727210028097919301627571783275139828689919717341/24685547946676583143508174505401867943753936327354041965432291608569569881330910651551008549353417352891352430011474320540278926508071178724,86549520100847804384998839109910692559126739399441866401858001665675571105908361003907098394755227430175364507055230497554753514669755404579/104689677029804319554250145510927779657888706036825097813373675205875812994925654996671300871955878701017951730714957790621475121764206332699,1918604347922375285583261383147772135283464119317651299137735730338567883583963142690221793103931274483282182014567441572705534842894186386284/113160817941882096689157475447887727290029980813826805816774632475385896242751959562055505748411047243133731624499694985236496622459017289101,16077079355718930699939247890282739661335415904227558204211415830457549515464360773460472207273217934029986736470553471222288376852123625804/2685723392439678390790195875887800110205536912978771817299619755944688980502130953634039248665743219842580202205871361611915812013008631451,68065783366048046657124693571514405334033156112426414056027419567363619128860351679376288824872767189195771872517270589412076024147212616365/20566855959804491789721777419181454810466237282767923087692459446508898672474998950284559657280371218103126596676929565227280336895849199492,495798408090754349112228469094269343445702461566983104129512470441057313062116692312695047273750764609163557426695213951293753044483767726931/189045654173796493383891582907628363612466075925421134709921846853191350111789672591238580278327132619028449556503324770941654076649767411358,919924157207144758234805823116928158882858432553249744553616200683349456667452175811394171123010597185692751297129666558128663930626477945478/200813611677138918251645022944745022104000582327883984778396377759012771110569760636141137061942703820023831746211188345713529564828143827889,9910768070851649450415980992322057369721775875628246147823175663433697285841547523452208007204432735313706505262676229848039626583410659128794/3730493620042672056369428294340509448825996094076953911221218367997751368024256405030843436608263707798279602617869337795019349048802881287655,1348569940430902545652256866153821396416295409672713244790244508917974350263749108098615432066237651877686743664498403263325439712172735097506/745113043811863553099182300896533744026631234175693902077649288151557604719559979602232505449170567717834443026181862340394594192251240079917,588017325853989686325311207590772371594708148734856994861974779200321567563092185468961358565273318753407528993219807679087769744086434510026/561216593099092631572988554992881769964629715771971622836825031036315607149021831944952564349649370283458089727045263401019441638455056953741,-3963394114316028793463084507785394013994673994780069425113108032711643148108825496171509423346483903184120576307916863801114319166022984418/156081454999529880675553281864954474546952358796802071988943762853421795809891393574882003227227259252663804091051134286750994213723690119,361307182128160937719957661139366295944410505699130292546849225633010476872620344484229341225080879335588247871429942824467020151511679221228/479258841420642458499977089612639001038769314883975204850498244721568006326509963043084834105340748167962658394262232275858360724323855480707,64999550525121880208839360628658733514361912047539203649096515687070550502791791761778686880399521711557172300294505171356818044322081536809/80183088302054804301475709703667966851094845040781572148010923623581518092153451640543867757512083605553265690345977306182540915044459234613,114906551428660902222350512160827549906534344829344591244084131627332719917759924890378248466633330778245608704640862063698764277288426898626/346432646829249059545403344932933036335132682978860039970834259483144534191505436963050710133653762224055587751577198257813892855347005972073,225050235308919593494131563223755455094407726120959375661523372564613340384810993567746426296166949524707929585223293807545535546656732720938/791044204649189080096383196305126861805767716103555782691993467807240074520471797776442868405743201625116179481051331227725972920174795788029,109070362197068188143523067186082395188532676613708658925046923672335313932770252019347177587913686105721692423364522869190564999391432238893/3401257741632475577135301383945161184158412663552420204305850715801341894638643923769353222553318949418317473637286949214697388877546192065,192944327601635482461362937118085498724649191258408297906842351762579894921863247621211071987440583229036424335959552292846379470811109813024/55927884778438800486566143513775262980375533474865242554518291430725274625478686602809638786085336946884300335197226050769209279444580079019,31681203389852726984056934049481749259834363690694686610688397295209817069822438473030118011713855246093200028570266348936798076247845710872/60289247324640443215845880106220303180215548955263738954312289340824468106005162034309238568913235279526132724661017894487025823399744674577,560219731951936121783071845990861508568221376003838238835769563779449817175254702964204231998343053683466622934825111562412734605193172380971/162106421300877867795528459586540054199445529831079379701720443494164479687163905784572407024183056975422736616686305208034327019441536923960,1529651650455440994736531576142060702136614126074317013957600298830151041398601197633826168406370023968520532130835671555668222303901986476463/2031689876365743760335910648342793375326146748968989916715353260737311521001361149928158816937432061025351148129384926629500593367321587702848,-4253692496281264740311458840870028340998655930202573714358563345070060144490981355518618543935616820442772074451567657480109164712129900963749/1036824613926519505639499739794897123028816928773497713044787598799606073723862812046696151373445183045443927431528835991225739801816640343500,-63598436104602019165566090981108694584315688380484298834112905116152691044445398689734273641618587185481714511553420994509761839193331138392657/75353263714678417760643330800353655025377287135151190163658110549944856204600732281106349727867375188730300162319415358545333761772837321744560,-54515920146448899746065662236067332595551282381600392718818736180343766142806159217973021593655804830631263835467035116158326702890245612846325/42239471579535051934263071424464590462017036891002023240269600946563005008976119222296138334775117195661112439809335123288328171754912310427232,-2968900092512202689135119422103524356725319823730472216921583087132910504276523644594041482050461525934088061441695087423587788776951159870631/364938707773382864345467605997164124044878713112189153494651686338489095919609401430644156256815584551999624096787043681381594831621613995090,-5739657490800393317057510092069980477587805273198413844028699466834193526651537189500930743148992768638441832837001932280767831399283644713403/4901036388386452072470033253307255828445269324175570676089147444169511528360624451142541230402810964047894559112199610928862495348959741296832,-25453243535655062738864492888619957607336098684484492209681830460620003537073836186436000919023421491328560989285168542172090020279552737886099/37670364821389938468794069039044942954629715474864193446060637651365161303162796822239897366324759425413885123623676260041665486342361308172160,1843538355211144410156763413868106815639506154621629940405340880262737989233136319928755559896184263113249567979206000701713058790558636655121/87101337523181480480984778737288884409123495309691756592496270701145319178847823966392548259639099028832431448187647514851403825343088004160,-45592743546908083352431098072132655779746931835286279824257792389425429491609520555863619119162505178761589020583224501500184560753136870537/47947045442958646631814412804532739447914446262664625926546638100729971979728900008744883705132750921198541593134302874066465093647364682138,-5547237701086459282330887391214606422075754195526813782162465456271904109887426302276071186633224865921818296432899154796166030009514617124351/702659009311022096845592067824232995433853208681007777239262272235898600261472542090896870519980499511629693694582068540483455988833265232280,-25143853914262206186084379319295134327351621010711881635892847339118953706447717831574069292916159920685963911553671430576515015931473426837/10919081748712364838591786855712463674245409584989828693298596456877777670468972040047338088660735254856508683447969345419531717305437817488,-1487165950470435356020185663845940648885355189325746374321876035753419507449374121971625647816169029799270376552560260947779861558770993642153/2829303109647316616395949422939561125510839638531641150895220335646582251906320389898815130624937646973561662167359763941586994825300733297216,-674602914631896418758080356385687489368634603563652380932024733328754059811270823255762553293426333111887464384527506252250563173412422118867/1081647504947038876906956059834547830942548366785082304883314623334255228491876611918255838736738535203868180169832685627384450627061138118072,-102340544098031338395638561449729937825856658422047920558074309598396761411355439950523094763831519053413900079045677625998418208471415607482/194096994751363794723450704420938205892924173036643697860913944290370891195481581632072586572635962240162927602302058142813829342696164228377,-12040954659908418801246445358888686967861149167855301665554811394049024305357434655433605374412956184701664766279492793561599517949577842013/26455126381698158801393029494150802520832940703867573091500726828113900941822320778052356723466468222910485607380448115082228181969772796238,-22634484089169499228831615907855773454600420877892236906352268429774510057886231810139524918482097537869162477951741068267594932139022692721/43540747130196634587227609774884026297932345545063578974987397852392194847598846864491294341904957560408521689917737211930023803394977378636,-72029636535961431013051943228152257478231698351324218220915677993431891180966153560337732582226168793275813687066595796475568639442810764639/247863051472490185955604379274936059785540996804754039152672383150311876399264183434839595358201614700963006833690679005312012643359549095530,-399215467371562600275745581337917660203032927652751803845489318867923457865734965841693807715576050320261415869135992394175356702352489453133/1018038002913344419934419915916774169945165418904970961165875974456297720717220981865873049288559772383290556246459187334113205675425403324596,-32390841018498249513726808327744966581845710498527886998363416062469689584416096322401897583294777968478662566612376134036978132576338495699/49054669804380279249512555399085636214409596337463847200100966728404286910718531269242742925667816317267891783312871130153433691723659117434,-149134524832366531955289708318266189423604747657412727534644819859319157178229419742095737396329198347470374441934710979103363019218017452277/534802824881664117761337715745557858523680938309182575642059511174347318341999224359640898265164055700504925232669030258165797320708010227922,-64223159487739459728534919714836258894428018392650162837160283745485922092863899338647251032551938733826864785546446351372773976844430071439/157982390996735113396274437291316183267627634774612022734776972787817203720064578035416659964403977753966534745930673249386621444106368584348,-29792879521400885793998919636724572724255907639412640607610749720561989586086101054321326756254812242852153023770500855564908290020021520567/64740819705823110464788269971213825302949880820852754807070203679702111022343025988308169818696989401044992248667446013074408117188090603190,-401725956493155128358723919163033426366172066251139937769361734009982579981708012374150555234935182364898094397036335707119651148492469207683/732617862220900115495377909655178231961231921130840120450834085516157401635292874753902075572006642222392488564037210228965556542873261710544,340790579896061013657333800195658209643932503457361040180074706489275131615472598162859878412383481272468358566730228611693678443517832814083/786048667791907548269603545119449707286733458146017941679417423725454114184002881458008821838355162067628631429898060447416094432115227471552,-717479066037559691283138592875608946249000415999647451207857372955168108616737783685484364660972035035455620707533103316487892500140782156307/1711257989678698167610659667453401617166863944392795106932020553002669050230096803268688063513360642664604113974083850062206189905502209113724,-703387715100856701989477120496317530059616297782679421686950180151353205414123439267515097640130432612956522233193290422056390791303899479117/463746806126313356472411358845144748524006059972778442447785331297043404611163058912977709940209704160414487140250752765930499046376945958988,-1037796591422460794838501867726978777965003404093436848384416431107724135288898198476687950614697391695597384362597187992658165418478330153657/654287896989608997335437352686141556627882824112920956389030398304001372241862668083919021638162836213226720607644183417116932692204209017820,-4062635989006155083259158129636067116994863094326968304204621186659633807151666049210513238625226867541689992814125301213313258275372816048571/1310521158104161060822868102036753614828107065433132704321949396809620969162598369910377342701117860511124846432350552641862549193572095229776,-8094240320973008006988321267240130208276268952703257356317761768185823160639933743667610750126388493132305798319500023587445851296871180078897/4703946402374543974811864558151299901575020249419087743660031006542055463300973392742998238281092686624954441724400146711461896238945368252384,-237059350709656478000727492522928624793758242896936025819380651631575537074610121124883910408747051560071744070764614348364053757856156859892/149405272856945465303901846136052121371276378599249483293569937201098602561893780182573478827902041239781243263727677445847446744314797702445,-1803232324347114373115763950326593537496477271761686008624028753207165851499024186600406989459579805141362024232258933845620700443464487987791/1275560536448400709044646496466837180573433916837045625868258443180272233398939715625861922364319038587148839070611219159916369903032624804624,-222992326184652077712282649863418921460262413823789514162091715469300840529865110236987396715533481813597923908065131325351886959169131764843/413330479385626292354638179985608845880094007815079543891981911744036301600709576924241390834162107702061885226678877973065312734975433158296,-277616396530370691883526154531198545923902973731105390228349690935129505924312254437418518803711286140962477657936640615911602209621086246109/549524394996967913499900700350206035520218146478839581950397458692216171822759745306785013504856438459693877969319249945149695636772847711044,-64583773692127802563493642112375666928014949965852709665350338464925028349543409083365155758169362647030911807426851357668742660904993402107/121505085238454631873985341297990491451946911187596156682888816006050265863639446050893899310632797629683419277593897600774280918082390254956,653379164840706566730930960825632149366491786194500757918151184719618583563786730814083912271632209526054005638919481666978966990239957618875/189035811696056753677670921259190025797630573222576792577295733387872547093507436884652491582824161336726678110281017729956941076657846760444,-2238807102587498340506594667578039003628395301091324608684865925921306070703979558150893747518455307042473891476850726136287328242513571337302/333934679547294386041991811260647326294049116309434808657981264687286869081511424896990805827258791575290795228616232883543440725184408776389,-1355178200201414192445649566250443167724975943449719077674285283883521958680571503367593193584136731416404540771879300367980725163867368244385/680685210728174651373635742544845037887408532478612818600571793862618548257640105705408518488257924982320791054463841457485205014976356332476,21008920663815966440268154696717216268080895342726871645902347614358077142442720051759095428706692880676001537491533649781911939612529505716/17157043263895333453817775432814329731470391515422481756740498727810573778341374140683817917321507062418299675125107109173684245869347867411,40004488727865952521883478210825636889330124568665353659063615750954602515745710123230793747260640817457687274940518638457240300620722851307/60199527044604001387169052007885120858380027046385964453956514778960062075112380713235166202401434374687334949876743803910668443308591144484,20589232231088967937600313198176020180936592640061264948089731188205214314759429137041510066313973665421688512893493724765581005454981725736709/13647646589143789927659578301840036905186537319934685699644990502555209180319674070369395817730997846433447347247810588930997933233301370088032,430690366597318108522525304674006500973059058930926382956315988129917581170216009546023563845146021366426251382445736627608880862930471553309/313675300546435678725916616500900598976570520796637279486618738353808987291800236242387682084354917222264221168369952409715699756349421306580,10188016024860311798994849873190464168158145817705239604639485596662863652681864814301068318674625280946782252879896130413241263837575480525679/7510000034426579312523745731092473620211138326037696773489901486805036484020511284290315442073271594517477627331056674667715773219566258804192,892234175248680040647285766178172937335981693402387602335994166099696162373809980416161135897808960880326570887676291594691009371687163585642/648788569216819935549553400108130032565871135408700363041920178702948535371584102914533729241587703777309686414684898871644523572715743537461,3684828397860627139666382208137956028614460155387352019192873710457954899553894603266125352766517549474284933939382078252813651035399943901933/1259673205683991850142669672185995477328721951790741603548194748262726661919258359215350120812281322292384412854896389917425750906902011374308,8757628976359032337998456872018690531992460046437314399681412285187178840233309798237267403203540714186944734412525993856800199726884560656/6883098764185130369571118862040337209194021928153126956272127996084672918378791101275498056649535976354537037254526959517611191603023710111,166165870522482903997809890087417575833438197510404021070361697344801356418468456499159389042997529222382254318499971012438401699060908463434/119891863401833908294163326806428909043500759167302075879818975169987727267308345622324412772485128521124324677626903379190546232939571622877,509547405068969575685601636462652533856359791377062034939560573172031547172728488745292500970104037259790255475028873038304627393746105639085/380853519352765556949846258336831129150626163258121888431773133677770366262079484142018582626215441640141831244495846741122178396367282476768,118272921717179951534811219565718495947362013537543411537195137340232705167965003998485692963198176962563756024483155990230190304632646798389/88573782817177268175655311954081300854935568195237401188560557280074354612815879786448499266430791043793981885201386119374433187914280874344,62841012879998338657560573102087238488276019768155638320608375095514629237822352605874148277108926086605473000565698230154529456949624385004/49087218665684036809476406565227173621471310154418684611146816393760223504809826281474537147338088179377159846875538292278378599766242885559,4212352465903069580499957394729221704501307809656945204334052958162090843694208530830533036210350898391763593614384251601965801186387974602200/3544903597810201666748325841929782833604739059971119173159336373773490435203407187621352579830708910740416125127058997702605641984452026518507,1025807946587235429474877751613240706891188154040651059451505428774520375888489182570297249405658398724007775075203204568003008495696141124762/742239544357532089490360991714071661479844077576117367969314334580915630267788453142082744733472300344615033936031482749037689863859647403797,-1672315900510973485700608950121443664860267827748872213720481936285798887483828105410872983117561983396117920470448108294176032358552435597/209402724583759695644858866955693072995956243439218687751507110213344388985279384754966570419501952922656161338596883469367523310189969935,-714116070717878072642694823157752909262204282896396441476366454888122468265963365650986062868956747390706868702381111405693425102979342072251/102615992876108605272693082441341427189322929349862840096420881282075071819719140948218218002889051292122612163191205680083247130081591128003,-492908471024849557076591736911018630809815869150454739853108328376985437554694463017803626116329687299984564975220223230560293475778240408590/25926927521372402652899240149264081304593792259654838153038638883108392648108827265647493784259669650717908045977837748855764597022154422053,-20075874871129417751928190248554607734524440042276940090290530686833046107019744280761648855217228184017978656462859371016355612362888976578/3388550417743240459275377043176282520830627471698596869201841896766174626663887667298645031693486001508494974957807185629278537244863304105,-27474149469889908479844290214540671500495698841338674993083829295781987242330310458569935738119331889113298642140892868885570702130408157428/5417340949372164563200696524187719385427022772572619586896196308306507424774727003350201151121125055409407159878706227332486845809865129699,-215892735350689059770805054461277624607879357475331636349754652142286847370927612793481081225393314890242833436860156959991480948209010662007/43065231448204818421704699134220768142612728769928872223652723446044790899732988555781585699933319692879164016210713757981417703249247995154,-6229806237639325989433051648756211320195649315117635533611079837639219139812004186912494036659524352702744657788829381479304394026159935812446/17619778737164895610323815640041719132918049851605522125630903998489805328577983513672507043358054204831822204005499146866870597313453414807283,-428472779738406577446324904097824179183381182011435517097834758510726774407127809678995848609117423250225731620743175310842800624458268989431/2397365886990677939758445511029662093541485480883910199119164107742889326829354183114936256943809076190831907192565893631150137118922322812163,-20058589488323923077763414419215733686140285786538355401766100916062277730112292865373930113032131121218429846529360955278617247944884266556806/46042709317561406447189263075635934470683513261594027070358659264706408535622036213539943150475438616738642251932382727018245535134658628150823,-687185503346210591159460807336971862483321048222542937849109204101422170271621651346699236583543204804115348484725285105592501766065227945443/1965664105896855019740828882507978934414853490542179292208493397751808591652303029340100248059678538489448028508255623259938107204738009737854,-53046711098420869363528043559696065851959721797407522555784207695313365519408270210759600789851324681071610673732186319663384009800371006185786/133228514373621738224792916716731154834209700946863416118852813562939796792400494685417787559072303808330844720814397846597366430379005023375993,4897025390615398185784473001543413302043423504178036668402651639158890581739302200582278252464578291558333788662066717853706271095776441182228/7278345203190068789196849460329597131961326230938833559940273226243731316968282487920383219367517803304846780087480774225066605006444378974973,-228261592005750048553461524355211033122558034044754771105301362849991335825326269263047971800185863653407611602041447277626422602656854333724/785932731318164322651275410867643699915105907459804602314251856434072146858024150392338831213434572601662192073060300828063334375180496933207,-12138137046463655949186073424507291660690904614115437631295701915256967030650677261488680803461753201963847368383249568791087121061942112348246/6233294102505206301394172796139780965144437895805670528368851054906598104439205521775515976508183276512527171397836998889852841023795351140587,6582403559906464459720685934313135564760424607272635479586260595984291989493759373565853726292986785128019175383872405913909570344045039310333/43437824128349037977879844304354268528999528636387970923427673155781991024767407989465164679174728877939138981546682154276653194959789855263701,-4271874692174206196620353259385650810964325930499994619475862109823668257089146668559226850417492362285142852974804897430249491317375141111241/3980434185262638194000474002719304689211326105978785832475958986638959931534330017088949207893797158146408468683302582743995062105632920910939,-987885796830617308893276215121691465714909195036687223074279835724490698935510041637862390637888579796023821509180471898402918299122699060691/122032792754996294780034447792892172732311150189211208179174952462227108223842035133484063845636531804589388415865876832398587904394579855807,3925528397653632818371798271180970642635120872184387176361592680073900101313011688278698670857141442237182411754032325621652227819724297420113/8368387444160524150558539284941823630429594401617123049852166985982380109206615354273142339556715304806277429257073359651645061027623420394963,129792850961760954111372278420326930973699019015106826213307812561939801662564726236143622936549229836497121104986095873354014403642676158953/2163574578854768313957460408524060496811466080240278777883316835343224678660585109672699776787901410326919713870984755185652022248991550022991,339081820780570411063310578656553978710965064150887681960666583147133575136920248360936002713963957096256721704228672085207365258792563149579/4293057086887179700330316333650809535803348690727018440337519614818280945855244440037501114581339852848317873884358721575248218421082669561513,1496596105737663638490947989776283726291581656744115499951791225485835532839390187367522240326124881365488020364728047326961489407658811143/78952236084540783716430957665713246408219787933567644437099900721893685569514084766113272105259984225428672254853226835027689500615392814821,-875331460855407852656372292024698600129303036518705185106874832735246866243196706941298567047659695604083706863842695278894123385762882291053/570097923813556358813807335631817495631216457372630551940735347878717651994387732814876655808441275142302871277984175597491957789155661465313,-3685928094281565910183915936774228840180323095080198199525785856190387331440798846997679235321693314082180912024856875694881332845987428127033/2517001692494869683157364248923569434483891843570013368425463676243775875271322594212528216812776569320819318230219049386400884759615722450751,14996858160616817787088231601653582688642464238315810215650323223703863334501722324961476748392535878316997084624305971067155747740176053681598/75988363023244815583398457661417392667995909704655961215589591637010608765707388448197935970618502909864172213751553811831475420323069580640071,52440149286393340675391313909965576534860727431563838694591565947212970315502102158985311503837673418723185278519780927167326955129421158232706/96938065962162996550969503125462017585634132378390791680219112024354973203992917044748710853465445260854470090254782711675125945563366284616673,-46064976994385864420492463260190654022407092787114814437462954309180533568824260264000884146679802146181612463895429985051364426131744691166778/628646355827126453272637643062087241540902076797972312304212264521062419520227863373868993220864044612830615394454647697844653777974757539513987,-5032835154646541613031330220637757612036452437790494577691322415594815588365967108898661582868021646503578879019514587389425510213706927807735/6012475408670280637025366710867819749271356826532201224688376591264494850616439635506688361202427993844691369710581661513615428852749399967776,-5667406781583471331598804377500049459402439984919831297842298962163464166574544430182379145979963631783605604452094859106242320030402123821275/5713320206599390688339150092151363937334504587938973331015892047285453964273869124124154721616870764352156416621228173879846176149165449149696,-9229288925284705671469499153271288061495402478600494403625506370859211744093561580640711527708506022600488185890725345854451435913457379980327/11909864037512430523458343627364664595878064990945398537858830385449949715607775372563181824472030455511424350901317076124665882884206718032896,-25334185084517019675190283643429231685019207614061010955710421474805998155703242133041800787382164735795188557107799971358024669757688995735733/27776942825587077183157040198751700252164817961871859023528599916421510308289412158519356510234152584679361732910315394432978319172764998921056,-57871944791270170167050188373907656338440536039381724004286382124789306493219447889497693071629425740672954550105559160594292004955260272240779/110586077404212232096704199328503976661607729775328971317499356932662160589897843542828623707689119784320505204426220130042603676054061762705312,-273443543310863770468585485638341900670308779657049699020723804288045983476213783209657856316672964801047221764041212815664489318910666490131162/90407723505933996199877893065451612655840355315146303639044194280703044763854479031060571642211944450477782236087536754595264923721354034740277,-6859446963009370035609122646048478794439479606417750928330510551490534876306633101423348482147659195601725470357205832375732531929179443682009/5017259321741376316683573790966381024011110236010568033251563845685087369281575760277877237326947853660501017846504068905730516438183408841995,-1332357399203733665496897120110363518058905343788602446967194491549237741344252570218716310471538845153577448767980403451794538114220889460795/563866120015405177567843606380120336437024880054436382935375427800270899621868516822736072408441483904452799391663401446020422235829995564032,-367991308235648863566532013552734096659388081686889236275039793293900407734476537025222379575704441190187069957524425718427429043379528127952/199928462687911630950395667413418188066270243630853023694025410418747972234643538012634062418428997201956272934440431990909622757359943045127,-1444302487120428194878402495049703963339429956555231108541320675071578112547486590413164767677204019738172952886404640709881422101089075718932/854254612688005411413183945985270792643875218394218727789815082160932671336671733263962173445167743832854840186015173782798251278645137613031,-629119886072333892706395789437506468276632597180192695245511662915589108302499525451105154969524615302930500760651042160680968340476734560389/421480479123742809104546962414601528996747882485726946211284318075754246631220857735955472526032184164535610257217099089034897021536709115263,490361878960595158097073879073638855678211803614828422470364351707189387593809017370831160090932549841291516128028300807449664931223249530262/560293473447986112674489180418474124756922364481137137365085814079631815101776291934195575299221767539564986778542829883576604227680173105577,605831379998175623114963030766125654517171523192088877406995613495108553812347771466640908346370516347356800828406015154340820076086667166264/654869703996949118543317493412373196232426032967288099576442358310316770437123158761133089179173242282854709146137335310578408152399397091379,837071960331801483116472589552809844381659283605156045219560635076475722212933795140554002896542778430003431195515474263696365732014538162371/1633128071477049342369052798446542449976349280981597009218002992154205933383585282849517438194740275770159199670061698742656141773827745212018,384551819963427668558971444750232039242799461833598851578011560869108690845216452976424415406128787545812992931704916891066372222623090934334/776973494290299742931703634854186322008582826220916696746277338764369088887931279320971332391086532597966489703585853158921831454729711057963,125492204980719456605637256998303582829162350935324765852199681309451938178519889785023989377282033486287040805580746877449808969556894327823/227346566265386676768721381935933601648391850747651054874117949195236838177711374751035600803669255628719012934260696648243756927906456007311,1307874202396067913390233856567277986609639596396063004531056359801921600650924637926807765783696640899026236267072372325029506177066152539405/2414618587068051913423366003041695206808017974756076008209767162996354562665575313767457041006505868118686527335494529042458489959917219987224,116765947369558447030480060067733550869531539297002018851292348414671685685655913132025794553791225635842006449255369956100607569194680551731/229031971962298852995202316006275093698441732906421291180203140572440681679268244327439029177390569822212793186965860964451743134922259541781,-14112800625398484194191062515485220059726907537818007348760902165090289456856146701296595513725778154356642247505506619992067851200837744243/111562101849302631324986940707384986245801001673850330124833870823385358300793981938852123761175994475055333838315816404430695055991518543359,-154083321813142380971020437431208675835814740199274262374416828022439336073451753130214350638210837857981766443376942583285897600237168475469/1108087477608722802351211624087172618216220049785250771062951163586239388805830122433298941165096993118792255589581511358332412615878040225786,-544919938474278554807545495112379218806835200258885090469929272436361014180303115934995658932339044784314563855834021633594940859798640542088/4922298853755594953916161366071634508447290492448519708062936398471843433334257016078045264365855683065274959405232632132955244922397549503197,-51540000338198877859220885247335138617506814314956363837319513069553713208502107638414306715442841927825885994438940086012398016543090281002/614377934133331434633487128706423709780896618977606727666036706262494391440728722656109549684278858906938504625246396641824486726867581578633,5502925353687286415242032293280711718258799233769967670799723167319740958115255584521529462540092340013057853478350338701862884791435497742/68952047823333485747468692306141085421537548000118909103461841609503187194261849969856521085197551279785146027928401789471141144854755444689,-118712579583402229479944414304784856173414993066314407550657989795085875486799154113869168643794365797796520548514300206490623055427634586358/797586384570400830793285132018516929380070686903847826487266821516249315933850365223579391777312798569977914673824532224228241154447355165059,-33760361816946266177454914921789457573730499197091047617583450821540727382225030885589187052034042259096671418292626796455885205274307727191/157015716291105497152675741514857779476606654172255508377266440009802437760165874759145592586700369623452512342133006811986254995344626773891,1836205985407054374798146515615470796249640948795377387179899730125992936613856732287252879358418589708559679876407370396662892870654758814372/9445960973966211872100816707258763195807196808898080313067306167086114069445547721816622646797710524604203300295346868903189805291615576204359,7580750486830952445937646954465308698806847566213250182161944744247802154525566460815714282111175939361532001672934230990311431455462890243/36731090972197854167135866115728465106377489088681127542716856874601095274380653423768947915682561078669666077163224270612441918644845821062,179539302880739556799887678972436670467704053829622643585900178189616985498382260937437022559002791421192528952504552471437666090360374358014/387659437566693610139642291573320194359513277892399711664998011058425070094603596841346619112839091515764788675319583247790019778792589859443,-4045984338956843145235686329268549770141270676149862927720992121321457513224575749664191269088301711075115541083534329551957492829163717807014/667987715025088965383070627860424715859438577382066923511951807872137972338758908064427488625486650354740896204919293509012831960956521774895,-9981465195216471306502086065120282302221558176536229803171273332133092809315341623394589708289766264237887968328133545530359827573548549972242/5220161908399906327705892812037224798804584204547470984924330108601972189611906872028863961222616009563016954576086958030960753700368238848239,-4687721980301290095520273240487324660436411067070022798972013927275036670764093334618878242977860456565145729895627167476722264316054420357142/1929806546986045334096120506069833793614238094654769891995110191818930566593378136191889708104170177610942786788355104612762108315920485127981,-87639345276089745614615544099169939617612678619882168356052007495328638563396304006967704296763776322165425199262611932085310224835114141335/196814369776500959477109150568510100720797992505248363226165318335208000848402390784547608763520117084432741638082636333427185398070466374234,-31137354542705943818436879733216356232460010827149683126340657314643342520221310000615491045311368719228485236600941659462764732961233218528/68400993462952804431553552776968436885175838631539277990873501762457416748268824110361501239442895977686724263344438495972015752561154719107,-40116638431965722722124170632082488062862839805403261277980268340661674600599746115265733992059867545357515165900350870269828604752188492596/89289677985718789440498334130035562911254168286656065166898656287569527812572335903316135707179177365748279607059982765667927115060095168749,-195175717619531660714462863245692986575584930904923479561707721078489050268984123548892469545155186709857829827131943107312688164584465820032/592967563226866612372372013052902903829883962623796830936048692144314862994071755707457931289991962533010801689258323097157670160261593678613,-21790371395030365613484824486876943936552695823934774631214209381939356560636080752381779901037170306783153792658858635370213700803668089667/34219331009398564500036948441659641165850077424170994778150862612588817295071238003854780607550738085784516481645506483848147484300149380758,-605421738962121354644194783835567027061324063890008717525294524893147156576399603233426522644554631619459851833969919228562823908005137013974/1032476511460897565466490580873783440503252735041330953823733188294608987734979256534993782217496477957134367505921722862099768940477206078861,-275210547621385330794050205753937414094105488278670536630853570724211965428416121547989449063716308532171734233461869503572606435952183930934/2788753077817557310921333200108344444664146489475728364907653640633870978507619765718974861463934548988222910873398509404159867134656860149709,-70440320901834055177306795901601865164095779618079104221705278238582067108803728669521333388820424528461355580668186812145249886140427307250/390197624753153133276724642311497694319002509167946571337374645793141503223642228557124445639856537444639333705733617634931950379876986810687,18374448949381780868064225145379736656906783605214963060389668122623474054777773128342308707642912235578584007529986214744855097807227353769/106176339406316823323185807353114203298981960448028341932508351565383358838052399379531704174794601698821183414074423801986518577346621645649,-724031947641401604982910015603472446695728596879941682113042788283461125827585036490913243290439660065664703754333117633146731738313536906374/794969718611959676801736352757715012767040150050076454651102195301918578816427218830031708011666993813494724014142976430165451839047677295269,-60606805090207222496462309692703122175572888002342081687461920367015191546657669862070600346192795080499044057517367949256901662041822674152/133692740195501687818713571697136442785597513179288539196119190918671932357195702511953106014920302771876467634164673205625131800220820534837,-6887417726856016480623156788389189570026608745955876216197492479311655071318236199661170580611312839487944851556391296547209936472876545624266/12316969890126019250087421492774264819659856516192425656244476400295282602522901044667223594797521718509805694690091050175724835268434556767659,-2070478888484002984806024257462546366649904830729670940670419118584754670839421726370622406238346948568521888680574137521404600676649375760998/1867820299461219331077191889040617759582697540517193634679349051630267968376188855954252352619924153440920745974746662552025082495753043257553,-128909922277047531175850646979036610087959150528131777625508577870568516813268585713747659699448503829173701036741584288231451052619864201939014/55621907840631011782228262932707117296574683389561601145374184353821310249192070401984100025818247880286325880651470532835966112435468214422021,-1773914507492098170303419504032172744507508309001248613373935323648601297951543114747007579641685007576542003663452786974077123168211395910/962735534347786853651925848233047595612639914447242097991348723733136982690726140918670472488861252689056176618608577769243802158205397061,-924313627847638934240635042387898348337570124637177662629259256164227368515254703540470696257286894988277864685641929658060500041985541556766/465350360270864657283280785399636596636415360104131861288507476359495352338183353716672448681123994784842696661540741641120680920182019573177,-47681033344477372521367189796138556570814802554974208549703106987549269132889320459079968692740002977268471269443834478099489897603516542557/120915863400214580636270396071274895151120714147603967169830483849246433691345972752543459735500750138586772608683293695044366463945517633253,-310935808720955135084009840049180587601946419296766801471867208275422910526497595861135529074257917302897611234790813800775815397301062144424/608653183431181881699016838202827441965915849060405986071144442853116217908828174552637813421655357254357595040221306104706703972948405650169,-117167843251844912793006189570252186946091531653070903602243313467129592325397608508629939693643714859452107777402588723309223897996298763349/104352120285368198100644835183706969566485987873810205342654734961835637455581703489528818909515774721853184322563149486351810105498331105552,-133452068674731654847000479903032604530094337029619198843946534048337500459817984518557384222990888618611947072398867223416186987508255664067/623774363628274738783249466481221073631411117529025327858358008767357331083703678655913326102134662887002774294685102334848155010247100028073,-1715287502847957193033982259174273079502626194264020217603234350965831386072333564907094943230461904990335604752964098565424790061072947764742/3228896732932891394980874576884562656111096670318023276690208087276825809963286968327245615768200963893810993192180883816693703585697554348163,-1089853415530509458453721715180405573927225844327510161050740417107472089674691241703324706228017303037712930471103368500753517897868247322182/2462691019082084175664334386290794286357820719822218240133444913121709260287815623247221282842921878496304612664470833129583969884561989388587,-271566810593611306037888347768163727594623323612766048111826850541301295631730065851254495929591092911642119287860894461375988075559730397892/1034983208146232221170581803544027364669811273637705245266356233388726100655922089766800151083974988028083184940250600100141950000413061814673,-40510114746087695460715161120330609801636408460962924794949599507404239240322924661729703635948740297905804204765716050102892220284437416148/300111979092398999111429068951986759395840800792189084750866791513753363385303191254877314943339012512322798070762591509711227696341969811837,-74215209937711051899698594882278309923003610345215130967141814954190869275533513615208941091046052189018426464914995262383338067735147762643/496873960216272273158892127707668132602051224677091386414135533539554527152756671284478427264854162833921070721125438170438127419252804250364,-13175857807614510124459414881918995560560868113649825031781635530533924674165279025361243137042521439812622081327060189061872067250010449293/113457926447410702541173865823744895114325645752755946319347783496994550416867212468216103364730339215150401809443934845713694647144640906674,-62727509404478152940105203229925019711196903165309510348133196982827192117570901000237234285433128747830405701393989730529240978467844941136/211686906977812137766931414540662903764785756364570270372264998485840430104214027964669584483708016372487199187761044488745402121003262011773,-918619335084261659065639240215092888656103352975813106118916479796886730177476232210026133834410106702002708725122175413459924244342154720703/817192082865853855297246100439664992847461850174358073765010058645771653279117182492312694181717018289686859334669486348056244607769248969572,-225196621536456916714153763079079688683846403213103738003499681352525335908172045701945484201276899899724974976524833546167224870255331173973/1041901416216479975149527121930079703915424998181752445035970154635876932486827919683931692619666513336994130483617624789710490532417493539968,-393493568836451984316328881094371314584728652045161567742440232445621796631444334226319300923118355351151556601322720819572211808046713870783/4724714557986331202252291381283183901197295266187319648178676004587201038877140069089767543455538965453147513955360247071134308724770863955424,-44881752582461715741749712574350339015354235444848503621412101169229375091490122818197314095815442468635713948538107413876705069309944027127/915689646255833812864374076581222835048276359375318367409369788480457643414463632155410565279804836986618981891307237934278583351658432022688,-11381899115102823149099742169285738841820978465260269301597065610538293796233837112800124411215212366267111905760022626389422093482701812327/41530670383711672853088471427470228195527813713712368903030941728031846123552338496417746832790389486791831017753972565741504894228035441175,-2093424152119772349288283647695978110557448593585422210533015167043705187516257165149109400414194516917971456092761724732631395484011693607/11816196838930739789422423515761725463981354100572855218782563998343858454028881618436948151591657960028571467628342867086638531944504696115,-1634668874491573719111207703006867758108901577986544306051813606724915609554239782762785756793300368436607503456917088210151829218954113079/19336803960274883695418505997029808126542621545994417048304373400102018714507180578800397580643320823178135445163341843129848235455428813397,-42832624275869056667789448400083402452215228383098893888525464335799493167938261923262177356208560028988711420535053837019210356846400920916/249760661363771426295383321421078216437392093757218988335476936424494992043854263572785183979242074838401893194562815434686188287943961051031,-363305894503039362695645596174837882829094856127934982079889113282099793855184266696758728455099929117567266415728769172775787874313624718758/982564066900064268491846106171641415215943020696725229975642451288943109894659927658513580542175373896485848751714094106560427700769122180065,-50139720476066047052296211040728371141369632636114765544250744448379073881362756522583376339481556603789301444672936420241467599866798223487/145719700250458342638172730076311630117467570092293813177167673250885644226116747073775757361757526839545026267422374959279621045726695296317,-78139643555683931296296630571424513316586097044804230406752189795801116444606419255611358383053435703126280090112254994423225943882803940017/165785269674577790609942835268892414677296567878039262904880616102495248660637456409158794980624840796205841361246063132536419700753843146893,-211144365100176809072329331559198174821125459784344737214833484127178077842547740965448837445169006664014005937694060130147689810604708085456008/155473355972301760823245322096420369673739783116948185381602480851836737491811913569671828481438903703581408729270565354173437886333164845279361,-3646926368143118353228741072281955262050752959469335587143763360237317890284899451303509971202555001253629888591459744252889348737403398040405/3584355053315890794047194672151058987141166032227379124090543903958702288088087900606844960799953249584227208626043757743286788209166180032999,-489920983367932346208498186638274224060689085854294566667503648748256599042464579905929843758274626314594966155269080862805934421005260400482/574211550726530408295605695922855257450425332448158135888380177656253525840629511364742108038419339542412228082267223692371347003019800268503,-1244134461462321900089947335874549972705257673959493996604403460336551406086717859374963083467422738775047938718186100375388798925518306234072/1260028526712978934363916879466867878041270834243014068509462243019826553408046317333581016147503148720266095528621651033996573176021325056415,-253800908736424309919613332874774647788059861091037657464065926563685658129459386421563989968642806787754132429056590038753673183807190281918/563205443073766122531902264392047603747107198608379708496505650864219645145496571135208672353662806623060945535657204953796151301266999660825,-1233841166461493419677506228471788680541308579875664901060654181502173924857877736867444244148265609197078389956212254928167845107902924289914/2731812887702433998014027116391506556144290386026539131220840239223535863444735905564071539354417287466510820049941754253793675004216533515247,-158047800918376876858429284806574299777883734830576968024397342657614271297113960753673848107781622407600222130324135333818917474142894424215896/116675936323592949008405434158524580460807987798661983268152469463888716650535533197008817519594650713036742877360523833726426651546938359252341,-5705558919859255326938687752511116599183895376494643399695262783642354168809591219708559937864980003589826933804253407813939480404700514873101/4693090382740035112631374499867161641863297298886229523258835908521661469415962423417129707834302129083574570429433292297365115153719949511942,-13008671175266983954799580518098141005904271624788526711539061682042280561111057691339476082546083714681600097942610858646384410905428559320232/8201565383116588618634128438781291057455094273871236390295092375846275552881700924474146499541526050550556964042727921689232838224451552056193,-1324285002808728467150348385545933879661769533766412956173030889159662520655774950782746348988077850588839563647773533294224840364567140187388/328286227085159774388220287867685423037156916807442732758132044558567451467381411728201858003116053950114677710123903989132370067613979322959,-16810771455745401390144901237526577991893037390139243075955976801193729469108759768246394009459113134745559607345579429925671619185440827292117/19920527082791163107857004439489255789795627215444100309375378859390269731923681541329907536835517612910307711415286746369310580746060275213369,-19839780376913701319502485479935079469220168709567752273521008718379750589979624238254077455324434290551536488481975680141815655796072601759048/11717557032452428445219008907945508742598963922589863793748020305075464783877171187129695424310492152430395964470018744787205431320782591858197,3123606891371009231872367618721507277928141070760489962149136783993057772826335836051221894049790203004142965973654994228728956195248580819/91061210194229397280707599583517658138588882632703653946541207110873068610932725134384587706719000989822474317572643315632322056381229656684,-49218111467881289602892987388676607251026929683347599657370338661756243062463352965283206153871029237495983952327873328967352140177851230602041/66425159212865252372508043502428389896673629304115864080944812280067924699882371801119661222972292052877716124281629232024315308330792155021224,-6413319999801786879242398980524493776427193824953350940168337027530760838487444265468659584275922211875821972009998908335903630980334511757399/8836799593798870844707317454877725632734024896526140497284478236745978253393220141188029097407377612667641133186092927244598478683641637865744,-9107300051185885695578239838671391454104074957287049419282154255190655259938722190234721761277077516544571506492017413748698729581767371825491/18368272124982184287422108020010125395743043941172712225339222923145648455484848213292615899739249254818813762849192397007429877604960744149432,-89267904864770844291212582648649920869756904567458414610555309950120012080046260993140412916845177540318429856618301619451758700075632755399/231343789522554711120538524866444100105051312330880489085367771862840841513720799310254910086250555869371279891241522563592836206335360551947,-267570633370416462625013063279175625941230607109887164144238592874157419450937458774425556357177920443625629547850771420459585907670545244301137/307955760158466594933333612639590301261718648295770079320474509875134865171273541833300123747660806447591082625075800598006667170573182287837248,-473915686509686301379444252294823984342705400571990224081530356040963519683566904571513981537959213990065707836643449808011142370220582227703131/510123695488467305275414256647709244730053215192586737070986851913815993337887822278051927987094444266780397741147657958590279319021556230635712,-71952469475222742912106618262008060198092697686760521031512249782065334012101264929877169652093663300195695954311314432104506247632474261282041/110840063450021528034406656381165012754380378678537077675788928300140182845652966681495232621712428662966499130342286580171238137067781482856508,-21924333066894499725564514576665276967038056420557171463254165206031884157791041848748201288450492940647853453264590718114311867112493929028780/49695007425389269513007706514936195839180580985699824095016875216536105581658618953160034893285147633201436326991327584469160876170317709887971,-510079885668406703856651461858316801156373719729384911362824053505078116256127034114259466411989751918490317230435907767081769075641618538402016/793812921426202134823817791518972037408781928634890639273770925928373515279199274004975878128433406686540464034164531804543359802017477452804725,-131621704698269771216603052170183798378508582370359828688754626025528382481156772911165829590611093626700984010408775482814816533281139438813370/118258907454198946035208099629053477677499272928266173735123362719834132255207450722711716594606115797894664908050577143445501266148350825986733,-21579801931937892077129700297761914401266850055131026598481801972236184701959553227245895864704583519077761505132526402357469226350647986958341/33971024959416338462820973185443314685973377901082779645116913657859365809151301697883546913009096081374899816870286006450589115388643706958973,-369466939210098563088161189869992026536141489540680723772123678876505767511832174461162502692751253618965675850061985559274739450423022079180772/528832125706598950407194119620906268620737840215251833794621641909766063454989118772370594677906770207749297670318240565628896660299075412163601,-2958991069526491451177714539200776205201592923756652316646947616293617143411259112279860968714686177221574346795571234868652110842446606618056/4241138493502980170592730176848812813078136784940115609886471076160336784560732352883014863525211368319455121158487668366949114252775411330769,-4169205066750884940536428407599378339075449908257533479610125683044411807517074338183755065143452417994307384380007360849281411641007146213261/5773172275541573109309935863042957457794972445239421318928697558312085872146979049587141985538432453625393348219333653353907535339748968779104,-740808873219720410813525628022625667226995695467952192608521682280027929319690952903388951785185308221949110376420215099803045576300886225704572/1062656695936341702673896911318816459259598516216619098675259376048538109217273249452166134872678523474328071821780906390008173369441984491029241,-840714780091324261196627454769387803384875331453042981406958014586511425357755414679529694319349842185809542472508277534118018972351369182313/40959467396025466732847619439377115470666982046597366049294425034857703872906896861730232793603762913235252142424319367941920512971710602105076,29377717450301733947025163923917457649774516371145738503853973143871298368023986500718641237997665333336727904419704703200178259649339764468264/76636987125229427929531207302114768730327999742041759372105691441119393564524752827372583459281410241745133060208976145269009557002794650712335,19711589693841158173964543754587083819686128550635573928724211690175213339947565457621755878756154708784256456206004917841151168942495124751916/50070099354261248248796593133554161876445856792657338273135152720297163115761483859952700563824451274075752361323263343925776961306879600973501,4115205326091572032683897282953678859911914636436264884503634556696617612552281963127195641982432943680622418185749131666232349584985758446290/6801322499825926831463836182266452558818066248963736218487707232071720325279615257058442576427647423592098148765047367734767427806148474431121,4276229408678633702309194175166514466426319627987712204728753185959270140344990677176559276941866866536819279528336862288751084063431691779692/11270999357187406215407620178750425733100305804920045507295108068336498379075715869309959067100442456852192686144940731438233352370377697318381,-179852723084106559648229458679949258608648332111285028809607503061089160366470132033850878456823339761755490403392137087319730392624848655629/1234016421412950516659056524371317998309184280997666197277864547662226806348914983289685332504772898704101525564804714739890103164527651387960,-1059542429927142007650841810568479328779176435335842822063813457943871050368547253967688396539958502002511795158517337152831078991311234522321/1957723830955990021077059308204770228909517629199956463710963158679739950005768444166943245794428790088512695471680659864393232209853920624384,-56095553226183037432370702934085926845084952285232535530075567658303916087342000455189664831739507325514710566383883434913320618035837933744/99029888066168402867539225843142892946420690770878789755617880024140687519232123751850508184108696087761921693464000384125424955979891288261,-45538362553370363094796059452291515955135851856321530210428800757359409218964760773486428124658194416074099098148210036969217860629642539544/82892899862067016372022165004949581408701236975506624408455015786533854198326174131569390891435015786644617762817731051052071860695124784301,-89960754081095766825297482434160439545719039109718179068397642551561381404464566139119315470762958048615792627449579946969344490601824613850/742712742461537718210901701563841426890716675248283990798525867607092800549114638299964425636111895900954061915313503075336435858452719348037,-678864368759196395711237129596789568903095968129199441657291298315762173402225024696547640513017237233095055191259898824474890015713417843218/4360110342147155416066525419532690100039432132443458821508208922502098090915657767847419023949917559651252044775075474731635708420984787101167,-2946283354889163859613399695206146022034236100552940809756712948588062820451089361133287763812506381364162976894760393150812141254268705198198/11292348080041017080289500202100999873522452089028734359126682666210493132542633253948476540332720790874157438415827632482176965461312134815101,-5009976822258860014682011168276009729375476807297260476015184686893816060220521753941245208331954613707299362588991566573049691829840265237394/27119514293674520370136160658510127618938814684276316715373327042807587284008701332743297560646200562903264268075794528983039177258536768701279,-24909663415973492908082743157634173366551296005095926838402618839389542820659138032849454697535595004970241251347658065345006107888174317574/203897306416655110648711035021019571101011722451587110545805567207321869943773550675546349115442201689987145103518928455411308510227089869793,-50409507715131716318822349083201301024966710157029558496794820343278536347759676019354617789811142359959925138243159381196649273423130429330/407868219477745149690540258341155944281751521210367133082758206724930554439560443707584937854598377079892846615846517136022095280614580775031,-1827045600021615841448499738876832303534366567895409347995983373329103747529454581105871532430024703767597366209265872448848432176034293434938/11010884508094970821104347306848851315763752394805267707577685960655247313340489529944662429776190610242740907643542859895538938082288633294747,-2156049447933036954965557810181690528397251972605857258246018724588163196683710292570994520722951987858038376579395704868482425691761245858439/6700947534299079509633193306104393459780385488514145193756349483410680451558431563285502171978266050591001978101419138590786899303022117487322,7503353902673727391778353021815458875701190443802043585582971634114504340267142827212303520168100239872389399351646628493271391323675367471/44359100544910207212606279699526032012545240486082222691366995811696603095263114607101739351263554557345828466676501749659130993767497928614,479540504895320652420480404574674804659825470839495613940801150390374949373135917260852208766109568836669462999326958393948457348219244476689/1365520227395895436943141207979226068846772409324500376190476262541000107054563635058515403418164683936332509728005117078324127459932027259516,-120894477586208935481459681004944810032424387521706138894397193816824524617824906461057336025422072619219940809523899658261431991448482625362/1600198852237743448590892240952702347243855940231049886681020348948876400286102999250688278913137438964912666564714687084443165898027808410527,-1619043122980067832057247502037391073009552618394321666128443165595671053449380521983952418735168513071808850099883054431648039017754981515482/26158582156825723675423085970606059583092950019161126135012244078761704320868685225777008207416158018999173913132930280117185101880722782067883,-43263529722073308679002611287639277438542219084490806614153622297001103169196824976436320294906466584009760993383961997441945128399581023098/561051317878748417714859912756940455320332171809578221572612680491472062008725996208711220513669845301059807825564863816642067180187373168731,-72912919943767592706957482230579558722672300484518908659690335483128019772160653515227888540671447128648385039860688402551799319692910616242/1090507961957575050940490333585740049884774280405411434151087499837331883043301571206441313867450084786242955162032093039892523452401216094751,-58635744941431458098188487196655134428147056042837359382668959374228735278827571383335525711762260238465863163239006394268889336125762267403/1102979728720204100629572947391234639736999090999722301761332133684404644002930156466235922446690551901328825625066062253496743803210998236336,31585116449738549615975750321640656651444811388131308518322949093566716828958881898358978338605533839865634688244078949038363586348837816196/105411635709891705341185721090977926611868763903268657038166287997186957022621406112015219814748676238573731078480892282593457672759084633119,-6850030717586991726245862124259244483280545019698076866510538190298055903881266438657149581727831662360075899881006774841869510899804790330/67341566594865683935669300765425572516077108169599281599858755488471800896266823755301833163403442012049396035586322425039176230923193679027,5727919451548932758990883535132708066071418375031054935297992411681928387647384250649198410565696624617081589728529505778937445274074252318/40590793594302910511057934852789850175674908601154776685335927999912068010262906413119268392574486054137982937969072266318422137026605323107,-62969621170090537124668440179842688193138566017139910493039613039141228141000533183503822359276659883427193950375171380013485156903413379723/580607671079558457546633699960630476227884209728132824875411734525453242378330432295391865223463770296612388300966739573778959623861032347736,-507556523377688291729136434679802365088093115002651375267501498227784278848045459024230086070949274245671063989885235169949877920628191716803/939579462972439150645489925367576661932457175182220839936352287132149999463228966572867040865025243326421973589316114569816911913083944123296,-70222322285497351109944649505203506248499850268892406755441488951197625033163434584140008726705529196755027168203025861918677013118508600143/222539746212013258200180394536044736931870966729892401897155094180775579563402794207873087951842504338971269694895849870670544089804149773772,-161316617801857016791473251694232077943150417374521385369219923490318243556142356481649028120930555571904156310221243009932957721015145549867/1665737753941063193297074390148418440297935020348619318800668440387804821469143879925168937430564756561509542166485421921108098513525255777680,143621465509757237627341770502923826958112511943716866994660973940565976300502387661578475037419241445123219798385804949521311361357268780373/2053277166082768003649145174901409399746253397060549383594948194892457069821867076125915896718268930389419067711918174007941436715837775578672,-36351080433437036330623798602268962232223152143019762571613719684101779656936446528719323513887960755564770796441012334261007257628589067063/165810216132175164137076177565401979137569646600847362733608453066031415632771728366721753412263312995041008686531402737508586587884626931512,-81172807667959692347770291196822062995288270827332753137690362337298886519097115435175850892437037724316735162054683362635125298099983428433/802576388711136118950524944424264770204160131783478075153215934155731560977065736283675370975241926447450463995993120790411761408606061618128,377197071419968678564299216240228368523374431703011373733495733848656629222472271479300825123510712849474958837889950892875405799750802482913/751376140682865937835644221941739128323918484798952637577023136293376225006047300086542323512822851091291577609711824383776378682051822598256,-77501172983225589173423642660297704452776860761801579345540421045191490580222026247901527883197148729336960255185897689476031446035345143008388/65819526768905153446825781025174501640009358282688365906316315476669332207887774180130387006543183986904164391687322074040406335558753745549895,-40363538176200262738640642821259903790434072347150002920156745021116028593683014895981045809881472224652957738457408713425551372152914243217195/33974201305324510008947004278523128898425393048734159266325370828012610956141893897719563253851225121517000447955258814677036196231225337724876,41327913443262025022986069443281071245511188557561507339860094181745901372385692656131525180089253364718887816965836645344391626215776502275110/53249365149908377577714807066832364166191380313535393213786729124855393048827408934903899609853963276832879918755912921981196830793382505016983,-140537809412318776121994763125430784191407354391496993721613942299227113409040158925677373845406751317408837551498136932779189334495789992518994/280744616506621812856360160154650071462725812015727861918364152292745403480397251074448899616767116521719769940429279325519422448396684877261839,-1111817129005165735086227759667216517184362670128492822884771337189703052390424568516363384027036159252140061433577875354928320485666983448862806/2613814347670171864479760937092643776112101013983895042244019623520927401189352062276913696060910079626947887551872385231479973261005936358320765,-306689535240548906835882523683723001339311564045993837680501878117237779261147105002520723937962089607145517481648136161906079792142139950603706/257239706801075287615040012641709499926505707814695788540902421783095418403998783106250154785551402946202097103793587296453348915520749771264291,-808737221345845213832680762206193476652795188845544043332678328342745332794407524310396221741319124192641305514713202745312074271500452894128662/1792517836471683340849469983999621720197725219277344331714101494898804986704629840810900147687573167951490716262503709963836915484771630618693025,10939723305197309295392604303299427060416113386719973409205164040555642088713219246542657464472800182732075601151646396452781042151444563659638/40615827396329339794503270783289785654350515834106960556265437512040354600854306641642015416543233478430387915170958975107785639132457985475555,42131097803944556924835634263462800767110126575676206470364010243499576090482912671539015499526089369657932263279987422759738841092781982126/1088914127140432444924325593808978480915447187524477949482853138612223710867789439263615742938616312005897855556987664040208128184191486721315,2473083594918043439494526347433915859358053677859714214574520305688609477012511658593295453551867255750717941910065771860642370980414043713354/11374813442529308093554650706646823696460375087665743223096035317151269983361193085844043483297491734863248329331646661247261836538155793499049,-152441537785919733851091888347496678526124771123013645364527916280700200111696104006950958216170032360434235288390373761962880623788814614151834/192080121454335949318906338395323293994544180901096670818449441026828664466360828419965237214183312550857841464136206483120289411046228411641051,-227944897551015297151606821944121874491194612386531780003913228998530273642779233729603006615808796071600130866583032880594144497708465081680346/305903681790759508986244469454847474669839314300269618671024775933499392636780519644922296172983413973923963068124273877005756235468234853959135,-51035889606115391842451340523339116988142992831947212750312756633144273416119968746971385239473809008079225937651114949416987951813474546260570/56909915797024310854800247032061870842894985771505437362034694180908237368595559749020679014670177352100321628602811883615102584377055526126523,-47869366876516422849125556898422465808008551837852326057561924567687868164966914588785944631113052921656916303128407093358088077191294598073114/26632580213190208549453476564742614251994068469162368506069583832670018015145625998223204168753721339926695764600488674762403196814410022295243,-2869882250565139044777474372594950369077424454181542763425392736119760901329145514687273769771857217235522538097345655288038211435087179916597/7007467874883828712076105539646669129136878545659005075487475487976777705696038085850639820449045743266306599869505285362104568634050905202013,-1527383266958886830117978835099251338916283026117216021504570613736520523623113088574156120780491296766029040680530321706824490815132471515505/10448960511039603513987487758438279935278284832263054611632740745528249242590993933709671711529082647852257406104884369571667887505752683783214,-1470356527649488953404030740756093757189832130031619526584763439289018074986747640877614265029996019669994070051904448544856932817344727398452/11968331509370981095882076849420144358285560254606405998526743112603004913759436955046994613742837049405635209790913210771740960876251076033011,-246213020963125425591431300300437015098673987516785300343414691548923348145023042552083257314543125280361119302525336640888765933891232343514/1732188025337405874030195442902344790055319982074881483299024029297473149253624143063085789586541532129725976801886174365830355322156833806815,-762628611985504112090431043555479265058291132261674142378591652394870587677938738612070332311109848461411475531069165795005646843810480570636/5703687952966315023811621699002679531936031250013167904957712616494052253758139238709745513366805063086446121764502522203435832187604678488197,33217904712051782961943010955013895077975623444858529370940938803403111815423672816551532566951042510201441721590128984919706504028867912188/230098692891745408519078943959265694784449239921142253927278923803448682742132054411061090012901331462760961517847539966257010287539983322071,-96311563754396304932045188886684009695505522428626950293291674331069831547052940654498966674788623253492814976058061657610459438439461342333/749581501197383636174263974068295009259779572189269020477895732596143300047467492650580565661511722122751738119817353496900022219965577405185,-1577473716633374605367217939890100450341421640012306246845678955201002771822212861292214918349904316995556192264675133399933343397904482670222/12656840572542950583039818335910343675093877289883353290534790540744194965549257481429611454783838687162498828385583246122810235360031875192445,15629588225570519754311109107778074077124881332719995075246758528123314596632500996123721597467936951577185647225996380886931823183471023895610/19668463509857464529751469037348636791010467013027515356416360675096129648561095708316918207480774129144857241740515612538249661615840041053353,4835665459941112175488049417745283924742238134228235786589518557662584800980411575801310571187760780824136544956589678370617112668321004225007/606389402413373795422655563030604147263099884484735644161139553612130042375210459248245113264687332347220485315291462598501712475866375661887648,-87995566250499581094261057192695470360548092254289937074949290994758376121868143990775940697711178135226280400710187735800823445771859207311/1459996108869540611827913053954005243015872261660304492927528326395424181869893724359391895226721643477620005875449264866613457036350442573640,-11374455872045628139368542395874248365592245695038675582985873311693341718877406234483576045190674134372105775970806230052249444456582264535/131385263187796372379341293648561045681958035051447833201399477408806721268487167084793707758867342781957773709785579386648855226841198296608,3699991431309440878200001451069457761107257467180737013993825708625604565101710107895260428076977926233821560777888598346380149916581032132405/1823793688172955329777581259868440234401394734554731935500668773303586271250309738128626005451853573966966852033381286405799957156049779000384,-444897292580643897858398019493612737491057292907637097493380417257774126661376886011817818782067962982932019425678404412755059713065093560667/2107574356888246256356373457027736048149216533448994292749681226464103328092071803841901536178681113706689239687075289284332635964163334282272,-241501490553954157129255164034631284542563064946540077623391391630838570030566212274542637129525276086460184662982481186119808795658006708835299/252505931869169192597029573262273453218482883571156824966374637582342214399339006590630383397981246787498010401766120315604229051536527886053088,-3303269002533819051003719846580929006797626832668111120768349575726451144875359930048377060254076303053883896049065207701985792109009931291909/10161306897067169128675791361530100471742118864656197792215626148666983724260229055557333771491749741727776824703763264067760637115996650281624,-627796394357020359172211225925013895521742803532011078547558694499601462278026349769719670216460180043865732527988317177401940121708623323208/965097410388405490045604355196528552663362834171339476162412517669335850181372712163867012647352908757757151310409133345796511748946584100989,-4397268462014982914200855652916877315494336699157257440794669114016071231547145256027974044127303713717831385852856084988272910483196968268079/13741688045609858871444622585077210999097171746359771845216118532039248631292596470804712563773693670825501367104154232416861531772686823675168,-5963719584014002966298793287113726813763780240936092824076094672075878590756859034009136268994445567880219827534655286208108687327946436921689/36291683521554945840744243642885657547114146614461874025739268400398420252633633859924632094084973818138621363937339122810340720848075997143520,-6930898421197019926938566329921626008569753584824237428567037667673841358394968189142058134755339509493421937823281889756984170509960523970085/23338549844260306330885768003945274232236849745591813321214457892069989793521890128434082190937895550272327892738177748114198406370082533533792,-66146458716282359491535933372479289708829850744108258453214400627966766683348743058928948274179796820628672907015875967764694504624877610100083/174562149097326101188997652569764906293746144235261846745154065221160322750973978902361148991968164670447229101870019680148612124954516601143968,69763944097714144509754586963867305177433982935572566729971770500571148070950908198445071016931864220777373547635523976811910269264497798097/81807956039866206062104010879698639111504397054322880845750230479058050279140559831684176336598037592049661338100588306036362218390080373692,75686696782468659970000133801242999581650685844883707056677346988914580986198832327136279818391323205953253968914972358507267988467589840603/60391181169629681289068483661329503569270777658254282827230711774749197717688524724437444248273721194156509230155321440001691753140354981360,-328438946108560071848513497293552875068898425489143275493243534566877659426780364718451267342589126282672924219112458198784079107648269200453/1448865418651464022536367010807355507859510111353972717917290391206848264733774398396448708626015452304809085341552460133590761193357935450720,-24847243555156468766372924406116372319251864766053282726214432270983943388805615654440398351902664997780937818912270088538223288756298440315/613685063848963118015726252634427551614050919443277696096586311524176465937675619988430565919076222988887131008438280152965606620979829302688,2083382789760460398045668286509792350828479041060394360965423099627242686772101598364181331587652489861363922715675468746579877947866202185/191720370360952711351675387596964789474981755741548329850720207353281416055044088355180111740432518024862281481503132907267218647213144042464,486676628514056352494672891872657935921963445785345337582641468345966159550808266229008989663880214516701328267852306276738451356467930647367/601314513885062637402441504181843965564486012390543811612792001582721181023923574161065808679504489783202987920480809820453420650062114061248,75074622358311344217088745390623973037588544432096188873456686211089124947169816097830244491299870463344782948995450852383221300835334252125/91290009039959100987489792571011756728182871814363858596256396816546625076617500466456268061812089348695755782492789786483916998596941061696,-775904326619026572173908493963158891499572516196840550844385059110187900034405501178708984498148283158156381452017977525532879114864374596651/1430311299109571007595349365482320790522482977674599793193365794221746554403348552984325171278007829250854321395259601356157902868402757343680,-53692692535492679632400962208987483726740898499468855210301845036877132312910009093213637902682837033820219375959115536384497778548878735479839/91677073773838256022077264565219708343803596881916113071822343524620828724664248635625903908957718684793098885534248229447660847508518553883232,-26249237448496356149292858900417552855761810208409813979395377027262817860844252456534116120406981770427339595082524693013024842080553269740138/21939211154013995800302253142308651349792295708934179798784198749573472707223332187160704054815933448097863377663820549156001583256379104865955,-1061706648835190077236453612313411068555312129474145694899680879368821696260816342573290398925875434770159517699462316911969457080832203772522/2178878015198091113019457181356274052112678598435386230019961221911362495894631519698493752937904431735902001103951140442384232858324537811615,-1106929654323599213685272604756422244074688729747608116547708229644303136384936991599229782857503934602764858451115235258560729469561896066883634/890908963107551097360893721266458218561090123436286958150921497773813154202892004730138629679006903906394814849585337701960044755609022344731215,-85983816700180639763580172343395592548570591972771201013966783539600914589007225747567470433532420046459274962524639354584844551710069422430/175740317739492267605582399619146728491033756693546223723214777534111360008177026941134479538336766032467102928350296140103508704822541631497,-7658216766042689871240795631037646676822583412215326885310411715398730325159985849497407729300050362180690208524967645303413046337431539724/36603928800707071859593256563159646119551238099832341525583965235776561835805421692796087620568282298347453759503788966825748249800882777859,-171054245292534676117948363200010818724958089736288232631031828451336732935715913456255056970404354605451187155966183227692228976968826153676/986644120013702426932973889026135307847353113962951983312430034997498293625796390548292192706071397918011358715641676375535131880268039374973,-1221605005225467278328769889793021684889818018081126496070120547169342718565715260875831346405287801221311109276745263475463489059502442650079/2680837822147136020128085998349046637566136454547988076879493660402610963072486889339379359203362154174120699632817319013038564985974769878051,-11989570955773021963028163519636450918283191753745029450324303711329230804880426376906840404200179159144027359593004553140028926354327679383/22558174890244467877730715969778817045212922539714457235153177733102331615755711204664789582705466287910128697592762716095940264885385883087,3084863872740302001953182157554787424097498453103394973417564857448563217577211027604182771896614607064248625475183180372057219014860910322753/4064327142153337419077475402642140272753600082735754094421847393336989746713190377060681612019191694051304527273171995447895871260948308921392,6729984919877183263553737282699689059810600234070654134047114949607524686366004415448539653753841266088313162759058678303239417113961104616749/6183695795522493158583795783189779657107801486785983068794500808819050199451437899188147143108238915872979954883071694911735693943101405018256,24569095250647224571130473488515182655974613602555114591142995220729451852466036274297706677338124033307780853600441261955134632939083044507722/22080775590811613345055717682344364414270968911053168733206053130898188342621533914329339071567488617551571452909316296682250674249964618036269,859701191377534388960707885353022078348967323772657684002382758222117670281004066085566366873929266721460296186186453920327615668256861952042/856956311661842414214984371679795572983291960053309486679910592205059885190895205743744833180068008894208644342016987705075512872509971340049,384433371391951704286387433203287859060184779481667791361185060105584664779678018552798885751434511586926837836406618809048946453259113040125/151440617072346131855432727397362350985982021926148622221963241608344144887873474082506316531973715234242128568062127498461984603551331348044,891757003001609054620881135260832219796421305433275840552326469142653311742289923786331675094757120789568965262469187616603829832640402592122/821194387156718364254710955373008370210859108608810789135872751492065159610720988428722298327044054710224680679423933829253690936616608495009,4297785257324993022507544995718670052176250811808537353721541426401993606730667338970777749912765132789918846867243904672257676429377288844281/1770410957543354011685703962303707846360240448753041666763893080098382525508816738823371197090321210318776846012670443009750238022606058012992,134067114417737234293008487035676757021495788679311928356763836361911367048412409757767198684010930876857277294022133759484308456613756933143/120373763040034179527192695579859714530099905107171441859660528307638446439319745773354256084573317877665334172681068911152989871352544651078,5794690013577956905967345914454145676510409782253189962981558822632770740937642754236043703838061012747494424203694788252188675750125304527995/5296598713268794258691755614888629538927207108769930022969102917237345190052881825987443904814143601730133622818923488779067682620454787602544,2129359063565304987062273187557719294118638917844674466474523916773955719718481730731153001275968846787247005215706835967116480422316358352498/2221074140294528512652234975198180694461969418726869107871308637370753273166442778933604932361241811321533661271825020261279695903741390872725,28562817300801902530969775674751333591313959232305748383286323584591732382548865644154347108293863591904515459375156253122765881598223633743/22227554100841449569504380120816846905364523831334000587202161967182273889105769140100234372159971312820850468927881258404648719249112286300,-1702683540820647427082523805620136763288095748680144195668526548022301455434101744320793508016403974871070450962657019290872895305032973790075/1291821131747128530774106263306716073822663773568687311358030299663982149355570053597148568109587700936605608577139132222545930119715171153462,-101901461796067638096949692441336943558869493107667982886779175624385379215106123360305697732340355567333228171601579718213962204714103710882225/58701065400958330542949132010961242840656998032206349771204796766206409655845774874147478863373357491568561999330984119290613920303729056004168,-152561408984561982903410958361428211731970863492353530679220058403385302928147234837583542222521249855802407288982551553843826269206061261110851/127534878605471327079305545370126622167325597031091421287677668546400224485768028576355991774465471809642130531292607928044976908860996154111804,-763556411077896913316491955223653900470424928705546314283683994469806580661417290793710636117324936949786128457142935002641747684349217887184/604232305120085305038687070073123286002601350334045522131235634778025504968324719684577738939638850701867569652584149092142042960870850553501,-87833123591716697391071096055742397710969748571709127070190111640020043310925053796324002805651007068247192859572259742565572941824481552666048/64825574826724550586298040899720659366198505083466593343221132842165946843602113286269295719589081740720920530814260525440517316265952526136837,-146353994608998998203420965672169918585917261331175162395269681891982742603208040897235471102197745917601541332056703098524977067683029765843043/158360809487111552145779545403827450578289713410333358412538100754957285708530093529092036010274776673697599962756714013867731604416369452913072,-78168598298304336803433803994437652930261911634116001778404146776012751936892806734744595291884230657411143039392910949567266760346722852992783/59463312985281115018669222344613359691763319319608570416462151902300384692889922351617514651936122042744991873891393531428104009450667689695248,-4158831563916530381869392254337304861405392448026802047263567627641564095164005510365547866980202616905310343337767614922042039408425665018801/3762024606223050732991555692794788865759323142213227926263505547493634819109064776205120265436352559697148094608960030231703835236626604218384,-647924613191264144259770900452819004815430132671021723307001700114503761763587698246545981291851772037721283449119686168302500083216767398227/510696581870049491121555742668799127862518088523030754508579877342919659086458359651283482752442124107061609466427314307450448890563125898403,-3012120814483753404771438945158116328610634666237131548618980709106653588559717858803223501770604010065814505993018796187807710834113071812503/1222162406855270177902364442458864157693115032976383587605884522627274622460104040287984671410608595809279235170688887345258712533205083013654,-41417704395708144716502746259222797830110333790911188237973553509876888273913993072961008070099633570933363982208565928606023793751510125410501/43007526949145706945971265708969878031411684794070455497267769858989418812307857508925178019170500018929711101294475650848768976763458906039456,-365300204604959370591381364815843279722677664107861624406105259155324975388029865322359084215953360559267500722404880597767484666552867601/418758405216571032250503600784781880371243558436074246009701719575032592444505887436847585155694576881494207515739844529387302356925385714,-72805048427604830900928689130689887596319031830367386120367457383951441496397979872646740654006172781233510103606034549019861789433586085479/79817517754689206047168870508633264361634646754159466337455362937644275542754769838435958671608445042508662586838033010644429083427556996225,-10856124539754454280673507591176085160893768832551415744024480354501527278434203044845452596401112497663646711364204279562857031602660972060919/12875851248941146385616047915416037448470997094844790419082166303472255847336214197523935409925459662328063432837441436171054035869234929530592,-829868840120796470709453272654270846211538250080960514596649376737770917652096836982423059845902989841452470994315556138729894941744964464369/920364484037584622720614588371154880834372270650736557896620987228710510395137808036017537864508254941243128068637727425451899837198418808776,3027278296670539663249994267724581683337093981271603355305633602888734728702829691910435981453882668984555502370583851498231897796524399160693/94710103363262574145582534923622886201924899985656191718368385825892996589426146401424413968460065381599965241412739189617847549768186182067424,1653328148428551168978984660442091128947623987969407763144344395541055441256166381047097893685836042952396056671741534589353154947313222108/48936321462127438554462050050205771929589235848521362968376748178423778414679866086110569933592951787142088158294722930712516194804427580829,37006734987043534465793118215581709720517345889305632033928020143947600600802708178964630285818341479928493050981476080016642566522296012289/30054189777091022167276945892061149747373828120483866682475247229206533980875779262481374655459793432100756454364890815800212265559181555060,126315780668052950548557051827222442901881486347508610153126227893341894102997685341468581139247518670010855001313272365192675341220248087517/3081959152600306587444179969572118455601686931403636307860715039708493149731811396131503785831842376063821977559371368906123424637009275636704,22735944961136233583222243168649331790142709236060871475532257025431902397531881937859577484655668192934702348266305856064143059731500580172/18505479697604304072335903685154765712544006682479086846706755274538432975339269720771262398698449729572509097473127805227342644587130896853,-1980582216883294943629457514666266073501845812680964657322866066840376085723965831122545901158546997532725057394782293858504482024513692426133/2254758836283021351413107905247476616362098985277836840248458636245646002062473540022667348248226866859222766754953539461180854066353337241952,-1005185545793363570333421044462531737036039500212124650253250522428120422050829650696131038317266846902530153366799521922941351063257506894663/1665949988915718293928876041049969535150000693037934218096222540817103864290884704555950694444263912352947410090159060544423990982092256955232,81396781121541472116476756692120776973048743295418029603949798059740578976723601569698411503965341542280359754017428286803972813926615465550/90398571049233263259687520277349730750863841305825603578074682578225667665361237966673495604712949777411244573060426042472703479644926959539,-732247721923388454409419515417861879698380213538263513046063221789258848095170740850180392041787447609702705831711776840069986430661425142913226/2880528656608147548228748514066707948325733921319778424095240564359189641103375843288323268355245263996764814949652978360595629550341171938572683,58163724711791148725466922152838811602436426247277911182206747679565820053194834118281560619744080562490421097592873055219832907683238115630702/85835734060048474094073173848295633470434770226838871809538040573406096019162891577388204750523386646257789939278260074211662676681456925205923,426972222940368699616821232399386793097831848108872314435325260785036822016980689762903985565485857652016156378396341648921409851092727776209/1851619226065174470810154373153437513926783584441753691667307703742023263499845523181655005260175513471394070879593203221019756148056861033326,-649284903140997740011172391423589124296953704947137062812934813914915691587842619253908495308235671898918648623126065675300745736783016718668/1807162345735134583937729228009394208506582421337125957834583455754885058157556386244833237525937887144728874667634110585131277598388596458863,-20551149119147757121223424175138437651391244159230083186707513507466474709766350690409232132811020739480215923233638180463463075673154818743/869699567381284791540342125212851045119543873331625338630372255939421489946418324311146014586579979491284479999504876987419163919616621737013,389130841175328662191787968908143908233460607326423232581016689032652361938249015309921817180300498427299622641458244979448550158107932172035/1530433728699253317358348089511513560033505618807946948139674154508787277395309093793707905314872216222055406647283857712988404902994133295058,734372594054999838205725397519005613850167641913214574839397707257795907541120874885986273220280665638873071003388371461726692442075956579284/1140150891515772208641161446194497610801068980910686317466048106744359239037575966503970265974250030668116116928251132369021311517889406628633,-14888045729538323461713453976185230318475788126824317218140365510945241723436207315832200488962821288967564044112099304132783816666628354829994/133622875536387995782041836354882744639880216273386090423227434503737821294093447610043972142265620571663200985024825671886231807042574654890061,-16847718924265870461711270577192245143956538332074075852271107548834308005322710532832961107525981173045425756662852867913434387550591543063391/29440082186335968398414041421508578579922043631168953170405315718167828470722943581533403661167177518803235844953514833445401898581487239392075,-30228126977634335171826869867086330877977166196084759557473717516514869049776038101045748577292761610315319827509871800220663448721531396211/76876336754742429866236364956918915996566783716588025991311462270473156348193166956124050111214743884499652519044104326615320231819491529750,-2371240342685188626606605568612910792130246703315018971225423556654171468170587051454907794857000858997812972389198241302130385230348392021119/3868500325757434566807274639364240731694051090829644327335100434049301638065398029242153654943405867411420989112529639314014953054865173297949,16605434608416240288281896721552999570451458493265130692475748323137073807278164475108121227321539176346111368396654201098782337774914526946974/14369004095699409400887728440541571148678030879291778694909232231747872380325359838083704201291204835901501720032550854849307996444988348976691,10845425286090271850497248497254760772842838331495270526593693738615533096073972035997441290763847135391128077320975962860511789528453297341256/4538276055309907237342937345233738260243452322862507644361771658065230546450219050825476553565552162146360157844131728643134647527757625432827,17750649390584892649046197338686880303364317728634125683948304396342932338070794392625446559716294076356717602339523538455720572860369404589257/16714740398262196655297046033833480607845064983755596808344093781458352639584885991533068355324805206644386845823686851733549831270558454800147,27149154742007020786130429027717337224589781864469072054323060756495035797977608877979782628996032195540623929701427341540606515359172260220178/22976552107695084705419414861883662193160961777681930075138056585775075548500889421508787710989315906766021080177917945211306985478802192267589,111715246214574981566238105168292389450329368655724527071305651500862207909763883155531775744645622405171320726624819371170847372857730419386/48967940139390996582739684976728487773992805275638836423518645188202444284389903359274554604556786307862133620946991498048717535587430727869,119761852005218337719581072582128429259087121213022899535631146709682349741879659894216540173559646257408227495541054906842563514584794993857/99821762932558894494289573157562724037769001510715122722952937938000171017572851681572673636512898975508112505267624398413748551835813778173,-10689339276397205870631511837853462815916091250425924819918243191154487641820235016805458182719573340683449796417616715754230911763964852937/76629834079994116035937527073625893997109855305501517968146044662696211002606859516250189192717990938701345909529288016187323172068123097248,-67086927068533000969061926603469075410211689752849348933222197207505419730584478586568209493307568553424831717617809635852213942895522290629/429182609927081031778156964527260342148483879857477178649572772627301446511531139121644172336779452067289348940371752596398060901512564749370,-463209409075933588470759657587925940079823095858454334300329694571762987328072216723226312862309675030230408026646956471931609786853428550246/2349496712421256250243747018928573058478881126438043976825596781004744904364133617777748820783162543019529015373631892597640741815055657249003,-14637708761676044637827796623802760735850935992633937612478380067864844125114047703693722662237952864243685099019144841918338631818502005560/102329631058324946597622619705544144830891802963652652140193488917826773142677814305480696015183805684437068995428435940267306062086427138611,-161739812584232956908259640048965536400142272760825449568129384430323268523737962713110958830353545643607482125215436872599428877372900857237/1165247470755069489991565861607407007590225931901761949272451693665678880949658174146585728845524526790627904744148168716904391687891954345220,-376993056916868713783811464793350922029396941918903634493523025304333183615070732653093416743761398276880396350859462818408595010106660076528/2466961611034066745266147143517135501911888647810090997871588835960210625036318113031632985771364227555047986307346271412265945675972353236769,-2545003870801666786037564799983802919731542243131463624127133298086869173378565147566468084363821376122985943394241407563506424761780098299701/3896715132260390820033851045058618529306491379388921359370110867196994045194670723874397559540990340611816155146103329710552221103023992383293,-31539451262274553518227594756586305456379451924889755916432969231516493812702196403012150615787562569542477284917293521728468600546578291337/48201417154094650182104219704765446760825648356893719523192737243382478045588303554921086604914233609701649678485988537801700030098093486131,-4755822670737533352126657168835107321361292632727781932273600414810265305896282553985907513337724152165592472712530911724985912437999374545/7220381974977673417121662681336563475988687847579080954383728094037553454969152660737349496128750301796350719379274543647908630640792809741,626415128446518047593060657181481915746592052032909693277856096907454233643381199301086685692539401518107514938815481477999299683068190373011/623383180151765448920010989642821353599030292539101290359380942129276389733524947494820542576594887215317425338823786615489021430244722115344,384067700342406721032921614246830048828742232324185630865586000230931726394694751845455914445246995661620042192950868128239512658898201659827/533188948097554599004183033975499257263750334362538838141165186747467421877798745653699033937544107393766051541266225303578628902353744262448,-402074410060176421134010994346888640731507064195676185848170214388123074446164369098132290780575392588556532985325531908168405987240771215419/1705946336972028903689751366038583508530679348164961877265663012076651203130822236926873211052923249333883013639641044193791898910117697133757,5129395144279668971094276650755142891005572691475843498767295330435845937571928074582240136643341548714920488174923380441707613383992280625/22994790991924765756281166026404854653467048592760625266229966361195357016419273514965138288429930252740649795519813766117183325585651029568,328839510699458090813986598540864314380181944184409815517635464988161963962886672880926936141512437026747055460353812852144487793152367668339/603201835051233358870151669956009453297257370963305526653339257362140042818007204451397535397424671115826084158248048450925691277413012893488,71173180222865666785010964419387776261856823128609679507406554156244607274041055713671997328213961069227374284106700054829534880353100265489/116397711335903227133005437892096703031195755571072331290504105646846764343760419170277102757933953221683426728354416781913670926812433126572,4976940384609502510828210108127626789716775682165081289682544757464154801615418377780269555960594207986624277509982769597691988772541135153/5747163091933382522676923360254008765667027348605384709426891547839091201486270577503880106496156297203513204607867714848292683338780846489,-607582849185476148759824394275012916100073355732534657115155430043243722110691017222760376123317578161081977259452297952669600501526907990651/1624925779093271816348831771689171176205260870898020825281100696675274163317385221818886365360213157466199225168475829527963958511116248999736,-3302783532331310336806572419616845984312068943956491577315391241449682185174530522065055872578321636940927474116101576268633628168858112873/5840588034566262153644868807116046556227428990350165022011844387558412276464150226983834995253880336899337255053892253845003585445828890649,1413911315616041478362970318079256385430484462565726202260683741278798359641547524120020598397287745480371285684609590346562745102452427012277/1343108591905015982359090537961247044221227423496991974809610386819521173021847443213112219016930891233294487058278975768367173383912946402898,288475042909372741593436622766066671710555564950925383738931634571749220509421664311190625435011352252413155247050807823522771505133139095613/212738696507767379166149452650744596547625516086697807127306970980046613695075290681578270784680829615366702690416992505339039008864064724115,200917852499079364063087682022636029186295226323899844698619191369886913948822755538311927322496947161426421919432775766406250218409716240111/164570375940493239499358965605467458406305911215869829828025804709857968769992711598432304387195037429238330561447574538209935925605400562178,440175181752340274753192466780135372283813582076781479660459432895332067454419636522215851219405786706270743713537327508997543296760438235698/362497363577434167952179410274769245411855635646930299538513729451279988478639088393166867473477007773096932802467363366649694719525794881847,217204126694161858970967455186019111594144785923941775613988218136837116583464247837748534673696750730022767936563350591283920268303405061397/193223445697792077745627822862775197127255201067169025165274515632445248597984894012661124104859267932396162428086753833222660178393110536958,-94816261551625348136538657407668484877134839252426177161387512566619171498509148425359574038614462303064845166121518627608761675815628674842647/261871823336350883625915428027252842528048727258657249354776606436826510824993283914257139861627294055507596640273089694263410646537204314837184,-3200137293215317877510199569994223933623367988305181704582426709255008801796280866930721762091110847223458452384602114920535425704006248564129/6096422758558762897629403361026830552214912475754341290824437198907084633267315630449113431803781910995475488404612971536960568056360125630016,-48590862325367378774669207842502718461101505109595812045582021386365446307843375821718405389066250992795840345237195801901002937364051517548677/87386002624651117451351286121817595145477087435575202892943459018591321974572261573798520682195332915247184388863984580243264336763313785737216,13191716312386113824909834317060821617176175459162323155874046987398179686563791520183996592704632323670401203805076741829383591297006286777/59188973491560079205922290288023949383534823205950834314650809062651002902779473937322118453038916760070255262145568208702834739896543090830,-24724830718742261412893487142276722485065367415588782742127673109844691711443009725510110658764137047871922104989049654479871567951531860353/1202307073344771285383412679019747219877023534456225905741341149370111674291905885508045134407888822408839135307354155237939220562966684392295,-232927552265182976645286070711765542814167937702233553027271677985584339014308835645537682214712318735428059067248628675888762512849479288711/9986108660427644230062370665401864659244647998530748270107344602160932417416889377491643101888911829106000443889984160676414632359460957517054,201644171813324284575346719108473816195352482327226713304163800808044655451184753873294966026083549400004054278802193782545976942269817432199/931646535338978043138618413187361580478498734689572139003765636236259864336633511324930186068771857409509860319952939309292900461453096914090,-8424243607375521412880519011714042885804647217423160155179322918989141040314126987788181899242281060100408044074883224061477893832481177534357/15255008750371185998476252706842537679894394270017719878901426781206868991011043345960251250722374791562405420242472992398519756644671132588122,6365787997411355382437634621722236919865002555540136005220074874435547444231005079609857066381906689526469750012560434584420990009338676520971/1095191724233694739230019945737271327587975040083728162870081055597312636344137100169109033608373824014267789736665394813461943178339093399482,153532732770967468453902878184073134712452186922034325744974982995837382889885654593650556205831940963556811317804736767578895380128958462925/131368870890621262453679604377582790415244758766171977695720032005706806945070392229547441985406383817748427148743825551484531015510921468786,1101225237704833038158629315572001954736901561630376626230649410760022507678193884840337697203062085224090855272192828170013649058324578888545/957381323179394144317697383309467260456865119729058756865540198788131431467861061365179872703574448567656910161443133562613974954361275757117,35680885970739092537213320407152057534822320028914773017007817813373710713753034960735931142648584846348165557877686823592524118397386657629106/30279582936516255242070493628109761916395693364834192686223633745908217560979309125265717567093961319436596211430827743682845848911835609378381,33451747353753911257687845194857797123630411807431708806390092231421506611816052239932019714358478797852132134360614934404892318893609762716414/27922334594175441069034707790484285380082757846208905796354265118262771330088422938769741584520960709665585201147906931934644937812892568739519,1044281092848858450722555782960497625713555774383134844254751241281833316578079947305470359427816018558590122351275238080789720941741529081342/919284071999857331997863094814130082804689833764612031796305013033562293755888242699878587789393029647411104837506297696137635926330550224661,9147562500033269230519754474926423422040392364888589487983323731770833158108718039258737063280031109095323179123369946337029163680103110395079/8002799718975920304261131932060627581143071375489366873234821897107534398048511335916710434686957574278670004508027402695496975738796705959042,56238478501928808679070712979201233752338725716771125155626035371541372937689336586535210466353149217433970702224434011368134791831073233551/45734931303598238085790214613462980791104579968360924399233453164795252349128823693956598126255488269132227970588497334614096358287830791726,7279676540636564702469738037353600931238255359729160997278652828459019066532217925042076744682130116979130360439104498706823459760264791770684/6942508474921206477043257411803138161184899456417624116043412792825611397283318795540841276874152338461683030202600754341207393819439543368449,403538558337419382174630408575388281300960003034030956604376470942819938831417414911967732432938041000740887135978907257782585852793042991967/332758758809615238666511217182186205397853210248688408095945445260316033054125788542470081739691923355958636177574730245577821232908816940648,1105093694803277090650099677130605429238090365338816457637941373049106832438864764568711601522284650737850241086379521077827810669620454574229/730234969557996252691759255606037814601302927815171669465660058011528245128886319859869218023881287605237808701591283182443619405390224495056,37077316343877172563253112865435039069788080535236523711887979601918352107581955624755575689598583274793591698518384023319604540619118631615258/24398690109529406926872821412005087713692166999330955499320209162298129954042194693306015068763479406517578182259494509585264318612565412834841,8486435000323746417693798230768928189733168019257209297037432887418725752873205909515055447106190206302127356879971028499884107573066502776286/6467798509205739887567724870953350920998303975698329452470385876631512081507214176804455367652887738347954417464859252701922292978863110730147,9138053935258902320761614795961670304239431840920069269315999234247389553836939608209753834586169658678829992669862583596553680020910269905394/6962572026606739328025731317456142508821089462394293785345159210561189376078834945074420650898384908547563366855120017038458030090658445239937,40452918419244173242598616619782379906460943681667469091978227366940086607523992382612636405993309817809426633965240263993782805225751229575/17685042143688237187332340743679527730981755212439778405864028144167489927229367465973020755420072830308646624111930019064652170491548169518,39891182652142015012209553657185622061702345678337198481890997285570954635641059744469976227623546890043511543562572343069503034597123017353873/27747469960461463036972298954961225463985676287853526890955958474123143534902610308773074632440268124336659508835500166418832243440447936644528,961613510473372978811306212080559163119644446412781317146040243664168795163959652611572269242592715610951286117838143401446616985907443306259/418600587890432687195877617679673893948711254830292192858624719223962583255492935055611530513509550497753056948219024626757065468123061740868,285007008694693225759819734386455964397241532757636402021936925462581337672150076128462493812211657356208372097165645857318626705812743929007/65589695739738621720257442740457352389635397291541905441756939894382528872583797693555731957177022234971894143844443832836628935979943959200,3051066103292547628779175214380402423558854004597098889764544409486672524322386898834383858436479393463707897040269710391940403646692250908718/2455962565594654687668609223702078326225991411681447706308145544895475613137865179138236860851610097672460791013056004724606103952721425457319,1015894964914283552092633910465532396253350592879650539704319581176908315447459735478568451246292612184265016937929193823951955918708585269517/945615137657756900268170454233979644543768399501736616470145348562641866934752622522919294349814516960777532468388506940631633683450329174848,9862095917691223880559357372003578289719721608985896671540430125900954368110788800809883648986136756881568920852853904341888288077086498375/7779622069927558623168256720932931041169411871572863904484689419533179116814235378402437044447856527388678514405290861376986461723510734974,988528161431381290920790367376828703429720931861894261437331905430432672980986571818538811097779211588380949612113542116971277919273396096431/861214780637868475349799893232836273616007603780059492232635471371503581981345965539469945012967809568179538402782554318538635664355340679824,368296639781734788392079235961254074506972988008751898868789449795602600343476238977612930064241199137231967472099350685249314574935186708627/331249346575056100398313298440759378081917691412053298927179193015612981791201985053707534464398231345255475499002833443259579431052036396648,8092093738254648047970666429037556803772509271155034126208486375104756611923289693204662712970771295459698255728850171867811329407541997906599/6800897836336334926149845560689116626764996302678755597770679386950985877591244559495404255529688490049718461201072718328809018289435258264992,84136258971689670163491466506446654332626460055034907600015208146253780845970576408312981608267717699228071477959015837717035921781822149939/60506357763940618234970587462048721901708874852941913998878364864709602777506888435472442191747994624800076085676321136692451584740400838068,935421496335495406561156452065232492806960446279803228100551119249106978301933471228596607539012974239446535994108951366325431567539376240687/859007549479735954768950604277654241234639794364899676126854474520187459992620984775972619997121285339122245148699469754736184779603467541148,20611173467256405041049049772782647646098322621228071562646802489503096474612972822001998446303932888806751235278691625177759422122922011614/156112328249350537668528051635672571911599668010214475781178006311547108671778538722432186946929935123135950010397130012145593816556310961,1259002287810671836846817680284430466555394453260422632859581543642949794329994156565713912238831384603015382353410579528597179278580532224547/1050541086417713029838522724929658695520016538845649746920280658482159065217808911974648435600662780964302463035008555033234633608113148201616,738904244474475823573724539960798181414086416848734422182036171701649347375232390492654351250594894508099296358564249550199058215489112177437/616054619926364953521397682022046110747593131814704756654724040781804528082900197829300310300617229799943609513147710083683544021524813768236,634761297203569715135660716284398721687867222405209968337074296669054325886645623461814586352381651067497044123213378207968093786161006392939/530545522356928011460056511716634307241634742262617194479740329408509150887439265950927214734883220571956779714564789117677509673681431314062,5320229468655832934997414627306199019558864775798495272150292154651781753296259681479137250369620242964038883929791848645859002205605457412974/1756965227787141183824705325051834164022309080114279477961709618502618081251964230533445416297137707092236762212221338682843715542892518834583,1720983144051994491997530841902662205976325075886644697903106030168867172548129842930038688089598722683643083584706516424048741657355240597434/1069302920436447623431799524983497155309314010145787824677823293038056531074878955732760588080173840778348485384859878344870866821911024369735,123494749167278408340767361844082771930989267013960759496905820448196092069787357949377277617995516457642557382601390199798922255558242934951/16920067302928750141286522419072843469103119539287854486480036176738227016033227944625792411942961169570676897816292758769838751458002912292,12655175506920155474080786676420823717564240371025434950473985839244730349899308544231403057040117976437072955730556902546969715543511785850762/8743622163456398264172042395698378398653871269843591897593698278280655752923257885859361971864765418436854673691403807679858571972638068795973,12125026664324887763948466648793055701371385036461477030638882659514228350732186384325522564590060961634744114652499757047610229947886860182026/9615790748750231856912887364012117936033144300991052309928645442571687075050866716317893486886012620812770516765963985324083451088948663256763,21160853362839327604450992588021671075581380992737952226859990128368422269417430177025677409269179690070269932351402476398035343519826851640882/14747214503250273782014945940597104556875888795107066622602600809435029863413719197780171151056250366458856787875984022244049518203707742011921,2743688168469967101063112782782799293199994863760417055223050668925577901990043899037911403284471412726444019678804445160274900418577665578246/1746075159928631351640818459033829113480483105119701106822620607125030144188173620423923781960249689796545205476830969411766399971315569861931,7438734783174322974339783704860219909666089762943214923334058472325443820551260351489475694025164602802307685796529066291059695012303585350511/4767600593977000297157785403561926887060993682543339834129517808685711349537152734878958651857484771602076450036125846925778963717197710903714,1387581816997441011485184960312562429651916164223236297505399165565070382209341575774119756877898184765268122983131305334166228436868295679199/1156357928739607306958483109593700331920806044520386361066272691957891171658869209786592781779730963888654976547508718755956463380432455911985,220772015141765865542019461481629305959940648569602612721899733540021245196112108464181464303204459539276536522421224294803781394839069622050/186534069760229370045115842419949104768813005584380658263012654802470472606501629576114525584791480869091414193574272237262684288163286661941,448293752765976262272752690858502406861009706068953376040189436681381802207520272221638128384115543213028613896605226504556948288705984712323/168455189232555735957337500171097835792603445039026822701675420125170866641678980741686761054305006677958991533921216217706265899303214497283,196283409045397163345847067561200045612914515510575924233652207763964585621272415700428473026972655306658234124705329317315514454130676825778/119679162070159637746720361439954466484305952997789292139437957443200370679579540971167601435690580831573529871595202301628883785471123740463,4398076399506171752077858412011649425565206799089009257835522029083222864456560783701024558540120135491807509063600012933915293039706805238506/889225450274012651010750438844167499109186789473616192288885670908464708185956850930522011939598596509010473432585159439818597852666283217205,-18710793252983486565593307641507473899478003700120478187247334753670942579328496682567785459666941234708298295396048597671287534179550565629/35656779959204714598081701567615423513573270154248091276904805204078205831393054745590241543929775494343964784961877159783099663027609612026,-1007635138373523202115858773062986897848228127597561371724146553393978955904265079291279654329462658971163185661667591845447831881179699767602/1221255939053271040564457154556481465690148969880655031199052281233519431359314197112521080795428041303529495457041269243109636030979387426771,-733167862066914609032646766379041678087458815787488020863305729182125051580398519285485727523887558369039283140477825374511886238100729178499/904730506151578703482783536104855848323430911098123817073813006092308592341534333647513916852300658406967389392454618766373032109665849433427,-126830888747029238577423086091725206030030729037733700031037362129866378200880208707471981214492808464691183304467905403908776632648209067649/241765593289538724006502434934549408487337215639070460378180920375731784656851485236965831408024789993726613382622459608834112567336903942320,-151312695985087188035667603754681177817524280565363121858370388234374678079359392780456512054927465811759259921341627237425109314692878049801/287576960642740535556564247821901152851561738956377849880570299571734678682639314361288637214149760158464997254984033688299926082357100023504,-373576840643246149326374584572485577097141156232656451010422555600498528972969652416621333729595638922515977334060557271581045238364189986509/711436552614431441348038349767482363948349808588647083048858911738375157229004625812211242978395352608956073002189423304283545019659452055568,-84225045266431397709176165302901530819056942304002161070567465407996726077531839220733114029533923668054198742555535395535703409739029060014/155429742488138829361447485238466063497649875347503659441409730998303315615759487764079949229272728376083658696408322058052030113052669275485,-42768930385499487679863908018579278964707908368607624870826492532539005434360406068121203450169910953853227254287096748345364712475294107897/60352138358274801480464884611330687416896459497188285989866698721454323242187772028085451250061407371106046293828874604752612674236782568197,-1729967223040668067440767252251436025076733238212990370706744843137594312325074893007253992610715008432280032668452170931498933414901058530798/5030523479691894692579060442429371957364752907516747873427061280622924012222101172357136317841122545580619779648648030237986767069160180262345,-601920675984896685789519413904691115466338525309292265991772975393572425095859636323310949090377856338404007187136325512162992110903708994962/1497530262777783450439711057552827849752140835487540927423885832417589250908639310043548471890805139383142051174551776482759463337347216511387,-1121769992778435129710123273177974608842069339614180661833321370319914285137567280862666839021295095716724328543329680866716573051852011591022/726339087513611796769778216925603118053987100821549714904371259865181558779690395624636124377706510878564371050684197663690857008287219473265,-198513258466761369532156326068467083705213115666727310611385573217218796162975169154755592762870637355981889662734379755985355866302075096118/153576575322186563502725729681662002511351652720598636287590402450693297882486335523546150274429040968603563290475023063403352455308100421925,-183667136143543741568787757634475790729200378643176087863931903040743478402471750318147445629018589854243633718384141778192629492536732018502/91186375666101471584660327926898005674195649416014088835141379479036251074213421664845988979473851833052547567363027657722367121877448668567,-129541933110887883344361349459836417826427817107818684389869488975759530023417946824389931333689385575951588683941828124793095226630053529551/215355559893823303308722174674343256839477074039891103799553112769166238574124284546167484533993222889816821953659707057499289107846434699576,406086188720515630993408462118464582712677622403930561142640165516931061162531641346696468542333613215697964076631579213069069162783843906407/267515761595234365769338649159132202821131311283880141845807337763184821925029386715517717880427139103204341067780397423536607520875828002936,-109360065160187886653343836269379292817777362396989989247181338568840439165455666416716549133409557082272940402513540939054734277140618023978/40842656803104277473988946696825273648364866002947078883524718917804925594828558572374876685553144941590038879286268849965298913590047815989,307807202201946677248197946019085443400603352453242217629950417270769616677263149684213365405316487793742111536365790338890467478072563502781/8423726784076957153868983490477208684828483155644072458455849523747453766519788621190477428728750541959767824916796653409820006503744366021792,-7990618184593808108533902082016514406828595913474310915942147087924922750189259552198003046038193562898055922075047420539257070884399438507897/69150573886117299416414156548966322917258267933976108855603172146376814342908856973810884252745585743144934516031138348480330960828250743354848,709220156985312209370320083055980889308321513831516503226271407759919916025346767648633771875245360499493100514362414167437063220530601206741/20066432092837005411070304652454924791673560226827477026470021155977539797936298383059227404494387156875698972367115508744559692940619688738128,96744714847047340624258544541835561592191885664094498785305205803039436199499076948184711194364210361262421783515353358662379088677429326023/2392776217405814392712290433387847306541381903591170861801478583345679025082792032264452191983316128924499835357850766208335181292007936640436,701223885032459665827930670931626808325592471310643956702172408892481508390747448095061246184664753316824763019599695728485726292199056315707/16828047130277579934789524464039815187209489519496254672821599258620519341506004312821347711966849567037999029347517469937073866102415476616544,89821302764609476150511375490944126392249046607343086139631227656311847237718912545681690319021891642786121854850601297415225262382454173/511758171873420763939365854688546691513703961963251857763211961071766432858475934841255138538457719347823778843595141957367138573484694228,-5436108182015105015693171230879648482268692551466446161331083748399495987079627071156769732265635078437516081095093808371658794407102441417133/18697426592708923198824637440914048542886053265569753886512514444995497342632651329079647991324175462754644026058471052123103622342681185583454,-12350837499765557887954479323271668390891101877457280673441229582362671453314117690524208931155839643889574557608760285766294124269318774581645/33607447185802906225094560695676122214683481916832302203270814285770398797181529951580852100201287650842243330452299045826435016966150724622264,-829307049700948719892291832152898187597959741190763770837887066449656252700473016557963997367384186440180195756071850328165405219844822460147/2594579787533467466638969607936789681080397452629690411972069399450511790570803960465172795939592398796569918452836902299257048776189271695512,-8766730539178099662965446919141912299576297233900270413981753009206759480346180190490726998002062276308428675593025406466326989379867891994385/10262385899209815849472469504545807713261117828186841238685226292670966244477123903155639336886190375706230715261226505396366495205500082283648,-349498072213464408092687687636829055748268134669080681688398525325131324342216477498620277536352534817889134776695306358165789076798169142854/2200905699514422053600286121950427475099840294712810327307538531752541921686746392632255841271613973655696864621530494914628565589233410534399,-2275677095976295711328848587815488585761904378863992637630190136045718779954803820335686635459217860431629604002425763050629131951711851832722/7681107700341303466104462062403866166486886609599180052091542813635561718976130408651939630501532607136849332052735253192936825167134413859661,-191508954718398971388409463079875482812291333387685769478872371560148386607420970335010285993430928931758467989283297381955288006017793782003649/549183412560004179198604925645958364513507964635379340881763827104357462890708749089333687933168582708036169358528926711376027154112946570142912,-15094196354257521591237775371250373195042405965667315036595348672241488449639984001747563124082407568159328050546320198805353695284702447200719/44315979439201074850824986649976888353698113538405490514667577508793697438403307344981936729572903032451206927523853857603538830143312379834184,-1790398703911918926997125193004543911833474937181577783013762185765135048334438122726470467877650629274189792600873856976448699524279020575969/6656512935983618925939999612999385812601743127216869078042322339814780941724992480833958318457130509534771780110095954425113670011223130980468,-5902086948891011990119638872336484945313655337770397350600676566957750547014078079171593834502016623067155150752072343273699539517868103107573/37224212565790836513625764834692314736682875625788598419123057111363974152211734801264192499537955303723527762018446259523864337669868550163008,-143711842926998079339306965549515993105256655434307011695863932780439379704728282909987082697264062547554945328423884908791463115826768537901/3283697829986830606657917194545009747742240536205845035825032930899728918950094966673934882568823190762646199742386711308602861578162743761001,-301791516196062130059078051081031336186357554896591819505226929711044367560710049030092189356286010671655522342905164195189701134858108971229/3269235291145471508720969532304629092245400451303834657255859679555270392641741004896570881267850313241531674739571974313353967281933077848152,-122104508227949346898872183302973051284268099996897005340087592231757208960096971073844921454917045141850796305554670974467936435222357053659/2041188582140320712990236839887911407752271371998464975868365482636934285674830892516142695414435145415199831158809307146207986734585462466346,-991244399998329598718876388066637585194239426785073925094248867786491663308309766965837346617484780034481884982356764230934928816997909813723/22436572740268448829781987934239023597022718406844941765493885591002022305269217193577301141700789128613067428816206246176042703976745080164103,-4602060957530342843889931499962054738241377466038567053035147244957452837321672072131075611269633616485256506496384213618746327633019528234094/16938116538754861582398944827906266697154520306695373848094278785563941648874896089411477601275615729649582471293763134765456451427541417910107,-1093623002272587027021611737949346967148116072621433516355940928678658593241190225958712801574588379966127380652755167152656297976447300235654/6965344267989757738907506426238166702253707814335410446736814815278803384520425784180787112236458451935207328527247044706820860777137260572935,-146502084213068709147479981069125163397717091700868244716712519297625305989387578470822903731146783926834859648654254160837041160799094772067/468156196532744894964823183156249895370473767193080135976967032344984700285672825155871856163715114251814784112090889872289470300444342832,-5239141015060526428316919456944531400939418853504264041673496603398539088383368242104988468562773261929236144517953777577441599303619777852591/1473692105387686787763688306181107542255974505903819283294840468820178340154856994230699382546092121139998873257985786158676911942729635624683,2167052556057349367170706356899699180016828883830943343156274422022191128921863955440729532741881013104209207862193918130445645461676005014853/4974719255883026409652319130931051065975618549272152322387837987684702345079220356160931908087487264909442843278045637381714180684035662673899,805004390297847109175471631712189861489975426853695078163237319878851649069243213287947668219218041026865652111312303007733620473846069114178/59840755106392918717580508283558796216610843652105898255773237835157508143498295933014387716119613759438191578188892061878976939863496518173,796837442820789445168747756933052225427576980703233420097638053650841682055449626843977729721293388786825166303875300023550720705940246701065/3740975104855926457310393976497560110412931800823950246905520406073080319633747035960517319904170528967526162362516088979157767963603557204368,2417901496381448146075740404337504963194432611900916215338798190916087183052266524776469548920571057625147248286424449764748925276203910138287/140064930908143892068463333184823511397311114409367247560818081148931870052597196019934826130528106399926980400815323666500496055950710854468,402421347314185643888726264153125856288313565839446874728262430823789403302083068893324276397384065047328219018978908195290974633459870779/30849146400180499302596280868537970724473935355984057277942256159088633772180390514436101094636061072857509174057016281544306819082325303,2318700558856024137668283555776497480862130754548270601661435382244377900793285118707464027027658327809300275898267571931176267754597622586175/139341689502505502941843917218853536193397600553486211488986019623270682006484158018331999988129937827549410797991853681066382196624066883376,799176622789369700495654632019164150766818714190491048620793364098110499334147455619467818167082013437909998053753526724977262198305821792468/460427182706669670627278301397181447024696461215577506125085492172773847683649857447971475129041863857583909356274290323913340275842705939271,126953558272527554684494244352871294069264393847159937544006754428596666866057110797291618630402078862562490053256699548024070724509111610365/41435705864573742714467684685017487423825369657163597136367904280291704492002901813440922435608474895631437439180550994715584879192503739279,183420308458799966202466491107045016419976027624139942923906376474810363709274235345064734193456912437859415968146987201446618188962150060105/71779853470281714675972479767444272914589118717237641174873394251916282207100239746164291715476084725173145346844884415033722833938671219328,44734862243639402900337160870030398699549377569958032821149146951978371045138084763245031721426162624899010213275754431813431036294706679785/29934040964253165068242592758741324130978968783421534822198142091616471509593694222603889204866216661022950882031500965536106363350705582633,-5951014239787430423803516270185473530953543819767163678204962375794846738711778358592968448518084102476917699674725522809228880987955006559/7170617685949925577970171728629740661668152375871624316339729342866373862800469796954892023313349824741372569096280042408518794548558674068,-137068059577388862763237067516228732180562649582364800495232037152991770784442395762872371083021820570119850521698956293201832764223840997/21174651874402974513995601919049850993665260165652926433366953563596313724794720985591626860729266260537771900199847861813819553715880238,-20696880210965594523363822287522010291446596221865013554572854552396285657078943474452516084080614205590405630772081266635591725008169518438/9831709857877074696702003247632110806708072857452094438010151690566202159377580386576784189659451607200893061954891776324855368769331556625,-1185728517466378375838193273495457217243747880100609928306927126737012745554017861011755762539099926025639835590234717380549225006134016463/481527902772603362121560309257866935269717839265851520813376073775113972524535439091368687348422496714019176328628779111194170787748998532,-8576507440146674287487905471864913145506527733897968109943648590706083135238804803550296152828397665678288086501853708301970571655557419855/6088680153991667963351553641090912776291747133417008153451981563911138374499668033203684228810575108589707373313275866563146225510779931066,-5144026962552687883866627160828791564337802826227392853912997074455817846338691289428317374116299821302389732379878566192360542547782018485/787255048966315939240084144157936049673768409134565878090804414564282419863614549450921709588568092403624413583941185745298318653375844286,142931331302323024844831713313156876197296547807727617006683688989361905146650313073911566948985497396719176147098620260740631912917233876197/69774245542089295242972239386257620702125972857926220561148905692033992139094759043825171709834084514547833814803742233568443296792901113964,-279928521494691016771277114493133528507957410797139855295458719743624702724872404346610745527764382161348466896574723748413772555960417118198/110870522721119374099763724823395171902645446437756251478388418719981542638526642025486090600468488293863655346462342227486174577359704871337,-23858575193734706860512056523248963806689456669221927846658617640060433785208810730434126585859553718454704517226385756811401852433233966520/10910293879581304045060704562304797398444815894977829018989549994765719271385844479274323210484386380584227895688636537012538191722269406103,-7396605451408193654178045524861071575178975573971370272097905823816929693608651361822599674030828027487828838880051031861636416085670156681254/7367329828243302568655483477622484190504375340585665143713354290016714305566149429019652092171338949281606236141695211825240876538793039398027,-657591997551083093564012979720967825987258682043634126755751219500009665755548355737663784581462936326852154384520646874475337395221296421608577/653621351162680775105268913638548303903333366824007182851684893335302025529653809967190327176988105209686358701062933341636746218974261106488496,-29566246894631730892433705202932992736756135352026610793727238502192694201324980854278210009170990723435040811149451956570492063008874074019279/28480289502870990584697421550864230284104649350399509521079434702489519171635689633100546076298649686299912956653744200147871198309255698987504,-241753300980667417899250180956705337324580960167307908517642956000488219354339099300439861684819012711559440137168171097272422302186084094632232/169940321842266570859990221953265694860042317322607767320355545656510117643941573771748412169599701011424159090065799159857074349122874264087653,-679845905793194196923549913402714442050509151679697675480915864089116011327446178300697569559431649469650274962568485600463519140174779182275721/457018075697439683635966400165461959670612411429284146976111028061861486308698450354014566405104466348412652573702712091445679434043154126706294,-344123618793239823630748324384300416509718138939767711893243054632914416291243836851020462058007132443640531590816709195496671213296474804569472/235909206088905284652279165343159369079234150222284563298282992772508475541797012845614896876075333244849084379418423375604081261322765711105909,-4466496552454099790779093250511701405842232241887869766185347597820259542878795011575451669858388301666144382133334160439165994585018536731504/2870569644632863123896468329050121589688586622184058430091682691546481738779199987119459101937283562063146787925160404424538650924078817841559,-412171859454341261118452448117098437305730819065493000210980649946229355281147267299343453139584760483258556678650008603805153782657920812249/404802695377259696489739348115798205522785541722565512539098473364153778755308257137274498219146383473374791314538192451364875689934837446444,-356293279010672640190930464527576384977229699603594174635384903589482126963850886683545982883993421962192395392989076524773287950104666414081/360020245689094884257404352493056684052057856113246753416634332343612710274738748636948257833655185160122991916721606260331792710942833034958,-2698733717338587618871685375667685606815526235911749280742036659604023723803460062126997659595368569099254685063079328275104167582842937860677/2763120524441052014350889981511314436789660873686360814854283573851593030634815127357071431313888739399340700816795770627624105652846331812761,-143750494330889351894996771371481004942821787571544348593556614853451180842930232482698135795786697580641331163651026851296166384676699615617/147875347035696942136502256149883498346326869365354488060999106440037683570656371516933669170313980946111588666420765991773272390431583647987,-41949293981586622511283013924330229961769321629395918977538184487104046927608694503541656290197081759038254797655888919821433730763282279287/43151894777281704239563133501702761806662641680029339371826098272358145878527534175764429363513801205546609365984443507735282669935975034839,-44166914356886647982863376924380481235304890751942135308116786991269726345718940977225101079223520267102680770419050646647336182318533795597413/45083422164603859049699840207520493544017860821708051706421113194700484746405123322738017299794424474216355944990831830390738152187916353271344,-1126934526733557899894364447888715745375344924808280442051684804755334925852159394681941079588011446375569445440184553498769405844914188935357/1154677494238050597385478601588190319217956513301028104494553795070742540380707468026203206759283832479799740503044603155916984871382667329744,-909398359504336369905304136095489932729501050829662842826572198644388908016849608853296949768465067488307981256912530997994222719882308163664/560656828806118911449780238544305145134621169255766175353554807619647744633070819925243741428362973833844507475866534498838272621516309766441,-12553625352861381646239014380058657695039229381522474385498563052424516782988589513659649850662433328737874752686071253819641837777490809707836/7915769771917219752941471062128716543437528847858597010090180482905017833203004612964012155643527207991363944598276591743535210663347558392873,-696137394103507030200362415813655028099408361899328332489068164538845009370506705911155280905578756016133374574075540084967412354370131570402/241511239099209785601075636328456075887586509874489931193350368137692696574321640851805179077371976036115200362282234532863842097528061439581,-805149457175612930314744437231263558503335423101882315023123907951358877229825867529981598902870769860457617712737359479819476458262469599408/409075726972193773781960417516263495618273433801784899094785660123013577833745794276511751851090488076903313257160982234247538993296970094029,-8744093942288197973619713069086006689831552748361855577883552857658344852540095664437429442152216108831123626654933246014645424007313498538321/3361325794058859981521243761364077769652700514779574136788992306956763685376066408673243092881419954818035775153220612122787127751220705032568,-602355575866596421419344030351777053881806865466666381207212470487193791561463927007311531088710632284403181703375195914953746788587271885019/283746172409472259789690686912928932599117334747496472098074500689196928147647640421207438554206007799412727508239284834470992023880388725026,-2071839055811958636946310776224608128111629691035180658340207831078690713758482185377590872006317959438367574973588535649224011163346722728687/2073302565910268062861730461464346503272354063728157329235196503981325751052040244501023189551598369777662064920383734803012984402423225676402,-1229184873054856276738588612604460690244989178476261756233035263017367493418472551697993587595805775785465358761827634828630976623039577855963/1240149010527976023640006703218366121781797039840241374614268549585535593087398052916803851867123557250563541205586524380219485861664356157312,-191303499189498653414313379156298986202898287688810400713284681609726255759772493451984195481629801286513521926613817921799121835932712594933/196269667191075220997979488282468702663261306854223392067940735169881285589713669041190613744504156927919953907592554982579239413117145754638,-24068764589567913914263968759582114182602631042498202214561292595139721914997936299604865422739664680770444087295627905021968067350658716631248/17617203139278102987296383205843167470722044071485503618693934529793401868497064638611986833144186369886477781967922770745162461657759573986463,-6390206958718215138792892431726034592025868470032867257773017799285679941991817467735564004305730708443352040580430699228537098509546683972574/5062966200174831020129517096096322686854631343444065804277473554441934467800413885450072488160832972001865017392416998383631323975578405663221,-3599386240306982281854353734056142814973310318251452282453979057578449482802441079473504188253027801545058360565292388831572701966684163651644/2702239977019587622414371610736575863435358317301525101746444411812531390340477025024300331688681292515546159748210275598634325262599615691929,-214772128917893672466932129586829501689847887931954022900652334701510671399749131321945842833733092943216669228113730155425499536116200817264563/213521773048971545954332326343698984284611039592426099888447938599875968660992995990717545616760422227502014692330445992533868402927827909453472,-56725501698773302038758618851220130495658555443306967878865305423471364135615356660717366843994394967947486709750225670187210585303095060306504/56470230219575680624295826795535827050486451645144973866388980151319648300820251550534145203042418919167317033550544174164953384072733853724789,-60691836456826539832480972311459027755357826412467897334735942046323409571366404116132522264556649831259874718370838420282306500309128817427839/35409554305917823067720087587455504058272779313943856628869308177415608387125921471874809332905678088585663178765187516425369481441063062442816,-277595836070500583769696357236844552869244873598919475078155777898098064040996854531469729877171502961111941810006724978320196158538031797952712/115031346536282580594932693242084392966591007128192831492839814411294549486346643616737664838621311933651602955980081730749990782521302043852467,-633067566540083669655064353597413535491206230417156798335759468520549294358311917472610549326174040912187977408776325827973760827711324521241/519365265250651589114920062675651610969774469977756927517945759672681647662587540893245530639359231713207531010855626484684544244356559697056,-3910939696383503049341796823008420465469432648432767656426943918303602603153585253548167399129835552494334098272487979319176979275169414421513/3977902495297626427046078909516663649868292812022214345763668612501475441428453130977793639760103346157021845608375349710562713079316143166368,-54218478096607853601216377351679125630546326870729954060791194613704842033651184595339387123857173665986286563191039660901561756661295502048963/14012820819081996587283949579941417718726345837845908392187639713950460570928104722659564004893641216215404287290472428987253967695570863226432,-34784247500960744520489246867444402691928753759388117156030528135084833904033726193386837053337209100122375245831919195802540076287949340927729/24562766416366690141227614376630690710577742697405431305068135037911744602336612308933083009720661025385366685791492568092106541651778398152056,-13228135475819826739294302697374726616149985836058935468567461337125729384831964194563497961386057010272159886218835217111596206825290522435881/1351968165984298459013417706226295465105649814857968899908291382936487553566041758217717813161514473771263051976621804040898597391955595011848,-39445702491664389273550235638458561624712859774773808884082021200450135254829120696340831721657552642406680300801605820699739858337597708807/33714008073284202330913190238406378738455008899971275640497579072520595756302114892881154544872012811991735097110069175958792412679131254528,-8132965636526127558701086001427055604748854147289743570326171749244069151049249893415294044776896060906272524588980377807825050561135752740215/1083545329086175851933744849355659015376189495407477670631586127068203278045178257910044996701170249165439315181486362379766987888333998890272,-35779684979625241157810533557467055770033703347841971061823171110770582256332066972067119021333935358993541873248549041182342656829034658539512/10444533386301524973448658458644901267945188187261176204883738148813873216434285108305349541419308527006449726311128229072035763699024750370289,-3203495835923926047894918352369177059233458386630585921027136338641388692113025766541469331186836584862663661061888264482927449762197909688594/150738539083035908321597544631568035964635333043019705968302894577806792915386600426873470325727348347515957713770108556812650881117103660011,-26817099771021901980017407055962484416092320241582874586132386566563481588801338102569307864118649467101539063437875693508541008688540921458132/9451796955374159617993412218714379226724022366845006154057517340280201569635387858395718867247520308249183873645970570673035280099302584869667,-217043955946492007123453311787196597002776986084352921118535433045450023001939036406870078620159378498970777976737049645429723091814027871498586/143437042053752484743034436223183212405077601591995579521020514038808701823632400621912089537213505125364048830194638974186390293679217707509285,-54514850017930796828403538774810886665345144785201920411769355097474596066627129876631454331578840897190245249950228759788583443504156596115937/36917637888844542776356472992232064274407600822759279980674975628558997977897889839541347798385510004524709937987012374016656004487360844406846,-2882206655216566191958982105101526502668003477648998392917264940387279083812156493966281674218388756835682552469231371654424213806065009313783/2424428917778400282297880388442193626929463094699643609895488464088246658683336224783924130116275749244765162300632168591893782269408976684914,-503433313714128892026898456242685393340025732659634214137632419580184609123642200103263874289050609341511668150495562374254083501847098151633/371408849756776090547027295263530105087452408845216922711534665241532312421172176352644576485457000169681889374738888151230572041759026964785,-15138060740944501384600106567801333253273122124944692895778474705302641792332729321088049236397104528318569831163209025650242649480597984125/54324921755847907639973890342336153032028665706033282154879078013602092417648164849243141194325253614524335107396527378393786653637314379408,-101075949858382939642275090136349518313348615738281494524481802179334664003188543789148901070300238356010896007956048440103713687276322569143/343767326034206620821302376196468533876140517557107668343226072413642231398084859394672851680591916102711075707705898249304796385113318350809,-4294583775678570946486285206431893874823730199914031868602810645961692984698461938266390513405178280193773677622117990334908544504785273554246/4962143739358318690367947503111093326356030061028676654912487003467762735857563223516622925639661192432941456512977431447347094494570613197185,-1047360403480223038502023758037331819444282415441599103117390707209122558934152346016514327948377951895311624543023761322666458198818823470258/4579581088666228048147593331867312506358507554873009866666504077242492170773409126379777085478024861026119854272813200047085389038209316815347,-2915109196324095314958316884115483379261311052133626648228862051860403027052054229023028904115022053957694642382327851304981866605564657891453798/2258900555565966209472598954019238989157942390788170189943054163037626336409716654363047460791237611673919052652081225947811633149355432851274917,-251073181697896129813602744887623252868172990439823363658946069751495629233790890688826698561676483970451613510594550733981018868717892100661559/210317217022194502501367813428065554932430408577285577634541268102492338036003799060629091922356851372012475736575474726014015813042731563439878,-48995258739639713345931331577326700243149230981705357211475182254725259752533893203816097691979255037299469700343681376229342996681975565454667/38882265389078598344775299170258741874430360924815171897802434195079948258742108878328571543305028015221713656504908131120368870883450513114286,-938964474374926073227884513194502571524732306916547534294360714266873866699154854244068448733904021082236107558502012120461949071853569530688/713090499953476046738667194056915458364826029928043890070856674366026298504953735839275963928288517159438436553951754140131173190956435967039,-69373463112561125274125849098107317703532937784113018847899149438805719359932806147486298826005286742461257564222066130475056800498983221999529/52153069516032483157117527945286167629109954921260583409867268101471516573746844670010982924994903085222569648662431527118397893236809004728708,-69144433301802868988521806333675007160413031239629901357436316181575553615512187054184845688025452923336616571780707305077091266329279227606/224185787438252355514942261198032016543454215824787021719376842953912013161451781843035722827088622793862854964630483713721766616665969118579,-95281751633048533275081318744407309814995549599067507899735333927431596699275759115560629727641220543933424674037512731656295909688948142437/117488611884898728740829471580679854117605659286535356585074270250949152434301561032414091482522244912177401784477997894520261732226671503442,-263483695336576049402652474752571454053306915263768666729770915927270589941714917349461349369636966794616353295048344104640799336590626813029/609868849826704295473657198436562641151623478100898275576821208951712761444583082805779857879588029480771130853338757230493152673962375674727,11701539193635401756311363054157797582442902542300506496561477411411452197192726995930029306632903893474119387600379900924220243296193814609/65305585606486873514045753679002299862092141797624239668088233018750928834342895737575320847702433469461922652473770929359891147853648399066,-2686156821120017634089047267181482082568322356988504224221224408050958147351016635423915603961179985323059735805770571259536527173122289066549/3504145091536768481943930948007162624987329495452377208688171499613341872121276191677338876805658871220857269881010754802633104441912198301092,106886353718449964359291839876578167497980046279657546380411658005674797205453055923681619096772680469735820203780377127690416287725319277477/76641769846698020737725242808771616142578925551988038707272861879272104481267538321476036801227040974491613948939404438212372956283695035878,8802514171727702084069495809251891335605063668876830143070893518156305665607788851625096362464885351357466620033562653150980528553078023961/23808460008482189976738124505747662205892524417427368310226379656162829964821930392436471772955946579923812102811400511554756523322135603574,-1690831602705583630451578623507131937248503088565636877595072984392791731746603754812298057095726813126375246955496732260484203810969138506359346/273575186010043871354293206579119589346516069336118768617158409385370073981276303684264932432258457896883446548486751700900347873969879460992329,-347577458971507899781073870397719613758537330969141687597706061278288803760978047665848940362096975986685725930706525681505968290377939096673/359809015861387599580201035611070450164844718626610061563533426517489890722528803173998287403181050858821877411109129450569680152146550355249,-4309024922813379531508446497201900860403940702884379094051548710178361456850154062268941765903978416836358676175405728396048231960719432450/1657623192496716246314222146008707665070738244036080260429774522928604214036351822783294960848639887243330756263670647696349602854611166419,-73312781838752607261835583026935739838978387627818302959399314815141508366340242804903156176795768942428627761186644011564722712725182381491/18902040912975939006707367362883285996418580331203034787313750798625085035584285316553802506502480810863424627759486866151111642032003959484,-52676893721687331426400336359506804078535930644510166795695216206091044846696310154213347270575742913770057038718422002033648676044901837334890/2611640079074353375584348302395053539203475098843072739524111382685959744504069977754659644452556026447865287000271122664428237546996880662067,-1554309233884217025746893022785898144917441845703862809954317227862491576585342217592295607765077393501624303674149195232240516032688158325840/108125221956450017532673989407552802469503555906731306759216084677956950668079713406736629975741609279333844863101180724893684281708401927549,-277306037211818789337025918054172255526652206850573498622846357680152958513736215351728356084283555173070489936531199134706515659554764834183/20985578729636310960174582298916122455372070430165918472504037290907614205890488489905063501650511293093884825060384594967850848513318349676,-1931370806953726576786184763047374666403638083842359284561615877387555097853589620568132625116663609668857323485614587266425769472103414433/2749634735551497039156352387185993498523876829134879349160448627522472040802179549527716987796316926841935903822647285616426444879639567804,-23522713010199633935419787075982697775367896118989814812143419774855717780977990645600896942872944630135396577299872423358252111790322872472/30766711354919160898090036091782465762481379567536046181328606987452243630205362582464740933111262301455420526673679640373528447661257124113,-33786116079588795680851681375945648686198506285799322764081686136459108051412584894099490123896217335913531929947302280779362634289046662704/15332117735165418771593428974029959978868299544589297316017804312781590387229887981715306650833649274314682990783602103985804892238018681401,-1330972654072916286811940167352562799636540867347799221718861155820166963018341515722648048595153184105410788825703369394044272623069716624809/904747349879286757641597893693569733788311356736169578886947317373772756691849287759235683855772313310619325881705202586551421894197064699544,-2411187304878664640565466746071181554209826501623288873992363804454498203197470484669653676169459469469362172109940548575397374212806740438987/3187338370485153477796938869141871762004899552174745353049145896236331033616515707000359966881192219350223096705794510453449835344016783722840,-991723445158825180428296097018931673505502238750704450328357046658435896305414663173134048634547061918287564655110315213545230154918704691609/676925265019334167371006876724301124568817991275248879413260129268218476804048299227554872175405129121839806156124828420258102777975656410248,-114089632251824703532977153466591548266406159120282520395291212516658111211531121057560065692469830068924238438917743710569413324304946401751/76796512706460530717965783090879227576396806672466340598569666171281789964930166005583354423598946660171590555834026412395779422777338675976,-611610453319044067907603999653073978320777071139269647577944849632608191171104978713269217798000112186624785448403587528311996664171581309005/411473624067066730286762379059634622449810934394377898768062144089583195302539926856561442184468964093276147502183264601654171915223570354456,-220260031537779966141853112848286223442800964312255968121017531968964000413307298758219905263678031016580123017195791653184771779101145418633/73921531645342034144047173944590996628648211604566713133914668483037678645759085651524730338977732190495043369932400003598429696836132075210,-1149593872889891092252597738875711863714082224896858170687866717698029589377360984247748868679093613261299313806395546158680263892034533588939/1174201688077732018819749936707779288143639101690023513689260635330820547724428292749917361565314678985164433386477985504282672491567724147544,-5508904518832155420318103350217802405189197208287246090269154435884025843998249240293054756574860291283574286771948651695675750727052784486963/8628861361405309815158613514486753979915770329432555584378652871421390555642317599524041494685794455531708369442611303257779995156944878170396,-107898173320476914700257097972423763267199912635312808932776264240990715117987168564466487259653505786515873232601258223416484612800806679951/182984478366698610631937919742248263856757020645662588637020439975687154550475697792028132017974074600608696724775697456283606944171423746406,-6343084699322918126389221777665219469945480577934725045124676805478920810557577675653012987655604419587000977671037903625052749239479311212029/2804173641570054529654056659398126022511203262674204740499618460979598027263234082416471806681024960178158901241697645516761876147230275614473,-163406178716871709766637500355785354006369195280005544391895071690954654948226447683581424387518886982696688611839487355266303540191293095267/72784004471047905605422998144604650446279130884392618556647886458684721784217746043132456907585736762259297568819632074673509836934701954378,-6204499868294827211518959965152208968345341363490818749878015565503774348030595526702028084427195203097415152405004783922882154085988670507/9968229458689236013058759846583427245409346857963876260610941430587660433435532678475825128210200963090941034291782802885973026946386999448,-4392111293068852260873027690566254982806703468447136840723176572589936273670770126564756424567768648917858170233151427902622562430650236929850/194836758742485055296825213331061096889682348047705552391826880303132717591209100695335916520845598090239599734727743735242783340244053242859,-78831126513738287269199304171739558789270123512972708535467728645538164256723808454146416939048477446405140556460442048879335168832730847599/108692574274769159394786576821738405365214283414299696787487281515739072979988558533562527774378809261816632556937909818776679524397932673736,51440766680001366833649603455115615384143955073700716789979635586016598781765189481754394716099572224630053505923759919995725678404358444287/6182641768225426404028490099420716339043450111027813302803547903771577219166824661998097702602052318411075052799939466873059448705966717899,3456630932190591860835894848260304577487081078196394526043219676908400507715054644380387940416793184055969877695047051129709839886092694507/31799533412914909250402089129218636467052535884187676119910028803924434379957589244006612915565330446412115865507957520426399244086648624011,-200847711121539320587949547724132748976126266253383792454119651902480181860221294663146475912784161348316097318720232382058036804815690364928/36299904212168498871488845930102451063381732747860016711689501664434941416463418991196868320488046679865838026571302675396643357219723496817,-6809584812115113449061982441979348400850486171772359615468508295393923249428327452376526863386343688175167646639071948720491889561474601573/1129900053983548216075957444352135922470344002082922712516338491739483139465597258840393090615200871045693187359020905754992173152778088952,44884691341721218624474398996855185665971855562703814873195517306585115702613979135592140598739098422600739280981046591802461358166279656943518/12449294262310836275439009119632295180365256172873202472162261642003316012135513494155440053180587764129689597675129488378715537624613567759459,4389129122850633946218984762346988274053101115504988446375444008487300940280157399594889320670934718654112222790850459316768894369866565054406/1562277877126785462261596380385758493407993285312096940221105725171982566012825139166750628482941813738909687609414237278968427360949977752295,5299077149623985866780273407953606010525579678978388315151012573338502705006414258320404368008011946327510949757607280620364902051290013987334/1441909741276488986764513376497247388305793513366086464427060844775064479941637449153694523925469828484198625637880295583096453811344612469559,2871913738304868671719336547233903132226050807230741362554116092285343776836849019934672988515338616533200363278408093619922642151984259780042/462501799728510519452634971603281652315967074283940700655672609085728554957668010476689992935765516899610770829836245432466722783785845558423,8478009153918372907086281042667139636482449172893215096697695113687419730441831293819894946041360298650846588816167138712083796904190559623978/141598673423289328111405922207743680377398356360731199498992183543245383992460782918817119853319841659948185776966809652616797119070761163589,988608758630090553771850733982820335578358088166283965868507968627568110888045980066465178276013871072669166363379016229445332803305518427442/240296763217624600620351314561232596588903005310420924834464571735755028460153582862754156773527039762500177481798731230151078828068007696989,1469975738221919465366043968085388820770280062716571911035456795009707491608608520594745561497838345898832696444461498402375153684009645544674/1877510832126935650979980146303303354605478363540190619224642010384892754505805535467333308345033383642174368902960761395971291369411551233951,2088548005605185687545009493075619543901854035338952514875928593188162657264996647072946278986014325705321447515084548249223118923784172444046/3189081692480321021560861474997932594477462924144681257320435878687547109770859969714329069538389082128983858305489566657352224192759350633941,-848620991667436448000205734987026009656410524127745095439187281801112797148934082705110321028388157938310212324825140745631337478345733999110/1107546755829162616054870909191106541999718982626223452665161863821850108432586754786471505447617888690356998758009099046935632960074106410861,-1277198551995368126200216787620224500590428681634336569664776804081139110886258778021663126747462047093006677634789634517464862671005116634166/1144299912278091281566917320932691578199308414162864307272923340756490389366542296474841624118375660173150427538373553670137312375559520693909,1349245561308915634457900145803991319032159187214127128632836887725002032989696005906160381344589170514508234772129627998450525527798540123634/553532027523797027483647663853584982094925654631158117734618000131158224092686274510368769975914229576179416337918538999158753828359552930183,6232814337155658786649875769109339319094744774909356699245964986852271337432463987926976897975746842244113636956974667689347576184423989207458/2491198101529824133639076412170619835696053869202128844919538622720313792891552907486161051564949844730481927921363687715552443426637783480117,6519347212891149414403522853542641826271310805900725036327593021464595680718857833269085518923220424240275584047453080310456464669235470479382/252003861328734184578264782286298964665564432914144907838351718455089691348475124906911369131064935481969896955225809840126940048892410937701,-106802682979380275643931019291280894667462230074493373463555571594194726709851411595551846463978310778088378147458086049602624011524254146990/102897304055588059081667516145967394449710772929127604043338469311226041658978172338501621429305673914729721789103110974301421719418610476591,-55570319580318488104800947158787503790850588589044525179142207740435916354429407550358573514382647620223075360327125850517199237627981426754/55380893947537053920864621406065331331558118741354397682240536027843671479759518316873746000777632942030271259790305360177044893008331725743,-462859146745295075023728538422387087625021466625382256528795387666154548976071097623921479356249008827832095484170582174516214542279830907174/201707389911338635108297786325387520995558961798217691931232014529706436958290668484076905273764433019515110783225668289184842099842562961357,-1371470510831118373611651988529114124000007555547806654981085680682222841479741522032240642019670613007072160705847188225915869007376221435650/1480788910902838251493395308058255245485690169466805510152900847237171036167084258234651955872656533318433995162394780578071899259495218192383,-430390144431409910559436192948234742655967669517815546509055312420926056421327252080657213651642016759917851081537156745867273865908768602/178355195682953646091583285008307910632960087077471585262723188629996247027251582831207077650630554511532034766975525490859282944010986451,-9204729014054610661888210900980036218580943947463265384536217686230964407911412011418670606637209516185793520759192463666424785028743830448098/9115756979024565324831996512965509845904090094901146325791578121848225426278588035394736421951002944631012480746375402074194970720924935020559,2258595698249937240346111586212765726160088093383987349721176052739526125246766521368104212723732645783453612825305063129689583662453100234838/263465475735842435475352916395438366100637706647996814972876093989764130640441678976841932430743686328406205054020109722540279909204591728625,4458095576507058969171815854422621280662647653536151143349737656725853542798721561159980735582402045336280593329732516634544274701606495757982/4481821395812262082427056860937374552328062711278417303525083857463355586050954227470932715744459403055112123230460810125947576090485399704263,9613837241454967847769915363653168538848708528179717503549895155731300443411910545380590365155190807211378283153468034586803767582925764621866/2903540773009019707689947900017631055271106015672994014148944526416952195068071669722541332435308709292956659026706615837405128819514724981709,962241650109076520383389786146866853941424503177528882899737716209286664682929013456647577016408353418281025936574659922782109022750611933362/1055613123123695417129686862588210807280616684454158043326975807581633031413933890067667019669785907123583520221596297612123200229585401907117,-3140415938360365450303313265358455542060926493303770420133554528331481780519135142711270005318161590595080921300583435527036492376652354541042/6505978976504464847252102627035368233635025955718464252732454472200758060292129992540032815755769370838542276430608497170035540080083950052087,940976797492044940446015389001797243102099740578511754893461032124210938654793292234753698184885576983298411668187276249861065321724256063002/50033647261599369540111167072303959027175456358803941650134789501632153066009786698538420446367473208309802283167232167271744347401139691211,-290442977315705535891913082158077730856669070400995097128479925588017853043270929607755284695526623225138943077725674351718664718566527633478/181313454682092894129759373344439506042446691116657955980774076926305474800199721349916310612986157607667651884171045180851314639549093790451,-231243277453019829330173011245273366458690138334274095741986376124890226955110856677873813979994499698389772209987760862114415854028995895458/611996338870425152877847645661321545959265215402922595787850467973156382419535580383806589121084870769212055790989683602101310526288035131839,1042759961582496085315293329380027852432010124725350331523300226131844162833540032798860840407351264466383878828449405566844135692908147573026/352815534339534722328988487886441232817664353591510624582965379322148460774961188612449633860789288837830492551962233939057910274717639447687,-3539299131659133210239014439061188214756177876753959433655387725489840855536232903132307032519282567358174235120861077685730138176071215663516/12903457983763591598767116261389460488957818105134759943621728158233926895171226095243164253217848482579334945195162070690047335908621092771,-2198981087731780833708004341486409914244042004425159298022982869242660223507206531970584495413908628424810710879742052673190349210685849750540/50901214398028320135406237121480996505980851307822372001798772375830378895908538206952068902845146655705796314096078218520974902574824400297,-8946923910936785650312723793502811047452073502251159663943762600679412307300768111700650428606756984234380160697253665208493704311240796843412/33789115090623646241884407936239655874783315884202404015818161042553697825221460901392584724606464117033933530533950839542104333484379622077,-7128383531510144236255925102636777170224597636323884077325653670038514327539789338495059395928757057283228298827489336949572442656699670391299/377469922622234291950391029156213195509971619135381516301948678844170258623586372197877176575871283765125635540135571188121528500807158889672,-5056720194102286510028191277831050015204452257465604221923883042281202894540601856437147078098597443069832281062897269568403731533576959856677/4062476417924259097384453011439777493963583395875202249896234908207088956274234944641741120835355936441314967161785109844473303310247915192953,-1710350656964978502157477001754970035211892017532267992803760043060269718442046146495332555029825451690191046073565174028609238522112021212524/910884240602045834361810026499877059641327795618388458655577542242272754732645234296957627631979204076528638071707002700968610029435955773683,-2311146046049088011895588861840165168942806617549474497389663766470477574659990929057870457477085206366937404109095801730234878970454199126483/424805036826360548288840495193472000476113392916751301375283773024572927509755302850885343585978184039612667076298751261276730818763147878496,-4815405978326346050577177099398616772617161978501170238469719640535924704896939918096745555850258004932613192486953422734481512505370091796339/479681286652060663839805875909860239279929222762817473264863547986871879817209901814735490113157999737577403801783770888446633352696267873208,-3704478804352587365060187059089603911106469522521378506161964159310685242304859535402899695700886357755934212274978683593655449902279853126511/226518470263894129062443851711619408344936751853561453112855416925361266387388140612588686665900360516793587462725969610327905938018137746985,-1468824104657342409190384059918129405592950299560387171507658902140838973269406384719015000437581046953489896841534487776560889886378404817630/247204195836556354237660374891735836205821843605495681479745065291249507895800392023095944417696962845384723353911573670884724220715784449679,-1258077474814697597880425074560062032597205779070795234950424742117481153166089028039172774227170657829697705189628204888947014897273338890106/117795310048735816109121286046832958208935306222285615174167282199740065156292577916892390147843183280354885460196339739079663148659732775695,-3618457680904454378580327555811941664241953308566832405143278229411023401983523614876893383786472452846147439589196493697227563179604936181767/159569008216274243418461307918197154094110577922676398862366973341951550926579380832124468889506025564551145293524455278646685368485280385020,-15160786312237939982500829876642249224235904256765342726159338861392602444179599213516860545573345276674787362929644642606746273493306863836348/7473763043353643103973637628490783891461103130059415291649705612789690916060396154576640389292943375222112459757563983067025109295408987008191,-32888426421715211024059147343405489178051709716397350659423909039383348866176454444965394668826465363537494088738148734005006447816196991736493/2127146747779610066597088621355952199427408864085426976142224856647743179498581483671665583990048505551547189529569711538408206208381726747448,-22874412385296459581320355700106180922834012757585199028667241368842816809407265785838359739164168089087631965529779189233192149218529508680/105219683954880920435661038377438698544036926623043653791851955417080480698489131449324896072870848104165464286140149676243332909630094081,-141231790622633814307018172255244659271945379171029652724101535141990881769204076446027934630710086233900460710738511717823322043076998918387/11696075171617812054670702637411528908113220527391742683869402697030263670346375842410128483867945279593346119125962050333758358246099187933,-1247295874206034319705351861305450362502757572763116310642931934364489358798184694610376423424593090074488193526522224589495969465940486381044/390205553484677759274938186880285588316896536951099490126159693420627123059160584403364645003664020856057849032665565138389709610641586295805,-3144331854358382189404517594886157683195919845825295308782592100992071990306247924849170509002361967219882334986861977735674917281962231425292/527706482476365619900122765406805153198409482179406628123114651198471663907391197195332799377982724474638456380728918673508642662214253061317,-1682424362716482086422223131493902621280903456171289092798337394251679718105296335783222830993439750631168166503990923671248598675468802301528/153872514897805482420971391899161924091772006031127107781631703356510218035700568333099310276055429480690103148518750589430337003387877337907,-62112180289198439152540488520692647058688075957708686467902860700680696417235320923869971721500986377024136925821130751768040682263167682149048/6364639163199692710981713186972077585660109492726665622737192802121779089804549155613206736738180083116025540149455411047118669956979533513407,-24729757019129512202744178141341651961614780705565035996643139449545013247695875944976127566402188148373128235642657850557471567257194249634692/2011355276106377564611395365461707168814928884020375241274659261578875414427957772809375443718214113317305093145027748712972277497871436138943,-1957150654779133086788818769721650065286678023401935931925249936252637081550332823018466329111183753999357545993044735253524461956179078968292/129112691897903040468734523478467958705384579619483674911331451040642979654042161225970030154621426838126949417797422866299247097598219968709,-70648765263924440230695995590842320174351589121521953530465789651273772542870495504024374938900853452376582199732855371024979490348498974023167/9174937645100565221352383664039991091967027631791720695664021147255393342390664711441034556186749344796758928681006421741799412321597761616376,-280634887788540055153487499179211664897917840352111623728631601763935124038622784464134458064268587378900276304582414576705369173002123030468655/49121981352982318513081650020861145827302208767777383697994085247497343035853924364992077743288828879606931004277654271162742102172603412168704,-46061526296596797950368260970127473096849213201876500475258539580372924214060832406519751831577253321101997387941001396183697718504495024525720/22658182796958838339859052663821573686875091056251691422495504943839014016333921826830238678374403135420868172101722352310634373158938094533147,-37138815421308399427005970954713203587672581855250053328087933315885927774954199774293508685976791230279564564350511137024905674771098766931628/18310316399163725945534887690700076722397661822014791492706892791304294013638555723016480996091426475377680543733303454430067505772077273732849,-29075119182930811552526315884943709843903032683144307242018690821796126996407650417706309788370912069575017320653644374539343952375924488248031/7908658324611578478594354191276635666523724643843749658101094239201723998807895996254896042762106121416563948234593760716036997794906733826752,-3346791542707417636575620204513972605466808990473367981950316362800759931041694706921113469007825052025071011372527746398658888843279544057385/16588106617021481067363921913634031182221883344882252729610103753349362884861971157523450967853096347277679610171283558119283289641308146476,-31790570299104057299913953088732587252295929094230952911330581224428469465840692487514565407144403656086740976554122559235092131874028337400/21804832800544688022546381900344612024235998291194398672681363868890354350527735840306570772986032206817169867000815586987593724013961260623,-9802290437676607726119409958863885112530416752674471464307997184643722218949228157040915600848275056261130838688356549422087240849155097489999/6385796083279418842707812493345357422677711695080388909712230540899552443744871687223285608770276903248349010214594093069186081676757092227536,-817287927412480397377793368916168516245663154561840995527811615630145447644234123544491202782200552159019668927134453095735776827591827827412/73753486784869476001595526506074798962743781168108191222809271175049993326036017132064544923919169198434860143557409961420980722770938093187,-18295050946630310548447951189601378154333544955882562325625607442210155367796494889535652531859595972090471689738472464696081395807726487067467/6818837450368441231260810089860771072133253227193162182941506036191134524372666232711308555611139825539865210158876672933272562059794356036688,-36768350982686733212169584943286292682282376531097159023611148647245695821045753603231484297135549143746102060328714969205380172319241285684941/5671031922910798574631260026494207903435686396256592711161136886221754500999750301504625565793124517031549080075378923310922824209394753189104,-88238927987632784349403446302048966456266452417081649752802995836745400493588005151893858330452083905175272977168000700198316295982785968506609/10536664752477766601826826422159528098864191931030899496864757122883933407672795150843743391208087725912650962320772570057940279942452109539284,-17375718547296488880304918706937622407587403998076300326642094429239620968400394553908903452682623003757830068304350886850167057563757258032405/4328234945873980395688811056650737260542025645320303722575371612697441007004579871931998913546587077312985731973854594250112137039020581837414,-7161010515182080743548910052061582613387306444997937474301644493251339119387724599362014999651691800800049627375346236768429178343659357637772/2895474799043733819780580188191306328078520764376814686597767055024828931055177684450360231696214550707174556865568510765809219488870591201573,-588955097418107903036277052693454510305326182419996090713362483140379857603659064597598967039484542045803727651565162133622286691439259132116/163761130776031835300375258817819103585899120472890627565694391717705531085340669002142279214539638013326324240761722861113791698662325889779,-1272262554141831831517651583277971873087286996155409240640037491765019810142141738864602841268533076653792039686609207091967082217239162358644/383425428723993202058798905138965726436451214720848335777397509264857593847634582876896516427538761366356492883792660631412873058539731130411,-287046460415620723933560739488898576283577624351409771747475659564422546058706189853990712287867281705040940191918450807739362810730586701828/83513753329805455354731594626196458671045436060160715925286903010330538585673156545281037932739986794505783616796667443438525659034061025807,-657080081993341429842684626312137948857460063868678149709811377968696199433905261333434250269578703388941288930144589861471103589356401611116/187807692456474619592480920592299856965860540338566369190495848578533841630371103915809959842327503773100382913929562026407469263526332684029,-192549451522735978390591804382032554573948849164102795058307600938102877715677208749219239229388052693683034738070920334973461391770165026319/146685464367352771139428504489039937030796202124385335029357641376025410821594982358945443812334266993251396913978799313752072240207773764224,572927127502090463174708036027790458243236771524864121770518379484771361421024951932348277489323179279557047649837875957874671545069550972811/1111046517510890172319124412049959448271037136885812002562961827645671165564452007238360100954410409731314167093079259828457879320331158407168,1083692308757411325354317628617888730282573167811244166572317223263810162132694054900117589374266270565355917948729907101880633844611658045/1644149047496874074920907452306347367122943731485805377877649037163765626100921854388653496254339253024321291001184518234392277331625066928,150204887719617872219730110543147083974830706828416405803763206270736449051366871580046882649646500469645030275251100759684239655814981979833/178081628112198581641958572175298108361806889380228227303366141016700856689907376026368030580960899639960678168144320318799278388228728798868,5596292390740084814861197371774993144738458159104292943624580450149890657155075430262141000980933533425522717675404912369947257172990642627/4730443874319080269566512954976839064431521400580191582167936556456066940802974765557201826125242371504585831294941472751962525282493149460,64972522686560196545646330392832915548380516162290577684411693215358721651151408303755092102367664229927521053614775504985152315507209179143/56888153594154193457922605608525337957011153344149889810726698081801103014218159334481396261387920364235758149677548798989456750061364574168,473639530600302865338200515555261188535456682735466727215506102982303456462791549252076257578982292798609411751573568384544075059021066691449/354477516053494793850441067910994354726453068854529037747254642315747697299956941383502923207785137935233922956063093661559228673621651447884,251970283658683360278804255097318412542320105230597131743887811114020577270504470853937515708277486419328588398462916237874345386139174892189/213967183038126137759342845542167029909876172826290426262466190597249666167795169912967146722103889384385905141529311283419420302173065203824,-124395776952276429679256135300091849268050325547768330572464630232774718631293845467066622813662316703813813434861778977304739689323115263099/639730721374612376147207376506339744927046522216761523273478144476961147344124167441392818621256911878924279640178737445549161470557645349928,514709550487784029000149575259402707543562037438369985889096619602881061163972133013271500750289605659116667623523067773675785108884713211845/614788536826487080171252330187310779072430066976625281701150959820201134576293612125487767615906393488512397783887948393336351642284907271832,386746860208051915643773315175748073758397960920574282560277406810082712453228102040461290928948638884881724503864543422312320529023371564997/328407327378328890783191242171867448754405263766523805974840855555932687138015944714918019529174280473234841723475587352468188664207559777392,376639839985302059609517081554367929865137501891956775896280439602148825134951278415100444818263985157034583917678985127859373708607947618203/276527258738863751856542760844927608923724412015257236389819099848215381740057011077127103124254196631005146678455730239097018162598711852578,509042478708311639195481057770833114542572266324292068183051199655511150023329190569087345767356517577831073064171115498493460376187738880763/499051212381344347983695721131137942874351933526009262666886322536308104406072553260143324006800019824323242115993050738263536468086588152112,258634329036106700630607560310596915607596465185507850760645258598925744301590122510598623855240239219073652526211597606855922466584119978899/680603178368862689471234804819107362154287326162823998056120469916376332819937909836880712317442966369526430942380489228721866800295459992624,-393653732333786972308355358263533482780494165493746595892194922054152591884112674155202832543634051625545710951141300592846665835608993476797/866282858810836399129485760032603751150286726105581083408152114240685430679778584217193726967899265488691051633508102567061051295367904029940,-9265203057207338103174953307584567693723968152507613003260638000402097245103819943272708894416403497337635700538031298665930866436939175821/35934036780742830048859605939305661818557392287932318622696204782533391875270374993645934579442622925705226320793340127192791819127423195300,-819445607225924600846668978704560023084867638514815515684733556948970907582664126497276189063844713895084471494804733316447198381193607314997/709051436110862069354605375745141599720351311300888345584903942623163377298629070665713781201775229164666551190359228959605361342929472444448,196451767433596685995507815584306564418462151499782762609514730888057392314409051788145140659301969126923079953022460420191394363571089023941/964645087282067596232779155395152649638037042188999257748225409626625047847656539292318457329046982079494309509727010805066736401847099720380,330663413617023495269305597274315874341288379486280236550939447188699159703957096623865644518686114249212448580694658826071769914584173152969/1408384172598150309169120179821185913820525113694275929761510266554262209093917268885617924998635776931388608476708048900208082319769029681668,18750688676381169908199479364413101435309564982567919484598111603435688870555133030230398078221417197649306781403172617961392369198523031353/49451440194294813670377398826252115970887086597792963184958083285817899476491493161772393279496587986595496349994475057036508925772264848488,74430425036131995789826180897539319870312556955394334781582709081821655098865331690429324103484061854129093726722932004728054889493722582607/122175674903385818466218372748867576476416363183037359198377529097070619399984594286460734100832178739962591900907593985664845961328365792944,37975081763349705791220336541218456625220483364134662851456170951372607400533291482196054178457387123776855289377711247350683526852861745793/1614139988191676029190906269256773608765460222631748028310075053414495775407814284049398240507544708652671157322950002653303135279682606394952,29142702021013495923702309916799677848688887433755772996037705837967665670889884825861445287757845182030791012470349731417235786240026668793/77952030143110617340270329466511700953931956380658182370726287954878655876514083647768333962442334950746155561686344590274844970271060805556,38670095117559298075052086534062826887447483016989846079744108944608205641275875843058274596521837143906970809757263524929582985157093605119/164618885600566231133772396936648134186230746816776382860995007417885132184792456962241152726875887562460582153249310964900493063721357101216,811081865012214726849814407093694660102601906232452186995756548084745788198430158659168940799117817252097861725728883637970525355232070845/9510528171656777138291675112525859945187896594578834882996240181179575596415209656817153673231113557975910114278137903354746080590435535604,-8966610048027599820226818480575835065381276148400363912134096316953342065500604015663604007608699924351202946929232644437809056905223526665/43501923664249655379765937850832564323402869713232778798077351247502484600235804744172009320194558761920160272492758335863942111477696000132,-48266861023801403513181260395628717668892572491159796406171750079861401624904762453353873744960900707345141964060134547840722329319571651345/316400086129440683078240471978227357613983690888403377372359963513415014352159526368103444475525277069377475041181105029063484491793757706076,-513152960607587622792049974789244534192568959111231026315870402595550825335251002036640661528375361746774091665540802966512541400012085687405/6507701210089629671176235301713641934382248858480278027039647640988039099114914713536160313998511626270622834207438946112816302548857775838444,1659006821851907582806143210468021803412498947051028336222713301078123867876155895529928182394527743996683113929347429249623187126673361213418/3172879844322358350613060056852150998994121478001881655812210565789870930714513628712816117107199133432882611529046734668760350431414877427231,1106076625748767072945513094995462472348318969686761255869586074655472625161991562778201693099119983170087913681483044604701072477277674539850/1857280962402419644925118490436413964855595132471408566556748836315588505404784432775208403583156080536863902999053989114899371292579736473551,3088085151087942979046763269860715050487882424659562895849149311931620402630381678772258783758513213311275083718060642218466737919436485236318/6566378595748070868620076143995951627632085400349937023240228889188088153313877593665603519930207602683314749324256112686228251474035821626509,555882054406747307355162572419703413231578526520377857342492502667055549568612687087755009186773590088226000042444811804459737443774950468010/810174505572520434203337956888446676061140706569972055662673463894462051357232467767931161886725902141841376801871002958044562744392164802707,258786883964911805479047215603623109638892589035658822634267438717968448722154281739809781200009511943065758421624243010304712363372582298991/152894778513135864448025355782224772542912098520748088335321911843201947709202836078801682162710789757338979098706035341360685132013585548504,2094378791886927923739481870317547915345689767850783391608748234604882772535684180820991965637170447382834309606395788535124447578061001597611/1359054034196978560403475463972328577030676671711687098380567573042938459463044163230821178699874764102095028107056948616200427867165544196874,242425846545064458096536896804347025663740516540038943651112941579185876411709463577677656113230770898379437665818157366838518400081194247393/228288714824422374570887802031586076931862421685818081249433205856693289276219065425356411947774787781706185164528129825640757987853620189662,32898214466878986114878269354103986037438356223763184183701134930155267607728849701253356252506151854987681144525475475458133176522168575841/35137347937865941455581415220021259750847306508282142287913291258645302105374664674863244331244195874721778427814080610551505548791416032566,91508152133820122577600115162438032904050571182938927235479983785058284209087721735370315324151063105968140768410419601654047353271362040832/270488851008647232752023379725956464859238367726669725777607464639961385925979390869503242462507861559737147290878257914789589433081865038581,58340040326393687684691003262561333824128782649448260697460958313135175386478574342198780961124674214799621430558954189321419942235484878856/153830405332600503409059425583007111904775473676273192960684079368390887187471153907952003657474459800362266454436447391782144386499400676149,9458972532062004178233231617789192392961281324714392399396124227631214616226031914309342064847309383035642613547442026972931580344772970077/16378980603789076690067352957500281889034002580409964538674299171172852407230643981052589605637383708190144879455938306669558285275986129610,2469901312712029640845157019218707085305350211149436680859578303184188801641213470096160458704894841492596230867346508251804212089085418580239/3019505729498355975888328370463882868029973111751170979740250128001836417790093089847800452938506051986701331558996714581228995309060342880276,54977636894927357885384322093240411538205664969909666780950138805425507614088875050337021693165041740533470605702380895345236548344393139461/59019215258129060763974961672444085836255370156815883762090381762332417191720257143844942498080370490242804440521913983923554345858162165884,8363085284731874615534918164928451723372789965500196038076879069286944966881183809893826503807825590574513977095108346355862236808700898927/13394135837722320313997416099959957043704255799461065939441724402113584693212793475098335184084136963101242345524103976629139569348616025486,1047817241294262110215214046012127240027064913905915561823761382311174736357745452535701680738485245041409614989409479547003522947477529647699/2040821549215897703332113617929476196617587253675376944407306879588938361101789670487110605684738058967699758093963101464377101013582464219916,423913113075926106284864636013027455907088761617764950366816446514829895575661282253796568772501176532772234693130838008444886915579234194395/1916224465111872598980835327852884572466906451453490918159934254547012260333296363413307047568541032419691712793930866486276780083669526228144,313559913080544010073290539351261886474585289930370167257817612751273093639197448561913216195541591786569261173058431757936888833859281877897/1449719374397648838891756824135443662243515768572300534588025191091263096037544989020922635067828821761450254919335757980177671823554905030814,99799901575018459550812494388185969844826049723696018152790278361297617413592773715645950981954268334046346072992948679214032843582025544427/103660466156755384274693195904892218440322808230960821299493155134533783469666195605118347082839831064306390627821667067887455430300472968188,-7359746587055245300177729363484408609906878305296517568863796658658374267521982139879828393457046463237071813313758877952089938673976711604351/2229726643506924735862312211811772627925965845420684083228677889171029196982446022260056740080576676973736989693208670824018114466401194050872,-40963274973337097056976225684090275762227910308625104803516373021932369964962133427089194972572908794802296451201017430403330028741833665365/40302329385016911618223418555035444650236120441850361099073459463153811831973292482504617903812057870282043756915206149637239205735411912904,-628334593953841308106710528570501620854773170827244357001065273850883005258123232751915078306962704608857940687436168485080606676872859278027/126482208555753039700888877679112604837834730123631645963590392820904561925147947798822527604299717895088804777840208121954397396239080994631,-1202447561947782075328224854208988435438928105695759784834332853364290212824355866516735178926324935980087323999846824775494563879544950760921/27959696259216049770436347374110541829368972989566641772499109624169963251911117554859213122340307969733597036132117113485404883872563606732,-7851515024971743561122829854615262813985023234179944438638002767907591321282622292248245762969667464391038289273929435116866032339628440449/357896362418432701584675193131434492077549692475270858645020858182403446427470122475345855495375767483885300320887946644820319330527484724,-407333948940596228994260925221065772583712164298027213501065075977458614633311340987521326790018114773476061534477942516677372691648640912959/15004954476557667132030694776120284152224672340602847250053656799808260431485010895959024073515101299069504572870803943259713330723740483401,-3051737344015010072469977555131773166419620530420846711192752493085783407288381766305742852248889134877834758270763453573555302141458336151583/12600058646972090691524265465129714705593416364471191115201232807764744715159567603960912238077188694090420583724128172988502063359401849413,-15932605788766298530756944667456361354872464706154202243812082466640813309104554809464848855725739337538059068328540778754543465204953234230231/1199806110610523724216537682101968967993156737397641173819611984152305887308347048424924021538584594354678534108470312368637009603165048801184,-4270783613323970950951431910379309734211107699623518580841726395919294496610892974378070943146643017262837711606875082446655091184460319258425/687216427637022846749073151396017298099046694911393835311859713945636904131640999135966966693615983525779770565051069562128096984095558817363,-61365030445572367459923772684376913721996442922970916430212275003301645410831779443268386384508466613016428166047589576977435704042538720819/37230951183743250539558462712354534317302961386979326780754042732193564921891373473738836703437923578707623575726914934462541802286942360255,-17681378739792776420361465712704199378073863847814372103304056935422019389016096337546834862116205993313621779519059378372698424737651560579/16744381936166746284055050978175286455028658011892671805302745718688945921648919187600345372784916816801751009404569028715307368687363359456,-1183756678736537198493186384301149624934258657300711608313544778724891092003494670223539819726176219284338411128667454251383040001686169506583/1261497121393283123884074287472435313364499874928817732249703547957238920163256922857887277040768379832267118105096299899818056517007545821916,-3649879212482027096301438770585991444035598722371519745821964138100358454108574951729282887290662160685105593455842249596296699447362591015/4076069206090803006716818086738258346284688672427450787602575518737866978192745604267252483147420877063922629728405630134975922664828595688,-200342183629984727647849441817644854031121907953972214189613593378072407037742013325713705017328417961805844973025833553103902043283679075015/159410816089624120564297956471563207968786964443897290373775620055483514961804161866799846407406690669824038828122475621225879818771294611388,-189069969612478249147861556643256106462263730488294701966205021479330256531281249381749843725291503708851032319412315169432420499092565837093/13352825951156592322843606536625367469086482684636219978951332901597118919192616601401559249490178411238662734157488737814034397138400108660,-36491569456207820094531414001353063652973319702052223396702081984726286093879209479836347777206129806246837615762602896743525981246475139323/14750488529748690191786550144575565787558176086910158016584948858726564130937554959239170141234795518005469824313958485040080189996648247040,-309768864350704375596968028966807694511226655723875497467987672729363451043946353198327149321174434551654237819404268681441202400750768159553/193519097049411668885736955211715947978826033875613776988840858141358939855093693299989836176871768516372206553369738060864112211930338076520,-290382858933966680381064978993738320090210546394002518611292165619940643915960665566332596748968003518040952840475272750426703588540856927919/329938098913743637217215668444287088656313979594283938937479532364737551833359187868895416339040542005290191078397019147838283767820394486144,-901275420683653639707843102854332849336356452892088828622903015173331129616185215830192788084332610845508971007684641310382178341013069365481/1220640212206394065649066257173480472847110801808269050175253011228661138494023849071165960390875656646284297309347425931815522677134802052104,-6394428320011136363629559342048715783937096463400026518393740894089719387176371010133737187270596625683757522636200619296017007621865537/7331547128169536091466315275503625412999811224561140068797470858241536458464365995611701255709440510316985221266556452390200793152414824,-16231966532805325399834721452117133658407088181676487360200694960340146020998401876584322110260060041971435934928427611560409739342779138339/26558821951071185192927766087196758278618439333703371044750713670434083673396528328255634451700525422119264039505627821289822386302631780296,-148666383326504879185384228706421389057960176009165296080589900295111031183715051191796894132959334444175276129170371770182330117703779612115/339878630471322462373894858374377643192824330875494122454792684494442668797192372760547853082357719997224369197999545021948388481679191901012,-62488587189314545571209485308432179718496822834535922002429464762381335743726841195358699646695138638611872572845125671372170663623558561928/133807958737628423696577145398919506635191780092167531423481623936044925756371586148909085108774498191820793302061650954075483602661067179615,-5109481709358582185189853301602368787720043216503149007307848328257877757487748623978378611232290686246069428004149123883452025718181833187/324315802989358330172593428434040636400358103407251982734502117381085054375616778613990270510950256008541702417280981708749944510327271439180,-442791856619481886312252139496417942183917929035163380386987713889454123387669142110587307495665319003461397928787524076762745858674060892125/1606900398767354329435569681548362925891148492730282839495493445054448011501593082332087159509403094476451473861120145864648985090238397017196,3070967505330492401627686115891984451361224654416308159949721631176491244513704928662156884540115016262919395496162726753148864665724438718661/2293333885200585120871412515478543699195288259661783571688621604831791610751577617320355509562442536323552570794099112948176427799608316479040,33302998782678064597221222481146209681435134720384122457200211635213027845105376829901086821115411020239398876860444159753672243085667362511/59932902948667159788575583473509593566017845800645062525722293324898014140893421128897043593458875892052769736781406483110474932590961680640,328926076120501279042801548135024882812788230282426691028492570513093860788059091274889250212794101865019765513617661802382567551955028470553/486457085532833314196927465257282835794094760256578946429986645328176820824842150499035554182709814474348144549334088855535171979836300775872,-241587449916469337109840705790283484133642764973222775133718990697171870129008211737518858091791264329160308655052535823188232478032268371067/72056114738729981263106579205257170196134006704265194397346948678295956357112461856552112801384807589042273151870765965713089825457104740768,648790032036692590179432817947447401058325425374663412168419595531286054965338453341092215813611360319740297927224137356710056991777500283197/1225422203209656379640588463565356334814553845299394172359430183480836828937307790768332439486903694611092941655845870713954909000592537864256,-464088272271569825497503265007223889292695389199878381094693451633578199357824993521969856304482034871912211432355458306483064600747278043553/434807366282935511411944974281994858753775443520271802337036831262191936223645715160613209303813198043252709620271246456611619924207385251424,-4497536272059814161966648888139716413964412848397849576311775398691394328011944088094475581510171908024548462613348321129176503427928197371485/4604738405803356017953314400249320221868670470004339083277570022465745394925314047298665920276277668339888093398412361546192360293597285974016,-229854227085023545211831871503935776088462716212015034676108498310275219438331877358370141250857460329229484835921419454857943063489162464757/62821778151889738200661183098585045986639604793854033842140015981126039298221861453480277255451587277971109376858816333202875896440088343648,-2691176588106058375526459795049143750880005370186571308473276022255027113485383890905216359413863255099241464036225542727719946257867601743289/757440357886968437717727794433359986968374670185491325354406766329215038219689951898135778476477864545334488574203206985396298860152535752672,468685430499501666373302635638791331939337596213127765533578243631914815663950921001956877547436631571455130329009504700793582662834275210261/386959642436077897895275923591631944878517756901118498851432791742290030781308335740411587138893098482142894709385294195590242237056739936704,2110990763585572142133511600351129596298752195324503633666120541856520722563831444942730186337996254077204799741948167562939022601815357775749/1575854153463177962356113665718571328531210677912294440733941690433405926469571660399917486021016230230091952264888085545417303509652741452096,7637683920383027969944700170969812964938173254483538852425117121628528824053989692176542557373490714957482832733562288224055692506599285787337/5426737881698207265019661740716534433404306887594399960645242182681128451933389749274779828142646568749883095631597467387205671596657268678144,661906151339228427871109275130906228425562024473420440859923685793408782870320324639884227717212733799155391306821876092990711024385821485969/524567735927935653556711953162367859794923845216100580133753443228071766347103470654293917128552375580694403258664200973822889813890121794688,495643171356805678968174723358986844099206494534794915621553328410193314894783445315345721703846783103801942859897302907670652850826642017465/691571938889610394989280861307196410677551635996726140078165044465999545577802849348937757323778109204056308460198506768129257300992453967424,-13099557673890892819244036967964754723512597710853700370217865323713458206279928611578886382957278176959433116361859154715895816586643666042/40491228239180888694921478697405213590425784501505222592032039634279413451724624907102726670041891052870365523911624116861687548068880101653,494972485345879565149104748712462289136145754502441544608747979445467367907046734072105833086049777813566046862799939107773216121289945488977/432544195158141474578508710917625623380964530317449404605016526424590200639285267105823191605585108151189160983376984390210670369221458311264,66083347194097847308986384803930199635863259978298609076900177989924493815855877886030224025635690492157104462334107391445239902898944268597/77077004474060883790391475044677403584341746274522364224330641008748478113170711171872427793462376214305638604402985229250598054861956370744,112635197914828454575067172455803725167409129039346367268875468704877668910715060995311505377376334219979646487393033152188137235447888582558/137920690107714037293504778525879956941957969779526700137038879293604434679988156537662109094298019059584387611412949036393779555950895787721,109335556466049543701244896177537110496376914758661871773082915701808537444989395261615512312192277629494379064071411950914623226666855326287/989204742626192332457115177296576667689785324613733308985250288749503676007747650617754695544345318510365694043893547737043169991978337455904,188152991461833543301198290868131004856460770464180740853403549885578332163587253884192705240865555584766732656597502123948441549223845920938/484833001705828107107526761930540942805965648390719452642229908507676294380893657102895335554208916602827255435968459373857468975314258116013,-682709680759125740796399824511375698194131882049206395748177912237074842697270936434823079071948572216078448072245055510477525882425718885660/3338506963924372504564268650259404754005455973512315740948290573652475985720445204687951213980945668251032404853429488095524386203046431739689,-62491883915510505443727654244867017834461081105717489070301746307680441111962887880476871993355147001823334645792076581365862926596894589653/1957881856256778741961677402478525611056157627157476280954112794262269580245777004069748168769051595886745998502770833107494380411845323525824,-9026389878488006904908466414454491373487281528610879409230659580468571725959159707594655251498586434119996163759463175147491585993994606448033/43893841664914317453466863163565318794852803961971041949067674998643208029168842085740850751207488027660897193165495339205474285886866647047488,-115101742932789573099779162216596571072126212085210346572398186186261430565462616893118646033787995082370950074892103714583046051234438482997/710289108229167333395367689408649377762621751644556676576069010255725990146088902915660524619312171768014978448438390025300982656622880411536,-22982965054866714425798202768039778064447446898597500803051717826983841233504369126243537932826013658642839816875158572751936574657024110208/112284319621912947876735095527436976077983479087562327545942407756764719267231456985667979931308449601940845593289050215311012906473979810809,-2204307376994678825422786471141395939870563603318882098376408916028862337130732807170562574374988697395489942460400707640565943677788112288528/1138070337179225594870431621604120961698979605469423438772841380041002679834708959475337366833839719143083205019706330009704875410609103142879,-119172398465576858474988974069143360567192221561948816769586508821984208463670770108966024312775998470855939602411467144376071682904531744857423/49873446900762551093511874874689905263142252955248783141964860361571338872611013001648290224462903164091678589229460142919889105633426906762704,-1299300253444071826666506840783703286058873230028025470257307036605389607191414804341283411208282612903524511278572965586338898284195171212836/555479102171525687044468671929323947590836013273595404825356467305164922820100174290039884926815552676984713482087021335047853434145155956461,-997149845624973321636217823130030529185736633243376473243579725788515369292269956505618431079210818082589431537876295946104803396042216403399/2221357066692832800101074617518778903689482103365683161502635288130025625537611475959348949013966067399713169590922270174430581229796726650336,-334157600923619411467847146626643736189217188704512027089145405692344459351693843308163354918534009020355583290311777140454185132097452578585/629830972509951837364737488737358471395337097522263850642927462820376562932602824082235175840942628813130099116802945529373105370415480642086,-70862371631623517458480912256381704063319306243578096255907858455522332732244651167370297613338671192213197444669067494883924563948145291123/124016598856089467558166303865250942774129417804998182599218708993997189204830028302819350577994513553541906233940593695252533996126859608672,-143746505075923847862941589998121016694063734826270002482753500880698716431903052863928949819887279044317280755744223123019995732247890088187/211755632107019610296620526197868136970507993620982705818923880600632569514315476724870561454943145919119400149734541716783684675795724094192,-996575903087429630867573346653788709048262873151123391669032445502714632831520069053085997856346770333239074302998754430522980889598667190029/477898477929574503580766178581800772742704750215310843581969843436150845280718051498355388921537218097355180807732666288334761591313599211648,-638448366822302627034770786441389131570283224103619457144526058109925878504411996506226547352358976853694203153564932152271681327876107481607/270514210698905245810713123005489338219698581937323361003687947231898507117257235159347582746655390546459791232849245917495086862776225696816,-16040608585326189552771870147072629293772663755173242629682073771675723887027673007238394810655872255035072507166584793714981791763380044248885/7489825323329563229739158839553216298039128241702022521224538641422540186798571080985663203126749250386389822138770405616661779545523002119296,42394530269983342322810340753575185078262313714029407154616917891147102733592037216124006178370532041868823340230979755167898388922906240161595/44535822089541270122690767416759009291958592630474789473531642192795985542094855384075485994678904870226053973835432478556584692218361259513728,58205308799765747286020770203298338416357574472040383931299595841340533891557567366637524865578133942332007422129193902804480523545531732412229/39077570000229330058446728461573879074232040409705355161846962665901717501936401592347617604899919828464396128754642062228262609316082938512448,210397853128676240442706499175345021120927406184478857252058076907440705968892847834536580070504393690456359265338829141395741846828051982447/273286970368435099956394450544235725799875784728991029230735519989679986248065630929807342401965698194924334665352557936520725052283424041472,62019598003852918939996549122458714941147373364299918559188931460416714448376020959996750666123692187494184799111799962895654487965700493969/90369617377503427823900295227324076274211754043331144869693159475373408113152129910443229717510817203441206618269674525940648771787260324828,-553122813498290930718289357503209036937826637671191755909044595405700889509806797418483163419460741055742155366282452368267136148322577887321/212582694119425392429905506154031546446606338786823152900996796334499969477036553839972204115936687720095079041799112281862174967477677392352,-2283872025752628247307851047578070380747753318215198383368870712207428227575948808842080783005709100148466322859190553849586902241357849379529/332028364296981015949860567388667514395666148664760320328563785883960047834223796421507125215216329477238449046377798149682460717186449719776,-517089482334612143802476770546848373011949274818262109072593101292407808010405315127268702306106248794905464102988089112810501187429261728663/649474548829967691393352412161203091856800744296798063737248200699121303971893895382621918374666922538871737063997000849674351924749628414912,-586672354228455501576500456617409376863320111626124074691412692109882383545961086138081190028522997623802518982028667165594590670912823988/706840188869501149090364141837814538587559566802149107583956608790025556671263928373243154978377065338529305403397349762633733951166671313,-181857253387005644780069335928180828217965719810765350689672707839910089895404030348368106516995860411496004872854611547603226055234866139597/223165498350813436755414777097271018644017049980173402757017380648515364342956293694381757053137278463835334070739695150643044777932968949696,4016227297721400455038121818577914952626766814338996610610607403423501083710323472871487030942862082430764834493902054458444335197874438250/9445552054187307107149799311992047069097465320447079067117025764359932143716507406491352597002522624108778544926967642827548695534009985057,1250972881984212653709442926474502135601877276881284673867484208858235439448325080479247989165156886088821581987496804380486045548386093841181/1428567843867328987854451579627799667160618541567215134365523981175765820137188981874925446753422428191517854408374592129258272031572614707328,-215528627315150208695468827311719095683899937358617047705221670208064401105847985937609764512508932706545263823135250158874924657360372789449/169444323037669018990639122408824754364324095653598482842665940032473312797051354933862190864122705652366626399396690364853479492011776044288,-1131443722797599509662266177327109504968899021945590183903805292812733207596742072009549719517038533697173959733536354248559019459846908983599/2074940057276954483749685295358779173880982982454442819910133915293499221523467259588901067261120362837339447715275231961562187602955427742880,-217499655821686709872708878981622805412269855779006300751561755926336480525736090062798330494779894603480356052960902522340823179272027488329/405593858451851606840751279502206479909113718267959838414705273153721029836783049033822741528565652418330652311540583798741326509625508006410,-372040837484710207043087488706613991549861438903011776480574622531054170288453446934574474182044807209550086085731349026721057896219604844419/4458173514983454128763694528209389799589848392744134039258107750236820951725249672223098436355497536032934511773138685596678054744873135697520,-1260362258552931548234281915340433224593169391633058585794835845555380491130697722184647565734406863240416095309565934240878334537180627031784/1282545483901267319812332825722315953274428714844934304463603381501761890625568085067111841947752632347893947576469001520697150144811767059009,-3150194594702231138127701231035681222642051636396171654637671923291270820186919153078719335846085517121953384686807865327757163308172521345955/6886990352643215318502138273803557259730288441693658092146454527231847981768349536206610239742305705609843628186082415505800439454476889800728,-404830971505240919169638214203505200972618399164407216258120118375414651542114507139973812180104043388162052392516156098081943536550015977148/1826364055884736338146401612955306218886872031187327515633740175700441809955380765398647722105041472702401267408919496305659073925178955420443,-10341209496428334385836600133603420442352777191246574964020257364741928697177150308506147743861896105467561894826266900087802785899613301480172/13978851831077007195886686591108264641604317895393748768343708521548368199094068132304703397516071928051531491450668409830365818173405737467401,3446697150112544572740001175116654783560088006312554194181623406094068062742114584582705968129742752295948043628258139073521304027777231209664/11456724038086870841596326060542792128626347431619399736898388753356445527998959731428894900946272375376652026178366544705455297146628322146081,-6115515602122516263915530060863027751650571679747258546862920890766979732468517946015305431048447736105549534290826227575876797018304248333356/23573167577480567157986168659152726639192451353979898891800500594070527750734599393987648951316570117933896089721251580076846960943127853984633,-4543715697475146682656300013633156622485714514569099191417811816543272535067886120874134993252211372417845468664793278350117337347994183074476/6698362244724334947084806535604186314530120023921487871421570274448841476492209590732801566370807489802547184660341259215290404660910557041637,-1681876518390062362958869972263313053801729252823731249916722612380716908876919469148995671996166698893945670378454966215537276657644801890436/11313422905855691689575929503162074375168113045834773591930258954161248684141103648193208197438606122353916691359999940500857823282219538622279,-1705242644142019874358367395278379760236521984795258640115791075232877291510838273458203205363902927790594214335329370175476655921403082808940/2975780630887367494999297199651108834089359209679392652843504629186947344405862007887784048196861024620933607203813998791054060878141884322239,-9765934159251182596028019626685209475909745356473344578959890354236148032290470242971858331646440355091163496046952426223425300896863709402580/25349724460723831486698965235851340665572913528560702467038595457631578966174633497955340494813516592130226142270025719187917175288103788094873,-3014410177085424097375795193843248209949595495618388735406216806750198133014851183843343184716246908757350389497198072806566164891057360237746/3911833647786773472124295914582302775650973607266751486579707636655504208049037762646365598061149850989713210571828307096686911981022837868207,832904818733216022974060058288333455833953431651391921689683529874038712275418500871086468517967874855069332543499689619538092411122364622607/1022776431223584672852869154430398877040225189221946712641083938146440271965068138244855462761475430128291830807712484049953743277683348828000,120393843477932032017280179513864990939588625837976021312008381969464759681727155105636985136003905320986326301550366624814854852250093645299/115497036927698360321665804653685773207702997127413856486712625872317063905625310003395430387243523026710065825291742694421958578839189986156,151109975545890144990122496120335169823625560671087957081340341612816721722944880643084037340433843126285871164423535973982419683081910756411/158670426837309535176560527963666817498612651096110630886204996294038771278365720820007452768690074382109750426770430622363819917310997742444,4490802040579612346563822618280344472627000353370212583744392460668597799910567512377862317981429769812104760185464245185187031759422721772/5676158039020845185449609302925971239406463214076334682708686998032746485111713855170219968154261534818743150174655740273946527487282622445,312095350168171665028034773854779193719347702622779776455350428344559763245832344927154934392433341971650867772116540728684541666797172044933/521038016961988161790729698738736253036185274643266984742355768076876665909131110967476911805612724946135977625624112113423902530292507408742,115930588863819258515088357967995299854426277166328977325423948848796274453809009142940958517140235687735299417139032174428143125233682790909/174918148708105684658432768691819794024945916703850232400316627894426149298899353902067592776645904960121969669716969849337054085647983959044,158013263067880811213046524666798733409798102030465532651666144273823158114155753365557941913919014535190781295324222976542653710084024849587/546983495409189570066147078878123613731606028291723621790879077580210942303821624867307585698250454951260343020372862284791884095514345495980,452692151932528937297197607525138531154324184182803206578766277030792393705552996265295458280294093316619673611123572368093038392480826829727/1931460679441138092998104854465360904747472284312715154713559227384603620040325357094685410072055299000876870265417257277215451120156946992864,4039149964257415935450292217534114563286525658014218104517458060543519063858350736847839416164161250637689630115472738980893591590554236857135/5869142506639525299982198653210458782073200966774201262130903001661294393336385567737519715525781696499054502947979572048293767988608025984732,2879391752164125714220324075279586780594661529492911089854033196272663637052560393532787670775647387338770643743593689510546308767808366942925/10123710575430717186638636451642630578442713208760868321124356251345652584357054616098444682982089944374880063968938944325147782624731475220538,1649231174279639412602978971964055037457813262208727387062434044465114865605558520609878562140686802093517487018563038754994675498130723843897/3232009576446500943398403737256722856127726389822942995961641321905678671299457610210793979874914874766827466880028495848080543588574883585643,12383168454243078675329931177292145338465324010805135560983868724915665839038190364046885202413677458126147809656720436319108672199064937517/17474207844747181897070518919588246237181260518408379026034403851656302768072451252105395600201462865410565059511192235842455319751708389904,-5725266829346718827539746075505939140668341055668334601209458364340494261591686362541941690344455024047742098333952097205510789350865335917/6891601378579503214320917983615490112029590977019946475189509843808565166072197267378335736458645805093743922659670484205783233249525812992,-2369990598102244888075103104579242690134587921788227489468446131078590784020272034095987486619492380022168911869994201531539653006702033212067/703785158053745317541581509612344183283208062881592012217849430184229761697813302599055589937277392574883458227617850883984838354244537747924,-11612665663591081790843442468755338035205298908654449086083639567511918892725997346049946978388345611955580880602506784960542687453154121022/5021755019730617509627013976048558689675442294163309597504272300237885721428451263784923437735623382024903549319336200919745274568008469087,-356443867796437055571880270960715207388094803502701533486222538347195772474533780139980907145226116372407248164277321151932270634247212631549/161701616017482091285258395968103127580039270346019837526149760443900989436506472110183930598787681226557007424221090525869748931041532418734,-181262618796113563983254574789027025094540492269314015434753352819194244714853285758966386042344078631845973042521634031748370225253701558201/77998904166782339069453158252544260577422875147943063752778584439841658219484416829626304410367052926710478473223345241396322471601304277466,-313605393999447775947874232723311379099403491239378612320616169997426452646135885857436432987793389012836759578608418310755768809462047852549/148405521206792804431132991549809433280401802075953119064856685910399002362929814840397788696270406251413305053960668013459175967317342858068,-416232195065509948636504283513256355196496165663543150579412752870884349920976658398122929406201752943015217351313320482422684260543145482523/141336554693961825220152646874314339188176646281640077547394752735003171727136794656007183295047873686806219648776289202173480954536178446844,-22332939610520080186640071982847176634434490706278808247769656779700347928872598071492498980100108918210348473182262619528976760730224347165/12797879444200104806436051876824159878270158447868074706305991012850267620128275002001871780081925682497622026180717200500719156173452709892,-288527629708123428361017395725350626278533002507269140661543158509753826785732812927995903080334529704044438629177153868573835956853049880869/337048067113352836628452348077722014671620651017455804337629951417942571233717135193431148473798985823661122405763289348290717884457950078400,-203061272440200043638576413995793362130264755376680278187777081089323777583793832960846959844173838005282013198575371126025390418234644795195/138654974527653624327815508103148872696978243339394725437376851039853379782654582498700819040306264524973557537592904968948193352998856370088,-18519138583088330147459552325857541624832990777638421143903779064946229107036834215197083773758103906398627888550676414889804003118366988763/22861054927514875654787056238067441736291416589434313045815980437355575850291642468612970266901737499808996988774156617861232131170289591015,1314299270491098007172180214807525118511475166671556119312314387183373233079325047533533639980602777060434438555267134902774029704778958545/220881398963519418367163839266039657285109107903158139449551027306806987809898502092070744410592196115433684859075757419799443032473785282736,66782583056232249085709744881828237838426769281529395894037756254824797029503983308959248507216266679448219565834104815340646193724849606753614/276057340623525132497327336819023344626137942374404633269757059164806112300787391537297234866190848515375020382928403960854924390229720901152363,157361845824748051172215426571936768031185547891509326357210629713871498979469746579280114120798695359542170581554866194560887618433082137465346/369400886739182592963174468667704952246691717551232998548613543863686669655010817087851623561259085488758694389756505872133485116677428045229699,71207675830378132009887284088494795466293478373168097377050424842273423628429509825585143689529745609383193500814489319198412103301213398804354/540035539988262043371831039540569282132008151287033053470408591558445000202414611365276537101891915221357549613458114491799588060458518051835059,11689857253482880780950923404760033626339707491512501225926324254096762518190938186824139861770665520428067888338980784852528708013736940202933/25421983853486362341614542198445159260897992125014256887204001768420300241282949882876659670221879526803877585188067171244447257232292738628415,3552226178680201763302092805508493880251423125315774263425002720743275058660448068150390858714354390836669462097242854765549203641926317480812/23050988328340664674215379347020340031947885089165860798839309480222185575321017104507864078493367585031965299081903348958463731533357423303307,-379384676718746549476341421476820833695203839106250923899901823239359166451070317821991851768059315233447061313360603219737252538457281572067/31036606610461031508059131521448839916101489359060714273523579494576406600015567170801004795862624960766860228681246421950643756090904799774032,-21700037183966482063881665301957885154513801962023439664833027242306761086231054225321880456345114927624076533658176244440535578639062915221823/222654520232531956989181069059281732483795357058771286011008292405299664155179161199672843789836298901592069571037091632148234665795116734962228,47709794416429279574505162499304003991614581708839146614373567669714837048372834850392654001568120969024719392376493662904250136493118705624/261392327352905713523460831416350514756345493669528372672041407171398834427183445238337200336670822859363280446598655256106979863747193587643,-242457520813548630765833723852555591097509865135777148274242717665643507993399642171571450097520116348083433475601555395196321275497558479557/276761048880488614759206744707629481721139550500768552008966959834985933065606915752250398227758372338646482806233001532243414163245503828030,-13020700719193410483300207886695193253096558854408914578081853959110256870881309535145198852207485155526515519725625661819539291563697634079297/26488291920833390724637289437921827816490566693149881517038511355714947954889025184376080852882079818325435526554768438508994052860821120903480,-8153650417371181049120098834190910293767043680525901166380476383832738554103300277133981430676794372300323953444524789599381576244716946150276/11083480836283121229127781289286156136185562560507240408547560441098251512893269508991725788001616618865935222975072334933628534623263824495095,-18209744582067048095493674263229370778687575776293506673246798190840129403874305197671001757994202221217822655889111655000054630534544847281932/32827946430409619642742568322824593210396836766548469576422289755869335004526562827270888695166082274661816782244769001370916902668603980433549,22719448430910296022235001421177202086425762789101469294922270308500939786242743089647338198930365831646182586927307294016259752401255283198442/1458327637456611436793988165771552978822357901362562881621764653084067096360003043778208648538292046516715504640485482738442154388221726178698131,206693284367018185280798792990857620091301420114313748857308404772877251598319446490882216758177938189066465652598257031691905452083986252976006/2982231409927597378026961097954673402927217024577075336331073611694209869095194853403732593079500991753281459364840581429080069299965501946576325,4152553126408684131608385439673868695849066254531620085047671169881505621610715468325110886144991757983574622267949843054922388536774369304088/20452758999266645372493517078946422387305453619843689230974298673853161994266305334465858356860246266133459644716948581055834887456102287215327,-8302018714180891866221323678049640377280019631025654415469377670455814460292549611387369842771740250120440165665553021365331730859624761539978/1289501416585676853381358302285341646475603374955455800606846765603053321442207027579295942667677769832973130477946936324389481976531627509250357,12808139641086467084638167851830591371683097643849582090657751425299061912010388947908847034390796472166549562859762058269444027990855974402695/140224243592558599374184484455036706638993352129567953157380146214820343722947149352855973164621417022552540271133730767272164047978352603612149,618332334445175729302342531556484570107792677554215314183099010122685278058670355736046574591914944646722921084763637143131930168656252295013/11389527887621221337089591113488699500687092036267078177192537250394293044164302532230079992823759646646887449465057420746736392924612116261496,-318455564354240284063244628320678666053620771149140781369612334029898913934597109629493008637155701517500036087746439419121894737004568534668/267803039602623364439620668865054390831919467491042317830470349059574050384313454310985214703546437990911221272601458334482805773285826039341,-101376082831330358720809419429802871538740919543292725755047219925696956613963472534513859824862070869775858874716990129682871689605930287317/59137687303766395464890512487511518364306356513174309455084529349643724431662336402127885044260081777874180935520718089225887675520524264564,-916407032360927468294077669563382466070945381096002068278146076780250247285220628537238739133643379977611338724563066912160594166192336671787/669771749012516550847050488573166407980492689461683107026564665032354380799551332146637959212297938941473668499058955843981963352244953641864,-4976260472794693569616492652056583275852556644159420815733622423818479463051370040908924209213259450806475114144258401818940031752415603855/87219959969045677567055898870009946362845356196536900141919462490931174339884837515093432434222966051255586308601802143110120986909460216864,109937530125495217608657633612001828697095262928512144051053578348037353923404633338342549277933746512362791170951140697002700989058797371495/1310152807166443150782045565128351043697048889719901398961219813848147846978593627803777157137375179392651056236317997457150267992367547776976,376714624990351257824575245253586198171797093435641533855092849181654173476767819296825060835561399452069204588758322108742258590305111719/8705812065910399233465320235387304555263110122512631907992832515620927009139491802129337876849873546346306419217592443436090307626230386320,-8871349139749335712339992547723442480306616125677075548769194847353094164717434846029386140994012588384253190932674470680775882378498802917/5146433336396055455218265239835063318169061346259621411536545531177870769583055012565155254945784251667282846065443710233599823137689395544},{-154456418531805023779718771345486888915593507573123882444755321397408320186784800557188919968185266316853177183540287017851036939532145429657/190543254304531373639860750765239032508490244817986359145071372079895136547417863891358278275441688017209098618975842631065715497067600390528,-81768732681590949693556260232588079671627814130188668032642459041278947445801274794528525291086255281321097562625973703421696693606512163439/105138383610066406394037564819789782698267698228558277460373199361536560539253841364621260399723890723670801337455087049691496073016212119424,-66226514448994280989251672360442762722417689368764698350596805868989514518924617046200324025288836837691788466569413074665870993737628221181/247843166592970245282570202516554028121164204695582256297830743405290073248202936640371585998406198376925673567053748257599306918127394171816,1585644289039714829156732591228500384695461626141946805288422434552135618124131170867364490020516373383782620586509446457000601553337686115344/1343452152598916679007774471037722437179047399835508707808728288534551328972891141616610287216983366589271186273956581261478183219539289689947,543777887312029909713522905712014283857474316265596877939323256514374166701088083698285328268051159144139883745642190570082511220159476799893/456296370403920523385239850586803600226341031084363513558911590747372538336468691718503455319093712594419453701161566453793067997515732522288,367675505430071503045374092818908833471334892241883251335233742842322884447639271805062493711321726392714099468840441026568956925658056979062/499300928557199164242030975800660350359018448980879251695598680500384659575681902525786919086455597564492294350445307552668374725120098363287,980641878483742729198966146538455208049989748841632450227327634724861519850548673970692707645764220447294622908527372212066626975532936908959/649938853119775862772868943562415489937051596287217833816108101118262049550788152950870186731211474734431153496637863092397916491799304507460,4989614712311459629553273319502241051598443656297039067485921323549796467103560855282637457253488946003478095529358867505136448461116169489296/4234907939976858267164364737662844486843021264301493258955111470464378387915597916573659956211106275123310303759580692924292703314892400782769,-34054906731542806981748118232934306758083746286913079306323395645595121952275586963228585550569788875970349457249120480110914969317162384482/162834922933214421114804422943372967140261255424851100739263333762456945154739520678370414109706668179503445987223730444693079531065389229291,-1523704617735992052914320939408261755222588488435705179243846485120529766099055235553938603831411152143649299946480608562669352466447546747685/5027090221758993992993726244466118181807331367438271199017281290118083204144555411938557539385568006644787216394541741970811092044348002907692,760279213530018584095295081082586197132947404741448355044634198045028123997159686747194894889450298156973923151558860253638947119790430253739/6624319098148169728486987394090540423341248588550062286898282696305204313591501042245448457279849366493356201497792046644638778915431590319768,-47372301316615371951004871654910260391796225710099976748032844990176067162834148615888172145878184255747985776841244832708706926873959732396036/61947409266988367706940583109256946977269564013853663882525258456070275306380299346012380108572662295225042477731339196906129067910703865171921,-15609213687202965064815342927856659919732007430537682427406827132027837193058407424220914202965377075497314419966838256617699109494449317895777/23492477760381795283431368533586110043337492428611443679512396906316321840705778448681978943939603889536516653304827264747896386127578938172316,1108380686656805083626478007482604646511195408268005946654308081610795032143047734308131663505359432293498683253309628138183596642512618897863/212413539863606690525418016119911325388057422030175469201282357773660119747579260204452474128358756112537934725551996512338714942309744075982792,-62931286181254972801185779221969661144317203127124259838333645452234992600724039308835879170739043053245186894236922325914381244952016348408513/91954810542927178959477412029622837025377310040103370710261485561050814678896585779597951200932265268140505390908041126643508706469038102164728,-2516755689008981853654874866258336035551783518437390507759212784100940671893987979852081899847007276166226250638406462485564484596610729576432/14363024578901406694310550115135330733728545260827709514708678676612492197189524328537095738422803886931625411660551327921272677619880311826737,-55675732453231356987444442620203107048540138047052649204513111689081911846792617425402303300725287365996793003541214162180191644259076784404573/158936636464161854640268779248469143206192680356267870632783433158486584423030033829505763536164237124074268787488330363873429249554427132573068,-141311316640675677399521707259418584043545265071576731868495508686435386828463123486634947060514535064628334278187120660756161202138305924571796/1014061422561419362194004256893334673451819136282749336145095913640190434713532298605226808750128824194052456767742889432833418792069719330994877,1994116818235052050906909459775180102361955569670222399029107377587957207784907378217613524763460422039109502459512231117438282327731280198473081/9351869215777472137479572337512980935862250856700380495103957099911529369485753431088694267743466330164426236693317082598468130007868326424774724,-92537271998878710811137448200343153086449034646856187928552301898077174808823931722026792996428527688566651397225262741947170610952941197246496/335887043615910985377780469573984162017193941445639414540090365696258853512437272786602588540373430344640378185175934194447439476235837292968115,-1386859398903102789726179080834746334935094958486758559809797363844954852310119897417029942964417832133770057876789101435897092129404583852439856/2499399215304518112254614970881207317953314405217128226944035950888198940165163038636229087888784911709082265777771803607027237643983323966583231,-51723606249766792292274415140103470589369609184896843962667585915646325244565192318988166272931560394051164530239981496847274057928015021100681/76176973844248021361044592812849917453264989231716304272787730056053058255184937784793455779858156189517354531537427689191875627360667610596640,-196257660625215327575581831826196843502111219284663469002570826981795873164684898771038209255064980884970665847918481267197340106079572582743507/267829750776561782854184243336030011463274482782738108864474189513795060554158397127898528179230117052255891677176448009996991568727242829871792,-10793484791383217899758015845563624784337173724852274650654868393862778604087035040482035581894189097473873726583460979098012380186031730965513/14087158443601659636652980103570202201512787772784031085527594141821507757619524702381696943758911706277721398902345044537288534173675436923652,-134756116695012380948915181873414327670173115432905487478234708147805317155588775612417605603080621933167892652979901623094181867421782215573/174718818235656260588592955968730595070245043064779629181017126699182769152854582553372962942130479083955243205358085825195730996615127722880,33433289240764171221864898675930088546427695493841729662397250136210926846120868541286074839477520903650742756936522088446598661814326805568/128785435266056456581370629473187764674744122649896439601662083732866910703114026785662013663771373404045383452117305147650581839920363562149,1407935046242191907818153620067445626443795262444998468593390082326238104903866275665082416060758326670288704699110151656784706377359418213104/8157216135986461000023542974093573373916660861882648584408071359725913906438401729374671631354886420956905510290604658648590322805831167974407,15302065134012391067367697709247509635477068469521749845128849638225171838663761846176852768533093646602077679157208990218014112310072556896/52769022303790058234718348565988018958986266130020715839155415150835577344372468686647870925841123738709703158420657337073593086212280077543,20898682883508025412897461187228179657568299259782692117304844063726136644903448348998383206654214963938189824443932583195664432675073492041191/278085609831842656995374385370202256274665468597277622145077045748704297203685152340441560432511507775236317536995194247222358134858865037460336,363649976747868391481840341073813375360250754880694591514122236858358608775695618890499081177769113830514783661976767496321592682891530916699959/1103908840427641896899141940287857601143440093856653232372362643479127767327260750639093520501477811792001767090112544653861103758432393756767152,17662369133917956947984352791384499811110781353529284631928707671975854549014288603965172512589581276866423739455502625763118713758870913035961/54123663110829398842267884350904589483156584877325095171096880455233257006561685036677052022020630737998948244780211417861418728946995273757584,101027758310565071076299487495013861350842267055122393824609167784460561085212197375685574772117732875618472063876585985460928479836234935076423/274295448912353462063424767047906993431227716975042050563570847128334233347706758571167738622186087697319770330017408896118102094305611956077564,5775425668879074571738714456952093843249507192338641123896181990065192607803809027966594856228591292088199928167347631989155114067205343045125/16700481110609690465398058099767426982741955252119019131642657089680320018074958532162162313133580866481142010118038854971213995538353502065076,-870814209072004506945152610635217261483630707243632769099196114019355433645706644714437226003091289058531479100725046347364511989669517376947/5310283170207594718722506139652757090791079795184190829291816609502712107716342838361601880984666675088722120530816480054913492068941929453634,-140896209124829742134023145572278628737852655085310491726801450402633832072090836865023694770753652063958766670155506782262358125988664809314101/138998098715650277429562585329196579463955772891345559698601744148329287799082841159781722086419589359381724440353272964749605161432475943848772,-144188331191599946011423160039164932999983803004638906238836340200926345738088865161019521482341981800184039398825980785844362386396312109304909/214052107608314260054315902045979417253017406284567617664455618879932693382299976212628094078551431502565697876717282705432614167179414177548624,-39045853945536243989128643097607744390795992187620294644235354702211297555444903754402539887753460025826723576269591804508385002079889831180457/52843634814672084199804783302816517374805667498834803643655507386419515986690244437621167806489459151072727717128668263467667329161935055287972,-34500089889720287490070397469837795442460437542885371468011953173414727135260076838546158718815649039710119051986507075752651455961711425409617/38977091589667032885323650802266163125399095808165436008544079495700408171351232183875953819535779944101572078496950761125883796881535041552900,-34490059867667185776007574229530942860520222261487795944037244003329616621304601568782516889387655296620388647820446130023695351016662181497413/59605362079456153587322528008059919786527501766007253005808237938413279661825369454188860452660458177508245035862961492269808338245292965221804,-3053376115081916554211431469403406354399698751487284752628228171811940654227654968341561723941882412565128602404064836447032713240312559861397/6356719764657979675507651502012404266514320973082911304833180155374112652496170410688418409482891659342711584800778571354694406640477298743216,-36725310632344703622193465400437789205830013413502973302582202871135781475630790839962242692023184228548335805604642754446362222774232803225653/43991091191504215798734961843574092276770863146300098501817407475077235820481559434581112902037508622456760345945357934851949854602163863388524,-1534932712632459152041006970717184948697471384992471165104081615444241931146806389997971243665055071203224143390979706772247440574987362966155/1550944202820903676332031595078527709755780244709908026505874811181584769415250702094967622599296156304048118634400235196879032696771807292838,-47642240549254640390305884312893306130383934507138279593793303796703962332429373617906181232872117496937817133515001061422088290000621332227965/58892671558941216987132308887050624074313196858402196760674790398471688682627397674076812287304030176596876494456716450575761650508732246624652,-147533030009430723578372431088640081011817400345789802510165446645853428941174251169648584853536980249090370747023079892542099394953494594775/231241596732867479430998405918230997389749824144847565919077031537005583727163815863009720948581198166288858282613556876669893386339544243633,-17475960319757943152307705011822272484891621726276910500078825183913270656721621325578597554557091429066520127893321254053160844128769356833883/16781136464344428982649820554044723433705862402000426297781226490855997345138225421720951472020860252639868948162304406890116009918874263236442,2430280416494296910634155516877636860478277469773287502690880755601414153375814239901998809452888734999999687177930528242757636314241700703785/12421157566146638455457089079128540034985826345982426508182175177126016377886014169825705601229413197515774996765961315611911172599740851175636,126951830214692190600707073283634455673003189711094353929456516919417420136651027434154156474444022518929773004616470433383725908402476141246/654267343118763444785623656189108538897564000231821612769721314048159399647193860322139125538419401706691118662470920483293827135312264936699,-83034189660002258496824341445416358879841468525865149408570405869431892352500493484221596473094202470427234336114083786232377837155075157813947/81248075945368044614746346712625587955050254782524249381368061098408752688641230694081977880833906842890994603988124359754673537946049525796940,-3711533842846746840320722756434124225640753871527401490545163529820846082027462851273868164771469347519050481206070504368078377237217837334985/3078706171552953693933811103314016983931148318828932185308333057685596234924959752976179657340173995858429673252491904878502091719799186353856,-6278896719513306151239730279462921096621766808259086890907517933995665002498052321732219672676539210346996264559640402173405329294846401195737/7515564341291376086249628134645922636684789710305120357942929256468506076474965362706696221272530999173219388876545242911561123093256316790896,13377126136813585027378155451414044247846381827358657636290016488676103234736375009321616875351867026377690828892153432924527960101917174711317/38493262647254930644529597565895974036866224766110536568604853500776023780272867395957475442151913956587191707644357530205122885377652254090484,102300288459085327536182696089189858236400105658901660709160712660836081821410821370170496990306472016428526949105546926047286307880438732401301/194529817515280578575563529593155754003335800016779876525995520285453869381498270242112543596817840653201746536541211529567850536546827359368948,-78148781328553228360753605638478724529121349310992062734256745800989820105146485213913939824338496965575090457255710108160138532596054529570732/458029046739024476654051106793406238420602233678864603318480415422196146506598483729554752479810411936521949166251360017066433685082332830691013,-30251893185314893976846222205999996010335629879895001899385773528212790403823453249117441934602521057261748288942555698594922539386281118387470/49396106479013760619872160861680012595121155495809942514885494495218658169910517504420065577112245760828584940892000761152204805950362273848721,-997511737885599301222026918093859563411556663739924583178285246830723135624349655705281040824507589178750170634207896658075177403520013459876460/1343041589500748810290301136912839336613505938990995342163279248172877151317789744670226696992596349274558003956242642014476652114219696990941421,-757171340564554796922225699051733649696609468093868711349637725768722607207320708613899259626481299014000267392016871461190644494943934082078909/977330406662798228619256485494737193706814908785907371881099564875078478021053964278279324346485947025491038496761862953580073268783213111068634,-76574100460793876292942042937508238439628661685911458970181662006363183372433109720095295817858868289562842009030427464372677342336856343765271/192517943579598757413240910423579149689944930764295228171121641787554778890507448849652317243927008364928400431165941910179497913157762920816926,-29187738926124236101274266807644668443385199558715111992355405971159134732719877493192499046221528718687364729485375678204843761254707509050710/124784094116346737494843008466854899410448298848218839384307882569136535729159560232446898927977553433355732082367587331596215626729199542475751,4230873516960810985598797786097293385686841115806671467618250445786980047739270162788752195107308360035126185945201812034061926457836855972858913/7090699657824031489771771974539688293892733732646665285867951340565700972064939720942069618171933909562519588845288431863985065311978443624162348,1022064968320861741145829064013425761475194566081453165520209473687842586965664758875530614306169475429890918754551409805304782159704932799313057/1818205573359015772327193969823721032764998958322495123810110344575447502188128889599011924753280488799431866521477815516626894782921470003789252,-1767956469227599368844389877421392034984480602861894415652345028519746994149152215271532641397160159318481260115048507209258060600954931202084181/1926835187392833220971008759671151725239368497399531182294117125394956994657706520444313670930970376164793511881957945456318897579021955784012506,97994837024433604659333442626805913233815463470169475841363500589494697111359435268121353483210471549060285000209209655974867844296207698036797/271553792886595377124953282475012637151959871494525944412177892416267182353194142985829236923973390863011216316401513475625141704407502262303766,332738718157952076329929306882903862008520097598975319313544932987957900353130934593801222097648802358446883017601280853799967626427318093166215/610941413022596683592463562607148386464830127635118537225118345279580396032869057770046435193207292068719095487748666544278103107726654536282196,45410733238547121012352440729761414864293288403969925892798290442731337738834673679506983228372925873432084006268480155458020171009065187588671/117097205383727204776989888412067090052171877427868840908878523721556074271147611596456774910585186912675382142017653928544323593980307369241012,4702432754334348821167788165114386412330789665339512546342188149845278739326980680211991317338678156349610655420260619895232996762574539910033/13120486840773471491750683374561908325905830255440307572094138819099635972807300828818707878114891886375772718451031648581735149152423488204102,20846194800404524558986231225091944016007605250979679752378741517299017367253086849268713379269597403381381417091843383588961093126787747293119/41807312590609103947178261882058965913280168196910135069799808941161714927411159373025139438333861140533029872035528087447035145685887014106334,-1853650017089880533272762344392817372679558289144527447196620501743038727404630603262699022952017515674202841786087524919391388593600169096831/4262521975310111069955796583076821224900995021029785642189539187266469965724439570351878007006004654109590084728692202282441397059579470481800,-3014178524055026845718100162057503414036231939989969228989017566251613628533481431096044468045376439992430294357991159294175644158185576294721/2911513293057327253987067575161434698278451280730709180565402265004286461915552214058292317415911051403738128071583760793683901677685706852004,-20876314194557021729133285234053394559651549638744464532759892169562387648382459426256936154426563561330667990915862305035213154470627815485755/25082027279559219256816328080245966547777602669517414382160416290864525052133067734739815750505606435321025191493682598048510514379136928421318,-2780897174381611129973782019457295400000934465031928257296275400794748973314449112371128207977036951393458944766202513128740980379803377253423472/3215078369693142403836601762322679894499900320094908347714555062862805956613813617700922529043486039356868849742013270761527089338033600267699141,-4084415040514691848999462411722047876463493951551570886258432078481793555279010536462359507378925413999190406107168342560539305827911412657385812/2471297312797322425907286452168412440770850317364035939506106352706753825066665383023545184383356589580830028648341641360834530491625783105294747,-2662772869363679527920070949198465832906029151904789703063047013300448460824684609835074836153744117452431067084322048278937728807399847613797099/1000600414510431957530559131492204504726856102725214895719862360523028244923661452078636514392083985862089285788278725852447392041386566905567704,-52227738117378563220894856644171176777693893747526752034282004739517828571461936628331828617295908495771913530892982670045723391396736086436305/38682144300428907872237688048284800293724968865669368566954245884398906444857991205562923854876701680017696521949372302871891225398970537458231,-30981040996207307255548020990879200582289643264104114287603461654836679368583079470571930199317211289865232586937264702808647962687199926835149/25985001607015142595669280898223625062536602021370436553530571695182372054044905793421299673264270819635954351715731798613641824691534473114490,-1930697891297326994827257835156382545589217652849459771271354824807485109037109592080108817762896703349614197244396734729162543344976132351895/1276446567581051096174176473324017898735364580744967340612549237582612567075902891035946163687704417835723204864503355274388515117627486443873,-5891888809233875957470506753602338072507269877866945960894608803944762363718070936153270425846781375640724698379048693794337528917340212443347/3850953289973599901968913657212121800300314842017469742205183755018645867356016101272108493329131224373665528349707534257783630419705327529361,-202274833621649720671519781476690144684361641442284209819252868332663250599513403544256308322494658858989682934020824319193475956852095455432/189563292773887475544369808234338713163354956150482592109686787530082841032975320081125801535973353736610770671857783234831355449674733300731,-129208188004153514856197574531694624584937774286978149227262941835776224608896708549658381596154587381691893056175385072054277658590779296703/138938887466616047027610456663687924139625147673235075146631829669015172313624075259161823122543376698465063809328954747339075566274879697464,-17829714254072178438105015173554682639575628463602744403508690559364655873570498147992280147581140245849213011654215202334294225806117017054057/15572316945620553688307658500228353867759037143794533510461403803393525578127497419330714900394229116140384524380343761022004221790945465043404,-111225096733233314219750493005441847322860244645117262061259453763030210882202699908051585928671486782741412006442545575170935966694762971081351/99010551125002527045270173427928809532999664601201795581379132519951475422859469089636111029040604971886182205795017934721332688355740344011838,-6994353536645160361572707347506748491172263413141530993048792934708444120562686982191148971595861905557737051922709809978566628951190858640795/6509900742939858260335851070808274390567233223313305181545704820545697340696308914661068722298868864459973124761528788379612639127590969246168,949907539513847818872700202426270173081690746081883997048249084674864049737258462542310157294103344227294954662450949781943605732092719373356655/4448808002834900123981535051285902239711758846400274749772030152404269597087609756876582234771484673312294528331593057173635630734770647071644956,-90738892993275405290033776774068687699894869892932870841285991254739925598500569550684859907871759633876621897176418640010151671506250116502137/211102960534315402812557906652790336172326030281842921561367242449340874696158257276983798060553370111694620994730111676013027009031498352658556,1254566982692139785347013498313238713905185004268756350934929555140493394957013034054951242014836254369192203141711354396913748809015130132832283/3157293554631502960661810422217538351476361195989337073453264443596589021143865976371031870858049676043793752462334863351182989303076800750183420,1428314404256644629812469978475745856806290744482495515639272052071769591921633007252884588959456633043015979819290418697212453781363761055865791/2396340401036938205247063364658437960907991073723939936217378449241092570704636944641550942620192340631857741754009115177101582488173274164340516,2090606757559208494076229602006148758328282743250223591291944219297728524719358776619864775030371928343500859232655616869321775018735612180187/4017046793079439256936232285770497198111633258518762525808042000308437748695601843378563122316026738229660026747555060612568616892732605978612,-348548912253811914401410021601008083777778986740523603670506673391070841897868059681100191068388680333793920334694331557640409618586308377665825/947553050935707798904208830689909587495444282070263971326179815593680925410677539625173748952907479794140793436056944291948327487091773464894036,492415498959967968956325544090845078341906723766893653619746364007564482534552149223870174183160086552828604258062102134251501825557194635078275/1545513404849823850720984709202143219741245895686003503387692813826329487774910162811102679183960878859313965872045138408664656476162512303133308,-203191162201859130905771880041374548768605493303511344558325665124829728036311891834714464972125221294549863196697878528605476771036299635146/1596523259400900279513546295055653952536580929297763863233639017596261972723865172154684307334860678940034306379042072637345529288170738023499,-44417016024845235991761768047863715099726233879524550547499811598797041566913309321273829406522813732253789910134037099978294323357123316649825/28538833940119467950449401338082390326073788660692127764284389147043728912469495525026767225479592493029462730274393753387984407579285936926578,-43844061660947548174548781074371953094780713163828928297683897276347366293611625223299547312826167709268128499008175222151459887258536591375741/32396513830875957857705726539164795362272969345353681306053726499428151302608509911148312158857402746554577990307251380698512574089094735849386,-322703598480356472759861108028346640477799803290189184517162876955108131153959238224670293472210054627390719937756340997833568122866471829047493/137838045765316596565753029455082074259151949726820580455483640350161765850729194665412321466955468248865555071162644050765052577006347459328648,-1656978221183523881714270598347315680213834053001345243382433988764763482899383076160379720345341208066636825719957240805023665663612625559032401/1203660337724388146371786910289799614702771091455002067731828099799081440550858773322161357199613889586101725012183640794619172391698860450767266,-686924127071976485198429218456345847396945987903336653360409687806213729157284176887023407081064780334516732368042595879649148395248177917584179/202230015542234875240844265546754047949695250843090284155491090755873127252982974550824146086529254997343052384414432450545327707319728580987644,-13434189289469941858014969916939511359506930793995056410676910092204959652589650204276083295831494076578729798569170385924590944339481883022775/7709001953401528637335169064394339236446213601184582512348713172855050646023246627518778300462713768733629579876711225726118240699808939367938,-200619883860267110878885557306305167240360026296149086522645697621364241799762511126052806142089771433001316473698776598462310442736083387284049/84590031634843020318829334108219024067437617734341353173640946227644742456844882309042308310298318286701458347372968975258972969415252908594108,-10120680374208599118331451789707214996416052469043394560643113931284940390662582739336372989012015283810608689386806253502371867415367457225461/9033706287620159100581899325988855328797832900961331772153799513261771458534093139527211863264658408844842470304413697460596113214697227367854,-35689155086554299459162800877000775161006032597366071011307919102270240008163432132583422194139866498537588919029280264411308309969668711946777/31945563723063070290723384686265687010079209700052249151684428455276839672544032712238236075868955839428062865165825151960390405480676529619948,-355415723393391529649397065369054972517017198517828740187637426463702645733181778035288368606814598455911087514920853992000202378073232604463641/31149944873861955479674616075116927936720576001018283743716146477546140535637076581036298484850758338938795732373376565016147892217610851736292,-931576944148322554192687501586513877498007485664062245128755230168866102221173418468862609366933020633496355776222113376347809918804185386087505/388691153365718829320778212948610161418170047455717918600641487066939088004186228864676453075204533878435080295526632452025693319141625032695332,-168203110079084219226622156804101264753268618863138161999279077654135240301806989115499388147566865632067437217546736593466971824227803109003589/138374480998869417091334218046427161389965541561599094108472405158663728960807081327544734103909242734710823150738889496018789353582463231968188,-20755020079118023402776599565515254433032608679917701923403394474226214051765546783893035947615904541864825074626203039346137245984595936866235/7704895270761404108537012570634436673684961566303824673577036669468971802417434535890149994783509505303550435396358677218495516241531307778394,-29752380019681109288694312486979215276022787516063231914237087593093434447632075330365337358609646773895344967532354590801342544515596601011955/4852442763382251365669262528990587008775306750460522420893950019384668972499978190659112477215735284126507241571525600854191033994469466665292,-2356787592846525701186517226930832981604433413497943106612074481988280439081068181376333191674081199054622080738454613016024820656081664228443143/558544802473819568196486994557042769053625527628544816546171767346286785227741688150638096388243783647405948851427674401366326065481054179036988,-229066383572867593481887191256890537885515393020218639478667622562626409912014397541479910278449624316722044268093574896382260915052758398564893/119386781949265351208702234665306041253188789798366758122427326259752701094857388916246301322607263583238257776299622575410771421411847976733012,-60944632314390220732689238511120343331600596711214623159849213991901790791610182142432515213808080045658352551898681957101250321491629469070195/35486839106419788590707433246554138303985611213974293897857631378114410618161501074859887419369167631773996920743294768533783420813044828038828,-957958519805185266212516418148329026832068696729601226817829888361294814923005035503688053669963511986829380803417014207130624643521730229457/353344360702768370382195733458086724113583940975933611720107676221266592075828651073688332871501609313529662748769775214951498215547504233746,-1257185053781422049493170437677045212944320898791679034617377776810269681778950206642516714038084174120698047015533764772524749446068107979345/1736047295525075158325930461989104558327087270188635341893329537419100259952567046272251279990413115082846452492424449105744558298080443063748,-5966887470745751373345129256896789792873609704769783668708581388338336085396340188153750810213519504704643755330387694504856755036891768084037/6800117056975276045584775727963010445081282753271464640218423163190130225764150951167993556903111572372569263238863446356034264658592512099212,-669949693185374565603966360226500681012557433337957440273572419563883885918790730561839310249856326046158175041221018973306786734972519611337/1050828397343815553067957509253385701422094004878658318795121794299445664406670321360845862829454303670835792339853712853193642944124716153600,-76113740054083566710078371340925167814891290189836904129055155569344216763536620116470727042792658776182921849396501162670956346250072562887363/59645427262806182388914334345963117911204712312665395324709543770507762332394738265221869947672665999308402618392476238549408588174726449454620,-4369654473570415456631185629010728770488064719198244442662642961955756292590940095983311011586817286880909034084847245926346356928801357266378209/1857489158882278338859157718696461675643365246644337708891447547929594012260439133210021917045122566065217884260961833152295729677456380890301412,-1684003109087364038098284520839650614696279376258596093466377995132052732830976791447889472623251387542894260876841973735541773038349586187377/2819751671925932588340788257312739308791210443968331204380680622130848076390022210922722970039471245322719892128787212926769778765874130303100,-3638255228471618917899107337100570988531346709427709297265083928452655297415237457555242784429052538805176170605134850658843558864350672741117/7272366073250929547016575493268005967929582462031852339417877066161877729275987125181573055322297860893647935460406994121984483612215257426132,7454205302640065814630511018571657163513796071098439530792274443578924968881154653109084397594016975741796632523214339108004190192455561345573/51987047196793193501288978586081754503272871415134391405310426147357410297872428298780779868600107647262820152921008048904384912523850946172700,-7566406007568551658594538579170826110312123901696404034307294919370421232041489523222021648006501088829832906327661817183683532048535240303291/18530274347159420563846034015198486049751577794548665695471086764750072034718044051347139013490243759140807170360571888666188981961566132047230,-9266308098712167994874389768477545169089817756881543963710548868426295306366227179905522041101892614985239762213355617318245170581588694465501/15926796249397368482504729388789903087409735927243288128907911618988169102953781260086755334063638482755359241927109166606312993623705451932146,-16343045577882713728979095701307226051717127376390406677889842474208978274494218423899220658322896755821866374077933768944576800524662601532052/109077838690589961788519153009302186393590123116147580025015186706224160736657920230308480754342949370171919155571173381316388114450772691438639,470362267190134660259909218580300495364430644593572162321123609223012711625786909714383688294885565175615491622032831457196052581115150559832/1948241832252703578058560621944231473433494404966267898631452559693367732616406882691557296216015231353714097758998632253595873751271630391281,162084939311147027487670477779964073501101480464799378681554805209652535659773046129622625673778119172552176189924009456362391829969137546838480/262831181202952128632441937200145810194724931740040052619833946014179296426255597017262444249988450204644507566922623349355378355051697305423141,10633834639765516214460908003250084181273147328426639712972391717391061687430992492749212783792529864075371878632326506158362038617323686423760/18305634187741138616874142178830350560330807317682700005707430836824401697049797628104427512097493339275375136033784877281538671831389704816709,-240645513306572073027488907428886115890161539934129472348059510617995500666777762858322841682090146717491403507174677373140385360492220327380/1140717180311719181386760335925735220486488503833674865682462981225137492133195483918446721830079560065563514161429445217151643579241233588657,-181360137288226589310677327599967217369091630141384167231868650973318739817257161190102372363925488786116533138059120471986163091772537756221972/273077850014099585662988531716485541168943249351012429831137102531451827498728929609838720350769053541193974519900899841254809465195742053202119,50733530661692309742005121324162189956662469550852409204332686625151492319336164008781070594450073170407497117238418776584623526611663625628840/72064564610546666217549684677714523087409187462410900571785549564950242506651765727668416470974868550874314390975345517708733244745054696882501,1005861001050144404141065485647758627684633644956876574346402458481486462512782493570536839084166121143972315631052691738354247212464431959544/3602096133505325599757108604720598653965625746159133709904673870123669981730161846576170122132642440406805399993820575548808559428192498213731,42529262626627625003377433216491653359828502372361187314162525239045646254703823686544219467816419397543927810646142366961050448534461311717737/68201103765944585327612537404383179529606731846737504815961512055938112294190354843751598323517967273244967536900243736566034023637740141115076,100546741842381357769630438640246634194024800614856706920251345323339334924384337860457796424467998503391206491783830361352219844544881877600785/148424192842297179379500792183929263494104260905537521336531282214548022707317217431322268218199370301815859101583236403981211046142602135586756,14155888158042074016233088927400241554928220733581344059001488022506835649700824187465642190108049589691033408555185561637931463627263897387461/15492509485839012725201695555504705995992348357276248551847083719843455919353826274821055792078431915696192021637277995591329967039736535104220,9878761480803333891007133101301176381520993163507248639655799066857110007947496671714656631913828397625795130662823700450711960489525382476168/18304594556468900655881500476054775241956422112468133751010858414990749505107286719451334395539818964977256804214834591926322581961451132932639,24757498767921368350681277522462084811225697077718865404814503393840479640329479945318365943357480577752228584739835158773206559344407589791120/23356260232643387583814747141912597114598116705616651938775326484568628040926249878646593344232843098063475364761792151103581287974635355152273,-670965865236181892489620208546558821124710460549964431008848057633273834459775997813479984340067640059282454619951311291914644686363116127578/177998441714009666326596579188876725881489511677097365704605904711978468436963551430333421531500960826667062927640617864722776700975431683529,-391857559359196447525305591898131704034730439266369695409346064383810696884224151742988155353713487598873461114048563585559532786396032637964/2407362916571330418252461838258675555899202372378979606040899782398492925530017236727667957018663189615504866827546450981340315591407140189509,20445559948262267469343274971694528037029740164220585261944200441295839426235468551584011576048138120175607458499495940008191155849343312815802/67500020241270206667827226849054202014119047983526789344614159027557409136441447509402533856497094136844086860194421802332566556693507206763701,9479104443673622758004798490663730271831204289702453733141864683279134863341863716148685921196399846468394706875476592565735190973971264331312/16557210327405081380863672327485423205374433917452923589431193723023784879759129155911455007483951628301940996947552163086045342942164828096991,5299834554653365005807461939518376823266190630686243695956545288719474821562713091792989511436394459716247635339968075893764873854571290248517/7816194478811562898295557790423529083021625733639466292194764394617168285617978964699620655169083059263495795881967968679021103856454908612368,51340498484943912068416955789421259748626888476567040172246667527626532908860753307343115266797059827146212698722887530781186940802953273590917/70317882141435001049272970401446046308007374253472520251179665894522690400288057842607234102706404989329366773080477391867256569286999561106296,4149420540509449739615117155495447640014853193822917203370449855072783732169480163239426657880647749124399458410692851237571188837719585257909/7024936069823943098325819607127314856560750760581561061999863290098621007385541675695250115874615146508673385310002056943482815779478717486584,-231545425528661380774807838603312166988957264936814405988678679085113135535238195891941266670690456345236806362891049601502788803927076347264/428495362601720519473020212279361667283906272722299230207916040889968610140232280724437077325129384781230320953265363486640571338293138208119,-246873674816677867168181875633052594625309898134396065333880538502254917373103213760499600264731213697085380570363738631624800333741951500880/448434396377415172026699106695083263984268541098925179660812426008695838071621388531798238523097354464780528274691254586327673743725996417533,-4939862420347454522241350803986563367439587563144444337009169626433169435801780594796237869894090139619082054265265357467051078346800710368664/16110963373420360633633927101759870845942103161189798027014634079979434881842820347104669949750648130545024947784378135953937693365832951523455,-1036163453676767205904587451630413290984873975516940007329073871863617275811417425889612158574665194653753178433308526308361911498931842301256/583315343463468346251439154032738781729366076626300772913000718722269991478593486803995928449738619703334122348109553159173868378372514559437,-1830748538046921971846392933077767888371776435784059497773455980795659602372711040489620138078446696746287547993074971716317509691525559556144/2265909639673245592876458300611473847896077403574213121743718404197968178992692629259199417808218274887690407589786577542964834536034776056771,276182193589758002507578111714910031501447217745531981705864433523703179026749173770641949444039072189407616811496974776949150775386633940891120/234299403894804370937121726037468340670176748362784944859471922454518889725132222228224624300314626284727319345260249532076978337983424591601207,-1113250101725038443847786933239202692853507924207473621142505005468891793419758805644489517162784730188652246808255383611398978765844622703840/6141302417993900719328078688587085628012916920277738238270103187471299772906950412311974114693901375324103413512487645588808863451911364646929,-529035636611701400062736418121421752041963039030513624811617376937299551874176112773572939587690390375300990280597498806795180923823885013520/678826292583311418142189979476598239755187775636775631882496639524029992029771236923231137440946891421226557622186000089187341230118332649251,1769197968975849065138491213573803152644673448771437906270158820465188607619736594539089875355301249684587673582079859748902274256649575078396/1523528911728935245133214908309420272948550249529134041637142599122384770600910870116404389962330087779622176713782272286716946954058583030463,44817071353025801673288342703281537706131499144421870791850261458862184078406377303410013781428040968285142603756230211118751537490576556608432/36699682880770892078183506379087099297701089164901896385297331998832523091037966649991453151634760766357331304564016618494830409728452836789523,-6348267367098161693398326304168430886263573908232565923481873730310430914268301934468758586460972736342323049682330144929460221620319870595984/5818519086256404971552509452589712097133776544596017389206717266513772812951952632148299371020756776861821739133378476529738673569792588799103,-157951512895279071043612968087699997708673557150610264086134934249119389937436486931714018325767857502132411445696232292002472397978184905620140/173811246554619480568960412225937393336714227535441454109079484262644271613362929942310611289938866814001190849955901889605320345826323957985753,-372806971601137736983330646110178418589344272304608675509919637464365318994226009874384907979687196906282940609371107293581643302017309576020/257980830442766799445949656988598670805503033448142209162025143487895494293963985133054839396199899981266729870551443181219078475198045841091,-5999592428436643121634789366233799108116464603623767360626565493211411091692844098335651316328564317459932939134439348590886091486364409276/1517517158769736671322417692782097181522806625914242314361718098105024192170753365405820840783205708202929630802472775526407327753882019457,-55672586559899272786575952258058721482832940169598696635595129783105652512813570475061839264457025393956566679172472615691893878331625574804624/15542689946665469694270942598400151224489523491172431710907540958727019330823092035348995117657927285873163601502207512807813909752089424643857,-37450282861227683859254053709667484336575180491352519198642373912046174462487333501022737209655840927015788242856189396216840770693047494705158/13409852101483985355995977549465285170422983542757782732325690760953578636731987161690117626817301492582234040783108563326146930112425541017557,-13331354733480326984930259860106655511826397985776095012969611006807961293992992131875136376870728333944325065281602502429880546891010067594631/9290209962108012235663871043454542726336361017548040967572679717301059340330101080192601759147781408244649806605282116722341143091472890349935,-82859231148251578034388715204731974487132010874070189302275482826074342468236901539830362638217619405266138188478621817734669298240376209749/49294323277473916068096376254789718644147499539788197128419665608393965692324647034070542519411292896979576412306036917246600494350145662176,-60805178992012744018070453271962172218345294805600777283712709373663184467915308530945039015938834585019783510044097885157192899895449397304/26661457606440671833546573951445889507566957256874267665174235308123413606525826032388832538952843778131602895962188614138297100340503884631,-69274049545024716903092131021304761432434395823900393509625573884211518446188042052205340981000494675059634883210496124482801452521493728/11177116911081801336332047171867650015491390578617415179969028717100845110406695869957486184494921813364863287613930840464257372387239273,-6291872318147132405045178433746405578338589381556151892681352819589061821361856742845321892832489402254488792208142678465460752699772251322/887494625312507896950859780629697215715685147217133987557584575480163031855024024201323479004900104100703922907750303618626060033618036199,-7152525111632246283176050535639368746974520174967939427276315720116165954301852811641510411590231124841519971611119710245949647260827875081886/158056928673773192509197213548836509673540762028057612050243192297346025336867412862358100347931325627163355519818182965424549275800370549773,-95353953438268110743058699418970457901756691359177443733509373365397748519957108333052938192826542202858264041588645265496818328216820244071/1211327725511357708517950818378632058343384997754112120026227630528350147916985586632023370083178987341914450054046238558425014552252666379,-10277554238684755705513353035390343845501466374878789572293839208235903174165793350833643627145703976273992980298082487168205284155990426227668/485431840226194504194066686096477208977052470024157058861611155879972474140636625309702150830413814997837415099489621354881808846029223045625,-2389771223160096360036248195434179807145386783130731196236336842991701576838363630531038320867193473621333352042888461034043589027802253006764/153559459708438408559909735280064172257387745253866940318220123754826413108619308788181536303588198192442472652250377666043992287730619877395,-1258852434834206410451125783846363879486796204475710272305316862863760853633827048767100604364354530993981565602077510776525937973957442782332/123838656364777004299730215678671348992057814558259628231177730804204384947751420680531423266127538950635331676709162312484604798450149092647,-23869598854562980764923549270863123261133083366186464607366651035481156671957648774474577665351111465815710043950235347486501698131885151738852/228807701220394122717118900646793593241426302224923738451422507463537694072959031636205179058072560164564831956117922746368928299530458460111,-5547456231994351775283686187227683162178780818129287563341361818794982106415162033072924923358028625338217274113409919405188980958892981187576/554571799915423757431851063318006831282950513605404908137494471274116672263339356862049958830543923517405275180315765748435572647063782880415,-47244467264516914707447063301179621068519527354708940578738051198378032108405528148390228258130437234194995451449429428135225511363856093867182/1112400680796060158764704321574998507014641553948605792590450036338659883578231553422220916661059436561172670266750910864609349891981571423745,14798344374175289427505442965821049802974659467602572707312109999153191324333889994723139401204544034287065782342279199176073625424754288339408/7593481478506232774513566472266389672542900199036366241051801654404268275060020475626161086873756781052705740385048833898945913409260210155835,-8216455580792277776805353353839876591687994627653908717735636047727632959454702299740484205737735876540356080304324743690668939947881657852624/2776741146112394898686654637009760368062925195841633821257548882382004868979671315961350711538194852497797796902158939374944299464510381794213,-297880495702129032009835075863302588807625811174005568879123647731563931613910349883886088050775999399155743721490801775431383920528668569244/106917406642657897868391369935982320935551227406957489982787421586743085718455800863666817515835128053972199211476119491450129817090136672103,-712899790062134086837459657792129184407126841435526236212013867208653248323029506163992350409133773692169911401560063835635823941571203891916/343424347558280674143253699771693605601420070752249794814232658801981009033355140442898741498505380947211803908352256474567626838376899384067,-265200760876127913209053749949928193235331265730706516881631709826520032079473471907050931022077095476486529538537268045562863085276892947193/327862544776643080167540018389049138202896702656045886183752470720012892990705091475043278710399265420526040825600438910747279093164842500546,-41561877866417093488830465458653417763424260039126327352946481311285426109299275718474852527241363199035772520763771980056908640681230189120/50964344032090449122596317470788687019561519263952449594386919424774315714127115597474243707631680944449273148961408151480707796138266747319,16815057663048984495083162694939454178062906814218615932849555217947782656243578747861506268684911464461108309154666750889522535713139553150330/14037935696681900860619834606561905377740293791266801630775185637125550370052592157230182143342608598617637554069012553432598905816764844903273,-21517564044643705289051053044942868544213338142700484269571523156682964571157591891669346730996856223846472782705825761595171847418832730114/5694092639068320865862936391655364367905534623318396802631036545582647963193962924949888799002813503443070528010471046934395671455960545291,-292439216666360848638492885829158156687344399243136478202474327630688361313452934976400984318485130198406607847631734783793248759957120035521/5925871622882881239782802430292308220827626705702064387607139632903695043527028602789041243117318164984391552215648479229363053985974665798,-39233735220301012745299722805329924045866762367412237454338023516735571931507771460170503587657157560983773602100168966134213385737659255912/8408780730773052847771384706570294611675048881053019774732932633088497037649302554756823063300147433781762114745338643004930564406342875633,-19328187630407152962141675221562095987381660225064299363956714412878961087874960705883898025106357739548038490610634088238944313247433553328/10900605902413118624710504974636574394590133084606890613537140989812575244823350184917744616428301138034585715161622387880235314838189347173,-8510356846231144980762015669611904933084097123673490273877335323961667440653994238407296375408857384756923735039616747243453088709286555612964/4552094779184476842489223170267672317670508628241094722015733332082950644015963125058225249736828479474831277481753999125303440765964361676079,-2422833410286490184278575072296387609629284652779300533029745855067255140730662265541589503072105605738102683685382181643210350451045188920919/3116356447428655582679625832747508587384474212773551442263988498258723185981936277013919414243638357971845781329931694525301044474943100592096,5056244876953030320453783431790484918063507609562295275404086977660514808706706101827518751195883273886117686946255119354847954441075688056473/22719244499095565963620213918321562106882738363556518288065497172662066696342258904186278802440413901642335651752730109727785138393481553116568,89322619717963212570480263548889097878850940563097847808976278742618779551539724401940824795312475570419829695046840896124391785365970179405120/51355179674368847784776508756045849907026942959443691189582134151410712480164299160595906505951809460638646434829709839007427352954193908812027,161232367213838177768159277087570814192416347856385118201396525050538563818019747152690405542761838450821237733939281484176762612884333856062941/52702355276199412112096387640772185624603750115460795073890320979939198263333721762803315652888484896428631569077315346347588467306835027545784,11713102130764925475220779547180609504943976161735203254948180125158429049337042872845556411976945553232399573262589553465828999585388629367392/13776699698415774191204517184692197722804372189243075780822473769176357017071571783302958259404722559004792868629401478851648943202613134333091,-154482787195310720426987536166095434914913280981838520120344167263751317283510745689687435636568152300740784749835552908914809518145313146710/42076110250123310145213874601119358853267501114984383874344271639039765731275608413463822147554683047153554869932680181308254528283099287049,3394898677482169436236931795324701772751742623880779640690164432367216647677658523239173791238340290466974392938105330610327205024199621287568/2163660671806953483760727351104805856146894916856567014013365300448141304777064815509103541636489957277693991657183568843309720667267121428741,51586213570686849186103646094539393007815846403354849630507912798713947642201457238705520080224437517989026502816685038963204759253706654573847/8325506310969127293540481459086851658078785960183560234826180010829784626500130622429431969937826579467787795026943102599347035381095712389312,486405857978290804714627876753935377339756298957046486327450855797210373642631379004648981149677459170393635817591254145734760032696482935175/220537390092220978222662509689545771346657780644895634692460272205137201068161666930414835656816868263031613712287554744576773512357009298016,35866221065043173482045017135559079409076926841902178125373101095206622483505876015872399512107828247316262667268366868209326639419597173468464/6472646946167899677656603095622603602168029734864328697166073163914946953686572827963730521396569623296434640540789739465068927316465094462155,203860045954496176507984857389300320136400012764307884469325481655210861024185775085256718011488630193920739039174357669873081203710861198167504/9639529764876602515157339905215122640681760639525302962187255813538400035791531070129382727139459634523482712804991313079617170665272743409975,2961326688280219379479681952248574321002291969149805535307898177957871132849697106224653942615192588973423387762399440849021389204407603453104/2914303882679868419242236722718907232919335393394188131947008831938776882271757217031325940656103750106469546841725115712309173685967006823603,33027664584200300121591181738258520408561104097773553938717349469061037454425050269565013266519823785865303043697071111849340922308618838301747/8176111610033723638040664980322957910154524231098534993961349420274484977955024186443780938967958209134858807689348704746694775722263164971104,406488887468798125409424802017506491932069986177708086356635555301084638638351363352547089782291567866322461619841201446993616131762614663890/281966151208827480269932326744752415547208293995736710938086902738982035667718864596324322513964268301154145717790690266898844698147269150197,-11397377203772781776372092148322344178608144960861648292535654230813112529513090829463956388927043683823532243212758959651949932293806076202/2553825460220892856525186266278626578067614109426781145956386414482024943581977452117185048929515567078924098748605649584702010626371965199,-151180435810682702167542239422210626361159236534465575015001061719518529869308678462940600710040540805490705106059177614428134877007134854806/93937644431575545647113811340896406345756440374346216399769919619422947225472343485474729280819934686312991218743463521315983751024321931765,-3218180001858697763711176946999123524409570743704160542746979905438331020171588517959121311652110568362687758399933314789865813540683640105/1039701258304079398411907990883889252306235244772966055458789461120154379364782808856492737957719782877035264175141129572692477769233570111,906031161699014762796333114799566420435978955879524550317837720178062988216366222344641757848983654984524739319543862078982866689244231446203/1262002724744332938497224624543478042670563603232293296484819215562979809311915801380649634054054682121598041084200490475443145992561665022562,436571083067743773627099646848151494797261931562382581893624526759166405776311042768184213746589851219255298541747127417381711205206359989980/863710298510529042406340324825919903484082015977300192264310580815954800817860176895176917783412816484572236418222440280595597408123172186323,4152231408414765972712548345802307389191579498410106585728522881508319815446637666322435091945447511446519742899138904830015565606136246153/13170433010304483410948134618786494739622825569588183797339471854568672995258249251034573341696119671909005818977334960615585385010280663697,-904276587306955862645764369767208853477885726732941886040250341567044673688247591027172048617286451237601840307779051960143739073338642567592/189906653277104968198553608275098154837758533398953235669140132120531040516975059117152304318135943831317396372890051610166624802033280231029,-1232853382440580591067235151344529277932809730446731585076735440757362455492997375207412267409120038188139651933529148948928045592171321467399/451409637832391524015348690558514952439351064623023648969593643586468477688650815942221721960709182749921273094202050015078407060039184192218,-8197701557869626605681098953093737735584827135990759631416184868453111070162051116455233587893897816047673496032303281070222195580902340934346/4206757280999498841063700188063155113148439886325058343052926508171457704562292910435489918485113398579000567767928924841584608113362213797595,-544170314691426047169970742767358756401868250541959332223627665290835605031542260949898236422643936865383964631051471373105637651802661600161/208205094667001021508502404234288951100770012662622810131504610660487752292056594845536867823254032674087727197463239911552806679447214363872,-212034394998019331672375732524138097825984740981954417743245335191719258725809483825747220036797921354464990524845111162271770543384620754351/119366336579505853695468137633899654453911059757324522750517575350689365202986379225335109039564112516272003357277273413022813109049543093904,-6972082757276622109185452129223703935993838297337530699316253661945836058381891954352610468405890961129553393606816102743327559131562515556310/737510672099579671572515244764608535999470528337060026550649546046964270542180883514335994020584209207195867206334799246110266652390419591071,-488440105966079132367491402703560721414199220405110676096711067930672286558915657427615971716597032800097537539859908526837024758267325842468/134078894999223184755276874227799102584292863534563106199259294534815775574576422655991461425723853735743465847366260988107801826895139865451,-37429678069630702042176348785723763508901235984321015008112371695117007624928335098792086132128679283732315106812756451858979281439614066737/1180492708120842281372321983899815464542091785652945937160155837078439541274090103109450920369305687750688907985295848525712502047629283786,-561505996187415726450138372070978963458339024026820324471552339950492147279647847602865807004707169485016903085477260948314715727090507629082/29218051227545874572503458536720671335474238660061586930626487391429738712975767555865591199876399243162565926907382694010465825531856137821,-92516226416831752910755609030009169338615039705420162027289762881307008527791713088599189681405199420497708152928895315144605274969760040275/1337393480664386269546941899510963931106914420066602172583434532394653392472152690566387434007345374709012372884403007873531324078927896654,-962595721431131686467802353564900067259325489485641828387116819849375739032117137025897401629106123924444390348105303223498289871100508892854/16068556820204490086748094609623042976713408875432002083303664751305182077426909544663955445461605829510889427013408536912449201530160218691,-310853657441078192705852171077332428390981409461130411095063318828659754284991652717482673502869420347197922763096053690636489353006873822374/39738061990072736916647007190197498659436926288883012225427731291511460366023338054920492266228517728461812662955484530675650432036928519365,-55710344779424700456350267228384126691904054674164374307983721002492088516096704591546785496676979143027490534961779752082651094388725837614/2066589014420565580777495095019214934659126320727037986555333775149015077049324263580805231282998023295154088737971516532420113013023775193,-22819246009501007449587068635349535690214322923155907606914864306186667995717032955342727997915571172084278017215220386724100580375254905568310/10614262405351745894765881003889835423258464016077662692497630610061593918373846535978682403778921426532800574494291071882816188651861979094871,6829406250485471906563035622415788822427956802895747133760141403347390360566136456181544322775981494093398250554565961448758867545185871502626/15836069533997721377847690951664153500598828130491308299319735090426277516553846314541988900872753944574881866434670175599110710131228479976169,-1160925888793101491836018647250431820900137266335940577851563984276977976319625925675930910870137428172170990755099906803078569574529347463829/423476790914025031930460366202267503749551576462836897773841308449104972183269368501880266243987855281439546610630778553913710906444472104700,-5659401904649901116662171975044617997566843477694435313852910994797353697184560104192552927916555982611186832381862957566713536851415497055/2683732711440359699991433393169321366482276701336982935871668277826074129050822517502772316776512262141911562251712906705555750265622828941,-949869517780934519976969682863329119611047516435054083365497410109625491172862663118841083914244784129297048958751703433969797736416538277176/365879617120128795773436887539405362330621129878524765956955795083373436526642540126889206836247795327703258196042429459623671305409288589673,-1874832530538981258401912052475826198348374831810210056429886445898574014880563490323669906412073879013625982313627553038447048494239512407/409709111531485200681795104101799119902061051934199759172329118516664256317074700197883128015825565559882502601365859026495029248840449061,3977794361584362339092060379023952800017902136193330368016497402520278483056831531119917541155803074601579210326355895263868428964955822568758/3936535641195034002036185233397828232227277762888358604019349762356090017796714953773317324129154764005709594811749834073589851906388019933909,1278552253102366824656068107812963654268426727910108958128343481309122907693919317822700034846119850601886452781194320922548663147382450435764/1267199718596307935215117445433001733958256208158658008632797311259409719105570050893878094472104095639644463058663289361169896632249039807711,91071010057132077559180260608661574830550964795565484461753915461029054566183783778744762795032711338379202901668338634238337524527086638657/87944786867165401051536103215413689474719673921770566099381505121630489360799615638879843562108771461172558519518930223192789251207433225027,1255588740127476199233470992426468342002513087622790006030674907045674634582724929727671267923620695569958662114900054279864320950609093451871/1224181831502509333412911672597407986911018930383262960116171275091969663536965757114430431945790894655597738330966803267704774327825402150416,-15550446738048175780460976025492107900728245352995636148513351762789811770421536613862598182063309169414147071144361737889817919178621727184/3287336038574805578790452884390401764925073960979555920085925387617997778391353446869115514925949783402840354579714594864534052392860787569,-470604877405097083172841221294013132479416327158544670105151097943695654928460245969561908885571207337087237221648777243973342861313738816232/124361222108020482774963838991065804941353667433136449658791145352129071353230430951545549761290266774603230500336580422711787873673002369857,-25994793307361435875121977455620208197592257951088549580485087120234524661267085835653367814368395006944403971299058148347491164899634072414321/10960314506725305533485166073915615569953195923397293742674101928088158578586559230160211803750935027839283020255031715264617731019797250438745,-14199508033246583086292584690159628613249948505076726660504058074320442519047460113898560955937480596218813399547939067712851072051127465989750/1012247467158620035441415418353771806647448294730802016386732993749602474360443888364205506353226101042546355697505350493975065544755132129389,-5482374078061271325273304873993529577196444926057443995064610824844677101420226464585532189630266355157330343283838185503803719349026000826274/1689859967523974578504196122865513611529103263988563882190337160751502823000497290874545578651644981631329564613754494535147814632926889357101,166212766606319790089897800716264838867822201051879767945431496147199098983138180857200355186637549714745301557651569838346635053541470051629777/161974307204223351196228902021759950807186716067376789411979176234054898442693355047671393630794980132096307614298803172183035618431194276486272,37334872774794829234183132211752802362376789733829362496174971669460857976660614022531854000541176326448595137383805987573342598939396337608648/36941603665136113910643841935934658603665012688617019278271853135277278149447570232728294962396271977713085970929266430184195414150774889888811,-194851413503499093362558612226970418544511798495638518386342264076314551959055538082616136434242757043784163549264061653350333386875798457016/72455441080193584523971175511562091213587873814798485260548241318312937857262833653621331442521043958813916967837106419498400551898478218309,-552682489527298563772781846255991044040424291489962354412321815987020572109753129184052738358398451631400379450319922322054018894252549616339/103105581337288541924407028294281593862537809994106043392101325867326511513800841002691176003994692664421599063251340394619541488863051894676,-24291517366518277647890885035321941890594183560278029529632672838140854430856890632721727623674483542536415669917273875370387343768481039397/6470012557299603294118665892867031360609816225448256823102137479779893864295160780588361979902760506138790862767272042277099133610392900736,-3169952846618695054843907208788870025739288759868174687365434628002540125027778353805583390080562876034449176951526933853876116941605286012345/22938533563325303510819164668506351611828917405403272372546922555543579280279377526722884822249300432333356705573605735859954949911883266272,-547122392443552642743794622328424552775751961001539243734748927766523148717140253079229931809529410314078335629118924130986456788680354717810/99644340945338954078522855563944670016200284922927886886073222058699983325284315456494104468000747588662256135965241773346804536610921467513,-10084063495485738618602771112234423127846310215218267903632375043871097376076402523798167838091198099977704959290634519411567931442329210151622/1862588446125032641902154449785948948980366200191817112096766624658744083474644804982676241102864387716701131344221131138020620526019021389859,-33619033625293923684874914578938343734504002688008487541719819926483764922715231008212287439439616899992586584143764687445582933766317697164507/9960453366824978655896826451811156860207781967168506187174346203809606108187426851258634943138311362186044837281686807928535354261529607113028,-65291171438249410844531763039758285077474916363160791562603605555695025880898937291125953132290301976114412444192369761205337728913718435605711/5093413317767877840520742774270610802038263135903083509962223835828816038321508417550351119228826040056665501939379983799067022998619953146494,-815532817484973480195016194936325985997880225649321070074823720772885262613615956569132627423649849472322987606422880946165750615742399885403/222986759410610454942758995511323065493067920059050610133118856004371417496783530070764665926627119361268558223850987660256925280093486634660,-494736410616905529391014179458238917413663750171587536316358713326568695227749567597050871732845068695385746931743320199449793686716677708583/236362869669713775515001994515506854608103317043074603404326279212230715735455471609193713999393171606535678054858447503583249640191588081959,-7593008548542908178770378871308644164830283593032334999986306405081519413534291771744345509482340077566183542048277628609417853874903797367745/2194783015689219992149404172500934740409485674049473032103424904691508686094038299301651595434846020669618643329390195179804674387029659625236,-48831555460661670331485328707966129342575982444603367093135111100028919939252738886781198127736072816735360595598491671947623513369030161951839/5166566448380133712058779817433981927765614452005773519791574480037740691548853427556107316024288923233810460535269584835447306218067005213468,-297859357706918042783622812154661636933664363466417438699935809542478708099685159989705469467951387098406510426088045357594861483263091113913459/74381188976468382142768792555115548675577788884565851583256477539046429445388449013620778582750426188560308469654748656075936532479325510029364,-7144839658201584993123337433779729753882452914627729269127189014035154791072822879848221649383697193419573596838152903204886687904489702524953/745814940540631332145935984112666493887912178040697495962746430398041077542313243787882642891697080728831209950240142691057111634490479036004,-4640707552800004046227347641479150416671427435792980054784976018968359830194826819046051091184640676833057085849419241208686735826234781486051/958680664121801794900334795067519488506332120669620393351197582001519888522172275595089876791631715294881099247668662024337095441243087090228,-797775539033274311654825743736478113578761363788970305054777202376662207099360151566204309905181311831431518180578418042216731694213204849393/8267681326115639001721750820889862645754976362299331464821694291509350925725088337011978412098057543788344402887700442901506608170232145090,-213619934448669142813776159577892799585443727851267054372314053165180991699959364554849802650727437787022122547147954288103354196954554963485/75603555735677041498359932405163424033735605053271926430012540313577702899719403308318437592896609983904575656310382444028858236958579713001,-27715395001639594271852232059087997712279782976286224177748080782267136260981827003009261026161876114868181853671800712479849760677105486851607/1733233602806874167201911776114118459444821957085852201221004457738989944007940094201333159467342700414158649180814854689577474731046422083458,-173809574893546674761193708823616923889070424604645243684657777460822257064628689661683770357127853034055638274667313008766000980302305651933/57436867107997573495280339511627287770803562286253313174835240622620682350002545531114142681698634214107100075375464615810221667680847367400,-37625344935321011363683199391907464083800748052612838154594699705653978382032260120683718032359387970450693845829861563412910550392790997593213/16441086846981442169038194984584401883259855034971147640783354636665833909064697931785970875845526415488435322732422178739169254814180418856641,-647752119634369125815133282547810054849426285238045555354088415889175523136081558733000785012132629465555953813515370457517068166983725801261/258990108512017509092567765690354009262984301947535385323642511502349612486787381097937459673223752935078275673834093481418533262811695064048,-27557076235027080135842188647873229288080273954188433795846276589426323027732076740360161855125737028850241227929794857439925437012591859807/12421396940346761950999740202428013483110040141782089773832670307430469838124879431781796706316989467934962914389081535775283559658589943228,-65463534101094803854288508517116476919274444668121480300884358555844811678945153266415046212023476390607997830341583838897592150314845220635/26047137332380602495656395829319214925960166044261886812110459929532832367720875443679322407225002003506463742354849303546275007697378144044,-51038054897181855657943262265483542134987431350896189394628736392286465901271738508414200570152427751616742839068598764467294999095636523679/6236827914080418077324953714198664733817208302007352345915668935470325780538030213333854013455601463095258464352925613732675041968547941586,-178136999627789548099098196064795172096784291809444270309920561738204472095260706510051774355565339577927972873019903674821716325800496471749/43865751098942554829555159949675083818879421063856845077666796664323478152071167563760941780579693310197270387037950245326606850367608708942,-34217240245767179323228743464544033918713867625431039884582924228105742315424506432274288571166354577432988593351422536648966721238014028927101/2769620239895104110833817274068537386372232394598064958205467744880179801450645074443805067126802223128638691137141644679815638750180878397982,-2422790921924751687560930663053552420170151696264947339347200293251601626453390360986337847060570882549424139052369485157022501637717453165625503/463721456683171453957316419334361081075980493578762087050479189209682477405519278608105116127957405489422465835810443573306242896875838151506544,-4558926217620325987294275966063169946504089810907203522391054949755363583630981972238489594016023977919436124134248410301770808459596195263/1706476031036551752179691097508117808547127744091796934863604902180060491051064110360830760273995437075464883924396784794510239661042754504,-7612252575772243880838416039276568367747732836631669264109168254133880770396936964788190568877328585281272749388023649568240759723215758749/2840469139182970587017496078625235927126812389305177049886083853040445672027658597034167668016161645070559956076742159595796136304086191762,-87481415950594221116074162843614738180998918441406141522090201486162049451564703862217383318581596115917876985186661607646199692330399084117/488867705520036575944849537371203431723088090246313366261441531542398252208718321876517945521747615699275043182630046608040113499949639498,-527626153089197067984695081271720500166960497269092983556030327128290085714426812994577389915516903261836415765421683509975142250794882847663/2466033954905447665380463591518463457002455690090563074294324708533761484698247915232797002086051701326193154511204978601900767128336878359,-14679252267271432738615306478668715069006971818163009011866323865865145856964075378899251055824719257784155982832226868840240356439225221022866/883613809145846494089882823507740517916961167173816833361671211122119445565000524315073066253741857691779043809568592585176248305775701376141,-24497527877622266328438429363148728252646013111578792555153242472065676370481210947405447784793504908961348344235030666423321230757584036275077/1244433530484150444550478570776029955412318999514677308216903768572889156872378364872640942119231307819322413750479529871389090283561101904796,-4483884604888873845974345925633845234046022473053621262232605810500175868581924969573944461444133412732092502034376997551664619761740426707927/29683849276882149343286476826698370880231007859310472888353764193676526273852088585519033316821321062444567235629186931784308044091781596414,-542365603779123009773654901157701743954248781026221857952343809618535634037306686048419687945554662746420902266095413317961276535115346203674/22883814529449099627323140963783938398644967956453231430265442123637212402202216534912325039308982983802355439481018150200712956474322509755,-3575426739213625255597884251878663589114292576640137578712241963319233351048874027550317725359939941699717964709524023543201027643543485068092/292444207488246373647849181291660081254980302886934029170857362885676282899348860258775317778386155056100567757250576311138808638686862496719,-1503466487107176880041837021380852620234725669960093525986616473018676927197941640543514180919566917810463176130386450130125119196536011121181905/561867827429607272958494222403382316499683226072253836180176832072576174484773891073489701539387823953421404446202525772663898458523979675187042,-695819153368716240535097199090528966936882844104734849479038956975318476747961556904069844262882264200341390386283960871809779566955491348049668/163499272960999630476453856336368546130528792894446424476446519575838176999802228408716960546934493845003088587498560655638228795715949909433285,-249003901281943075126934437126379243124385981035906456880573479525546871396968372497926077966739821143141910266027614196875953779582715703983118/24897098087090423224956764180292769484706564623004057304574009312398001737628716454108647495020234158068532968555553999775303111741459757719295,-20010285328010576660782411280076768166896499197946990703154617553478716059080265771458271142363169788501350927288627071213969266431046021337764/1257334182359830307506655898794727263658277115987887520761209713099221628788656019728814653807724559138063381373665799468065708883390255719065,34519632530687395461925187436749905040946121451574672650907900267734427450506554424917097567025079638402105726241536515960899493743846127132402/22711451942361541131790605428299638982504349928138465227115376149048695973829531785510133154262148714754985588501545851255700762812203440936321,3805027445109359785658291798712257901280169813597612101336692725128592706451295629226763600403309934396735146151731367000145237714343105381073/3084756172932457599110685793235886553200749632988432528838240727841726880058974310099627102351364794079388600939830403136312568788822152931738,543245732454468984913011775551074714954860351218572786849615024948772894637824615288234622601080519716036266713958156168724629806066947224255/368010394809129270619817802850436005204324448379790556411448862976480835572058322731927325630327231988038807199634966888188780267556164936706,160748602596078189196597445194038876041989288745399713157894100334030497576034492732012482747013414768750682481127364770767762796742942927665/11448731627858411494752283131026959227703700555532142569699459008563920801473549447237257957581091054404873904081966353236188364481905818304,924809292460923264139051985233141251989191934207609187465384751340517927062430123880793496851160369852401601262377513607952342947226458911851/189213168258352052040318253477922245146372114639586192236438688922443424864286675314220360885289360404187303364684125046932106934008381758496,27922295286509055513605946995188231208431164722440862333304288689126210007831343822924091412855232448994890752217188348580337621955061121893/9420791858131460068754706136792448414687357279048952307302499550662688292907764014606457298083070985601258853647349053739977878819500556768,170471928141796814680719074640230919955762360167475195399102929430321627654723182495364669827324969245665445626341563197785476206651283237/34568938505965332999424311082704710019963888467230286967750215433542882519647169144847768623564878133806596593240312074102316134398019472,-2487694650987856535189745194384736449431721225366113777661170005452806167007215587449657026039659135841574100734414065870874012879491401125591/1250093810958126053653459845747442279164072256503541448323615664087823630841597755560582443679737455174891238528251292280710846393537007497319,152089845531082972497800596293848003634128731878056063071828766582173074245884242697583727818189383223480830808004355505250247518718779524871/67022095331710518320303066235183309614638305399841517713213401783777845887456040827310674521501063644317117851804158056575721903222807734844,469315379213820015670454877457949769962610991068845041162866116260574609214482462743526052311859598869041595002406261826649517069276328329669/158723117978239630911955914136428808473819561681145536381895695943293184132258237982323827189941421129219075691403959358607072799739124505088,487023584736386550364440302580223725797612289790221745646969752629542880175419399253447329440606847154943047997428789480920523470416525023219/124920491000612369105512864108121880364474860007430375393987390212408871388078410426040962810898205062003324822637980978157675870998720126768,1788999554608797928259114419639778575733839771062747525980980384920318558963474557348202291256627604868920084012573313947299272658034805028213/122529578269625129834220181803491469734255086425173875249131892414273533990919028790618838413487022532092924576039893434917170625886480088076,1534741879590583524367836888298770335121651046474227857487395002488175399221819854899515296402682105500220781088606864119181760563480975036491/13505085340493550400116157605942135494821486451753605401633540761566254406509017396178299936561678340610150337183547190053216190350873961468,63153393396255577887032796743829135804424439305250467267802279982033834694491711224556033674620207018118983923166405125017943529867045814137/33909927006368453354177168968851189838187071892434693347300900584815290857830386412079822246529117487434578265638784217107161713994694458724,-634176562905093636383387762485558401190939564358052991185311380279924238864456564030604795396846412710945756698143038198807592040317032087459/184648705813070097615336217233345881639454955525743518124396482932437075245669238972071718182803167418942589928913326745734569484186166901932,-198933038051824235703943682857477944331076560812926222723335902874844998087350312996645463013306799697923625771098609646441199683744836755463/45106800167150916643844833142322069221573649611777474234669666253843471099954243345118801042071918183002418063428686634270451930664295782744,-781505146845236172056561866757575452619487952827929904728786799196299036222959576481605011497458601548706182521900191039005951715605514098357/92972613186272151757945561151935846832634649823218741799182153764689050444057338634881227300657400624152322873652301474610763643460645155700,-931140878083893018941799929517493828739443574728177386604176054163180318338163449917171977746157021379239437147498734459548385241297652417743/201023527686071294409848435492454626028668571414247837385828081162517105541581728653215472557567362582138967464264803240119130368423605054684,-9810115255903525191779175320872846810299478046559554048872095079254757654258484692616912242703471849825895871667749942600334943495447433345/14173695235458953962258933611842607738237244768421367485262346304518123003490775503538190830487032308033820145938673449415183779664197609556,3874807334540051934230415154732798346536977304058949118233268841350407442098036584620490787933454441310304158487337010248224635520018698218515/278225599936585335163229425236302361747940953170769741921510905201052769098213205396387341432834132790179141404817036462639908152228614959072,3216461019704473038106986406030150706369470328768436488944760930346369411715848498485671095806059628522504240377557842200543643088695310577383/1527790137362288441739339480548125072915549392490956570954386589178298270347213956288401361188518259578739330902856720287907261062999484431264,3786721729460208824996125218047402969394578177140646208191845807929871464816209768561944795168881945964475478899156351634295193738999671206091/2089541611493643897560803714769329594627868930290572767876801985103399447728072871508350852964030201994893913055448329108486717230730817356352,-48660190266204591647444290612434324806233624835925253205382225129683018311455794141246708066371661246814703618231616774175370393742515863619/16241025895814500347140432608593412916326262050489311067973777766881344086174611793955711760502110458895909696004417655476859404491823035340,2305587317394767672455863280352642423803512710946512452051578742441620486061164935424582498560819080920289018808831823844450373703093454928635/1563963719271660027703388604835358840017096463299152280028502244909180257578109446568904621515752874789922769293907704766919680450494599770176,11152138516015265079067119065235003928601898781409062617843534625775440369084093152329339665872874805810408917854627336011876687581076677330917/4676223950557269874009911708900623743527956030976183516602755608807901099417354355063924109912095114182794621452523770457543363440203376625664,4413864359858557975765264701466996287154186737955257493534918720052811061969676763750534158607217271600125940858781357343666279918258728662143/1201196475362188991580846558388438841118032714289791517393243326938978287493556120472579480451475048013861512744121321728271331094259440377008,7780309101311508162818083225179108692265250754666159838174976290585602740801241464524703482751528868276048280580776537716026240978350112420259/781932060924083541293171614578396813319371646691430967125062395713320352615473061269783984929345407298293962923218651504862780180374297760112,9870047889026956041583724246103334408206538911129507119702252896692215762430035953046464048193969736589732903895519731744390827496907356813/153480161728810009458445268409414126184029871208538241600068111765327697645078207705314130386858889177882932610064920179236666696541299669460,486709518504786343921892623000872149761513595245790772125627289786312233750089502496516337242558867950839081580449989625163127814420885575797/358832367301484552471626198558039474746264515079385692421223352553449210555906804611343981328238413957420577301254490929206568805783081074028,17384151375112934027373555341690013285647242425295389197820974868527523020526372535499704273298355076663207180844645908660904432236176086701/14372629553332454036974995980026100448794634777639771022891708189913564064376256174271194757820833776831622323322722110839564807602922358180,814072822526220781787876018306519089109427912830610044397934643155900877773018228093447435130474428366689048445381343120304061385221365663925/80538605725059753696710468359407128381977676853263277160505323169209763144793136124792491732623745251430291791280012985465616224324822801656,7456583575653379787198215973352862612096582386309128043802709272356061173338137366911325420162856094135617796306807022418101486102054859037859/4342620920587885358685253300971580147275313531404271541449826687242973273190018120352687371659233932242233630782542861090294263919071640858304,549896625128445544682304304401986676884678460381402018315372726008289044106620998420150339759872331762999098636786020305508491186978614389743/568739916706823633234696341526503070168195102796524606407513436316469568263642222944385130306325605230886968089758195304931449970524573782012,1414817412758242035882139867851615904386271567064522784723995503677535629575271885940486070215585931214325441016828118608133653614102300570207/24887063601057367585131141903179484450924418693284553062556995527782884738207031773454448898976738768326864497726825901417232373267976675824,11082695254848789677560287656185436705337211449968707025274253501383043237934838841403278589308957143813368557005955308351351103460181608300623/418191965847363167131554072613408764106751190278036981979001956514294388495160116079848544469504556850636746485649816522592537670096513200608,75579922019635217991517777430871795257875741574686633953621350334758984077818509556920976584538758158547919347934312868030744260050729634353/5908877775026791623738887162857988348466938905353770028836800322916002455329579559121912212006210392173090053009109796205824947902687345888,-50457958218374925972367276215472071507898934655693770171316133140153110364975253632003522285754936216511213236955907883265845237300967997806/20296069810577405157172697731732667370720176536738875851364919525376759623817124409599452269421706410896233306353670785468472103217924451075,-194249813526937387741753460835464879419522311370374364638975260515753338079292509037011554144388113402186547677741787372942961326266936011991/49371095893353166287016349010803735887507872654708083930864583217139139762661821303102017098706834705782704860022948641080557853016142357448,-283087718911538464636057526041226624098197921828455654831835307710517131150498775774670013702564081026329578785849573439147290008777298291119/139586236039739092739000194014570372877184941382433463751164900274501083993234206662228401162607838268023935640953277054161966829018941776932,-12776650762970953319027831513306411565865715536109567114347055929259282840619255814175827344073637404420670700934552005686129012193787222019469/452643271767528386756629901791550909160119923255307223267098529901543584971007838248222022993644188972534926497998779940945986489836069156404,-512703708920531207892165704999937299951074728261199370780472107376872910330287365194903718817009813094486044247213517920570003234360024034851/21485787139517427126321567007102400881644295303830174538396958047557511844017047629072313989325945758740641617646970892895326496104069051608,-5094771650052594824698760297226958063086057062284011118996093263973487361027663549132699653183050853179781161391935086134362009093746870929/1713904663317040982476814784931787900872186440230660257307704953875741556039583245857046638106697601508593883056410797102273361407987433291,-324451990915332522829735160081975189566474497855473197391116634422149752061666662781131271979203264792640757788580295658691833206910128678783/126030436115864328922594388605085575741644050616947423139947897902127566741193115060825720185551421746018966371002216513961102717766511607572,-3474752679711203764236569868111415641010296206916557504425063710171929776090992897811439739715369417301863083537089133474259904472031774933905/803254446708555673006580091778980088416002329311535939113585511036051084442279042544564548247770815280095326984844753382854118259312575311556,-40284569064323638653571174634098874924166215063786573257929229876030813945150932418260489671353052830915059729565843861475368167655237628471511/14921974480170688225477713177362037795303984376307815644884873471991005472097025620123373746433054831193118410471477351180077396195211525150620,-7727510010672613485453902523235136020515034358869036269762113845366897004683656966488024160331192197566341929449224668934067516134715237500329/2980452175247454212396729203586134976106524936702775608310597152606230418878239918408930021796682270871337772104727449361578376769004960319668,-7190799912896570644981252225335170387878484022020213365852113360481415171511616446255155876315216855205304741861170049341907690217390061454926/561216593099092631572988554992881769964629715771971622836825031036315607149021831944952564349649370283458089727045263401019441638455056953741,-62049559427534862766214363288947422922291358743577681286304381403500848175059331339257121798244959158465473501960634024535188190505736789819/156081454999529880675553281864954474546952358796802071988943762853421795809891393574882003227227259252663804091051134286750994213723690119,-23748572986495435766963906271781847263449936718418514442536430223291422138273659080367061045806050077719648540688612468176905977814200351418223/7668141462730279335999633433802224016620309038143603277607971915545088101224159408689357345685451970687402534308195716413733771589181687691312,-378152538009138147725562884781264424126424198809807902707920171222129405046836608241684048772880280285274889827323756046337518734504155939468/80183088302054804301475709703667966851094845040781572148010923623581518092153451640543867757512083605553265690345977306182540915044459234613,-1535587839296733136107039577742274197284292358317981925216030507027084084077133053966162086129284538886278668541195888635541674488156974174271/461910195772332079393871126577244048446843577305146719961112345977526045588673915950734280178205016298740783668769597677085190473796007962764,-3556120200769443020384258917494073989165585781349149042774287632048897065937689329680061763894621118523026318974327403518596333851720386186627/1054725606198918773461844261740169149074356954804741043589324623742986766027295730368590491207657602166821572641401774970301297226899727717372,-309836639966509897893168632202070053961069804759684628116417924217895582665112149171239000459486600371273304390353455025083557129118285713509/2721006193305980461708241107156128947326730130841936163444680572641073515710915139015482578042655159534653978909829559371757911102036953652,-625184851978345261850254813667983279611204973976233525186656998185061228023293051522008122842999954449590647957418705949928123867729765289085/74570513037918400648754858018367017307167377966486990072691055240967032833971582137079518381447115929179067113596301401025612372592773438692,-420744415477650932310312573663330499929512127380741475277378502225864669433500269729725131236913527754838816494015068459810087819200314163527/80385663099520590954461173474960404240287398607018318605749719121099290808006882712412318091884313706034843632881357192649367764532992899436,553053581016550458837202463025313818154736723003462595226881755975312611740996731675421466147880407145592866685754338465756468315561249185053/243159631951316801693292689379810081299168294746619069552580665241246719530745858676858610536274585463134104925029457812051490529162305385940,420233218463195894537787361299045511629968410247432961149105939653948614057503688694074371372172522301592788332057733776334276611500706067481/126980617272858985020994415521424585957884171810561869794709578796081970062585071870509926058589503814084446758086557914343787085457599231428,8468062258116804031583924716189528098865594958205536920708172409587657704652068747147980857941172184355644450136748075866422744271547902029861/1036824613926519505639499739794897123028816928773497713044787598799606073723862812046696151373445183045443927431528835991225739801816640343500,36062053845739390970065767732019106980060104246341754215364292439512044193069748198855938892812880696029559685855168875752288072160765710041437/18838315928669604440160832700088413756344321783787797540914527637486214051150183070276587431966843797182575040579853839636333440443209330436140,12589914908491046532987918695438695242890857878736120105764541675079943403086403215322714442488643853393107099839468320857432367319283567351987/5279933947441881491782883928058073807752129611375252905033700118320375626122014902787017291846889649457639054976166890411041021469364038803404,367871871512410359052932175586074729322887604612481341494140490610123610112841286096325301591035831764987229876721604819002705359652305388109/31733800675946336030040661391057749916945975053233839434317537942477312688661687080925578804940485613217358617111916841859269115793183825660,2308994181032354915809986676940567653450603514916531816767728098592639580007239571759483756434738759034259206821589096026287563669815517325187/1225259097096613018117508313326813957111317331043892669022286861042377882090156112785635307600702741011973639778049902732215623837239935324208,13966194181595494476208912525829286771843824757997325377264156939208599817073349097479169997602615426651174144578358164997739657925608591703429/9417591205347484617198517259761235738657428868716048361515159412841290325790699205559974341581189856353471280905919065010416371585590327043040,2659277266050737643507488874130262334996389942300024295713629096132592945733617713461782322168910851525884694128001990319093127448725529282313/87101337523181480480984778737288884409123495309691756592496270701145319178847823966392548259639099028832431448187647514851403825343088004160,210798554596176979952869799246138080092325612855977561908488160190535996662711590749323370745365501576628967498656129807690732945229565481685/95894090885917293263628825609065478895828892525329251853093276201459943959457800017489767410265501842397083186268605748132930187294729364276,4419952017379487022286420366826499051441810098657312526934480099406041473830286047485481579060815099997272983525202475368181414148250091985747/351329504655511048422796033912116497716926604340503888619631136117949300130736271045448435259990249755814846847291034270241727994416632616140,33132970281959442169870375498407560801180817910096182777906659854476664443281223810648659495458308621327181021584676272756099880407505995099/10919081748712364838591786855712463674245409584989828693298596456877777670468972040047338088660735254856508683447969345419531717305437817488,75869455753899733569502871967277318325578075032142632647781635755915160232189143999690587412338774062273987838490159104150565296516380643391/58943814784319096174915612977907523448142492469409190643650423659303796914715008122891981888019534311949201295153328415449729058860431943692,658007025637831503422664286544637441904878152357569030918350791311728273400873141035109564397417362885249130825220520565049091749851387196759/540823752473519438453478029917273915471274183392541152441657311667127614245938305959127919368369267601934090084916342813692225313530569059036,875623650859327229834585207182364827018505105997535432995504755362061004509244619785943090593028123343997056180693496161684206907124713510977/776387979005455178893802817683752823571696692146574791443655777161483564781926326528290346290543848960651710409208232571255317370784656913508,57789440653646454233152701135646259125502150387054751703193132243341090998755252720501418309966014145349126563846847743324628639897712498879/52910252763396317602786058988301605041665881407735146183001453656227801883644641556104713446932936445820971214760896230164456363939545592476,54574991611324684384476596519291592664094485541203298774444944690102933625885611978942523561576644729164240410158283488836140907287882856319/43540747130196634587227609774884026297932345545063578974987397852392194847598846864491294341904957560408521689917737211930023803394977378636,235590629644961809083918165083046882130903437414977694567125327484641201367596593595130388132874691683976733298904043438933693094729040523461/495726102944980371911208758549872119571081993609508078305344766300623752798528366869679190716403229401926013667381358010624025286719098191060,566964474677153915963897571801261052220007562408333938192267360852635079399141497428691281179365099954307628275575032128420709232189432626533/1018038002913344419934419915916774169945165418904970961165875974456297720717220981865873049288559772383290556246459187334113205675425403324596,129265054221251046771765903321444671200202461780583351227784630352069216554403622419829608305461319491940597258085481138472499207097107012177/98109339608760558499025110798171272428819192674927694400201933456808573821437062538485485851335632634535783566625742260306867383447318234868,1466223265680374291818616579940914195682071435923871038710475003262977935821880210244964635237833972527250660661965656448630725854041098349201/1069605649763328235522675431491115717047361876618365151284119022348694636683998448719281796530328111401009850465338060516331594641416020455844,367975704124095658614691224212040658421240435930274004226238392073794715402737618409940421004991474989518165293867533985138057558935410232423/315964781993470226792548874582632366535255269549224045469553945575634407440129156070833319928807955507933069491861346498773242888212737168696,702609048877083204252864998301246214789399707395840037020872615140242716774326887276919107921562732104224845059388082240949106799739943124833/517926557646584883718306159769710602423599046566822038456561629437616888178744207906465358549575915208359937989339568104595264937504724825520,457278731274433245723022559565992032023393225167327061138256347058733207765822425267998486249218701972052285611997330396811605852746086071077/366308931110450057747688954827589115980615960565420060225417042758078700817646437376951037786003321111196244282018605114482778271436630855272,1069023430891029390812105566532702172032694580584991761810604425372020620324648054890497044784862797012924543210055783166371612149306903992071/393024333895953774134801772559724853643366729073008970839708711862727057092001440729004410919177581033814315714949030223708047216057613735776,259598511219718678944556253905897199216127917499436929362086201795962703843768526223340986699148936844162436766640094706133017937311673286573/427814497419674541902664916863350404291715986098198776733005138250667262557524200817172015878340160666151028493520962515551547476375552278431,10973306744315506122094540074318294111759575194055319047956623975611130885790361681102351314481231969819206088540324960823939587271068918417553/7883695704147327060030993100367460724908103019537233521612350632049737878389772001520621068983564970727046281384262797020818483788408081302796,1287493806913302636807419967590057607905425457297895327096807490781262514536493090699803254513435272138206887669761253939755821879380077292109/654287896989608997335437352686141556627882824112920956389030398304001372241862668083919021638162836213226720607644183417116932692204209017820,4870228665028548653303558512900104068804298068642506458896897441750059779803176260864333724175178375742991223037934490311272287147717700005469/1310521158104161060822868102036753614828107065433132704321949396809620969162598369910377342701117860511124846432350552641862549193572095229776,13556772885086649922114078074464720696552211158681658929917224558602422973385755764785639706479677702584194911060338693393982624588805630605529/5879933002968179968514830697689124876968775311773859679575038758177569329126216740928747797851365858281193052155500183389327370298681710315480,1221286647321317939744500055781311097870289744751601186503511438691152825586970207323118076780796680758758144413855883343469436028413234565691/597621091427781861215607384544208485485105514396997933174279748804394410247575120730293915311608164959124973054910709783389786977259190809780,1286575368114968125951575142412274722884999385068749335802453880320357993857765417579920410177129419738677557296979927345994553151021084725113/637780268224200354522323248233418590286716958418522812934129221590136116699469857812930961182159519293574419535305609579958184951516312402312,104017005282922687192409860875851721711319122122883436185771447014551534927189790230243401571541431266972449246788923742234092239529153559313/103332619846406573088659544996402211470023501953769885972995477936009075400177394231060347708540526925515471306669719493266328183743858289574,263458222387080740953459835944870665017048519673803788379983610392939541241631801890970748701333412953589554735201927557981612621973700655697/274762197498483956749950350175103017760109073239419790975198729346108085911379872653392506752428219229846938984659624972574847818386423855522,136331025647862291663787690742341185700294036029430295642788281993922293165971970870535786992464836547869458556933777201529181944006069732951/121505085238454631873985341297990491451946911187596156682888816006050265863639446050893899310632797629683419277593897600774280918082390254956,-471003504038100189233566778486115183136746402618906246616401083893406428549979083356643183976763808359466076282356567093845490325421921238413/94517905848028376838835460629595012898815286611288396288647866693936273546753718442326245791412080668363339055140508864978470538328923380222,-822412719307244041238166928976108769491440533417775152800603477985896051921594106058877072985444133501759954150911491947160158702210864710581/60715396281326252007634874774663150235281657510806328846905684488597612560274804526725601059501598468234690041566587797007898313669892504798,-14023918554205986157498307837151178956055168589280154158501322960997595267004552139644477660249886348466286804815302786235795441333190270725713/5445481685825397210989085940358760303099268259828902548804574350900948386061120845643268147906063399858566328435710731659881640119810850659808,-38144225653344677935368680238925957392693218342373629759078515189531400621728805969859194462493643359859332521941008073616471698908667266890/17157043263895333453817775432814329731470391515422481756740498727810573778341374140683817917321507062418299675125107109173684245869347867411,-550443234150510535904249343524071733396950811317357551225034096367124489617432614777121779225797478292926708486727419309804356777130290339679/481596216356832011097352416063080966867040216371087715631652118231680496600899045705881329619211474997498679599013950431285347546468729155872,-9530404549779718682987050486928469350376319965256926775577698126043665580644730960980871501443497621389409050316963441558005557935595218061373/27295293178287579855319156603680073810373074639869371399289981005110418360639348140738791635461995692866894694495621177861995866466602740176064,-1820475880613350521005119883889194632225021923905290339074608396129012577223385136556881405521104065050637542515143246106036502083850921386109/5018804808742970859614665864014409583625128332746196471785899813660943796668803779878202913349678675556227538693919238555451196101590740905280,-21705161669228074915237179967912263195610355466896217427786972633570309672703106078959193312576754093090838809652454595239706639655183875051991/60080000275412634500189965848739788961689106608301574187919211894440291872164090274322523536586172756139821018648453397341726185756530070433536,-256407392024585024443856219529460977144498748442926269461902659511797573430577467850923491636996358765072222821927778685049383233900311581094/648788569216819935549553400108130032565871135408700363041920178702948535371584102914533729241587703777309686414684898871644523572715743537461,-1264729703740128770657125308492937128298103982916898493528773343160914738094172372909977779977234069663252610910925353206206648726459559837771/314918301420997962535667418046498869332180487947685400887048687065681665479814589803837530203070330573096103213724097479356437726725502843577,-1878480680271041039939290060127742261414168983139731603141716455382564176459967309421962317998536448156031316233128951699942315121694908333811/165194370340443128869706852688968093020656526275675046950531071906032150041090986430611953359588863432508888894108647028422668598472569042664,-3207478446718788228974902851019936784007805820864912714461582154913266743498045969948138398444530403018110437896850369815635769959046109232341/359675590205501724882489980419286727130502277501906227639456925509963181801925036866973238317455385563372974032880710137571638698818714868631,-442368524671189188005906669658448435357355932942772869049138192621783454204526194370352844533292642267199560223166562256379927824458913144313/761707038705531113899692516673662258301252326516243776863546267355540732524158968284037165252430883280283662488991693482244356792734564953536,-825342114699864413170928169089010145047142128316643120701499884244379404757125758077457492191824950029166980280050210773595952500866921066503/1417180525074836290810484991265300813678969091123798419016968916481189673805054076583175988262892656700703710163222177909990931006628493989504,-292896443118049860011572166485283141037227004608175199731199670290521508203467667147491638510251795700229966678678383644030164502723222267133/130899249775157431491937084173939129657256827078449825629724843716693929346159536750598765726234901811672426258334768779409009599376647694824,-100350155065014904980274958603058850338331824890625378567870431175968737472963217714699799225013865524188520075280244331092015267083007380086371/226873830259852906671892853883506101350703299838151627082197527921503387853018060007766565109165370287386632008131775852966761087004929697184448,-797503873894476877146977627881516915145637196363350951988623884083033745921059290508191877419248329804134381182087822411480388164934518244657/742239544357532089490360991714071661479844077576117367969314334580915630267788453142082744733472300344615033936031482749037689863859647403797,-177255054001270227791971899288942798415371360585012193105725774984195618502505531194224066172109441691691901427100550339671891148607965048539/27850562369640039520766229305107178708462180377416085470950445658374803735042158172410553865793759738713269458033385501425880600255266001355,-396061270093346131206913229834380453277608566427755877858834866455282417061329214087482267076238082786210805942499171262278852193689042086251/68410661917405736848462054960894284792881952899908560064280587521383381213146093965478812001926034194748408108794137120055498086721060752002,-9555594868263536344079902532287205602307973120340468593091362485784426719748101238579238718604768109703587079998247920032162618457642421146597/518538550427448053057984802985281626091875845193096763060772777662167852962176545312949875685193393014358160919556754977115291940443088441060,-30372428863521204730760983211511802185967721606532433800750490203328900971113495854976510449476780302169791684521425478202274734414919955229/6777100835486480918550754086352565041661254943397193738403683793532349253327775334597290063386972003016989949915614371258557074489726608210,-34984113645279103368948373936052096015234539672703014465257961834061533690004548658492618223790788338104481250857092940489690978709758882491/10834681898744329126401393048375438770854045545145239173792392616613014849549454006700402302242250110818814319757412454664973691619730259398,-66617104219548719653154353219144046836863998844301238587830768825478463291998659517945296710984679388295739066433988661666984569104221839783/21532615724102409210852349567110384071306364384964436111826361723022395449866494277890792849966659846439582008105356878990708851624623997577,54394873419504901099664914993158481068281884635317365080460334324995722887665305558669223155564282687205785262883507689671801950808747142273558/52859336211494686830971446920125157398754149554816566376892711995469415985733950541017521130074162614495466612016497440600611791940360244421849,10570607608592108766426306320176592379895721954602191374410084874998723135408468500144441023593513886640370117887480114616046537100898906209391/9589463547962711759033782044118648374165941923535640796476656430971557307317416732459745027775236304763327628770263574524600548475689291248652,322997139498474194050895140747448544434755572085869392414203113631776795426917161656575711534414393412601589837327154817319336898768326665418878/322298965222929845130324841529451541294784592831158189492510614852944859749354253494779602053328070317170495763526679089127718745942610397055761,8225045551079253919666951362076932255491023619878757084996886261673759841073300319063081060187330611289569609973776990260866292353343488656633/7862656423587420078963315530031915737659413962168717168833973591007234366609212117360400992238714153957792114033022493039752428818952038951416,127718743128944788954925214700582312506648684692924088230302578230853314724898564463824120480880594058573369543148453604089380946409705510000822/133228514373621738224792916716731154834209700946863416118852813562939796792400494685417787559072303808330844720814397846597366430379005023375993,5378351347817433455121553818408659810551896550041747068684933826863991981112361468267166499612939032454047235565039264334849642545889427325422/7278345203190068789196849460329597131961326230938833559940273226243731316968282487920383219367517803304846780087480774225066605006444378974973,780695095399666159846143789931070839320375969160185518260020285219943903022318738355487870752618427133816965997977983679734725971729930001155/785932731318164322651275410867643699915105907459804602314251856434072146858024150392338831213434572601662192073060300828063334375180496933207,1610174437273040023568092611431390562076557747275486382066744719829269606383566826116497522465901046639590541157963370602061759348462455048320/6233294102505206301394172796139780965144437895805670528368851054906598104439205521775515976508183276512527171397836998889852841023795351140587,138994591352484576384817336506106593880285204409695801198758625749481061620619237398279916759026106401702939872587370019147778509473212683136557/173751296513396151911519377217417074115998114545551883693710692623127964099069631957860658716698915511756555926186728617106612779839159421054804,9060240781619381116716745459105776856986541321080924524708684770147461732399313118081529260968581268590205582492961811154343436710861654548649/2809718248420685784000334590154803310031524310102672352335971049392207010494821188533375911454445052809229507305860646642820043839270297113604,24657912341045412275485364296010987114693113910100495108856064811325551395701685246922563340419195068922270197135432204668833505970116100701733/1464393513059955537360413373514706072787733802270534498150099429546725298686104421601808766147638381655072660990390521988783054852734958269684,26487988728895742023764775323755813428243676384966764008306466439735582333060752097987831563941635191942197586398486991901753923438066382220115/33473549776642096602234157139767294521718377606468492199408667943929520436826461417092569358226861219225109717028293438606580244110493681579852,92023553177936833288845739883903663174106412574241454921674946865271869294109194675511764550012105886742280466189032650370665530225172572206357/95197281469609805814128257975058661859704507530572266226865940755101885861065744825598790178667662054384467410323329228168688978955628201011604,16640293406990133150145234111856655932318352933936750784535038806517484071540339976930400259716118946715600965620467693756691340762131043669641/17172228347548718801321265334603238143213394762908073761350078459273123783420977760150004458325359411393271495537434886300992873684330678246052,24086305395474742179224925943269999069841515185227296846375817554510367124881166005448230553306888496344362074816823644030565372320761360951/23107971536938765965784670536306316021917986712263700810858507528359127483760219931545347933246824651344977245322895659032494487984993018972,7882160315664680346258675594004065106582767385486519523404788134658141578116116783671149841444884984284311529825656977440364090048544294065045/6841175085762676305765688027581809947574597488471566623288824174544611823932652793778519869701295301707634455335810107169903493469867937583756,36428077543839734072413156533226790491091001401116336580564208146763464836547716262789489573494756043296786797464730038933044503936555645477455/30204020309938436197888370987082833213806702122840160421105564114925310503255871130550338601753318831849831818762628592636810617115388669409012,56368269395254212015598086481264048912257527561031920112380361759010558845641237116711136791501882029136815760932852122812408037357526863948455/151976726046489631166796915322834785335991819409311922431179183274021217531414776896395871941237005819728344427503107623662950840646139161280142,-1497689280168821373365756043287498137681343449939253851389578562550891598737459289429615580346163094255096242684418252156591716687127517770782/96938065962162996550969503125462017585634132378390791680219112024354973203992917044748710853465445260854470090254782711675125945563366284616673,-210145489519599300313429734126832895616651530355002287416553961346276977702733229724071833675435511873683319981922144261542015682271824688338038/3143231779135632266363188215310436207704510383989861561521061322605312097601139316869344966104320223064153076972273238489223268889873787697569935,4876002780450380306801045111382600767811754797711553243996539868070872594636308163612405460476279853006234577297094891717937286131401594751131/3006237704335140318512683355433909874635678413266100612344188295632247425308219817753344180601213996922345684855290830756807714426374699983888,4115355053683402470649293335983424367721610176938379012397148279016391969111651656670309946025801508792408633460591510346794583575885273603547/2856660103299695344169575046075681968667252293969486665507946023642726982136934562062077360808435382176078208310614086939923088074582724574848,70336854762113531170198225387178253565964456447258530122253958288503986500989561168062671937413313510094788109115436743995777810274688551133585/47639456150049722093833374509458658383512259963781594151435321541799798862431101490252727297888121822045697403605268304498663531536826872131584,15939067756836240786217780302569578257181873000418052439463098476423310707409048850124157632749694999169120985181225590980628508703333511479125/13888471412793538591578520099375850126082408980935929511764299958210755154144706079259678255117076292339680866455157697216489159586382499460528,69049868153873294538903384736908754680487399495644659386916799160965959714456659368952790039202803667733444140833143542437999978768126601899403/55293038702106116048352099664251988330803864887664485658749678466331080294948921771414311853844559892160252602213110065021301838027030881352656,-162868898789362767585937071668535433729345619891586925682180318237237711350233387433978796224838023755619528472350979284811571266524243066421525/361630894023735984799511572261806450623361421260585214556176777122812179055417916124242286568847777801911128944350147018381059694885416138961108,23669191844972055667488501154141726336946438586942076247748701118829169213523235325560078092053158295319091449511706913634829547336683270210467/20069037286965505266734295163865524096044440944042272133006255382740349477126303041111508949307791414642004071386016275622922065752733635367980,20292888805473285496559038873747664276871844776602021335668820819845596793267506773080926106514500586449290806573861962161080052896920403675543/6766393440184862130814123276561444037244298560653236595224505133603250795462422201872832868901297806853433592699960817352245066829959946768384,351335541150234845670038098628492710065105235415962612595457044085802980504054112020174372201520784913818152107133609913332529657588173334600/199928462687911630950395667413418188066270243630853023694025410418747972234643538012634062418428997201956272934440431990909622757359943045127,118974452149666564555091863616799940511700227210257282031198748800249608503597991899131073923874816571227280646143963888525998735708406047736/77659510244364128310289449635024617513079565308565338889983189287357515576061066660360197585924340348441349107819561252981659207149557964821,3111041875546811585123516805564467192761884178481624532817710345788350170310819135292308377706650624858005574271391007437926241170698386309207/1685921916494971236418187849658406115986991529942907784845137272303016986524883430943821890104128736658142441028868396356139588086146836461052,-5478863323564724101066768293383170369418139955527228729013301560715340296806012729425778602358596285931307604306636198353746987882383995062137/2241173893791944450697956721673896499027689457924548549460343256318527260407105167736782301196887070158259947114171319534306416910720692422308,-5176071201818584320609739964704470735056348582251565128222525011689627958970784865857736421228326688321810289154902120684138340272133686880227/2619478815987796474173269973649492784929704131869152398305769433241267081748492635044532356716692969131418836584549341242313632609597588365516,-534874664592584361171783874513719647240235912359320246156414021746999659419037984923698148229449692645612193573142891995757260020332104099046/816564035738524671184526399223271224988174640490798504609001496077102966691792641424758719097370137885079599835030849371328070886913872606009,-545822323247713357518454921856404868434288347201359598985674800094958030509100707968495400233890143832444566606581802972467928362328135703266/776973494290299742931703634854186322008582826220916696746277338764369088887931279320971332391086532597966489703585853158921831454729711057963,-240442824057135555316197458636033843736184983574744387722096235657531437568185319065156851499168419343396534614234597968971544024468220201835/303128755020515569024961842581244802197855800996868073165490598926982450903615166334714134404892340838292017245680928864325009237208608009748,-430607641911455952799397303284132328075655441909367007638525590705347920079159347098513290132938632468128610850177343697911660902141850521013/603654646767012978355841500760423801702004493689019002052441790749088640666393828441864260251626467029671631833873632260614622489979304996806,-163204406339019794572831976859650864194607285124707986226941340437903320846303952821060077032287980967446276251565186824500567238600240742970/229031971962298852995202316006275093698441732906421291180203140572440681679268244327439029177390569822212793186965860964451743134922259541781,-206347650097297348960596874442144459901978025053388110589119869941863259848429000092198074267155450683698609641298095214047889642186412704399/121704111108330143263622117135329075904510183644200360136182404534602209055411616660565953194010175790969455096344526986651667333808929320028,-1818146071483272202192279685924471787919742457635303679280706800964476618533336174760444859085947492018999310302945262972981981644417031436453/2216174955217445604702423248174345236432440099570501542125902327172478777611660244866597882330193986237584511179163022716664825231756080451572,-24468341459899240767205205942343572239062730302663034869510897102379313273816998558157522528898411981649016909700152000279097384685441702632605/19689195415022379815664645464286538033789161969794078832251745593887373733337028064312181057463422732261099837620930528531820979689590198012788,-9833144917509425182003409088685183839280611563069878697368630916654256059306097470523508071913828776990948092743560335440889559115314560066419/7372535209599977215601845544477084517370759427731280731992440475149932697288744671873314596211346306883262055502956759701893840722410978943596,-102654784398820197066026025659525356015591617409065579364993393838495261408259221032089409141391585720567364602788575568919620351181910737493/91936063764444647663291589741521447228716730666825212137949122146004249592349133293142028113596735039713528037237869052628188193139673926252,-8145799299449528568507715980196275603758338617803423649057838070771415566249958405738978043418165176330824358802229849203184773496983593400857/12761382153126413292692562112296270870081130990461565223796269144259989054941605843577270268437004777119646634781192515587651858471157682640944,-1870935123634783403524845723217244300287172670765793976054932435408555550701510770796019972181609105647300024237043810558147440065114411115203/628062865164421988610702966059431117906426616689022033509065760039209751040663499036582370346801478493810049368532027247945019981378507095564,-5321789532328620255924378554362285582551902439372821231178910837334858599015023064415225853630047040848374897227771943643008847073735148554061/9445960973966211872100816707258763195807196808898080313067306167086114069445547721816622646797710524604203300295346868903189805291615576204359,-13975096312731094852730552135447171445029067032742259827002589957236072822455673435503436754161190452553099922945159321684122935154382897773/24487393981465236111423910743818976737584992725787418361811237916400730182920435615845965277121707385779777384775482847074961279096563880708,-90213857896215612340883637697075286957724531714316394599298962237693708389512054801566052243426776197018216211475293451632274308593065912739/129219812522231203379880763857773398119837759297466570554999337019475023364867865613782206370946363838588262891773194415930006592930863286481,-3321942622533143058372935737376536968413062927474314833995221268884165589916405747219861053167225496200980985664410487623363149091299828998238/667987715025088965383070627860424715859438577382066923511951807872137972338758908064427488625486650354740896204919293509012831960956521774895,-10243420776311332178354994104594071211895376462960907260295402320631217381887887016509719103578415327806375580517445405792691077522084369511220/5220161908399906327705892812037224798804584204547470984924330108601972189611906872028863961222616009563016954576086958030960753700368238848239,-4529879368811701858032253876846386242712457609746866855365467689593163173512531210777974644869180353480275106472457855183353003357723910437932/1929806546986045334096120506069833793614238094654769891995110191818930566593378136191889708104170177610942786788355104612762108315920485127981,-103492299136006882790934238190591221470044368125796309465715314923977808036797904737976789514243476667614135236480087635852085007732836403023/43736526617000213217135366793002244604621776112277414050258959630046222410756086841010579725226692685429498141796141407428263421793436972052,-109922592552412123977748622186610986228855315123540680951308788703037613087558203531979186304587274599916003249997072500925864701410235120754/68400993462952804431553552776968436885175838631539277990873501762457416748268824110361501239442895977686724263344438495972015752561154719107,-144889605585317646151398667461744834919134454190508868803403061733133009056557410465343393800605802825009567550994673073815715532457553590195/89289677985718789440498334130035562911254168286656065166898656287569527812572335903316135707179177365748279607059982765667927115060095168749,-4758816111713759677767984142590714900935075743238968415123212547874032982991099628207964038859229157796846116506418707297963472196187588527417/2371870252907466449489488052211611615319535850495187323744194768577259451976287022829831725159967850132043206757033292388630680641046374714452,-2228113411904030383917445252722099809308007075237810180586833643742518672327774254819170962772995760630731333685104651909587160630456042645911/1642527888451131096001773525199662775960803716360207749351241405404263230163419424185029469162435428117656791118984311224711079246407170276384,-1277290778721449374582808389230636292764605521508021350163388482620157779258662621710000928828181725133423950528043846007125519513253443036499/1032476511460897565466490580873783440503252735041330953823733188294608987734979256534993782217496477957134367505921722862099768940477206078861,-26470040979328267973272323315465231812193554071757849052374239036013121068262921372516140774447003567895826317136343672686413896671134305376537/11155012311270229243685332800433377778656585957902913459630614562535483914030479062875899445855738195952891643493594037616639468538627440598836,-3055685917104165250876474492293177986360487464419742109945136009135713922111290081503459675386281829800494983867446055392025908636359219573291/1560790499012612533106898569245990777276010036671786285349498583172566012894568914228497782559426149778557334822934470539727801519507947242748,-320495128690501643188949898423718320616559112436094085953722246788214433228816567062023555388021779359963120380747277478081173010618026458292/106176339406316823323185807353114203298981960448028341932508351565383358838052399379531704174794601698821183414074423801986518577346621645649,-1633816629397317067321835538870379468857086866135974916218843630935811564558438226415956238402190440167872718071066082192794189530166670746523/1059959624815946235735648470343620017022720200066768606201469593735891438421902958440042277348889325084659632018857301906887269118730236393692,-1719061589121757479524662274566976972238573401404738355006828777212400588195368993556666207128425093125613670366125540950927386870064309124205/1069541921564013502549708573577091542284780105434308313568953527349375458857565620095624848119362422175011741073317385645001054401766564278696,-48194226792172838991739151505151044210141136591890888347195150009361019194198655599369141761923505629334114624764490275508430601527643298188197/16422626520168025666783228657032353092879808688256567541659301867060376803363868059556298126396695624679740926253454733567633113691246075690212,-9314002910664062248075129867728553339119546997299023846639534007587570868541172274529696510997378302440588252012631655680571686025438935499273/4980854131896584882872511704108314025553860108045849692478264137680714582336503615878006273653131075842455322599324433472066886655341448686808,-128427867468208588830524281643534296489420807083487669326319784757771185513290694873465628414982673469989220844613306452485731549237370947912380/55621907840631011782228262932707117296574683389561601145374184353821310249192070401984100025818247880286325880651470532835966112435468214422021,-21971354497510547913825618528107968185857851165863482241791812353919572764753601904848181280487148621063668072040712547363659132584203346727/11552826412173442243823110178796571147351678973366905175896184684797643792288713691024045669866335032268674119423302933230925625898464764732,-10337300305818650784081427854159003646513574863220483087334865147102185736137310034157158560717710919541291329615625835516546063273661834940020/5118853962979511230116088639396002563000568961145450474173582239954448875720016890883396935492363942633269663276948158052327490122002215304947,-339371701643444674027607610148366548419053393057901789482472453576523918479530602419223835075996968405316284630554090949598384846172282063601/241831726800429161272540792142549790302241428295207934339660967698492867382691945505086919471001500277173545217366587390088732927891035266506,-802559835197376959254778049341332146521380675230483228860136480812311922308944833209956932890501222210581113340887710369360211709089323769866/608653183431181881699016838202827441965915849060405986071144442853116217908828174552637813421655357254357595040221306104706703972948405650169,-268424869254825449666747470453575135163597972077705370111825400242043557347268236355569175625754891406886411239142849110697324631953702624713/208704240570736396201289670367413939132971975747620410685309469923671274911163406979057637819031549443706368645126298972703620210996662211104,-2427488654934201722753924688900606521174284561319759788773923641980865714368816642903205935645552681393240461950809138736807546403420904113683/1247548727256549477566498932962442147262822235058050655716716017534714662167407357311826652204269325774005548589370204669696310020494200056146,-3890127809434110290586923683973280885514879932140222396032532270525414167588244087504750547387367732634203459090668580401885206420167431235919/3228896732932891394980874576884562656111096670318023276690208087276825809963286968327245615768200963893810993192180883816693703585697554348163,-3201782350473469897643141055355956159628896778181834027357718373890809929745704915282999059970478584420132773430169530357945678123662384008207/2462691019082084175664334386290794286357820719822218240133444913121709260287815623247221282842921878496304612664470833129583969884561989388587,-1382247344519037740586639914122932994141073300729181904713833582338010307562585400699733077192664957587122962329367786882745891502867448842683/2069966416292464442341163607088054729339622547275410490532712466777452201311844179533600302167949976056166369880501200200283900000826123629346,-396934454233306640844666605743388748350800051168327933031437233764954992952193265997586342635628731875149656914783486138944865420848899583460/300111979092398999111429068951986759395840800792189084750866791513753363385303191254877314943339012512322798070762591509711227696341969811837,-121072465383178854000358652852615605809890084188594505532661078770232940738185954392939832531786134010252243989348612097165305401585253324177/82812326702712045526482021284611355433675204112848564402355922256592421192126111880746404544142360472320178453520906361739687903208800708394,-257152120804075932890116772612221244958341882648147626922050367116932058636070727346878746143236191696134882885157045930566852839533402133573/189096544079017837568623109706241491857209409587926577198912972494990917361445354113693505607883898691917336349073224742856157745241068177790,-5203761605905047954216563220757194758256971278479941193579181951298220085032154816851787786577379847969107569452621728393156409253401901987047/8467476279112485510677256581626516150591430254582810814890599939433617204168561118586783379348320654899487967510441779549816084840130480470920,11429017165881369132318211965312572085982883165811794934579913018048663236732973053115708688417215228847291270795780426226865110738538726767389/6537536662926830842377968803517319942779694801394864590120080469166173226232937459938501553453736146317494874677355890784449956862153991756576,3023808750669283010920533396646628505866201180421672608994480164951190100470471712171472122659603570846066344916078372859882392994334502751793/2083802832432959950299054243860159407830849996363504890071940309271753864973655839367863385239333026673988260967235249579420981064834987079936,10340931043479943880131990007637984377340624424653639477704948363373283248182699977881021687622063414794729227348076373634807223227626489206271/9449429115972662404504582762566367802394590532374639296357352009174402077754280138179535086911077930906295027910720494142268617449541727910848,3015300661581235852159813448261384320634809986819995124840144798781286500860697560135249394900401333192925956300264896865988505867502045339247/2747068938767501438593122229743668505144829078125955102228109365441372930243390896466231695839414510959856945673921713802835750054975296068064,31873433250808990467479676794960803587498951148126871061587740261629228609667926533455208353690660476170021226740442525055638447564574330953/33224536306969338282470777141976182556422250970969895122424753382425476898841870797134197466232311589433464814203178052593203915382428352940,177105822401833985959025888097984958541944340595610783669339054172218515247123353818667374373942530315446211495931541371663695684295030750331/165426755745030357051913929220664156495738957408019973062955895976814018356404342658117274122283211440400000546796800139212939447223065745610,187416512885240378069674508812647990038628738442803731826190224718703494467355341415530237526498156362198125135593594900833429023713520108553/193368039602748836954185059970298081265426215459944170483043734001020187145071805788003975806433208231781354451633418431298482354554288133970,932357690686507307104061110989553713114081471493203999017995255834563422437437423489911504412676149927628647611232651974170836680644108634433/999042645455085705181533285684312865749568375028875953341907745697979968175417054291140735916968299353607572778251261738744753151775844204124,482181135713291648130420840718412723681863463479001470186763787884821979417604588480735861600193325510540444501330199739609086360858607553361/3930256267600257073967384424686565660863772082786900919902569805155772439578639710634054322168701495585943395006856376426241710803076488720260,57818631534968887972177533089477536033019293147962340991694748496562344447641656299842654876502433554774118993780474613587231192907827736913/291439400500916685276345460152623260234935140184587626354335346501771288452233494147551514723515053679090052534844749918559242091453390592634,-16041008576369513249171870500108862248966726307754286845740482969699326107788525783531597240182692198066844352949672458722307265270141277417/663141078698311162439771341075569658709186271512157051619522464409980994642549825636635179922499363184823365444984252530145678803015372587572,177578427711393221842263141654077642822169249617003691214332816163367607720060976109440321627606225987543176574043885166695145416362182875817454/155473355972301760823245322096420369673739783116948185381602480851836737491811913569671828481438903703581408729270565354173437886333164845279361,4855914132049784144699498827994810553447422729133642653791516736729635161301327140935163290974178402259208313709054494175718744753846376086439/3584355053315890794047194672151058987141166032227379124090543903958702288088087900606844960799953249584227208626043757743286788209166180032999,3629574945195309358687124649554534955331813510715352517633350193386473271166736204285832622374960197848223013452073913317881718236884314285799/6890538608718364899547268351074263089405103989377897630660562131875042310087554136376905296461032074508946736987206684308456164036237603222036,1782882205553307785677697426782043551921235458683177669192356343378129737013458052019355037104646479253386766496406418820678622681953504942334/1260028526712978934363916879466867878041270834243014068509462243019826553408046317333581016147503148720266095528621651033996573176021325056415,139911128898991866377754191259845343023197694143365443089285239912857783491244262416139733338076097423188419904300567037183189634546626997001/563205443073766122531902264392047603747107198608379708496505650864219645145496571135208672353662806623060945535657204953796151301266999660825,2696602434377938089570790401561448246069087654739838874521309775416834137304974660781215144214782036420073503961863821106866919422046379871785/10927251550809735992056108465566026224577161544106156524883360956894143453778943622256286157417669149866043280199767017015174700016866134060988,-22035052131225484361383326721250930170008213959695601178119795768427094113200614875611179306259167885027619781800187567342396074578785680269442/38891978774530983002801811386174860153602662599553994422717489821296238883511844399002939173198216904345580959120174611242142217182312786417447,-6143046976129698622512838380578152065697409242034913229496294505559471280959559045727051515984346836012300977883265264714369545923294637298725/9386180765480070225262748999734323283726594597772459046517671817043322938831924846834259415668604258167149140858866584594730230307439899023884,-4278153601509852331088092328066528577053888276647470259628770276189735363881062763368882580492522424932551937213174351950795852472109657677414/8201565383116588618634128438781291057455094273871236390295092375846275552881700924474146499541526050550556964042727921689232838224451552056193,-232984401699300035699251869329819884972514973922121126246968132337188037202148962175270052909789869074989125530753385864094562784124581068746/328286227085159774388220287867685423037156916807442732758132044558567451467381411728201858003116053950114677710123903989132370067613979322959,-33710150436185492383544446436193997324834648511344782889445704956142659778845603568928317781924284070997612828835711407572860676422174637269033/39841054165582326215714008878978511579591254430888200618750757718780539463847363082659815073671035225820615422830573492738621161492120550426738,-6807325666714712305498446893073027162356361160449483249170614150091987597351993292176265052787113263787780145710337967728005872178470912428686/11717557032452428445219008907945508742598963922589863793748020305075464783877171187129695424310492152430395964470018744787205431320782591858197,-1112645685487092664985761352001888595888570707680273146997188780734448168514058352952328981068343300752692044519685901938389784327578294302927/546367261165376383684245597501105948831533295796221923679247242665238411665596350806307526240314005938934845905435859893793932338287377940104,-1488291775434497665152820425415287833926951838763094015286582295648214412820779573435371870160063385128255608425434028013913430738884045811453/33212579606432626186254021751214194948336814652057932040472406140033962349941185900559830611486146026438858062140814616012157654165396077510612,-621447308938264349884626424683682545405618844379953092130236516771913736972518029988366109048595116165334026495300268296485754697144213778825/4418399796899435422353658727438862816367012448263070248642239118372989126696610070594014548703688806333820566593046463622299239341820818932872,1842190329305858806812111843742801416846434547836216190894035739945343429015778229155400341767878963923704737363916529697235032196423544779609/4592068031245546071855527005002531348935760985293178056334805730786412113871212053323153974934812313704703440712298099251857469401240186037358,118524193539799576129620105549285823106417913180934760104477241508815422551748999261227294467894640203984381828233238193880929576471156931253/132196451155745549211736299923682342917172178474788850905924441064480480864983313891574234335000317639640731366423727179195906403620206029684,70710825133446849910239535817721510419691408216355740866949873854981951613300180189112541094734986523351192910053499024286878223186849295327741/153977880079233297466666806319795150630859324147885039660237254937567432585636770916650061873830403223795541312537900299003333585286591143918624,198583549864046913098141732301069796919662514128055084481411314090679932765605081667460802220582152472634184916166695533492990577570591203525915/255061847744233652637707128323854622365026607596293368535493425956907996668943911139025963993547222133390198870573828979295139659510778115317856,155724212812741148201024072772883142947025006335969123147355023332327558264122594539110856374544305915841147310993168675142743891660790539027027/387940222075075348120423297334077544640331325374879771865261249050490639959785383385233314175993500320382746956198003030599333479737235189997778,-205055072757327155776931907389791696628309283711748358286417041289807737267940774625573382519229357475795860891608743539046502618193562453673558/447255066828503425617069358634425762552625228871298416855151876948824950234927570578440314039566328698812926942921948260222447885532859388991739,642794191437582885646340607616143258301461946503939755418607216477663656337262823800857658582817553466813477919030894885885446580734410329009766/2381438764278606404471453374556916112226345785904671917821312777785120545837597822014927634385300220059621392102493595413630079406052432358414175,11088976251053227432317153935989970671991426734209405371392127058421429308564969901286118542729974491966231961832409801980425492618319771109892/118258907454198946035208099629053477677499272928266173735123362719834132255207450722711716594606115797894664908050577143445501266148350825986733,-15279509311327300374947002117397742501149956722629297645980463895522109424242392534180098255062653500231207512666024887390817797287674979304119/67942049918832676925641946370886629371946755802165559290233827315718731618302603395767093826018192162749799633740572012901178230777287413917946,150900398482535219580324400679162077559567019012449392724754189095241132229094784983609878428200830263648426487396353253743354849046123891800808/528832125706598950407194119620906268620737840215251833794621641909766063454989118772370594677906770207749297670318240565628896660299075412163601,6023717810947120373514602540114398834324986478372413966784267169484930212416302851417770199550958081394127475811760580866100412332654861293402/21205692467514900852963650884244064065390683924700578049432355380801683922803661764415074317626056841597275605792438341834745571263877056653845,2894132770869050349729664300186236168419193558275642311512981643762233044787444259182864048689974045490342380049486560485421966820702821192521/14432930688853932773274839657607393644487431113098553297321743895780214680367447623967854963846081134063483370548334133384768838349372421947760,303367733504266362746257220322533838726408680542203771283563880192611540129038288890555614354835997869134879361757772732121111649382729939122868/1062656695936341702673896911318816459259598516216619098675259376048538109217273249452166134872678523474328071821780906390008173369441984491029241,5327601842591028091900114602869543672196237185083241388957159580019928192541342635163767771949103134789643456821156908176013762181574009141293/20479733698012733366423809719688557735333491023298683024647212517428851936453448430865116396801881456617626071212159683970960256485855301052538,-55624677972543261445740163785637252426331496254342675663614878813788653083780466889361720625934399705179341429512552570091474616091119778745424/229910961375688283788593621906344306190983999226125278116317074323358180693574258482117750377844230725235399180626928435807028671008383952137005,-35110787169859259043651840628992961950761812784374776163954235369525840661988508829538220055327622396261355834880655987879726025921901802908436/150210298062783744746389779400662485629337570377972014819405458160891489347284451579858101691473353822227257083969790031777330883920638802920503,-1416361011281701975754934440611421412518704175103965722278967771256602255248666732017853380735484327392493010646983451068971061964307743634073/6801322499825926831463836182266452558818066248963736218487707232071720325279615257058442576427647423592098148765047367734767427806148474431121,-3404262967961178093576722380019232458848090271593036710126942519878482822359243992693937574416688582464572786204435102814444773379008179408306/11270999357187406215407620178750425733100305804920045507295108068336498379075715869309959067100442456852192686144940731438233352370377697318381,-205205363291575433438725382631556185890518614402161201589663199467569500407031310023607241827363127129829026486057645066009071554243526642621/617008210706475258329528262185658999154592140498833098638932273831113403174457491644842666252386449352050762782402357369945051582263825693980,-71465275962322944152145351393558170552193051950200518153664756360398846886294428202567846331031435568417288969646108007245973831733114978363/978861915477995010538529654102385114454758814599978231855481579339869975002884222083471622897214395044256347735840329932196616104926960312192,-6757812591704048405720217849937553079114313158452519267941090749193826057756220368098381512595184913970118129808114756032507048945675413259/99029888066168402867539225843142892946420690770878789755617880024140687519232123751850508184108696087761921693464000384125424955979891288261,-20967029324912052014001078185943349105824586582153050140584536012438081194406454959417622240683535504095534690973488172134240249723500834097/331571599448268065488088660019798325634804947902026497633820063146135416793304696526277563565740063146578471051270924204208287442780499137204,-199527099359816529129512630652446878180100474923212745970756801028181674107355476000636331467507931450030013987571686330439802105998169176451/742712742461537718210901701563841426890716675248283990798525867607092800549114638299964425636111895900954061915313503075336435858452719348037,-1255589088963554765296274467523145415270609863078833199320097722786544433158936175145496059775645842758450953114790995860984818522320074599757/4360110342147155416066525419532690100039432132443458821508208922502098090915657767847419023949917559651252044775075474731635708420984787101167,-5857294175415804484491015192979740654110311079856156585770571884304796569362731073816239251560271865393356642909073232199172962193044363415775/11292348080041017080289500202100999873522452089028734359126682666210493132542633253948476540332720790874157438415827632482176965461312134815101,-3272865254871612306642710124393310772035114068690136678743469780787435945235171470140429353907590804893359037468132136321170329680372030720761/27119514293674520370136160658510127618938814684276316715373327042807587284008701332743297560646200562903264268075794528983039177258536768701279,-88622120107089549316572901122360032799760871621573939225345073142812948008250603789949224571238801467774862765930027989503922409755521514459/407794612833310221297422070042039142202023444903174221091611134414643739887547101351092698230884403379974290207037856910822617020454179739586,-91725985660357323771432759835570149142634472274966552855668319570097109076391625205548926625929325721530197781781963168271607129608728119873/407868219477745149690540258341155944281751521210367133082758206724930554439560443707584937854598377079892846615846517136022095280614580775031,-1627992105241463421762539002983222596625361132566566084125604266073601482906667520711074597934417020500754312088200572039128960643385785498477/11010884508094970821104347306848851315763752394805267707577685960655247313340489529944662429776190610242740907643542859895538938082288633294747,-763735807827440626339566719946305869394585266797655776223786083810917778567068663169207098244527313182560145346675982207214940257550632606781/13401895068598159019266386612208786919560770977028290387512698966821360903116863126571004343956532101182003956202838277181573798606044234974644,-8957829783402235698571924067992656536090879220808209842388717068623432636327085815066258295554926606451920402831749419662924396867872694121/44359100544910207212606279699526032012545240486082222691366995811696603095263114607101739351263554557345828466676501749659130993767497928614,-627341764795456982318407305526023897478571403572596758556291638505831343669907069069518860062262481803585783934963239978909460377222620436743/2731040454791790873886282415958452137693544818649000752380952525082000214109127270117030806836329367872665019456010234156648254919864054519032,-185763923870334428466996805338188861517540613246445325646834475549757673647243109601611209477905612394628725325813026316696329608770341624073/1600198852237743448590892240952702347243855940231049886681020348948876400286102999250688278913137438964912666564714687084443165898027808410527,-1284690463554995456830688828539932279065563085756222056906076810512856200080098566365413317767179850486889811061177280082193979293465409938189/26158582156825723675423085970606059583092950019161126135012244078761704320868685225777008207416158018999173913132930280117185101880722782067883,-71423795326651227607054536035749669546742207085464463424567968606718327959986166287116651530617886855150122501323710969871075987957919391357/561051317878748417714859912756940455320332171809578221572612680491472062008725996208711220513669845301059807825564863816642067180187373168731,-3280321448710583614946769229606639590333055609188869337442802314003601025686920556285704528115726274716728946386313347633185627759669210587/40389183776206483368166308651323705551287936311311534598188425919901180853455613748386715328424077214305294635630818260736760127866711707213,250315404111345780335603657636766531944768483582575710834373953713194810071939690619621336578053094876503674355758454695881465682583244421161/551489864360102050314786473695617319868499545499861150880666066842202322001465078233117961223345275950664412812533031126748371901605499118168,-72467880058719764990998602549153561226812604790466943044534106005829082877126874159009495256914748820163914267099194219803570924880801372002/316234907129675116023557163272933779835606291709805971114498863991560871067864218336045659444246028715721193235442676847780373018277253899357,-14271003401790890938708591087074687174013517119871132531573580134279962744545454666122543400911695703134451582227730172043472313923007194911/67341566594865683935669300765425572516077108169599281599858755488471800896266823755301833163403442012049396035586322425039176230923193679027,-8204346890283448907021136250286293941620800637165364890902012688312188474376374938894796509706402058084516137177373034928252181400676733477/40590793594302910511057934852789850175674908601154776685335927999912068010262906413119268392574486054137982937969072266318422137026605323107,-4041076101745033858408147409619396380589039424535382699683317686046006420466386965046000158854025540155115616366404004481151615325947893979/32255981726642136530368538886701693123771344984896268048633985251414069021018357349743992512414653905367354905609263309654386645770057352652,-30806489250407608890105669063394464104238050381247093139762264004743545599228595343220962895578348377867986155814996597004616698637885247521/469789731486219575322744962683788330966228587591110419968176143566074999731614483286433520432512621663210986794658057284908455956541972061648,57533509200533256704192455052500726029339277264444108134110614925663873947831045066759128142286030278238083644441155310491466183890048664557/222539746212013258200180394536044736931870966729892401897155094180775579563402794207873087951842504338971269694895849870670544089804149773772,1930855343926865332690640067078562804587633394044970741995948684694930823078792709866267246418242807206680490149390626126125894137495198397/18508197266011813258856382112760204892199278003873547986674093782086720238546043110279654860339608406238994912960949132456756650150280619752,105107179743935045961690872518789082863056920666745977625367868205221454139212668158000539391014177250425249634968709147003168580039683069/1026638583041384001824572587450704699873126698530274691797474097446228534910933538062957948359134465194709533855959087003970718357918887789336,12704609298235076988602088109353882874166456473385282399535885454139843073375225910144563553427197807429673795127741468641479743029990774763/41452554033043791034269044391350494784392411650211840683402113266507853908192932091680438353065828248760252171632850684377146646971156732878,66818212115241806544401144539515582810268762202146850717555076943602392285450213104891917561108793764516319552078768763215321919016132577283/401288194355568059475262472212132385102080065891739037576607967077865780488532868141837685487620963223725231997996560395205880704303030809064,-163587806679773450924232635164979743972139928430942756949345720574770971114653467514681143050859815436696175874236656843885387485594201767407/375688070341432968917822110970869564161959242399476318788511568146688112503023650043271161756411425545645788804855912191888189341025911299128,240794751474426037886966754538833031857909226408058209629399271333107132957312590543658070404237296670874911612342582749532849313342321778922/65819526768905153446825781025174501640009358282688365906316315476669332207887774180130387006543183986904164391687322074040406335558753745549895,2091201512223034835360417923105459339730595178094222784016124581917895253460765571904727835805163094152803632246700205884858437915865263044815/16987100652662255004473502139261564449212696524367079633162685414006305478070946948859781626925612560758500223977629407338518098115612668862438,-46821201844154884716580327244183953762034112175012577496563584156053881078352498712993466300432164573484206560907382453772679496525440078665317/70999153533211170103619742755776485554921840418047190951715638833140524065103211913205199479805284369110506558341217229308262441057843340022644,-123864711976535490379271531661008741296676074721866239860840251558409468106547680642602619065492435022947474442055333664161064465724783023649110/280744616506621812856360160154650071462725812015727861918364152292745403480397251074448899616767116521719769940429279325519422448396684877261839,-1250784849083334059680005436613966843673358842018441447686089647124606109168457905642453260543796075981206972872661706781510626346069144850235414/2613814347670171864479760937092643776112101013983895042244019623520927401189352062276913696060910079626947887551872385231479973261005936358320765,-594394214248101023695244890813199312056166397021018202281785420746102823217213386195222598743046759931016460443607428905553290127646987795210145/514479413602150575230080025283418999853011415629391577081804843566190836807997566212500309571102805892404194207587174592906697831041499542528582,-36358733109183664872012790329368479450180959703321961651149279264140546584298387856232189950124023627068813671528902285726480285635822571526200/71700713458867333633978799359984868807909008771093773268564059795952199468185193632436005907502926718059628650500148398553476619390865224747721,-10493555330371740962846492961348089518513770821287935291126309191156266221668555573463667173313151471753308298709980478581779820827927492192549/8123165479265867958900654156657957130870103166821392111253087502408070920170861328328403083308646695686077583034191795021557127826491597095111,-333212371325847114057439263105035857217589838413100088635441040943884927068993490732218482264193499046813982125827729923449084710675126719209/217782825428086488984865118761795696183089437504895589896570627722444742173557887852723148587723262401179571111397532808041625636838297344263,-18541581965924963819376998319242576444515834587153156259138863413932905779890612754252629378825490077045906516083425886045018923057257425176432/11374813442529308093554650706646823696460375087665743223096035317151269983361193085844043483297491734863248329331646661247261836538155793499049,-164626050159482748754998013713873025277263506786852413166521501337914260269679314564047500721435037312024557448211096745034206099734425812384519/192080121454335949318906338395323293994544180901096670818449441026828664466360828419965237214183312550857841464136206483120289411046228411641051,-252205006910278398889897986372886216957628926254884299821305424824935707848673445431931125796708823033100117664265377196698064650879539222787444/305903681790759508986244469454847474669839314300269618671024775933499392636780519644922296172983413973923963068124273877005756235468234853959135,-108724781639261359586520695016446322723457285479968245342097364357353665425808767381492195757057178847669108465397735394817784740647030618921581/113819831594048621709600494064123741685789971543010874724069388361816474737191119498041358029340354704200643257205623767230205168754111052253046,-49197389370387486849163932902146182914068271159172740809724657370245348283034023670294548359606550340217621167881403555055848075662251857558900/26632580213190208549453476564742614251994068469162368506069583832670018015145625998223204168753721339926695764600488674762403196814410022295243,-4292225268087635089948028313330125366867070007452925507202269914994152905246619309856736020804590618948113784251757272971204564367256425028633/28029871499535314848304422158586676516547514182636020301949901951907110822784152343402559281796182973065226399478021141448418274536203620808052,-1735637574096734538542568820273478214879422689769126593331299050276892540398741912778946370594894244833178968610725780797235419830485893172994/5224480255519801756993743879219139967639142416131527305816370372764124621295496966854835855764541323926128703052442184785833943752876341891607,-4204903486746760330853096187775831898281081902904128666157907023951097136338066698539493671914449487209183803509678443229513723050229078044314/11968331509370981095882076849420144358285560254606405998526743112603004913759436955046994613742837049405635209790913210771740960876251076033011,-585198539091875144759663092021287094838584942555514099056050482667635647963999427910006467626607217957133407876349962370901151202243556172482/1732188025337405874030195442902344790055319982074881483299024029297473149253624143063085789586541532129725976801886174365830355322156833806815,-101822180610488351202390680253740732137085464848822346719975627480413332046300359897312476013843217338012522561268123358492517465388714768984/247986432737665870600505291260986066605914402174485561085117939847567489293832140813467196233339350568975918337587066182758079660330638195139,-122432741245296585022645735658498984556279687298180508744232008682138069616064087819959299554289891215500184119430205186745966496254525922434/230098692891745408519078943959265694784449239921142253927278923803448682742132054411061090012901331462760961517847539966257010287539983322071,-330532741391386323698371679535850621942887971175182886667480265621920092303817304426855587783030769113878912914984310738407281876523523891779/1499163002394767272348527948136590018519559144378538040955791465192286600094934985301161131323023444245503476239634706993800044439931154810370,-578146735725934357697660292923831506750721203437948121554941599297629393256277632568233054662449577020779919010443218479362480720864313653874/2531368114508590116607963667182068735018775457976670658106958108148838993109851496285922290956767737432499765677116649224562047072006375038489,-13373741841858194230915409631407047562755515150307489408129771320698903203356316922037373615762096326667756690186757612447465003780154603602381/314695416157719432476023504597578188656167472208440245702661770801538074376977531333070691319692386066317715867848249800611994585853440656853648,191491318839815669599726896828712850266866065809271506092139186955873985136444056968311739374376095813866953312029385012112108504954717931557115/303194701206686897711327781515302073631549942242367822080569776806065021187605229624122556632343666173610242657645731299250856237933187830943824,9317567695189846600147279249769764246252462100345329060400067662519800062839665229684721524137490767672591241207804588374092410100991480735321/35039906612868974683869913294896125832380934279847307830260679833490180364877449384625405485441319443462880141010782356798722968872410621767360,289102713596567552264956494788491851869250380341099042052754563546736141169425113583708433388452358844345820313257070273470874931670834895225/1182467368690167351414071642837049411137622315463030498812595296679260491416384503763143369829806085037619963388070214479839697041570784669472,1444455718424953965121975872829166437897611815013398575636479942705230036086116867749466719723423305542242672471022853533989526695908933395101/911896844086477664888790629934220117200697367277365967750334386651793135625154869064313002725926786983483426016690643202899978578024889500192,287499399119655311826785725086437210681824590846005656964552330627607504203632311680107840001083565228290524765638483523121127891564097983753/1053787178444123128178186728513868024074608266724497146374840613232051664046035901920950768089340556853344619843537644642166317982081667141136,713735588687223435371121576873263357923123270342360159757053837246039839458880386123695510106009575675334916080060319516751288689475488281939075/505011863738338385194059146524546906436965767142313649932749275164684428798678013181260766795962493574996020803532240631208458103073055772106176,25688305865803542039768821619061453585368487557543725606458646359524602350204068802670760546078905049154034274802880918269275595623093015098027/81290455176537353029406330892240803773936950917249582337725009189335869794081832444458670171933997933822214597630106112542085096927973202252992,1293381807433362342584936261316464854718463173629587806035379417411629125172445810534700920533168844152164040147626239316586602099053132408931/5147186188738162613576556561048152280871268448913810539532866760903124534300654464873957400785882180041371473655515377844248062661048448538608,7344856464802098176314570861044324608633229075266520844578221765639845466899696820461244389390572435942601927276459484486814994204828520568347/6870844022804929435722311292538605499548585873179885922608059266019624315646298235402356281886846835412750683552077116208430765886343411837584,2837262849228475669854909418343321603826615085229697742174447329371008454676060279174312429418900776090911274848353254280035030716374323021899/2592263108682496131481731688777546967651010472461562430409947742885601446616688132851759435291783844152758668852667080200738622917719714081680,64734093567102456080812547536454149924713488521381242928043871066799535519185590534378986094776709386847170164810321118742801629139578874795413/58346374610650765827214420009863185580592124363979533303036144730174974483804725321085205477344738875680819731845444370285496015925206333834480,96325154540926137420131864493576037302979941397861397823689490870303825531075489231012473498859218719486622794587660923978055111506190006971731/87281074548663050594498826284882453146873072117630923372577032610580161375486989451180574495984082335223614550935009840074306062477258300571984,1195440849619189315366094038087041226059585300248795627237180210933396807798141609482754083266726951245361934477164003463554142641117682684151/654463648318929648496832087037589112892035176434583046766001843832464402233124478653473410692784300736397290704804706448290897747120642989536,122253965042418645945770099892495164590326491801768622715738652629649812833688233237962989226020847553667357198890744659192486951453064361379/60391181169629681289068483661329503569270777658254282827230711774749197717688524724437444248273721194156509230155321440001691753140354981360,817428152393553009906304537102790664335345688633331311750934043695791711976232941874727060672446810589564774155429580930552924866600678203227/724432709325732011268183505403677753929755055676986358958645195603424132366887199198224354313007726152404542670776230066795380596678967725360,359447702369638496266628238784958233472356791615110778798116967804340951876232011054156699006894564715453069402475328133185443668637927438477/306842531924481559007863126317213775807025459721638848048293155762088232968837809994215282959538111494443565504219140076482803310489914651344,198089805009631616017325030699903131821672358415972909302597103936063225506236508914913205019051498156439272658124181273613013868072240352579/143790277770714533513756540697723592106236316806161247388040155514961062041283066266385083805324388518646711111127349680450413985409858031848,67507668437966778186934547252646021925622555432008904704239006468660726532985778841638819282091073906010656143492619438534910183311879225319/37582157117816414837652594011365247847780375774408988225799500098920073813995223385066613042469030611450186745030050613778338790628882128828,743819027845068129215146975952453721489484467034186880700118973340105630756744953196438574479734987600202061972373115337734681671211199386253/410805040679815954443704066569552905276822923164637363683153785674459812844778752099053206278154402069130901021217554039177626493686234777632,442662237511830000503514488130776895528159377219670960728311015445186281966342402220678271998629413862962834117826683127506657873328523437213/357577824777392751898837341370580197630620744418649948298341448555436638600837138246081292819501957312713580348814900339039475717100689335920,231765898769891266699106402575992296286034339317041117761891258634130750592868048225489190880358483058412950903693067086815517305524789555275449/183354147547676512044154529130439416687607193763832226143644687049241657449328497271251807817915437369586197771068496458895321695017037107766464,-8984333558572249402152022675004516867835804447414677094546420151784904118369586287321158214000889836908753965907308184212343562639983992812198/7313070384671331933434084380769550449930765236311393266261399583191157569074444062386901351605311149365954459221273516385333861085459701621985,-41560523316013145331675050250170534677359022882738937050455393754548979648598077472074106125526754183194468301021947853033539422187417301201411/14525853434653940753463047875708493680751190656235908200133074812742416639297543464656625019586029544906013340693007602949228219055496918744100,-2142538907094139448961835245080591494308169817332330161374981036786350566169318642087105757617907210618886208595997000045522408781646645862960579/1781817926215102194721787442532916437122180246872573916301842995547626308405784009460277259358013807812789629699170675403920089511218044689462430,-51315886273945073521321176226010621953343165338765837373724046424667369131016373518066377911079279019047613990316720254533185655286582307653289/17574031773949226760558239961914672849103375669354622372321477753411136000817702694113447953833676603246710292835029614010350870482254163149700,-8943535320000838666909114806505602560183091049617848201304656657389369139412537628675572315194475637205391591549362346050321850372977053010/12201309600235690619864418854386548706517079366610780508527988411925520611935140564265362540189427432782484586501262988941916083266960925953,-1133143191438675631464327990368110241383258029961656230358296280375525022379367892301900502317362926647709644419595815412770294303770424452663/1973288240027404853865947778052270615694706227925903966624860069994996587251592781096584385412142795836022717431283352751070263760536078749946,-1660179828436699600187779868020647561539768464336299270195941158650610318241879554213286445138453574547485326580783393395856652958110639516901/10723351288588544080512343993396186550264545818191952307517974641610443852289947557357517436813448616696482798531269276052154259943899079512204,-3956789468753212930783034440374065306891115657790181413607650172421951293410997981352915029142977322124607786899136618515741527969989878185/45116349780488935755461431939557634090425845079428914470306355466204663231511422409329579165410932575820257395185525432191880529770771766174,-359806238699856095173417876162954983652881501570577518960436711775292486428699734185461163753698046546269644343393497511146337003303650951549/508040892769167177384684425330267534094200010341969261802730924167123718339148797132585201502398961756413065909146499430986983907618538615174,-1065570061053176519716941953731073544755097923167508326597009294872443986895327995470923561810575328072972256590104667248192205151938004345549/1545923948880623289645948945797444914276950371696495767198625202204762549862859474797036785777059728968244988720767923727933923485775351254564,-64129394121401358067748967580251933562570844536880410477247506422267034069655010598066092640455132393957645808104158334230654181985078749668583/88323102363246453380222870729377457657083875644212674932824212523592753370486135657317356286269954470206285811637265186729002696999858472145076,-75786552614833082854924718216541018151653955889645010715343125118988476428112544325415955359040502755124264083011533607183220380695160959652623/85695631166184241421498437167979557298329196005330948667991059220505988519089520574374483318006800889420864434201698770507551287250997134004900,117440768749139088872155089326458691163222447156020705525655145035730003024212515990456476278213907932058912625552692124728942051842637898669/227160925608519197783149091096043526478973032889222933332944862412516217331810211123759474797960572851363192852093191247692976905326997022066,-228152133736349049861654413101512818010151653500156693614353491767284060581674909748611303842633938355632630881257600080806712835483822099721/821194387156718364254710955373008370210859108608810789135872751492065159610720988428722298327044054710224680679423933829253690936616608495009,1285013486264907801345296258983309132910588130424850909513056394382734966265136611835009210049181787403509225863853255079144091648005203550467/2655616436315031017528555943455561769540360673129562500145839620147573788263225108235056795635481815478165269019005664514625357033909087019488,-266293323416277355308016774918656966824913828026545076217057750281416990057919468660310510011585430564172171841077390761676506520756228105537/962990104320273436217541564638877716240799240857371534877284226461107571514557966186834048676586543021322673381448551289223918970820357208624,-2889938076186723334468114741778711145827910471639681617445102702273563116335032162791867799330542745772007905965923703854713748062706234373825/10593197426537588517383511229777259077854414217539860045938205834474690380105763651974887809628287203460267245637846977558135365240909575205088,-18164489753162730186139885941774668312318424494792253109245241911344476890652691946403979011990277646464275914945127786399632188578558039620441/14807160935296856751014899834654537963079796124845794052475390915805021821109618526224032882408278742143557741812166801741864639358275939151500,-183279134901511137432377227402427187929401713558726891888510731871127106986411622606648391617369836300428252740760503725671825561395934456759/355640865613463193112070081933069550485832381301344009395234591474916382225692306241603749954559541005133607502846100134474379507985796580800,1259215613324267789729577884685472807718711241028026509642724805555349448207538630909407138543130876931759763763960002225621708438538877790365/1937731697620692796161159394960074110733995660353030967037045449495973224033355080395722852164381551404908412865708698333818895179572756730193,24947169709766033288097521662137523797140088964190179456682528577346763933248477747164898332529437225314968467211879905500203178273302093511025/29350532700479165271474566005480621420328499016103174885602398383103204827922887437073739431686678745784280999665492059645306960151864528002084,43466927082604111457122292913748196582014404447832441646724793877738980827229472214768020017464823493097839808406294700261788739217483378265863/63767439302735663539652772685063311083662798515545710643838834273200112242884014288177995887232735904821065265646303964022488454430498077055902,3133603911853475610560723082662827032702757724895296967059846263115803179746682126085927411274223689818085377933889676644309945931581556193700/4229626135840597135270809490511863002018209452338318654918649443446178534778273037792044172577471954913072987568089043644994300726095953874507,66321018957980269354723788793993070034398480071620807971934214901988445811553272356709159441830450251897982030052061052133224230966487603764708/64825574826724550586298040899720659366198505083466593343221132842165946843602113286269295719589081740720920530814260525440517316265952526136837,-3170493608572322976565087572933642289385672919954390492377146563819026070678543591842941640706496329839098829790839866790330892380279493479149/79180404743555776072889772701913725289144856705166679206269050377478642854265046764546018005137388336848799981378357006933865802208184726456536,-23238172707165802079400017408330913097415790136594258440081425995146426217417283391937983324556973938789237942158078712708602298007607646945485/29731656492640557509334611172306679845881659659804285208231075951150192346444961175808757325968061021372495936945696765714052004725333844847624,-265047315892921828715160415683047020228293098068550332274547945517719940045105323000701014806367740991472309464409423752504414946316781485321/3762024606223050732991555692794788865759323142213227926263505547493634819109064776205120265436352559697148094608960030231703835236626604218384,165881019256526224517524668282570582936295853581874460211513394633369447348298204951003539963647884427537570998103346624394257067219116728095/2042786327480197964486222970675196511450072354092123018034319509371678636345833438605133931009768496428246437865709257229801795562252503593612,-1082773631326185290804103963564320428524073546187261653112309395432429218054777459789368801018958240751576580244143703780583757572670687661617/611081203427635088951182221229432078846557516488191793802942261313637311230052020143992335705304297904639617585344443672629356266602541506827,124258234568503569335469062015502397554341492677284401520424418747293081574084225940940375849225468084674544785046836294598604597043725350628989/86015053898291413891942531417939756062823369588140910994535539717978837624615715017850356038341000037859422202588951301697537953526917812078912,1402297583516726360840370327334750738189197084842538402495746518534561322939294954565928654214526275395258702277435615140475717426591490029/837516810433142064501007201569563760742487116872148492019403439150065184889011774873695170311389153762988415031479689058774604713850771428,538411364855776467064112462298551887030729772504810024152230177847289276871743610424760150244110622035645419986050765489057565395266411991739/319270071018756824188675482034533057446538587016637865349821451750577102171019079353743834686433780170034650347352132042577716333710227984900,3906071896668018814236650830618002161023530881995885773484419504673325718254328483725936510609965389727594471458958495141334595698517570011333/2341063863443844797384735984621097717903817653608143712560393873358591972242948035913442801804629029514193351424989352031100733794406350823744,1610069695434250685894170943376916303364980234881841248142392079298347958956555684732678544108282556596716835860461156788817450711173017474099/920364484037584622720614588371154880834372270650736557896620987228710510395137808036017537864508254941243128068637727425451899837198418808776,42524167273098478247074949698620036165691913773469836228656384404004190478191657331716189446159480995110755170236074500597350659605926757404193/47355051681631287072791267461811443100962449992828095859184192912946498294713073200712206984230032690799982620706369594808923774884093091033712,40997645917452681506721809434561638718814357291236922808097001570048374609542117597595822663943901652789061499548238556445237209993326688481/48936321462127438554462050050205771929589235848521362968376748178423778414679866086110569933592951787142088158294722930712516194804427580829,80638139712970180437669441539568156085618279248848290136882510233605345337808870381795922430156636437842900834786372418592209026499118082569/40072253036121362889702594522748199663165104160645155576633662972275378641167705683308499540613057909467675272486521087733616354078908740080,2140518240845397865606933582557886592826732240716223828773675176005556955048585209914122577045312043120403445476986247611707511377727664857957/1540979576300153293722089984786059227800843465701818153930357519854246574865905698065751892915921188031910988779685684453061712318504637818352,592771481639870122476196002295649606141608715500244319874045373393839754023046451607488216182692144698252794560072507324370915024804524139767/296087675161668865157374458962476251400704106919665389547308084392614927605428315532340198379175195673160145559570044883637482313394094349648,173048374749501236113484940241840077091347179275094948466837131869303430764738830354930306053079333053056286099955181273816234045787265092845/102489038012864606882413995693067118925549953876265310920384483465711181911930615455575788556737584857237398488861524520962766093925151692816,247048110187303614445269504916966941786722173915505668115240792535004039793778470979816298651758319215218146460981451929235512011616522270915/151449998992338026720806912822724503195454608457994019826929321892463987662807700414177335858569446577540673644559914594947635543826568814112,56800568139428198788783395204794889916993691964575574567318461930561670360317016965719666153361760973917826456847511221602932851057832383806/90398571049233263259687520277349730750863841305825603578074682578225667665361237966673495604712949777411244573060426042472703479644926959539,-1142533481234526618392121957513507539471544560758304503654517939408140340190379529646802687713344185080335463116571523115320127022869667396617249/11522114626432590192914994056266831793302935685279113696380962257436758564413503373153293073420981055987059259798611913442382518201364687754290732,-60633583564944425621485962094237470366685211400204130747450516522800807882179423575081549256427938247497538379972573313537242842806109932648725/114447645413397965458764231797727511293913026969118495746050720764541461358883855436517606334031182195010386585704346765615550235575275900274564,-84302587623374763374310119214227221093024271499244400252601796771427079584584486526285714294959846489673779464836024205041464368491598066739/1234412817376782980540102915435625009284522389627835794444871802494682175666563682121103336840117008980929380586395468814013170765371240688884,31147198189413235887484374021468828005016457112897597311545585493062804757915534897714008929024104421146205217916963452154024549953078493758839/93972441978226998364761919856488498842342285909530549807398339699254023024192932084731328351348770131525901482716973750426826435116207015860876,48043343976779145185978726260291407966928542629236728742068200494692998028377433771193371640354953747975887603558240549238623441809698320080057/86969956738128479154034212521285104511954387333162533863037225593942148994641832431114601458657997949128447999950487698741916391961662173701300,965183691815485313522491887133810687798365914657411560883945233788070338978339463266219878674537185162591489649379025523161755632100133845745/3060867457398506634716696179023027120067011237615893896279348309017574554790618187587415810629744432444110813294567715425976809805988266590116,-17672397347948207128645072013937891637520483980165154417178687676920960810306465402669915121157889439600336608817266574456482186196862080982259/63848449924883243683905040986891866204859862930998433778098693977684117386104254124222334894558001717414502547982063412665193445001806771203448,9374061538687984031396109258201670644057054778299348243019278497935432245039205784267902565198031447404049115774874734650809439958709212269260/133622875536387995782041836354882744639880216273386090423227434503737821294093447610043972142265620571663200985024825671886231807042574654890061,66805333643217598140191441457478395667550338909902444550324998907648344345220711813852410372007452659731271110031312231924831546058598902205207/117760328745343873593656165686034314319688174524675812681621262872671313882891774326133614644668710075212943379814059333781607594325948957568300,503358244312716797741446656030318924911701605687799374710761013023811032699405049126092210460531053342518904769548673242594988765645570993329/871265149887080871817345469511747714627756882121330961234863239065362438612855892169405901260433764024329395215833182368306962627287570670500,45402620754952575622440773164844072917028887301809734876953127821308910868985733046167782635711747290263639321541105668427318460658037009469043/46422003909089214801687295672370888780328613089955731928021205208591619656784776350905843859320870408937051869350355671768179436658382079575388,-54941066456991301619497736358137582656899814355047365292790706948856742397845291411801076832811423353469354489554442008176212790274993003057395/19158672127599212534516971254055428198237374505722371593212309642330496507100479784111605601721606447868668960043401139799077328593317798635588,-5487505433619170805876343571367519883832869283580411547282159258377933431766418522836170262854202365440008848168365842635606621387047853971281/4538276055309907237342937345233738260243452322862507644361771658065230546450219050825476553565552162146360157844131728643134647527757625432827,-41254071756544706999944821946131699374811925658458206870876214188955567892502108069921542916702119044298658430483597242386885437603781923729841/44572641062032524414125456090222614954253506623348258155584250083888940372226362644088182280866147217718364922196498271289466216721489212800392,-61563853076272047500427806388621997168303818560567504685406783611018700797873120244144623638284490460280618013927624041465673808515146944458405/30635402810260112940559219815844882924214615703575906766850742114366767398001185895345050281319087875688028106903890593615075980638402923023452,-1356349323630530230879477759028624722271376565866805385386677565182133585770547540988712015267211278919031998112307402231294162851294774975395/195871760557563986330958739906913951095971221102555345694074580752809777137559613437098218418227145231448534483787965992194870142349722911476,-383322536180554285875076884639881852005838323190828541682783081217544797071342484071864980305220365614361246690814486060648363725611474156061/133095683910078525992386097543416965383692002014286830297270583917333561356763802242096898182017198634010816673690165864551664735781085037564,6653550058739836503928120608658485184577622412480527816691178478452612079260476103956730803036473571849841618135634448340697410714905853989/38314917039997058017968763536812946998554927652750758984073022331348105501303429758125094596358995469350672954764644008093661586034061548624,166149898362759529548556391814461020274245160986948528918720234930749348707200375260135381809775014546067157949532602531114934275947848216129/858365219854162063556313929054520684296967759714954357299145545254602893023062278243288344673558904134578697880743505192796121803025129498740,1166191262988542071785845287841610893743331825848059273586061310546126237769805732977058153585399717423181089618470920127440304863152064620295/9397986849685025000974988075714292233915524505752175907302387124018979617456534471110995283132650172078116061494527570390562967260222628996012,138001811970284371241030381878138922381984455194201612172400266351568621300639867691137540479110003907099302475621850302916389087723298874787/1432614834816549252366716675877618027632485241491137129962708844849574823997489400276729744212573279582118965935998103163742284869209979940554,261720349942692903028658826769846646284645332936405682208805531751214134493560569892108853212108404960441968800609021195798565550776610824677/1165247470755069489991565861607407007590225931901761949272451693665678880949658174146585728845524526790627904744148168716904391687891954345220,2441088046040795341143959511664247584485445225275173262677599758499125201457214121412129127733560984228543199514160390051607805829633068897665/9867846444136266981064588574068542007647554591240363991486355343840842500145272452126531943085456910220191945229385085649063782703889412947076,-742364942882732805499612176500827861358168954312204075298307765593176155653316871681985163351676450996931764973531904580763398805366570654255/15586860529041563280135404180234474117225965517555685437480443468787976180778682895497590238163961362447264620584413318842208884412095969533172,-4510186001388446129992926473239956994416191846100093534543058164069211888066428671344174736489776030276307887595916803189499963912236786019/96402834308189300364208439409530893521651296713787439046385474486764956091176607109842173209828467219403299356971977075603400060196186972262,-439336606901379390874484702156956386629590879892522487477883296272099514024160321716006805320877336857689242101490426022369345705038640309/9627175966636897889495550241782084634651583796772107939178304125383404606625536880983132661505000402395134292505699391530544840854390412988,-274392593839690015407168597611175807977369966261006889577732128833908765904989575322182344581044910903939338825323000143246936015435357971223/701306077670736130035012363348174022798909079106488951654303559895435938450215565931673110398669248117232103506176759942425149109025312379762,-90433557648212819045293959149561415642201806948551363897451945923094578414880588587966712387401437028057055986521587802417938899639161305667/133297237024388649751045758493874814315937583590634709535291296686866855469449686413424758484386026848441512885316556325894657225588436065612,-4074695172039168988639193886457239060239115368579734395659069579067648989922434538614574727342326019065744463943833881056241433178121521018299/6823785347888115614759005464154334034122717392659847509062652048306604812523288947707492844211692997335532054558564176775167595640470788535028,-35813690594612737947133567256504743860465980838436664436650436267155309756805767570218335564518818387193516886941380911938268693965658218435/66828611320281350479192138764239108836638609972710567179980839737224006328968513652867433150749484797027513468229458757778064039983298304682,-966147261709757765111308145969963950801466702358600808273518135464901137423465696805476614308752025602924969955050365268541323577990961242079/1357204128865275057457841257401021269918829084667437434970013329064815096340516210015644454644205510010608689356058109014582805374179279010348,-158595446399243903537189509666545966979679516001430825682272344944271230379211488304689884868168186459588796871821212326550613347586767110083/261894850505782261049262235257217581820190450034912745403634237705405219773460943133123481205351394748787710138797437759305759585327974534787,-107819046418743274342673505673963841075166819354763217841319824652486795538949000941734930394402867634130215317250232159065168059143772461741/68965957103200590272123080323048105188004328183264616513122698574069094417835246930046561277953875566442158455294412578179512200065370157868,907991371237686729938347212612304836381341578415465067085867139631053115148687329443423745017522872216999686420566140839244629557802731468853/812462889546635908174415885844585588102630435449010412640550348337637081658692610909443182680106578733099612584237914763981979255558124499868,657387601281025755824221581722906530105769192465466870934003016963094272455575312764617493698176755474398794535985741728728638067779892401829/537334099180096118135327930254676283172923467112215182025089683655373929434701820882512819563356990994739027464958087353740329861016257939708,-106781655551094932655873011498368385445863432624454585204857160239067508952836757739881677623572723930577952545225520027374277540585428248417/116792051470001389770355698953151916888802384651912345635618294506045319393204125496792366871037468802895172787676432675510188989905473600252,-793071461999523511448157994540637776734953579916050087522957636221525208058826538124291679294967617340236423630185126265731154060470076016203/283651595343689838888199270200992795396834021448930409503075961306728818260100387575437694379574439487155603587222656673785385345152086298820,-263213997764955983847244833925067683138725012112076169481190903785535757526759496060452464276698183486191210740175844788699551628453253641185/109713583960328826332905977070311638937537274143913219885350536473238645846661807732288202924796691619492220374298383025473290617070267041452,-1273448251730473094782938789982725131148263690210453037407026619168725409689858846634477950887523296482322960895481819222171205870088396667299/483329818103245557269572547033025660549140847529240399384684972601706651304852117857555823297969343697462577069956484488866259626034393175796,-380392765273798553316048246502941304832965144029969145099361057318616758680203013438832093449604529369124559497474967681698699851018484553843/128815630465194718497085215241850131418170134044779350110183010421630165731989929341774082736572845288264108285391169222148440118928740357972,86741516559063340796296458822559036730277514111682343431279558458495296089910392921418543397185957430144990836249477801091573000557385999344977/65467955834087720906478857006813210632012181814664312338694151609206627706248320978564284965406823513876899160068272423565852661634301078709296,650851972676811798889100770267503351106482327341037523762756074358960373009518713720084878840157350399356971994334198957460260945162092283585/508035229879896908135783613418902546017909372979528440902036433242257052772276302537426119316981825916289624033717747628080047338030010469168,198393580310997107466721993817945003254818430612967866257354205465355240494190602834619180160298742963378085009329293179883785431967425939945399/152925504593139455539864750713180791504584903012256605062651053282534813455501457754147411193841832601682572680511973015425712589335799125040128,408052766020314658297616289039940485554585883604602326071949686185807565573506770416634392557880189018302618101833850168399814412258742553913/828645628881841108882912064032335291369487524883311680405111326877114040638912635122509658342544834640983573670037954921839686358551603271620,18810736015700177560969170230359683016497401337867963669069532780024691345841708871142727974078771650746854120387487958580966106050655908441921/33664598053653595990735555012552922156556658964774325360757552182363126880173364794225263763420887027447495788605916346662298175763067162984260,99883821915114162339358878847356212865371452032201355190963722069086012911145716750132629187099510580324309181796416691425139093392344233580047/179749955887697596141122671977233563866403663973553468861932202838896783513504008794849575834000412923908007990019714892175463382470297235306972,778498977285961938796859797578928629713117131605223454500689335933292602343950276647016081417898048836880039289272093178355526469258979729309/1863293070677956086277236826374723160956997469379144278007531272472519728673267022649860372137543714819019720639905878618585800922906193828180,102625597503769494166560296025321920575157229199604056419608478597711232405119125440738098920703827406628109379755007079121548799253246605187743/91530052502227115990857516241055226079366365620106319273408560687241213946066260075761507504334248749374432521454837954391118539868026795528732,-4216115719832779171440060202056439012997751370789351373406686086646138428578690950344027847167519496687287718967620546426864464328807941992667/2190383448467389478460039891474542655175950080167456325740162111194625272688274200338218067216747648028535579473330789626923886356678186798964,-167078850779192525505558008781858317117649393675845697830179238210253899142661558001525285917783429888279652680577764761850232443647076593761/262737741781242524907359208755165580830489517532343955391440064011413613890140784459094883970812767635496854297487651102969062031021842937572,-691364395287317330419642925415134841018247233185685989415631627054781500448239902104295505311180400389486021105648992922261323279070021999755/957381323179394144317697383309467260456865119729058756865540198788131431467861061365179872703574448567656910161443133562613974954361275757117,-23210193240749141048160414249963441577629033927411958106197619918967449552214372450170070079524880376863669181726858465614697012674108378400309/30279582936516255242070493628109761916395693364834192686223633745908217560979309125265717567093961319436596211430827743682845848911835609378381,-22666116216958571590946130041866733586730015277642261637203642187373455604669177297734274752235482130108821000496223455355477923743006376236518/27922334594175441069034707790484285380082757846208905796354265118262771330088422938769741584520960709665585201147906931934644937812892568739519,-416319638315713761497300314318234501269208851425902357176655906674323325519680098084018538997655486802854498372829658260857392249378341114783/1838568143999714663995726189628260165609379667529224063592610026067124587511776485399757175578786059294822209675012595392275271852661100449322,-134723109929459273113577113996602749191911422294378016836902623495843351901058086319457667542340259423287465851133555388818672520318053270289/719352783728172611618978151196460906170163719145111629054815451425396350386383041430715544690962478586846741978249654174876132650678355591824,-1468216905372029520361490562108045246859988534593654498925916118321901112868670578225523966911281177006004884246397450618515516980222210809823/6219950657289360379667469187430965387590222875697085718295749630412154319481520022378097345170746404601983004000035637507517104727144987674736,-3374219207233339413807399142802371244398240379458529015266750264622964275741183583835854047273395445981245471869779518095126091549386493535863/6942508474921206477043257411803138161184899456417624116043412792825611397283318795540841276874152338461683030202600754341207393819439543368449,-27611166699098519297839634718648953269833239405554271354489793535139551471411885676016026717906844984580594476325356624821894739807542736171/41594844851201904833313902147773275674731651281086051011993180657539504131765723567808760217461490419494829522196841280697227654113602117581,-107756548918778366839187525519204302789516922939208010574426172141143864848035096135752864733486401110387721284585853289897673607769647992129/182558742389499063172939813901509453650325731953792917366415014502882061282221579964967304505970321901309452175397820795610904851347556123764,-58054533323716692129805925060581388223689209154160134320902962978939148532650460661958399038223056549182818992061669640523364591048720010782387/97594760438117627707491285648020350854768667997323821997280836649192519816168778773224060275053917626070312729037978038341057274450261651339364,-5053016684079716601126328730354655151786657670485410648985307769098899864941366728478786819019953348670155867483160003311236993272306177535976/6467798509205739887567724870953350920998303975698329452470385876631512081507214176804455367652887738347954417464859252701922292978863110730147,-21802660208698794693251670335195199237274376561211125462420433215177614083401345996671024865439486453371923699549518983201478591509234198264361/27850288106426957312102925269824570035284357849577175141380636842244757504315339780297682603593539634190253467420480068153832120362633780959748,2952278112034824556354120026776961838056025841130797788114718377495498550570892396571911344574175935574551116717079882879793448864099948799/35370084287376474374664681487359055461963510424879556811728056288334979854458734931946041510840145660617293248223860038129304340983096339036,-8337652851940274794539023968356602910675985268332566138032807216794259189739512237713702666181028602373528889012090820827865915221763911886819/27747469960461463036972298954961225463985676287853526890955958474123143534902610308773074632440268124336659508835500166418832243440447936644528,510260977687179151962899600920126338083973995490781183654344391137086760375641465882819848282717341161894698989071361967090437644925872695127/1674402351561730748783510470718695575794845019321168771434498876895850333021971740222446122054038201991012227792876098507028261872492246963472,972367329661706389261901906225481971120856600276853850481384716493375587977992322251879372354680247796541064903099288734756206550814175813287/813312227172758909331192289981671169631478926415119627477786054690343358020039091400091076268995075713651487383671103527174198806151305094080,-8354498283305460622697862372397626910104123576982370789189410661502920258463778524014011529577685630612490461365360765211366170101778378357927/9823850262378618750674436894808313304903965646725790825232582179581902452551460716552947443406440390689843164052224018898424415810885701829276,188049274685704917260577924113434669751121597029392802425077243457970063786857197396571346442839746032338493624506010374071958757431921729511/472807568828878450134085227116989822271884199750868308235072674281320933467376311261459647174907258480388766234194253470315816841725164587424,12718144573324429091250827120781277303945283986761073896458939785359050095806278631225690042551022252809296612280530859631023548116964650307/15559244139855117246336513441865862082338823743145727808969378839066358233628470756804874088895713054777357028810581722753972923447021469948,290485792388674779697163105092283710105526699839974510033641617792917289891371289001406230886699889020078125511558007071958988793858850106983/430607390318934237674899946616418136808003801890029746116317735685751790990672982769734972506483904784089769201391277159269317832177670339912,103880918521389788785748275635742382508683194572405576525936087506101420118113425090349627373639032595069664780859884852413495298985899958711/165624673287528050199156649220379689040958845706026649463589596507806490895600992526853767232199115672627737749501416721629789715526018198324,2338135516220513846522177118772310596289505143995546210174364178561885114974564613776508344570658039420360045832914080435546718799510565830699/3400448918168167463074922780344558313382498151339377798885339693475492938795622279747702127764844245024859230600536359164404509144717629132496,75359237939221683478440931621305137792926318937231072648358309239811192566501594170575272457279429951160669787282248654894505949090246591209/80675143685254157646627449949398295868945166470589218665171153152946137036675851247296589588997326166400101447568428182256602112987201117424,28325446438215709418200224464940472645233602862899150482798701658358926781180861973352527076136000476508980750539010397692434716894608715689/47722641637763108598275033570980791179702210798049982007047470806677081110701165820887367777617849185506791397149970541929788043311303752286,116259875234771707271974378191496181531882022989535405010211584162157746649773226973968865812180780359550368539618683075901511628447961442087/832599083996536200898816275390253716861864896054477204166282700328251246249485539852971663716959653990058400055451360064776500354966991792,-695954272154561402019391533646429181644047040105647402794552507343168581853499155443347601162042433395361224077618140947183989161775424461497/1050541086417713029838522724929658695520016538845649746920280658482159065217808911974648435600662780964302463035008555033234633608113148201616,-204348937418409001751753196210780004282769954075637847316586659182678081359013942063804054395559070073206184466052602960056284447279532278121/308027309963182476760698841011023055373796565907352378327362020390902264041450098914650155150308614899971804756573855041841772010762406884118,-78053207728514868649847477422730691976475137768547839606380706690195304054293764270086138860377679961266155440451321890620939420951200625727/117899004968206224768901447048140957164807720502803820995497850979668700197208725766872714385529604571545951047681064248372779927484762514236,-7173139958283120701553408425721201369202807880377054805540637889437029497163399570279014008587270791609892203745018677200189993889538817652141/7027860911148564735298821300207336656089236320457117911846838474010472325007856922133781665188550828368947048848885354731374862171570075338332,113498400677538993378638947136532198002785764486077924719763732689973217619765599421645325175473838784403270875395327341025877470185223025141/2138605840872895246863599049966994310618628020291575649355646586076113062149757911465521176160347681556696970769719756689741733643822048739470,-32978373416737633143520558031965596111866575634491373243861988362244113297698344099774313880122264183334056747503152858114906952741372218315/16920067302928750141286522419072843469103119539287854486480036176738227016033227944625792411942961169570676897816292758769838751458002912292,-40417679571417978078146512965701941717855177211287849108257318733288597621277528213622042025587457816767826707333070299772851644268958075993971/34974488653825593056688169582793513594615485079374367590374793113122623011693031543437447887459061673747418694765615230719434287890552275183892,-3641083434528096931113585702492973086351834244274161028181128734272477276158668934089070832845580203080468362124880169101331499022370282427152/9615790748750231856912887364012117936033144300991052309928645442571687075050866716317893486886012620812770516765963985324083451088948663256763,4058195680244305010408176419861371309490527620310781294554995828171821290000573381583005804610489368257750759492477650736756157157039714665917/29494429006500547564029891881194209113751777590214133245205201618870059726827438395560342302112500732917713575751968044488099036407415484023842,973945657183411879433731238216558033328314874446895187990318897516704549469610296145812549359678054168929168988766604521752667051737081285919/3492150319857262703281636918067658226960966210239402213645241214250060288376347240847847563920499379593090410953661938823532799942631139723862,2071507375950030078668402443404790204478086826284866953325076184651406602528758458674460385832638959000666697678100504508208578001085333690651/4767600593977000297157785403561926887060993682543339834129517808685711349537152734878958651857484771602076450036125846925778963717197710903714,3306861055416480133001978450251236535326671564769942724318075562449722247254172645272513074682235594517188719516857236207869146345975795000547/4625431714958429227833932438374801327683224178081545444265090767831564686635476839146371127118923855554619906190034875023825853521729823647940,1280839511273516305461605515008012282065609678904505193476938509118483238662894424832227336125014154081952289878138808108568731731830898464997/1865340697602293700451158424199491047688130055843806582630126548024704726065016295761145255847914808690914141935742722372626842881632866619410,3551150624764542150880508253013877726744514834215331894091164528072342376024531955296876013931677106372314924437524799477962632157098080881903/3369103784651114719146750003421956715852068900780536454033508402503417332833579614833735221086100133559179830678424324354125317986064289945660,5678906202211717381794378030596229733208489293548890274469690245633204827793924662536402293438044401181946948104049296538359597277772915794/6298903266850507249827387444208129814963471210409962744180945128589493193662081103745663233457398991135448940610273805348888620287953881077,-1340703297970550592069159966270954466451334598710728050325959811766636773396565749324568070947351490316238105189821721821631991509150808695846/889225450274012651010750438844167499109186789473616192288885670908464708185956850930522011939598596509010473432585159439818597852666283217205,12974758160438309011621688672650263221220043654738497417113584650572746553559312193090156045019793004650494459412115692185782607136244568689/71313559918409429196163403135230847027146540308496182553809610408156411662786109491180483087859550988687929569923754319566199326055219224052,820413439002799197772869227069871180823567366945278723144730400272202112360795058116697226192216566810611524961829887248158235404174917126985/4885023756213084162257828618225925862760595879522620124796209124934077725437256788450084323181712165214117981828165076972438544123917549707084,17455419095136464308246600208729726560506537767836545060536756170589485770652518628301997553993954413450023116300603304068512949096293233809855/86854128590551555534347219466066161439049367465419886439086048584861624864787296030161336017820863207068869381675643401571811082527921545608992,88053186425801267578039447795401117676926314904594723716828897375111518505540125343864225861014345300304410608426667146650633471934325717927/483531186579077448013004869869098816974674431278140920756361840751463569313702970473931662816049579987453226765244919217668225134673807884640,104864738349294531471681399227021570053994520142799519722174547643443246200081643253775376894673676839823700650794270849855977796179929406401/575153921285481071113128495643802305703123477912755699761140599143469357365278628722577274428299520316929994509968067376599852164714200047008,260348647551936398850271414527185830758266914002035479549752493006312907424731404589711714858090102191290479452145911004095015530490806409901/1422873105228862882696076699534964727896699617177294166097717823476750314458009251624422485956790705217912146004378846608567090039318904111136,4253201008125679614375270789115167577427093439747274835647132389598670381914964658426543476531622326725583962974676063315030534861855905919/155429742488138829361447485238466063497649875347503659441409730998303315615759487764079949229272728376083658696408322058052030113052669275485,-9216329839789017547526808356860110158113360562857549907998299073361428941627608456303638636963057727215331865413667274230222414988966220887/60352138358274801480464884611330687416896459497188285989866698721454323242187772028085451250061407371106046293828874604752612674236782568197,-3053563380092411452952071957795949441558753594709988448560629757005841446713566420977068891220717434386465398969878552005035947152748722617801/5030523479691894692579060442429371957364752907516747873427061280622924012222101172357136317841122545580619779648648030237986767069160180262345,-948570334624380386922878049656080519218286336638722780811814336495994038821560932485788461196223963984420439458932579367549075330636282980027/1497530262777783450439711057552827849752140835487540927423885832417589250908639310043548471890805139383142051174551776482759463337347216511387,-1081264073133975233787647106883308922215963956507141931493270379470679558762302430046425196571850861274133634278470783525413310399259374046034/726339087513611796769778216925603118053987100821549714904371259865181558779690395624636124377706510878564371050684197663690857008287219473265,-76504770338268279049731558478508320085305433034392261598808063844910203926488274136821812078659263971578701577539949805015233029725958072407/51192191774062187834241909893887334170450550906866212095863467483564432627495445174515383424809680322867854430158341021134450818436033473975,-25554129649041141617997307801964221877052922904104952129884714234179743107960678545557717585122134779359230712469381176936085078324070534253/13026625095157353083522903989556857953456521345144869833591625639862321582030488809263712711353407404721792509623289665388909588839635524081,-247011766535308696508256726181513533933374578844259334206789444422546944916032869311311304560900643861968297644242416634829327789639651036523/107677779946911651654361087337171628419738537019945551899776556384583119287062142273083742266996611444908410976829853528749644553923217349788,-181338993745889572923956308778359136353283261738180619225259721900022954758734396014875190606267139790982545507815168530178489322010729886525/66878940398808591442334662289783050705282827820970035461451834440796205481257346678879429470106784775801085266945099355884151880218957000734,-180956359099192703131248740792771575967830604492226046920733325790144033824879591669253585320974290839440005098215245224091778533536822803880/40842656803104277473988946696825273648364866002947078883524718917804925594828558572374876685553144941590038879286268849965298913590047815989,4804200508387892489595616075659293363739004659421508923810997518128696051448562772531403191490939904492552709264768359351154217804850796097685/4211863392038478576934491745238604342414241577822036229227924761873726883259894310595238714364375270979883912458398326704910003251872183010896,38196961801364841027438709028821159729971120885823648544294028455355923479006370036753787183357373445008808556285993703781693501884003548931505/34575286943058649708207078274483161458629133966988054427801586073188407171454428486905442126372792871572467258015569174240165480414125371677424,10868295530567044229335194831040844568009147685116142210106641297004156538558412533657681073182150175046797611854923311582867464981807549872425/10033216046418502705535152326227462395836780113413738513235010577988769898968149191529613702247193578437849486183557754372279846470309844369064,1296277878874158775116984043979750155207354187607567807676677399774220765910286266443089534457088451160925434177620421241909993836218841900333/1196388108702907196356145216693923653270690951795585430900739291672839512541396016132226095991658064462249917678925383104167590646003968320218,9859301720046452669462454045855858131858784235357276616629612783165239330973875898469205105828050130230244329837995819542948638184644961028207/8414023565138789967394762232019907593604744759748127336410799629310259670753002156410673855983424783518999514673758734968536933051207738308272,776652753898329106148535041279182312353555179745875604557548094133883236978261092250148881270633868805286533298784621005619259211565113000261/628439035060560698117541269557535337178828465290873281333224288196129179550208447985061310125226079359127600419934834323646846168239204511984,677123412505888667777167505901159916766383945312464807751852988026961590864104982980781568932072318337891289128051426646056911551696286031951103/598317650966685542362388398109249553372353704498232124368400462239855914964244842530548735722373614808148608833871073667939315914965797938670528,318986800233442376863386324386366545109405241416500452789983273422759385860092770910766988481816626324600505455254170988806288774128561236057003/268859577486423249800756485565408977717467855334658417626166514286163190377452239612646816801610301206737946643618392366611480135729205796978112,27249109164096129378298391606479335980255173532602403404455859857323860876602356163756741367080492989176317754784525316570287135428616190482399/20756638300267739733111756863494317448643179621037523295776555195604094324566431683721382367516739190372559347622695218394056390209514173564096,69801499997178817595269929660326174419921716910339600923864229505277136395237542272801605391154702166573874017657847251464174390371611978880021/41049543596839263397889878018183230853044471312747364954740905170683864977908495612622557347544761502824922861044906021585465980822000329134592,9821107640777295228268770509651841398835043863778741583420688788379983758409879404385925149184257682587185394447222129847315184289116623554219/8803622798057688214401144487801709900399361178851241309230154127010167686746985570529023365086455894622787458486121979658514262356933642137596,69693801495487765980313465726164790376495612404343232931969864276515256304117183459265969790678554121317821534007839182816564756006913906078579/61448861602730427728835696499230929331895092876793440416732342509084493751809043269215517044012260857094794656421882025543494601337075310877288,365745171232483124898011485258814014300111331818915971571328102108325345292587827326274904925602441902661544211005615711893152291185218721818933/274591706280002089599302462822979182256753982317689670440881913552178731445354374544666843966584291354018084679264463355688013577056473285071456,116662380911463324242505764821354605310032187645677413061108632604678891476683432390551025259736897281226352409507404790574892244628486187950635/88631958878402149701649973299953776707396227076810981029335155017587394876806614689963873459145806064902413855047707715207077660286624759668368,420368974560427035903865468502652486689572074144517147721342348699229449967106631245622843062015279870884043957054995052912418600726237503635409/372764724415082659852639978327965605505697615124144668370370051029627732736599578926701665833599308533947219686165373447806365520628495334906208,10337589932126313279959159834141394265638757132786185013260166924602756672802339340486340598964097150511521274677449336969900710996532502872723/9306053141447709128406441208673078684170718906447149604780764277840993538052933700316048124884488825930881940504611564880966084417467137540752,14370089730350923531181018217906353546069508788487867459453876050792299962716972390290025610376042280867662181374578828216598344892174792230841/13134791319947322426631668778180038990968962144823380143300131723598915675800379866695739530275292763050584798969546845234411446312650975044004,28805654865877429705825763253617656477753884138813703199289340027215222731918054558150452855696888021311205704992714654099363159598964671731019/26153882329163772069767756258437032737963203610430677258046877436442163141133928039172567050142802505932253397916575794506831738255464622785216,3451531215011919915487840746817898479547743386344762490546759177751168569883921467067453239258230512326990231945779741010407309038736355439273/3061782873210481069485355259831867111628407057997697463802548223955401428512246338774214043121652718122799746738213960719311980101878193699519,104027858147756084025450024146840820919001985530965407085676828991350133685772835261015956355514601599634690468893982309592012232149917586085983/89746290961073795319127951736956094388090873627379767061975542364008089221076868774309204566803156514452269715264824984704170815906980320656412,38317232920867305139913992739847598624294742083310956486028540552828086709076105926066774519028980710782593781923484681837431434882795620504067/33876233077509723164797889655812533394309040613390747696188557571127883297749792178822955202551231459299164942587526269530912902855082835820214,3107540852004915319821881818549246218456735432226976432057504445519828314733686218725319223087999378100432389287409636357035892567561103195613/2786137707195903095563002570495266680901483125734164178694725926111521353808170313672314844894583380774082931410898817882728344310854904229174,788265433476149000025776046864505468953888521484306766862037918145771055957203150783295161140593391378676050411009081478312002314537808835695/1872624786130979579859292732624999581481895068772320543907868129379938801142691300623487424654860457007259136448363559489157881201777371328,46035563933233208230708787764140494274413511184928583732824868397297283827088960327280090460054069864029194359538398066662380229127064719651811/5894768421550747151054753224724430169023898023615277133179361875280713360619427976922797530184368484559995493031943144634707647770918542498732,20409947555023457102204780935524409330745919972690780917013707717794021102293212308098812253119452341415255386457008981530070789576880314154611/19898877023532105638609276523724204263902474197088609289551351950738809380316881424643727632349949059637771373112182549526856722736142650695596,13402055428251877697145897231392576330918608952018820296792314450957648160148773070635858591627529306855447167783100414829540484304932255432383/957452081702286699481288132536940739465773498433694372092371805362520130295972734928230203457913820151011065251022272990063631037815944290768,1978478521505780510520915623964380037035692870307924743198131600192325417627583332360559098037095765735021040550647039748780835011950909715951/1870487552427963228655196988248780055206465900411975123452760203036540159816873517980258659952085264483763081181258044489578883981801778602184,9934583030525980359254737053922895752032532236359063155646108158327329135007914719547183306614282539747899605993502912659446839463966952846975/560259723632575568273853332739294045589244457637468990243272324595727480210388784079739304522112425599707921603261294666001984223802843417872,575251766791150516867843345881243176159070190415015258864494287086436064208595509803901995084378618186144831620693587923992996453506245338041/43065408374651977026424408092479007131365613756953743960007389598087732745963825158152797128111941257709082806983594729035852319438926122988,4788786143086819777075285607514915409019044938090630883471562012498943876036111116596993185559878161464331003435941224667715615284201909543379/278683379005011005883687834437707072386795201106972422977972039246541364012968316036663999976259875655098821595983707362132764393248133766752,6764572415798293894252757790693837013029649586023877627887790434172621320920108448978173011259688974329030285094016069750787874117920510692895/5525126192480036047527339616766177364296357534586930073501025906073286172203798289375657701548502366291006912275291483886960083310112471271252,811880471768452133752062707069609126314331058196888472239170734919372060863013520512854390101698691716198430832011997657961656305527351026069/497228470374884912573612216220209849085904435885963165636414851363500453904034821761291069227301698747577249270166611936587018550310044871348,1065470052124178853973332296703635066504140662774215936019386388608329391077435541282569420234401051301224574622672538372516454161369400903783/358899267351408573379862398837221364572945593586188205874366971259581411035501198730821458577380423625865726734224422075168614169693356096640,-106711073562024427942731525557586991677199168549203525109056700362390596633840890795290649280533076085904857773527007965542559171056036929647/39912054619004220090990123678321765507971958377895379762930856122155295346124925630138518939821622214697267842708667954048141817800940776844,-8651565440864112186179831712877549766509394273300229205294825400225683414066091981316256821521324441134332208791197265721100582941835962475/2390205895316641859323390576209913553889384125290541438779909780955457954266823265651630674437783274913790856365426680802839598182852891356,-1548675306829101526591227536514668726067340134066011849828993659907374699169686373971030587729526458472897246804895035764674180911471080527/214771469011801598641955390893219917221461924537336825252721957573619753494346455711000786730253986356883114987741314026968741187689642414,-51019405566413762703699053123813819757696585083689953070901312479775147548424717852591888951927439467856500046622348537502881491074939823461/9831709857877074696702003247632110806708072857452094438010151690566202159377580386576784189659451607200893061954891776324855368769331556625,-203737223535009345258650191288739849727133057295871849937593939056777843660697905041488508919499150916965726646494984499632028470456622728041/15408892888723307587889929896251741928630970856507248666028034360803647120785134050923797995149519894848613642516120931558213465207967953024,-197565894819952839506145436593156217593950968546916606023298466636168327766189907763997031272367581623889398188317959400011370261594695244757/24354720615966671853406214564363651105166988533668032613807926255644553497998672132814736915242300434358829493253103466252584902043119724264,-42747397969179438668267327784442292613715442764798395490570771738734483255763300765913124032577012073833541250915154628920622895712465210335/3149020195865263756960336576631744198695073636538263512363217658257129679454458197803686838354272369614497654335764742981193274613503377144,-5933497816914975246758220535896302436538237135738884451508918868575108122141475792398220219167612139694760632988163983010591140583248300933/1938173487280258201193673316284933908392388134942395015587469602556499781641521084550699214162057903181884272633437284265790091577580586499,1758068275850316212672635515044464358007300561992199668785901250981426329982963160924291940588722663784808793631814863266638975750219863120623/221741045442238748199527449646790343805290892875512502956776837439963085277053284050972181200936976587727310692924684454972349154719409742674,127299737918098017969561505521029673773381430078532011547631758896366359942239478857920058762577000084894563519617167528770663551979205716486/32730881638743912135182113686914392195334447684933487056968649984297157814157533437822969631453159141752683687065909611037614575166808218309,10564308369772428123054920304544583766913621218232891416494729557560424691584546341200982582981385122299009643626023432478128754210549882740384/7367329828243302568655483477622484190504375340585665143713354290016714305566149429019652092171338949281606236141695211825240876538793039398027,1896999007137011092509471532724498227188695194943811109486498934571400359383377761312503809267388394682481894906927086828387645027262676873588163/1307242702325361550210537827277096607806666733648014365703369786670604051059307619934380654353976210419372717402125866683273492437948522212976992,27719650612095049883476475853050850477761978207316241542448093981394276229009163516782995265692609476505714554353044953103819475460910579461655/18986859668580660389798281033909486856069766233599673014052956468326346114423793088733697384199099790866608637769162800098580798872837132658336,197353803561718391512988384368800759341404315537894956701067254202518023990360805236754185928720941883454553045170471439622881404040739904166486/169940321842266570859990221953265694860042317322607767320355545656510117643941573771748412169599701011424159090065799159857074349122874264087653,88423004503202780439263291064528840895789743946076813198708189747354933981879825360372246441056891797402128972074080405440360738392299180450925/76169679282906613939327733360910326611768735238214024496018504676976914384783075059002427734184077724735442095617118681907613239007192354451049,272745336870628000012407127613114768780445442215114215135496141711802275727970177567159213389014918405639005818333158708375745801630677894969972/235909206088905284652279165343159369079234150222284563298282992772508475541797012845614896876075333244849084379418423375604081261322765711105909,19947690145805328809005765579465181385679818393074127659527986432133703055371840008444855822612706560331239956577610184398257472016619217456/14424973088607352381389288085679002963259229257206323769304938148474782606930653201605322120287857095794707477010856303640897743337079486641,567526229452633066166712623244336606899779063873437480457813705583296159913816093921507039049684277233775927145015255407340690489804087068379/404802695377259696489739348115798205522785541722565512539098473364153778755308257137274498219146383473374791314538192451364875689934837446444,1031699208660747554345790520353967030801088011457379339710161245039302487183484235532223544330310198335361753516213474269831258464068423997179/720040491378189768514808704986113368104115712226493506833268664687225420549477497273896515667310370320245983833443212520663585421885666069916,8019420122058337948136515527925156561603438703881319761451739875062282176088786987377399285905181299512721584658874029890406227390879551004889/5526241048882104028701779963022628873579321747372721629708567147703186061269630254714142862627777478798681401633591541255248211305692663625522,442491177408144672589429653085434340874693644149347969223936842285463563818011072956215809065414037902333269185246782016682237668775465426233/295750694071393884273004512299766996692653738730708976121998212880075367141312743033867338340627961892223177332841531983546544780863167295974,134981407246737352578012632615641620307564926004941107594301914559024948749654894316015025309155395955237824029627738137560827689322567266545/86303789554563408479126267003405523613325283360058678743652196544716291757055068351528858727027602411093218731968887015470565339871950069678,131665634085389888334953670355700279039159439266347124533572731269872326290672611081431814825669245918034532121073402998520774389006939650007199/90166844329207718099399680415040987088035721643416103412842226389400969492810246645476034599588848948432711889981663660781476304375832706542688,3761803969616615195985887846029427527146760714337945829107712098680263718633560633567801526961756017006088355930888468325346116988943904843455/2309354988476101194770957203176380638435913026602056208989107590141485080761414936052406413518567664959599481006089206311833969742765334659488,829533896123811217715247614505015155070483906284600270621092269613687160775248539266766005104764392227023444622322229463633350750225740217168/560656828806118911449780238544305145134621169255766175353554807619647744633070819925243741428362973833844507475866534498838272621516309766441,11335376431563177932856715577655993017742649067713655251160520139143150515184019339419757196490667105010911531838851089123409232683900055281348/7915769771917219752941471062128716543437528847858597010090180482905017833203004612964012155643527207991363944598276591743535210663347558392873,607661647498938901087971900506771974484046124078919294683719990965719783850029324849944498997020776180305663733809417059457973791318265280116/241511239099209785601075636328456075887586509874489931193350368137692696574321640851805179077371976036115200362282234532863842097528061439581,772939707879898176750391940400426505695902997611978876815134612450878885302484114696937419501144208739653156957897702925461723389371761790024/409075726972193773781960417516263495618273433801784899094785660123013577833745794276511751851090488076903313257160982234247538993296970094029,44613884597988329745718896400165852391776847956386116620962535607205665182900340585908652990493416583820337475364353722108244399701547447488019/13445303176235439926084975045456311078610802059118296547155969227827054741504265634692972371525679819272143100612882448491148511004882820130272,12638940543701846749388054288061240964215937498994490886449474357885865623758554454052480478600413418663717841840447934158163940122538973784093/4539938758551556156635050990606862921585877355959943553569192011027150850362362246739319016867296124790603640131828557351535872382086219600416,1501022744147355958387138021979677991125631918887719543846622337292854319426045806886730790473872658692469669722326351363062648240158729421700/1036651282955134031430865230732173251636177031864078664617598251990662875526020122250511594775799184888831032460191867401506492201211612838201,554742416065045422836054030511866133841172491592340584050347312434909590807263789538381489459793299069208928119959286840966127881742019856485/310037252631994005910001675804591530445449259960060343653567137396383898271849513229200962966780889312640885301396631095054871465416089039328,688007978730174670524169743492802000380571016908338068810083659468120427432219585497610541485704044356355372707271581674374359098656009211327/392539334382150441995958976564937405326522613708446784135881470339762571179427338082381227489008313855839907815185109965158478826234291509276,20759866303749455107226691796366131894928885795121959691016498711753760391828540839372061744415317307343875713537135902559219628514396944218018/17617203139278102987296383205843167470722044071485503618693934529793401868497064638611986833144186369886477781967922770745162461657759573986463,32823515659478739344645115528818452776341426488735015637839943640378012110188201080357073279521634887703156682918351157629359798717670860227642/25314831000874155100647585480481613434273156717220329021387367772209672339002069427250362440804164860009325086962084991918156619877892028316105,3727269565685659603899481171557790093191532138488401451138683605170775701265390956736270826904204529070680105657283093495106079813380958052268/2702239977019587622414371610736575863435358317301525101746444411812531390340477025024300331688681292515546159748210275598634325262599615691929,383256156541809868041130482530318315900219834720779474774907092161314898623188848114436667008592040767967287326162208714489958370070581891807829/213521773048971545954332326343698984284611039592426099888447938599875968660992995990717545616760422227502014692330445992533868402927827909453472,81921440333843189565723038183430873515925275530169867856172637490070545184370590165587577772990766848698062054947585675516661274031301548831942/56470230219575680624295826795535827050486451645144973866388980151319648300820251550534145203042418919167317033550544174164953384072733853724789,42567816426240100072609550265103206487670870372585401847332815821066533106052280267962680615967116386447630219932372053917161745018224265170291/17704777152958911533860043793727752029136389656971928314434654088707804193562960735937404666452839044292831589382593758212684740720531531221408,254082669464775338764390335645002844771134703294963879302517645493852392159197183687507658793500117158807430022000521240878805281984607481782874/115031346536282580594932693242084392966591007128192831492839814411294549486346643616737664838621311933651602955980081730749990782521302043852467,1707583516322498569290776190910201478436393180691392075922873897029369644896672534856453713167152032940061936071775830476830533109894946583615/519365265250651589114920062675651610969774469977756927517945759672681647662587540893245530639359231713207531010855626484684544244356559697056,7617707842368236716787843593793484182789787488372025421792148605938486197342897048310878614155337875934159034932292573250808414903639356945911/3977902495297626427046078909516663649868292812022214345763668612501475441428453130977793639760103346157021845608375349710562713079316143166368,39174737426057411323502745071942794367239729742620612961300802283074707331994999906203142664166858190770207580828503846271244006005521360100487/7006410409540998293641974789970708859363172918922954196093819856975230285464052361329782002446820608107702143645236214493626983847785431613216,315718739506273073869439409553230543834247319050091419536011024007668143774107791536277852998363526239274203554397640480874564984452579308662323/98251065665466760564910457506522762842310970789621725220272540151646978409346449235732332038882644101541466743165970272368426166607113592608224,72655897171257851215472589443556972033238907016429922515404171979231222050244612686292098140422928832561638060996906699647920835116847888301213/5407872663937193836053670824905181860422599259431875599633165531745950214264167032870871252646057895085052207906487216163594389567822380047392,32922684256452016541060591820360490724116803966481963145864812938670061018051361493028083595546788070212771176931967694466614788536017986187/16857004036642101165456595119203189369227504449985637820248789536260297878151057446440577272436006405995867548555034587979396206339565627264,10280074147496621367485015803581134994253109763396195911376556759094959280270288838243244670038380563725751972889756773178868311869523048411477/1083545329086175851933744849355659015376189495407477670631586127068203278045178257910044996701170249165439315181486362379766987888333998890272,46163465402394034480678911750986306189905617157033195964926547041999767876406340700367877032115698526944314875281956165611984884807228791990478/10444533386301524973448658458644901267945188187261176204883738148813873216434285108305349541419308527006449726311128229072035763699024750370289,7708768046574399980285300879868076605551270437924094327107394593940654800103822442660828557346086180499387686793215957295215990000867115246372/150738539083035908321597544631568035964635333043019705968302894577806792915386600426873470325727348347515957713770108556812650881117103660011,42942049048716699093527951003786708594950063564718347260041516268140552658319404827401770611630944329244914085093887830463645220140270016012706/9451796955374159617993412218714379226724022366845006154057517340280201569635387858395718867247520308249183873645970570673035280099302584869667,-3284524323228618964152449055440676769281690881699762884646845561586614687099250713540389104474711744027200567171913135959231305827828709272296351/2294992672860039755888550979570931398481241625471929272336328224620939229178118409950593432595416082005824781283114223586982244698867483320148560,-69740076655703159510116733543929276036226214524091830227308858252090246861715415242591943309136707016745677340412267566081025855362805092077465/73835275777689085552712945984464128548815201645518559961349951257117995955795779679082695596771020009049419875974024748033312008974721688813692,-65183341279333904120003841752640450449276620225713207795737284401748973637206745773882923776170438368265292135745820318754434742593247116555/2424428917778400282297880388442193626929463094699643609895488464088246658683336224783924130116275749244765162300632168591893782269408976684914,162003794966213419460422443110879228922717646211623235662076746640166987474697960231398832511270338454392209374023278823753282374414272507317/1485635399027104362188109181054120420349809635380867690846138660966129249684688705410578305941828000678727557498955552604922288167036107859140,-936800784386721014845061708545312978542511912755377870598984263644883948110435639190620903049992957578994348353447387538896278203780169803871/217299687023391630559895561369344612128114662824133128619516312054408369670592659396972564777301014458097340429586109513575146614549257517632,-6761404791523679230097874963020345624329815376043440372698412925321987772565048910910559807004465840842975809803852555928265810710481156012113/1375069304136826483285209504785874135504562070228430673372904289654568925592339437578691406722367664410844302830823592997219185540453273403236,-1153133056677045466175802466713294379244166918301039664385416896426796408066800602817896034103017987728884324870856191719968213314117666112845/360883181044241359299487091135352241916802186256631029448180872979473653516913688983027121864702632176941196837307449559807061417786953687068,-67660478803967326211484721479707535879870662862835104020933535107868665590622250747209584072152583312743471860875564732893899908035298000990193/18318324354664912192590373327469250025434030219492039466666016308969968683093636505519108341912099444104479417091252800188341556152837267261388,-9165315591078035744948412569654375772069906586903093125611930956439474093685359934702287885013928031959689502605725238934265669926358478338326475/9035602222263864837890395816076955956631769563152680759772216652150505345638866617452189843164950446695676210608324903791246532597421731405099668,264144316012654072037036032101179738510114414675887788651627141632048922564117272081128563185913418679639199770429740457207535427063584639727943/420634434044389005002735626856131109864860817154571155269082536204984676072007598121258183844713702744024951473150949452028031626085463126879756,32853540267005550267429749794283524601264900763578480301123621093583880944039130552639742159241936008999766065948042443494052608296986458116535/77764530778157196689550598340517483748860721849630343795604868390159896517484217756657143086610056030443427313009816262240737741766901026228572,369075394863705307713981876209458701483742907831027409661485144473991914688586128579370470189442222690086791678072709779113878138983432994200/713090499953476046738667194056915458364826029928043890070856674366026298504953735839275963928288517159438436553951754140131173190956435967039,45695171668167556771429240699867455393374216078578292228802990584877687798235208434991193583456302526624432268152709959479173079953411410787669/52153069516032483157117527945286167629109954921260583409867268101471516573746844670010982924994903085222569648662431527118397893236809004728708,-2789659726249438520422331224124477568558224065946341998207702364728876332543251907640453965294263026066160016326111292904394729438625069120145/896743149753009422059769044792128066173816863299148086877507371815648052645807127372142891308354491175451419858521934854887066466663876474316,-3730919624609775319928052369927324326508517316561850648942792252431421212917899995803905730400266316543274003661859777966475025055916449109/469954447539594914963317886322719416470422637146141426340297081003796609737206244129656365930088979648709607137911991578081046928906686013768,-172996954761217969992719106017678195048897284675109989215861550761947555407060419987667279157745660291503937590574760730837988166321027699943/106064147795948573125853425815054372374195387495808395752490645035080480251231840487961714413841396431438457539711088213998809160689108812996,-1332225336223761143757730055756084097213409171871013076105854790530363096535107690114063991676593709206420480158988630458431688013449497655889/391833513638921241084274522074013799172552850785745438008529398112505573006057374425451925086214600816771535914842625576159346887121890394396,-69772397076752746072208710980481041292393051339740701017189972803461495339572101780360875047214853521724214800834552694693420969854940709097/3504145091536768481943930948007162624987329495452377208688171499613341872121276191677338876805658871220857269881010754802633104441912198301092,-1198274572274126777079754175415630399685067092980406959209612274747472824678092945739201130012759576886566780381463742240614740595307498563029/153283539693396041475450485617543232285157851103976077414545723758544208962535076642952073602454081948983227897878808876424745912567390071756,-171160866343653945560432297657228251170896886940295797033188850102611311152959562272582743865458401343870684566718022668024891077844590766037/47616920016964379953476249011495324411785048834854736620452759312325659929643860784872943545911893159847624205622801023109513046644271207148,-4416647921713561479448016905512623423288475176336521570816871472706723845528335094397925904172754885828189756003003386648657860202387840345474797/1094300744040175485417172826316478357386064277344475074468633637541480295925105214737059729729033831587533786193947006803601391495879517843969316,-47807391187524020220361135309705255284990618935727945140259081080659847144306891460664130643505285894223387148254908741643364966720584986247/1439236063445550398320804142444281800659378874506440246254133706069959562890115212695993149612724203435287509644436517802278720608586201420996,-6361836241251124259165825851283829817872538135615863472698554049523612648496913402576256281890190371211881210226682144907558364049654346971/160789449672181475892479548162844643511861609671499785261688128724074608761526126809979611202318069062603083357576052826545911476897283142643,-305154571513359255334703025709939884732595138819233725907845671710174588980058726330898777821969574802911670177654865544855396842692170425229/94510204564879695033536836814416429982092901656015173936568753993125425177921426582769012532512404054317123138797434330755558210160019797420,-102027886835169929954787775173030824502063562039259043995806156654046623916127175546524802085177955678069375539061297797057766520279335501798563/5223280158148706751168696604790107078406950197686145479048222765371919489008139955509319288905112052895730574000542245328856475093993761324134,-2726336229679017741360605085498822884471941566783269868394638329850754229505505718698299606991771634743612971214185596761178747488624595496201/216250443912900035065347978815105604939007111813462613518432169355913901336159426813473259951483218558667689726202361449787368563416803855098,-1448130541951359800393819641542477608366506241369472846107016835548485569500067146971144448413938444637037529744964323826430854036231317004075/62956736188908932880523746896748367366116211290497755417512111872722842617671465469715190504951533879281654475181153784903552545539955049028,-7524434528567645009312432837618773044655591715669424105751919463381676418605653624222910164757589488616226136519818874599499210548554172359/2749634735551497039156352387185993498523876829134879349160448627522472040802179549527716987796316926841935903822647285616426444879639567804,26065176154249470494567610804522773543655775152050189996116660385309707685017504852885825217109859872708521708056448809643806581722201581161/1599868990455796366700681876772688219649031737511874401429087563347516668770678854288166528521785639675681867387031341299423479278385370453876,241404929404323735472706508398976055675754903610248856491478993433352699116512672237184168437325524320403742877599846605892033652266482415016/168653295086819606487527718714329559767551294990482270476195847440597494259528767798868373159170142017461512898619623143843853814618205495411,140047451527294913911628062706679332374874974591861202447150335947932928975840977918693083150980721801435673360449470040578319357590241344596/113093418734910844705199736711696216723538919592021197360868414671721594586481160969904460481971539163827415735213150323318927736774633087443,513191538164789497222510670112794312799054966815446328463001338150050109473363401478894115490579363340061133593382307052437578643150888074699/796834592621288369449234717285467940501224888043686338262286474059082758404128926750089991720298054837555774176448627613362458836004195930710,209957320126821301950238585204902481399295533257844696064544477678177277551073967900629749082259971625694915731561638989580936347106148520059/169231316254833541842751719181075281142204497818812219853315032317054619201012074806888718043851282280459951539031207105064525694493914102562,12121839496691710850181959849907164342246666685371547224342413972673332277600266625459820859670971993881432307672746105197936513353269691534/9599564088307566339745722886359903447049600834058292574821208271410223745616270750697919302949868332521448819479253301549472427847167334497,64736882471541677724443039167596467274934472773256258038261405525137456291801286515826689650040538227629701019024586335487111902907919517315/51434203008383341285845297382454327806226366799297237346007768011197899412817490857070180273058620511659518437772908075206771489402946294307,475947616549297887017324160945359587813502614541935142111821139623938062959988479515981756669631832994016506838977843931482833275500826200973/147843063290684068288094347889181993257296423209133426267829336966075357291518171303049460677955464380990086739864800007196859393672264150420,1376854694352048068340973211605746382352862429786320354417010709762137266110747505991113525901714634663025773997886461520678393194343780998691/1174201688077732018819749936707779288143639101690023513689260635330820547724428292749917361565314678985164433386477985504282672491567724147544,5027334716563152475013147425092431085552907744257449543761725814108442929107853100997019503797395844529125953294531163200490420954652416081103/8628861361405309815158613514486753979915770329432555584378652871421390555642317599524041494685794455531708369442611303257779995156944878170396,184324080955388027968007354864329323918234941683732036672179314344723925582572166576029320918671202609301869810594965261938359636255165038723/365968956733397221263875839484496527713514041291325177274040879951374309100951395584056264035948149201217393449551394912567213888342847492812,21447676303361981563735833083630965952519770004287729141717547441212504499878540819240751582026402458638261570683032736521445273526028121315103/11216694566280218118616226637592504090044813050696818961998473843918392109052936329665887226724099840712635604966790582067047504588921102457892,660367815218482096714671567440208913987098856521542407710658106684335306377032788639651551602279652313734910244715906342431300681400025836331/145568008942095811210845996289209300892558261768785237113295772917369443568435492086264913815171473524518595137639264149347019673869403908756,-3793402603251207937302470213079879453678936797372641743452021255936910831399042198959555207988093373881114023382493577937867800586200057133/1246028682336154501632344980822928405676168357245484532576367678823457554179441584809478141026275120386367629286472850360746628368298374931,-8578653131515097765213710823356848725460615673301332123378302666796061003620859918471128513355431219480666411176949303132191750824235003652375/389673517484970110593650426662122193779364696095411104783653760606265435182418201390671833041691196180479199469455487470485566680488106485718,-10044014756450413838025221777649381077749776885049983808341922395547575275175953817448036925102885893910597513659929966892674358154103633474431/1739081188396306550316585229147814485843428534628795148599796504251825167679816936537000444390060948189066120911006557100426872390366922779776,-7816260462133817216319966713014909950048986116734528729944223618443687211353637529749020376875394406903280984162237457910418444528251635558003/24730567072901705616113960397682865356173800444111253211214191615086308876667298647992390810408209273644300211199757867492237794823866871596,-4272554784068098109303448835862969117865868144898432192802360925405151254715684313601074664151333336272672506249782978939524784387028595401261/2162368272078213829027342060786867279759572440124761976153881958666861537837116068592449678258442470356023878854541111388995148597892106432748,148657916356831176146980798693086864713398432983247646460289327559946540319841488378460394459017210063270530271756001605946167341948428438434/36299904212168498871488845930102451063381732747860016711689501664434941416463418991196868320488046679865838026571302675396643357219723496817,459263318324639415262518727243676704699021938915426751594850840458004480766620726702879677707465709507218158916528329811954717083402164265179/62144502969095151884177659439367475735868920114560749188398617045671572670607849236221619983836047907513125304746149816524569523402794892360,-144607468282177632742726924025642031684013023589105942937337350298380551012500462259248640229541398891921081564074965117382602129466450282513375/16599059016414448367252012159509726907153674897164269962883015522671088016180684658873920070907450352172919463566839317838287383499484757012612,-16777962542528902749583780700886097682979921240164492210701823429353503675910280534634286634087298366613476703221465274866939965259232240473059/2083037169502380616348795173847677991210657713749462586961474300229310088017100185555667504643922418318546250145885649705291236481266637003060,-17357973863007637901660445918198265269975222844738100303792768456415711116465543568542609328416743922860467794650513511300429526805287151284979/1922546321701985315686017835329663184407724684488115285902747793033419306588849932204926031900626437978931500850507060777461938415126149959412,-11797779601487078847780430772243324636631451351775868392694052815934457486727442204542693660887784183109435228512596485958848666458928396031447/616669066304680692603513295471042203087956099045254267540896812114304739943557347302253323914354022532814361106448327243288963711714460744564,-20749525478202489754955341724395446192456054827097182793680024046502912079330025546123108699332174703426424740997433339564471729322788687506475/188798231231052437481874562943658240503197808480974932665322911390993845323281043891756159804426455546597581035955746203489062825427681551452,-6800386099006519333223565784073804908728711178404909419747748877756698577801333911305048385457064430676820975109865925544541213417485090090355/1922374105740996804962810516489860772711224042483367398675716573886040227681228662902033254188216318100001419854389849841208630624544061575912,-3038139978632782133483769762011210105540813143150185419210544197181916088760762303054752819349809519104544802682139890805604091919363365851409/2503347776169247534639973528404404472807304484720254158966189347179857006007740713956444411126711178189565825203947681861295055159215401645268,-4913041774134838806643450346437390786601308566475426346691930989247368413343629455819228575935759622188993237867794442338363840221290810201357/4252108923307094695414481966663910125969950565526241676427247838250062813027813292952438759384518776171978477740652755543136298923679134178588,-15285490543439078076824918677252451035579314739673834448161226482287783106545752561789717914950036188784036278778824154823460652736712561121027/1476729007772216821406494545588142055999625310168297936886882485095800144576782339715295340596823851587142665010678798729247510613432141881148,-20878936194805291675729773667561435471976102415166527070607833828719654399373236675694244451382205212285234739637874367933193174083217734892539/1525733216370788375422556427910255437599077885550485743030564454341987185822056395299788832157834213564200570051164738226849749834079360925212,-2881015343519907553906816326352862137826629879027673021094303990728985109875217140751413816261554798434778643180233318155513199932575415375561/369021351682531351655765109235723321396617103087438745156412000087438816061790849673579179983942819717452944225279025999439169218906368620122,-26111468341339371260483035840043753641397428428663005114941741034525175679755940122833119347919845221320000505731495118270838064462342082138621/3321597468706432178185435216227493114261405158936171793226051496960418390522070543314881402086599792973975903895151583620736591235517044640156,-18066638823081752583090320182201448060950307252584371594829119972271336608588781446213695161985706305432395473311995954010299809846876156295691/336005148438312246104353043048398619554085910552193210451135624606786255131300166542548492174753247309293195940301079786835920065189881250268,-3432417417711238947028159367150536988585899085606120341647821613765247164727674044352349000722292044545781855635920200388676757649456013828521/411589216222352236326670064583869577798843091716510416173353877244904166635912689354006485717222695658918887156412443897205686877674441906364,-38376423230710789310848739376437188307814372393016957264597419793380769223703352783446002820342445216987673905301401479023934636168392000906915/4947359859313310150263906178941836265619191940894326192946821218487367985525183636307387976069468542821370899207933945509149343775410967499708,-8230811854623613603793428612392098610974420004012668062960372355902463452143370691663561017966211509011543121323486386799081432084863432209519/806829559645354540433191145301550083982235847192870767724928058118825747833162673936307621095057732078060443132902673156739368399370251845428,-133012103631443234998486995967454158895928964612678867812142372393373320702652137236849675079975664245462712053692822762400537269687622636979249/17769466930834059017920743696699062945828282033601666121834810166846052434005011098815823470471878399821207941948737366936862791113942618308596,-1042965635000639288417287706527310645047161040677801913192983453584316784146385531315079714103933310486743403597997350981823387056619317321/59451731894317882030527761669435970210986695692490528420907729543332082342417194277069025883543518170510678255658508496953094314670328817,-107532685944142960689490395082604121814843453210967841570996862629460475440070733512630345738236839985523206059316718660205924652553333804419961/12154342638699420433109328683954013127872120126534861767722104162464300568371450713859648562601337259508016640995167202765593294294566580027412,-34502807910577443787712534174686706348613921094230293381224543907905887299153583937468022904219351164646886699459673161180286487441341977761191/1053861902943369741901411665581753464402550826591987259891504375959056522561766715907367729722974745313624820216080438890161119636818366914500,-174508924309588381700597223267263936565193603627998361976219011952805450717199818819688923755650047617211739086243110321935040965179155513847697/17927285583249048329708227443749498209312250845113669214100335429853422344203816909883730862977837612220448492921843240503790304361941598817052,-193687520454654201746610921815516547437479541997968121540391576845087625035516821269532527504506943277127063655356390121462834313504220966951951/11614163092036078830759791600070524221084424062691976056595778105667808780272286678890165329741234837171826636106826463349620515278058899926836,-12078335017855424505515256829589548589158831733292341038008404065665543667478855920065301462777152933607663828984187990297295786788524433217999/1055613123123695417129686862588210807280616684454158043326975807581633031413933890067667019669785907123583520221596297612123200229585401907117,-188877811088370539650961037919085252382613008480184598580946111816752233063941373338937728205110844888272026597079381864304643328480465960679443/26023915906017859389008410508141472934540103822873857010929817888803032241168519970160131263023077483354169105722433988680142160320335800208348,-86903526157629726443689068640506669972379491747248694496771665437878959922197518033236455625693120346761778437522833279408985770607065341352513/200134589046397478160444668289215836108701825435215766600539158006528612264039146794153681785469892833239209132668928669086977389604558764844,-2726479310256296732618521644922190526090668974720270550894829134932536374467942524952119378979373227546968080983961257040500961532625874505091/241751272909457192173012497792586008056595588155543941307698769235073966400266295133221747483981543476890202512228060241135086186065458387268,-44633584423625972644090401563181640951770172220457361143557123815802458771943725430666459265561794920245831549207480147691414363712026512272881/815995118493900203837130194215095394612353620537230127717133957297541843226047440511742118828113161025616074387986244802801747368384046842452,-923954720911631574792058016390556151599778673978762938618600884516786069112652110843017797716272822096192417523312166555016837788038826238125/352815534339534722328988487886441232817664353591510624582965379322148460774961188612449633860789288837830492551962233939057910274717639447687,4760085546039960930981012767089429687579073744102490886196644677903989162482914334592432014560375746043705765956887438130659151373018577497685/12903457983763591598767116261389460488957818105134759943621728158233926895171226095243164253217848482579334945195162070690047335908621092771,3902950841614014203833553323072074532315837507600564173113065348133083321786443532055993792939195808735777919633924424835180459726130829527889/50901214398028320135406237121480996505980851307822372001798772375830378895908538206952068902845146655705796314096078218520974902574824400297,12031889821867406401799013585950273143619821008723366567222316691810993318726168648094076440740606577954494384940323659332454035558667373122275/33789115090623646241884407936239655874783315884202404015818161042553697825221460901392584724606464117033933530533950839542104333484379622077,3621179130565041282499596330543469964433455624071543284785189096790178205632752869355307437963664707036162687815139173084513518528876954194815/94367480655558572987597757289053298877492904783845379075487169711042564655896593049469294143967820941281408885033892797030382125201789722418,50346634736407063011390819798655486105154369442833133100167744074749125645834746693005978210281924013093240860229428768035587005053189272109417/48749717015091109168613436137277329927563000750502426998754818898485067475290819335700893450024271237295779605941421318133679639722974982315436,36325549662879707928594116405756903821344054700084836779103127629159189844712185297887976140726460280537303842877595385089833553144404346393295/10930610887224550012341720317998524715695933547420661503866930506907273056791742811563491531583750448918343656860484032411623320353231469284196,3477905121700380480927641844425475343944451492541380836486385997681432973399375318199585024044527513931025667431249962382423921456876049229831/531006296032950685361050618991840000595141741145939126719104716280716159387194128563606679482472730049515833845373439076595913523453934848120,3822723104847801592395040993136608181146560398847072177366089795765042961866777861639978216370343590547428217439462261164665763050925096134429/239840643326030331919902937954930119639964611381408736632431773993435939908604950907367745056578999868788701900891885444223316676348133936604,20649560463278495659183955724121224077142951822895361094073818964499769416240304958276893838352952546049226766623289096579947785737108623976783/906073881055576516249775406846477633379747007414245812451421667701445065549552562450354746663601442067174349850903878441311623752072550987940,8768742170301453924525510049405459801173436234314847377193162041582949891266082830884057072008972130377768898827670725201343336152859617833433/988816783346225416950641499566943344823287374421982725918980261164998031583201568092383777670787851381538893415646294683538896882863137798716,8724266915396752767877064048519269530971315506438709198879062559834024573926223689380238014159277677906219255169313182606729255872227061895641/471181240194943264436485144187331832835741224889142460696669128798960260625170311667569560591372733121419541840785358956318652594638931102780,429734681979221679746169395014376050776246330746284821494324923441588897761741089931589038266779151635421389518391657927973955942436771537479/9386412248016131965791841642246891417300622230745670521315704314232444172151728284242615817029766209679479134913203251685099139322663552060,21252878647776215135355527326534491394350298501239337504391093898799371944816267375850716391878859881653191389618801763177295776988776162761585/7473763043353643103973637628490783891461103130059415291649705612789690916060396154576640389292943375222112459757563983067025109295408987008191,23014383743391342466108247297236556862841953258456858319840968915541336324404840705273089873674871709805450085773599970217273100482342156765179/1063573373889805033298544310677976099713704432042713488071112428323871589749290741835832791995024252775773594764784855769204103104190863373724,92026303941524192665676635330613724645627429665001464302400514478375820688702620868110027921437943496863751109248964371332989885561705149172/315659051864642761306983115132316095632110779869130961375555866251241442095467394347974688218612544312496392858420449028729998728890282243,655419615142286065483640539554893811181914004079918457373407645721620675049528910664725385522250851380973879869315088521627640065331995204964/58480375858089060273353513187057644540566102636958713419347013485151318351731879212050642419339726397966730595629810251668791791230495939665,1917630969405264900222808651749233218894464777755739633272516067440840908169409580921085536983269052659403468673981834398282924133220377558579/1560822213938711037099752747521142353267586147804397960504638773682508492236642337613458580014656083424231396130662260553558838442566345183220,1998354903719077432290814684653286215277423281267670488262667074935537177729372760709544196627841629581429520298377329520540666039264897224336/527706482476365619900122765406805153198409482179406628123114651198471663907391197195332799377982724474638456380728918673508642662214253061317,230495136924894945002922815740524871388944803407094203586965009008232765106889647136402870366195688394581594213823274324770608716170470116012/21981787842543640345853055985594560584538858004446729683090243336644316862242938333299901468007918497241443306931250084204333857626839619701,19719604048513386891406026041993685151531595217318302022085440537415712178132970724592209504401247057554231893127204352939001350060534795129132/2121546387733230903660571062324025861886703164242221874245730934040593029934849718537735578912726694372008513383151803682372889985659844504469,31456289841453188683421032404191712157637718156671776717153621793482635877415737338241730505974148229132719955481087006760530443466820575498012/2011355276106377564611395365461707168814928884020375241274659261578875414427957772809375443718214113317305093145027748712972277497871436138943,2512958166606618408903294364848941006050386684852310895766954258169622445264249987687481184315317328921176694811356865751086983874924945446206/129112691897903040468734523478467958705384579619483674911331451040642979654042161225970030154621426838126949417797422866299247097598219968709,390117977096801338334510075420908960365252399103688030773715751899166442395998063580125510046184731612841868949953398963543966161698990328205661/36699750580402260885409534656159964367868110527166882782656084589021573369562658845764138224746997379187035714724025686967197649286391046465504,94683821059910037415719561795853455646122944988336147132718387773747436529582401381164465501084883796386303575292073613984379264749738360869781/12280495338245579628270412505215286456825552191944345924498521311874335758963481091248019435822207219901732751069413567790685525543150853042176,64460734991228090306521638799796760003582446176262326346769581507016857497687738557444076116419934123752459332972007665185320436234726466694756/22658182796958838339859052663821573686875091056251691422495504943839014016333921826830238678374403135420868172101722352310634373158938094533147,52054683181933229465941596825756602566278511998167909017730447722124437142253875116318651778608867415181477901885663827601675936876684597163816/18310316399163725945534887690700076722397661822014791492706892791304294013638555723016480996091426475377680543733303454430067505772077273732849,10732406810858772747542179635689215928307109208937705714137327190356817819225328033065967261824720831557859700427375945242012512926568538081867/1977164581152894619648588547819158916630931160960937414525273559800430999701973999063724010690526530354140987058648440179009249448726683456688,4591643176498618672303262381198924136309436024234417865209970900888320104405185455676183907877861679874213427484713709760874985889986093193801/16588106617021481067363921913634031182221883344882252729610103753349362884861971157523450967853096347277679610171283558119283289641308146476,1669472936210102107210549560601299494597729374588510619507810860247682634664107360091971844603064558869116380900884349900176201657364691862520/1460923797636494097510607587323089005623811885510024711069651379215653741485358301300540241790064157856750381089054644328168779508935404461741,3562318457113340823149866606323816494438167967048971890952067062457446549186274544564279671139690571492339129470136109966120828085785316811589/3192898041639709421353906246672678711338855847540194454856115270449776221872435843611642804385138451624174505107297046534593040838378546113768,272062153096722436054898829275151512746815135212580272371431240127472280792733176260222814368360898893774401545739288683311074666820404151536/73753486784869476001595526506074798962743781168108191222809271175049993326036017132064544923919169198434860143557409961420980722770938093187,-209605166653567317973162556627984873977842964823496527320105934655383754342928886648114180031551149210949583727208106370648172058920558851489/1136472908394740205210135014976795178688875537865527030490251006031855754062111038785218092601856637589977535026479445488878760343299059339448,2042674408336678793892164030308402680955330897245201630694266579778145133755459871340106697864574140293708648819892645107192667243127578830360/354439495181924910914453751655887993964730399766037044447571055388859656312484393844039097862070282314471817504711182706932676513087172074319,74415650522688173589078917855884729185962352961186197168315225095445194694078478465089343022272730033795614258582817085438887215081110198534671/10536664752477766601826826422159528098864191931030899496864757122883933407672795150843743391208087725912650962320772570057940279942452109539284,42286811685992005407249194278291604057995543486491662269586734711194683182378722415631160151193812954183486532784153703989752094209038523727635/8656469891747960791377622113301474521084051290640607445150743225394882014009159743863997827093174154625971463947709188500224274078041163674828,-2317715516007219326048489934827208406210622371487039417798146257550421732616617560757355796253160069105812148339759349378005597929897351095312/2895474799043733819780580188191306328078520764376814686597767055024828931055177684450360231696214550707174556865568510765809219488870591201573,401327216153581879838680778270633448342148181064460831914195386540340773080804463141514499578179264561810973704420673109198366676315027156848/163761130776031835300375258817819103585899120472890627565694391717705531085340669002142279214539638013326324240761722861113791698662325889779,814417530192291003780164265255750284457156133337912034826185519349194453721803072360347061006453116317315800341646742874040057311591164072432/383425428723993202058798905138965726436451214720848335777397509264857593847634582876896516427538761366356492883792660631412873058539731130411,165628659283441861853058115276805320466235596952923403715966258237347517353755524431052586318642655532838282323493684174442998829337618620784/83513753329805455354731594626196458671045436060160715925286903010330538585673156545281037932739986794505783616796667443438525659034061025807,1960073939313318067941163706966024409834271812174941687087369256949395660711693492745866860727645683835881297433584509181203743947924359060144/563423077369423858777442761776899570897581621015699107571487545735601524891113311747429879526982511319301148741788686079222407790578998052087,1105825531313762077480712858758815692106612831133898930461341431871753243421136485075735415593037393001813718758548905584213665864434674881987/330042294826543735063714135100339858319291454779867003816054693096057174348588710307627248577752100734815643056452298455942162540467490969504,81322103937199778207488253475460937766744890725971025828718696529388440500513784114858906708921647352359587364082681665893356000826109653103/138880814688861271539890551506244931033879642110726500320370228455708895695556500904795012619301301216414270886634907478557234915041394800896,-113945325781423145829142047408959249347799989849016604915990322764123485022518298665870169006231222920330884709567273082748320688326631952811/82207452374843703746045372615317368356147186574290268893882451858188281305046092719432674812716962651216064550059225911719613866581253346400,-210337177683332969286757202220899371118562106110282332207560287102414492291911037333455911646203559288403091495000902052354048750041484907817/178081628112198581641958572175298108361806889380228227303366141016700856689907376026368030580960899639960678168144320318799278388228728798868,-1862383797497424841161101701571942480146127528837765838786019036912676692349886487801819735766869361503932458172514215034955732055133408432/1182610968579770067391628238744209766107880350145047895541984139114016735200743691389300456531310592876146457823735368187990631320623287365,-214713959299233560197673518438906490819864896414690389765179776324180433523158766152555677355812920595580933333039957443404658965843001246879/113776307188308386915845211217050675914022306688299779621453396163602206028436318668962792522775840728471516299355097597978913500122729148336,-281179441590461229339504006139207697146353093266306159726097825060047968081189568781460063906358949607118872118992787193929173664557539775723/177238758026747396925220533955497177363226534427264518873627321157873848649978470691751461603892568967616961478031546830779614336810825723942,-101111506221216033217072850520258617188425601826440367107306274167678011023598617052316674929590398735137164535581256355917560681291424742569/53491795759531534439835711385541757477469043206572606565616547649312416541948792478241786680525972346096476285382327820854855075543266300956,-118655343448983392673267821486466271188032962004257132000706548412604443153783081165792217247419977781629439125603995401677152382568006860295/79966340171826547018400922063292468115880815277095190409184768059620143418015520930174102327657113984865534955022342180693645183819705668741,-88293749867055861391564836678626219440983954926194827301011929389572696262090948582935360404352155714663357934770590436580786999985141612573/102464756137747846695208721697885129845405011162770880283525159970033522429382268687581294602651065581418732963981324732222725273714151211972,-155793351703928001722353292868490762018440697788467702392604205754594967667025217126255599939223723509163415447513019386804054473598529833451/109469109126109630261063747390622482918135087922174601991613618518644229046005314904972673176391426824411613907825195784156062888069186592464,-1237853689492134539069308120332505181127435624947818710098631246621875070172577798867329558939399430861702147708740442064564998665900227691183/1106109034955455007426171043379710435694897648061028945559276399392861526960228044308508412497016786524020586713822920956388072650394847410312,6365887791720115271301386772812540152923882170311636543752491872735939778610792663378456761959670298419620547765032642429632009878815777232879/5988614548576132175804348653573655314492223202312111152002635870435697252872870639121719888081600237891878905391916608859162437617039057825344,807050530991505244518843641534228411221849507593140075254283395132639229417665817227737541317676062622239813472884559934115659942407607741739/680603178368862689471234804819107362154287326162823998056120469916376332819937909836880712317442966369526430942380489228721866800295459992624,-1276464843766519940497537891085918637555000336566884249990517362028203889428014077125545766797065846851123477981102706854306874987884625448543/866282858810836399129485760032603751150286726105581083408152114240685430679778584217193726967899265488691051633508102567061051295367904029940,-57380090935504432758164838677902331659770222747045367573336802098653050755258167391123731772873237256520818278764090016105702858514344844939/35934036780742830048859605939305661818557392287932318622696204782533391875270374993645934579442622925705226320793340127192791819127423195300,-121243493807781951682820074154102821716650749660003802888091909763751882375522969464177878837100123046973375243170935729240805092556274421347/177262859027715517338651343936285399930087827825222086396225985655790844324657267666428445300443807291166637797589807239901340335732368111112,-105839597280587164919521955584203299511717061539555977351113891240463763078979484534631565073631994091835197046203312856232567020818345710671/87695007934733417839343559581377513603457912926272659795293219056965913440696049026574405211731543825408573591793364618642430581986099974580,259723696331545155382799160307706464064944990492475672687499510831127379884484345470837688717043688817169721208981048437781996783495137775501/1408384172598150309169120179821185913820525113694275929761510266554262209093917268885617924998635776931388608476708048900208082319769029681668,-60455111172196350010151762307890549739039774045639913666444054366416468821092286309911260411308993149397539993147926259787815927361161001077/74177160291442220505566098239378173956330629896689444777437124928726849214737239742658589919244881979893244524991712585554763388658397272732,-7749481043236239458479278653448200279165565806127146151201377257257942849690021600329835275652570193923363520226626133862177118786465623893/6787537494632545470345465152714865359800909065724297733243196060948367744443588571470040783379565485553477327828199665870269220073798099608,-6069853573912587023402955061847909045142765648408273737670506627787936199518322254824029526112632871236959011751169043317107990196539835216367/6456559952766704116763625077027094435061840890526992113240300213657983101631257136197592962030178834610684629291800010613212541118730425579808,-120354733362953339238596775134803170731593948348569471003082403726018422674249839041590391540031865644649646725485356902370589031239786021637/155904060286221234680540658933023401907863912761316364741452575909757311753028167295536667924884669901492311123372689180549689940542121611112,-479503374883620809630901073792702410460922841014142481503028306786358137631789247841036144341648333709489600765797550079391918379969913121111/658475542402264924535089587746592536744922987267105531443980029671540528739169827848964610907503550249842328612997243859601972254885428404864,-2686889493324634978632511700976613715508774002167800506637159190730823708382236394732292304024468319462328067910897586362427828828661637049/4755264085828388569145837556262929972593948297289417441498120090589787798207604828408576836615556778987955057139068951677373040295217767802,-383657325377702684036606301769191936639026973970851431535609967884929937185901498222769079312811892886860051232702052706658800754273300986/988680083278401258631044042064376461895519766209835881774485255625056468187177380549363848186239971861821824374835416724180502533584000003,-32687312078447775932703986635788272453315915336860856452516229875046771036132313876432947660747171315795679581000583234725358134266879642328/79100021532360170769560117994556839403495922722100844343089990878353753588039881592025861118881319267344368760295276257265871122948439426519,-490944028233310222043724621029903929421087243719354856576889474736016639830111573490154787348077718358573845120956754378348866625690307776732/1626925302522407417794058825428410483595562214620069506759911910247009774778728678384040078499627906567655708551859736528204075637214443959611,-12928312976824460729825093824195363317271218892561820431226444468686638108935745148084875273834262448082042604002843390787483281518775608219015/12691519377289433402452240227408603995976485912007526623248842263159483722858054514851264468428796533731530446116186938675041401725659509708924,-911846866227452253369265227430252866972891363705456782362331419586827740010426590705132708778115345727321200364366961624645517439009153799711/825458205512186508855608217971739539935820058876181585136332816140261557957681970122314846036958258016383956888468439606621942796702105099356,-27493405669902237775944956301107766266520361309500445524929651310743553445477284229482593696600840025857160742882266278568825801062432089598997/26265514382992283474480304575983806510528341601399748092960915556752352613255510374662414079720830410733258997297024450744913005896143286506036,-598314384767479396106223316341233863982564516025707670079201451475943011660056073713058377055208190717175550158262570719538060823654374631303/540116337048346956135558637925631117374093804379981370441782309262974700904821645178620774591150601427894251201247335305363041829594776535138,-63424046066833230456651064606345422497013572839003825621950010948288348817110433663355811509641764343398513721908373085031550836449019273955/152894778513135864448025355782224772542912098520748088335321911843201947709202836078801682162710789757338979098706035341360685132013585548504,-1496709828282151714460836196004197859519264143535443258849938814783658398067385935682102532250277149673120488600223367899186253599726374317719/2718108068393957120806950927944657154061353343423374196761135146085876918926088326461642357399749528204190056214113897232400855734331088393748,-399110161302913315268298297435372996356158100191809799026217557104585020948676783485693993117846755666376495351594365573277819185384107844837/456577429648844749141775604063172153863724843371636162498866411713386578552438130850712823895549575563412370329056259651281515975707240379324,16137979851788868608506201185552493923838152139194425084042710547625153124183845552309789797245831128609654589680578571883180914501275576435/70274695875731882911162830440042519501694613016564284575826582517290604210749329349726488662488391749443556855628161221103011097582832065132,-1071062967216935698722285853696129925275649031510765924966678638528502718625272874026700954530327364574418264050915421869242510985309710928453/1081955404034588931008093518903825859436953470906678903110429858559845543703917563478012969850031446238948589163513031659158357732327460154324,-1592806310258223278914192394708584152235650588916493280329833840637826208899436531928017516859839586421072531582295843277314389863608865823527/1845964863991206040908713106996085342857305684115278315528208952420690646249653846895424043889693517604347197453237368701385732637992808113788,-4046220813212620376797990589680394183710494546531802660822902515798418822924827994080072269255869162088363632728502191739573656404367101937/3639773467508683708903856212777840419785333906757769897483177593593967201606809773567242134586085268486698862101319623704346285616885806580,-749706717036241976173021951822680451487015698955451544676895374706104532528928450450249436335889020871448107563381017531617876373865276401747/754876432374588993972082092615970717007493277937792744935062532000459104447523272461950113234626512996675332889749178645307248827265085720069,-91647483316131381299925464282982402022462607125139918627839990302564247185242608516929333235529186903609529241623372157678994959634113846430/103283626701725856336956182926777150213446897774427796583658168084081730085510450001728649371640648357924907770913349471866220105251783790297,-14930036588269262318220506757131263108007317459328645328964385181203887549445207041072908659770310548211850257581808407206036613091810891685/13394135837722320313997416099959957043704255799461065939441724402113584693212793475098335184084136963101242345524103976629139569348616025486,-2932432265432466015492199140328588012465077862172889802017257406953724363588348766273792928865682769309430197482209541668381792060851721456741/4081643098431795406664227235858952393235174507350753888814613759177876722203579340974221211369476117935399516187926202928754202027164928439832,-577771130472323435970358214992183186962415587725294374590440203491660045846375763016658532061047166287158826019775991241269496360361577423551/958112232555936299490417663926442286233453225726745459079967127273506130166648181706653523784270516209845856396965433243138390041834763114072,281691520001719507887981402905228286202919304920704168780910903945605016348907673269725233853935914916088654107603899587107673342055091345351/2899438748795297677783513648270887324487031537144601069176050382182526192075089978041845270135657643522900509838671515960355343647109810061628,52532289598270069701932485329795439140004620180950825479071077217028861329080000017612870425984491259486072163726946117440265588260781025815/103660466156755384274693195904892218440322808230960821299493155134533783469666195605118347082839831064306390627821667067887455430300472968188,2291371006677259080509041625474929643422919873341522298839763832913081756038503581768326961133723258455077950363489659103802051555988879268925/1114863321753462367931156105905886313962982922710342041614338944585514598491223011130028370040288338486868494846604335412009057233200597025436,-8885056060066817031100857457784767126736290903565919577927311787846012686128460799563099983543319057272873237914192290643176217227752490617/5757475626430987374031916936433634950033731491692908728439065637593401690281898926072088271973151124326006250987886592805319886533630273272,3469387170939567554786613678653064752079084372648651758271001812892653659242078249101204501145617533666397106181013688218058772151156131786115/1011857668446024317607111021432900838702677840989053167708723142567236495401183582390580220834397743160710438222721664975635179169912647957048,579906164221101647300358782163391959527196538771188945108889250573606233203699943773678333296315738215626048516599565086049598633304960969745/111838785036864199081745389496442167317475891958266567089996438496679853007644470219436852489361231878934388144528468453941619535490254426928,451963582241245657000872765884742281432064309470638421245461136892712374999720613342869037027147913675100120799397407300738664107901128121/357896362418432701584675193131434492077549692475270858645020858182403446427470122475345855495375767483885300320887946644820319330527484724,32406970179234494972293604377277892037493958132144658461532959452437485210340289217493438539457670844514097038877369031723239826032046009756/15004954476557667132030694776120284152224672340602847250053656799808260431485010895959024073515101299069504572870803943259713330723740483401,342836388615900183179731177375639569058902777381753827586584964843385949082443360473037481652228388233005123880481452932555498315833938903500/12600058646972090691524265465129714705593416364471191115201232807764744715159567603960912238077188694090420583724128172988502063359401849413,-26533316459675394039077464551215016545991149702985807861607120598448056705372732537834502982803177584116469232648250077225817046640830911299/299951527652630931054134420525492241998289184349410293454902996038076471827086762106231005384646148588669633527117578092159252400791262200296,1872577289530169942177551197807951393509904024152160496193666332784244872609917401066880122439026702392579860543305557044350189574609718123076/687216427637022846749073151396017298099046694911393835311859713945636904131640999135966966693615983525779770565051069562128096984095558817363,-525654718208585083855325634326001286124048202183743316723462891732578936662328666721507804881882969036143108712132592013670715166443941882/409131331689486269665477612223676201289043531725047547041253216837291922218586521689437765971845314051732127205790274005082876948208157805,-10873705871676898630666483707118352818078804699052133840488708808103365404386452335435849553431100236685954417188991730179642646205973793669/7774177327505989346168416525581382996977591219807311909604846226534153463622712479957303208792997093515098682937835620474964135461990131176,-422232914388577987866859181825699771682592010407085291821126616262683000544149094421715226527587403504233787490933516248648419517991738805596/315374280348320780971018571868108828341124968732204433062425886989309730040814230714471819260192094958066779526274074974954514129251886455479,118524084000203992930378014986078231440547731426405292649059791029132513422642337287824007081816361399813301730119628426820902346911813013919/55026934282225840590677044170966487674843297077770585632634769502961204205602065657607908522490181840362955501333476006822174955975186041788,326022065921993480269758814425948511404857790207216766587254879198344190695262917214174744251535240443754914386383227601397331583277256329646/119558112067218090423223467353672405976590223332922967780331715041612636221353121400099884805555018002368029121091856715919409864078470958541,48703562553558941585243115619658757527997540717421804721846073838615736218447215346774171189163130784404091234217764971117440833939674414566/10014619463367444242132704902469025601814862013477164984213499676197839189394462451051169437117633808428997050618116553360525797853800081495,7666136194028895221526022201016175411984365990072834654764864981267779195907947719334669534064750072213490750926900653760736764051565307607/3687622132437172547946637536143891446889544021727539504146237214681641032734388739809792535308698879501367456078489621260020047499162061760,-2263870446317343343814720953507667035538122066934754136276471683501010903420884143840155634808597329002009910488751393780659480367403235864/24189887131176458610717119401464493497353254234451722123605107267669867481886711662498729522108971064546525819171217257608014026491292259565,813215281922267097354984569325257393233749080264486846593867692375532183692903759886998690618772039990558816624163227837598971057090879274821/329938098913743637217215668444287088656313979594283938937479532364737551833359187868895416339040542005290191078397019147838283767820394486144,397436948169050496117681356360064131390780522321673138660176026057988126393008080667602084902255090929271457034211627769179877157105137568019/203440035367732344274844376195580078807851800301378175029208835204776856415670641511860993398479276107714049551557904321969253779522467008684,5562284468701588948668648301388680100787342953667640768213111102427743404442524001632823773530758246947017022041650162635631366663547721/3665773564084768045733157637751812706499905612280570034398735429120768229232182997805850627854720255158492610633278226195100396576207412,66011247422495244405038388982002372936105573319816010841789032962118056051839300836865214015900740824669516035459202484141652704781545085783/39838232926606777789391649130795137417927659000555056567126070505651125510094792492383451677550788133178896059258441731934733579453947670444,-432168144701135074080984324917830838841673664619373071276825151498876374928012483248574784504112887659283193395109689710931938030089726555505/339878630471322462373894858374377643192824330875494122454792684494442668797192372760547853082357719997224369197999545021948388481679191901012,-145347023118287212987202432961922647475153243731841070107755237756761048784307367868899649454494320619227250408897906985915033458808899800653/267615917475256847393154290797839013270383560184335062846963247872089851512743172297818170217548996383641586604123301908150967205322134359230,-596510452616638752462792652696911423384913359807698062496546938475563214901951889168159921847602367586004879998670842705975094160511419651601/648631605978716660345186856868081272800716206814503965469004234762170108751233557227980541021900512017083404834561963417499889020654542878360,-249495428980602571321720580353876846271172026159882079353849537990989631386913782444485035844869571606694573519576822940746597726682439358924/401725099691838582358892420387090731472787123182570709873873361263612002875398270583021789877350773619112868465280036466162246272559599254299,740794192644532035795426156871022037915121069350843906655303361178220831768669034664000436509733329604392570001612147958422795475099437496349/458666777040117024174282503095708739839057651932356714337724320966358322150315523464071101912488507264710514158819822589635285559921663295808,550141479588327524849731740774576628011799154391376183377162679216608289967913973312560244019174061135720867057009777540919303545760033319609/239731611794668639154302333894038374264071383202580250102889173299592056563573684515588174373835503568211078947125625932441899730363846722560,1052332751212965087053864895372437985277704404157038773124494952048834465887880224852297993101913531768922619436275077097338735444831388633803/486457085532833314196927465257282835794094760256578946429986645328176820824842150499035554182709814474348144549334088855535171979836300775872,356946926502464500524861593169175279459453600232248925480773819926926488096669404230294911992954250833400033633250952426803100721198858056113/72056114738729981263106579205257170196134006704265194397346948678295956357112461856552112801384807589042273151870765965713089825457104740768,5641368460844224284494906357870598055954432198802928513541440402885319538478252178344232877864117941931631325876847917831688677526182590220087/1225422203209656379640588463565356334814553845299394172359430183480836828937307790768332439486903694611092941655845870713954909000592537864256,3912864949889078393659937028497834882281377449004300099072232061779749269123785139748189231725966417622579255611155144383417976166301959278907/434807366282935511411944974281994858753775443520271802337036831262191936223645715160613209303813198043252709620271246456611619924207385251424,9371967270752729000650235547682001261730888970526974317900386364916664933311120625167904263429267947215246420522837650709611671752684184237485/1151184601450839004488328600062330055467167617501084770819392505616436348731328511824666480069069417084972023349603090386548090073399321493504,344529468257126337152813690652551948837909479388158781059116119280293766601098578600228837703963800306028992544827636404719730593944478026463/62821778151889738200661183098585045986639604793854033842140015981126039298221861453480277255451587277971109376858816333202875896440088343648,3821411390488003048512065279889730292564030837271717346613764138609139753509597805250378831198080320350697103073027249739324159215289156338411/757440357886968437717727794433359986968374670185491325354406766329215038219689951898135778476477864545334488574203206985396298860152535752672,1189446062243981297171698337591730871332276596726921574759322967279264544408450535798098203736029898378933944835297754209503293374199842888791/386959642436077897895275923591631944878517756901118498851432791742290030781308335740411587138893098482142894709385294195590242237056739936704,4188190979176983981029741623187297515382298707227787018800618598282956884804186492814701302196940513487677546343116018262975753616096746841759/1575854153463177962356113665718571328531210677912294440733941690433405926469571660399917486021016230230091952264888085545417303509652741452096,18141102918679122990267577910714379429037312198722593632464113684769710314837728484890010282473606538800199477669654307818752949320123512600419/10853475763396414530039323481433068866808613775188799921290484365362256903866779498549559656285293137499766191263194934774411343193314537356288,15667571871033389119296105180061292252522365147948457817395067749105134134977242184854103039816144166302909063401166267707459081336622824214523/11540490190414584378247662969572092915488324594754212762942575751017578859636276354394466176828152262775276871690612421424103575905582679483136,1481096461331177381419620198273611565169529731629246214112529098677868344067247205049736127946908609115864990357267062522628994028995508424595/691571938889610394989280861307196410677551635996726140078165044465999545577802849348937757323778109204056308460198506768129257300992453967424,249163230996834631925378326575196189817885995649738813661311275703771126536334281673606565418872151973096071448862952926820064652352848666970/121473684717542666084764436092215640771277353504515667776096118902838240355173874721308180010125673158611096571734872350585062644206640304959,579349762490386372866853556627147180802253448003257538518367791325151006526782278927821381120902795783313420142301211084338475113128406528499/432544195158141474578508710917625623380964530317449404605016526424590200639285267105823191605585108151189160983376984390210670369221458311264,73600122247527304917558850051033897841284555905700092702342795785731774417575543573368369490033120738421899280087132539170772449763946596139/77077004474060883790391475044677403584341746274522364224330641008748478113170711171872427793462376214305638604402985229250598054861956370744,257005826761377679225924603246719411590221025992708539830179914291935875934253277663383684686024807595036822320025158946119932692165980708695/275841380215428074587009557051759913883915939559053400274077758587208869359976313075324218188596038119168775222825898072787559111901791575442,980230521463849623575776603851061546420398520002824698755823858908714384323760936422443131553361573104202568532574493250890063207995281839799/989204742626192332457115177296576667689785324613733308985250288749503676007747650617754695544345318510365694043893547737043169991978337455904,891520407302155156423869813480942923976304006892784057515724668121736798935871728057169452891955438694553898056744326535831061353376252688561/969666003411656214215053523861081885611931296781438905284459817015352588761787314205790671108417833205654510871936918747714937950628516232026,3312251511627812178812707876721167739881063454856470424041157090417516645930406374804186495011534758912099216219450033693370406924373338619142/3338506963924372504564268650259404754005455973512315740948290573652475985720445204687951213980945668251032404853429488095524386203046431739689,3664715995449194044275430640807255613218994705739110630867499484334335066413020154758681594993230332505743173746235959384935635401775624700693/3915763712513557483923354804957051222112315254314952561908225588524539160491554008139496337538103191773491997005541666214988760823690647051648,394667622513195057520770139449016513934908754000313813501846627550929460528077865049352627502563966900239690184614160772960493567755425671917/391909300579592120120239849674690346382614321089027160259532812487885785974721804336971881707209714532686582081834779814334591838275595062924,5673714300670970187239245905352899453149987948773491991888650875741298412590009383891762285401385752091289031385786485142914138938714003756263/5682312865833338667162941515269195022100974013156453412608552082045807921168711223325284196954497374144119827587507120202407861252983043292288,111858193925683966386387645838655901236126291319764803181001152986780597102019594009335062286789468426346859552538369674584972507051497973530/112284319621912947876735095527436976077983479087562327545942407756764719267231456985667979931308449601940845593289050215311012906473979810809,42777836047639077970354211421318202434013354646474441819052851818358537972913406052448434949370386434260331481484736391558819049251112690803157/13656844046150707138445179459249451540387755265633081265274096560492032158016507513704048402006076629716998460236475960116458504927309237714548,18989050430770199067026425386141468463349139819633213170547339144929135545598360813255646806393295073969414333800282249789418683136067598463093/6234180862595318886688984359336238157892781619406097892745607545196417359076376625206036278057862895511459823653682517864986138204178363345338,4858161315480041477001941551200893171610923006292556209179868823890125709711116788687153464756375314679659278704880989286658116965480072192544/1666437306514577061133406015787971842772508039820786214476069401915494768460300522870119654780446658030954140446261064005143560302435467869383,412815219696254866359965465033326185337147135788663573624789618973968475882549342820423544559280710270857870350905458316235596892084127347289/555339266673208200025268654379694725922370525841420790375658822032506406384402868989837237253491516849928292397730567543607645307449181662584,203336693377430917404809278390316218267766193053511269344122315354738013325846238056150503251036989727897910430300102886680334095319449704074/314915486254975918682368744368679235697668548761131925321463731410188281466301412041117587920471314406565049558401472764686552685207740321043,1629543260022545986001443276088871092933114977036123628657979584595620913916016483669554741567896278471391433895913305204051920878856801142953/2418323677693744617384242925372393384095523647197464560684764825382945189494185551904977336270893014294067171561841577057424412924473762369104,880613243474640625677258076450250223189446139682544553676663786676491438466688968030986525217321450592912836853517342212785518178375241367727/1835215478260836622570711227048190520411069278048516783764006965205482269124067464948878199276173931299034801297699361545458600523562942149664,2394084292390222728763304230794449907414053599979186618647339660161697398730074956926885917036373882052031195134412165315778797032218916912167/1553170053271117136637490080390852511413790438199760241641401991167490247162333667369655013994995958816404337625131165437087975171769197437856,1026439955177673084161370289449453831434291463111100152084566194273837930548916857819286490752013241100706628319209363627575568116898265522643/541028421397810491621426246010978676439397163874646722007375894463797014234514470318695165493310781092919582465698491834990173725552451393632,853738870681955031954629702358266795956043838615124154120763661505668522541763269279538121845610327892835543487104215345792383095284840880845/234057041354048850929348713736038009313722757553188203788266832544454380837455346280801975097710914074574681941836575175520680610797593816228,49444045516486357879315437042882733302445772856216248001088518916722819939374522501068384590675828298783676254581705558928626525644204476245/32366149774375923054281080971481838148225721388426445838322414384299408097452656529124626449621297144059632248426913138485890037949390450228,77722163640370764711545772416524031403213591536030541936725201977853026212149117830258582716215907870622863894739485085756356834415430785296559/39077570000229330058446728461573879074232040409705355161846962665901717501936401592347617604899919828464396128754642062228262609316082938512448,539181529265841568865633677225748259328038566130695491530653584438545447806820283267703166510814160859323212555821597918381092670973799063067/273286970368435099956394450544235725799875784728991029230735519989679986248065630929807342401965698194924334665352557936520725052283424041472,94593871673461040932664264282808863145165180365360512395666309187909760328334900315416132528825351931541206954143477220368688625741296627261/45184808688751713911950147613662038137105877021665572434846579737686704056576064955221614858755408601720603309134837262970324385893630162414,2887669772447794404351715605577491502872123110537307837556247674882823748591622097583207750424367195393448871551425776473911290223450866196539/212582694119425392429905506154031546446606338786823152900996796334499969477036553839972204115936687720095079041799112281862174967477677392352,6607837241644416265787226589877182099891496027087181442558603395153088865577055419955262970592394005408466821647151753124213013202998696341083/332028364296981015949860567388667514395666148664760320328563785883960047834223796421507125215216329477238449046377798149682460717186449719776,3582315876603800460652794266310041867054498555897880332009674695800398899853998586373653697740479362984603003150531603366280083608480688220079/649474548829967691393352412161203091856800744296798063737248200699121303971893895382621918374666922538871737063997000849674351924749628414912,36777972388274979476761113708610526360260697745081724787070205585951066084836114892290259772776982273371888049301042785035528413217239688233/14136803777390022981807282836756290771751191336042982151679132175800511133425278567464863099567541306770586108067946995252674679023333426260,740802774052734301631812882296044230608394958660926352387199951842467980371817835357649224940019252495181473372139594997785135024479371628995/223165498350813436755414777097271018644017049980173402757017380648515364342956293694381757053137278463835334070739695150643044777932968949696,117521238415461259619539381469567297460048704504151874139224570041406415667458470856467167376798277473964096078516439357956782896033529634761/75564416433498456857198394495936376552779722563576632536936206114879457149732059251930820776020180992870228359415741142620389564272079880456,540801283378584126624906283016814524775201331643159464828722953569789384445910578060440893350170567961341487435700715128440988817456411744317/357141960966832246963612894906949916790154635391803783591380995293941455034297245468731361688355607047879463602093648032314568007893153676832,13457072427553821176180539426337579600013329910484187031999745435600400525668673394987759880001099090257705316160882298591128418187923609690/5957026981793051448889656647185245270620768987821821662437474454266639903021336696893592647566813870591014209353789895639380138391039001557,1075994586388463960531340775252531393367642074331348916877602872320686041698307675566952040736158242005828464971500939633999845938389417461041/2074940057276954483749685295358779173880982982454442819910133915293499221523467259588901067261120362837339447715275231961562187602955427742880,139046010416304168770459151888279984309087835864970188871653783907452263951998729063441743721897103446189752231292223324913066875897588970013/405593858451851606840751279502206479909113718267959838414705273153721029836783049033822741528565652418330652311540583798741326509625508006410,-16141626289186664395918821376812393608001460204709562302753857539743768410986248521369170433454576162005411178310137715370871752635138875607/2229086757491727064381847264104694899794924196372067019629053875118410475862624836111549218177748768016467255886569342798339027372436567848760,760187680098866148962989235187889863231435304224472712414451609113364164151592812801398479416517366857373720400961166327857638760756586773136/1282545483901267319812332825722315953274428714844934304463603381501761890625568085067111841947752632347893947576469001520697150144811767059009,58246925198860309298487442285889325571578317789208324863701078128614472968682355108335829606094128157435745794288663641786116476067229604984/122981970582914559258966754889349236780898007887386751645472402271997285388720527432260897138255459028747207646180043134032150704544230175013,1733103921260666581215304987568361437397971059287978833211409521369007743650571838609788169530471925246637880845372857801914676375819650530958/1826364055884736338146401612955306218886872031187327515633740175700441809955380765398647722105041472702401267408919496305659073925178955420443,56775288355399742546035826980330609733703145718550520115685995022066940813400892291402482371544846557360512872913636214064593434438941389571552/41936555493231021587660059773324793924812953686181246305031125564645104597282204396914110192548215784154594474352005229491097454520217212402203,6286429717564815975369414859724928981471921207285894342326599371369626638126878039238441545888362639119758168191416835439132658327866990247704/11456724038086870841596326060542792128626347431619399736898388753356445527998959731428894900946272375376652026178366544705455297146628322146081,8660615871694902798678625706602715062351083926061082292162719751590467363234730041263192463991808715328583187531356859293490021645417653945152/10102786104634528781994072282494025702511050580277099525057357397458797607457685454566135264849958621971669752737679248604362983261340508850557,245504690610610109899922759182545783503612041354689735716749336085004367693696670724932118758596261186693659549750019804952073164911057022432/329427651379885325266465895193648507271973115930564977283028046284369252942239815937678765559220040482092484491492193076161823180044781493851,4380323884553554320598576422254849001366925990587098218227427265184785101225268607864960458607089877428584861313683878061890895827164187143496/11313422905855691689575929503162074375168113045834773591930258954161248684141103648193208197438606122353916691359999940500857823282219538622279,4191368656740990195598552465873866095446915630890435194598200747375732392479563673440833146262512189254261949689174583871861894989855320626256/8927341892662102484997891598953326502268077629038177958530513887560842033217586023663352144590583073862800821611441996373162182634425652966717,9062021419587579844711368620846883038320675990655382478091820143497733714618972658219904814069468425384968662558061473808429051853713713135464/25349724460723831486698965235851340665572913528560702467038595457631578966174633497955340494813516592130226142270025719187917175288103788094873,2004235593332788579961634404656873377689639813551072177505547437194618897848570586740702791466588413727685942307750830853900006093296564781808/3911833647786773472124295914582302775650973607266751486579707636655504208049037762646365598061149850989713210571828307096686911981022837868207,3257271245807486794272069019109003306927552946319848839335819453398223999863367559991408577635623079377131147386037731242071126405331796310573/3068329293670754018558607463291196631120675567665840137923251814439320815895204414734566388284426290384875492423137452149861229833050046484000,651149862825381477535947488617314338549069495284745839296854823590001743350318690201380229386200123926609957375307532826516471475375039595259/692982221566190161929994827922114639246217982764483138920275755233902383433751860020372582323461138160260394951750456166531751473035139916936,70763977656406048299487309823890489509222297946479068006546048983779388141961999114024371624137136679533772432542477160529679457885875090203/79335213418654767588280263981833408749306325548055315443102498147019385639182860410003726384345037191054875213385215311181909958655498871222,68867194434289849827358681521626293054371223981536294205020243216192063296899400774010947128326199826208804333499794271615540459064326879383/113523160780416903708992186058519424788129264281526693654173739960654929702234277103404399363085230696374863003493114805478930549745652448900,201010124431638559227888620321513750314475902055228859736526250377883048936638004181201366052689921194822874632688390051055579841197244713611/521038016961988161790729698738736253036185274643266984742355768076876665909131110967476911805612724946135977625624112113423902530292507408742,141087358699654467563152403999967194717972912072563361278119200304595568828230631216472082577775956155712670971803499385021790860868728384733/249883069583008120940618240988313991464208452434071760571880896992037356141284791288667989680922721371602813813881385499052934408068548512920,342346456088091862493168482745132427753410222496624375379047221297212129619716416709795996888652565389206924372366785470066552851915708993229/5469834954091895700661470788781236137316060282917236217908790775802109423038216248673075856982504549512603430203728622847918840955143454959800,232020008331608804027715166912279885582320454587926968553641373962880862378999585461786966627143778972564616416218242206447831076174150196589/965730339720569046499052427232680452373736142156357577356779613692301810020162678547342705036027649500438435132708628638607725560078473496432,3958325128263832678348038543981081634692367510038780623358215687879312701288745867898304688136981217679876516134437522048898947647408888744463/5869142506639525299982198653210458782073200966774201262130903001661294393336385567737519715525781696499054502947979572048293767988608025984732,4056752322375401373609557403089707597543646962096904507872741561362492134052756607504273923380814284343063463523675607482433629294388411650381/40494842301722868746554545806570522313770852835043473284497425005382610337428218464393778731928359777499520255875755777300591130498925900882152,14801342230804572059370698525709259679757045447297359146482518077379048585274024624886704552856129823920053389887379967188420395038286011246289/38784114917358011320780844847080674273532716677875315951539695862868144055593491322529527758498978497201929602560341950176966523062898603027716,121100389551856520986844197218579267275334384522312784314589972465397872079572981589358155073411801211699037786786299826614971271513311927887/209690494136966182764846227035058954846175126220900548312412846219875633216869415025264747202417554384926780714134306830109463837020500678848,86321869708116134761119060760059904772145898413447748592307435355246702712697271655173765993981052226251241904361372963870107925895423239243/34458006892897516071604589918077450560147954885099732375947549219042825830360986336891678682293229025468719613298352421028916166247629064960,1545084265220106765789128750623868053367226187222909895682271380199889027437147096382656404920099806089378311409270305218669470649654111098077/351892579026872658770790754806172091641604031440796006108924715092114880848906651299527794968638696287441729113808925441992419177122268873962,8050352030576906936469087590053455602875937541420970150585192136771944563457554930870062868279276099416503904824218337589907757470426632936/5021755019730617509627013976048558689675442294163309597504272300237885721428451263784923437735623382024903549319336200919745274568008469087,117800271737936098540250146927980927611055583589925683880355488754506994183457226613177528459793785581792871367722278312388437041841331553186/80850808008741045642629197984051563790019635173009918763074880221950494718253236055091965299393840613278503712110545262934874465520766209367,8550976706587139768770563314732325835007155598490902871959499888461891925864207674007174395896188350937358352707986368046478898552969675166/5571350297627309933532368446610304326958776796281647410912756031417261301391744059259021743597646637622177033801667517242594462257236019819,47615593125089255886426134351687062271507433021426005605105097537260034662905911387429288542020314455160005235176585088552106478999980650389/24734253534465467405188831924968238880066967012658853177476114318399833727154969140066298116045067708568884175660111335576529327886223809678,216120489368570724605643135962925488983928003342513220098008426769749436417400616899211906003544996408852730731848774693088344418335308080613/70668277346980912610076323437157169594088323140820038773697376367501585863568397328003591647523936843403109824388144601086740477268089223422,81494666128136308413705261109732527524809719137317188290095196601362845102768893174821720587974058491586152520504794766738096487699585434261/28795228749450235814481116722854359726107856507703168089188479778913102145288618754504211505184332785619649558906613701126618101390268597257,822938415817529986364590615466429610930038841695179160017807658746527950806119772906905766588638806050622325139218740807287031003268693163111/337048067113352836628452348077722014671620651017455804337629951417942571233717135193431148473798985823661122405763289348290717884457950078400,109629834955700378203656055401908164155580085734762479438946058705601858699788125673635746938311523061847669731525830094702331954080690328553/69327487263826812163907754051574436348489121669697362718688425519926689891327291249350409520153132262486778768796452484474096676499428185044,20281020006140217623114917719224181902165911031963047124174870232400789897923659263381936595462154681386786176040298213616132908020402143187/45722109855029751309574112476134883472582833178868626091631960874711151700583284937225940533803474999617993977548313235722464262340579182030,44392023706229004829838195394136493003578446777227933495153850180061793374145220790246467206395831099256550650035252576234642067049180386045/110440699481759709183581919633019828642554553951579069724775513653403493904949251046035372205296098057716842429537878709899721516236892641368,124624422809163508272608554221052023711042350282031235578948069558566897628355926555272713205942462899143822516771232917751364665859212075308509/2208458724988201059978618694552186757009103538995237066158056473318448898406299132298377878929526788123000163063427231686839395121837767209218904,514900587005804736296908099506243731846572436386070625517330298550170372906748472600337368173557692562931804250466711210523455345941503167397003/1477603546956730371852697874670819808986766870204931994194454175454746678620043268351406494245036341955034777559026023488533940466709712180918796,696406714099834159831674331013959898513930102540041592410894756550478044628121080320147251343940119119456027838957108758495913646685104969081291/2160142159953048173487324158162277128528032605148132213881634366233780000809658445461106148407567660885430198453832457967198352241834072207340236,7770884422133482232475880973003945857976706489025694300341356834804098908519893350143962641626933213533088218748876706603117909620055512452843/20337587082789089873291633758756127408718393700011405509763201414736240193026359906301327736177503621443102068150453736995557805785834190902732,50941736609927496476291086749198276723395161992464025618119185902098340471838322597271014484438678048178666354987479372141739592629599287726211/92203953313362658696861517388081360127791540356663443195357237920888742301284068418031456313973470340127861196327613395833854926133429693213228,-301898793950412219652411271977467330259268572771176775755519620988840687373560898609321183090685468983858084870924573911652071057833885985223/1939787913153814469253695720090552494756343084941294642095223718411025412500972948175062799741414060047928764292577901371915234755681549985877,-442748232979544222542914452592301690017092216061104031984775183026504526327908763694113238263727968888295203421131683313083929121685059592968/7951947151161855606756466752117204731564119894956117357536010443046416576970684328559744421065582103628288198965610415433865523778397026248651,1452885675337153069013362587690986043672666021684120921666644442791419676690831286949694125744541965508335293794094372855528301074765422728303/8364554475292982832750746605323216472203055797424907925505325029484762701669870247626790410773466331499624974291156968195423355639910194804576,48497342218168566041837145717570244142989418691585162242581141752127403231749057099520644190059415221667080067037228159342958841548494965219/46126841480081435793201124117938246953523258416794758668161159972497655510934485958708399704626395389774413801038833588707235693874250638005,10578888287074186213730498411982835457323543610801917642894951623144629611599018240364611519165964997328766644688651257693895276345203621555797/13244145960416695362318644718960913908245283346574940758519255677857473977444512592188040426441039909162717763277384219254497026430410560451740,882858769618195620108901528871330707661281531935673001880704041986413039779253095661765868574163535226717393907149083333114581518042340713840/2216696167256624245825556257857231227237112512101448081709512088219650302578653901798345157600323323773187044595014466986725706924652764899019,9146757543572508280956209284550591987990864472701761376298879099427111608558183761909909712882359733789995771128841567232252057354845963082256/32827946430409619642742568322824593210396836766548469576422289755869335004526562827270888695166082274661816782244769001370916902668603980433549,111306854449033685888155604737583527270047357385973776964910350381463939102008623383463683203588596575558542744790742306072984525988801281309128/486109212485537145597996055257184326274119300454187627207254884361355698786667681259402882846097348838905168213495160912814051462740575392899377,1071150362307095012070216360649540324219718060073231559723614917249382476159018360232637629493699873159237225498006829556054658847449787321518991/3976308546570129837369281463939564537236289366102767115108098148925613158793593137871643457439334655671041945819787441905440092399954002595435100,36221464791078878690227286304902361998244227722435020059858051678649856692190297966269326721274457020444159125645528660852664675336373579238569/245433107991199744469922204947357068647665443438124270771691584086237943931195664013590300282322955193601515736603382972670018649473227446583924,-8094640238974281857355879796046331772092378772524747619776062023929216541733045848878341605231979477005064188737038172813312726425632776989289/122809658722445414607748409741461109188152702376710076248271120533624125851638764531361518349302644745997440997899708221370426854907774048500034,-57799153962271448104374860098431250503774384504390521859425071705246891563394106983782621406416102851697562747745795852362877946168857725225933/560896974370234397496737937820146826555973408518271812629520584859281374891788597411423892658485668090210161084534923069088656191913410414448596,-23398346882970590727319341385745453060134354629725934669693861588179557156017390195876426743888988687372968468606247491257607411555614223101/156020929967413990919035494705324650694343726524206550372500510279373877317319212770275068394846022556806677389932293434886799903076878304952,183206960555662427712228047471246997721513394699342199663865767592501358079632994545611301408369205237066189924191615078764499281272857022512/267803039602623364439620668865054390831919467491042317830470349059574050384313454310985214703546437990911221272601458334482805773285826039341,39155048740063494301690064322507043823684996894070924943109616439937656353761175116896105212462021732672344397165667081098069855976702369931/29568843651883197732445256243755759182153178256587154727542264674821862215831168201063942522130040888937090467760359044612943837760262132282,65007408444478126016102760899334570842965953011015306617763413528409938167823808384652958539114186392161093436351148755493010057222635874130/83721468626564568855881311071645800997561586182710388378320583129044297599943916518329744901537242367684208562382369480497745419030619205233,-1426140776048488951765775276816913533819439494164857404320030885357906146577486837833630971099539461668221769128798069537483946833342957963/10902494996130709695881987358751243295355669524567112517739932811366396792485604689386679054277870756406948288575225267888765123363682527108,176051934226292039401211893824575169706236936717662310245926684287971577307886727899015756106609694237350596028920834527721454291776113573895/655076403583221575391022782564175521848524444859950699480609906924073923489296813901888578568687589696325528118158998728575133996183773888488,1249337518390712457215116203942780858028684131118563270197969568973657427228165179511884530772046058310007850672157904225681950322194379343/4352906032955199616732660117693652277631555061256315953996416257810463504569745901064668938424936773173153209608796221718045153813115193160,36037336700985607182444679660344740924253197488952502231199730374476014689938422690326705564249235400417860234390531678472540383904490488889/23158950013782249548482193579257784931760776058168296351914454890300418463123747556543198647256029132502772807294496696051199204119602279948}};
linealitydesired = map(QQ^5, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{134,136,138,139,140,154,176,177,178,179,201,202,204,220,221,229,231,234,235,236,237,248,272,273,288,289,304,305,307,308,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,763,764,765,766,926,928,929,931,936,937,947,949,950,951,952,957,958,959,960,964,965,967,1008,1011,1012,1014,1017,1024,1025,1026,1027,1043,1044,1045,1057,1058,1060,1061,1062,1063},{184,185,186,189,190,191,196,197,332,334,342,351,408,409,460,463,464,467,468,469,470,471,472,473,474,475,563,584,599,600,604,607,608,610,643,644,653,710,711,712,714,715,716,717,769,771,772,774,775,776,777,779,780,782,783,786,787,788,791,792,800,804,805,812,823,826,830,831,837,838,844,845,849,855,856,925,973,974,975,976,977,979,984,985,986,988,999,1003,1004,1029,1036,1037,1038,1039,1042,1069,1070,1071,1072,1073,1075,1076,1077,1078},{46,50,51,58,59,62,63,65,84,85,104,105,107,108,113,114,125,126,281,282,285,286,323,324,325,326,330,333,335,336,337,338,339,389,390,391,392,393,394,395,659,660,661,662,663,664,665,666,667,699,707,738,745,749,757,888,890,892,896},{448,449,450,451,452,453,476,477,478,480,481,482,490,491,492,493,494,495,497,499,502,508,509,510,513,514,515,516,517,518,519,520,522,524,533,539,540,541,542,543,544},{334,341,342,344,345,346,348,351,352,353,354,355,356,357,401,402,403,404,405,407,408,409,410,411,459,463,466,469,470,471,472,483,485,486,487,488,496,504,505,506,526,527,530,547,564,567,570,575,576,583,584,598,599,600,601,603,604,608,616,627,628,629,637,638,641,642,643,644,652,653,775,776,780,783,784,788,789,790,791,792,793,794,795,796,797,804,811,812,818,819,820,821,823,837,838,839,840,841,842,844,845,846},{340,341,348,416,417,419,421,422,423,424,425,426,427,455,456,457,483,484,485,503,504,505,525,526,527,528,529,530,531,532,535,536,538,547,548,550,551,552,577,578,579,580,581,582,583,585,588,594,601,602,603,619,620,621,622,627,628,630,632,633,635,636,637,638,639,642,644,646,647,648,649,651,654,656,657,658,809,810,811,815,816,817,818,819,822,823,824,825,826,828,837,840,846,847},{217,218,219,226,227,268,269,270,271,273,274,381,382,386,387,401,402,606,607,608,609,610,611,612,613,614,615,616,617,618,687,688,689,690,691,692,693,705,706,708,729,730,731,734,736,747,750,751,752,754,755,756,758,767,768,778,779,780,781,782,789,790,791,795,796,799,800,802,807,808,996,1000,1001,1002,1010,1011,1012,1013,1014,1015,1016,1018,1019,1020},{0,1,5,6,10,11,13,14,18,20,22,23,24,26,27,33,34,36,37,47,66,67,68,69,70,71,81,82,93,95,96,98,111,112,130,141,147,149,150,151,152,183,238,239,240,244,245,246,249,250,251,252,253,254,809,810,811,812,813,814,815,816,817,818,819,820,821,822,823,824,825,826,827,828,829,830,831,832,833,834,835,836,837,838,839,840,841,842,843,844,845,846,847,848,849,850,851,852,853,854,855,856,872,873,874,875,876,877,878,879,880,881,882,883,915,916,917,918,919,920,921,923,924,939,940,941,942,943,944,946,953,955,961,962,969,971,972,973,974,975,978,981,982,983,984,985,987,990,991,992,994,1022,1023,1070,1074,1075,1076,1080,1089,1090,1103,1104,1105},{381,382,383,384,401,402,403,404,405,733,734,735,736,737,746,747,748,767,768,793,794,795,796,797,798,801,802,806,807,808,887,897,899,903,904,905,909,910},{118,120,123,124,127,128,132,133,182,212,217,218,227,268,269,767,768,806,807,808,897,909,910,1010,1015,1016,1047,1048,1049,1050,1051,1052,1053,1054,1055},{359,360,361,362,364,365,366,368,369,371,372,373,374,436,437,458,467,468,474,475,501,508,509,510,511,512,513,515,517,519,523,524,553,554,555,557,558,560,562,563,590,592,593,595,672,673,674,710,711,712,713,714,716,718,720,721,762,763,764,765},{11,12,13,14,15,16,17,18,19,20,21,22,23,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,1081,1082,1083,1093,1094,1095,1096,1097},{278,279,287,331,998,1009,1033,1034},{244,246,249,250,255,256,304,305,306,307,308,320,321,322,358,361,367,368,372,412,413,419,420,421,422,432,433,434,435,436,454,455,456,457,458,718,719,721,722,723,724,759,760,761,762,763,764,766,814,850,853,854,866,870,874,875,882,883},{327,328,329,350,352,353,354,403,408,409,410,411,459,735,748,783,784,785,786,787,788,794,797,801,803,885,887,891,893,894,899,900,903,905,906},{55,56,57,58,60,61,62,63,64,73,78,79,83,84,85,87,88,90,92,114,115,116,117,118,119,120,121,122,123,124,126,127,128,131,132,142,143,145,146,148,153,182,187,200,211,212,223,247,264,265,268,269,270,271,275,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399,400,702,703,704,705,706,707,708,709,742,743,744,745,746,747,748,749,750,756,757,767,768,798,806,885,886,887,888,889,890,897,899,901,904,909,913},{1,2,8,9,10,12,14,21,22,24,35,36,925,926,927,928,929,930,931,932,933,934,935,936,937,938,939,940,941,942,943,944,945,946,947,948,949,950,951,952,961,962,963,964,965,966,967,968,969,986,987,988,989,990,991,992,993,994,995,1039,1040,1041,1042,1043,1044,1045,1057,1062,1063,1064,1069,1077,1078,1079,1080,1086,1088,1098,1102,1103,1104},{131,132,133,135,136,137,139,153,160,164,165,166,170,172,179,180,181,182,187,188,200,203,206,208,209,210,211,212,217,219,220,221,222,223,224,225,226,227,228,232,233,234,237,247,259,262,265,266,268,271,272,274,275,310,312,313,314,316,317,365,366,373,374,381,383,385,386,387,399,400,402,404,440,470,471,473,476,478,479,481,482,488,489,490,491,492,498,499,500,501,502,533,534,537,539,540,542,544,555,556,561,597,606,611,612,618,669,670,671,672,673,675,686,690,692,700,701,708,709,768,769,770,772,773,776,777,778,781,789,792,793,796,798,806,808},{34,37,41,44,47,48,49,68,71,72,74,75,76,80,89,91,93,94,95,96,97,98,99,100,101,102,199,213,214,215,238,239,240,241,242,857,858,859,860,861,862,863,864,865,866,867,868,869,870,871,872,873,874,875,876,877,878,879,880,881,882,883,884,953,954,955,956},{460,461,464,468,473,474,560,561,562,563,606,607,609,610,710,713,714,715,769,770,771,777,778,779,781,782},{130,150,156,157,158,159,173,174,183,192,193,194,245,251,252,253,260,261,375,376,377,378,379,380,833,834,851},{3,4,7,119,120,123,129,133,134,135,142,146,180,181,182,184,185,186,187,188,218,226,227,769,770,771,772,773,774,775,776,777,778,779,780,781,782,783,784,785,786,787,788,789,790,791,792,793,794,795,796,797,798,799,800,801,802,803,804,805,806,807,808,855,856,900,901,902,903,904,905,906,907,908,909,910,911,919,921,922,924,971,973,979,1001,1002,1003,1004,1010,1016,1018,1020,1021,1022,1023,1024,1025,1026,1028,1029,1030,1035,1036,1046,1047,1048,1049,1052,1054,1056,1070,1071,1073,1074,1075,1099,1100,1101},{382,384,385,386,387,389,392,393,394,398,399,400,483,484,485,486,489,490,491,493,495,496,497,498,499,500,502,505,506,514,516,518,520,521,522,525,526,527,528,529,532,535,536,537,565,566,586,587,612,618,619,620,621,622,623,624,625,626,662,663,668,669,670,675,676,677,678,679,686,688,689,698,701,702,703,704,705,706,727,728,729,732,736,737,740,741,742,743,746,747,750,752},{28,29,30,39,48,56,61,64,75,79,94,116,124,128,212,214,215,216,217,218,219,220,221,222,223,268,269,270,271,272,273,274,275,884,960,1012,1013,1014,1015,1016,1017,1019,1020,1048,1050,1053,1060,1061,1066,1067,1068},{8,9,15,16,17,28,38,39,40,42,48,49,52,55,56,72,73,74,75,76,77,78,79,117,118,124,131,132,133,134,135,136,137,138,139,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,947,948,949,952,958,959,960,967,968,1017,1018,1019,1020,1024,1025,1045,1047,1048,1053,1055,1061,1063,1066,1081,1086,1087,1096,1097,1098},{0,1,2,8,9,11,12,15,16,21,23,24,35,38,49,52,54,55,60,68,70,71,72,73,89,90,91,92,117,122,130,131,137,138,140,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,199,200,201,202,203,204,205,206,207,208,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,946,948,949,951,952,968,982,994,995},{0,1,2,3,4,5,6,971,972,973,974,975,976,977,978,979,980,981,982,983,984,985,986,987,988,989,990,991,992,993,994,995,1072,1073,1074,1075,1076,1077,1078,1079,1080,1100,1101,1102,1104,1105},{29,30,31,32,50,51,61,62,63,64,125,126,127,128,269,270,276,277,292,293,323,324,325,326,327,328,726,727,728,729,730,731,732,733,734,735,736,737,738,739,740,741,742,743,744,745,746,747,748,749,750,751,752,753,754,755,756,757,758,767,801,802,803,807,885,886,887,888,893,894,895,896,897,898,905,906,907,910,911,970,996,1000,1002,1007,1010,1013,1015,1021,1030,1031,1032,1049,1050,1051,1059,1065,1067,1068,1084,1085},{40,41,42,43,44,77,80,99,100,101,102,103,104,105,106,107,108,110,229,230,236,284,285,286,288,289,290,291,295,296,297,300,304,306,307,309,311,320,321,358,363,367,370,412,413,414,415,416,417,418,585,586,587,588,589,590,591,592,593,594,595,631,632,633,645,646,649,650,651,654,655,656,667,676,677,678,679,680,681,682,683,684,694,695,697,699,724,759,766,857,859,860,861,862,863,864,869,927,928,929,930,931,932,935,936,945,956,957,958,959,964,965,966},{277,278,287,292,293,294,298,301,302,324,326,327,328,329,330,331,334,335,345,346,347,351,352,354,401,403,405,408,459,564,565,566,567,568,569,570,571,572,573,574,575,576,613,614,615,616,617,659,660,661,693,726,727,730,731,732,733,734,735,738,739,740,741,751,753,755,758,787,788,790,795,797,799,801,802,803,804,805,898,907,908,911,997,998,999,1000,1001,1002,1003,1004,1005,1006,1009,1030,1031,1032,1033,1035},{337,338,339,355,356,357,393,394,395,485,486,521,527,528,529,530,531,564,565,566,567,575,576,621,622,623,624,627,628,629,659,660,661,662,663,664,665,666,739,740,741,742,743,744},{137,138,139,140,160,161,167,169,170,171,172,177,178,179,180,181,184,185,189,190,191,195,203,204,233,234,235,262,359,360,369,373,374,437,440,450,451,452,470,471,472,473,474,475,479,481,482,487,488,489,491,492,494,497,498,499,500,501,509,510,515,516,517,518,534,555,556,557,561,562,563,596,597,598,599,600,711,712,720,769,770,771,772,773,774},{66,67,95,96,97,99,100,109,110,112,280,283,284,290,295,332,340,341,342,343,344,636,637,638,639,640,641,642,643,644,645,646,647,648,649,650,651,652,653,654,655,656,657,658,725,824,825,826,827,828,830,832,835,837,845,846,847,849,863,869,876,933,934,938,939,941,943,944,983,989,990,991},{328,349,350,351,352,353,407,408,409,410,411,785,786,787,803,805,820,821,838,839,842,843,844,848,855,856,891,893,898,900,902,906,907,908,915,917,919,921,922,923,924},{228,229,230,231,232,233,234,235,236,237,307,308,309,310,313,316,317,318,319,321,322,363,364,366,367,368,369,370,371,372,374,412,413,414,415,420,421,422,423,424,426,427,428,433,434,435,436,437,438,439,440,442,448,451,452,453,454,455,457,458,482,499,500,501,502,507,508,509,511,512,515,516,522,523,524,540,541,542,549,551,552,554,581,582,590,592,595,668,669,671,672,674,675,682,685,694,696,700},{10,13,18,31,32,33,45,46,50,51,59,65,66,81,109,112,113,125,276,277,278,279,280,281,282,283,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,805,840,841,842,843,844,845,846,847,848,849,856,891,892,893,894,895,896,898,908,911,912,917,918,919,938,943,969,970,983,984,988,989,991,997,998,999,1004,1021,1022,1030,1031,1033,1034,1038,1040,1064,1065,1069,1070,1076,1077,1080,1082,1083,1084,1085,1088,1090,1094,1095,1103},{47,67,96,97,290,306,320,412,413,414,415,416,417,418,419,420,421,422,423,424,425,426,427,428,634,635,647,648,649,650,651,655,657,658,723,724,725,759,760,813,814,822,824,825,827,835,836,850,853,854,858,859,860,863,864,867,868,869,876,878,879,881,927,930,932,933,934,935,939,940,942,944,945,953,954,955,961,962,963},{85,86,87,88,103,104,105,106,114,115,388,389,390,392,396,398,406,623,624,625,626,631,662,663,664,665,667,697,698,699,703,704,707},{9,10,12,13,14,16,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,953,954,955,956,957,958,959,960,961,962,963,964,965,966,967,968,969,970,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1081,1082,1084,1088,1095,1097,1098},{332,334,342,343,344,345,347,460,461,462,463,464,465,466,570,571,572,573,574,607,608,609,610,616,617,652,653,790,791,799,800,804,997,999,1003,1005,1035,1036,1037,1038},{18,19,20,25,26,27,53,57,58,59,65,69,81,82,83,84,119,121,123,125,126,127,129,141,142,143,144,145,885,886,887,888,889,890,891,892,893,894,895,896,897,898,899,900,901,902,903,904,905,906,907,908,909,910,911,912,913,914,915,916,917,918,919,920,922,923,924,1021,1022,1023,1046,1049,1051,1052,1056,1083,1085,1089,1090,1091,1092,1093,1094},{167,175,176,177,178,186,189,190,197,198,358,359,360,361,362,710,711,712,713,714,715,716,717,718,719,720,721,722,723,724,725,759,760,761,762,764,765,766,831,832,835,836,925,926,929,930,931,932,933,939,940,941,950,972,975,976,980,985,986,987,992,993,1027,1028,1029,1042,1043,1044,1071,1072,1078,1079},{33,34,43,44,45,46,47,66,67,97,100,107,108,109,110,113,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,863,864,934,935,936,937,938,943,944,945,953,954,956,957,962,963,965,966,969,970,1006,1007,1008,1009,1031,1032,1033,1034,1040,1041,1057,1058,1059,1062,1064,1065},{276,277,278,279,280,281,282,283,284,285,286,287,293,294,295,297,300,301,302,303,323,324,331,335,338,339,340,341,343,344,345,346,347,348,356,357,392,394,395,465,466,521,529,530,531,532,535,559,564,565,568,569,570,571,573,575,585,586,587,588,589,615,620,621,624,625,628,631,632,636,637,640,641,645,646,652,654,659,660,662,665,667,677,678,681,687,688,697,698,699,704,705,707,726,727,728,731,738,739,741,742,744,745,750,751,752,753,754,756,757},{21,22,23,24,35,36,37,38,40,41,49,68,76,77,80,199,201,202,205,207,209,210,213,214,215,216,224,225,228,229,230,231,232,238,241,242,243,246,248,249,256,257,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,853,854,860,861,862,864,865,866,881,882,883,884,927,928,942,945,946,947,948,954,955,956,959,961,963,964,966,967,968},{279,280,287,289,290,291,295,296,299,300,302,303,331,332,343,347,358,361,362,367,370,371,372,413,414,420,424,426,454,458,460,461,462,463,464,465,466,467,468,469,547,548,549,550,551,552,553,554,558,559,560,568,573,574,582,583,584,589,590,591,593,595,638,639,640,641,642,643,645,647,648,650,652,653,684,710,713,715,716,717,718,719,723,724,725,830,831,832,849,925,926,931,932,933,934,935,936,937,938,941,983,984,985,986,987,988,989,990,997,998,1005,1006,1009,1034,1037,1038,1039,1040,1041,1069},{143,144,145,146,147,148,151,152,153,157,158,163,164,165,166,174,187,188,252,253,254,260,261,263,264,265,266,267,325,326,327,329,330,333,336,349,350,375,376,377,383,384,385,388,389,390,391,393,395,396,397,398,400,403,404,405,406,407,410,411,429,430,431,445,447,459,470,476,477,480,483,484,485,486,487,488,489,490,491,492,493,494,495,496,497,533,534,536,537,538,539,543,544,545,546,566,567,576,579,596,597,598,600,601,602,605,619,622,623,626,627,629,659,661,663,664,666,732,733,735,737,738,739,740,743,744,745,746,748,749,772,773,774,775,784,785,792,793,794,798,809,810,817,818,819,820,821,829,833,834,848,885,886,891,894,895,899,900,901,902,903,904,912,913,914,915,916,917,918,920},{309,310,311,312,313,319,320,321,322,412,415,416,418,419,422,423,425,428,432,435,438,443,456,457,578,580,594,630,633,634,635,651,655,656,657,680,685,694,695,696,700,813,814,852,853,857,858,859,860,861,865,866,867,870,871,873,875,879,880,881,883},{329,330,335,336,337,339,346,349,350,353,354,355,357,407,411,459,575,576,629,660,661,666,839,841,842,843},{140,154,155,156,159,161,162,167,168,169,173,175,176,177,192,198,201,203,204,207,208,209,231,232,233,235,238,239,241,243,244,245,246,248,251,255,256,257,258,260,261,262,263,267,305,308,315,317,318,319,322,359,368,369,375,376,377,378,379,429,430,431,432,433,434,435,436,437,438,439,440,441,442,443,444,445,446,447,448,449,450,451,452,453,720,721,722,761,762,763,765,851,865,866,870,871,872,874,882},{325,333,391,397,749,886,888,889,890,892,895,896,912,913,914},{0,2,3,5,7,8,11,15,17,19,20,25,26,52,53,54,69,70,117,118,119,120,121,122,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,950,951,952,976,977,978,979,980,981,982,993,995,1025,1026,1027,1028,1044,1045,1046,1047,1054,1055,1056,1071,1072,1073,1079,1086,1087,1091,1092,1099,1101,1102},{996,997,998,999,1000,1001,1002,1003,1004,1005,1006,1007,1008,1009,1010,1011,1012,1013,1014,1015,1016,1017,1018,1019,1020,1021,1022,1023,1024,1025,1026,1027,1028,1029,1030,1031,1032,1033,1034,1035,1036,1037,1038,1039,1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055,1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071,1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087,1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103,1104,1105},{30,32,39,42,43,45,46,48,50,63,64,76,77,80,94,101,105,106,107,114,115,116,214,216,221,222,225,228,230,236,237,270,271,272,273,274,275,276,281,286,288,291,292,293,294,296,297,298,299,309,310,311,312,323,363,364,365,366,668,669,670,671,672,673,674,675,676,677,678,679,680,681,682,683,684,685,686,687,688,689,690,691,692,693,694,695,696,697,698,699,700,701,702,703,704,705,706,707,708,709,753,754,755,756,757,758,862,884,957,958,960,970,996,1007,1008,1011,1012,1013,1058,1059,1060,1068},{72,73,74,78,89,90,199,200,205,206,210,211,213,224,242,243,247,257,258,259,314,315},{414,415,417,418,426,427,428,462,465,498,500,501,503,507,512,515,516,517,518,519,520,521,522,523,524,525,528,529,531,532,548,549,550,552,553,554,555,556,557,558,559,568,569,571,572,573,574,585,586,589,590,591,592,593,611,612,613,614,615,618,636,639,640,645,646,648,649,650,668,672,673,674,675,676,677,681,682,683,686,687,688,689,690,691,692,694,695,696,726,728,729,730,731,752},{149,150,155,156,175,183,192,193,196,197,198,244,250,251,255,376,377,378,379,380,419,420,421,424,425,429,431,432,433,434,442,443,444,445,454,455,456,577,578,579,580,581,582,583,584,602,603,604,605,642,643,644,647,717,719,722,723,725,760,761,809,810,811,812,813,814,815,822,823,824,826,830,831,832,833,834,835,836,850,851,852,870,871,872,873,874,875,972,974,975,976,977,978,980,981},{425,580,630,634,635,658,813,815,816,822,825,827,828,852,867,868,877,878,879,880},{74,75,78,79,86,88,89,90,91,92,93,94,98,101,102,103,106,111,115,116,211,213,215,216,222,223,224,225,239,240,241,242,243,245,247,253,254,258,259,260,264,265,266,267,275,311,312,313,314,315,316,318,319,377,388,398,399,400,406,430,438,439,441,443,444,445,446,447,535,536,537,538,539,540,541,542,543,544,545,546,577,578,579,580,587,588,594,619,620,625,626,630,631,632,633,634,670,671,678,679,680,685,697,698,700,701,702,703,709,809,815,816,817,829,833,851,852,857,858,861,862,865,867,868,871,872,873,877,880,884},{167,168,169,171,173,189,191,192,193,194,195,196,197,198,379,380,431,433,436,437,441,442,444,445,446,447,449,450,452,453,454,458,467,469,472,475,477,478,479,480,481,483,484,487,492,493,494,495,496,503,504,505,506,507,508,509,510,511,512,513,514,533,534,538,545,546,547,548,549,550,551,553,554,577,579,581,582,583,584,596,598,599,601,602,603,604,605,711,716,717,718,719,720,721,722},{386,399,618,686,689,692,701,702,706,708,709},{0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,1086,1087,1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103,1104,1105},{4,6,7,25,27,129,921,922,923,924,971,1023,1046,1074,1089,1091,1099,1100,1105},{3,4,5,6,7,25,26,27,129,130,141,142,144,145,146,147,151,157,166,172,174,180,183,184,188,191,193,194,195,196,252,375,376,378,380,409,410,429,596,597,598,599,600,601,602,603,604,605,773,774,775,783,784,785,786,810,811,812,819,820,834,838,855,901,902,915,920,921,922,923,971,973,974,977,978,979},{149,154,155,175,176,202,248,249,250,255,256,304,305,306,759,760,761,762,763,764,765,766,836,850,854,927,928,929,930,940,942,946,947,948,949,950,951,972,980,981,982,992,993,994,995},{381,382,383,384,385,387,401,402,404,405,461,462,463,464,465,466,467,468,469,471,472,473,474,475,486,487,488,489,494,495,496,497,498,503,504,506,507,510,511,512,513,514,517,518,519,520,521,523,525,526,527,528,530,531,547,548,553,556,557,558,560,561,562,564,565,566,567,570,571,572,606,607,608,609,611,612,614,616,617,636,637,638,639,640,641,726,727,728,729,730,732,733,734,736,737,776,777,778,779,780,789},{160,161,162,163,164,165,168,169,170,171,205,206,207,208,209,210,257,258,259,262,263,266,267,314,315,316,317,318,430,439,440,441,446,448,449,450,451,476,477,478,479,480,481,482,541,542,543,544,545,546},{53,54,57,60,69,70,71,82,83,86,87,88,91,92,93,111,121,122,141,143,144,147,148,152,240,254,264,388,396,397,406,829,889,913,914,916,920},{294,296,297,298,299,300,301,303,559,569,589,591,613,615,681,683,684,687,691,693,751,753,754,755},{65,81,82,83,84,85,86,87,95,98,99,102,103,104,108,109,110,111,112,113,282,283,284,285,333,336,337,338,340,348,349,355,356,390,391,396,397,406,407,619,620,621,622,623,624,625,626,627,628,629,630,631,632,633,634,635,654,655,656,657,658,664,665,666,667,816,817,818,821,827,828,829,839,840,841,843,847,848,857,858,859,868,869,876,877,878,889,890,892,912,914,916,918},{416,417,418,423,427,428,432,434,435,438,439,441,442,443,444,448,449,453,455,456,457,480,484,490,493,502,503,504,505,506,507,508,511,513,514,519,520,522,523,524,525,526,532,535,536,537,538,539,540,541,543,545,549,550,551,552,577,578,581,585,586,587,588,594,668,669,670,671,676,679,680,685,695,696},{158,159,162,163,165,166,168,170,171,172,173,174,194,195,261,263,375,378,379,380,429,430,431,446,447,476,477,478,479,533,534,546,596,597,605},{17,19,28,29,31,51,52,53,54,55,56,57,58,59,60,61,62,117,118,119,120,121,122,123,124,125,126,127,128,1050,1051,1052,1053,1054,1055,1056,1066,1067,1081,1082,1083,1084,1085,1087,1092,1093,1096},{134,135,136,178,179,181,185,186,190,219,220,226,272,273,274,288,289,291,292,298,299,301,302,303,360,362,363,364,365,370,371,373,460,461,462,555,556,557,558,559,560,561,562,563,568,569,572,574,591,592,593,595,606,609,610,611,613,614,617,673,674,682,683,684,690,691,693,712,713,714,715,758,770,771,781,782,799,800,925,926,937,996,1000,1001,1005,1006,1007,1008,1011,1014,1017,1018,1019,1024,1026,1027,1028,1029,1032,1035,1036,1037,1039,1041,1042,1043,1057}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 1, nvert: 2
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,2},{0,-2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1},{0,0}};
linealitydesired = matrix {{1},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1},{0}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,0},{0,1},{0,0}};
raysP = matrix {{-1},{-1},{0}};
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,1},{1,-1,-1},{0,0,0}};
linealitydesired = matrix {{0},{0},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{1,2},{0,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(not isPure computed)
assert(not isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 4, dim: 3, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{2,-2,5,0},{3,3,4,2},{4,-4,-3,0},{5,5,-2,-4}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,-1,1},{26/11,-13/2,26/5,0},{-1/11,-1/2,9/5,-1/2},{0,0,0,0}};
linealitydesired = matrix {{32/13},{-9},{-16/13},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,3},{1,2,3},{0,1,2},{0,2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{2,6,2,6},{0,-2,1,0},{1,1,-1,-3}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,-1,-1},{2,0,-4,0},{0,0,0,0}};
linealitydesired = matrix {{1},{2},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{0,3},{1,2},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 1, nvert: 1
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0},{1}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = matrix {{1},{0}};
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = map(QQ^2, QQ^0, 0);
linealitydesired = matrix {{0},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,0,0,2},{0,1,0,0},{5,5,0,0},{0,0,-6,-6}};
raysP = matrix {{1,0},{0,1},{5,0},{0,-6}};
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,1,-1,-1,0,0,0,0},{1,0,0,0,-3/2,0,-1,1,1},{-1/5,0,-1/5,1/5,1/5,1,2/5,0,0},{1/6,0,0,-1/2,-1/4,-5/6,-1/6,0,1/6}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,2,3,5,7},{1,2,3,4,5,6},{0,2,3,4,7,8},{0,1,5,6,7,8},{3,4,5,6,7,8},{0,1,2,4,6,8}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(not isPure computed)
assert(not isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,0,0,2},{0,1,0,0},{5,5,0,0},{0,0,-6,-6}};
raysP = matrix {{1,0},{0,1},{5,0},{0,-6}};
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,1,-1,-1,0,0,0,0},{1,0,0,0,-3/2,0,-1,1,1},{-1/5,0,-1/5,1/5,1/5,1,2/5,0,0},{1/6,0,0,-1/2,-1/4,-5/6,-1/6,0,1/6}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,2,3,5,7},{1,2,3,4,5,6},{0,2,3,4,7,8},{0,1,5,6,7,8},{3,4,5,6,7,8},{0,1,2,4,6,8}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(not isPure computed)
assert(not isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 10, dim: 10, nvert: 14
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{23317/31250,-366203/1000000,177109/10000000,-306739/500000,208329/500000,29961/50000,-86293/500000,92747/500000,436199/1000000,213659/1000000,-445439/5000000,691657/10000000,305543/1000000,-483077/5000000},{44199/200000,-139403/1000000,-525737/10000000,-187543/2500000,380641/5000000,155533/10000000,-160979/2500000,60593/200000,281319/500000,-371801/1000000,288947/500000,-268571/5000000,-874143/10000000,-217887/1000000},{-346057/1000000,17637/31250,853023/10000000,39983/200000,-216667/5000000,20007/200000,-418873/10000000,112651/1000000,-11661/312500,414149/10000000,-205449/1000000,19989/200000,1083/10000,380389/1000000},{-131053/500000,-664937/1000000,120661/2500000,300961/5000000,-177507/1000000,323613/1000000,-111641/1000000,29173/200000,-5581/40000,44977/100000,-421899/1000000,-362799/10000000,182637/1000000,-899/4000},{-32179/125000,-281981/10000000,-59539/125000,19623/50000,179437/2500000,410753/10000000,-356231/100000000,93847/250000,244547/5000000,79077/1250000,-32047/250000,336007/1000000,95957/2000000,-212221/500000},{250339/1000000,-78211/500000,-102359/250000,38379/1250000,102139/5000000,408221/1000000,682889/1000000,-68861/125000,51789/1000000,-22297/200000,-250669/1000000,67621/250000,-415701/1000000,265077/500000},{-21889/200000,-6081/312500,383361/500000,-250527/1000000,749097/10000000,-46797/125000,160343/1000000,92671/250000,-908099/100000000,-185253/500000,310239/1000000,2617/20000,136769/500000,131663/1000000},{3983/15625,20249/100000,-195731/5000000,-220223/500000,-58871/100000,837/2000,91527/250000,289861/1000000,-113093/1000000,18537/100000,60743/125000,724323/1000000,78459/500000,-860287/10000000},{-168117/100000000,-240257/2500000,-17967/312500,386299/1000000,-205609/500000,-194651/2000000,131463/1000000,-97873/5000000,-30427/62500,246957/1000000,-552269/10000000,54849/500000,-451099/1000000,-70611/200000},{853709/100000000,-497801/5000000,102639/10000000,116089/1000000,-510249/1000000,-181267/1000000,-277701/500000,208347/500000,93243/200000,-602537/1000000,152277/1000000,-98217/200000,613083/1000000,-74131/200000}};
raysP = map(QQ^10, QQ^0, 0);
linealityP = map(QQ^10, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,1,1,1,1,1,1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,1,1,1,1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,1,-1,1,1,1,-1,-1,-1,1,-1,-1,-1,1,-1,1,1,-1,-1,1,1,-1,-1,-1,1,-1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,-1,-1,1,1,-1,-1,-1,1,1,-1,-1,1,-1,-1,-1,-1,1,1,-1,1,-1,-1,-1,1,1,1,1,1,1,-1,1,-1,-1,1,-1,-1,-1,-1,-1,1,-1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,1,-1,-1,1,-1,-1,-1,1,-1,1,-1,-1,-1,-1,-1,-1},{-395087605312287969219361216648602018715291879055628914362034528/149008900722892832570655864621981010304324229349239196234339779,-25369291191998256928529083514070407703116238588581812287119287/5237719526279200128879508764673708060454445449240725493674536,-51579979863918444957876723148742424407393922549354277612997843/70131738463282578360480407985176613664486127096808600728828123,-56154638215976295383234942795031800990977389987054382140726764/43834889288230390708167980221144857389874264631124930487326297,-12748835561673494741901198165236771838887636396571223641127604/16026612712025948526735426769203795396209881989443907724124041,-9480752499814823362888638036835327007710983695912289782190803/14042568377165693243294900042167961901879833998767580035769851,-4005401043838049645896108160629619009186018225697196679593115/182073352944510199931699681457010630793579514234031987897249973,-103516842477946949737619300822889453147368124654679363243516288/153155702033632087942501502372510797810128135383688394687190139,-19809864883276758886237058122176545418037620218009852097267658/29366842659911791775459432511500012986940202438547413754666457,11568238663821111892649616788086715053656378101611079764673749/32470298049625553825974948933799117497348512695366466249699921,-16959473209056588982498610519510939368900201017316380063579808/603547727018558848965857388301880441774372108719571266427707,-113445617083994016088421964059690144519733008097787893818500864/50184058008999575290025725440709916857363457004943949989761975,-22255650464351457359602635403378138199226999971051119273969018/18773404803929184681879611998850234075946023166297600642787231,-71792431319543928615119343647903329002264343051227646861048256/99146394102460963895589936857620569641217003580035712153752509,-484019597349462057929407666177400197070540878609376258425820512/190807400993432157839790299219277181745752515571994662206442109,-19716866485927904061030589087320780221598616224099785343109450/10580146425154730889149063022620523241001821258307035494165809,-298166355919516542008362764992437085614823509149568070396087866/271042692456044871277983162866513803310774132876225504355955037,-354574089435271714501715301535960543910758713881337247285918430/396404720764653905750119007838458840754051688046752287263369371,-16299015051748411970360038297303705752789533606855542713493946/23078600857277028312695436989517305123077405729457081087851603,-635643812981021939076890825912629147869954524232518113918895430/648187157921329534145136501530704198751578482955817688619010543,-4143056483734116558894542357687060979112698234133957324587638/4272654681641892237306260203013585351425190840767304376000619,37762263140177598048629776496913614748482481659291390732117630/93734400358040528489884143038935861940748607750275097284588573,-456876138031439584086294487446973895916142254533336722505339510/470548341421942907385889242960498823001062178805258039109093879,-5670064386906977657023070595864515656768515221139858177985926/5602180305260626458663151513209894732121522121129103119567197,-2230933977492685830570308595141769654730510718445582522200422/541528244368061022083511225980476649270580914252805200161381,-6951426597614716450540564229487139901846828617885601580267496/5473238079603641958592100858079420493923070304075223034798313,-10328398085599256549151776238469119927396602233889652827414758/7506223818821274825657351634859426606413217010736897209511971,-25426847808760250735378859983179462247517285471588386006900066/24787085395446413703427861288362557002036934736198122587399723,-20013539493190736783320108758435296925551953901659393875992014/4024818027283970686899510618752737252670220085092412467694937,1490942307972242988278465984893006889425584693694370758915145/331431241652564370989337017016346784298673776888537343715324,-13563134406311621825124883342933169739111519576957269063379169/1168825470033905846700307428382980650737128610126167496261343,12640639227517786179527290147030995495276738754860257901599761/14868041587819753037067541532758281537650137276850784900077700,-13762151344173423402737489578728288320368752650203633889140721/693560078153833075352772507394243276143617644472920395316265,-96245002381433826424066997941852766042104195107959314964616089/12674309076669704715221551836643621235024390814334449977747765,-1443908892168303401765625726713716170476093920807018436212877/327182629960657802342604374342964219445179943671428293327761,-363741188184282456294118637274997551480362827304924037115684/1081875493156341216491078213423389370480056866572270602654203,-17152217517014038905162179271115644389791564767056952279945040/91938882046356086401553224045446097890320532616695771573666263,-4805039442090913506583278433321458901901923427961764924423272/12743084487106943024517577033818431589956249849578071001721201,-1240124221986352983718250890977996684542136093078242830037308/2805394092913224518809264202763066053920873671389065888341101,-194426315417547325176109822738595539634020076964947817975019/2551434473437050874826100278396725032823238306752149596152671,29050803286933906756249881195849768196451039900253457970736923/257995804707298365963769936721142648236014471450183167305360563,-9778460634545535910105056720711036089151130326464940334548217/38652292313995070433391649840298098422136055740351286888948556,-18314039032006443021373047767115870112597234250338343969473667/47804714024230194203432150683956041544344645259368754755709536,-1033144328337545076127562693080248705080784496937742801033599794/1086672445339209205271795245476396992864576362734157593766753957,52509808250589068521094468251646661743061504865185768287572702/24167960594875809614185484768681450243080891597090131370313871,-35487928054516471980771915910027246813551865847798005632890950/58666662274875690355536378187935875761334331508325082734195233,-813074182204699008264585313808509198437348594735571350960759358/1202763184370624150670439480870925079178701939391212144956588689,-181907542407160967465771877046303921774518602223747657683008576/307356648592677227644529736304525062116115482570105564740588403,-100073679094722828930459526449908860511169641215382520147396182/114645209506369039152759465501256585542813741230927966695474911,8980405848462923441348668263380030812872176914884397219247863/362464551186560065739032084725819320691511567246207074622698189,-40654216036771654987267100183587511092877208141551318105980606/157569882863144451675882704907580940522812504887306708427841703,20457382967422478000336352611960804038086752896678139363411218/139275307159402376954822297455056705207844635235127461082028921,3328866106554007125856169220969187036771187657778463351611595967/1933638615087965400005743697145293080698241185137641577280348385,4090328976511288826181320355768144555314369175195523059790896032/13828272623005903959676677684707296433001459813812793530567997235,437803047645745206324327557372553660609597455433640557349504783/1035325657488223823094056819938560322608041976379094188847796840,11523451868234639949405927424030050921682337909018699256865423342/13813274421959904877770671123916426749492279895038726457619568185,8556436762748320995560924029515387099008813726402402381727050822/1693466634815835595028783709574027111765841547510528336149469085,-1971237564722777402016916579030093043426888286478123833116540953/992057553909039900795920516206907541771337500671314682439095860,-7193048344297935738267035215844709606423004443465702094995405/25182724643676570484411723758915014989712125195528134703440254,112323299451631856731925904054558296089292861030377528657805395/114717755068706933825691242495828539161203002446488004483755792,1805509732675914853850110936974597010246820429620928236234874770/2236356497231345157776305107091274736314221549138063334779925241,418931077306544736951141917604213010290118263223455171372234935/611012032326055247641765438206235111800341590860591386398873258,361123052500523432441251150697965725891767183737302601866789102/115388865866857148703372178926540786546992135986399020583039465,-121336087443118624910860766296836873103847288826061715781148291/191045123547792861322494688282991849942712501253679262851931627,-41135215513916078128689911430427205387782720848399860994622859/160418008922860777418869967375985172439283492709059898247845532,567128410263676741884141025496378838229172634727048387841627190/89220985289576521125334126924934072687484142232983663158125539,1078328891209131511633381609766879807454695380707799627271067681/988958988360005304596552238854906445265248711072830107842600158,286651731986386689772399349662554453753069958483133799882049056/30913417024351377680855676705663534649309225176033226358955049,201373712599025609288303906418600044109819405562000309248034938/334448041814451045588867729959696322501144642474797925002114929,59010232466306810903668943949177519370076155552969027927333023/212415548627850021227191371700832979416142915246896071230331814,512212513936548374529472191631645631161885820362149958458028222/575310837274500917717840203259744628650960351673725226027484785,999670863539333380933463143880606117390730272841694649318274910/1051616385695126790045688423442181313090404519849247000505070251,95393901885639472239129459960596097265311636585401371975170407/19940798536354907107114009938307644793200078291661157334391313,1967227452817933088752801539667283511126610077915918431552118422/854182231562306069257106349869540174678305812099907243579845923,527353193105580683078173693764523025884965480798989637251029207/527878771459612806593214508669253914328994568727679404476324318,914493427926351401693227975453724037400024474941342303046485977/88023728929805660923568125279355764058875197362041809623668931,3187885991578266725873632086249666483517520426599328028662135381/526797141389945337268040714089752381997584978356473138607436937,657192157064699099620111270505025811248295401453772542969450167/19654060835675962361275725723308347728185719633950773134546901,532611548044056213455213616615455522641834859129360023225362473/86521611342927374164899423785428896928608138147157180993128181,11345324430335239599544861764597099487787380129233203991621971/4939383652298265820496180741736420051256284123331750758655238,-86310183586407216849021907567037580687518679953015093135379973/31799362744110215077800698512891530629485819346543265812100719,339115603617510134195710951506091689445583062815989468752350695/341824699768120301575338360715543836724385477756462921728824826,-10367311345512880435152692561120040281956734630643655825361407/10922795760932801806547901845853648749057526881134631981402,69912306320056905285276327871529741184749562589527792662467534/16062437044862260017420044103128173011619736807974396462625023,-294250360844098134562145344090793992030517028498155757666330949/126005867936055967086713101421558562162702524580708586252908839,430352329091587749171061969472859268969794803138000018562860101/506614404456914147583184883044355427828039737019406082078801802,-43941201428851131320570253849260044641057072121511806148822017/222231020618006465059032487054368288347768221174384515421770299,2572265284578615881751028513385657863188610726280607322347520/990242530297765481236679884247451703230338978976058101410293,-1160967006781222312207766038310426017677867983411828372780419383/443518809801349690567265830693775270754130759964582793448780703,39108001875771290734556644300792708060488368187127109875802734/9224179278998307704459429421804619971595795469793635953612117,-557306640250263341769415654659655360406486712340268808057158511/231285194763364173816861077755992322317776169376036195004431583,152238961150369817353043677263746864037909399701851391349400975/166317517282913985958837803500073250055081537737312009327685918,-64960564502669002852744990879575934973439865761574482161427948/49753881962944310712494654083870561911902311747106624676647165,110865356238363082921929499580299991384021861713965409771183936/141563395355961250221448979142409658923242924076707447605434815,144741067128300558267583327884076548438095709422808227826829645/202313852309944714540875829743295699173012059175767504781457591,1167740014770403302975934878175116594886475281776897772114778275/538194080190739514300488814305711036874180338109755343860800986,-105079354487226617218184219624159247076145827016484868578568546/160796798597372188436217357113740725855175510796824890456054155,898599100546942687524344432512873371587907894678164912457693509/914161936321448376037456636516832073865990260235863107907094590,1668267100182828313905833037391195221308341129802091498386041755/1307450664601574322654755204176961468703622020212031291864115214,1351320516113506933742556119228862189382917566528512089733204705/266199728692157260868531599960194630497814624464656345825725268,45209181679689570796827404990343404398382459927925130227065273/15977514657288161543406440730483492334182258566778691059590714,-1236666025001578197671293602537394216788536846744724240167061557/482521052920542172082997152082752165971463498991751977991073831,89670091662236211001966489728447681111463155618955914811789907/202502742510940645606468723561539191561290857943007452284285424,19340170340373254718476563182249204334279627348098490686929048/8312892799558727207591277790467665470394666351362728757516379,1773946118364417851995444929053842430970284699925137180077432790/1491266295677743396903081999882727103741370743024222240000542051,-19721040150276602417430908201048971845250184536760214892792535/43836305865485841488687697090826290983572542504069361957756184,-99077910589565343372834121958735251189655637348645950888915365/28737815099666333962410392479500912149524536651592292423949571,-223016521731199369572126644165785144085219113233207688551887413/160535197393515256473166899447930158084051636819773963218309348,-234536572033480527407696572939469951907424562333661485506949090/3073912978114510703223052035222667652173806311599223412194895073,804371452768808989847564991657918308822504006551481177282127838/904081537146878599514324253463348761736980832678862851321520267,-553375504378259790532017630959998371791229525745274972260771863/1313464995749969331469509479915024104796746118049158995166486858,-207085702170218141292868411332694594003277338293906044917027655/211867597306059266595754999363513343447155348769134201061835104,352206867268486675779007292107039940387399878940429927723863166/314605648961812758626231895927318446999523749178332863248239843,-2721264776567043268811353034055037719093753810515267321478313/14312989656075926946495130685719575479786984263451471977120966,-41354347791340814190380000490289074392489029780547004267104586/83974528308576791139071178405007329231903338122441444271549077,-376991496271826675864852352413287809337568360911839368416293916/503571638948920612440980094813788449791781562454651074357759737,-14821479301466287659544186988673741855268495286595255706384357/27683667814853549230776450589322756010073053430990298184773119,-33504646470615313343321864347795814854125886942401769752448004/28817380338444742026694819294989310607554944760773885802745833,389084703224798277186774006320388906988746769260367375156059098/72442069088668324779053889540241027909971921601409069904859709,-649498698233934759043125679664203435445813958041239605114172454/11255917119475375924358883013457118794422274676767185942144217,4144763558268646824650583869835210757175714603630658566795702/20285922260872559036642559082703933446546988800088650530406321,2436455786262850164824194334598263436272077026144679477197908/29532355556585890741388465130498448822427108955980175194300057,179594383576910622461710165614244337413037473003472224021292832/130584571862130662964090388607258413380556569716658630844559237,-153302058455715327537598929675699882971659979744762801666367080/66117393717677274280441116154940882700604611916739378843909223,29853969264147121428844677135471980995437672467508279316912472/9688553096316137242757001918066654311672919088301459880560027,594969261036139639498536312671166452755476417400464740778987862/585770532299353869703242965455397788890307522096313210535856867,655115308655407878259919824373402323884246853621712130823888227/451653343988461920157140203868501374736228378868405880753449561,3518726072500511859145814432889266467202304407822386585192957/3659180796663591234155908457147513033630666469731629785413047,54816667025402726420714574843570871599968850251057455206553628/177204760680967089541753973545983831379975413017931596647471501,2462996695653221316557360198571368095175561996385715761188021/1262424754316138009476782286010944213375956384606587899069523,-899045581586516885244377729824707046879327275909783884054730083/363950339476211018847864584420778199838063930121487700634200904,-16529564952192580843823121987358020399488196523878422507054455/5640815449356665182750430832096960424001735673463404083111724,-23014761499951448256074155925187475535601520163027038397046340/38440999349326205999060859797611744620932612899491159570371521,-2969449108603599269145995589840785449925082244840894371769167361/276609191881491387352493714787359564942381172468784970199588073,-223037302493842629370758437786572005371847993438439613815831333/280792656484867133935043662674879854085256316201432821353340049,-42515125988481771985643283575525311499823070106604794686535243/54629680880633316997901354183671528522669291763427529780846801,-4954501726447160396973463322556945188978166796014525383740745/641456628245860262714382568568917665378171412561920292667876582,-420246243558955552055241742624532250188267303248918563997416889/156867719070172610723656213553900512298695260384785683017309121,-28813420889624231451979465886946613843103873991890485092396028/5531454904127615511905394369336879176386904946428670441775451,-2486057110467174785461525464990868016724606289394969605068434546/991774017502319138375229138396680924139635024445870386014217495,1100315984194953087327914775435538974824280521067335625298523030/1339373253090511317030526289588309543214362962706793090694346351,148796141833626773472273290709418989459867046197554401128999989/805390201660229047776285967064474610949534990554016403969382457,8252107640656009737509679565066331474210933252081762430404499770/6408958039354688095637714774549428421212963636431369124405008461,-252705601628334549874704866155678069892728036035132342088386180/1411033560801397396475655444286846508289723648540266060987865979,25721378824849570047191861097291032107893154427658474920774530/114175474576981992867258669896410766474108646739481778864544093,2909591580713928999893736334012598896367412742247486237344333170/5072926996923746977779578516290809653654134188372548431049926943,717511054205568592564561766210468891331704949503162591141864900/1236447908987023839436715739912566763987183639744795655478399653,1795167887222110107964212659012633673208805002527666353825158985/655606647619815604079658934358892719562754327987048249709592399,92239587076746074077864022992429175055366459135835524798398405/159061142521209223266293271335854549824800076232000348284729101,-1004155935971540534850850703307309868315630945287122255884401615/798492975381474402784228788390964354918768424802041358386447446,3255006759891803747967150114788098995937409560221078796308976010/7888378644075152870437351294957273310327234310892543035749348881,212454326404419678881194381614338216146208747973078162735315460/1053323742224506812403002107168904355126160235823091691901979381,-4232417020052823430080798689505631286684457946184628325427104255/1783993324207352601220062365630002446682966611567490425096514792,364442011394705735612654217337793398293443062672852859769447610/364278314098511127820919745113677628718003504792239528411454613,58786790835528353595047364919634791840311276641017166220704416/84092673764886127625102960778475090835768891934301200950080605,-251547421795278296585481582005756608065235307290282985022929695/6797762779059022545092656842082408997405493476905533955682391818,-268072614768900509347482523354790732002022796905756682965346788/412619184675082462011309582680574610641962431057054251333761207,-61038069199329315172968193987770161574655870784800682997146/6221168335517289605203454208134935689517270823826120635285,-10741857415671554376965256249155953287058932075948275190219489/1331591652166555275875659344946924614711242931555081461402683,-253280771787151812369121926877478017102233913573338075251818084/6305095233811826702230839878398307175743811332390362516664675,-30618025665896038476493229042576262360016157103124127394219806/5107674214063797454390810726914628078561617599283605609934409,-1898569240965410659549108651359320695655497990169548266026453/749770824353089975915843594968271965172220341379639011103217,-1129790590505374704093787322760074384204272808974477924759764581/321827125692995989594444913205807446798590907557259449513310079,-6099038685906506411963635355309097113552834547554771420576262007/1041567465927450143010608155374528732733832190910978788608207226,-1351255604638743392018876315087905592385358021762561792539180674/264527570450330800218111893254220270218519053844242632999527751,-38656430110488064850699760917636391007789028278081559057201596/135970969137821328543987585863614389380103965315946821121905995,-16651039928696136148318482307045869299805677416486301454261765142/6523499737925580328290687259429576168840679326204968618421739615,-557895152837429362603129257955813642957322682493581767320714761/252140286750192188029147528560450539174752741322835930640162763,-539370665473107928536315363854734724703088280736699131391708666/271751704797323232362861909144401612027348368891825140120903129,-10567542751843981274659924860120106923036307275902683302149183772/4823094804477520679211146666689078497095110531950694515929623421,-964664560471699459446056921152864434604344785170062781760599453/435182932473134722174876515770849921268157641862748762333517497,-86252310533261727985482259516670249496254599353376972215491681/36445093387114421168297462704144962849178128179122006817611746},{-20762913338818491252440897895629566751061148778952979547636149/7842573722257517503718729716946368963385485755223115591281041,-329523314157842627599624499109475046415720122563246232693468869/73328073367908801804313122705431912846362236289370156911443504,8829071443121689143896792824575721956702264188230886693787864/70131738463282578360480407985176613664486127096808600728828123,-51895989419761021055364203779986924696039241157667556086244219/43834889288230390708167980221144857389874264631124930487326297,858923672538101477653011016558328905460499122360301979689445/16026612712025948526735426769203795396209881989443907724124041,-128120762516572370789682303852194875972049195067972041791479367/140425683771656932432949000421679619018798339987675800357698510,99990607410454510704491925419279163692226831040157484802852410/182073352944510199931699681457010630793579514234031987897249973,-47790163391669467436439528375875579907865778441843657135272708/153155702033632087942501502372510797810128135383688394687190139,38670441264608565499554323744515132703957809069238267872304/29366842659911791775459432511500012986940202438547413754666457,218683331683381897450502216219231254678664595283457845572932/251707736818802742837015108013946647266267540274158653098449,-14442693953236335268691409478505837127858117804926701177042745/603547727018558848965857388301880441774372108719571266427707,-76374947547514363015984231692854541282756400586499436294896916/50184058008999575290025725440709916857363457004943949989761975,-75344025321357746948800680727988510148210372079730496457588203/18773404803929184681879611998850234075946023166297600642787231,-72477606168408443097583075985696821717187224801712309153373916/99146394102460963895589936857620569641217003580035712153752509,-200521447097879848525915386662672026789277480932778931991484719/190807400993432157839790299219277181745752515571994662206442109,-8176722643367391575345755923905941122298784048863621477706980/10580146425154730889149063022620523241001821258307035494165809,21682438942758156540499857308974324665881523062810998392410168/271042692456044871277983162866513803310774132876225504355955037,15697631015409276677842715611290418609778911955581415914210455/396404720764653905750119007838458840754051688046752287263369371,-519423603908834218810485090484591927807249852273870451892532/23078600857277028312695436989517305123077405729457081087851603,104445617890595141176651852013839559327042409327606732112222840/648187157921329534145136501530704198751578482955817688619010543,680156769896289117896646707609187923155157609380192860766480/4272654681641892237306260203013585351425190840767304376000619,38052616972299149482638240162088829587080767365787994419194720/31244800119346842829961381012978620646916202583425032428196191,98493235543993664249337853143745501651525209348825360040575680/470548341421942907385889242960498823001062178805258039109093879,1891943239435446824076224717863443487080971819291217767853548/5602180305260626458663151513209894732121522121129103119567197,-2035890399050352155283370571060646232924565318721749838745712/541528244368061022083511225980476649270580914252805200161381,-4436529229536550719103879882494390386474462288014675299257596/5473238079603641958592100858079420493923070304075223034798313,-14995649807964500814573002278775364256447937416065548018163776/7506223818821274825657351634859426606413217010736897209511971,2977142764298055498948334541763527547619976657300204826439384/24787085395446413703427861288362557002036934736198122587399723,-20565929559101196886776994786669052441877261900693134866544584/4024818027283970686899510618752737252670220085092412467694937,-21526899694294691191594469293839983968756300645682107700548795/994293724957693112968011051049040352896021330665612031145972,-19998416625497685119267686627966473300261588418521356371825761/2337650940067811693400614856765961301474257220252334992522686,-5351435208365784510854927728254580499864248836563102552371563/4956013862606584345689180510919427179216712425616928300025900,-24525066595182726465278092128747200200101821216787436792479353/1387120156307666150705545014788486552287235288945840790632530,-171989953053762484954618911990337017610402528198642737738393521/25348618153339409430443103673287242470048781628668899955495530,-13718891774132606961998116621914335788524080655193252888195273/3271826299606578023426043743429642194451799436714282933277610,-4508523050086184570060281154297944314316732314174093308137456/5409377465781706082455391067116946852400284332861353013271015,-47466919108748659869859784739933707189737858174440437038765490/91938882046356086401553224045446097890320532616695771573666263,-8238835277053926462911846317251961693905444098402133483610442/12743084487106943024517577033818431589956249849578071001721201,-1190305026601191477331085729850623480578117614221907430609386/2805394092913224518809264202763066053920873671389065888341101,2550096384703062603299251536457017152769425766999988508431976/12757172367185254374130501391983625164116191533760747980763355,117295468294669465321162366649191822688126750844254854011173159/257995804707298365963769936721142648236014471450183167305360563,2871958377966668730139084442300707326753919521702909164385755/38652292313995070433391649840298098422136055740351286888948556,9565884568587992143260763219084703548284320980876925934817079/47804714024230194203432150683956041544344645259368754755709536,14765092771926530115704611575376002344306311111268091975352536/83590188103016092713215018882799768681890489441089045674365689,-15138019448081566936639198054370917068070482389691567566334730/24167960594875809614185484768681450243080891597090131370313871,8964573440705948953126944517800442070039549601990145858703868/58666662274875690355536378187935875761334331508325082734195233,279357052429629974073553561022380865776842741540120146012604681/1202763184370624150670439480870925079178701939391212144956588689,-37247263068211146017201409596835319627363316668281706199127012/307356648592677227644529736304525062116115482570105564740588403,-49220835965862490968907019393159337190717776207418008907206977/114645209506369039152759465501256585542813741230927966695474911,241653300202146010068907815027815293833959163501290324206881584/362464551186560065739032084725819320691511567246207074622698189,35452586399004395583627045551138175124648810842137619823559327/315139765726288903351765409815161881045625009774613416855683406,43054722971626145321823047471629558642221083940772259472316121/139275307159402376954822297455056705207844635235127461082028921,4466234232295655443934997828574476587705745736098457087882582481/1933638615087965400005743697145293080698241185137641577280348385,53161309528095823731636104775165057554681376298536931410236031927/27656545246011807919353355369414592866002919627625587061135994470,2898669922111433293340799336200250650809552149770529253456634063/2070651314976447646188113639877120645216083952758188377695593680,23971548674106340295109086440222613855052263423807987590672688231/13813274421959904877770671123916426749492279895038726457619568185,9331737289217843808943572271057905667843997416010292252419638696/1693466634815835595028783709574027111765841547510528336149469085,-2112887726688833202302771924385674950142345402790030723358912609/992057553909039900795920516206907541771337500671314682439095860,-550089409570612756316663931068818811802698013105911802920971006/62956811609191426211029309397287537474280312988820336758600635,-53013181814271662094219806241927379016820254258024119058184489/114717755068706933825691242495828539161203002446488004483755792,-1022730120552105419698667655585091682384631178761715310705015171/1490904331487563438517536738060849824209481032758708889853283494,-516225637713474356000618539718074797921937063071701924765594075/1222024064652110495283530876412470223600683181721182772797746516,4250736021584918211872220223210170081758346354319642749498779774/1730832988002857230550582683898111798204882039795985308745591975,195473480430619010170062171126483547901927594284689482581517467/382090247095585722644989376565983699885425002507358525703863254,24828208653201711586582525697626870261536744778531585587618061071/5133376285531544877403838956031525518057071766689916743931057024,1240005673605740784470317135329580957265025423902809628964721381/178441970579153042250668253849868145374968284465967326316251078,1094608678997874186417276111417907013130036373059764094711371230/494479494180002652298276119427453222632624355536415053921300079,649850490776666751826063459119584199404535746786347455831754132/30913417024351377680855676705663534649309225176033226358955049,93385826834056012838732414881104706128693771177810172964723284/17602528516550055030993038418931385394797086446041996052742891,-110907731655814540551129182576083246307386521750975463861957928/106207774313925010613595685850416489708071457623448035615165907,358628076677497465863289165701899196817306494395552462993535875/2186181181643103487327792772387029588873649336360155858904442183,1345052911737058347321458217013814687036105747872647572820754757/5258081928475633950228442117210906565452022599246235002525351255,1960667360047211511908827372708650503939209673087156737502569949/378875172190743235035166188827845251070801487541561989353434947,21266867089577852993353653238898900910246580973736838351432256/854182231562306069257106349869540174678305812099907243579845923,-45689820437285387931362526693969790852973585981402661100000931/75411253065658972370459215524179130618427795532525629210903474,859924711549508718330445272307146906527975769128088126834195281/88023728929805660923568125279355764058875197362041809623668931,3514534788157789171758174285491544337474671791511535018008589973/526797141389945337268040714089752381997584978356473138607436937,684171193690649036078022602636080416940440755812450513041870791/19654060835675962361275725723308347728185719633950773134546901,978408830833680439275492538591692362342968590023815062267440009/86521611342927374164899423785428896928608138147157180993128181,3571392324811537445568613792879419632315795241360166106569807/4939383652298265820496180741736420051256284123331750758655238,-1169744671990715908812592262166264450685595534349439931482994033/572388529393983871400412573232047551330744748237778784617812942,44410102881000978776162151064605779224603234962657252668456255/1025474099304360904726015082146631510173156433269388765186474478,180780849202742520412165132630473521681214177530957006537374261/32768387282798405419643705537560946247172580643403895944206,-26133800917561747579422211146312611128723186774583539140907381/16062437044862260017420044103128173011619736807974396462625023,-568026493992186655038699289457941207838901317878185519372652165/252011735872111934173426202843117124325405049161417172505817678,-132799539992066186984396519494398667279007614311826889419920543/168871468152304715861061627681451809276013245673135360692933934,-134329812348706529059550768906482479299406135830224527206716152/222231020618006465059032487054368288347768221174384515421770299,-288114781132552981481452979078158215304473101979993896617420/990242530297765481236679884247451703230338978976058101410293,-2180944184173757832281502483598537701546434165317878142748888967/887037619602699381134531661387550541508261519929165586897561406,-167940374838133794001947466782150212814658397620544154270473333/46120896394991538522297147109023099857978977348968179768060585,-1104933450928880053136591147079116477896472035464067849879849263/462570389526728347633722155511984644635552338752072390008863166,-34449683486300249762313040850532107442958632023827211597116105/23759645326130569422691114785724750007868791105330287046812274,-27111454764697845007754868513796009319885149986398800072225281/14215394846555517346427044023963017689114946213459035621899190,-5771803413161431571541281451102878840903575748773142849675691/6741114064569583343878522816305221853487758289367021314544515,-58891052547729396743134382107617494941327669238435468917041370/86705936704262020517518212747126728217005168218186073477767539,-452657095055733535449574753484659462740359759437308818344485055/538194080190739514300488814305711036874180338109755343860800986,-511813405884298249128144066579329062239092949964340550661150469/321593597194744376872434714227481451710351021593649780912108310,-231432818014633577351516333173662069602667055114357345952156487/304720645440482792012485545505610691288663420078621035969031530,-1600883109022121961167900810553081448058345765837110917681095405/3922351993804722967964265612530884406110866060636093875592345642,391624492437632268280688464001690171325158083838305646642764295/266199728692157260868531599960194630497814624464656345825725268,16202728462422050188368029708612089498367084419056523608159065/15977514657288161543406440730483492334182258566778691059590714,-2297078646811322567795989282811466603738468797817097054179838273/965042105841084344165994304165504331942926997983503955982147662,-2586615362941814674613281820502789293719995036472602547415069/101251371255470322803234361780769595780645428971503726142142712,72201691549698243308321827936026679615719714742498730516175552/8312892799558727207591277790467665470394666351362728757516379,3289062493877048865498868450928736886008278704282982304842380040/1491266295677743396903081999882727103741370743024222240000542051,-206018064006652501093691018317539483510714108157614920262699487/219181529327429207443438485454131454917862712520346809788780920,1678905536812702713290520010369469660466825214899300436263928972/143689075498331669812051962397504560747622683257961462119747855,-45394285639740452907180886647906501966441813773160485444842942/40133799348378814118291724861982539521012909204943490804577337,7698240760012781651986693708179651423770378955660608599107701285/3073912978114510703223052035222667652173806311599223412194895073,1696135960552802676904224635478941338012599432764415597364208580/904081537146878599514324253463348761736980832678862851321520267,-615503087173343041635767298608579605988890496139323847386316878/656732497874984665734754739957512052398373059024579497583243429,5409791686037771406562123013680829081040587225275055279990482441/1694940778448474132766039994908106747577242790153073608494680832,10441147273915874429874040566207506368059233543117668059454183348/4719084734427191379393478438909776704992856237674992948723597645,-49508738299539609804765619201722914847822888406038850266610829/14312989656075926946495130685719575479786984263451471977120966,-121826185675663150197631574872716557282564205183055620427503503/83974528308576791139071178405007329231903338122441444271549077,-1000786251335155831717307093239052577986507819046846619186195453/503571638948920612440980094813788449791781562454651074357759737,-182520540056934111649568648547667795692640111575031281669914533/55367335629707098461552901178645512020146106861980596369546238,317469516997412436486612332056465181702759080428578485771885442/28817380338444742026694819294989310607554944760773885802745833,2281697661720521004269379300841155180506542874315846875398687796/72442069088668324779053889540241027909971921601409069904859709,546495412565781043640116563721316179673785797969283846463836292/11255917119475375924358883013457118794422274676767185942144217,760227891612689553122370970488373753035259219061427199142954336/182573300347853031329783031744335401018922899200797854773656889,24334469593543273927415706745767377155675926592016945752979700/29532355556585890741388465130498448822427108955980175194300057,132617887627482556613789505746164720243865815077656862156234060/130584571862130662964090388607258413380556569716658630844559237,-58567807034193151342785640914047466779735995038568775912467628/66117393717677274280441116154940882700604611916739378843909223,220110691073782722832597873973211977957845109805869607232777100/29065659288948411728271005754199962935018757264904379641680081,1234794599921097077697738556266244808337973115253886002370447424/585770532299353869703242965455397788890307522096313210535856867,1068931207910928746072861064832770927397885490688121679918911754/451653343988461920157140203868501374736228378868405880753449561,990152599904955845557491591431598515385791155781846733214947547/504966949939575590313515367086356798641031972822964910387000486,336812204424559659315598379133625066056791814077872409602349256/177204760680967089541753973545983831379975413017931596647471501,-336787234862825866654257907903143656672786062694750525859873997/37872742629484140284303468580328326401278691538197636972085690,-579142974906848422334277034549226710427141474247853960953990265/242633559650807345898576389613852133225375953414325133756133936,91270343382241195112208318054257436637738340294187728830626754/7051019311695831478438038540121200530002169591829255103889655,9131919393460159839787794352335099572871458341524182622648547545/538173990890566883986852037166564424693056580592876233985201294,718091132621791111482835714246675569007986177145004705945666111/553218383762982774704987429574719129884762344937569940399176146,1841192484341652411514741849225932263602361233468327967895631789/561585312969734267870087325349759708170512632402865642706680098,-54402802188944673373534109231039536533265737395820701207709321/54629680880633316997901354183671528522669291763427529780846801,-1579853454699950335005334745088962095792080219066299296672339635/1282913256491720525428765137137835330756342825123840585335753164,-1542062419768255183521929277042501303026313600105088508868090773/627470876280690442894624854215602049194781041539142732069236484,-157760063179594851217839849563940509782774574577339742779668087/22125819616510462047621577477347516705547619785714681767101804,-12475512203885575944463297211679818869004661301898685835455214946/4958870087511595691876145691983404620698175122229351930071087475,18771041408155235246342997259455503516046016437606183089916002325/5357493012362045268122105158353238172857451850827172362777385404,-2184362921015619721418957898543879877727217526122320358744421947/1610780403320458095552571934128949221899069981108032807938764914,12566801276707237265070245668965875544042004581929480319384182205/6408958039354688095637714774549428421212963636431369124405008461,-1428401938034262226027658260264517237952087192626160129022911815/1411033560801397396475655444286846508289723648540266060987865979,-5662357596301162748316243115369306872228570702591385871435078385/9476564389889505407982469601402093617351017679376987645757159719,-3770823122580574388648230806921089893994631325749991705568532552/5072926996923746977779578516290809653654134188372548431049926943,-1134747938305473286812553037870919975608173667598952968280655957/1236447908987023839436715739912566763987183639744795655478399653,893482121822782391980605971285104343990133724348169701247464781/2622426590479262416318635737435570878251017311948192998838369596,-449410093379801949373723407902401139089110297854169952475423951/318122285042418446532586542671709099649600152464000696569458202,-1488060777547005444229077703356318277699911977091819107439425899/798492975381474402784228788390964354918768424802041358386447446,-5070707566566461308296531210355484998008934112662465375455078177/7888378644075152870437351294957273310327234310892543035749348881,-1276042442183673985837386174115653979265082539144536925374214577/1053323742224506812403002107168904355126160235823091691901979381,-547552912909458898790119923413513671458168618877075155959278458/222999165525919075152507795703750305835370826445936303137064349,258952912383765712582016763858119518051374398157343151594110615/728556628197022255641839490227355257436007009584479056822909226,8230619384086477800545610899848336280518518542514811634608583/5606178250992408508340197385231672722384592795620080063338707,19051123508964750322172670158404820589743615201198435020639985245/13595525558118045090185313684164817994810986953811067911364783636,-449600014967481609526468757897916185979465424956462083322490571/825238369350164924022619165361149221283924862114108502667522414,-10111184822812407844680782831263107366030674836294785073786301/124423366710345792104069084162698713790345416476522412705700,-575159496013387618464698219827289908314894034952488638707218933/13315916521665552758756593449469246147112429315550814614026830,-4298342344912881981966188215819708733448945828369720817856446121/31525476169059133511154199391991535878719056661951812583323375,-557615068419374044039684627433526895956463319534622498431341841/25538371070318987271954053634573140392808087996418028049672045,-10080357241778421471783361815020861707112578040267858146763231/3748854121765449879579217974841359825861101706898195055516085,-1987302870658652304270407279724788661108148316026949992016408489/643654251385991979188889826411614893597181815114518899026620158,-336148146442897640992590557493249830924693463080161507699888733/2083134931854900286021216310749057465467664381821957577216414452,-2191747363290560868674983832819512020848988507557450511397700429/529055140900661600436223786508440540437038107688485265999055502,154588691264486952715654989114419128212389068703424639793469643/135970969137821328543987585863614389380103965315946821121905995,-16632212710560791810940993885437393034082213193440011767025962672/6523499737925580328290687259429576168840679326204968618421739615,-1161587414108095283171909910008293332762283921465925556491719029/504280573500384376058295057120901078349505482645671861280325526,-580137975535355815334956757902656980263968482321731272888689545/271751704797323232362861909144401612027348368891825140120903129,-10863554958515126596166711328863115455913518096433349827675945559/4823094804477520679211146666689078497095110531950694515929623421,-10019247192842123202395247624551871725287464310952418095580463223/4351829324731347221748765157708499212681576418627487623335174970,-2643584385901176821491933523759461752751477951608460051902550879/1093352801613432635048923881124348885475343845373660204528352380},{8966183658080333441756559587656383360445302682108210629315901/99339267148595221713770576414654006869549486232826130822893186,-1763143280635541622514013211464603715551713832171711292953/5147997287834091673989969299735461446669631865302594559916,-27974516555291024208887157626992221477615639414242146415713766/70131738463282578360480407985176613664486127096808600728828123,-119498789953655986851844211402805706061884450037331660350231051/87669778576460781416335960442289714779748529262249860974652594,-218779160311921099904318056216129903996298083057724994908505799/160266127120259485267354267692037953962098819894439077241240410,-3290051672247816888678564157009409824158833879242743406083343/4680856125721897747764966680722653967293277999589193345256617,-62444904275345553928552338658837557565504753159746784563991236/182073352944510199931699681457010630793579514234031987897249973,-130519817417801221135382830196211749992954295995447634443575065/153155702033632087942501502372510797810128135383688394687190139,-159988811424908263008940063736538998326141429500831738441941887/146834213299558958877297162557500064934701012192737068773332285,-3936659682522669243061589848389674177234768465256221742741190/32470298049625553825974948933799117497348512695366466249699921,-11946897985628644745065939566617091773346703398495864414301647/1207095454037117697931714776603760883548744217439142532855414,-6899726216307841571678354039140383514981962388350545452103237/5576006445444397254447302826745546317484828556104883332195775,-52052442256787155445569360661508652988394972407138894125098657/37546809607858369363759223997700468151892046332595201285574462,-102595385201137411892076098329738932974714206017392207495253327/99146394102460963895589936857620569641217003580035712153752509,-759328064990561497477895908468602902731822014647358352553481993/381614801986864315679580598438554363491505031143989324412884218,-78308129883281243898651183221783157991997822177396156436891903/52900732125773654445745315113102616205009106291535177470829045,-437104866751355196924077315513316558787453831708055173201868649/271042692456044871277983162866513803310774132876225504355955037,-1560797854098534250637626111096729953005584246155300942481837275/792809441529307811500238015676917681508103376093504574526738742,-162874453073104356584823488861762108008379952368727002390849709/115393004286385141563477184947586525615387028647285405439258015,-148844498083299698344148554815007184258546300857952327277938293/92598165417332790592162357361529171250225497565116812659858649,-18828386852569099303868666634606062055081516123172768296531395/12041117739172605396044915117583740535834628733071494150547199,3578123543494165036595387404403105663653940887466323370342419/93734400358040528489884143038935861940748607750275097284588573,-744575697204783713039381400262828388328995466571852411062529863/470548341421942907385889242960498823001062178805258039109093879,-9478141440848787849488948497322338591238734680719232916263701/5602180305260626458663151513209894732121522121129103119567197,-1646688773107097179548165572617066932409607899081161936953549/541528244368061022083511225980476649270580914252805200161381,-6481043247425712540105623162444904490318322807125328558428555/5473238079603641958592100858079420493923070304075223034798313,-371048568227801050907459732837244660929319021809320123637075/2502074606273758275219117211619808868804405670245632403170657,-39688055084899570979984949807594740091113261811436223342646815/24787085395446413703427861288362557002036934736198122587399723,-16013941915825310073594165664767227037320611836728811101251285/4024818027283970686899510618752737252670220085092412467694937,-12432869778450316240911545097891812511864982337064963880405966/248573431239423278242002762762260088224005332666403007786493,-5761810147710495258588953892467808565331032408335814128277781/1168825470033905846700307428382980650737128610126167496261343,752047377671306217429878657473538902298003516355371832103486/3717010396954938259266885383189570384412534319212696225019425,-3620049683453859554406118668746169337277520660801821294199197/693560078153833075352772507394243276143617644472920395316265,-3376278731185345412180366100342315839785489768942816727177653/2534861815333940943044310367328724247004878162866889995549553,-48959579769252267693984050105552616023981939357235634868839/109060876653552600780868124780988073148393314557142764442587,-372278538566497406260436979134075228758385475318804037115309/360625164385447072163692737807796456826685622190756867551401,-88564562337878193472404733030099534353119047122370782402684291/91938882046356086401553224045446097890320532616695771573666263,-13274333148764083291034612906275772452428216868292831634205305/12743084487106943024517577033818431589956249849578071001721201,-3121872152882190010257403640091683434501163123433012945789685/2805394092913224518809264202763066053920873671389065888341101,-249075629909635065935819612883232764111142175466435846879881/850478157812350291608700092798908344274412768917383198717557,-101285348290792428997430820126194453830660556271775248781127319/257995804707298365963769936721142648236014471450183167305360563,-11966268096060211098776148916208251651687875067581376228068135/19326146156997535216695824920149049211068027870175643444474278,-20113924540713636895094374938452451645838589412669857120623825/23902357012115097101716075341978020772172322629684377377854768,-1668264819272922722331997796626310597525544122801162617764951425/1086672445339209205271795245476396992864576362734157593766753957,78644130916714329086806005583415450128236175335444639697994405/8055986864958603204728494922893816747693630532363377123437957,-290675321067913382444288086275909226889143583404068760503602887/293333311374378451777681890939679378806671657541625413670976165,-2812192444911515911931077406657710520959920421297246347427027393/2405526368741248301340878961741850158357403878782424289913177378,-227257210421414521279938873414475409611641933449359074867267905/307356648592677227644529736304525062116115482570105564740588403,-210621370186017915169223458419396344795917550813853759346066823/229290419012738078305518931002513171085627482461855933390949822,-33045277278977541904325765037485900446285212281989921018002932/120821517062186688579677361575273106897170522415402358207566063,-8514920788950864035653206234682666746260183038725368877595175/52523294287714817225294234969193646840937501629102236142613901,72146985037925127495337669335890748668487374189442456746168167/92850204772934917969881531636704470138563090156751640721352614,1379527900341710078779871603280727303134395456794011619264506996/1933638615087965400005743697145293080698241185137641577280348385,-38460534799972102586185302807695339319664699159195811975355745061/55313090492023615838706710738829185732005839255251174122271988940,717982547197143424269649727810357534870183412169753184141651591/4141302629952895292376227279754241290432167905516376755391187360,9958893326623526117086885810915011288722844472672959960148121717/27626548843919809755541342247832853498984559790077452915239136370,23597857047013142718560189758775904082607541463043493960600283247/3386933269631671190057567419148054223531683095021056672298938170,81639359255901883726132020009590073346525192241432332619382151/248014388477259975198980129051726885442834375167828670609773965,204024810873465605480322262642202329597342918047486341036599032/62956811609191426211029309397287537474280312988820336758600635,670780607916506952327557318807679968115766210197382002586255083/458871020274827735302764969983314156644812009785952017935023168,2210682662601689896937629833842494971471146226508433830946259227/2236356497231345157776305107091274736314221549138063334779925241,434745519731054571324468741519563468563127291035659844598910413/305506016163027623820882719103117555900170795430295693199436629,19690197102812599671489814057071319831220877398453222105188562611/3461665976005714461101165367796223596409764079591970617491183950,1112205823401966396185344594149931665986353658524280992860864931/764180494191171445289978753131967399770850005014717051407726508,-26281690171853911785525001278751673616367486918434928650160391653/10266752571063089754807677912063051036114143533379833487862114048,922901749604235937921583920709879478283259847456548558956953433/89220985289576521125334126924934072687484142232983663158125539,1384381220343766201534506162676171756463670593873305502751765341/1977917976720010609193104477709812890530497422145660215685200316,447157167390531431773493306110571900391981480590004218800768961/30913417024351377680855676705663534649309225176033226358955049,-366708080684901121364399048882170433989786036565525545790194531/334448041814451045588867729959696322501144642474797925002114929,161979921326214849499036800495713710379179403764097651140986855/106207774313925010613595685850416489708071457623448035615165907,24588474974606741583557499146946255941000088438538481801284500547/10930905908215517436638963861935147944368246681800779294522210915,2455853101948635986565203039588182124963855005088433286879079197/1051616385695126790045688423442181313090404519849247000505070251,864468281250939075988036014189930958150483988660545660104051313/378875172190743235035166188827845251070801487541561989353434947,773894471555348494111794647862970306332934483730644885134217899/854182231562306069257106349869540174678305812099907243579845923,229159719002743341054095500101941603279863331657152293356073117/263939385729806403296607254334626957164497284363839702238162159,928945441805397871794331576386306419063828203389843777565240485/88023728929805660923568125279355764058875197362041809623668931,1907547175230326340696472478282180750804742067117307645750114745/526797141389945337268040714089752381997584978356473138607436937,477896505532282701120926203481002405821210901089945758630231235/19654060835675962361275725723308347728185719633950773134546901,150615947302750004150688346575377716738368119401666561759747965/86521611342927374164899423785428896928608138147157180993128181,-4172922465448117979231658017781736864270883019359479172165415/2469691826149132910248090370868210025628142061665875379327619,-76653251648948365996420534729190612522687214985122619398446143/286194264696991935700206286616023775665372374118889392308906471,-132895619317748764952713796243547814072628376706636741136459207/512737049652180452363007541073315755086578216634694382593237239,-128880842073897749639445224249693227334399997659126548964028035/32768387282798405419643705537560946247172580643403895944206,-16559187430519759401592477554226892056523197535911761559409655/16062437044862260017420044103128173011619736807974396462625023,10054015574419078157072377580039665475385057434969905882989481/126005867936055967086713101421558562162702524580708586252908839,89591130232832763663485257631729144147313321887354064336850319/253307202228457073791592441522177713914019868509703041039400901,66664337755996420168882272365235004020280728198521889682995265/222231020618006465059032487054368288347768221174384515421770299,-582647048586726298443067287780668934776378168510836586703186/990242530297765481236679884247451703230338978976058101410293,31854848353009885069470999225844841496115084155196925281455411/443518809801349690567265830693775270754130759964582793448780703,-8534230064073321820287229688346360095649553211239672772687823/9224179278998307704459429421804619971595795469793635953612117,28080017288657797890817400894048080448630953892983837804920721/231285194763364173816861077755992322317776169376036195004431583,31017490610781515130265323498305759057812092687258427188601953/83158758641456992979418901750036625027540768868656004663842959,2282508066388749335402133548960836149024750315951727510743455/9950776392588862142498930816774112382380462349421324935329433,51918405532039207221555631969439153767632747135563448136406449/141563395355961250221448979142409658923242924076707447605434815,101012006773722930740856556019477977163611400564547905761754351/606941556929834143622627489229887097519036177527302514344372773,110497250888054085971595653902234211837468098850001420245921631/269097040095369757150244407152855518437090169054877671930400493,8009239017289624289483862314431811208637887429144684683985105/32159359719474437687243471422748145171035102159364978091210831,170375037209844732759360662974297942890750468515212112398275943/457080968160724188018728318258416036932995130117931553953547295,359834163168055558541545905691227125697699804383441397172394777/1961175996902361483982132806265442203055433030318046937796172821,135302005502408240917069495625978080599796708154407657489771064/66549932173039315217132899990048657624453656116164086456431317,-1143371511817289583603358725238386272060853321374059361005738/7988757328644080771703220365241746167091129283389345529795357,65257306378959528005074205674518656006058969311041579341629897/482521052920542172082997152082752165971463498991751977991073831,101471408159158023364356279745371901729732487463554736318848821/202502742510940645606468723561539191561290857943007452284285424,-26122615682931825846491862139587477455644902628029593914621504/8312892799558727207591277790467665470394666351362728757516379,890356326989159101321060050936836410090024306984973863133666473/1491266295677743396903081999882727103741370743024222240000542051,3987228793358412172632041254918148466725899383301632065376337/10959076466371460372171924272706572745893135626017340489439046,-261609132161274900919771694435063573597439532510513181259895288/28737815099666333962410392479500912149524536651592292423949571,-2513252543753809128882259788718330918276008020807670734560686/13377933116126271372763908287327513173670969734981163601525779,-9547198511454334638787788324390424371030721216579084538155276353/6147825956229021406446104070445335304347612623198446824389790146,1917093119884172349308992295223820223601800138325064987645768271/4520407685734392997571621267316743808684904163394314256607601335,529988548616282726343760924970164534685643587214241429813588249/1313464995749969331469509479915024104796746118049158995166486858,-3537261859207597193994275427729403650939308066240054810891383611/1694940778448474132766039994908106747577242790153073608494680832,708406553027680326877070957244720599462935713986200899240021259/943816946885438275878695687781955340998571247534998589744719529,2981533807801825305696067662702329939547140701694655320830320/7156494828037963473247565342859787739893492131725735988560483,33036362187475450843434939637052156510988656719359232614139955/83974528308576791139071178405007329231903338122441444271549077,-15899443228077393398573000217061911927409673055040166024375645/503571638948920612440980094813788449791781562454651074357759737,22641548797767803204929800561678748972570985909918710703580625/27683667814853549230776450589322756010073053430990298184773119,-173322769943110959339769013849258624238946190044137869606871357/28817380338444742026694819294989310607554944760773885802745833,-815141470327993293639819459023647509212720470636374295360769751/72442069088668324779053889540241027909971921601409069904859709,-382942054794468415845501557593286163398357048591703807922188117/11255917119475375924358883013457118794422274676767185942144217,-266827741296780709233313038176836465524428093686699220479459531/182573300347853031329783031744335401018922899200797854773656889,40299624414366377258083222196280278236674899009829716559608671/29532355556585890741388465130498448822427108955980175194300057,225493763050858486692246942355492176913231643855199654024557187/130584571862130662964090388607258413380556569716658630844559237,9106326185060695536190452612145472520761163078753910100109161/7346377079741919364493457350548986966733845768526597649323247,151180630879395171696821499993379635394793421561381080018341577/29065659288948411728271005754199962935018757264904379641680081,346753010648979949810165991006907229975760708447478206130081909/585770532299353869703242965455397788890307522096313210535856867,749258058306381691102257762772168206841406724891023659967383517/903306687976923840314280407737002749472456757736811761506899122,552217650021650321857224849111039090087501305182314834938630429/1009933899879151180627030734172713597282063945645929820774000972,289345430855237174875229090151487007577618125833484838044094499/354409521361934179083507947091967662759950826035863193294943002,25936583739734522294526618666025017415448086764396569555646089/3787274262948414028430346858032832640127869153819763697208569,2555765149036377255401688883542024161862223241868484825276087/10109731652116972745774016233910505551057331392263547239838914,-2779616129026203470147653870325957137770342641238659198017439377/282040772467833259137521541604848021200086783673170204155586200,-2485092677013889613999808355734037572637965502061352238237015005/153763997397304823996243439190446978483730451597964638281486084,-8073832568505162229482305321254277921959465276651748106474140913/1106436767525965549409974859149438259769524689875139880798352292,-17119630941701440263972778829852344198941829442006683189177947373/5615853129697342678700873253497597081705126324028656427066800980,49254067366380634389759705755906363074949101031808448618969451/546296808806333169979013541836715285226692917634275297808468010,237244510632188984749299738770995128445371756393036457133869245/2565826512983441050857530274275670661512685650247681170671506328,-149457992120391677272337314742886756296337725389801492145357649/1254941752561380885789249708431204098389562083078285464138472968,-643282795776529704270599539593103932837352507669450180782684713/221258196165104620476215774773475167055476197857146817671018040,1292010732498574979767639272120785168654302252354990506006716331/9917740175023191383752291383966809241396350244458703860142174950,-31171245634210985105362328748297558472155231217972563547942097175/10714986024724090536244210316706476345714903701654344725554770808,117993490462886741536795954927920264595858390912440378745185237/3221560806640916191105143868257898443798139962216065615877529828,6992004567331328602904126810860640804804236176650096622709619895/12817916078709376191275429549098856842425927272862738248810016922,540204234296272193395195741935506896120965618205609006924626773/1411033560801397396475655444286846508289723648540266060987865979,17742795326904457659530139224805598364288211736803915768096133/9476564389889505407982469601402093617351017679376987645757159719,1772177229207781097450422760050493475722731755410796284891386461/5072926996923746977779578516290809653654134188372548431049926943,725203515315534230726290978828890054228959545588623377818471851/1236447908987023839436715739912566763987183639744795655478399653,1291882665009757255407179862219441065949432563038009865263524998/655606647619815604079658934358892719562754327987048249709592399,111922976333230874211873828203480333962008581521637570356846387/159061142521209223266293271335854549824800076232000348284729101,12493454342047353521852321001619933977980106051957079556103111/36295135244612472853828581290498379769034928400092789017565793,-692667791106458870697609483774932333902219614452203798435905264/7888378644075152870437351294957273310327234310892543035749348881,252500891802443091854561921362385858197816784111744958753313311/1053323742224506812403002107168904355126160235823091691901979381,255113740365021318943195312495507860127626287510178387390434577/1783993324207352601220062365630002446682966611567490425096514792,-636909972110605171815107016899396198781379775416271057478495021/1457113256394044511283678980454710514872014019168958113645818452,170150938898142809995874949647801660922329944156694125049045581/840926737648861276251029607784750908357688919343012009500806050,-30763696241065847264389714476756900499147023328508307611105505461/27191051116236090180370627368329635989621973907622135822729567272,-1606121936448812731212927394547434772548303728416203968862006213/1650476738700329848045238330722298442567849724228217005335044828,-1102340461652852868515335471771427119524743388165460666165251/248846733420691584208138168325397427580690832953044825411400,7417043422103499779622608114321884921444752234367537297383899/6657958260832776379378296724734623073556214657775407307013415,-817975836092213451797617900244932775028927246479973163693997623/31525476169059133511154199391991535878719056661951812583323375,-42884165272921038951976281572334575685597408226257033985089638/25538371070318987271954053634573140392808087996418028049672045,1830168303658109494072311619615282816558314816069669914298973/14995416487061799518316871899365439303444406827592780222064340,-3192850131871919507450348247287420861836746496090098381917182/107275708564331996531481637735269148932863635852419816504436693,-13803665212880281423709062812775347524797244225659523973555251261/4166269863709800572042432621498114930935328763643915154432828904,-530927748745729443042807642966535225086197000033418507140919217/1058110281801323200872447573016881080874076215376970531998111004,102315976489337507058210234230069362544579625599088187421174461/271941938275642657087975171727228778760207930631893642243811990,327697628983304074621097162440349219985124308064942966654692523/2609399895170232131316274903771830467536271730481987447368695846,46462122846748322278801448702543163595228865593250860371552181/252140286750192188029147528560450539174752741322835930640162763,57698869155156473846326752582310695766093871551518982877857447/271751704797323232362861909144401612027348368891825140120903129,798844259290235735169334399187148620045348071221033965069242167/4823094804477520679211146666689078497095110531950694515929623421,86419785743771630028214041877238272407723044924721681257690203/435182932473134722174876515770849921268157641862748762333517497,344383060482585330910468670092558938571070638893300657606965951/2186705603226865270097847762248697770950687690747320409056704760},{22598936431070700336864958819725233627979123459868710376684450/49669633574297610856885288207327003434774743116413065411446593,5327437532572388904480373613634870195981543681695458885484915/12221345561318133634052187117571985474393706048228359485240584,-15232658918073474466573107778619509820601729555334017522672075/70131738463282578360480407985176613664486127096808600728828123,47798876502501721774552207154438043183905236905612481469341618/43834889288230390708167980221144857389874264631124930487326297,3477623217453691032929264273164315286656379835654671944395290/16026612712025948526735426769203795396209881989443907724124041,100605705261923294058744826257559050400832207015275013134867/4680856125721897747764966680722653967293277999589193345256617,-39168159705360529482293349615279525469884606924909582925814575/182073352944510199931699681457010630793579514234031987897249973,-17110961637811415384042633336953006242650352632856002347535374/153155702033632087942501502372510797810128135383688394687190139,-1808524124595830371934850899103889585908974418973523607553040/29366842659911791775459432511500012986940202438547413754666457,-5843139399886194210578834456848730701139782880700632959284055/10823432683208517941991649644599705832449504231788822083233307,5173110157083897401996983981420291037477140410355957864906282/603547727018558848965857388301880441774372108719571266427707,-256981382008433419974532566160494030379508623261654972506226/4562187091727234117275065949155446987033041545903995453614725,17176669510929801288935052613842296799122756765608195280351366/18773404803929184681879611998850234075946023166297600642787231,-62605614059598918283169654333039930387612097546398363559570338/99146394102460963895589936857620569641217003580035712153752509,70585588825718965721404030226075646047394458599723608948699750/190807400993432157839790299219277181745752515571994662206442109,15303596146590996734433069806635656678421031741640190097040/10580146425154730889149063022620523241001821258307035494165809,12553788675043640567604922211904119217199414713564385813717500/271042692456044871277983162866513803310774132876225504355955037,-54339514212386631713839958431981702557084846668421968907965150/396404720764653905750119007838458840754051688046752287263369371,-8612260490044237394532873955771277194287348197293957825091280/23078600857277028312695436989517305123077405729457081087851603,6929735612772961561676412601942204531091274300746631762569300/648187157921329534145136501530704198751578482955817688619010543,5037587769126247788755188790208899958560925973074893192218940/132452295130898659356494066293421145894180916063786435656019189,-27358126081721189476871448134626272577048543624526949855103300/93734400358040528489884143038935861940748607750275097284588573,19830496604995574854268650862342637949346676950018911298844100/470548341421942907385889242960498823001062178805258039109093879,35120853032151330977400828556234113482937194617115874234540/5602180305260626458663151513209894732121522121129103119567197,1095528513237755469121913901558858752539938716366197299863064/541528244368061022083511225980476649270580914252805200161381,-233422464952589341937566911971832976310035279114477146113538/5473238079603641958592100858079420493923070304075223034798313,171828712032558119130302460464542192087537141470305006248616/357439229467679753602731030231401266972057952892233200452951,1136554934660727379951000079288497005787990638489894187754352/24787085395446413703427861288362557002036934736198122587399723,7552430556604087519267848453332600395373402397349946495955528/4024818027283970686899510618752737252670220085092412467694937,-6087576963305153848462095800477110753589067885351103392910450/248573431239423278242002762762260088224005332666403007786493,2148418111864816803541344884759267869454641745599559256173500/1168825470033905846700307428382980650737128610126167496261343,-636221301305491646038580298873133837996113819307941321591486/1239003465651646086422295127729856794804178106404232075006475,2600958228984303374547884613999612338367154260418848322462516/693560078153833075352772507394243276143617644472920395316265,4504785273794649413343325395455447586029040860084147955252860/2534861815333940943044310367328724247004878162866889995549553,80974020835180037697867249620749895887929287897734457816668/109060876653552600780868124780988073148393314557142764442587,256089700131479047883182669441253677496395076022540134550572/360625164385447072163692737807796456826685622190756867551401,62247346594097425412243434941675005717184772959893672428417800/91938882046356086401553224045446097890320532616695771573666263,7442399337043252313853953276939637884514001073423097225449964/12743084487106943024517577033818431589956249849578071001721201,1276685143421912776625103621047505655316701987813406733846320/2805394092913224518809264202763066053920873671389065888341101,-445976941204804687041770644981179933896101924344770110199482/850478157812350291608700092798908344274412768917383198717557,-54496867021957017738068679006175984222409968683918829081678060/257995804707298365963769936721142648236014471450183167305360563,-4130865477248877890851284130543212143703258434941865316999197/19326146156997535216695824920149049211068027870175643444474278,-1081282580432469422162877246989903886715570139849588403237695/5975589253028774275429018835494505193043080657421094344463692,16302134279114218329998431322917852439925761201683904954596380/1086672445339209205271795245476396992864576362734157593766753957,-77736634307141989308081110831172510225480165666122026528751720/8055986864958603204728494922893816747693630532363377123437957,-11675942926168317987628651970309101912070626134147636945764400/58666662274875690355536378187935875761334331508325082734195233,-34924053490063497625060184313399890480003411391427023118789290/1202763184370624150670439480870925079178701939391212144956588689,-84886218046426252106663651664897641743850981355580240070842814/307356648592677227644529736304525062116115482570105564740588403,367906850273084385571528666333804227469123254351769805876086/1288148421419876844413027702261309949919255519448628839274999,-39625496660576210161818385364491527101521154884544876409796445/120821517062186688579677361575273106897170522415402358207566063,-42654426193351861311655923432630101547824736102179432946083425/52523294287714817225294234969193646840937501629102236142613901,-63878082726111498834742436525045717300380874160147321119533790/46425102386467458984940765818352235069281545078375820360676307,172415340419824171596271849701227379785076597232895206281290032/386727723017593080001148739429058616139648237027528315456069677,2173435602873491274198428542020781462148558784461388816593142147/2765654524601180791935335536941459286600291962762558706113599447,104027318844290455510174407548615835945795710458824738827011777/51766282874411191154702840996928016130402098818954709442389842,-89379450525514678967150402136322384775161545052277381597117218/2762654884391980975554134224783285349898455979007745291523913637,-769128725984227852180425923423121293261674817663856897443716588/338693326963167119005756741914805422353168309502105667229893817,20649439695366084460034989904682666126067117118900467450473855/99205755390903990079592051620690754177133750067131468243909586,52112504162366145237111706744167345494481247024149086639589101/12591362321838285242205861879457507494856062597764067351720127,-33411527938779200839452192615801582072856806236985819087167195/28679438767176733456422810623957134790300750611622001120938948,-835662881989440607904350928847526734550564399640794963306809385/745452165743781719258768369030424912104740516379354444926641747,-1897150591614491064401618745761772044193230752291923886875116575/1833036096978165742925296314618705335401024772581774159196619774,-1354857370866291011284866033602755769046467104900139576508655544/346166597600571446110116536779622359640976407959197061749118395,442640618951953086289614880916098500476209452850277290164211234/191045123547792861322494688282991849942712501253679262851931627,-1488733200997673045799541770557013007156916630062560232263700545/2566688142765772438701919478015762759028535883344958371965528512,-911840340817503923769304178004539766956247557686755404073442865/89220985289576521125334126924934072687484142232983663158125539,-435565924195671997607192696000551025134814601742606626177103240/494479494180002652298276119427453222632624355536415053921300079,-693831972152530872695441592923398935446144044787408000454996754/30913417024351377680855676705663534649309225176033226358955049,-837920674848167593998856239307763294020919533968468448636822720/334448041814451045588867729959696322501144642474797925002114929,-50356128466463055490237958866686195866364177732825055981110355/106207774313925010613595685850416489708071457623448035615165907,-2635757495439098605486429803056581438840295875924130488876397918/2186181181643103487327792772387029588873649336360155858904442183,-1632191575867954550099464245245841866810989416777180888256357962/1051616385695126790045688423442181313090404519849247000505070251,341175456479469798710415189947536823783280381138870769571197140/378875172190743235035166188827845251070801487541561989353434947,-586303316481729108504318122017624736342157807282409988691338140/854182231562306069257106349869540174678305812099907243579845923,-226447019025829721839475263676418227435202091311306785296581250/263939385729806403296607254334626957164497284363839702238162159,-10842557971738076377278085204645371665410661507821343290043620/1313786998952323297366688437005309911326495483015549397368193,-1129016170583306623035187755168146343054659332276307399241695020/526797141389945337268040714089752381997584978356473138607436937,-355847495880283515503383418253037559433248222659066394821684660/19654060835675962361275725723308347728185719633950773134546901,-382434200026576127112950492877219795592823629262330744979901660/86521611342927374164899423785428896928608138147157180993128181,6611012560283495070407753132356786404825828826098501435733455/2469691826149132910248090370868210025628142061665875379327619,127651901856672041938774629834947506414373278980209213759796500/286194264696991935700206286616023775665372374118889392308906471,-394177214461265515716987651915049159121033524910711431998901400/512737049652180452363007541073315755086578216634694382593237239,-11283249194102174469338848841486310129142570329054190373916850/16384193641399202709821852768780473123586290321701947972103,85544366359185279380510969264374420617494644774102001872241007/16062437044862260017420044103128173011619736807974396462625023,60537920767790287813536673548677764307308640661080993157113536/126005867936055967086713101421558562162702524580708586252908839,-37278045919794763155186174133730404777408911347049645785373342/84435734076152357930530813840725904638006622836567680346466967,73831617423722465425164244508904261173046643203870280849085769/222231020618006465059032487054368288347768221174384515421770299,2975787783362429791528877536124890126509334860545173624167900/990242530297765481236679884247451703230338978976058101410293,296584391542675211445249669841517860730092882286864191987913500/443518809801349690567265830693775270754130759964582793448780703,57048619830886501114404976639823491241716000569076719151138758/9224179278998307704459429421804619971595795469793635953612117,95681454356238866162673964862106662229433968684458982385264360/231285194763364173816861077755992322317776169376036195004431583,-6995408904314218898041469271272892381744475154542495398065400/83158758641456992979418901750036625027540768868656004663842959,698137532441501798395669113678754688804039841728564695918940/9950776392588862142498930816774112382380462349421324935329433,-21555537256177874808127988333849145365093952689399994046036284/47187798451987083407149659714136552974414308025569149201811605,-366616151064944078934972029370422679615621606186171373002515950/606941556929834143622627489229887097519036177527302514344372773,21217511781835821653348267031243189854461571029611285768728100/269097040095369757150244407152855518437090169054877671930400493,4961684015770276386458193944542177328875675093334235525567260/32159359719474437687243471422748145171035102159364978091210831,-65620621836170930361072933668149825316169148553510805869894058/152360322720241396006242772752805345644331710039310517984515765,-148667068307202885315388433492933654157937316833271105311283800/280167999557480211997447543752206029007919004331149562542310403,-153059963437720038543814001491812617026233605167566522177957500/66549932173039315217132899990048657624453656116164086456431317,28538819980032725396553962819283394901999609106113848592647755/7988757328644080771703220365241746167091129283389345529795357,543478704565428156465149602647325162858916645950688329760464500/482521052920542172082997152082752165971463498991751977991073831,276783002288591680985451281821344401122020348648152260442636151/202502742510940645606468723561539191561290857943007452284285424,32606350881506095518208445805896505391982268580916537813101600/8312892799558727207591277790467665470394666351362728757516379,-247603940689266988328777694471639544506189097122102146847531600/1491266295677743396903081999882727103741370743024222240000542051,9585239483794140040159553660089588915655523741776546961736917/43836305865485841488687697090826290983572542504069361957756184,-50880236315385825379478124684558540185435544533340387609451902/28737815099666333962410392479500912149524536651592292423949571,737986105632078539840321754919838222111668536335545317469592191/160535197393515256473166899447930158084051636819773963218309348,3912934990188093594401126042446740652759282652157227457481694950/3073912978114510703223052035222667652173806311599223412194895073,-130479478595128605721016974578513111531645081240835870139099400/904081537146878599514324253463348761736980832678862851321520267,430633072855846252238769498922378928655714967160130779706053481/1313464995749969331469509479915024104796746118049158995166486858,1075938358061841280419726848128920686642908119148591867960981285/847470389224237066383019997454053373788621395076536804247340416,-363219032126536199959479522076234237736637916589404504098916408/943816946885438275878695687781955340998571247534998589744719529,12406753277585443928832764890113181146267828805194996952917105/7156494828037963473247565342859787739893492131725735988560483,35362566032990521547866508435058483476986783741782875704916700/83974528308576791139071178405007329231903338122441444271549077,398400142656662870159692921092538300953144706469115386457449470/503571638948920612440980094813788449791781562454651074357759737,22909156816837149653401237042198558325151232149304584305169655/27683667814853549230776450589322756010073053430990298184773119,-88702537865749541602384642219447276521866182386224319644614040/28817380338444742026694819294989310607554944760773885802745833,-1445874276420610116191100564427659132693908245813901013926157520/72442069088668324779053889540241027909971921601409069904859709,-404249423968959089773882220971277192617186135245157703223207440/11255917119475375924358883013457118794422274676767185942144217,-315621048958469414983463296831038935013072106591136562107844320/182573300347853031329783031744335401018922899200797854773656889,-47535168605671704285041764225494581043600462963483778116545682/29532355556585890741388465130498448822427108955980175194300057,-398748820783023672064820284265937752786851587592264792688539558/130584571862130662964090388607258413380556569716658630844559237,-5811863903786899893136405338268370830240259789220814660604374/3479862827246172330549532429207414878979190100881019939153117,-259798459600433862238461145344992307507653168802633262929059234/29065659288948411728271005754199962935018757264904379641680081,-332832610549908027288456185542815333959765520060904803521124080/585770532299353869703242965455397788890307522096313210535856867,-506099417081184371527335032248703850506009982964205496014957380/451653343988461920157140203868501374736228378868405880753449561,-565342936467667428206938676528410689757812032791009917134620/811843970963947894394719239688676525146353654056213682294213,-157596061669408643845966542139415884545576749147072362816928340/177204760680967089541753973545983831379975413017931596647471501,-11825796239647184200029664633021790974165621279016926832859389/3787274262948414028430346858032832640127869153819763697208569,65054547103196052629385769650918684573467873213176155840981955/363950339476211018847864584420778199838063930121487700634200904,-3037993274114852566386641400686937331027293641206338373657897/2820407724678332591375215416048480212000867836731702041555862,-149298642162654638983585071558529049762022662863911721758539425/38440999349326205999060859797611744620932612899491159570371521,407043304525673624763566882712624112548247762913497784513351075/276609191881491387352493714787359564942381172468784970199588073,131495902014069593691337992517112414675088525241792266910251775/280792656484867133935043662674879854085256316201432821353340049,48825908066394665375698976642781536428426277615392030157120991/54629680880633316997901354183671528522669291763427529780846801,112855144740043443088348433977711993183660492402832805433069415/320728314122930131357191284284458832689085706280960146333938291,168210634930610777168913828606396204210988835937695853437398367/156867719070172610723656213553900512298695260384785683017309121,62122810798535111939646158413646165192330426607612168336230888/5531454904127615511905394369336879176386904946428670441775451,427633022492603074926041616638828866787958438447859659070528696/991774017502319138375229138396680924139635024445870386014217495,4003462608513239347201476180585216722270031651747594087085616125/2678746506181022634061052579176619086428725925413586181388692702,712870802212309268538175078675249703829186966664208204079962672/805390201660229047776285967064474610949534990554016403969382457,-2526422645463553890158126384254313434218967087875799182639547150/6408958039354688095637714774549428421212963636431369124405008461,-2020161579792136573307429423448036904016032820134868842609860/1411033560801397396475655444286846508289723648540266060987865979,-4982980053584180119521201751636608111329878820233802992792383950/9476564389889505407982469601402093617351017679376987645757159719,-4400202318319198581849140832481938751106189991547900004952950040/5072926996923746977779578516290809653654134188372548431049926943,-1034238758371709666860635231965943319258393581857262903160260500/1236447908987023839436715739912566763987183639744795655478399653,-381313397642718689147319252677300484908593043055597230595689785/145690366137736800906590874301976159902834295108232944379909422,-117613615001832667425503094019952889460116196698115290999428435/159061142521209223266293271335854549824800076232000348284729101,-59235208458991713211923554879171101895145924298978620853479015/399246487690737201392114394195482177459384212401020679193223723,-4600092895804118792165892196923674889267030609652558693404528790/7888378644075152870437351294957273310327234310892543035749348881,-36076311287837432699067639584446055095734987642612998076820940/1053323742224506812403002107168904355126160235823091691901979381,173798804580933880740240618708942973176690047333030074646408555/445998331051838150305015591407500611670741652891872606274128698,715395487976126269779869092983957848687554600474849479604442025/364278314098511127820919745113677628718003504792239528411454613,702101528723704597273872303539117170657470972689073073137346/5606178250992408508340197385231672722384592795620080063338707,8121748888356157138546701351689112219757989517427182718569572475/6797762779059022545092656842082408997405493476905533955682391818,1582824077019696409467079821722767779520412973670291174986264526/412619184675082462011309582680574610641962431057054251333761207,729451218573370940428376564794736892898320283963102943123733/12442336671034579210406908416269871379034541647652241270570,32494169567426475302125052517828631146291582342487967222695019/1331591652166555275875659344946924614711242931555081461402683,659872049086247325342678436669938341732477055522680394989030686/6305095233811826702230839878398307175743811332390362516664675,82593299184662714651574065439382059757312755117061813156940320/5107674214063797454390810726914628078561617599283605609934409,412847077157178745536090505579449501746872402837745714435981/749770824353089975915843594968271965172220341379639011103217,151304857754453890630461515085257306338917996167181463874168200/107275708564331996531481637735269148932863635852419816504436693,4448437822632630117428621299562237815317634088401421902210701175/1041567465927450143010608155374528732733832190910978788608207226,871346867998962704400807355288631147875251736212406409600169652/264527570450330800218111893254220270218519053844242632999527751,8051107806540859081562043622840817868249295462996399561667790/27194193827564265708797517172722877876020793063189364224381199,610035247024630488322768543990986467234900538179113237660190708/1304699947585116065658137451885915233768135865240993723684347923,85204848649017548938408714432520477318605724348297428377356500/252140286750192188029147528560450539174752741322835930640162763,85722937248978648128147835650907686667536378809302680684507988/271751704797323232362861909144401612027348368891825140120903129,1553979616699866405172659293735253010605874149962825067886306950/4823094804477520679211146666689078497095110531950694515929623421,136103177703458998181791285659118613522074117407160623777555139/435182932473134722174876515770849921268157641862748762333517497,6029364941324630135267812148562464389792143947366456074982591/15619325737334751929270341158919269792504912076766574350405034},{-8099181670480831854600649339725379725339559123976761802556806/16556544524765870285628429402442334478258247705471021803815531,-394298170585716992666399552649542759191330658319478805648563/581968836253244458764389862741523117828271716582302832630504,12427292213866819052227285877683159191450475544031491051175567/140263476926565156720960815970353227328972254193617201457656246,25414579590621050936055633616591394175929196758527938600023375/43834889288230390708167980221144857389874264631124930487326297,-2071861803961365655169396098508444005526408839059428652932853/80133063560129742633677133846018976981049409947219538620620205,-2395584186097464855992112923004464256843974651093246389782331/3120570750481265165176644453815102644862185333059462230171078,20533169761624113093686227003674330372904042823075364733214177/364146705889020399863399362914021261587159028468063975794499946,36657269248547426711642769539346020305628681396342946981256664/153155702033632087942501502372510797810128135383688394687190139,6769877774311170139107713121711979772297510433970237619639844/146834213299558958877297162557500064934701012192737068773332285,-1753941723075499787672838249342598602126703924738548564554423/64940596099251107651949897867598234994697025390732932499399842,2909183762976485502042948544480989144361687884406671583973414/603547727018558848965857388301880441774372108719571266427707,6663293229613079248894933782761825330646095770116257488843208/16728019336333191763341908480236638952454485668314649996587325,17905596223055611738109201451558818597324141168987698376907510/18773404803929184681879611998850234075946023166297600642787231,4213915751776131723917109384759907937012670681056425443296120/14163770586065851985084276693945795663031000511433673164821787,2098395265051093420672433231172726911095730591830337611798474/190807400993432157839790299219277181745752515571994662206442109,4379462427626693179846251466911013379460147668506716167480726/52900732125773654445745315113102616205009106291535177470829045,33412999402234531529519681168250271831491492988606687399794067/271042692456044871277983162866513803310774132876225504355955037,-95160212682426733611755612807806304000032247047501693669357710/396404720764653905750119007838458840754051688046752287263369371,-8691950470914557910106317342881024591238161464467888956966982/115393004286385141563477184947586525615387028647285405439258015,70304472412194083510391077368923389079760685423927777390535905/648187157921329534145136501530704198751578482955817688619010543,78295404190070845101033578582218767605490937670853673470141267/662261475654493296782470331467105729470904580318932178280095945,11448062348672982980636592510899461878436773989292302007901045/93734400358040528489884143038935861940748607750275097284588573,60180347967294658119915518321016233949935372106734488163664735/470548341421942907385889242960498823001062178805258039109093879,674776463674337846315803445684517444906907500736876207867258/5602180305260626458663151513209894732121522121129103119567197,1895305900640150256103764988052972547522828883098481804887215/541528244368061022083511225980476649270580914252805200161381,4849566329877580423203292194077002126979040399568836904240780/5473238079603641958592100858079420493923070304075223034798313,841617842140091124583443269437435006370503230620417637795119/834024868757919425073039070539936289601468556748544134390219,4322838453144254967313600879313686909425705231756369006871025/24787085395446413703427861288362557002036934736198122587399723,20744059354795625675346205017616394074705279208951077839822043/4024818027283970686899510618752737252670220085092412467694937,-13680159956801984586662944272580472262850570394494139013765119/662862483305128741978674034032693568597347553777074687430648,1162609567058509877276629333062409674364825552534411741906639/4675301880135623386801229713531922602948514440504669985045372,-8882811604567022551558810769618215402105712434855353334573639/29736083175639506074135083065516563075300274553701569800155400,3000259356199606153838050530207211809538439053745396434246679/2774240312615332301411090029576973104574470577891681581265060,993390689103841416552106318229444563031620771623460373048659/10139447261335763772177241469314896988019512651467559982198212,-51275011511224906641727213405771736837507860230393146811733/145414502204736801041157499707984097531191086076190352590116,-28190635252034001938965032997235548305354786855996421107502/120208388128482357387897579269265485608895207396918955850467,-3948887493734823473693686391377632342406530323064483118286244/91938882046356086401553224045446097890320532616695771573666263,395322556592722182056097081352123363763431483157745961775856/12743084487106943024517577033818431589956249849578071001721201,-42082291226694852448585937014539425417996563481476285099896/2805394092913224518809264202763066053920873671389065888341101,85200502121977185073962423761000159385135606598698717939131/566985438541566861072466728532605562849608512611588799145038,194159877729468302960752287545798416512429512534401173893429585/515991609414596731927539873442285296472028942900366334610721126,33020395859325903331596348341425416785481016355691829832797997/77304584627990140866783299680596196844272111480702573777897112,23813608631169115380965915894700015398769364424935946170836877/95609428048460388406864301367912083088689290518737509511419072,140148855269593940434538069637446139952660243726102989292448179/1086672445339209205271795245476396992864576362734157593766753957,-16708240119319308550674818887446762523673006317315357570909775/2685328954986201068242831640964605582564543510787792374479319,39397202878475189344535413614418809441596477731834701553124474/293333311374378451777681890939679378806671657541625413670976165,125732218608775417915195955425351602717896935471708853800516708/1202763184370624150670439480870925079178701939391212144956588689,104718026007853481415794264409109938776157888706927501045394808/307356648592677227644529736304525062116115482570105564740588403,80825834560454109450105589130577186966721873434306880491225880/114645209506369039152759465501256585542813741230927966695474911,31511827400014592851945564170772398361343154823590568279137133/241643034124373377159354723150546213794341044830804716415132126,-2356535104729534262026577520306696661149079863902906635622878/17507764762571605741764744989731215613645833876367412047537967,-11435966236113812657055380029165675482986909217858198361479008/15475034128822486328313588606117411689760515026125273453558769,1540083626903340499121679780314629958623597857906399955328302361/3867277230175930800011487394290586161396482370275283154560696770,-1363166837758022724661892830590075196223001539882640023184202922/13828272623005903959676677684707296433001459813812793530567997235,1218869303688201356107171917617944157199694765839515215950290707/1035325657488223823094056819938560322608041976379094188847796840,493196965362567359354697258889072349139119142423334686523601818/13813274421959904877770671123916426749492279895038726457619568185,-5784183060780307635307601731873288094575297242501020331405078662/1693466634815835595028783709574027111765841547510528336149469085,-49426928452020712727504454751203550596794753960609393564568507/99205755390903990079592051620690754177133750067131468243909586,-2977189181594406072772041539385264179750728362949152341391608143/251827246436765704844117237589150149897121251955281347034402540,-290783821059138528933243236981828403862247655660803565667184679/229435510137413867651382484991657078322406004892976008967511584,-2406967290414607716595245410802723706246590526267112402792336662/2236356497231345157776305107091274736314221549138063334779925241,-613664678988343462370223673808435200836235183732070480548649185/611012032326055247641765438206235111800341590860591386398873258,-4507560667512415813829007077425153499742014952605680375137944308/1730832988002857230550582683898111798204882039795985308745591975,1014363725016199838294771109178960482066175758295863715240731884/191045123547792861322494688282991849942712501253679262851931627,-762145540476442010288410335120411330338066831013340349671754101/2566688142765772438701919478015762759028535883344958371965528512,-317891264744246072976706320697914345846372344130126195604176314/89220985289576521125334126924934072687484142232983663158125539,171987626649961114804763231509966335344286603213135002016635057/1977917976720010609193104477709812890530497422145660215685200316,362028611168757157723261432079646140130997969996606135804749464/30913417024351377680855676705663534649309225176033226358955049,-33409248728225676717470319111109286461701141758970714317977966/334448041814451045588867729959696322501144642474797925002114929,-3346866013775267123197916927148978295288405347997682777646365059/2124155486278500212271913717008329794161429152468960712303318140,-2431179552608711132145491629559757339515416044223971629985859579/2186181181643103487327792772387029588873649336360155858904442183,-5838635198685278376618623851293504312492557584801232872480153669/5258081928475633950228442117210906565452022599246235002525351255,1361384476546755959438255331429721418065829592398372228239726095/757750344381486470070332377655690502141602975083123978706869894,-382637357908070531999014320736526600897148428294811665949193280/854182231562306069257106349869540174678305812099907243579845923,-121522987661822906394985376970807980743916606860957549587282035/150822506131317944740918431048358261236855591065051258421806948,-12867066503357756122279591259702232726441505756171240759584637/176047457859611321847136250558711528117750394724083619247337862,2002711249605251044934158919642256030924187178259315490795254359/1053594282779890674536081428179504763995169956712946277214873874,670498078288268613599285387111081767943083670764766684198090573/39308121671351924722551451446616695456371439267901546269093802,333675849423449101226294898693850833167784648468722655446101187/173043222685854748329798847570857793857216276294314361986256362,-4821741016868176565870034496792300217269168743882714730628823/4939383652298265820496180741736420051256284123331750758655238,-33951324801822585984910229793175597322261467410551289266764811/381592352929322580933608382154698367553829832158519189745208628,-460615348343992480490571035166498568324996863088734060398817869/683649399536240603150676721431087673448770955512925843457649652,-10681998751014375734631500819696168655204021974121807831677117/218455915218656036130958036917072974981150537622692639628040,-13036429794563610190918452454694298251311909960568517180331257/16062437044862260017420044103128173011619736807974396462625023,34940289749350379938620959054053849951320702058041120196682427/504023471744223868346852405686234248650810098322834345011635356,-269074835265528597416768153526199617461942705163675073066005187/1013228808913828295166369766088710855656079474038812164157603604,515713369264862017258424773530636924905994944256598488723772149/444462041236012930118064974108736576695536442348769030843540598,-721145672222688432446171671145061487006381844014300356664374/990242530297765481236679884247451703230338978976058101410293,-58480072499504191749296004003468530354225877314664154550664159/1774075239205398762269063322775101083016523039858331173795122812,-34501455078309862943534721054137635335203029725815728319910777/9224179278998307704459429421804619971595795469793635953612117,-252701723220707259646962780702672931272952485850410289526090179/925140779053456695267444311023969289271104677504144780017726332,-56232491443892860135449586466444351502183917481558867426065391/47519290652261138845382229571449500015737582210660574093624548,-2753577930492544312791798813300614180452864067537878330909241/5686157938622206938570817609585207075645978485383614248759676,-7998453419912178571652221956900625199866768062796343573539976/20223342193708750031635568448915665560463274868101063943633545,-45054864454408889662195918730292032433786313008609397454806247/57803957802841347011678808498084485478003445478790715651845026,-902313922341951177235043726061259806054428336293205986827258549/1076388160381479028600977628611422073748360676219510687721601972,-39444309158730136844972705671812872834260032429446043080971789/128637438877897750748973885690992580684140408637459912364843324,-623235359227458535252224797061114435222373964742974496911342771/1828323872642896752074913273033664147731980520471726215814189180,-1636339860251567834899893116861567098235282546533015302271723841/2614901329203148645309510408353922937407244040424062583728230428,-16992860403922535981559865158198118817472854880326627526333401/11327648029453500462490706381284877893524026572964099822371288,20629383002739674972052925739123665377495727340030997065500011/159775146572881615434064407304834923341822585667786910595907140,211263447218007813420208761188319259605461150352591477252261255/1930084211682168688331988608331008663885853995967007911964295324,710784564536325933583994076822054747235597757575539321491367117/405005485021881291212937447123078383122581715886014904568570848,134782028905095687098069531761452344617596539030244417386167149/83128927995587272075912777904676654703946663513627287575163790,329451044928128433976714833036551372735365418996151946604462469/1491266295677743396903081999882727103741370743024222240000542051,208925042511893012985685907120596696854578346639838646066796283/438363058654858414886876970908262909835725425040693619577561840,-839703878172114682526958452696708462656587250947514736565482171/574756301993326679248207849590018242990490733031845848478991420,1173225567507970929374812112496665597772978481048107658045976185/321070394787030512946333798895860316168103273639547926436618696,-718477842077152160461838491534685355627703164744986771106427275/6147825956229021406446104070445335304347612623198446824389790146,68567308353674375604690418668892744188533686670435567194120621/904081537146878599514324253463348761736980832678862851321520267,1068111464165969232544710759780470391964172389869694904409064927/2626929991499938662939018959830048209593492236098317990332973716,-4195961181426122797314131427135088970451446619489089320783268829/3389881556896948265532079989816213495154485580306147216989361664,50513023468993910786344354018797814255315676820843048796701239/4719084734427191379393478438909776704992856237674992948723597645,-407849963665627601946749021495561675236111455656014588197484491/143129896560759269464951306857195754797869842634514719771209660,-116653843194253189429603449183864265837304942419616387508087061/419872641542883955695355892025036646159516690612207221357745385,-5400550250309078142912735648500908040207394287749812162802904481/2517858194744603062204900474068942248958907812273255371788798685,-902830403586041098602503767861792310458078317664385547254581609/276836678148535492307764505893227560100730534309902981847731190,-22884838610680773306294048795567094741018205602199450879808699/57634760676889484053389638589978621215109889521547771605491666,-451007977122729498851266844363571096203412421330305924305846706/72442069088668324779053889540241027909971921601409069904859709,-96930730474252774045801742591429680970042597881861960974278862/11255917119475375924358883013457118794422274676767185942144217,-25011440636718674488796794235367328655851666278937205079429052/60857766782617677109927677248111800339640966400265951591218963,64624658319335422464654350660816825370213146514406173471401286/29532355556585890741388465130498448822427108955980175194300057,107744683034989174039530381753013039563405276531939267528774464/130584571862130662964090388607258413380556569716658630844559237,23520602664724849911331053267538135455636681080339768192225872/22039131239225758093480372051646960900201537305579792947969741,43596664752213324100172256345378326697190518944863234658560892/9688553096316137242757001918066654311672919088301459880560027,57653684511578268051931259530258216091159071678107363102165261/585770532299353869703242965455397788890307522096313210535856867,-106891661478724303531622972462851976422396063032911498009856943/903306687976923840314280407737002749472456757736811761506899122,-730164326508662646118953675435574169612229386547384354841801/84161158323262598385585894514392799773505328803827485064500081,4473271751257694060114580273893672064409038995071094964424983/354409521361934179083507947091967662759950826035863193294943002,-51457901313492845557407289246186920257869260231894193365741611/2524849508632276018953564572021888426751912769213175798139046,-173033105972308599934055047772407358710720736637356816982264191/363950339476211018847864584420778199838063930121487700634200904,-85292593400790234793694289417160272048456728659548658261113163/112816308987133303655008616641939208480034713469268081662234480,-139027897859288221718243103626350466841540917953839581508260820/20698999649637187845648155275637093257425253099726008999430819,-442213994021603727777723282077916519988627117711615631276377498/276609191881491387352493714787359564942381172468784970199588073,-2024829750677384008291140841762365110559043872492803240437715151/2807926564848671339350436626748798540852563162014328213533400490,163161268509325154875810919539289168961687252149461077369992517/109259361761266633995802708367343057045338583526855059561693602,224284784021246369867687294356586710513405757219166275856482565/641456628245860262714382568568917665378171412561920292667876582,181851130090234963139977280499822599811867279446537841103144657/313735438140345221447312427107801024597390520769571366034618242,635420938261638569268974579972318214582524989368933492880035209/110629098082552310238107887386737583527738098928573408835509020,-2364932753282351129176661881582605167239413968867923917216880528/4958870087511595691876145691983404620698175122229351930071087475,-4283804266314222863650972985773559644073176740801469463765065215/2678746506181022634061052579176619086428725925413586181388692702,23434062643436421724866280857158461943453443768803675834379650/73217291060020822525116906096770419177230453686728763997216587,-1315464418927176336773524314428351073538026007224070694940588480/6408958039354688095637714774549428421212963636431369124405008461,55498850646309418371784164104555323785222760378784819978235910/1411033560801397396475655444286846508289723648540266060987865979,-8656111264129415347362271396987975383213018275108437800663719510/9476564389889505407982469601402093617351017679376987645757159719,-5200941855793814966968286243332234908314172341911853328745759746/5072926996923746977779578516290809653654134188372548431049926943,-971394454778595355675293889444649187372182969523119872041506326/1236447908987023839436715739912566763987183639744795655478399653,-2819838187109988537064510393602195717033420860638801197615730631/1311213295239631208159317868717785439125508655974096499419184798,-508989563773208307052467422324627314060725651076750295137208379/318122285042418446532586542671709099649600152464000696569458202,-265493341434542208246048657442936526866531932604046969692441706/399246487690737201392114394195482177459384212401020679193223723,-8743485607352835662033124350144688343410047601860841764619026736/7888378644075152870437351294957273310327234310892543035749348881,-258945931280083656350263733290200881736842168199172261208816286/1053323742224506812403002107168904355126160235823091691901979381,-443978930077590071991681794662630157930690787373882927168954101/891996662103676300610031182815001223341483305783745212548257396,-259581422634059247138360799160401951262308361223335685231507597/728556628197022255641839490227355257436007009584479056822909226,-31576430514992874397705889805787019000857206018645814295703683/420463368824430638125514803892375454178844459671506004750403025,-4591844107244282243463621293124015368086927361342481907412410047/13595525558118045090185313684164817994810986953811067911364783636,695812084181835429633388390655562980006857283487894441787111717/825238369350164924022619165361149221283924862114108502667522414,-9991361847008490314598288182610529707571562395357652115861537/124423366710345792104069084162698713790345416476522412705700,-626575630043017656896271051135217823211148219279004018891007693/13315916521665552758756593449469246147112429315550814614026830,-5044415926861054409096425823492558354652767586053080642415476677/31525476169059133511154199391991535878719056661951812583323375,-446129306587106016152953443258146604633711876015159592210467257/25538371070318987271954053634573140392808087996418028049672045,-9907583012641967083923272550796315073145023604006797614742023/14995416487061799518316871899365439303444406827592780222064340,-128754905430371680973806199819180251020411470851898911679681981/1287308502771983958377779652823229787194363630229037798053240316,-980300722242988742494105943302622306320772343109810936293837211/1041567465927450143010608155374528732733832190910978788608207226,199435181199694611538336938291302656477285851578784754603373676/264527570450330800218111893254220270218519053844242632999527751,-11081488300648085285463478348937348375922535103955434531273868/135970969137821328543987585863614389380103965315946821121905995,-633414683219549998123116778605685329243312414464211643633234690/1304699947585116065658137451885915233768135865240993723684347923,-439382687060047757780440606188462177226549753704833748196729885/1008561147000768752116590114241802156699010965291343722560651052,-94476713666010178490660679127090466673739757153628655250148982/271751704797323232362861909144401612027348368891825140120903129,-2215490909583879905480565198276224510177917178793047472216297706/4823094804477520679211146666689078497095110531950694515929623421,-997502477367582751201886184014884565356981151762107802003457872/2175914662365673610874382578854249606340788209313743811667587485,-170542044797387076547807525588185634153135442640110857288609739/364450933871144211682974627041449628491781281791220068176117460},{-89238127460378376195223717028188561368024427644538054408635560/149008900722892832570655864621981010304324229349239196234339779,-13485082941182726759083519240057108465959614250243569007321755/18332018341977200451078280676357978211590559072342539227860876,62661293827277921894382689636966690513064825243463376548694840/70131738463282578360480407985176613664486127096808600728828123,36873317323517587109742038863985268695230883103351701165780220/43834889288230390708167980221144857389874264631124930487326297,883887055932394632056424527034463128519834404355261730880860/16026612712025948526735426769203795396209881989443907724124041,1266054426080875881037972982957874970073625520120149170531416/14042568377165693243294900042167961901879833998767580035769851,140810066797354866191905310025655441390043285502675233932055700/182073352944510199931699681457010630793579514234031987897249973,73430684050871310083122632952799935728865493759225423641932940/153155702033632087942501502372510797810128135383688394687190139,5627064578165691713571998437024765418212532245188239834552876/29366842659911791775459432511500012986940202438547413754666457,31699875502461798737618664433068905270370130732379039904026800/32470298049625553825974948933799117497348512695366466249699921,2043998148754907973330852676816358582023904817548237594270440/603547727018558848965857388301880441774372108719571266427707,5179040626699389082693130146971332980366213157712893923865164/10036811601799915058005145088141983371472691400988789997952395,13207041793955966348040583929638174337937012678064842005122640/18773404803929184681879611998850234075946023166297600642787231,51875300980452605326606366842575703382718691505524546260564180/99146394102460963895589936857620569641217003580035712153752509,-21602298961102312498056854969071094993554604442052366577705640/190807400993432157839790299219277181745752515571994662206442109,1014875590974997134247322286680806667397152822699936433300804/10580146425154730889149063022620523241001821258307035494165809,-41198710661993228107888014877892865405529457116308814963433820/271042692456044871277983162866513803310774132876225504355955037,-127006732822973130081243903591029466400685981841607951124672400/396404720764653905750119007838458840754051688046752287263369371,-424901179544891848477720673183046220959840221866058988454788/23078600857277028312695436989517305123077405729457081087851603,-107332532114577159484080395493971968845887318975771251423674900/648187157921329534145136501530704198751578482955817688619010543,-18084723058190664195564944161433608734146073859467738631230860/132452295130898659356494066293421145894180916063786435656019189,103302661713876071361578739783234225831322489047242832826224100/93734400358040528489884143038935861940748607750275097284588573,-68647607228485584240276891827079785514564780211349124082471700/470548341421942907385889242960498823001062178805258039109093879,-1139563048831005645088993297036889799237649842779750035005360/5602180305260626458663151513209894732121522121129103119567197,769351828194770218233957157308036151914273368084519086273060/541528244368061022083511225980476649270580914252805200161381,284016594802190216516638396701817914798642568754371806463180/497567098145785632599281896189038226720279118552293003163483,-4089822265803918844754154677268383246767731213494216622804220/7506223818821274825657351634859426606413217010736897209511971,-3353677955666352575998092999998076169360574838983716382286020/24787085395446413703427861288362557002036934736198122587399723,2779297826450590714322958394028448083659578409021758009355748/4024818027283970686899510618752737252670220085092412467694937,-33315164324871404755624918488297339464029772670783085582692181/994293724957693112968011051049040352896021330665612031145972,-2049199699210307103078694980633942000966957842567123428312729/2337650940067811693400614856765961301474257220252334992522686,-9411179380338072211015293435149231545405854477553386918580207/14868041587819753037067541532758281537650137276850784900077700,-299664584201571876407995487302189816293839112260267373812669/277424031261533230141109002957697310457447057789168158126506,-12700568338763804429378562850729188748008368405669463191450281/25348618153339409430443103673287242470048781628668899955495530,-2312138366209089320197447962577946372788331520888678811137881/3271826299606578023426043743429642194451799436714282933277610,459484308979991007786649389138148922337944105367472406184553/5409377465781706082455391067116946852400284332861353013271015,21340072342174972290373182027996124441636707962160870460461685/91938882046356086401553224045446097890320532616695771573666263,2713191180570517877675966536013839681614980579192742867707989/12743084487106943024517577033818431589956249849578071001721201,1890164779108087020713726711330975411236321559605001703165429/14026970464566122594046321013815330269604368356945329441705505,-5907253278488052204210680772697070110467520415492954145445163/12757172367185254374130501391983625164116191533760747980763355,-9047100158998981698974128696856158420539186758783950549866437/257995804707298365963769936721142648236014471450183167305360563,-823996118293134187541214169230545392180614668570366898301313/38652292313995070433391649840298098422136055740351286888948556,-3391165514420062288922566498496541764201270997989488490612781/47804714024230194203432150683956041544344645259368754755709536,-152069536043200444337170038074445017366816228525942106422112220/1086672445339209205271795245476396992864576362734157593766753957,-395619855283329898475408289382189122104500992581104057894547060/24167960594875809614185484768681450243080891597090131370313871,5966747444914026659267119932242161364176016035324359886389716/58666662274875690355536378187935875761334331508325082734195233,-28556840261230178579213581067757710187935589172720702583085040/1202763184370624150670439480870925079178701939391212144956588689,111735232044185109841002347790443676403470280614464621684344300/307356648592677227644529736304525062116115482570105564740588403,16831152105817866419813914657986222731784114712122273709514320/38215069835456346384253155167085528514271247076975988898491637,83026792953664899601394723604652090099943768463738871683132680/120821517062186688579677361575273106897170522415402358207566063,-68551278587209439504895292735565579385420878957568404035651150/157569882863144451675882704907580940522812504887306708427841703,-260087414245722443667428805786612474689348364466846056471969920/139275307159402376954822297455056705207844635235127461082028921,180532518136022988225919961336177049530245169144581131791359607/386727723017593080001148739429058616139648237027528315456069677,1362698228241051864092989246758250349713753948570956516611165062/2765654524601180791935335536941459286600291962762558706113599447,65045394145285870172865298508333359128385473781714673056923363/34510855249607460769801893997952010753601399212636472961593228,3491059519540082379434178962631753361572718019744880951174431272/2762654884391980975554134224783285349898455979007745291523913637,-1649125632738976197898948525322325747928007022694539395399301748/338693326963167119005756741914805422353168309502105667229893817,-39341033800511010522940121983541130209289872026573694025104734/49602877695451995039796025810345377088566875033565734121954793,-91995724008180849981067167063014085692982141846469985175137259/12591362321838285242205861879457507494856062597764067351720127,-52588251982988346039837512886615010352220953981385969846640545/28679438767176733456422810623957134790300750611622001120938948,-290546539489835067829432229964934921461732452604414769498925870/248484055247927239752922789676808304034913505459784814975547249,-563475999062720221584534427056108241775372096234611092066833725/305506016163027623820882719103117555900170795430295693199436629,-1868606013164268672277339494331208447516910195670104768112317464/346166597600571446110116536779622359640976407959197061749118395,72598659268235007008851811087549797639621228736905473279049360/21227235949754762369166076475887983326968055694853251427992403,-33024437353538318221200258059831393811740540613316912621053155/40104502230715194354717491843996293109820873177264974561961383,-537999592177954253713695384936537106083115961165223008162471770/89220985289576521125334126924934072687484142232983663158125539,1504155966040905456234476356702949561478624768076060272802269605/988958988360005304596552238854906445265248711072830107842600158,562013114941375501338998335467782975861737601003462824344796060/30913417024351377680855676705663534649309225176033226358955049,86244371625612923057749660947731542629940502527080850094934340/334448041814451045588867729959696322501144642474797925002114929,-243665737284025060267184623969112743818855056579196551115557055/106207774313925010613595685850416489708071457623448035615165907,-5601106018486874206255228536222671323973757635035053330907726048/2186181181643103487327792772387029588873649336360155858904442183,-2781962599831784223290591765647920535244026681871192581666674932/1051616385695126790045688423442181313090404519849247000505070251,23129905060694504056658120663944349585857301527453604220184353/378875172190743235035166188827845251070801487541561989353434947,-722314074283603251981458725609662261251217029120627606190774218/854182231562306069257106349869540174678305812099907243579845923,-644341146739956375360156392660082400664536177909476529589242129/527878771459612806593214508669253914328994568727679404476324318,-689276067762771057891935279182502459920775562035720756393651039/88023728929805660923568125279355764058875197362041809623668931,-521575134912460517793134651480893850782091097567852801168340547/526797141389945337268040714089752381997584978356473138607436937,-159310117182698320502123016447391658034102495632517613881717809/19654060835675962361275725723308347728185719633950773134546901,-19875415618363086498022796796715933561828308013303152505235387/6655508564840567243453801829648376686816010626704398537932937,5593304212180841946234379643288227048412704776811238902261879/49393836522982658204961807417364200512562841233317507586552380,-271562933954337215904988408632929002791838370201057780432768537/572388529393983871400412573232047551330744748237778784617812942,-1046959513273921963300195925082005778669453396278002143010648231/1025474099304360904726015082146631510173156433269388765186474478,-330541221750347932316794288987826189804502986769488927663970949/163841936413992027098218527687804731235862903217019479721030,35652027683921722616623712642724373369322082299513561138357557/32124874089724520034840088206256346023239473615948792925250046,-68294071117828098502403583783762607840973422294634616357840653/252011735872111934173426202843117124325405049161417172505817678,-274233561202901803528072988122991983391309625077435298700502971/506614404456914147583184883044355427828039737019406082078801802,4307195258381173093814643407617123646130840925457641126970372/222231020618006465059032487054368288347768221174384515421770299,673399735934442529942775153501311825578622250026621313820737/990242530297765481236679884247451703230338978976058101410293,-246994511234928986807435054883678190477850791276892590810095799/887037619602699381134531661387550541508261519929165586897561406,-4254786537621253179231019255777505867460162440520575847344227/9224179278998307704459429421804619971595795469793635953612117,-227452460983445978979779540931102412509697515591652398138576459/462570389526728347633722155511984644635552338752072390008863166,-168232155049840365522898258831134935493656686963645400769432415/166317517282913985958837803500073250055081537737312009327685918,-64381874436262718137449620230590555049202138345676744350662947/99507763925888621424989308167741123823804623494213249353294330,-88394521811247540690139512648091473665451192579348829047177556/141563395355961250221448979142409658923242924076707447605434815,-52408595219929539689311850983297237259496609844624592072246801/55176505175439467602057044475444281592639652502482046758579343,-350580666789644446856793274703807245302646581325741069546818175/538194080190739514300488814305711036874180338109755343860800986,-148301129935139127334407857059959660316585500436551597134902889/321593597194744376872434714227481451710351021593649780912108310,-518538093451953275720638622676843031678261254148194632483353643/914161936321448376037456636516832073865990260235863107907094590,-3094948802877522216160597455919594089963702466268560674535251059/3922351993804722967964265612530884406110866060636093875592345642,222921208904414308492593053103955634083157578151037308990116329/266199728692157260868531599960194630497814624464656345825725268,29222615640203419058231715903672576287255947598625411157835079/31955029314576323086812881460966984668364517133557382119181428,-179942167369368104071533083516245911434357361995657987181694473/965042105841084344165994304165504331942926997983503955982147662,15396811842129776130889949822363995108953527330086728056216619/50625685627735161401617180890384797890322714485751863071071356,-25522240033829238728980681742976495416142497652721241934140998/41564463997793636037956388952338327351973331756813643787581895,2359374072132307299416300566310200096979028202579052978367152244/1491266295677743396903081999882727103741370743024222240000542051,-8739904349836133439532633564095420852375856692482795691321919/21918152932742920744343848545413145491786271252034680978878092,-185525444002775101658773094629977819603368715864085443748072147/28737815099666333962410392479500912149524536651592292423949571,121642777184685844359033588798714419103433018782500968341420310/40133799348378814118291724861982539521012909204943490804577337,1173562384939292025741358433164300763458302859417949035664674000/3073912978114510703223052035222667652173806311599223412194895073,1348888660629144104337918100779915846818918629354098131199563100/904081537146878599514324253463348761736980832678862851321520267,-296683000513612651726599385857052627138469542363434489158619960/656732497874984665734754739957512052398373059024579497583243429,-1349043857112134005935826937031783438669886532010521924538270895/423735194612118533191509998727026686894310697538268402123670208,116295490434110235027496861989073112693118607525781321837021444/72601303606572175067591975983227333922967019041153737672670733,-59964279190407005561516058923324643926777216592271495026204295/28625979312151853892990261371439150959573968526902943954241932,-67728117749786263605284206237723600746122283730132094069123580/83974528308576791139071178405007329231903338122441444271549077,-1046034599180907125953595065190335970723039832410025298021700980/503571638948920612440980094813788449791781562454651074357759737,-54589852611514249990691750297663651606780025330415321190132520/27683667814853549230776450589322756010073053430990298184773119,-49247041906851513389276928964539931407274599909528002063159970/28817380338444742026694819294989310607554944760773885802745833,-112437680140056155127281046353786442087673595955003851959648860/72442069088668324779053889540241027909971921601409069904859709,32246853095595986453652892840615876547163535971103827155140380/11255917119475375924358883013457118794422274676767185942144217,106621068295065578606450005077937904968498841877444574561223740/182573300347853031329783031744335401018922899200797854773656889,5582859694067733146513936381842248985844096801761509830156980/2684759596053262794671678648227131711129737177816379563118187,262470983420904449141124536648891739047575062173167690957759220/130584571862130662964090388607258413380556569716658630844559237,131710392249889555723646183186110449628225384071506688929565340/66117393717677274280441116154940882700604611916739378843909223,333264711190219301995734284129392890904730307673036183217189260/29065659288948411728271005754199962935018757264904379641680081,938953783127948587174481968453513153346898190570353913900977860/585770532299353869703242965455397788890307522096313210535856867,831978469437590092330893549387679769285332603339152495845925935/451653343988461920157140203868501374736228378868405880753449561,42080841906197183196037706518600265076850191372721936689096845/26577207891556610016500808794018778875843788043313942651947394,368266803859166951842425198081111491891469136064127004155731545/177204760680967089541753973545983831379975413017931596647471501,-3808671837859269714692224687998935718587954556880847009193704/3787274262948414028430346858032832640127869153819763697208569,-88624412523989672898836723400926585566242235537967584155931615/181975169738105509423932292210389099919031965060743850317100452,-7191014684311195605637529492778691201549251086718235769362649/1880271816452221727583476944032320141333911891154468027703908,-2054116855881730220878337049373094202742742567962548971363955600/269086995445283441993426018583282212346528290296438116992600647,-91320793367212701504358837373393073751014254766137816003169660/39515598840213055336070530683908509277483024638397852885655439,-103674289469523758796629779881282926293055181656366036207323330/280792656484867133935043662674879854085256316201432821353340049,33819727991483554833797945736644562514456357112489602526808670/54629680880633316997901354183671528522669291763427529780846801,85387929922263295891262230894621088131959508562592891251896800/320728314122930131357191284284458832689085706280960146333938291,66153724312034759757697739370347224478254785424300471846577370/156867719070172610723656213553900512298695260384785683017309121,47494237680343794666803586660011074984426745953345783386426105/5531454904127615511905394369336879176386904946428670441775451,-575998881093256657232024007480912033058171978048137688617713544/991774017502319138375229138396680924139635024445870386014217495,172395590409193590734619893977136767421102311011473380741457475/1339373253090511317030526289588309543214362962706793090694346351,494155110979608757587062328873328588835441122691424877064384130/805390201660229047776285967064474610949534990554016403969382457,10706125626109462238915512069831406705596662716639570719512445200/6408958039354688095637714774549428421212963636431369124405008461,-819335967487597370155195847689475155008427512634615565524486200/1411033560801397396475655444286846508289723648540266060987865979,-11459482009913125436849302635670961981527610437902705161819569600/9476564389889505407982469601402093617351017679376987645757159719,-4731070957810164101996547742710312477785346922030389990281526940/5072926996923746977779578516290809653654134188372548431049926943,-801490573904265650481120306808204012274885093779840512332858040/1236447908987023839436715739912566763987183639744795655478399653,111063628055602894033161914040223306906697792550828273013637705/655606647619815604079658934358892719562754327987048249709592399,-153109902322608191020633855686657099635170373598966016637404560/159061142521209223266293271335854549824800076232000348284729101,-262239661179150110714047314089203339034017283142127727669878840/399246487690737201392114394195482177459384212401020679193223723,-9052214653866966095328446631960547852081806229803883845066561240/7888378644075152870437351294957273310327234310892543035749348881,-311907023775986570397365101134592674240200756044508124301779240/1053323742224506812403002107168904355126160235823091691901979381,-266448755441151335587555201534217735727862971183359383622363295/445998331051838150305015591407500611670741652891872606274128698,647346470868566868304948424295869006147147199323069245671040099/728556628197022255641839490227355257436007009584479056822909226,22835212548628651312671470885416990695178805676506613134827708/16818534752977225525020592155695018167153778386860240190016121,2035251718001733965213551826507696044512208996973479998298811200/3398881389529511272546328421041204498702746738452766977841195909,1136669437552156299809326486393522802037423357255557227040871240/412619184675082462011309582680574610641962431057054251333761207,-718989777356305080260553036256721579612476501264835447701621/24884673342069158420813816832539742758069083295304482541140,-20290584327767454361001991358733629996053119482524119357613096/1331591652166555275875659344946924614711242931555081461402683,-386533998713038682491082758893373567451051662636501330491709924/6305095233811826702230839878398307175743811332390362516664675,-23482388151850454092309667499731147371067783790798055688454204/5107674214063797454390810726914628078561617599283605609934409,-485723494667498017276690478026969462960674611759133552868159/749770824353089975915843594968271965172220341379639011103217,-11987660175674924329969458006614057319272645668374851463111317/643654251385991979188889826411614893597181815114518899026620158,620384897504104488893638922721659287912975838427116220754788655/520783732963725071505304077687264366366916095455489394304103613,36623113088470422301440275034223721411107596790613289976675470/24047960950030072747101081204929115474410823076749330272684341,51279345769477182189660878422797722767773073235365862551099016/27194193827564265708797517172722877876020793063189364224381199,-744356473255442735012728658009467454832078213467643716732286100/1304699947585116065658137451885915233768135865240993723684347923,-326214248884309049241656056357583456042299850658180008412554829/504280573500384376058295057120901078349505482645671861280325526,-172701229573184266547632582503437326966082710289709603394374960/271751704797323232362861909144401612027348368891825140120903129,-3296047665145028599335831848829016382465071353235254899884999240/4823094804477520679211146666689078497095110531950694515929623421,-282067383719061403922374094814889378046682354103265724920347006/435182932473134722174876515770849921268157641862748762333517497,-33811579776864485532796647554067243059947644382650188401348759/54667640080671631752446194056217444273767192268683010226417619},{1857622897881217015144811668492172403997884010252402349510015/2614191240752505834572909905648789654461828585074371863760347,2840315987070670813445197493595527134382544031480035295993225/3055336390329533408513046779392996368598426512057089871310146,-19801502131744100722595351063720999264726178987190825584618294/70131738463282578360480407985176613664486127096808600728828123,-13932982956502016024945812531200447972646921569190774867374115/43834889288230390708167980221144857389874264631124930487326297,-3223123716334257985863364596156370621510245418515245676882595/16026612712025948526735426769203795396209881989443907724124041,-4089433208008156335191149040815909990273875762096708553778326/4680856125721897747764966680722653967293277999589193345256617,-79740202047032867494047974332660974782801425624020780552743226/182073352944510199931699681457010630793579514234031987897249973,-62365033069003626808207154207438201448492279547932286364562020/153155702033632087942501502372510797810128135383688394687190139,-43800431087095159489641968725109169627162581829580371398667784/146834213299558958877297162557500064934701012192737068773332285,-229662006605006522302053612568620496744808675461558629922406/612647133011802902376885828939605990516009673497480495277357,2626145630547187951347988097162830793518134435963214022877985/603547727018558848965857388301880441774372108719571266427707,-251562734416966018105626893068566148680759093834243128298836/2007362320359983011601029017628396674294538280197757999590479,26589278122109426235844330680510594591966824064002922530143035/18773404803929184681879611998850234075946023166297600642787231,-24185144532492195962673387146065886247923717382593123619067452/99146394102460963895589936857620569641217003580035712153752509,36784178460217459319664598040304200362823150456796151042773895/190807400993432157839790299219277181745752515571994662206442109,-2122182478652407341417547625900641579420064898876525245657776/52900732125773654445745315113102616205009106291535177470829045,-83839877705850652247061997277043041272238636556479678403527390/271042692456044871277983162866513803310774132876225504355955037,57593634808730343126581413661114580593430184784605531866248793/396404720764653905750119007838458840754051688046752287263369371,-11144159514788730780624543396353946173188957290737644179601848/115393004286385141563477184947586525615387028647285405439258015,-29405162862955280924434818620809659285367558003622992610343478/92598165417332790592162357361529171250225497565116812659858649,-44501135017731832850682635730426482913832844857515124657910830/132452295130898659356494066293421145894180916063786435656019189,-56845062550640675735826434179525128938755112858913340527166946/93734400358040528489884143038935861940748607750275097284588573,-163954684515854512348322977593313059974845530061182081469118358/470548341421942907385889242960498823001062178805258039109093879,-9995335407438955331707367925145420562330870008235796453584581/28010901526303132293315757566049473660607610605645515597835985,-968616158343250931469818356420064453647451950579278747116270/541528244368061022083511225980476649270580914252805200161381,-4190980135228813564059170924655859651594070745786098518472740/5473238079603641958592100858079420493923070304075223034798313,-3222263159642846933681734858339305296862662627825706965458130/2502074606273758275219117211619808868804405670245632403170657,-9098725394434168899769822257460776952556521189196730733008410/24787085395446413703427861288362557002036934736198122587399723,-16789782151274251167553337995385447719245508552370400135084430/4024818027283970686899510618752737252670220085092412467694937,3532056498430615882360555808509798990691677410731750178034159/248573431239423278242002762762260088224005332666403007786493,1507070075737494674642352376599913288162537633727946516305775/1168825470033905846700307428382980650737128610126167496261343,1594453873900184456537388225633198437517540646771156426006901/3717010396954938259266885383189570384412534319212696225019425,366777736560254104032289682514131114599806446158739543149115/138712015630766615070554501478848655228723528894584079063253,15988574019970750875541919025749822784220625122377935881637791/12674309076669704715221551836643621235024390814334449977747765,96305642310655079868355517249029863523663473705235904557889/109060876653552600780868124780988073148393314557142764442587,-348182668750078171210120797914850842708956601360238630974804/360625164385447072163692737807796456826685622190756867551401,-80350123817305462271958876324110195792654878248498008949869956/91938882046356086401553224045446097890320532616695771573666263,-10218733249574209685693399910131627303165966493699804138072940/12743084487106943024517577033818431589956249849578071001721201,-1861461178515494690286841261773579581617005573189999969721524/2805394092913224518809264202763066053920873671389065888341101,-50163167420474703891734096800827572490928791162597317560136/850478157812350291608700092798908344274412768917383198717557,-43561796224002057915941735869231707063790313214922640868230404/257995804707298365963769936721142648236014471450183167305360563,-1640843166272327954121991939020090054686233325165574822227890/9663073078498767608347912460074524605534013935087821722237139,-1703833465197048756681525218512999209181350235519521509280345/11951178506057548550858037670989010386086161314842188688927384,-344146403505925150143151803801123424522692274349686320687748670/1086672445339209205271795245476396992864576362734157593766753957,2270618151735689552792580781516500500759324710187676089380130/8055986864958603204728494922893816747693630532363377123437957,-51028159023128434294616130088204825471720658361634672550468584/293333311374378451777681890939679378806671657541625413670976165,-82313294648865610358750503829247631965598387288981229053493165/1202763184370624150670439480870925079178701939391212144956588689,-78193700303315309195999231524254188170248148252920883564769540/307356648592677227644529736304525062116115482570105564740588403,1864090241820799480853538003410207181495373981586693054008205/114645209506369039152759465501256585542813741230927966695474911,-39969914008624277553668207831839361538203220975975995959583902/120821517062186688579677361575273106897170522415402358207566063,-2887555111942336175848003049264611559200417044698586604631510/52523294287714817225294234969193646840937501629102236142613901,24537019051400679681975227284603151106796075185007564568062535/46425102386467458984940765818352235069281545078375820360676307,147203839169665586985305676496909152962811217267383958780040738/1933638615087965400005743697145293080698241185137641577280348385,7254719299611493357118461251072001301581887856152597454166678321/27656545246011807919353355369414592866002919627625587061135994470,1364205513006048524507550117290000670825252299384466751992032749/2070651314976447646188113639877120645216083952758188377695593680,-3754354774933018161509208817332503071589440281134229505089377987/13813274421959904877770671123916426749492279895038726457619568185,5042143603400090002178492532046448751432335632590243306404732983/1693466634815835595028783709574027111765841547510528336149469085,22957831708661097890784305215668480818706453214378568543927622/49602877695451995039796025810345377088566875033565734121954793,-37021866234196450313013029760774402534830071301029319333744064/12591362321838285242205861879457507494856062597764067351720127,194150439333561153638144042605601616806012707509635242507050453/229435510137413867651382484991657078322406004892976008967511584,1227490357488619490321408759246263082666945449265405526131353262/2236356497231345157776305107091274736314221549138063334779925241,184575552378075050005116583396017947929765770578977253053447271/611012032326055247641765438206235111800341590860591386398873258,3641059220103677691859496621040154476206725370557512438287811752/1730832988002857230550582683898111798204882039795985308745591975,416071668307608879363251285056208183134473369804663275041061743/191045123547792861322494688282991849942712501253679262851931627,455460627611145216109512300774334561522409195592982324438646753/641672035691443109675479869503940689757133970836239592991382128,689060853691063013138695273468322541715760442884024108210484506/446104926447882605626670634624670363437420711164918315790627695,-10814487619058340302609286375885269622624782745844396433050216663/19779179767200106091931044777098128905304974221456602156852003160,-825434103414419297890846703018744291370979394148729722059006838/154567085121756888404278383528317673246546125880166131794775245,-284384166217281621552690302288732632463949129960936045508959452/1672240209072255227944338649798481612505723212373989625010574645,-60492286718947197960547425655737825944534283480111439071257970/106207774313925010613595685850416489708071457623448035615165907,-974879236213438590502289507046994679415758388016671699241935098/10930905908215517436638963861935147944368246681800779294522210915,977544409395463227830276960833023637828461695539849206699765203/5258081928475633950228442117210906565452022599246235002525351255,-828091017371258912388216861853239911158398778724732514005824192/378875172190743235035166188827845251070801487541561989353434947,424687111384968870372150102706910143982039534574501876167709944/854182231562306069257106349869540174678305812099907243579845923,145674708048836706664294377085037337030284064285238449047275082/263939385729806403296607254334626957164497284363839702238162159,158655558205192529449305119155329588749570775990448523984108027/88023728929805660923568125279355764058875197362041809623668931,-52258087693837580188942015332448296038329985147338697260224349/526797141389945337268040714089752381997584978356473138607436937,15039658989415488284050631100351687134068796127316023421673477/19654060835675962361275725723308347728185719633950773134546901,39077521291842804774504699705163465194997310593389723103883483/86521611342927374164899423785428896928608138147157180993128181,-38155210588217821700118091716984599799874549857870164318619869/9878767304596531640992361483472840102512568246663501517310476,192938702012517293758805145020292896895898150915445106728584045/286194264696991935700206286616023775665372374118889392308906471,288631381426389894129360267980275512019863209229351448667401283/512737049652180452363007541073315755086578216634694382593237239,-133024025714706479896815094921574796714830916327780107093249437/131073549131193621678574822150243784988690322573615583776824,-227040286901140834117072210295302621155095204372651577047368441/32124874089724520034840088206256346023239473615948792925250046,70475245451360358019489107042344398878152467255852082007319621/126005867936055967086713101421558562162702524580708586252908839,97321840314042639167121975260566918068254352376595069753746273/253307202228457073791592441522177713914019868509703041039400901,-368569795621037342313218665809923652634533643716221754535352167/444462041236012930118064974108736576695536442348769030843540598,-7346998713204819770882053914330868269221542468310235870144265/1980485060595530962473359768494903406460677957952116202820586,277495171299291027376835472366279298884684647985777489530971900/443518809801349690567265830693775270754130759964582793448780703,-376711247448770245918425911614527198386432301266715640219742347/46120896394991538522297147109023099857978977348968179768060585,142695500590453990930217908162462523235249000329437826338820227/231285194763364173816861077755992322317776169376036195004431583,-6809056750252638489947816645248182699785295952895412907513462/83158758641456992979418901750036625027540768868656004663842959,28399701287114343908290066258886277250342945990246987144662007/49753881962944310712494654083870561911902311747106624676647165,57869972651547721174694466224349984908377040072930440581630584/141563395355961250221448979142409658923242924076707447605434815,314709174063834105512098559734268942388286995091030986514389976/606941556929834143622627489229887097519036177527302514344372773,-35753277106797955681508272932214455424675823701103895961670974/269097040095369757150244407152855518437090169054877671930400493,87398627455415522728075755790299758799235425562901867672527089/160796798597372188436217357113740725855175510796824890456054155,183046073673485887041563308396723968920063029295864810594074358/457080968160724188018728318258416036932995130117931553953547295,970860611274144676859071714543842279957615032663763737681555602/1961175996902361483982132806265442203055433030318046937796172821,19201279424325978262138775222810663291336388762137666945133249/66549932173039315217132899990048657624453656116164086456431317,-65020399344839449609271962951691004597879746165834875311569941/15977514657288161543406440730483492334182258566778691059590714,130200913115559385570779552842741935060061903972248150359778915/482521052920542172082997152082752165971463498991751977991073831,-21255872878874685607850144658804888412434647290505545466730091/10658039079523191874024669661133641661120571470684602751804496,-47316564786498863905478553997388282783996955777866664288138131/8312892799558727207591277790467665470394666351362728757516379,-1601858015950320353480364407322900675755500167904528818084137422/1491266295677743396903081999882727103741370743024222240000542051,-284246925424515472750527371607256530711078584488462098492939371/438363058654858414886876970908262909835725425040693619577561840,-1526492699128831776739767659028134130088068595890843242358608873/574756301993326679248207849590018242990490733031845848478991420,-74483596044555784740587085753707087434060770032565008926957477/53511732464505085491055633149310052694683878939924654406103116,-42095136656406734965770309153480117634611854444347781599791792/133648390352804813183610958053159463137991578765183626617169351,-597498230125874284767232771944374775770898809774890295164884074/904081537146878599514324253463348761736980832678862851321520267,-998289267544632700719029769853113867152076827080677149743141031/1313464995749969331469509479915024104796746118049158995166486858,-125321080093320170237934445663776537513476244989799873457982751/41340018986548149579659512070929432867737629028123746548650752,-1042249630166304037779782762469560695227971012598634436700084314/943816946885438275878695687781955340998571247534998589744719529,-37930527571240298435781516593887460534765493367066401019086835/14312989656075926946495130685719575479786984263451471977120966,-76055165711118772346039644431607150719232351816196122633125820/83974528308576791139071178405007329231903338122441444271549077,-812098035234702434556152916413185829276332322930306952761813420/503571638948920612440980094813788449791781562454651074357759737,-64714447754611472176236366808819261509573175126799147415090710/27683667814853549230776450589322756010073053430990298184773119,-410980254529089568227456992286229098596242678725461577720110313/288173803384447420266948192949893106075549447607738858027458330,582389419901471385645441146532078107239901530255155770040242928/362210345443341623895269447701205139549859608007045349524298545,518575742464951804501407766108659060676566769296507881169586416/56279585597376879621794415067285593972111373383835929710721085,-588893224972986128195830424602952634393875800152874783953935852/912866501739265156648915158721677005094614496003989273868284445,-222173798484374105243708640138934200899998923915545661424613488/147661777782929453706942325652492244112135544779900875971500285,-188251670313873808689922672757679251319039084601801091438456442/652922859310653314820451943036292066902782848583293154222796185,-1008419904375481002804450064526251569427678215048269338046846/330586968588386371402205580774704413503023059583696894219546115,-787895118918669328489972938442724075225915454340608253993395206/145328296444742058641355028770999814675093786324521898208400405,-2244453110371879039659131764437100953927443408532069145366465488/2928852661496769348516214827276988944451537610481566052679284335,-5321423134603214178471223894344130773047704980008175692499390817/9033066879769238403142804077370027494724567577368117615068991220,-6823244749996658383500661897928520069133004818927768676306464831/10099338998791511806270307341727135972820639456459298207740009720,-1922602029053056157626048653252401963627977401083933484040884171/3544095213619341790835079470919676627599508260358631932949430020,-280470030632005821099242293563364036109337481684506413882136914/18936371314742070142151734290164163200639345769098818486042845,1124879961663130579050189913357110837275947434792736566543599411/1819751697381055094239322922103890999190319650607438503171004520,-531747184875775217677058790906599984499271206168105972678555773/564081544935666518275043083209696042400173567346340408311172400,1738245215388254421015432004316366815472311317572215065027276411/269086995445283441993426018583282212346528290296438116992600647,138069309075478847112468893470907755307847231148942576177322207/39515598840213055336070530683908509277483024638397852885655439,74833467765180860640012700527589927812446893860142177288397636/1403963282424335669675218313374399270426281581007164106766700245,-237400177925020129557852448313245291945632210728507265935915353/546296808806333169979013541836715285226692917634275297808468010,217745633678164397029236386523907010899406316611415432147620373/320728314122930131357191284284458832689085706280960146333938291,125772189894444539101934817984165935763015917960689395329527565/156867719070172610723656213553900512298695260384785683017309121,-32838227640523992340377845186299259543400999556070676018364979/55314549041276155119053943693368791763869049464286704417754510,3418749927195983872059346063504458451521518549206932920752824452/4958870087511595691876145691983404620698175122229351930071087475,7864051756855755182211916170381103137165304739301877699624567047/5357493012362045268122105158353238172857451850827172362777385404,1517110203916307762653104017341750146397511047479159646212442875/1610780403320458095552571934128949221899069981108032807938764914,-2222644094254360059644231795251393490705824456338929536928736117/6408958039354688095637714774549428421212963636431369124405008461,-427644642922366558560379880777425617296852666323146829904391592/1411033560801397396475655444286846508289723648540266060987865979,2776251752955363936978130074274367846936719564376843511074300968/9476564389889505407982469601402093617351017679376987645757159719,2634603836214824400342364820586133208203555508173672111202036616/5072926996923746977779578516290809653654134188372548431049926943,526538240750589138802085530485731097928317641258160611071846056/1236447908987023839436715739912566763987183639744795655478399653,253206560110114373608529275471597245169510818600719059111250513/655606647619815604079658934358892719562754327987048249709592399,8190013288150974757187594160858798976548925686881552432531542/159061142521209223266293271335854549824800076232000348284729101,226655548879650005638083763785530927620231645691870006708946061/399246487690737201392114394195482177459384212401020679193223723,5611288338622958660859028083873047150230060547042341446575363802/7888378644075152870437351294957273310327234310892543035749348881,643992221430186013855520064039900748166495560111073176138670352/1053323742224506812403002107168904355126160235823091691901979381,304312613530224886369717201812997673286303782954707373118706041/445998331051838150305015591407500611670741652891872606274128698,-68190415228713801939055559496461516804740443716768962808984659/56042817553617096587833806940565789033539000737267619755608402,-37578422492204131920981506047569082443262867232378166382993487/84092673764886127625102960778475090835768891934301200950080605,-459415241653971984794741246577381926461608039964939407343215427/13595525558118045090185313684164817994810986953811067911364783636,-157597465379978655878474486056276708877219845530213937782063107/825238369350164924022619165361149221283924862114108502667522414,-1110771999471503383503692119897728397931507266725897024529889/24884673342069158420813816832539742758069083295304482541140,-29653505095180808859022789256905420677549887414815329594017594/1331591652166555275875659344946924614711242931555081461402683,-411179831291207004585237792946363934044318536485416297495278704/6305095233811826702230839878398307175743811332390362516664675,-42539656491296787445804134054913799531255157082176853874419414/5107674214063797454390810726914628078561617599283605609934409,302876008548503412830956940593564179883408938951082838680779/499847216235393317277229063312181310114813560919759340735478,96632829686349965194597601211717386822987205379804078499805059/107275708564331996531481637735269148932863635852419816504436693,400496656395943476392794392124483118502860554021071904729730747/189375902895900026001928755522641587769787671074723416110583132,868231540867292527220894834030555769417510063201767653677917285/529055140900661600436223786508440540437038107688485265999055502,-21241426814847487180505254213209178606492866408007762448949531/135970969137821328543987585863614389380103965315946821121905995,4596741257446133885069242540207659825867865639457370329286394783/6523499737925580328290687259429576168840679326204968618421739615,125333384155095957982868836662333717128156114646204745400340895/252140286750192188029147528560450539174752741322835930640162763,95094840958344244257133672621160508659387284195872754928018140/271751704797323232362861909144401612027348368891825140120903129,2279939316747132679641116494328798095368116780689976804977435820/4823094804477520679211146666689078497095110531950694515929623421,215783254911303572717415584259816383780582305629359375045967998/435182932473134722174876515770849921268157641862748762333517497,14537180460190398792876536922984910985745028032239160974248371/24296728924742947445531641802763308566118752119414671211741164},{-109489335244407976847023519986244983593524469684573419214375602/49669633574297610856885288207327003434774743116413065411446593,-2418898717479766342949196468843335462327876733670452159401119/872953254379866688146584794112284676742407574873454248945756,85302014550259571346972781131737830084140896774791919625370215/70131738463282578360480407985176613664486127096808600728828123,27126694133077934250972784570707082481639188488649781489759588/43834889288230390708167980221144857389874264631124930487326297,14169213114383514434561531198038646999377418474751561212970052/16026612712025948526735426769203795396209881989443907724124041,2227597577408096870167964886385837915484101294969802969461973/4680856125721897747764966680722653967293277999589193345256617,240470971218129300270479147944403124595619681313085643996572469/182073352944510199931699681457010630793579514234031987897249973,179197746426345941280968436450901196207582645199680838070922846/153155702033632087942501502372510797810128135383688394687190139,156930924830996933162244544487051160238817523760505660592938746/146834213299558958877297162557500064934701012192737068773332285,271097083670072691398702599976313933893814701720400925206730103/162351490248127769129874744668995587486742563476832331248499605,-3822642000638398379654982600165280004442422634549420994524282/603547727018558848965857388301880441774372108719571266427707,9100949468974001155886665924157658951394142203134618141159998/10036811601799915058005145088141983371472691400988789997952395,-4872994252855030136742974034612847493501882624450353444683744/18773404803929184681879611998850234075946023166297600642787231,8767983339191305261489179860045523366305357371650981625480358/5218231268550577047136312466190556296906158083159774323881711,94556670852965377123096428444661219688813016441155362108523626/190807400993432157839790299219277181745752515571994662206442109,43791563958202050258319578630215192342996643692311625755017614/52900732125773654445745315113102616205009106291535177470829045,403993044866782726680203850395584434020141638498469593296009298/271042692456044871277983162866513803310774132876225504355955037,477098841595108537081816688386135174986717861468148623375116640/396404720764653905750119007838458840754051688046752287263369371,153621885066196348429298044612399227385558908820042108418498302/115393004286385141563477184947586525615387028647285405439258015,1002031629070371982785441111688918397188845970465369535650284030/648187157921329534145136501530704198751578482955817688619010543,199841779814768838613898619933524924877261611107188773643684298/132452295130898659356494066293421145894180916063786435656019189,59706118355414119333716157704855881484521541680094719680764118/31244800119346842829961381012978620646916202583425032428196191,742625764489012896798196012842272890217731033001550117715739542/470548341421942907385889242960498823001062178805258039109093879,9022507081031812450311919302883410678585061308469193772692730/5602180305260626458663151513209894732121522121129103119567197,2800115339974369005147220354335778962418643559764321436561674/541528244368061022083511225980476649270580914252805200161381,12665786243939834884708444233544643690259735822364849850574442/5473238079603641958592100858079420493923070304075223034798313,5261530663876386415883549163783452523896074189990506591150622/2502074606273758275219117211619808868804405670245632403170657,40014955296368260149514750000564279575888628558958787887663462/24787085395446413703427861288362557002036934736198122587399723,34989861079367362440468259820838844155385200950396012253554818/4024818027283970686899510618752737252670220085092412467694937,2763636323510797360426926691372238966796813972244940773912855/248573431239423278242002762762260088224005332666403007786493,-6938875247402375736563199968123453523844600405565809154717001/2337650940067811693400614856765961301474257220252334992522686,-3026519167846319921228996828099681678099797469783634101069003/3717010396954938259266885383189570384412534319212696225019425,-2409701963811973797158408295767120220884254626972601091778125/277424031261533230141109002957697310457447057789168158126506,-115432645252895768834970977631502020093128311576177367575772809/25348618153339409430443103673287242470048781628668899955495530,-636382577084364683907874512255476285679068812818429235421207/218121753307105201561736249561976146296786629114285528885174,-23472477182660924855392682952737339375806370239489079118998/360625164385447072163692737807796456826685622190756867551401,9467101990979541317318362157491547439659904236875753486894314/91938882046356086401553224045446097890320532616695771573666263,2890200469099600468341499930999021115234219989300948634237574/12743084487106943024517577033818431589956249849578071001721201,2499658334619361537828431739762236980313977830941644688478/6478970191485506971845875756958582110671763675263431612797,894280709504224783598307114891108042327437838778163453198575/850478157812350291608700092798908344274412768917383198717557,261843307535765305512861193935202053924340781916124036318847515/257995804707298365963769936721142648236014471450183167305360563,41137817945087771363821200641161281981658232623685202307966489/38652292313995070433391649840298098422136055740351286888948556,50893902318557015737144180436490337054769486667110674840242049/47804714024230194203432150683956041544344645259368754755709536,1644419946444715046661777131542492789266008855450302920269402898/1086672445339209205271795245476396992864576362734157593766753957,51731237564157925021556917000921146143898397163222181506267462/8055986864958603204728494922893816747693630532363377123437957,26822922595173693177166087188001221838789645628948331583444782/22564100874952188598283222379975336831282435195509647205459705,1303570183505175668880103585613536077528196472525415157310845206/1202763184370624150670439480870925079178701939391212144956588689,403286182377635117798912161207617840953726783815524182829502542/307356648592677227644529736304525062116115482570105564740588403,1206413795295503696274579384939264062083675252460298015809866/1051790912902468249107885004598684271034988451659889602710779,513652064622827361784146418468440226584853666445527900238486443/362464551186560065739032084725819320691511567246207074622698189,66743155795390481152136569219149307042396044515624375684402914/52523294287714817225294234969193646840937501629102236142613901,49433711066814538147359287545780530040155937114512653885972738/46425102386467458984940765818352235069281545078375820360676307,1539555329612301882553932934889120856126636038872252986406361719/1933638615087965400005743697145293080698241185137641577280348385,12721393857157670226495176174043002110789798621903703643344027124/13828272623005903959676677684707296433001459813812793530567997235,125323762510243353588493810584610987097653889353117517887146932/129415707186027977886757102492320040326005247047386773605974605,20384723204135620473205977478832964295275451942895151805555604994/13813274421959904877770671123916426749492279895038726457619568185,901048667585575530509098541459135504860766649236874285264707354/1693466634815835595028783709574027111765841547510528336149469085,-162314830190280513109512639119241233978347360811178585713694535/99205755390903990079592051620690754177133750067131468243909586,-282886966319937111084153054922312900876957499575460951890051759/25182724643676570484411723758915014989712125195528134703440254,-210827075604934711204976886641794821518601789936948391872196185/229435510137413867651382484991657078322406004892976008967511584,-1537101908141428357665736411764668200973123284518108886942257730/2236356497231345157776305107091274736314221549138063334779925241,-362311112349231004325286213730578174822913912012475388225522855/1222024064652110495283530876412470223600683181721182772797746516,-169600654371321645375730478490093951712393606075608104436672714/115388865866857148703372178926540786546992135986399020583039465,-276464216094243599640971175761420559625403160588547616705600938/191045123547792861322494688282991849942712501253679262851931627,593802839658933968633725248289913310524655507930398149703658639/1283344071382886219350959739007881379514267941672479185982764256,2991848082103986104485151063929116456108561346610245952610146/89220985289576521125334126924934072687484142232983663158125539,872067031820900245373175920452524233882561774536916134670054785/494479494180002652298276119427453222632624355536415053921300079,327445844316940767876381750693049635730140351353609882194706770/30913417024351377680855676705663534649309225176033226358955049,35519035567001784312600320398669765495873494589484052460867654/25726772447265465045297517689207409423164972498061378846316533,-100525123005310342949455548085313924775365404364058532638985003/212415548627850021227191371700832979416142915246896071230331814,6215774822781925160912937793412113723248418963881601749057608846/10930905908215517436638963861935147944368246681800779294522210915,35628773430501497485865220960097090243217488999970665956631398/1051616385695126790045688423442181313090404519849247000505070251,1492709432411872270027923168634784775918289797830700984166367437/378875172190743235035166188827845251070801487541561989353434947,-792518694249719021636670182865940859697763810376282008385295227/854182231562306069257106349869540174678305812099907243579845923,-237689151110977985791892606504372741489433792813230283149457137/263939385729806403296607254334626957164497284363839702238162159,-262419173994376384594134676428360544161123134315958104915060699/88023728929805660923568125279355764058875197362041809623668931,-55134825520830641628069738886694346533622132033758248348118207/526797141389945337268040714089752381997584978356473138607436937,-167651196915243246621025154127021150494185630586694461285701829/19654060835675962361275725723308347728185719633950773134546901,-75569030694615369042608579230436654408612521247963714584609451/86521611342927374164899423785428896928608138147157180993128181,-12550514869623003940845597243349794910323274252589521102116519/2469691826149132910248090370868210025628142061665875379327619,-1480775379696049428334885143592517817466689705983701116888997153/572388529393983871400412573232047551330744748237778784617812942,-483661284821941310965514841828321729337919349398533719118221040/512737049652180452363007541073315755086578216634694382593237239,39433634935088580947233431811401805063605697615164842022608350/16384193641399202709821852768780473123586290321701947972103,-153595013301543730355650448284911007481703139259721809807305668/16062437044862260017420044103128173011619736807974396462625023,-592037145738629859664547255918111280011313139076897624867516277/252011735872111934173426202843117124325405049161417172505817678,-223747968424293893552931105911220092875801923726367541040165676/253307202228457073791592441522177713914019868509703041039400901,155243541504170407902599544998429721847801585328749737052937014/222231020618006465059032487054368288347768221174384515421770299,-4338088727563420946849690915047457482909042787710688137106976/990242530297765481236679884247451703230338978976058101410293,-2289661483746701575447085002572944639253940404498332443581447791/887037619602699381134531661387550541508261519929165586897561406,-107887825320992010890123259573062310414409025345435589703350336/9224179278998307704459429421804619971595795469793635953612117,-1044760780973302543738012911372553543118964604017224252121464779/462570389526728347633722155511984644635552338752072390008863166,-144573549110913927770278276966582984721756259475024268697675900/83158758641456992979418901750036625027540768868656004663842959,-170810281689690781303882323346992151692465512199634388763814717/99507763925888621424989308167741123823804623494213249353294330,-122454856665956430288738956834049263572738023921786383078749832/141563395355961250221448979142409658923242924076707447605434815,-47114636991591568719823115160545717543823468225938822824508380/55176505175439467602057044475444281592639652502482046758579343,-474297001766463466317956928432447158732275199059438220127703020/269097040095369757150244407152855518437090169054877671930400493,-556040170643137492391816185791843582579621077987707682136537299/321593597194744376872434714227481451710351021593649780912108310,-397298782192745570910595248361384744118788345407051225825018908/457080968160724188018728318258416036932995130117931553953547295,-1697705938952375920406201748968256274984512595293601115158983800/1961175996902361483982132806265442203055433030318046937796172821,2953252342482332032188731638983881308117354370777253417437251/3914701892531724424537229411179332801438450359774358026848901,2772356400209872017937430311280841550417741706643288384947333/7988757328644080771703220365241746167091129283389345529795357,-1965161664650932427528683308772548271881259019060691388145254913/965042105841084344165994304165504331942926997983503955982147662,273755216302897010258091236591338591492406752726158298259514431/101251371255470322803234361780769595780645428971503726142142712,92783959713470108445357888618048416270069371163114691969891636/8312892799558727207591277790467665470394666351362728757516379,4021050653181729250457208143581795536200142009522699932490122098/1491266295677743396903081999882727103741370743024222240000542051,15290076846290424893640452727517015331178574617476150545414791/21918152932742920744343848545413145491786271252034680978878092,189512597452505527472687475971787134357510194769415444451180608/28737815099666333962410392479500912149524536651592292423949571,102327200840390880042508340969612010571720110596281727716380955/26755866232252542745527816574655026347341939469962327203051558,6450141842300611181539275369265535614310976953996860994422946314/3073912978114510703223052035222667652173806311599223412194895073,1884588253685406925250354445624242734633501552829600747924512954/904081537146878599514324253463348761736980832678862851321520267,628027707374664476605257299594095405781161171943097119752195585/656732497874984665734754739957512052398373059024579497583243429,175423377882394469375387317773013653946916720052248615992939781/26483449663257408324469374920439167930894418596141775132729388,920416009819097701546893187882588285326050921237294355099835002/314605648961812758626231895927318446999523749178332863248239843,-18461685322253017459910423657236373333251261746820271636267421/7156494828037963473247565342859787739893492131725735988560483,14922700413888198834561298904262797701914229368462295316008816/83974528308576791139071178405007329231903338122441444271549077,-368300117519012856574166384121744915338849438971729541971692244/503571638948920612440980094813788449791781562454651074357759737,-50541038149983708133687992331102753596982454331429449760969223/27683667814853549230776450589322756010073053430990298184773119,128257790974725538289496867758172444067233240442838357004855074/28817380338444742026694819294989310607554944760773885802745833,415615920451319749682603022880196294671363394220921352782405562/72442069088668324779053889540241027909971921601409069904859709,-238867783937547028738505588791952995849893000613306884792992806/11255917119475375924358883013457118794422274676767185942144217,164622272184665619466209687451230553805445441066907014066528242/182573300347853031329783031744335401018922899200797854773656889,60825995416080759843844685700514787614806687637205193587446726/29532355556585890741388465130498448822427108955980175194300057,79590036542263847594293789392072616298656016173384417837589214/130584571862130662964090388607258413380556569716658630844559237,-82683669633091651554503659463933396375031813660544878631827454/66117393717677274280441116154940882700604611916739378843909223,108013450602381708324866231667117041584640657437178183149266842/29065659288948411728271005754199962935018757264904379641680081,1275039738114048323671060042930204943985672220495963217731976106/585770532299353869703242965455397788890307522096313210535856867,936121100879711566677784301876295570934127724093416489047737421/451653343988461920157140203868501374736228378868405880753449561,814967509044820581574992060227679014977831890862210634715335413/504966949939575590313515367086356798641031972822964910387000486,279509233422325840749819436209136681548308406099601530829524834/177204760680967089541753973545983831379975413017931596647471501,-50425908826428908672151626902226457199047404093110074403756747/3787274262948414028430346858032832640127869153819763697208569,-126862730100391607861189965018742617881194783118092322132051029/60658389912701836474644097403463033306343988353581283439033484,22135012067478283306024305719335158213431635728563465547741777/4700679541130554318958692360080800353334779727886170069259770,-559092816660107270867545658653225548804747951805506867969138855/269086995445283441993426018583282212346528290296438116992600647,-1751879644099670718482469932723746186954363902275167841317671562/276609191881491387352493714787359564942381172468784970199588073,-52168067860978697733442716251237282323447101659606059994629273/280792656484867133935043662674879854085256316201432821353340049,29604699252974077096968363774716678876742223194597487859580080/54629680880633316997901354183671528522669291763427529780846801,-536034436937520066873334893366686132312310680766344322352466925/641456628245860262714382568568917665378171412561920292667876582,-330698900007454933330604718401781377915205465397622397817506049/156867719070172610723656213553900512298695260384785683017309121,-76306919921326632386964348091101822939220715962500635416628827/11062909808255231023810788738673758352773809892857340883550902,-2143197921104505260111694738014219744698254790237023954406792382/991774017502319138375229138396680924139635024445870386014217495,3018387991857086302989696601037334365953250013613941003276377913/2678746506181022634061052579176619086428725925413586181388692702,-589881831442982337440433012775217070035933290619120010560657565/805390201660229047776285967064474610949534990554016403969382457,1712872705138465505554740475018526984777202551626245825570720420/915565434193526870805387824935632631601851948061624160629286923,371186144357516160284445827066916849279583849690574553687587800/1411033560801397396475655444286846508289723648540266060987865979,-3201237229966051043214851410572506205230115042864733524119043540/9476564389889505407982469601402093617351017679376987645757159719,-3385531970540471229475348415263164517254007533579184091201579110/5072926996923746977779578516290809653654134188372548431049926943,-753799243101179327785057939581723252903048211194236214056180320/1236447908987023839436715739912566763987183639744795655478399653,1064529726660952365869416062250035521265721599075570316950037955/1311213295239631208159317868717785439125508655974096499419184798,-184695914481906361447994486607473137111306912246464677512138365/159061142521209223266293271335854549824800076232000348284729101,-1225684754205281144049722479501151987282026113200327442558325505/798492975381474402784228788390964354918768424802041358386447446,-6474203934535739023641248954271379477515334628794627025545092840/7888378644075152870437351294957273310327234310892543035749348881,-853908329045657158744442613298759926444289641494363046982671240/1053323742224506812403002107168904355126160235823091691901979381,-3743226819926602600590683748705564859486805440822474473980965155/1783993324207352601220062365630002446682966611567490425096514792,-296719283941416528017517382956351983197635561990013158787683891/364278314098511127820919745113677628718003504792239528411454613,22164072166580143065891192873039658791879214770447367257232232/16818534752977225525020592155695018167153778386860240190016121,3665306220107566707927742942158873794618453953587870794643009359/6797762779059022545092656842082408997405493476905533955682391818,-121511937675387440741684818889515771784973173271401880761193475/412619184675082462011309582680574610641962431057054251333761207,-1172973447924808629323741944576457731243527709707232273499157/12442336671034579210406908416269871379034541647652241270570,-59713032865233190906889923857342757526351004461748790503800955/1331591652166555275875659344946924614711242931555081461402683,-58832230735852048411526368278154949030457829502630720176379852/370887954930107453072402345788135716220224196022962500980275,-110984411108669159926672447797782581226210082329204220936914500/5107674214063797454390810726914628078561617599283605609934409,-3503133403017783572256537892665791013673467082645436164045259/1499541648706179951831687189936543930344440682759278022206434,-1997496980092337112605687948017500898076015171214588176167448525/643654251385991979188889826411614893597181815114518899026620158,-351008357492656266238260285581487286530223122013726397673946448/173594577654575023835101359229088122122305365151829798101367871,-855589152983814958274302172787285504779092133384481841216307564/264527570450330800218111893254220270218519053844242632999527751,3235033159293066601857928434880091669925643917505530771473286/2892999343357900607318884805608816795321360964169081300466085,-14245454020006354177797734905110132933919646659968272838754107526/6523499737925580328290687259429576168840679326204968618421739615,-911639097630753908668316837383887277845519047624013315959889349/504280573500384376058295057120901078349505482645671861280325526,-398017272645387546636851639156374697773308893086406693717099926/271751704797323232362861909144401612027348368891825140120903129,-8325155576283596601281082708514921244993712448878635765716823434/4823094804477520679211146666689078497095110531950694515929623421,-776975807908510229492977811318880938773130683743257873866586460/435182932473134722174876515770849921268157641862748762333517497,-108282205639101305371131349914817501123666037288217103411288136/54667640080671631752446194056217444273767192268683010226417619},{13442251908757536611764576979776285483274583294514327211462569/16556544524765870285628429402442334478258247705471021803815531,7233391963397717082445349952612105217533056407110659312360297/4073781853772711211350729039190661824797902016076119828413528,185653005092910137548981729842460631164013864040926135085410153/280526953853130313441921631940706454657944508387234402915312492,2225587715536057434594496716854255919353467820111844810238223/43834889288230390708167980221144857389874264631124930487326297,22244925934644776828179024338385103095540265034889375766127267/80133063560129742633677133846018976981049409947219538620620205,-1215127493779131245440286284087058425183756774183077206259419/1560285375240632582588322226907551322431092666529731115085539,126587862370340085024874046873227032586067890686317688837510661/728293411778040799726798725828042523174318056936127951588999892,58085449512037906929034242122323218248731511822886631354904416/153155702033632087942501502372510797810128135383688394687190139,263349796291379771915445617264740791441843462248241034989086898/734171066497794794386485812787500324673505060963685343866661425,120749205260367103683522865498730768768488492437692781427991387/649405960992511076519498978675982349946970253907329324993998420,7387471887069048880980303532793914464929288219117865691277031/603547727018558848965857388301880441774372108719571266427707,22170260406798820172844895027627387280289053875849785729786016/16728019336333191763341908480236638952454485668314649996587325,575654823426135273105586590515741154237804891647560576137651/18773404803929184681879611998850234075946023166297600642787231,64951969082054702355657770403528278793925061177071099383999072/99146394102460963895589936857620569641217003580035712153752509,242474154266719260919540154513642352543061117025546543936371889/190807400993432157839790299219277181745752515571994662206442109,280399800204016053431660529303375364251803085794739354189200522/264503660628868272228726575565513081025045531457675887354145225,227799596752404797413038492508280794914705133440883107153537089/271042692456044871277983162866513803310774132876225504355955037,198739089063076644811299993847288843161000309503055897859082433/396404720764653905750119007838458840754051688046752287263369371,305290516751196254763003251044331633861920406465642659307278826/576965021431925707817385924737932628076935143236427027196290075,510138109219058515630579445344065840261783962453297366424931475/648187157921329534145136501530704198751578482955817688619010543,100640664571622585441551084681468518722247605291313465717054561/132452295130898659356494066293421145894180916063786435656019189,27902627961896235948040631982167938246360137196353576176776529/93734400358040528489884143038935861940748607750275097284588573,376563129507778024810822224146443796196037666479477300767223047/470548341421942907385889242960498823001062178805258039109093879,23117232511339500035778122230868277201064519045603199923448757/28010901526303132293315757566049473660607610605645515597835985,1896878351088753106941502819352298067796993674323613591917629/541528244368061022083511225980476649270580914252805200161381,614819148302544817111521067211312585940010831565938126893092/497567098145785632599281896189038226720279118552293003163483,52425931261290313813425588628472813003532630776402669851363/36261950815561714133610394371301577808759502467328005843053,20827701621447129200110650920662292870514825051672063081590555/24787085395446413703427861288362557002036934736198122587399723,25503659686540949437908224615012949236058451464245708587569985/4024818027283970686899510618752737252670220085092412467694937,668513707790275238234488506644091859968287399656048720894560/82857810413141092747334254254086696074668444222134335928831,14286245757375304050331037566616850863326297088212541858103337/2337650940067811693400614856765961301474257220252334992522686,-165643300012443380405557483407200240335296888846044603174092/743402079390987651853377076637914076882506863842539245003885,14355580582052691584293361914078652596663664299439374447878449/1387120156307666150705545014788486552287235288945840790632530,101173285337339620096624842442446326597383793292139529655585089/25348618153339409430443103673287242470048781628668899955495530,224604442022931526324855306353740049588062280792318601123083/121178751837280667534297916423320081275992571730158627158430,-308959494963198332080156750698707168783838239403751287852047/601041940642411786939487896346327428044476036984594779252335,-27743060793969906384979023058501874669392888136127721561978281/91938882046356086401553224045446097890320532616695771573666263,-2127295635659869589465479412828635404725001342152050155358215/12743084487106943024517577033818431589956249849578071001721201,-5492233565947346257716108555892256020826366467846252380627/96737727341835328234802213888381588066237023151347099597969,510745963637214043437734668959092501113163183034397387824692/1417463596353917152681166821331513907124021281528971997862595,122735447900551301017177387140974372003205304126078377929899459/257995804707298365963769936721142648236014471450183167305360563,5470650027040122760920419348479821840496834464565470013541464/9663073078498767608347912460074524605534013935087821722237139,431690611823854607000286290558740436354785478334264965706011/824219207314313693162623287654414509385252504471875081994992,64190572476301369287546573734283370796900022108765751958062597/83590188103016092713215018882799768681890489441089045674365689,-6747051412110043189705302915881737626555930255441406349946629/2685328954986201068242831640964605582564543510787792374479319,726787786474496839141559340077398650551752632823033440971868598/1466666556871892258888409454698396894033358287708127068354880825,567730163307681641271314507480570835179967467869989414268704271/1202763184370624150670439480870925079178701939391212144956588689,167127107758691111457757952139308051387463300502460562317444000/307356648592677227644529736304525062116115482570105564740588403,63754668015927027747921069711607954902804228648458016744894589/114645209506369039152759465501256585542813741230927966695474911,141257140489022819970311425499877800124191017869180876308375015/483286068248746754318709446301092427588682089661609432830264252,3277694625619931090591266186019817153997295759002911410926562/17507764762571605741764744989731215613645833876367412047537967,-7264279979423050848042856420653327853508225144924346877404491/15475034128822486328313588606117411689760515026125273453558769,-254683943935802639708267507905993802448741730225796559537319643/1933638615087965400005743697145293080698241185137641577280348385,-2001901547949065482501005302372807164300385652079437897045306803/13828272623005903959676677684707296433001459813812793530567997235,-331945708687042155674027360757635850973218698420762902320522707/1035325657488223823094056819938560322608041976379094188847796840,-1476951741157610160731972082974525843012408065975791652833024568/13813274421959904877770671123916426749492279895038726457619568185,-7813166805403592040514905163354351465788983303097187908127131988/1693466634815835595028783709574027111765841547510528336149469085,60600910343875515267656604861189334220196980108529178369849925/99205755390903990079592051620690754177133750067131468243909586,-403085021587839189723534127308498157803542644710240149578976377/25182724643676570484411723758915014989712125195528134703440254,-263727705128072650504207069094405840608312090605704191085086755/229435510137413867651382484991657078322406004892976008967511584,-1854589266476294136102787839664427409646348758108967579803428990/2236356497231345157776305107091274736314221549138063334779925241,-849389238912683365407208287514044110894541936476076442200041915/1222024064652110495283530876412470223600683181721182772797746516,-390758143412148844991275105862716696233633044929492386228202932/115388865866857148703372178926540786546992135986399020583039465,-137221721059428919033484608527276830999418416450396034429663649/191045123547792861322494688282991849942712501253679262851931627,-531984273729837140306797228929543598013968744566898562516728081/2566688142765772438701919478015762759028535883344958371965528512,-444810768934608306705972652511017859549602422846478829087247122/89220985289576521125334126924934072687484142232983663158125539,-46407569225657902290710926048284888988866763453556943463037260/494479494180002652298276119427453222632624355536415053921300079,-38603316778290934170765022895128620428700761242991675971127050/30913417024351377680855676705663534649309225176033226358955049,-51366416123752436829841150332608908890434055475253716088998894/334448041814451045588867729959696322501144642474797925002114929,-299789672767908851898211079881621108178744305276061286881883349/212415548627850021227191371700832979416142915246896071230331814,-6968502285312134040796242731219790234919777525795500335990291062/10930905908215517436638963861935147944368246681800779294522210915,-906688697413530322247760113843344544881726755668564534535920166/1051616385695126790045688423442181313090404519849247000505070251,629603466830213733671397260556938464007111423425640100194830771/378875172190743235035166188827845251070801487541561989353434947,-392359004396963054894377364960963851615676577120226793640423791/854182231562306069257106349869540174678305812099907243579845923,-25018897103355918079664846525140287786692370001414381154323868/37705626532829486185229607762089565309213897766262814605451737,-300103786256190217630999949077516348497775958194272944061294077/88023728929805660923568125279355764058875197362041809623668931,-79943557876815195877986070301485564856369712333200208572187161/526797141389945337268040714089752381997584978356473138607436937,-16978470393668909883323634869158434428799667590854183667100067/19654060835675962361275725723308347728185719633950773134546901,-20520658006253634474573258797352937115542537116500167171747373/86521611342927374164899423785428896928608138147157180993128181,-10627648568527606721310329282894102740770040116634781211621567/2469691826149132910248090370868210025628142061665875379327619,79923258109986282868443684810392144217130771469349341374568709/63598725488220430155601397025783061258971638693086531624201438,-65239495599784308889657864315238023144440613274773161157465315/170912349884060150787669180357771918362192738878231460864412413,7975896004438924699573525269861391737886843452344717413704710/5461397880466400903273950922926824374528763440567315990701,-122259089998268254922770329623966680576933575108609681306271764/16062437044862260017420044103128173011619736807974396462625023,279187912653202428085937547367187675358152913274060400370978129/252011735872111934173426202843117124325405049161417172505817678,-72346545841193222931470535407963852545663401413814813266383273/253307202228457073791592441522177713914019868509703041039400901,197127860214275684962688150088214169137398106514893514763121222/222231020618006465059032487054368288347768221174384515421770299,-3865706607429590380402011543348721094558473232927477187427188/990242530297765481236679884247451703230338978976058101410293,1156094956308787323065663552170409346345663767986604574224149747/887037619602699381134531661387550541508261519929165586897561406,-98356328824547844532486905452156108638523874356822002703836488/9224179278998307704459429421804619971595795469793635953612117,426696072860459250223206371222055819025034415734876076880693583/462570389526728347633722155511984644635552338752072390008863166,-16306850827557981855856981989298834529339586808902667290933525/11879822663065284711345557392862375003934395552665143523406137,5405937126193123354413710827527685789491679299966567298673987/14215394846555517346427044023963017689114946213459035621899190,-6911875633292774704136987590898100905428486742934208064920748/20223342193708750031635568448915665560463274868101063943633545,-13826175571141133189886836065242634799147015220517174417546890/28901978901420673505839404249042242739001722739395357825922513,-316030033119951490303157330717947180907430857934788112090778335/269097040095369757150244407152855518437090169054877671930400493,154524918017607350656821247152680930945115829055875445888522323/321593597194744376872434714227481451710351021593649780912108310,-141985803645915576903164501943930130181114621533066785008506769/457080968160724188018728318258416036932995130117931553953547295,-36503892314725176010509289312071266483248240471573803907643225/93389333185826737332482514584068676335973001443716520847436801,-153624888216963443386027750224315415070781789732759004079403783/133099864346078630434265799980097315248907312232328172912862634,-9011622448619425316590795194759743983336421956233015604705051/7988757328644080771703220365241746167091129283389345529795357,1691319614787360325801071979609668122384251464172514673108665101/965042105841084344165994304165504331942926997983503955982147662,190825114222512513663763150091452995445396697642337814397665733/101251371255470322803234361780769595780645428971503726142142712,43794039228521990900102760880038728978731487072578298101567288/8312892799558727207591277790467665470394666351362728757516379,587836632228816252187607145795626572774572609734277827152871974/1491266295677743396903081999882727103741370743024222240000542051,12299815615196754344273837105316809455669922007356680627215003/21918152932742920744343848545413145491786271252034680978878092,94096227622209453111052310898926513217717224044121370018693264/28737815099666333962410392479500912149524536651592292423949571,52215805641902391096811962564584804920714167238170642740690575/26755866232252542745527816574655026347341939469962327203051558,1368746178865734457983792947272846810221899558422874805845657132/3073912978114510703223052035222667652173806311599223412194895073,103506016798793179698214893244100191558036121769651033279280982/904081537146878599514324253463348761736980832678862851321520267,407187009162507352975595798724411690739163290019377405481751235/656732497874984665734754739957512052398373059024579497583243429,142474854020362137146474536161115231593275098416393559170768589/60533599230302647598787142675289526699187242505466914589095744,19764074021265021075640215580844348095265514366137685538110146/72601303606572175067591975983227333922967019041153737672670733,-25534910639486656339361276245492436332911231855261261353947293/7156494828037963473247565342859787739893492131725735988560483,-16939103687421020774913586286335514312854960451768576548444472/83974528308576791139071178405007329231903338122441444271549077,-929485134336695881786003405698036075370178803231440748084580652/503571638948920612440980094813788449791781562454651074357759737,-100324821661897416993998410802458114564119090424816178540040009/27683667814853549230776450589322756010073053430990298184773119,44906016980112404960818158815975937134828983767716611847285022/28817380338444742026694819294989310607554944760773885802745833,-231255490569775075978151839403065804837747870911289281738634914/72442069088668324779053889540241027909971921601409069904859709,262762332640933512477762529753219937948010289355899199480600982/11255917119475375924358883013457118794422274676767185942144217,-36816565808853977305408754332461389305461260695646130523045958/60857766782617677109927677248111800339640966400265951591218963,2373333240355016345427238512476408486886535819192898294231558/2684759596053262794671678648227131711129737177816379563118187,-62175025883875742734658364446956140626038882215056682563224918/130584571862130662964090388607258413380556569716658630844559237,25016468283118075296869637521662454661497992836670060646734946/22039131239225758093480372051646960900201537305579792947969741,-30267389004697095592314791966318818910244517411997467295712518/9688553096316137242757001918066654311672919088301459880560027,59243628541084942898280796220815078365893452844560478394813598/585770532299353869703242965455397788890307522096313210535856867,-93084584383239632952821202741510883241248488680747860456474857/451653343988461920157140203868501374736228378868405880753449561,-38229562762701796427874953546417275776581059187460248161598857/168322316646525196771171789028785599547010657607654970129000162,57820562560020642419613161046075655789866618596749071046566892/177204760680967089541753973545983831379975413017931596647471501,-36823103995184844259709095680244371723615711837380175220018967/1262424754316138009476782286010944213375956384606587899069523,140152981594972507890107161829595940790929612911134083358071609/181975169738105509423932292210389099919031965060743850317100452,15776399044330164729371844807507120111320781832179599685581164/7051019311695831478438038540121200530002169591829255103889655,-806397531144510968202011250000503471316916704203197626103877940/269086995445283441993426018583282212346528290296438116992600647,923656247657381928086012519636490321542196251814198696579984899/276609191881491387352493714787359564942381172468784970199588073,-231499228706211320387463222666925813251796674861441560642385714/280792656484867133935043662674879854085256316201432821353340049,37707544337368188649530953415130827118250260287214706700683450/54629680880633316997901354183671528522669291763427529780846801,-111495027075384877488180564321195953352586438540662590714769525/320728314122930131357191284284458832689085706280960146333938291,270926679334861732008486163044564308421688191830055546411440971/313735438140345221447312427107801024597390520769571366034618242,-32622092544130959741156416120977896845248400733693197855382878/5531454904127615511905394369336879176386904946428670441775451,745500204876527596797111246080242438239902408652592367414132884/991774017502319138375229138396680924139635024445870386014217495,-1162629896857210940234127325374282016874031675692015645596742028/1339373253090511317030526289588309543214362962706793090694346351,-416671518384116065080802549197777670896406007612442694978127250/805390201660229047776285967064474610949534990554016403969382457,-1538135762158643875290803098285215822328527069972051837356159130/6408958039354688095637714774549428421212963636431369124405008461,306671587973358530381357917719332762162592775660203730961800900/1411033560801397396475655444286846508289723648540266060987865979,-3264334351433937348277544285573927017831669563614717693087280920/9476564389889505407982469601402093617351017679376987645757159719,-3282208590493485430831798805368796399085122002953563269255818130/5072926996923746977779578516290809653654134188372548431049926943,-730759678438058467512775074558994835562529043175520461055652460/1236447908987023839436715739912566763987183639744795655478399653,-2000771590167178912217541602979069781019436997777505790182318785/1311213295239631208159317868717785439125508655974096499419184798,-242270182779051122607149956281953329944916036621356360985422395/159061142521209223266293271335854549824800076232000348284729101,168220903468418621914275956637740520698404964120107943376069435/798492975381474402784228788390964354918768424802041358386447446,-5245726970461220896114943387190844479971809731522572626386823320/7888378644075152870437351294957273310327234310892543035749348881,-485887371077173386732513703432586134550057898815096881127374020/1053323742224506812403002107168904355126160235823091691901979381,1231880565428827225088982314064203582494328126884428648663191685/1783993324207352601220062365630002446682966611567490425096514792,-530640499634650756472195185431105463895748143323463995729951008/364278314098511127820919745113677628718003504792239528411454613,-1489625321809813837981904463252410879530667533027725226836138/5606178250992408508340197385231672722384592795620080063338707,-1599409084220372497197797732460657131569248661608205268741360529/3398881389529511272546328421041204498702746738452766977841195909,-611213449529472414989885492061622773513830583135434839914631840/412619184675082462011309582680574610641962431057054251333761207,-737211028430287724848669745418755860036273489140964050080808/6221168335517289605203454208134935689517270823826120635285,-86104416564638356327577649851628997511251993731659642104376765/1331591652166555275875659344946924614711242931555081461402683,-1368319316648577669044453790688865114627399008800820668940538892/6305095233811826702230839878398307175743811332390362516664675,-143767549682470164548682836354683095781357061338141670405994160/5107674214063797454390810726914628078561617599283605609934409,737674985697570251478194256845818906941673811148422521555573/1499541648706179951831687189936543930344440682759278022206434,1111369327410440213433767306181721167142766237121131182459375585/643654251385991979188889826411614893597181815114518899026620158,196324454204396842324612933255223818245499920096238934276145731/94687951447950013000964377761320793884893835537361708055291566,461402216606570149653934921024430271861880855133138071170833353/264527570450330800218111893254220270218519053844242632999527751,59069103536958045621366405993435748807447905971804556010606576/135970969137821328543987585863614389380103965315946821121905995,5008251071902187890736827830101021899994455565927428615914178172/6523499737925580328290687259429576168840679326204968618421739615,370803931815246663629386973225459661253066566981283550739974273/504280573500384376058295057120901078349505482645671861280325526,188550298285600735435514728594881069773257888233109651216428902/271751704797323232362861909144401612027348368891825140120903129,3466382621043701062692904445524333298653163823527926799844346018/4823094804477520679211146666689078497095110531950694515929623421,312215524967444441496826178862242913270910323368303904894670880/435182932473134722174876515770849921268157641862748762333517497,80251000278373339387666876646446276975350933207407900847008369/109335280161343263504892388112434888547534384537366020452835238}};
linealitydesired = map(QQ^10, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171},{0,1,2,3,5,6,7,9,10,11,12,13,21,24,25,26,28,31,32,33,34,35,36,37,39,40,41,44,47,48,49,50,51,52,54,55,56,57,58,59,60,61,62,63,65,66,67,69,70,71,72,73,74,75,76,77,83,84,85,86,87,88,89,90,91,92,93,95,96,97,99,100,101,102,104,105,107,109,110,112,113,114,116,121,122,123,124,125,126,127,128,129,130,135,136,137,138,139,141,142,143,146,147,148,149,151,152,153,154,156,157,158,160,161,162,164,165,166,167,168,170,171},{0,3,4,10,12,14,16,17,19,20,22,23,24,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,46,48,51,52,53,54,56,57,58,59,61,62,63,64,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,100,101,102,103,105,106,107,108,110,111,113,114,115,131,132,133,134,135,136,137,138,139,140,141,143,144,150,151,152,153,155,156,157,159,160,161,162,163,164,166,167,168,169,171},{0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,17,18,29,30,31,32,33,34,35,36,37,38,39,40,41,42,45,46,47,48,49,50,51,52,53,54,55,56,58,59,60,62,63,64,65,66,67,68,73,74,75,76,77,78,79,80,81,83,84,85,87,88,89,90,91,92,93,94,95,96,97,98,99,118,119,120,122,123,124,126,127,128,129,130,132,133,134,136,137,138,139,140,141,142,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166},{0,1,2,9,10,11,12,13,14,15,16,17,18,19,21,22,23,24,25,26,27,28,29,30,31,32,33,34,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,59,60,61,62,63,64,65,66,67,68,70,71,72,73,74,75,76,77,78,80,81,82,84,85,86,88,90,92,93,94,96,97,98,99,101,102,103,104,105,106,107,108,109,110,111,112,117,118,119,121,122,123,125,126,128,130,131,132,133,135,136,137,139,140,141,142,143,144,145,146,147,149,150,151,152,162,163,164,165,166,167,168,169,170,171},{0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171},{0,1,2,4,5,6,8,9,14,15,16,17,18,19,20,21,22,23,29,30,33,34,35,36,38,39,40,42,43,44,45,46,49,50,51,52,53,55,56,57,58,59,60,61,62,64,65,66,68,69,70,71,72,73,74,75,76,78,79,80,81,82,87,88,89,90,91,92,94,95,96,98,99,100,101,103,104,106,108,109,111,112,113,115,116,117,118,119,120,125,126,127,128,129,130,131,132,133,134,139,140,142,144,145,147,148,149,150,152,153,154,155,157,158,159,161,162,163,165,166,167,169,170,171},{0,1,3,4,5,7,8,10,11,12,13,14,15,16,17,18,19,20,23,24,25,26,27,28,29,30,31,32,34,35,37,38,39,41,42,43,44,45,46,47,48,50,51,57,58,59,60,61,62,63,64,65,67,68,69,71,74,75,77,78,79,80,81,82,83,84,85,86,89,90,91,92,93,94,105,106,113,114,115,116,117,118,119,120,121,122,123,124,129,130,131,132,133,134,135,136,137,138,139,143,144,145,146,148,149,150,151,152,157,158,159,160,161,167,168,169,170,171},{0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,43,44,45,46,47,48,49,50,51,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,105,106,107,108,109,110,111,112,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,154,155,156,158,159,160,161,163,164,165,166,168,169,170,171},{2,3,4,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,27,28,29,30,31,32,33,36,37,38,40,41,42,43,45,46,47,48,49,52,53,54,55,63,64,66,67,68,72,73,76,77,78,79,80,81,82,83,84,85,86,87,88,95,96,97,98,99,100,101,102,103,104,107,108,109,117,118,119,120,121,122,123,124,125,126,127,128,131,132,133,134,135,136,137,138,140,141,142,153,154,155,156,162,163,164,165},{0,1,2,3,4,5,6,7,8,10,11,14,15,16,20,21,22,23,24,25,26,27,28,30,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,62,63,64,65,66,67,68,69,70,71,72,75,76,77,78,79,80,82,83,84,86,87,88,89,90,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,119,120,121,123,124,125,127,128,129,130,131,133,134,135,137,138,139,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171},{1,2,5,6,7,8,9,11,13,15,16,18,19,20,21,22,23,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,47,49,50,57,60,61,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,143,144,145,146,147,148,149,167,168,169,170},{3,4,5,6,7,8,9,12,13,17,18,19,20,21,22,23,24,25,26,27,28,29,31,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,81,82,83,85,86,87,89,91,93,94,95,97,98,99,100,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,120,121,122,124,125,126,127,129,131,132,134,135,136,138,140,141,142,143,144,145,146,147,148,150,151,153,154,155,156,157,158,159,160},{0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,69,70,72,73,74,91,92,93,94,95,96,97,98,99,100,101,102,103,104,107,108,109,110,111,112,113,114,115,116,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 9
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0,0,0,0,1,1,1/2},{0,0,1,0,0,1,0,1,1/2},{0,0,0,1,0,1,1,0,1/2},{0,0,0,0,1,1,1,1,3/2}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,1,0,-1,0,1,-1,-1},{1,1,0,0,-1,0,-1,1,-1},{0,-1,0,0,-1,1,1,1,-1},{0,-1,0,1,-1,0,-1,-1,1}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,2,3,5},{0,3,5,7,8},{2,3,5,6,8},{0,1,2,3,8},{0,1,2,5,6,7},{1,2,4,6,8},{0,1,4,7,8},{4,5,6,7,8},{1,4,6,7}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,0,1},{0,1,0},{1,0,0}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,0},{-1,0,1},{0,0,0}};
linealitydesired = matrix {{1},{1},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,1},{0,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,0,1},{0,1,0},{1,0,0}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,0},{-1,0,1},{0,0,0}};
linealitydesired = matrix {{1},{1},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,1},{0,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,0,1,1},{0,1,0,1}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,-1},{1,0,-1,0}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{1,2},{0,3},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 8, dim: 3, nvert: 8
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0,1,0,1,0,1},{0,0,1,1,0,0,1,1},{0,0,0,0,1,1,1,1},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0}};
raysP = map(QQ^8, QQ^0, 0);
linealityP = map(QQ^8, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,0,0,-1},{0,0,1,0,-1,0},{1,0,0,-1,0,0},{0,0,0,0,0,0},{0,0,0,0,0,0},{0,0,0,0,0,0},{0,0,0,0,0,0},{0,0,0,0,0,0}};
linealitydesired = matrix {{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{1,0,0,0,0},{0,1,0,0,0},{0,0,1,0,0},{0,0,0,1,0},{0,0,0,0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,2},{0,2,5},{0,1,4},{0,4,5},{1,2,3},{2,3,5},{1,3,4},{3,4,5}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,-1,1,-1},{0,0,2,2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,-1},{1,0,-1,0}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,3},{0,1},{2,3},{1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 8, dim: 3, nvert: 8
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0,1,0,1,0,1},{0,0,1,1,0,0,1,1},{0,0,0,0,1,1,1,1},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0}};
raysP = map(QQ^8, QQ^0, 0);
linealityP = map(QQ^8, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,0,0,-1},{0,0,1,0,-1,0},{1,0,0,-1,0,0},{0,0,0,0,0,0},{0,0,0,0,0,0},{0,0,0,0,0,0},{0,0,0,0,0,0},{0,0,0,0,0,0}};
linealitydesired = matrix {{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{1,0,0,0,0},{0,1,0,0,0},{0,0,1,0,0},{0,0,0,1,0},{0,0,0,0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,2},{0,2,5},{0,1,4},{0,4,5},{1,2,3},{2,3,5},{1,3,4},{3,4,5}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 0, nvert: 1
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1/2},{1/2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0},{0}};
linealitydesired = matrix {{1,0},{0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{7,29,40,40},{7,7,7,7},{0,22,0,11},{2,2,2,2}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,0,-1,-1},{0,0,0,0},{-1,1,0,-1},{0,0,0,0}};
linealitydesired = matrix {{0,0},{1,0},{0,0},{0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{0,3},{1,2},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: -1, dim: -1, nvert: 0
-- Checking normal_fan + several booleans
TEST ///
verticesP = map(QQ^0, QQ^0, 0);
raysP = map(QQ^0, QQ^0, 0);
linealityP = map(QQ^0, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = map(QQ^0, QQ^0, 0);
linealitydesired = map(QQ^0, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 8
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-1,-1,-1,-1,1,1,1,1},{-1,-1,1,1,-1,-1,1,1},{-1,1,-1,1,-1,1,-1,1}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,0,0,-1},{0,0,1,0,-1,0},{1,0,0,-1,0,0}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,2},{1,2,3},{0,1,4},{1,3,4},{0,2,5},{2,3,5},{0,4,5},{3,4,5}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 1, nvert: 2
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0},{0},{0}};
raysP = matrix {{0},{1},{0}};
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0},{1},{0}};
linealitydesired = matrix {{1,0},{0,0},{0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 44
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{10,10,9,8,7,6,5,4,3,2,1,0,-1,-2,-3,-4,-5,-6,-7,-8,-9,0,1,-1,2,-2,3,-3,4,-4,5,-5,6,-6,7,-7,8,-8,9,-9,-10,-10,0,0},{1,1,81/100,16/25,49/100,9/25,1/4,4/25,9/100,1/25,1/100,0,1/100,1/25,9/100,4/25,1/4,9/25,49/100,16/25,81/100,0,1/100,1/100,1/25,1/25,9/100,9/100,4/25,4/25,1/4,1/4,9/25,9/25,49/100,49/100,16/25,16/25,81/100,81/100,1,1,30,30},{-10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,-10,-10,-10,-10,-10,-10,-10,-10,-10,-10,-10,-10,-10,-10,-10,-10,-10,-10,-10,10,-10,10,-10}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,-1,-1},{0,100/19,100/17,20/3,100/13,100/11,100/9,100/7,20,100/3,100,-10/29,100,100/3,20,100/7,100/9,100/11,100/13,20/3,100/17,0,-10/29,100/19},{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,22,23},{21,22,23},{20,21,23},{19,20,21},{18,19,21},{17,18,21},{16,17,21},{15,16,21},{14,15,21},{13,14,21},{12,13,21},{10,12,21},{9,10,21},{8,9,21},{7,8,21},{6,7,21},{5,6,21},{4,5,21},{3,4,21},{2,3,21},{1,2,21},{0,10,12},{0,12,13},{0,9,10},{0,13,14},{0,8,9},{0,14,15},{0,7,8},{0,15,16},{0,6,7},{0,16,17},{0,5,6},{0,17,18},{0,4,5},{0,18,19},{0,3,4},{0,19,20},{0,2,3},{0,20,23},{0,1,2},{1,11,21},{0,1,11},{11,21,22},{0,11,22}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 8
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-1,-1,-1,-1,1,1,1,1},{1,1,-1,-1,1,1,-1,-1},{-1,1,1,-1,-1,1,1,-1}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,0,0,-1},{0,0,1,0,-1,0},{1,0,0,-1,0,0}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,4},{1,3,4},{1,2,3},{0,1,2},{0,4,5},{3,4,5},{2,3,5},{0,2,5}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,1,2,2},{1/2,4,2,4}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,0,-1},{2/3,0,-1,0}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{1,2},{0,3},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,1,2,2},{1,4,2,4}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,0,-1},{1,0,-1,0}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{1,2},{0,3},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 6, dim: 3, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{10,50,40,200},{20,60,80,240},{20,100,50,250},{40,120,100,300},{30,150,60,300},{60,180,120,360}};
raysP = map(QQ^6, QQ^0, 0);
linealityP = map(QQ^6, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,-1,-1,1},{-1/2,5/7,1/6,-1/3},{-2/5,1/7,2/3,-1/3},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
linealitydesired = matrix {{1,1/4,3/5},{-1,3/4,-1/5},{-1,-5/4,0},{1,-3/4,-4/5},{0,1,-3/5},{0,0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2,3},{0,1,3},{0,2,3},{0,1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 3, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,2,0,0},{0,0,2,0},{0,0,0,2},{0,0,0,0}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,0,0},{-1,0,1,0},{-1,0,0,1},{0,0,0,0}};
linealitydesired = matrix {{0},{0},{0},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2,3},{0,2,3},{0,1,3},{0,1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0,1},{0,1,1,0},{0,0,1,1}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,-1,1},{-1,-1,1,1},{-1,1,1,-1}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2,3},{0,1,2},{0,1,3},{0,2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{2,1,2,3},{3,2,1,3}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,0,-1},{1,-1,-1,1/2}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,1},{0,3},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,1,2},{0,0,1,1}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,-1},{1,-1,-1,1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{0,3},{1,2},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,2,3},{2,1,4}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,1},{1/3,-1,1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,2},{0,1}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{2,1,2,3},{3,2,1,3},{3,0,3,6}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,0,-1},{1,-1,-1,1/2},{0,0,0,0}};
linealitydesired = matrix {{-3},{0},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,1},{0,3},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{3,5/3,1},{3,1,5/2},{0,0,0}};
raysP = matrix {{0},{0},{1}};
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,1,0},{2/3,-4,4/9,0},{0,0,0,1}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,3},{0,2,3},{1,2,3},{0,1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(not isPure computed)
assert(not isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,2,3},{1,3,4}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,-1,1},{-1,2/3,-1/2}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,2},{0,1}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 5
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,2,100,200,300},{1,3,100,300,400}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,-1,1,-1,1},{-2/3,1,-1/2,2/3,-1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,2},{1,3},{0,4},{3,4}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{10,20,30},{10,30,40}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,-1,1},{-1,2/3,-1/2}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,2},{0,1}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{100,200,300},{100,300,400}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,-1,1},{-1,2/3,-1/2}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,2},{0,1}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 5
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{3,2,0,0,2},{2,3,2,0,0}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,0,-1,-1},{-2,0,1,1/2,-1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{3,4},{0,4},{0,1},{1,2},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{4},{3},{6}};
raysP = matrix {{1,0,0},{0,1,0},{0,0,1}};
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,0,0},{0,1,0},{0,0,1}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 10
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-8321380980819469/18014398509481984,-2046832846729167/2251799813685248,-1395443436688569/2251799813685248,-2921087368224267/9007199254740992,3158955016339417/4503599627370496,-645185810192095/4503599627370496,-8785454187900665/18014398509481984,-1856249633652963/36028797018963968,652448659914173/4503599627370496,7400843317009793/9007199254740992},{497280854233727/562949953421312,-5214195841833365/18014398509481984,1541928798574789/2251799813685248,-8404474291755813/9007199254740992,-4554416331438637/36028797018963968,-2242450194601267/4503599627370496,7231155802807217/9007199254740992,1118208975922993/1125899906842624,4325865856382841/4503599627370496,-8575916459934019/72057594037927936},{-5727137213455727/72057594037927936,5403807400775047/18014398509481984,-863594578515533/2251799813685248,5602426447207211/36028797018963968,6318008545109617/9007199254740992,7703911214107073/9007199254740992,-6178664207807011/18014398509481984,7543963564198213/72057594037927936,534697330835169/2251799813685248,-2510378208572705/4503599627370496}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,-1,1,1,1,1,1,1,1,1,-1,1,-1,-1,-1,-1},{-154976898510282527762332876384448/1665813342656233806177763285119,803477281067114460418246695141568/424397965461272524742232334702003,-41203338169412264545107614510939/44596522690162289138091529735896,-268441668307298676913528780629595/36624029714405909573455286583216,232239030117548015441952900430572/376871381140052196845992215861133,-6256975424181938834960663252261/5163955630559290323069412378102,-254141965359009292832703982685188/560670864597870164037606381075021,94178095506297577105424300551648/83845597471245234461235278897809,-102727953031062138690026079428596/110518665712443380883271560213293,-13170000671726657685073168738386/14184232164330178640852995856029,-15089718394432802070617253481192/2233318169627628306691090224889,2150337632810873755046807011199992/1855174910802791344622624962003537,-3529181271453308232113584032041252/1930850808739794872807671248490459,-1277084351382360881599942291574792/878850810684437448932355915084673,3522689223735609000357356641122968/2646834078104155187913065104198375,-98187501602523916564593997356152/177171071653249985701528413356151},{-365050632543375719291141354469272/1665813342656233806177763285119,-389829826030853460769718614629444/424397965461272524742232334702003,-93510944432923874946344349226753/55745653362702861422614412169870,3269038379499828795335385255107/1526001238100246232227303607634,490525643032686887072903862987156/376871381140052196845992215861133,100523006299508520033608035604/368853973611377880219243741293,-124943593240877784806251328671292/560670864597870164037606381075021,-240762444513818892874881781327420/251536792413735703383705836693427,-190952450993620937631982598907304/110518665712443380883271560213293,-121101668337684753910414777693538/70921160821650893204264979280145,51233346040507844339202087559739/2233318169627628306691090224889,5437522305932529588811392569661940/1855174910802791344622624962003537,3381794507301208035553707402179434/1930850808739794872807671248490459,986177817122060658638067292728354/878850810684437448932355915084673,-46419208077477744818438848526252/529366815620831037582613020839675,-17497951936622914997961324315302/177171071653249985701528413356151}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{2,3,5,6},{2,4,6,7,8,9},{4,5,6,10,11},{1,4,7,11,14},{0,1,14,15},{0,1,7,8},{3,5,10,12},{2,3,9,12,13},{0,8,9,13,15},{10,11,12,13,14,15}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,2,1,2},{1,2,3,4}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,-1,-1,1},{-1/2,2,0,-1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{1,2},{0,3},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 5
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1/2,-1/2,3/4,2,100},{2/3,2/3,2/3,3,200},{3/4,-3/4,1/2,4,300}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,-1,-1,-1,-1,1},{1,-27/28,57/28,1506/605,-3294/2941,150/299},{0,1,-1,-802/605,3166/2941,-2/3}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,2,3,5},{0,1,4,5},{0,1,2},{1,2,3,4},{3,4,5}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,0,0},{0,1,0},{0,0,1}};
raysP = matrix {{1,1,1},{1/2,2,1},{1/2,1,2}};
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,-1,-1},{-1/3,1,3,-1},{-1/3,1,-1,3}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2,3},{0,1,3},{0,1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{3/2,-1/2,1/2,1/2},{1/2,1/2,3/2,-1/2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,-1,-1},{1,-1,-1,1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{2,3},{0,1},{1,2},{0,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 8
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{3/2,-1/2,1/2,1/2,1/2,1/2,1/2,1/2},{1/2,1/2,3/2,-1/2,1/2,1/2,1/2,1/2},{1/2,1/2,1/2,1/2,3/2,-1/2,1/2,1/2},{1/2,1/2,1/2,1/2,1/2,1/2,3/2,-1/2}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1},{-1,-1,-1,-1,1,1,1,1,1,1,1,1,-1,-1,-1,-1},{-1,-1,1,1,1,1,-1,-1,1,1,-1,-1,1,1,-1,-1},{1,-1,1,-1,1,-1,-1,1,-1,1,-1,1,-1,1,-1,1}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{8,9,10,11,12,13,14,15},{0,1,2,3,4,5,6,7},{0,1,2,3,12,13,14,15},{4,5,6,7,8,9,10,11},{0,1,6,7,10,11,14,15},{2,3,4,5,8,9,12,13},{1,3,5,6,8,10,12,14},{0,2,4,7,9,11,13,15}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 6, dim: 0, nvert: 1
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{9},{2},{3},{5/3},{7},{8}};
raysP = map(QQ^6, QQ^0, 0);
linealityP = map(QQ^6, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0},{0},{0},{0},{0},{0}};
linealitydesired = matrix {{1,0,0,0,0,0},{0,1,0,0,0,0},{0,0,1,0,0,0},{0,0,0,1,0,0},{0,0,0,0,1,0},{0,0,0,0,0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 5, dim: 5, nvert: 30
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-5598328990451811/9007199254740992,3777620441948237/4503599627370496,4418539202935145/9007199254740992,-1592841753493911/2251799813685248,-1980074418118299/2251799813685248,4062289440118025/144115188075855872,-1534788755053875/4503599627370496,5154614830089621/9007199254740992,-176471207488601/1125899906842624,-4869384269756099/9007199254740992,-6275654216514169/18014398509481984,-8004268056164247/18014398509481984,-1720585855597915/4503599627370496,6770863399125245/9007199254740992,4906596993336227/18014398509481984,7518769700245131/18014398509481984,3873759404467819/18014398509481984,4611594854493707/9007199254740992,4535225110417005/36028797018963968,725771343531445/2251799813685248,4731746948712399/9007199254740992,-6999808219063515/18014398509481984,8498537721439323/36028797018963968,863909600946401/1125899906842624,-4832748118431069/9007199254740992,-1327177153243993/4503599627370496,5616323680980541/18014398509481984,1420200028061885/9007199254740992,-3383920391010463/9007199254740992,-6216336502461919/18014398509481984},{3371268707508129/18014398509481984,-5592500342912677/36028797018963968,25559801593243/70368744177664,-2681470054059467/4503599627370496,-2032330912371163/36028797018963968,3048738948531517/9007199254740992,3420222221312861/36028797018963968,4022269630422909/9007199254740992,8039681728413625/36028797018963968,5350710987515295/36028797018963968,367788036945457/562949953421312,3769827716064097/9007199254740992,7774672318662379/36028797018963968,-4481514917920841/9007199254740992,-5415726275712849/18014398509481984,-8042637357117765/72057594037927936,259767978970229/562949953421312,-2402810337271949/4503599627370496,3926113281217697/4503599627370496,-815739787508811/1125899906842624,8358270110109467/36028797018963968,3211411055535905/4503599627370496,-1282892812749639/72057594037927936,-4687210624738771/18014398509481984,-893933028032745/9007199254740992,6314337818614101/9007199254740992,-1645748766363317/2251799813685248,2364889909458529/9007199254740992,-3655412031969609/36028797018963968,-859902939708217/4503599627370496},{-6422464245712071/9007199254740992,-6110960293924753/72057594037927936,-4581552926469817/18014398509481984,6228439249536507/18014398509481984,-5919330107449753/18014398509481984,-2520759177270837/36028797018963968,5698097950820535/18014398509481984,-5329543323608161/9007199254740992,-8503839958730201/18014398509481984,-7464635572503913/18014398509481984,-8817794491578457/576460752303423488,6927105333572151/18014398509481984,155883896264733/281474976710656,5773302243960451/144115188075855872,-3969214973075861/9007199254740992,-6842265559142219/9007199254740992,-7042355303878687/9007199254740992,-1592195512773535/9007199254740992,-5010351266190501/72057594037927936,5412617918109677/36028797018963968,-8434620052677571/72057594037927936,-5070402520843973/9007199254740992,7869580771628243/9007199254740992,-24487886169215/562949953421312,1439701590339593/2251799813685248,5458320387169527/9007199254740992,-4354825894656637/9007199254740992,-2033789824063999/2251799813685248,450632801902065/562949953421312,-7398250507171181/36028797018963968},{4268940445219201/18014398509481984,4133133059406535/9007199254740992,-6610740820691177/9007199254740992,-3928871068873463/36028797018963968,-1903164696793651/9007199254740992,2987133430087697/4503599627370496,1909645223295919/2251799813685248,-1550768394933915/4503599627370496,-5146084209112339/9007199254740992,-3771559750095457/9007199254740992,5803006914767713/9007199254740992,1870848427486067/4503599627370496,-4891436761992733/36028797018963968,-8157670532243477/36028797018963968,-2756261284663797/4503599627370496,7779272550430957/18014398509481984,-3518238171924947/36028797018963968,619803648487189/1125899906842624,-131358470183143/281474976710656,8414930447751551/36028797018963968,-5491632645541567/9007199254740992,-2661380839917049/18014398509481984,-6174016550634881/18014398509481984,-7768768483305473/72057594037927936,-2438369684949889/72057594037927936,1760047786678381/9007199254740992,1493922943799913/4503599627370496,-1457953409119077/9007199254740992,3585459996476439/9007199254740992,5605764161747785/18014398509481984},{-8552810573599677/72057594037927936,-8416111715773939/36028797018963968,-5589811984556883/36028797018963968,527038559079857/4503599627370496,2399733743996235/9007199254740992,-2986693985149297/4503599627370496,-4247923820104457/18014398509481984,-2391213553271799/36028797018963968,2762958491381179/4503599627370496,-5241611821515489/9007199254740992,1720810605985087/9007199254740992,-4990437675891715/9007199254740992,-6255538458961723/9007199254740992,-6606556655692343/18014398509481984,-2325718681808663/4503599627370496,4020003922048729/18014398509481984,-3120098568315485/9007199254740992,776520069070977/2251799813685248,-5662437269768825/144115188075855872,4884404376989341/9007199254740992,-4806691291433409/9007199254740992,6154221727638177/144115188075855872,-4529869532607407/18014398509481984,1293610881489911/2251799813685248,-152192044151135/281474976710656,287461941206257/2251799813685248,2839936506064697/18014398509481984,1141656810562905/4503599627370496,-8002170130591949/36028797018963968,-3782663294692597/4503599627370496}};
raysP = map(QQ^5, QQ^0, 0);
linealityP = map(QQ^5, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,-1,-1,-1,-1,-1,1,-1,1,-1,-1,-1,-1,-1,1,-1,-1,1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,-1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,1,1,-1,1,1,1,1,-1,-1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,1,-1,1,1,-1,1,1,1,-1,1,1,-1,-1,-1,-1,-1,-1,1,1,-1,1,-1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},{-10492387812132849699495069707743411911571472960168607180507797557/53822083579557422774652612413796211449942129145925359703869462059,-453552974764309112358842908868160884714130414721065879336202150750/2717212121600571431220572555198598635712684347893134971613128915157,479709460418821344172442213038159108083741553368351485077362058936/969556828609776968580009160023490013920541288925682888276919719667,638908729230937377508366560278677274101477302806751960475380049704/1200436107157517229045691638259255899099519559862791507107885803863,29383945289937990333015357092748422217374493292322704031768611714/28701509502195275365156629881879581547840519728985057647117639409,207042923640482749859352954153533830176368356202285096281248350066/611073924557569869510231347409391962444578680605022610715360282283,5517722538402897773789088247434683931651312412613062210735909112030/2903891701645797639027841751618425348089316611606464083930517677003,279121757294300360731591100170091993573528118796281215387766956297/98544861419165339008684619769467213194427963768343213063728687725,77521479497947101492616627947322970467846798161757011012641909647/13325212700458212094265010815753470526675274245535590565189557201,2322375634543212752528899908349239875271364445928976788366634264762/485129857472609549463533504260980963036911195633616694215052496319,1717693129713566642733902690254040760836192255841435654810339512041/334431874926832121031610133219173804815757300372790377291710181187,705038474308247579332168168310524645565140641866712133193846184298/101241540015561674842940457771878501325436867963345124040466461101,21584748217563952426549646122348659010672087335080215605329661969/12637305016373594128924431122926200710746831434657807245021729528,135392786467392078014225860357362338613800511915959610098190865321/221878233699638723719363747729255903520632703018370452972633531864,1438984631838878995420799263323882134572416704659010535463067693806/454541894996366620912279566307989308686841094453896101107721441547,34498395596486115931943617005406564777133909904998691310017422012/98057557914721568921705207724373213122491048688897640348941050713,56553946803384320725729163202817230037364955599240896249082365391/106263943165269297082022235560005883185015625675000285511276304807,-1139503230071865326162098541275774588618131935914371243738207781336/1227298018203246961367613975268346121879450177284307232283906211931,2824391856825246138851472669660406103886159362778326311356606928/5042052563873379099907392476950308252849883588125845768587417417,-12532511619724832516298551205307569919552480720117311780265567569548/9497906415112986328102927422303342608431119386856540469010524194703,-120779439063957965358421220224122766767269717532190145681921031184/80397096923550340340633364029382949269608100159829544422130628619,-2095509061983740145869104618345816607808313987722561452889149863343/1358381567973601736578305751892528914819638617118553076159091313988,-720529363737427592257281755517829072030102030901408870717606429692/410671192628878224098128881256577191846944037349293457229800966399,-37786645564478909631607948189732838040393070268404917417530340508/20795134220799298596336735643206981189674468542192249278206180455,108930837736515856337715752103605812967412538411313879885348680928/177373217882008010412363878479714643734896062706717440999951076833,-1960219939143495493935058639722255343459568988024696797760851479220/200373375047299518441721193973256107519008578396539415575315846499,-190869773016095773739985351927381645685978408774539122991941860/48329357514700365364043131079378865104880621038177782630130977,89543195862981017571795250952962275105233781783168477267777035992/47742076512068834271862197786004779227467149271002356936688817051,-46958958706966337640750124602010053594589603298344309763706879580/1244416607042545611455002299143986970327029994272482373744093431,-194252096286838588449268294134731315272793231837279435617663443557/279594003131945258188157154554085617549379569265633728802798063251,-2329978376892552202868557397021223419744929935056332000352269820968/535606377326462265516516522731547102297930464898110766656709967939,-1893760935691632673616404360848283861090829884676603638234072218312/882638977453196392980184400785129844673947564558481924140453290499,-2597382127115109964637909383098542797631216495863157114119283547106/2815006540480116342700459381568140544996940980620124609182119756073,733101371012079281737180047806893991199214131087921224905430615212/119098157918760307599990471066688713375280761783506027130804376349,328484209024625935468896232892216512663460624041019290869931779352/83123322584114587989638128429965440804760908657288331882849202567,110044710401089708546462248183260895578725840961888247110558962264/57438854262097994080409884531535656600885741550452767000497754727,-8985789579945055478178455039121209456826882122044976225227544152/120901910222702312464198401774045460984191965252560387394411215421,135769655715201280995808824369999279858165606504010357683518649668/11470143070192442024489155247116965399407991101312786752838268923,45814153074231736612011273682451232671826709094221862859211595464/12025594778658557718788926796979798113248973971077869023362308635,-1649235273545613920824245480847262643339184706316353602253756265778/994631045053627604399929800183477177954071853005165057174474151961,-69988094275328740863835190748123110751279382625456204128128788215/31655997774606404639203236697387450253385767434530805504667064652,-5739439559101211932533942255082176545874248929488862162642022236/8385324455816298083247113879798581811592253330241790924524741577,-10961660715531335631664885633224652516911931335613097792171090530367/8264132835531299539187434517752210262457328260753739126630717224072,-2136582306301651267721729891192830255858397000572556859681183679/1088330960683707210078664798019518244719170952168522756954538397,-5626252217772789627683781121325431965341393089530578400450949850/416627792389801152137272654874976687972684165311593179674882563,-156524382992945213380139077551521326042380192520663401542142780493/286630604774214162366010085526307714771377529668461579775057229,-308889480073886337519886161354958388577707085525142185027131496556/5399512815335496791820562043289825591874262673908618165261648197,-12558540762507159904314311943933472726292502018157834165094500036/193614243538690455925551987453816616612049050141858845834380285,-104257713257011218156349484948220025615697866172439964160288825792/8813403716030780307608992331329689982827538892743621711208833055,37289347628829646519708147037568259123741218487188732201800123392/95227814315263177982312701191122722986094234583330534758076348003,-3725353924701900191281275089542763013714577649785314003601406901956/1961362681417682006295320105251848324558064812543393211110918556471,-40572807781865831790990888672195775153011678011301262595652710059493/22664322576091026077569075968353472320297151151092153258601799821888,-379304717863824828996577504063777656971788923216474827170348298374/141616659925799551372700635615811696048446533817185538201276260359,-18765793305070684684875958563295880702734497956752562813382017698819/6632113245889595462568620801165979726114992970635577144968898214304,-3592204395601493905779471610161247151239655506331126441265731652319/1342716761065981670077346419304880188014045252884724660198832864104,8151004198752703353728138425086477682377127114423260475944736533/970421426630734871729337318596132300174534761752241539717334766,27094226698952584013885359179346274966436122624605936053351865256/33433263412526479341272413191625512927788255960030294228216492365,45192966175396731964318255556962346993759073776631740747085250591/127006009551549310977027205886481238485888219277964501841947708489,-101853063748384444186379475306833876148319781473130753108881915420/101758817772075637091898068085294977154533161876585941746649980811,22112994755541747790460741535038079693209539805816232582845885633/34914169082423609009071540595403543823179766819497970432181476622,1214592281899619517529478894057518987888577070892489246613614577128/2341307720041092907482392919020566408743519708890981397693769804123,19155333522139517299432261404378371051291734751041183968497777559/25019379480384117049738041391420020217454785679329186560663200164,2113017227710483308217133406726249342120639417927923044450290911004/3381661504430423794038520688101898578113725412356423763055915262027,7402114206937843196555682974758395844188232443381815216329123181/483363473321927317554194636035712003366300019676879426988031795,26156996382707977962414443512788031699588897241297385695504374741/33150314070122260865003706927310251560374186817785294961052707513,2263870492523165900648597406271790503778516959659204097689518680892/3584099961531750185608265035009238224499330183280614547098026348461,-8044526956345280873602916481650746283613914585107056352920496710/31739792607104028340576225765302643705326855678106122105130881053,-117653362962555409223129254161126514369407528144599401609880455623/229333858361735272664856091461068265383604429190749799559477979839,6312787727128843802959261914479619747765722593347042888170678807/565408397713150774457692089532633206701640947913787605129592263,9403253488464771239924929306749259512436215016400659177075329853/13492722935971953767051045047861526273855557321703994215585103654,3150970793430230782475090436384205354647795749320145500827559559236/5022196846064239523238374895940873916922459909649592582354936819641,53446822844734545220140205443023495824645305473075656862534609084/47818953722738133792359099844574081671344098583103981992501878355,974037493018684681550648465580244376114207924359009006313320773052/4642350095194457536963348875720711048209435706947245040853093364063,1342996447337477243177511132743518805775888173848645263694117960/209299331416457217378502517146969025305212727850812269607451681,2759445706447596721851269384493738789975065801275005456954591174/235590464027488867645308821793559664906624951587805645240169095,14214787631273854277438767639586198368508630405989408401237732491/2016046736839909502309592048314383901071662336855197367538483402,886619773360835711814652737328207323161372277386950566894811777928/59634207065050813807104797948538322466634636608210338295033493705,248984241754840312663307020395492902078896564337285630517207018/194489667463287750512044848053473064384300100178690945058864831,65147736245239962928387951896646460221882144553260160310247817394/57335026124267953701467850163607943389082613918780203728972985643,151274354948081770080123237894094824673432673822042912077267250627/104136020417614295778332752417326819846663488429921496249143743076,12021113605526774452675814500323782099291861921795985711921156645/4641442869945978178441103982212526985019849764247604599581128986,877343955464671378996860323588199190881647656022185743253770573749/666938475262424937659040900894580250021725857633177402840015630154,-4142973081134129981129489210884404753691424268971851515113051533461/9570363120806857728491959815534374473717093956997020588256373668924,13369428824489283737129816699150777489730580417937050946664506935/31097435482368094012721279911095412388371904954278499942234511684,254710933608648016830462555079429454017966711499669310672016216872/30734275899813946413772110573171755895700796878746545521065411697,-24532980133552144037319014926529805075308116441886915428008493934108/149145890386799657841347161080384475789783145556907857936775091567,-14119451770214791373177651361933139186177847142298008875553090588431/622123561675530642408543075445576182089112091833230869617241161406,-1282418085301741894277639667539801195447909967068569055124065031020/3598144090461457043588678679056973091694269892463540140058121766397,-286792731246965596187746903260793909317321650163619491862574386/1524754587531868979402238151040194627058485668874662996852178237,-88974613824210432019043603183906490800322662854800621106318217186/309548641902914846113918296736972329417748678032044039771863103735,485466943406656528559051842583215249652248779078430384091319693510/37781889140614864466685374280688679599141148165778548402713141343,36496130595162778440408194928957630146290450663148444017110029183/9716728743415238188035903014485133863446311947417854345193842529,5646722043860689540250595369272114736520670624784836205397079017/2147065492592656894607710019708343074140586676567192551589954161,94766549207069246869125663641984866278670888876862919611971238972/51473704138866236206234072870783142169951638986355000999785765109,789115473294631518520611187525617727220471177509172775758812911366/464079263610981969433069159292219299855855060878807619856500074839,71467930519623511857728404664086171213600928607503362208301389214/42224829137429842035666225554386894130682075432538911748760743495,8847493108651382319806644120750640946393549944191862733052311512/5450025866600855862302817850896486026404778483469586850039174701,21367805960857443775822286319644687631918555196584158142963513418/12802707511311096003349105922431031445129596808469122511995766217,151531810900411679954709246884563656041013887822950394437828698158/96839879208010989100053569118058921961369454053084694007329961375,651608715147576197487937318069222769060523250119021626589924553926/499530456093486296310616369439602733272796294509385023531387139119,789555151434310696818188287011291892303860539812470247983165703170/182538897554150931202536364475327045775735345277068865839029687417,2456477882588622258714030557934347528335905200972362672817615586930/2358204712205364896200233759994384452534328122989549166479500992529,80508145772646630663257568643157445996012218352600297104002863640/99193875315248383173670490154844813207083712822620930963404766761,-66951184618984260233664109411986574677082376282944044412215425888/180280360550870784534147542463839501111598581839428366924274151341,-1207672945057706681490601012707975975385411027912915281424873170/6928281305052668527890962314427088233458499776365435691992823481,-265144670240649044917896055513820117608041282881898759993031447883/159920839563005567015370520060429427737879909526796249813036078954,-3328003568314179315682357176137339620417368428622902315330686788983/2000713727807053743185517725001607681992131320971485022907415905419,-1375441462538486112094601900960086043535538859552951395792395761542/794728299627891278910233365834490242518199398826692026434823503471,-7650004181864352752908665568069263178266612790475262210464925268/14178220925480806468929927482675526543974275638834118125695256689,-65254364341719504768321461524908693806413124415416870187910766210/152063029523763279675053734126455957510856821644227440866371237747,-1836467282754753949636537130382845884628332832303751918350368976210/3438787955383849496035276616481550750135677521597119969105437040147,-54746230251041161122500633275617530911917093153760615786506514358/57640202296572633263606465956835802132710996190501232851972665817,-25126953617062850258068617605583351689895698978108579703463950138/205341689154368060740071830388883131853267140349722547824354587627,-19372660966591438120863458812220802440630887287691013025798635027/42510993109456229013224852872449214479998794887737723744824939703,-32180158400541932956501387304847347753323283769961213846188184706/70134994640913041568299895670790265036658102424916959577748053515,-1712480918650095013367983623595695957485998321252856475035620514/5913865880965280488946621629392538258279364983956604658503923357,-17450391648201410414400301689844111051383929769546928176078425134/37012012804059715601890861501988999362972597485874013452857029757,-207848032802756406829261452953861673471363668451747805894099608281/222370063697943858346460554881461214805909194419582272739500106254,-64454580098991495343871602629400529261194331181975230712084968125/157628601958467879579890478309515860720838027112476806880641323313,-118110245861670518489751561507420777183807773646811684983494936882/22535004457944845380722579075447033857794892685612675397562318061,-8371056634577063701528752444055296428849489362590676409680506802/40577430092622621997795781766229502548488122112021473671005728437,1749725670673198563194981651588723663012776638146865124760241833/13302654887667760089866354864319834027695118627008958124296763277,-16197044347184898728843960445247960048157798131310130645740101994408/4177292433401045976369033854758880203842091553998247951638266246153,-642793216602675169300789404476100807105183640384702618280032744/3097836544566088839940051822768117776197073276199455477197957089,-625655567496142444795673161843986223843015446735373983095522999764/723018862611568593875306596451736251206227066638687082775642737151,-290160022468910930500200170077344596189411116304020862301083404/978822159911012329153393397499021283268274617243629508909208325,-8412087176741761519740592516914074114814321616954782802877970442/42309573244589364296697391113046614068221296235277188023465721789,-445195064331964731907713486014569376447885342386140389972611625979/69456446789002079536819449874502970688270455241937997127777877176,-8162629856511603934494510496112436659554445105614727015040484549/7927639119988571966772860334862049727761465708426188285909543725,19809988298972380174514564305424826121270205054067887570467542297/7038140341002859076015927107202197382561707683245257267317956801,-8815248206458565899897023695849981315269247220941360439599138520/23304168263530786896869753629401251041339326915343919562160536649,-368598758461665685623653753816233494266213522795869592626813870995/585425933016242217779243778462483448513448635947471170296541931764,174831929278993481523576702415528367482974181343369304906251758741/37366402730571941389574124056937433326821761477182612703187589560,-79261924318326052526735103203290563832677282076910203958631455975/36011244698837923357975350139302173169560055717693141267251787712,-527527624536719712061604122558763334772594208485677104386896180979/522182165430694999144227234552413213445859244171612724009960999170,-10585696722017149948901480549813157128709695261695489520071574989/7728117292261891019106253936817568519714363796906836138664063263,-54722022853003496837897828043991003222601355794573644880275625443909/36742951430606214553608841353451699124476246814682774213449874976896,-92415625502062624301848737669730679519674632049910433859207593774/432933594080747792700452180230286600620198714672065875251405681165,-655498841924874352732074385787820111791591225574935638288228394456/4456922014437369509048763204645835359478798522585887982603576419635,-53845676871910609891383334867587933543316592356549062826598490632/259654740449019046797279787168624184168844398195092010466532507723,-3545714185916991780884404064657644410123105518466523483106804348/4995707979419744931806776300155981494869512396040745084475786027,-7849488318549747802133448156182235149850897274981552578575463254632/12254266292115210258578173625444581678635498025512186138422995754073,-970842152104848149498625126732551268481531740271269936092618507950/1478970519812628174886498232268131710460694414021707934155847067301,-41673314971383978921439521987922111832504968572245845635118682946/90242156191803828807672425568706366354552985748070604414875327817,-112733843803763171096029872061862797668894388872140955206461974806/532934542617647323130040697971921175474955131518148066716929837165,-23482416168611326073222504871456390118121828716856867897729449064/117890259897469842215068509313857035701566526836151107771068173265,-6298258313291555844196039179601269698560447031855536983543620696/13852463050313207185505533219764417135692446465393763002977053447,-25328103284311648978188959455327079007685657548543719717192036834/35924189527770397338000690297863890641956482022938275401261724833,11837127184043083577049624001219683507492241912637274315540563086/2107070697560290595210998815851534970630591930588971673358792729,31502839204639765531859355220060733848330978185805560488974755598/257230068698546106470889419819269168523947518329521057860560226837,-2513673738299252072380278175166553516909523022544055378650392974/17654024580730335214189477565983700473949542039887753798852767553,29825902343021741530865809796256765562604767167181105127766709922/125440335086769631152503690436548933151061173945647366980636690933,-1628814597275660865599646415465383547433610910618457550707478596/48137914145736013275624194204907131073808695470886499106284670489,-3959641934516461410040723596556908084739960063335200311462562816/83124812160610194606488502880796428475178024215991322978285731227,-7961982220031470388769913414931264312819343953716361777667884846/59186013392340805645860363842649512123120013721326137015088159905,-47893345615467457338376681712282690571279204488516211617475303172/88161519037872478625367537137994085592950290904532066927697141559,-1174209238215883709409519930505781907050894650849849426938153934/8368197941153307812758097631317958838084490513219391695796076789,-2574162855113368443496652042405790095836818949485972048843096364/7514015601763963535223509057626554544466086259291880808349166817,-1009145153394662051214887640611125110006153787828634831301216135/1546522114225474315075775445218764186095858429120782622417927454,-12440608310434450967275489294352500347823167480924848016671393613422/21263276376978331781215736660990825252189626642020864162361038722343,-4744674179481878509941613397168076828008797977083513561039095818/56895847882349384458249326201845641839498455610631142412639735535,-970974688115866189108637593147312719748697175050425838418652266042/4760520935342512595296587109585435774465856175647862776680848290275,-17188036604295302459664467493256659679827757176299442012761242176/141092994036875026343165832405903089028116986109331944145460195369,-399052541221925433972338494180708443398390179390602738247504069626/1962416445217113937754526997299543183039833892030513597811775614847,343698364532953810568346480025349287680252140419420487239954248/62741284053531497621350437622346073249486386226316529743946470025,208394882571350270928254734148904082428339386389145033233673899368/333969610280303498104846744013234206763238463177251232943590943351,432584142330875864078384983421367640914085173638213636868662259/3384833448237418868016900651751018884052528160604648157446753445,29546815258387838003372696515042023673707285460396879562487179118/58348777293406756698446039576506267152670782769305503334671734019,15079078811880705232981555184659938523329295363856550054286818133/71399641587632954611722515060614713621114974535120281103119514607,30740300865265521048058429193539882773700421579533636168036432518/319442070580961760610088384933945040541539273876659294423851596643,17848972026065912855611367836227129606148104371098626348693753494/144053755415671113621298580870607958269445488659085887553794794751,-1275232194187540749335611534033950581060714076052446929259882313932/1791511971403006798479989510785574716511044294569839696332606017013,-188169999078748555566577382562795625764222364816325131187633477688/188183034070060529787022092543490901891195312877126151519967680427,-971511430549844500434025459299539473520691943760989660642871602472/1211463341832048087875806047023460496512048214394270756272709725183,-108820368270395813466088797648550154725003197738699483294727606366/142185481993759296767747723036693250064517498673893235260232934519,-144678811056513883905473866287398376925537106558052866770715058584/186979880299820228254765587908177083029033495160696604658645066091,-19437301411363304761544586244044230638298206474741849585529322776/25307988379105865783585109534697311795800916589220646798477291047,-4832981197679484361253382596877650971131938963284215211578366344/5030866588208899174123115397876163231338765703123178395605814367,-31336966906056761881081736239379872579964324750442037667821373722/79150555404679459152766908742395959432549753112539066931517262389,-2477267226645335249792482562214685933419611214869814927120965901448/473227973964502734701811702111739243935493042027870683809645040365,-56743401414563476638772779789986146080803494272278296704901419327/16337200595551097663170003818693246769505903174027566140250174352,-1527706418794438477353411900449798012745295676474799647022673043977/1114220204768327894597918052258522416718476556650028580918826798894,-1631682037011385451654517385087720117951627159505654358603757187382/987835708853246709228690670440697739636634073373446661013490603769,-777238793847408463084408914177587486160413908810452741782892057083/189892984376066131697460701617807462619850078385096803911935182516,-1928275517266949786264536933823058706825502886925259645170325386996/260552917489650276837553325264847799743024638752159738090267691097,-5861353483294988479379428193900160363443563190215508408209426386193/824084565546024620458661237738536991599833815024177376141846436032,-9180055398066414995943680267854023355029381368251877515665635120627/211561212792867925978166589959540972206066556107866365094112376256,-285567773859488511894324638764406779934945874607254057040636033043/28142588297758963508651633906722854986060315623303004836398868088,-21856848704553140140441930609655262156819686875136965629378123478589/5243760455413381867959345147907854634323326083431025025599594870068,-2911804461621468071695738429689661419544804362191269904085165002935/594730129557060685942065802726647587624937821428399322344819224088,-273381087007455536550368354597283779409486364431591957220615001837/183831529709082306423825597093604198218547406874374232435615472520,-657699316075942488634426622626462750695427722143878026609850749007/373176660919802351171839775725948435345433516809140975139855819222,-39477307338041897994542402388667443535880668923557952692885952106/61134732331948248649658096112795707272465739903621632722654189877,-972687258769157500028668157470740081791909317080055063800135748268/14458151603568769323296701461527438366476870412919641150260459337,78931138767540878171517454423956260768602747128678786119694752162/47462782437957304161562990464497674213174319211479332983182467723,29539458378237826481097366688280587610649512259842082054230906684/24486143986171062856707813935585982681305119619524961636835371671,3138886680812887573924465711635721116636484689330862431851683268/3387103477263762163448106401703010719874846899901939286667288553,20863300247522590362668236479115179765235009402082044905544593306/10843209512514423690599193553990217493830249987202853731430651229,44192697519008654725673230522341563365478126031961044081972593961/36536508509200610577196422438285691045075834039371901574495798714,10159212558235549150334054509613918736323381085220229632420511470/14284555229584179385540731602745585142692149940699455493452253017,44704779246839286520745218108712313749354740568328685979362050130/28550394730879747346746544769568205283113782507878453807393511507,171332313319611389952504669561566549370487181965320950728389359161/107588342942367286846431418417168754474696536142643730706709152903,698619755512286909259911491429294103260881923523577995078401341/896990003768201571851295370923224554268716507572407047284916309,286536838965081670223048981468680522386868182470887629945340832/386447202221029941686034566834328792682958295311064111327480419,-55375747480666723047653964914628632640103277884922804319063804776/1868385390994557338692050899659692124640392245687479981891112512981,-409596209343256183650129453307761163114174007168941225600932759672/2658542454294180040069395234342505056762062539877619920565006058531,-7894856698535853568173336880271872942304255969161191465044384488/117570517994403597825825939505849198555926000359383578600398228449,314566647201482888170303679718720438808791398420491065797127433298/356797900062913115076755956832223365281785342668391879251556474577,2087660508484276626572330234820476197680601139040587646521739512/16509614378145712654079857509086093275092441463426933427267122699,56081664565023903544679364280102762662018526127640893032906004888/637435429984741384684784636308724381007416269626339123311270540429,896205154846432053648262838747305438729001536492040526901469926216/2858648826613789212280993585965163733069814386826948890398225742103,117831243520083727456499027464659393441590900655864462212716113896/613286675123837814981799998739094331689580336639273565815430857507,179586413855513893526028074619191554327047014459430420972375986152/322715478253162515894026613725037457288176740890038967111837033059,252515946033257666506111567069224633308119387352772627483272988854/318668352959081445081627049016419295906478561935366831138967420883,89995301484178132357531758416336480168892395399249683120492743054/20242642671627400320083058146389960954406738106441848852425302047,34804175539198566626172643226058529287649354206019465644849425994/10909014371608067941581432001660523633144245123319310047183398955,639280088236025944988224817753299217676631374298219508135901381802/74965908364918899414468629796154222136003417560811752829276437541,-57225196149637845666136337479765574341036620289859003156970228292/25403444160353347726137135520160097700879636730822055283741649429,-65624226092672578873358706758086233809358118273836173721773950652/37212499515493243828735929911499745788882717468726702664290782719,-1522931001969754203225406422802711693738184421246130857635084028136/308317959727275901693939766464622712284876858826612688563724882847,-339410933518422375313078143994041953352097041197564217745596304472/134737476699728966489513727949301301963437670583495920446479792039,-305077022838485521477637110746726224731466054031969133229328928758/561891860160844938631186769436331131073905938771558186784082316161,-8064465574069001585635891499463190236497978887486595732634876363/22232254991457799085367031327711371809101859852613125810505392491,1266004279880023144135308330731740948944773942609431530327234638/3650467559305419306472219431100561784767471300051137438023080361,-7305482246845251272969646116649707278451952253622652787956492796/5395756142139456313420424291721848567510545910102073052151340239,-26893848196118277065937467486950556569611057581947643295280400611/10748921581187476616363629841841259484986326818207512107748568998,41570647711418833845853687229516954873347103864573431166292939586/92356691508455317417757679645446020668298957705592851941539410063,58247353942908156550841233263925656667066397678116823090090260582/130311711113157401172847438434042870462908631225169351812728791805,59432675447839369298750488394014551389320825505153635996677191318/83700058745064284659147020765594323206598664621917813681324736869,-10606761576469709068675874850125639920549978363048648229208439017875/200501819541872574441347919543442484276295460121206562572629583612,-722347674232012286288278064828758818067002405771814936919136929987/34176582305970939835902612449980772141165590500897269037200185600,-510849306005865900598311758936839260149446225951866562192295963167/75095985517259004459011744865026677188258840836245786439008266200,-8461679887582751878854381595426957069689194677281928978711861242299/141068398992516803216210206383416797406841060471262276100621872652,-13682676120269249189118560620401972603174327764252759692358137364/9412129458645284817335457159664086889422764716666977049651975567,2641121122797045860883811181264526281778131119806558566312196098/2062610523279371616312415973597443619469998240159124933350862511,933172871343918474742532436350252232180345389533190391405812371/3056988153840058490033600732326793055808698422600182451905848341,-27185475413301688680639485783982866216104840210298867780231953615117/17906128782664918839675322052091287987019714744906348962135414729802,-1259446916820620709990117675231988002291423620275279725868467855226/721051179351658903535239019534629154220753001933885660070087636115,-1639799793633972748821612406750536087188737329745630518059082394732/38667775046935490629670153824669175847638191701333058006857800323,-705456182106029693496634326983075211732199314701189429270967327724/576890769800529505176834719625187511522257528609978528890180877675,-201020412616012651234621567445419731487225389154156232110256109434/25467665088110547486404531169668267584964116269873829495186918777,-100137510760538896654419366135224891710853638996758523480901138702/284335064514149979522079529751948951158415851138145224445857275415,11198453785093789246061949164383051607339471787074926449774219920/55859090045989861721057214471922416734889084392481983921454094207,5299758602679723722468730851670929227581833778729648716633796742913/5779154781774498426383980523401319684840705256492799721457989286824,1048870994310809322674593667088490652283138885892013247294653290598/1010905445438899245789116168134163312857852481951393414200824885497,297726583673442559230733143925809299933697113450938753128786237270/288477089497694596747340832862540931161932507408912182858847324967,132463344516851739558453937402949559065965603467023105788912361203/149954735450619000214542114661941046831650689697677527162755432450,126754808827975383506438237388896384959998524446839667028664948970/13136871462047470025667203068808325915325108875580013238417438593,110117967982943897389724608471530575533059262913942244772111707220/14396204255129867368900340265485550489229563559052041743489905317,504628433306703093150773487186706482585946066822505570190072237517/78582851087326741755391800656251343525785024262697279259526255603,1614388785543485767266284492525875710327998882416805989558368645228/183020785499580803906908391036238404909426837133172741913164758479,3358663730057730451937159724513584933818637542890247247153707863708/46428282232277197400149386148472464478403127478815792437364428295,3526312745624950055461015484733174735064741835880087930067197475801/34543244353872920791092437014458719128401422051913054795535566424,9779973409619126918944673457022009894925092844021674117511930406290/689832504729870406074924335936008360092055817596643310762042709399,1333316536286291992073625703632139873875311703143795916538043611355/137807043129281275102003754741345557025659561561199536414579485637,4130174738462443514404828486596065035333940677214568416745229856430/475243260834226803700981625844396024911115892625244913164619029317,1092014403244512589618492450442429745328221242365168252960821968379/15552781190218287407584556686760646132286171395516206067470879986,21198997566731878262546177357666961420068214814746987582795541185/356777890318801319060062981051519890558229668497427291222716014,196721459229031795253375440424930930816397683420205589697688475569/40254657920131065782081662838281164739007867123999469822585426953,315562135190606519224480560970043541419892434786837864120630678991/59296296482330318683818438504187695004795090410529594922386214327,33842314392774022566521382163658451727288901083721984601498485059/410291878930701449151369907581817291570839833779457926359736036850,-540602553319030927422497832718276043440622798122791687051639894821/3532957481420951357862438524911428002652721814880476489929362966956,40946304061889520662579701558950667082964794047657780091257172678/33777592045054700033169417492591623948163757312197004052285115979,301056812511432093401878003922488413528767361188444335881590103146/163055398014793721914382753433284239626526527529109946390725256669,423461966410637699367881206128205790188263882877357665032383161930/437762876373148168218194827246786646689216448345646327263367656249,23724223403421678998122909340494343090026524883234764995146056474/148138574282267406972298325792332343727631720368725083189616743309,-479226348440814360943447746487755371393656489034348070149608119481/658688765501161878183525453880677413368443622995517166785860335300,-1697547518026652108756044193852031883796233383451743704517457567049/2338422786208446527739611254306045335555686781970217806819783440580,-1420332128021382420996809197139132635081412588176739729877501872065/2267324528333458896516423371435682584333461175756035022885772201444,5298967737742370626705445243113686019242707231459984416392692543/1423073636547073107913815843652132131049801966946002821724871208,-725954685494218595849231501168140992930115981955675686804894537930/3674872714479985382171234250288551736249207920291417268437456885021,-1965758967068181040092556969796841012827130836239372407086995968973/1884588776464598434359348552961594092844666574509305210890719723412,-57384953508243355877293443797510634662142048817177498317943222132/213606523227291040198334971440067766852279940999089878294059831745,-919938162738069252797806723213376323050579614258241852298149294404/1624621303683283290517433740729519205548727108306606788674134678179,-34974048148596406912246826336989393606106010038191432818896795885/155332916710212787769241348528666444406048912221469640240608782371,17992506587308367343092585702849649159000471848068483803911392542/4567448182423311864510403113133798139299926971860176017481149857,49587063399063510839307155776519108818121020190254206483667045747/13653777473989648844856861626332006938484801807917789995830008412,-916531669561238634997705294829070819523714798250566006858492016700/1554138208401135339123762902686840747121647154045065770406843435759,-31427797300809301377602753790857136598539070624614023982900319395/88114135990322382678313722147123461124549419433374464013927791292,29409390082024306276780039942207292684231184215839759226435211587/795248966004556106199668889751493181664039501917754646806907681088,4920766255038069585305245893088689930447210439444656726471989017/127931616619185286585446566384430169957346140162152847901111060747,-8406638580766478307871241060038632134474436344917898653426792607749/8417466832816223259188991041737654736341765505002455941170832252100,-10197677618573172609364088252857636819030392474170866722270255727607/7778035670428630582278872226348740485856949716638531551734615528670,-8281412743818062901430653949830106597006942748008705981247022128945/6498048185568564088393150820977391119192540062020220207364793804182,-1097981253572391787389049847566902750416628362144629196094733561964/859713820354476560275754820036367834626172915120678335383709254239,-1890304083076408796412631806199514442899793689332131366367501136588/1485089043574069618865432626059281838574133620606826243282588648101,-48707040563314581545829459516982790076766879682604903893199670868753/36641754346131532349442829156479488935930879008316363943016496338432,-1111427175656932248132869206540848512952298445556898411438578985931/1087755031401422533211787475656992956183903227841990874199951236724,13730598722504484151544713375579134446260525324033856238553013967/323926721936863673604021781543887873869531822828033816909938138612,91275679614931953533422437182567793730638036950452027127524339304/348894987144462706706526968809518887020464438344693273595902415623,-339631682679074024841710246144861738500794955208444053175778211017/421978784817724496227617290053413580164633335195931608286452001536,233819815772080939684801862622143043499254523463926736343274823895/140139619042110884598239380501021188873343443777293272012101593488,694945521619441584378278055904382902598254611664403819382288463012/137952957572467082701854863956149289424559862408853554609774659227,7173009136097156048419916903513731045053465564626403348006084787/3886226346416835394551941278602753384046206399591845101848999332,404554525378271725916239359449904635623797191725132460743621259680/437163417013314693333872447266457531616232126893210757388492500981,15393344477133958624569161184601888661791602969305430103289962045/10375805312478117038157383335108403250515316506063801237517861264,799209785217778480012565211345028350849417041605640760522133083280/988653992271931245227754576688089925725438108560275333079645494339,8381248511272850202395817408620759805119307941019479801506783615/20300597611854328176950814139107297470165153805409733143948616877,190224387807981615722421396508582095387441476261109650543638585016/153710117397953019323221344444221486041262050369908325231282691257,1640701086527789809462525746224197556065509032644918166327004218279/2110016293321556523384684797931550564646990491800940484667728075950,1659566999153396254841230820860604862315487076126668052093927875723/1592428384754173611181701941242124192197095832601603182497909019928,344508550731946373274769788200758943493910641099132712119043720165/70574774405942708592206890707698590588874795316622388941241054759,714589798396089608641084576706524315657873560982309279693856191970/578256367462337682563177048427008348924250816219463096679419015399,159128913445741628723408264527422993633335723321717909426275981610/48460748707019692371420166227092256471008576417758150773991003381,320848921058975243441561797916517069756046995313959449335910303677/65743867804140313490236865874008461997412817298953389676150136801,31857028443395949668537316028381368943211477252219838944568768086/307615085975913385232653232504543213328493719572104395016235880055,9118854603855017389770701477061726522658223733289363589848669054/60538773950446430567975377786581712013768619718591240154710675183,13451376819898928861659684335103375820138368947091210266924548797/220548449684712736142232139058394139521473677102487722954458089432,-407128228575540855762426463310799436251131761734162765607454628460/1849787993373906761325445295727841943120835851655285613118792054053,4244811517399172681761178840085399676883336680484156767378791192/13876490778867385256958401400629089710808905130058660707422168197,65309185370618714994005103889899102291769906824161522951006237184/105509258826278223624488857074591266175016526562968756905585797089,-121973259314638097509738487328778632702571407379356291819627750724/190410293757620826615065435288632974518353779491451119655060617061,-6193064389398668123515605931089197686871253588321698531880224013613/5892614657292625106909460547327525271124938068126345336002291230524,-294187353029943840786284507558057444278484085701695081886472125593/494062977285343469585475771108288551155405218532948457431766705262,-765615751483380407990832155807550385108598519918741874040862807594/3499722326979631132154766108172046322684185904243161596376535294237,-40943355672944514761103125658689422324188312007786837138260001789/145163001966735856117777574212130883466357208491784732470799668387,-22409841697393724750519246076543698549812139837670137898990606178442/38340815593260964020107109551427848376197179479219669698502234478553,-276311372974248963405828099862696554303517663782684957590966398918/553375227911579137010059732463016384994656216282843354947844213227,-25509570001995282857493790789380909352525258007931927893402129723308/33471542172149555583176933792310350853754721456767355439597364396235,-2204585294717621919483839528093439367044430328431472296556020624487/3396718018343913515818983476476156542365101994323902329138082211265,-38458443927831321893034150105095807685629001744180675646564967165918/51155310708064588450712403872200751670044308963107690007940162082563,-138023265427620620807145228928232000745718562862662760616530820014404/133193060062468157118019292743641598683255345593790954321095573841377,-110237335672943206150500410552123015907664570012544653016909755578172/105832924792712293620993791992282358917488220584255443038171130223763,-31823874911643616371885007491966869527399689004631967341385195510964/32287299762579402307528517539927531531658252495393411935041933850421,-602136912081530379559622823013383550947965083396169307661428232226/991342834999244959957957432925855133779657128447716003399934197989,-3771517769347164543483365641942945878533351891549604645658628369/18110946629691270077622265805758405700218791053451999324987203041,4687971158675378289444653586092115799692171232112827318817821970498/10744691558668979230259562753491846512757708967038333837772544808791,217841370580392290728163695732503006409923597921697299367184879863/330537598005953261946748038132774688160182624221960959623691061776,470651386477160535021923319272169836151164739913606536076969374904/1030228856479141582852547563793408845937063187775791010630111249627,484583150170478815221970432947663447339840958237486385252536224601/795690555718799429829197898530228548481903800131788302780573229627,943187537534833624877388066321150027869989819529458615453894138456/2101725543264531696964670858394631316747316567259338610763297334801,222384726330696146935373082354328830034884277492767097103852405564/891154282558566027546402554064892057503201688734928821685078303019,-625708635092495744218575366124034491893381925818329982534636079996/3168820026537127873203558760630860562046063281585696203343386717289,-4458477065653350893118209345157998104870105544309000144470096044490/15110223789877169249493387109583257612233102031549180473037342795147},{-236609871763408356662518398745356168849200220896554848475747652/7688869082793917539236087487685173064277447020846479957695637437,-72029126889631981556489185292181396102345278912655584888844746024/159836007152974790071798385599917566806628491052537351271360524421,7996024594386779724202804907156663743679609562487322255141449025528/8726011457487992717220082440211410125284871600331145994492277477003,3353752817736127519168223499588483808829287755670204513476576642664/3601308321472551687137074914777767697298558679588374521323657411589,4084484217181037157834441273431822190382299210091573885724891608/28701509502195275365156629881879581547840519728985057647117639409,7645235264064183886340722032220209341853230695773519974954030536/12470896419542242234902680559375346172338340420510665524803271067,-2974383723338832804701026693926084271393162885134019741654248959192/2903891701645797639027841751618425348089316611606464083930517677003,81688914382459329128942277224135699411796518232949685838323274232/98544861419165339008684619769467213194427963768343213063728687725,-23039634590726902536934543751430816584194232921131979059120567104/13325212700458212094265010815753470526675274245535590565189557201,-1067700702820486190791855757350608739598967276065801577171777546992/485129857472609549463533504260980963036911195633616694215052496319,-731852582345344766744539922596777015565982056544044488388653872646/334431874926832121031610133219173804815757300372790377291710181187,318839159128119145731778382444207163622944527390695322734481675978/101241540015561674842940457771878501325436867963345124040466461101,367438586021809889362384815276968248604752251797992765319151099283/176922270229230317804942035720966809950455640085209301430304213392,552206683836262450700702224927130033605798471202615889016457312173/443756467399277447438727495458511807041265406036740905945267063728,-744319507471056186673405753690084549381844310358087508703257764966/454541894996366620912279566307989308686841094453896101107721441547,109426386171359715727429054065756151522805661387249651124631506384/98057557914721568921705207724373213122491048688897640348941050713,123692292080049618012535318807940637401514393692074764032673293542/106263943165269297082022235560005883185015625675000285511276304807,179535349068794380343356754901179089457456068304726125851350778208/1227298018203246961367613975268346121879450177284307232283906211931,959173982984395838946038314210016446355787615602767052275733672737/877317146113967963383886290989353635995879744333897163734210630558,4104159636394881275670276774911381031141493179192041831655559640992/9497906415112986328102927422303342608431119386856540469010524194703,34523633432034145360617134401496416798657821969184384531945028902/80397096923550340340633364029382949269608100159829544422130628619,130193775690844391065919550110525172173618345698913928772675113808/339595391993400434144576437973132228704909654279638269039772828497,3515297063849023660318156401771746738240835602740480936428874110752/8624095045206442706060706506388121028785824784335162601825820294379,62900569279579705059199925126629688945610521254978983090448160992/62385402662397895789010206929620943569023405626576747834618541365,402638900380396833480739863036023449265849016675226728238857485823/354746435764016020824727756959429287469792125413434881999902153666,2719561438103658763596342591796202559792269119723571406814131640096/200373375047299518441721193973256107519008578396539415575315846499,701230387842883460945660837803328429687752021175470419335975308/48329357514700365364043131079378865104880621038177782630130977,7189895819075010135447914429124417798168645388615667988884655136/2808357441886402015991893987412045836909832310058962172746401003,21264310805386919077671785722317821374048625811237690330407848608/414805535680848537151667433047995656775676664757494124581364477,-52625503683716334057386858632419943854755449343963063878955185568/39942000447420751169736736364869373935625652752233389828971151893,-2550074686293127557802924314831077963328482312300831424360188874592/535606377326462265516516522731547102297930464898110766656709967939,-4134417677230666739550663091182873892609361528273696007248413936288/18535418526517124252583872416487726738152898855728120406949519100479,-4151745654867521649253361077818023080655467806368665931548137594275/2815006540480116342700459381568140544996940980620124609182119756073,-333101432712549148605606000763389233555061842860984120210611312877/119098157918760307599990471066688713375280761783506027130804376349,71305031059895014096965852746690276617093115375201692186082927764/11874760369159226855662589775709348686394415522469761697549886081,186807079960930778978169731746558721023153159674401022116961480490/57438854262097994080409884531535656600885741550452767000497754727,-1067433722872378047378894893546521419685550708131786888756547949122/120901910222702312464198401774045460984191965252560387394411215421,-12683079738200198970613391597416840213807683352510445769134503105/11470143070192442024489155247116965399407991101312786752838268923,-146164669671495787342256269159053255118973142233712997687807841518/12025594778658557718788926796979798113248973971077869023362308635,-2462806260665457751916982147878500800934705716771415714815584092655/994631045053627604399929800183477177954071853005165057174474151961,18714941686244963977237044864827319485200906590353137867478338185/15827998887303202319601618348693725126692883717265402752333532326,2362193598949294115762338557270922039073407553278731468732795580/1197903493688042583321016268542654544513179047177398703503534511,545258413664691969116385858552327841571588449311134867176697357009/4132066417765649769593717258876105131228664130376869563315358612036,31436999113669777372997163958309609028436322546547175618968479970/3264992882051121630235994394058554734157512856505568270863615191,8217126431019598611160152929694129105616366621131079543318917440/416627792389801152137272654874976687972684165311593179674882563,165554066150624728304883184917818161403077509109352963960850357690/286630604774214162366010085526307714771377529668461579775057229,335276058397433311570297176247472413151397257959545581800375586158/5399512815335496791820562043289825591874262673908618165261648197,15523072450803636122045374565589888733429799469305053343471895292/193614243538690455925551987453816616612049050141858845834380285,102080286494374252011418154086223521976967379986400255937747010086/8813403716030780307608992331329689982827538892743621711208833055,322288668777314771897912150067084846025090183317006953474170631189/190455628630526355964625402382245445972188469166661069516152696006,2365635079856903840164886207572422829423332491222245460270341534624/1961362681417682006295320105251848324558064812543393211110918556471,141033861888748042893273635562057096437073345999803291129318435793/354130040251422282462016812005523005004642986735814894665653122217,634312622464620340618220865447833766194677243801846923564494689888/424849979777398654118101906847435088145339601451556614603828781077,261078547946760689228648552998426447573222422690377296950326649038/207253538934049858205269400036436866441093530332361785780278069197,203016768311673056937685316128121036358249366693033543265093143832/167839595133247708759668302413110023501755656610590582524854108013,140572961856995601386115989405920622546131557694219557336262411459/13585899972830288204210722460345852202443486664531381556042686724,39269589136356090110547380833205653407411041643548787138241912036/33433263412526479341272413191625512927788255960030294228216492365,124101186136433109883430434546521825198478291189205507737658459504/127006009551549310977027205886481238485888219277964501841947708489,303435335577167223654719935973128055749735352973922580535603794656/101758817772075637091898068085294977154533161876585941746649980811,31843056242945028370129150861132081981161264620250455138853651587/34914169082423609009071540595403543823179766819497970432181476622,2004261339185835090758322834167445030856568975371330214603990653984/2341307720041092907482392919020566408743519708890981397693769804123,52562072433395694241880371756001695562676360757063465611274203355/50038758960768234099476082782840040434909571358658373121326400328,3279274919953968658190197866495119592989236984508582554119563251552/3381661504430423794038520688101898578113725412356423763055915262027,-4769565920704430395776353566517730586997465363484394557670014011/966726946643854635108389272071424006732600039353758853976063590,24161039695392426295268576486958849951748448970274407599720748241/66300628140244521730007413854620503120748373635570589922105415026,407223918921784790342183287191012232980430362251526875267448713952/1194699987177250061869421678336412741499776727760204849032675449487,-53244780580034300838273462864253376825633237404809503353052303921/31739792607104028340576225765302643705326855678106122105130881053,-504858553922056013047206244279270352492684598556044545093703444864/229333858361735272664856091461068265383604429190749799559477979839,-394517563758021958938268205204934220658641135200650557097765089/102801526856936504446853107187751492127571081438870473659925866,13457874917194955003963113951853484870861278278364782737632455859/26985445871943907534102090095723052547711114643407988431170207308,2527242808284470775416585281634334964556502112155839824965228467872/5022196846064239523238374895940873916922459909649592582354936819641,12176324343847102503518145863333914821505265030041368946465860357/6831279103248304827479871406367725953049156940443425998928839765,5079102811457070087157650597808744086518369429898127964798541880416/4642350095194457536963348875720711048209435706947245040853093364063,91942858698297795204840330285886151924153947784486631711966966516/6069680611077259303976572997262101733851169107673555818616098749,162674708532510839531893486891078515623686874644210079666987218379/5654171136659732823487411723045431957758998838107335485764058280,141217909550050103300799951844805433777017704635889463968207745019/8064186947359638009238368193257535604286649347420789470153933608,2157607101239635682198585582170448553642662455730385657893878118168/59634207065050813807104797948538322466634636608210338295033493705,15306066911149651910916915147818798113792726543259225135356612115/6029179691361920265873390289657664995913303105539419296824809761,139659580596876117170860497191003990496179644024619061978259421649/57335026124267953701467850163607943389082613918780203728972985643,493998278606137192093563149728542199414800277882604412071012917943/208272040835228591556665504834653639693326976859842992498287486152,110090045038353933331970694543597029541271747935370788940964404601/27848657219675869070646623893275161910119098585485627597486773916,3666732457755292691447400066133318741352332079183517031194705001137/1333876950524849875318081801789160500043451715266354805680031260308,7465245411984831224878382281543474393414721927696454541212762886304/2392590780201714432122989953883593618429273489249255147064093417231,2321368647341358378522495912484646274149886691461985586030047012031/62194870964736188025442559822190824776743809908556999884469023368,1338902979243236862378340571658579444084129914051813694934790463809/61468551799627892827544221146343511791401593757493091042130823394,31876124944146290097802192755683619506780575452523468215909273218912/149145890386799657841347161080384475789783145556907857936775091567,9767274921957516111828387400473741791143430481674806978006210010252/311061780837765321204271537722788091044556045916615434808620580703,22765453017571949082898634183247811583407573284707745865096717600/14000560663274151920578516260922074286748131877290039455479073021,2532210066939798606201215985577530857734482396678144378736687487/1524754587531868979402238151040194627058485668874662996852178237,96078658992279167339502005098601302349708730054061040187736827200/61909728380582969222783659347394465883549735606408807954372620747,1162124926451860863099168645583445662750101866946305282328049540936/37781889140614864466685374280688679599141148165778548402713141343,5598495249707100521352215802934000610072021774073482712908142267/2776208212404353768010258004138609675270374842119386955769669294,14796779884356561788401113035655469138497050476094568397125749709/4294130985185313789215420039416686148281173353134385103179908322,149584411135549177087111147084450068433484794420234848038058738962/51473704138866236206234072870783142169951638986355000999785765109,546175885134818434395960205446219490574607641928199822968675831548/464079263610981969433069159292219299855855060878807619856500074839,72119379379527782495512534637782495650628805006093638028777668604/42224829137429842035666225554386894130682075432538911748760743495,8855692232281820001190717833524710442684833214423998006066566446/5450025866600855862302817850896486026404778483469586850039174701,16100477892989914366130027206092518469568253988223184595695602694/12802707511311096003349105922431031445129596808469122511995766217,135085535392330306275285947381946879007955119131949022897192247998/96839879208010989100053569118058921961369454053084694007329961375,446403647441583695459846192221943358850242935172495814192913317164/499530456093486296310616369439602733272796294509385023531387139119,-181906262258415700181245395628729249278804303518930551896320512596/182538897554150931202536364475327045775735345277068865839029687417,1129074461359252800487325810558003648015979773592648481758392852948/2358204712205364896200233759994384452534328122989549166479500992529,43005026154368799218833340178724817513959002211216581107458882093/99193875315248383173670490154844813207083712822620930963404766761,-272867825231410029865257017722587041146725720504929382696194536225/360560721101741569068295084927679002223197163678856733848548302682,-15133145712892684838673977374547726368389264562264874257178891026/20784843915158005583672886943281264700375499329096307075978470443,-3303431350562293840077330428515100041777032831632181840571596435487/2878575112134100206276669361087729699281838371482332496634649421172,-833120179073176943989890664138307087991109412972534105914741578275/727532264657110452067460990909675520724411389444176371966333056516,-958976711141271432934738463838366840012430214694829261952694770245/794728299627891278910233365834490242518199398826692026434823503471,-689785221503654719723050905396710331321842109014472163508238502/746222153972674024680522499088185607577593454675479901352381931,-122104069930431204218662532197530891510881529919214787719649383411/152063029523763279675053734126455957510856821644227440866371237747,-3066740983205320533840899069801632352828250232323019835389475707871/3438787955383849496035276616481550750135677521597119969105437040147,-350675937325715186513429287450565136025299768556494651401698619849/115280404593145266527212931913671604265421992381002465703945331634,-1064963930896971234253299383431293037835756399865868464944632016876/616025067463104182220215491166649395559801421049167643473063762881,-38764218576498019336740790853591205965247624822954688088837379093/42510993109456229013224852872449214479998794887737723744824939703,-63546621762152757154209850657827504224283964619072912642239373271/70134994640913041568299895670790265036658102424916959577748053515,-4354845541419872277220607779237853579128530991863045614671492610/5913865880965280488946621629392538258279364983956604658503923357,-108900103742611990188652459255991947450310950509137365350404486387/111036038412179146805672584505966998088917792457622040358571089271,-106715536791133950544416506972993577128554957481343520500809280907/63534303913698245241845872823274632801688341262737792211285744644,-1339817223955092377021242391527213833134690355347883787752019621267/630514407833871518319561913238063442883352108449907227522565293252,-235010823678736810057707129342322138977414901467143768865061426015/22535004457944845380722579075447033857794892685612675397562318061,-29651863081206341897729112560102155907311247411624057921694374433/40577430092622621997795781766229502548488122112021473671005728437,-10396505003709463506689121607957467089207457620500570419964250059/13302654887667760089866354864319834027695118627008958124296763277,1899929709949514410073303434054938474317559222355174685804994700896/1392430811133681992123011284919626734614030517999415983879422082051,5520211087682235748265265318240980636267585335428728512583012456/3097836544566088839940051822768117776197073276199455477197957089,10068429832725538876924102272129865950951918273073384888680742619744/6507169763504117344877759368065626260856043599748183744980784634359,334578845307659811309625908769219441921375447542422906660175496/195764431982202465830678679499804256653654923448725901781841665,75392065690300156868069503542358300348140931534805115353149470569/42309573244589364296697391113046614068221296235277188023465721789,-35123101347303833217053685278524557669309744862822347435429465524/8682055848625259942102431234312871336033806905242249640972234647,-171759208203235798419399099025664309538516381595982151473336594389/95131669439862863601274324018344596733137588501114259430914524700,-211974324562331392262117170391345448169804587135198065008257183997/28152561364011436304063708428808789530246830732981029069271827204,457152532902523958054779077421936813451413700979177552886727202039/1211816749703600918637227188728865054149644999597883817232347905748,233032806570791675847554415877134806950968306601850555923071033247/585425933016242217779243778462483448513448635947471170296541931764,-285376709426668599370730066858152593466214297006076919241776069811/18683201365285970694787062028468716663410880738591306351593794780,32983381295727337751523158478244199434578720205440454840423466263/72022489397675846715950700278604346339120111435386282534503575424,679787494184164333026138922778179689211687562523785013100614795707/1044364330861389998288454469104826426891718488343225448019921998340,14494054540454947476062805514254618129405767282673684077253901841/19854350116705346032825823122230501237640154144898863575754829196,62152075686467920511105925458860280694782469572970176737639016922/95684769350537017066689691024613799803323559413236391180859049419,-146732011540394957116633695463353081078942752434173168544431988128/432933594080747792700452180230286600620198714672065875251405681165,-1728992864782984166676263625447599765398168058100722444705304953312/4456922014437369509048763204645835359478798522585887982603576419635,-942068397671264130277307723290246579250237634951397092832909078816/2856202144939209514770077658854866025857288380146012115131857584953,-7218192861766443740874266122226613349140904571414224928937881887/4995707979419744931806776300155981494869512396040745084475786027,-902970902969855332091626715457197901571296359061726829130198964256/12254266292115210258578173625444581678635498025512186138422995754073,-258739269113967850997042831599308618168364304334230072847543749325/1478970519812628174886498232268131710460694414021707934155847067301,-27294739415772476707201004037955206158492500001276367091769736408/90242156191803828807672425568706366354552985748070604414875327817,-205064475094785661982063705635392861867736947878848011170854944493/532934542617647323130040697971921175474955131518148066716929837165,-48502818409578538609498315458731003027740186788051130607974767312/117890259897469842215068509313857035701566526836151107771068173265,-12429197465709227592736976139767946742032699951741926920571657648/13852463050313207185505533219764417135692446465393763002977053447,-640229556914707679189000678794205029210756599651323301689878943/2763399194443876718307745407527991587842806309456790415481671141,-38450961378671221148355016233955025723287504123410802166168520064/2107070697560290595210998815851534970630591930588971673358792729,-9644859850312876499507510912500453287323414116003443194638103026/257230068698546106470889419819269168523947518329521057860560226837,-890559206123609702948052023550157128960093374218650997762766324/17654024580730335214189477565983700473949542039887753798852767553,4623773111078491924829161204585764830901713489027244579436523982/125440335086769631152503690436548933151061173945647366980636690933,1106964858703631440971147390070259164230367902528924509647842047/48137914145736013275624194204907131073808695470886499106284670489,3360730142104945942886573669353514117068867388059316209524667387/83124812160610194606488502880796428475178024215991322978285731227,-39072157334554671158055407499421306294210259855172684312903310901/118372026784681611291720727685299024246240027442652274030176319810,249869510393655263246839910459256755853158853493982482433688893/4300561904286462371969148153072882224046355653879613020863275198,-4813789132222996897621572782708768861385718698594688852757254024/8368197941153307812758097631317958838084490513219391695796076789,-1050227617221304018508358654888148265757216747436489420259184512/7514015601763963535223509057626554544466086259291880808349166817,-6265451194622993966099145990841916575251541040216762514245718965/37116530741411383561818610685250340466300602298898782938030258896,609414145322052950088223413118311927324076088063897803208995606144/21263276376978331781215736660990825252189626642020864162361038722343,-15559537533226385996685439432998414466937936369405327657651245004/56895847882349384458249326201845641839498455610631142412639735535,-119049676177574487462487104641402951158658455485712692668369334336/4760520935342512595296587109585435774465856175647862776680848290275,-50119991040360823834919527353577780410382589851337389453197777440/141092994036875026343165832405903089028116986109331944145460195369,-640695498663959661456870592608025081216368524828934989607375744448/1962416445217113937754526997299543183039833892030513597811775614847,-32486160517341024012472029301730528130642044871581169986316380997/125482568107062995242700875244692146498972772452633059487892940050,-97558427541662267669591518505435691041952139049337449234736563334/333969610280303498104846744013234206763238463177251232943590943351,-142076667278988931080089432376718614636275454955990315324388442/3384833448237418868016900651751018884052528160604648157446753445,-56379629459335100980336648587292810620863102059214451342664275456/58348777293406756698446039576506267152670782769305503334671734019,2621415733744883190565119227751538154998091266321519008777373153/71399641587632954611722515060614713621114974535120281103119514607,-1433628963698281378226435904865559596775210820682564571491433256/319442070580961760610088384933945040541539273876659294423851596643,-15560254277196061911075498372268218417375792549041219033117620924/432161266247013340863895742611823874808336465977257662661384384253,2095734682983702868268947956008859784145855035667926654094684732448/1791511971403006798479989510785574716511044294569839696332606017013,-38839211266947063857523127442273006055321827084064004242173881824/940915170350302648935110462717454509455976564385630757599838402135,-370455934740280452042227968579953751634071922994307410557618926342/1211463341832048087875806047023460496512048214394270756272709725183,-137681591552232402760550895329620042902332759892702423701742301907/426556445981277890303243169110079750193552496021679705780698803557,-173042726242410030179554103453019685388511361823087666300618349328/560939640899460684764296763724531249087100485482089813975935198273,651907947139677744394232240109961822159880703746950330194154992/25307988379105865783585109534697311795800916589220646798477291047,-13232525974906650667578304200298164917759862875687437427278769576/45277799293880092567108038580885469082048891328108605560452329303,-55393292949534666120378398341716670516535317479879132398070449111/79150555404679459152766908742395959432549753112539066931517262389,234160486166874021800674373170036542218895315996977349028103252704/2366139869822513673509058510558696219677465210139353419048225201825,-278256055199280779894803478397644944865137929974236681142319268/5105375186109718019740626193341639615470594741883614418828179485,-8250808023145674697436651552508101277964130542509089275193196048/32771182493186114546997589772309482844661075195589075909377258791,-54303331737502178937830541925523014320213173827972843780731895362/987835708853246709228690670440697739636634073373446661013490603769,61737170167893771821458073563145542567023098165394236337464653337/63297661458688710565820233872602487539950026128365601303978394172,1021679895463516173885201457364063434098199126481695112240260577195/1042211669958601107350213301059391198972098555008638952361070764388,14828876514908451983527855777148539777083719435163491816594214843/21460535561094391157777636399441067489579005599587952503693917605,-12119073194805773040956459562540613652016947356176833004562572361/3305643949888561343408852968117827690719789939185411954595505879,87127870857114656006246857423555612006547150393488911787259262596/31660411834978833947233088145063211859317855076215880440948726599,1331659759164812241501103112131018598272886567330426091686176646452/1310940113853345466989836286976963658580831520857756256399898717517,1552148692541265518936813284336079246988550319909685453616674393164/371706330973162928713791126704154742265586138392749576465512015055,2198917439769395377689013945618377356611510267542306244235490794521/1286820707963576144966779179655229387529831848120619627049308307640,989989074713071090011312847744943437388514703186432679371788591727/746353321839604702343679551451896870690867033618281950279711638444,168614996065720597131624604288039396242399355707238418066551139417/61134732331948248649658096112795707272465739903621632722654189877,1245863165956785427216934952830492704742119862546972106248810894752/14458151603568769323296701461527438366476870412919641150260459337,54419673808287126426650474415317919594843052281687450886511556276/47462782437957304161562990464497674213174319211479332983182467723,62834661860388720224468427225822158078492622603766577631861610778/24486143986171062856707813935585982681305119619524961636835371671,8354646539107716067269298949675545692320101522393379485635039546/3387103477263762163448106401703010719874846899901939286667288553,1161707765762015798089024076312821317874794228929763920897021872904/184334561712745202740186290417833697395114249782448513434321070893,385002231491090206289070165351309122178781663654260742704153261539/73073017018401221154392844876571382090151668078743803148991597428,-1184443458940639420318388500703653407686036953753801629728270454/14284555229584179385540731602745585142692149940699455493452253017,-11358145323908052319581184620510610406141606519314809716120593840/28550394730879747346746544769568205283113782507878453807393511507,-7527284926151416785667788141322605524866693214805506072548812918/107588342942367286846431418417168754474696536142643730706709152903,-776688339102571025903951921752057927654962604514771073621170948/896990003768201571851295370923224554268716507572407047284916309,-371230148954687573981776340046863417572221143417292831640773046/386447202221029941686034566834328792682958295311064111327480419,-1328942135385810497954426012222631474778647864970824422041800057632/1868385390994557338692050899659692124640392245687479981891112512981,-1860745711777506409661868772372293065707210776337381541620950021600/2658542454294180040069395234342505056762062539877619920565006058531,-100587470206382653475592347530537845046886205582976412976147016128/117570517994403597825825939505849198555926000359383578600398228449,-2267549994939270279221199653571153843605216621583791257091496715736/356797900062913115076755956832223365281785342668391879251556474577,-874382201547020359286559926354362367862718255947785937643896193102/148586529403311413886718717581774839475831973170842400845404104291,-2076104548807379470624520458386593143139668444440211495776992450080/637435429984741384684784636308724381007416269626339123311270540429,-382753757601266642069462982873418742457090023417161311987691650208/408378403801969887468713369423594819009973483832421270056889391729,-690818645593732596993701505236487113890821675079493555529902757856/613286675123837814981799998739094331689580336639273565815430857507,172999380583528225049283281733272255307920155751483187400280657056/1613577391265812579470133068625187286440883704450194835559185165295,115094749661509773710701670175373361226270785149522649422654737588/318668352959081445081627049016419295906478561935366831138967420883,-23833751735852055030186172303672756349530684225864590197476674684/20242642671627400320083058146389960954406738106441848852425302047,2407385922780060907756242380650719276461938540150809040988125308/1558430624515438277368776000237217661877749303331330006740485565,34147407035177369104148494586313512382711174050801383295470459668/10709415480702699916352661399450603162286202508687393261325205363,122270440112485424879658736888197190404569377016448368682254860214/25403444160353347726137135520160097700879636730822055283741649429,196047529766324024425148143904645517497185691717941690354967123692/111637498546479731486207789734499237366648152406180107992872348157,1532332461640107575997590645174567469856820712713132709579533825922/308317959727275901693939766464622712284876858826612688563724882847,711394082645322219905593343267917681799041011144297747031701216124/134737476699728966489513727949301301963437670583495920446479792039,-523505054684997143495261228970210316919344880836843476821566045765/561891860160844938631186769436331131073905938771558186784082316161,-107084277497800489407382618184336960915154716613034816775751700885/133393529948746794512202187966268230854611159115678754863032354946,-19182919886939667959736611592080460506215826960773161898143734346/25553272915137935145305536017703932493372299100357962066161562527,33962288145436938825456555901791676395427575594772346338872489626/5395756142139456313420424291721848567510545910102073052151340239,206846665292671544141246220763293150314971807442952479811831995963/21497843162374953232727259683682518969972653636415024215497137996,-64876640198852163040372552614295046093974231207809805650203626874/92356691508455317417757679645446020668298957705592851941539410063,-19812439007415992184591131228995464433231876543460362657895376534/26062342222631480234569487686808574092581726245033870362545758361,-75851080275219941061281948136179942810790187952156648603647595038/83700058745064284659147020765594323206598664621917813681324736869,1178754638558157094477622967478260729170198448800022591810983823214/150376364656404430831010939657581863207221595090904921929472187709,23598451355347548950368957626359198812353215832356148017322832561/4272072788246367479487826556247596517645698812612158629650023200,37084991747186734580216229503253931518877381633673681738796820051/9386998189657375557376468108128334648532355104530723304876033275,329258600870836176120055862085132002666787335646382147199681436302/35267099748129200804052551595854199351710265117815569025155468163,34085590932683329125135159249802778265381035365403690470090019504/9412129458645284817335457159664086889422764716666977049651975567,1218822629268528065411051771050947732229647146712320350534957024/2062610523279371616312415973597443619469998240159124933350862511,-3753743760509408927546505521947132096269903457376973936521737368/3056988153840058490033600732326793055808698422600182451905848341,-18162440648299754564445194332079215904298342449988936317752772982437/17906128782664918839675322052091287987019714744906348962135414729802,-1505356494832299324499480875536602023865411053529530255965791212044/721051179351658903535239019534629154220753001933885660070087636115,1160733156291162582469582755321220358144575217201965612486841938576/38667775046935490629670153824669175847638191701333058006857800323,-592747352188238970398578147087942029719643497155837766349838360144/576890769800529505176834719625187511522257528609978528890180877675,365796344804116588962944792022133123038061463635315994507919473024/25467665088110547486404531169668267584964116269873829495186918777,-19312446960846073821251867331392073568208584131483653572268996256/16725592030244116442475266455996997126965638302243836732109251495,-60761199438019448855059665794213104981481084349653418580504121448/55859090045989861721057214471922416734889084392481983921454094207,-2359268610650121013741100753536476981093948535059739626040730804397/1444788695443624606595995130850329921210176314123199930364497321706,-1739434683794414482817156191771082433029430291485418303000350405432/1010905445438899245789116168134163312857852481951393414200824885497,-2491406271326414774895146152043112638878981170547468876459021323832/1442385447488472983736704164312704655809662537044560914294236624835,-121476006422763913610155061671147074649576266481903054023133427816/74977367725309500107271057330970523415825344848838763581377716225,-68804780952338701436204148434703628329331200271468654745822509200/13136871462047470025667203068808325915325108875580013238417438593,-83526545969922106796076834456936088646732082215416718587866651900/14396204255129867368900340265485550489229563559052041743489905317,-107040742972092267604930349554301923450788012166541453762130962542/78582851087326741755391800656251343525785024262697279259526255603,94090674869404557027280773798673945664003214462064638833289303024/183020785499580803906908391036238404909426837133172741913164758479,-1151954850977660929963945858646077291946795878139602325195073370608/46428282232277197400149386148472464478403127478815792437364428295,-177838377604607653447623549653860439798206683809978997688958031027/4317905544234115098886554626807339891050177756489131849441945803,-6674424620727155190855414954612347341687356405503496987941877517632/689832504729870406074924335936008360092055817596643310762042709399,-661500049864067847890766454848368728543287071487054439374525471914/137807043129281275102003754741345557025659561561199536414579485637,-2885776631898740168232816777177424241714392085588112618786861146496/475243260834226803700981625844396024911115892625244913164619029317,-187549850603949560250302476015405632399482197832503852994664048180/7776390595109143703792278343380323066143085697758103033735439993,624681784773386176591722230376298729167469046304898192275993372/178388945159400659530031490525759945279114834248713645611358007,-77579360028876486138470078925951852532837183185988467415406089308/40254657920131065782081662838281164739007867123999469822585426953,-129062414641457943710064447426574476150310085903107318978140138312/59296296482330318683818438504187695004795090410529594922386214327,-21430842830986683961979370261259166313345049491326780931943101525/32823350314456115932109592606545383325667186702356634108778882948,-1422023893511846452137386458927889966618934054502900079005180083337/1766478740710475678931219262455714001326360907440238244964681483478,-32431838514917403006269155273716877462514701841439824764738412304/33777592045054700033169417492591623948163757312197004052285115979,-327055128279916153638682353496845033740297898706151778476715963176/163055398014793721914382753433284239626526527529109946390725256669,-359486849476659006669184715039650000713022687590921734856625266696/437762876373148168218194827246786646689216448345646327263367656249,11139213717133810715950242712066054040885799161540935515033192344/21162653468895343853185475113190334818233102909817869027088106187,-232171372662184464081703709939277990637247819359499572539025467667/164672191375290469545881363470169353342110905748879291696465083825,-822803763095598774154314763667511919126817855245817193257775903331/584605696552111631934902813576511333888921695492554451704945860145,94263102867063785436073281424956557011611457882464962103939519184/188943710694454908043035280952973548694455097979669585240481016787,2029693010831430992994989518756239529914541106775720814357077465/1897431515396097477218421124869509508066402622594670428966494944,-5208549918085305228421030662063193562953419322197327078547437776096/3674872714479985382171234250288551736249207920291417268437456885021,-416504530486539031659373606900860873652661640744279207780114466576/471147194116149608589837138240398523211166643627326302722679930853,-307684880389486752662332139008519337667727882788995729240580889256/213606523227291040198334971440067766852279940999089878294059831745,-1758410751385092211673324295713691972761938150397452755976924578848/1624621303683283290517433740729519205548727108306606788674134678179,-222359510940678731122321278111711406592742277696433600505485036396/155332916710212787769241348528666444406048912221469640240608782371,3069688648171674238474712868824008353362524039928463934115221090/4567448182423311864510403113133798139299926971860176017481149857,3766398563528703967829333829879339610461721774306898773692548485/3413444368497412211214215406583001734621200451979447498957502103,700447047401265283423715881263760931867654199364433794077508088608/1554138208401135339123762902686840747121647154045065770406843435759,56380396378561698069833976751289254372009821693278322136486707839/88114135990322382678313722147123461124549419433374464013927791292,1625150315097006658716941544345531684368095747595566924094501099537/1988122415011390265499172224378732954160098754794386617017269202720,104687430904393952836104555584646429956930768873447313730918892306/127931616619185286585446566384430169957346140162152847901111060747,-2772509115996702239982367628988460607167838209863163729587361715911/4208733416408111629594495520868827368170882752501227970585416126050,-1163795085126823142853673705098771223098124787722236636719842644752/3889017835214315291139436113174370242928474858319265775867307764335,1826205835638361019204595122317322360758099535706849730017343088012/3249024092784282044196575410488695559596270031010110103682396902091,2364467400539632540675862825954253597974668149336641152282682693324/4298569101772382801378774100181839173130864575603391676918546271195,4142027709732557380638736802166676459508644971471229066637404955232/7425445217870348094327163130296409192870668103034131216412943240505,47798317856848413145622913064430338517027887757481505879511105291/763369882211073590613392274093322686165226646006590915479510340384,-119688684371379615346344722557400095596039988024166634397449523051/1087755031401422533211787475656992956183903227841990874199951236724,122269740562373633372003085339642960847758915087260838548003981073/161963360968431836802010890771943936934765911414016908454969069306,1806740884042106092514431604813917825228134855796632088039872459336/1744474935722313533532634844047594435102322191723466367979512078115,253700465007196132143114092423068988971755811609690381951856802813/1054946962044311240569043225133533950411583337989829020716130003840,140680546848878561888172220780964843465097348477306300142390822955/70069809521055442299119690250510594436671721888646636006050796744,-276610688627241302162931318589151757855668952951110797434354753400/137952957572467082701854863956149289424559862408853554609774659227,-11486870485562888768115202614251452662989315577243327722627694070/6800896106229461940465897237554818422080861199285728928235748831,810721494818591026522086666834302148095910375039356667676282046784/437163417013314693333872447266457531616232126893210757388492500981,769264302180889798853022363493356589898780368440919919784825022547/332025769999299745221036266723468904016490128194041639600571560448,1827956113839819263322631896254793921807782940538772003748469908556/988653992271931245227754576688089925725438108560275333079645494339,316214355309512381584781628982801365022233915589612112766007618337/162404780894834625415606513112858379761321230443277865151588935016,218329930909968376772618276601090056110945035836101828096958322368/153710117397953019323221344444221486041262050369908325231282691257,-1598936741558563642792594003777703765835988020066790915326446525063/1055008146660778261692342398965775282323495245900470242333864037975,-615802167522688253994554458041558053664578902406926670922764343019/398107096188543402795425485310531048049273958150400795624477254982,-135903047461750860939038692567835676991763117930605180712369211124/70574774405942708592206890707698590588874795316622388941241054759,-2621865836599515688784877219659493796370902590193743498169746126752/1734769102387013047689531145281025046772752448658389290038257046197,-84337539141203518907832336547421316923833524650883570170801216736/48460748707019692371420166227092256471008576417758150773991003381,-126462596440250753352226535237668369958383738941963735841432630460/65743867804140313490236865874008461997412817298953389676150136801,52014276971882881409799853320900915990177265884791199273098606409/123046034390365354093061293001817285331397487828841758006494352022,115232143188778293711438721931487505062759842211898692764190849496/181616321851339291703926133359745136041305859155773720464132025549,79523349243905041833499150167408455231962444279065312760631871017/110274224842356368071116069529197069760736838551243861477229044716,-2695700336034206219291091594759658474424692194517486758516540816689/3699575986747813522650890591455683886241671703310571226237584108106,39046072252362733794564694743385290585206197715436238761628592488/41629472336602155770875204201887269132426715390175982122266504591,27436380112608570902151878071439226363422614819401556880600006272/24348290498371897759497428555674907578849967668377405439750568559,-61056406534262623442286773980838349530219474779519747455561035264/190410293757620826615065435288632974518353779491451119655060617061,-6364813588000345084550428756132608310320258192125553930591115493291/8838921985938937660364190820991287906687407102189518004003436845786,-114256517339901168826303122851689447527850121610490901833036351159/247031488642671734792737885554144275577702609266474228715883352631,-4752464417028772613441450719111057534017690839454597151183920299408/3499722326979631132154766108172046322684185904243161596376535294237,-185098045652912958738765926999296359009172591964970405507517309948/145163001966735856117777574212130883466357208491784732470799668387,-17776943620506877884599576087096102334030655709085734299452704466292/38340815593260964020107109551427848376197179479219669698502234478553,-245999393593253356426587180424237238697823201189939715582848319628/553375227911579137010059732463016384994656216282843354947844213227,199449659135570053380360541428684281185298823864700851311486122912/33471542172149555583176933792310350853754721456767355439597364396235,-2661935286182410650523106098675295316648180312575084220706790101472/3396718018343913515818983476476156542365101994323902329138082211265,-32244249063546544318063329536438288387091290123647785884369007217612/51155310708064588450712403872200751670044308963107690007940162082563,-33811762820474213445578481838035261841614634220929253189785794515552/133193060062468157118019292743641598683255345593790954321095573841377,-10143706743986255255509197772443453378329967159972120777356855266336/105832924792712293620993791992282358917488220584255443038171130223763,4373387134322475530654679804000179561353623162273480663651277483872/32287299762579402307528517539927531531658252495393411935041933850421,-335829007291878351690916302962236844889938872796685548647830471076/991342834999244959957957432925855133779657128447716003399934197989,-771792339865718216475645140293893815914406651170906689373433174/18110946629691270077622265805758405700218791053451999324987203041,-9468259800156785247558126401940694661747484754262155056374044485344/10744691558668979230259562753491846512757708967038333837772544808791,-13676343764045928710305213270614183982221538004482139127130689913/41317199750744157743343504766596836020022828027745119952961382722,570875405009988234884596202681996033710834072449248244797326936410/1030228856479141582852547563793408845937063187775791010630111249627,303266170128975156570408402878577049012259333570522771903312992360/795690555718799429829197898530228548481903800131788302780573229627,3924126737815853078594239437279492555358962778732078598677147852568/6305176629793595090894012575183893950241949701778015832289892004403,1690565262406769203519066060792527669159972070082396184501343898192/2673462847675698082639207662194676172509605066204786465055234909057,-105555560285426665410316166760910082407693166179261689748583950288/3168820026537127873203558760630860562046063281585696203343386717289,-6441767834567042180729848894229576482659906760138632134998219488008/15110223789877169249493387109583257612233102031549180473037342795147},{1295763732323301872287205622888665486552534647417426430017601558/5980231508839713641628068045977356827771347682880595522652162451,430826323777016123985126950265336795519180942946894952313366889988/905737373866857143740190851732866211904228115964378323871042971719,1112597719198660711957145934929013939092556330470292734855937990028/2908670485829330905740027480070470041761623866777048664830759159001,463831975865938425007477636998841405002131920583860253637156430964/1200436107157517229045691638259255899099519559862791507107885803863,-379800957953596700426960435348724836354037486784345333131705824/28701509502195275365156629881879581547840519728985057647117639409,422429186332542194405840539132775422049543715016938276631308239636/611073924557569869510231347409391962444578680605022610715360282283,11313379041110438890008669312660650199065419766417611627987178587316/2903891701645797639027841751618425348089316611606464083930517677003,39339818552492077817409909642903895898757910282854071811008027092/19708972283833067801736923953893442638885592753668642612745737545,97967211677995786786637877591630054757560167458994145488970650836/13325212700458212094265010815753470526675274245535590565189557201,1010964597029801887702578281863586752521145074424442714229309451528/161709952490869849821177834753660321012303731877872231405017498773,2519841176202789247651114061205257617706065886402533516776244838512/334431874926832121031610133219173804815757300372790377291710181187,610370665003283290971790555904152748524744615150547474027404894684/101241540015561674842940457771878501325436867963345124040466461101,38819311199217670266849913140756171585223350385964949844736371293/22115283778653789725617754465120851243806955010651162678788026674,78884987262524873974059403747007762782259442411384424874263895275/55469558424909680929840936932313975880158175754592613243158382966,3013293634992555154496623879993002513356170822191326413073505313732/454541894996366620912279566307989308686841094453896101107721441547,124256807248782888853449573737197505610526013768482626491274888824/98057557914721568921705207724373213122491048688897640348941050713,130836307655475711462948532680072554896617216259403033912184885836/106263943165269297082022235560005883185015625675000285511276304807,974880313557726311179659197399063989755331217585718592398782088848/1227298018203246961367613975268346121879450177284307232283906211931,75410289706353321786233273010163161164294810211336981494952219192/146219524352327993897314381831558939332646624055649527289035105093,-16118275831471544252623958564748300754493112445550322796558777852904/28493719245338958984308782266910027825293358160569621407031572584109,-8950558942925407292485727940611926225608393246428864632529738248/80397096923550340340633364029382949269608100159829544422130628619,-143895617188383374916475448074049097766617964759388289337470721477/339595391993400434144576437973132228704909654279638269039772828497,-9832676461109055691430687511827738048029985870049691196553295168904/25872285135619328118182119519164363086357474353005487805477460883137,-212228172550539436858678184213302620330812385073898097639788525176/187156207987193687367030620788862830707070216879730243503855624095,95471561637668184413852908448829842042641132302245392198823769560/177373217882008010412363878479714643734896062706717440999951076833,-5373601317782116189958830787087574144385045656197488739675756679688/200373375047299518441721193973256107519008578396539415575315846499,-3011783992587747062107163304107664371204730353251008577567400072/144988072544101096092129393238136595314641863114533347890392931,-29526146769786530798399155817233968095729924944254573638746443096/47742076512068834271862197786004779227467149271002356936688817051,-136771061253030617964342234337496962613497313411689781985202619272/1244416607042545611455002299143986970327029994272482373744093431,-477432572599210549851677393335753755168443236938632294122765807052/279594003131945258188157154554085617549379569265633728802798063251,-2100841170635587211267750250456015450649118222395435038460414924912/535606377326462265516516522731547102297930464898110766656709967939,-14939276348398249496987652745071418363687091668911508901031008041904/55606255579551372757751617249463180214458696567184361220848557301437,6291550712756211705408348855240853602304558787023103397671046376304/2815006540480116342700459381568140544996940980620124609182119756073,1272804906588172140192533867585868083757651112741116338069611712524/119098157918760307599990471066688713375280761783506027130804376349,-3320566635487608611441467218510607585243380435807215211155109936/11874760369159226855662589775709348686394415522469761697549886081,38150050828533474113297095375830627769311123350166027004981966152/57438854262097994080409884531535656600885741550452767000497754727,615240729277727790513137868550653635976278295359518378866903638464/120901910222702312464198401774045460984191965252560387394411215421,169958570329877690236431419181188464736911830831518691955735287008/11470143070192442024489155247116965399407991101312786752838268923,142348283902075637201101070081440851225621974532249395622955339488/12025594778658557718788926796979798113248973971077869023362308635,2268713083851871692177492559233778703379896226772563378984664157728/994631045053627604399929800183477177954071853005165057174474151961,10714102219092002266439738833956076507180613027289655278053913202/7913999443651601159800809174346862563346441858632701376166766163,4856935422928214748868219315794860183458741812326560237545580848/2795108151938766027749037959932860603864084443413930308174913859,-193969015272662131945531895202022886370744647596018276108935942754/1033016604441412442398429314719026282807166032594217390828839653009,27709206129131604244002303692781854196839236849990566297871410098/3264992882051121630235994394058554734157512856505568270863615191,8071996762486000229910178562785413471638045610612926029438863826/416627792389801152137272654874976687972684165311593179674882563,170170429937131313825461994189223185632825432658230842664746081286/286630604774214162366010085526307714771377529668461579775057229,367470222254512010644423480280251842837784389340111109423339574557/5399512815335496791820562043289825591874262673908618165261648197,3271744775275479056608708518905021998992058783935477301098015970/38722848707738091185110397490763323322409810028371769166876057,99167800617585254203794259958041382812261401085997359807651262836/8813403716030780307608992331329689982827538892743621711208833055,28182453087356345784209239958195506637877086069734789364018623772/95227814315263177982312701191122722986094234583330534758076348003,-6365062346335987303976907168497430342805239884426573186414961782438/5884088044253046018885960315755544973674194437630179633332755669413,-14186824506333663461541475890840490187888120100555780971423989567171/16998241932068269558176806976265104240222863363319114943951349866416,-439826027425023050773683646976565146060373631824695346516231985502/424849979777398654118101906847435088145339601451556614603828781077,-1543192661607594633016544945580511820794231200527411230525015272631/1658028311472398865642155200291494931528748242658894286242224553576,-127230185989621480276200052903506208113590405966455912580549484933/167839595133247708759668302413110023501755656610590582524854108013,-712502053960786988025898887616521358887821076085041980343740707937/27171799945660576408421444920691704404886973329062763112085373448,-8792585119107110431159068760265196978822039272686722582680839332/6686652682505295868254482638325102585557651192006058845643298473,-192483424585001051435006282896581135184826827508250797724754766513/127006009551549310977027205886481238485888219277964501841947708489,-535713689658907511109152384885672428367556782169646027039262013868/101758817772075637091898068085294977154533161876585941746649980811,-203018366420856484253003107076949572109609214855059116345423654403/139656676329694436036286162381614175292719067277991881728725906488,-3526702614315211741589999624554168419765319198659716430202282587445/2341307720041092907482392919020566408743519708890981397693769804123,-229168549837460765894187962089556422375388021363481858073257852413/100077517921536468198952165565680080869819142717316746242652800656,-7472333329650723527209464305998387425672657352164248503306762882420/3381661504430423794038520688101898578113725412356423763055915262027,-2305294857572808392833118749285434610810839851752027708553528183/193345389328770927021677854414284801346520007870751770795212718,-86494385459269798465270074317135657888051453357572320010962348039/66300628140244521730007413854620503120748373635570589922105415026,-4928663299136529956161666112088777988191089954083031804703054938044/3584099961531750185608265035009238224499330183280614547098026348461,-52357300081576374884753875205202302614692616275845693495520450053/31739792607104028340576225765302643705326855678106122105130881053,-660007226313804973643796146502455352932782895911803739306957594578/229333858361735272664856091461068265383604429190749799559477979839,-19783611233734814216275923738458491190926930135512417698349898847/2261633590852603097830768358130532826806563791655150420518369052,-28055669850479388517782922059976763111428443155766327103631597392/20239084403957930650576567571792289410783335982555991323377655481,-7138720864891093224857650235078991610431381888906598100319067828590/5022196846064239523238374895940873916922459909649592582354936819641,-1287657736978704841314591535907232331776186448232599619028368657/1366255820649660965495974281273545190609831388088685199785767953,-6916749841634267881314341805783162237165128961166284754160465251100/4642350095194457536963348875720711048209435706947245040853093364063,-14250971287533242570882012574674355305369139278771119498531884872/6069680611077259303976572997262101733851169107673555818616098749,-532225721261883968789447666294498472778957684007783687666186203/235590464027488867645308821793559664906624951587805645240169095,423317757298581095159233522286584542801442567470590100628338179/8064186947359638009238368193257535604286649347420789470153933608,-281013231396802580668487831398136069997195092537887897605627831764/59634207065050813807104797948538322466634636608210338295033493705,-4454927432229452254297882440699658699289927006954165904157809237/12058359382723840531746780579315329991826606211078838593649619522,-44328557178094838818735938833462223129541341645491429729708061607/114670052248535907402935700327215886778165227837560407457945971286,-1694632693368861513974922899760804803646754226421278175218453381985/416544081670457183113331009669307279386653953719685984996574972304,-416507562431125623392530459799523396417475196230913281916564480869/55697314439351738141293247786550323820238197170971255194973547832,-12462069504670226523021080548217347299674399967581395211161640264783/2667753901049699750636163603578321000086903430532709611360062520616,-219283891117278985645873979778041695741626652272340688904833995586183/38281452483227430913967839262137497894868375827988082353025494675696,-1586153876491778695507205604964526585787670301019574852794097619285/62194870964736188025442559822190824776743809908556999884469023368,-3404051860590821366901811896449825007324657299063304866744793388/30734275899813946413772110573171755895700796878746545521065411697,-23447184067138144818759334922485625316676435757720327803118228399118/149145890386799657841347161080384475789783145556907857936775091567,-3519576498942155891438389091280646447403625129912405216989227523577/113113374850096480437916922808286578561656743969678339930407483892,-4248316310785026676857749864262508437694502954409375700868830933940/3598144090461457043588678679056973091694269892463540140058121766397,-3288070114140539516679384299199411779726994637761696688172446921/3049509175063737958804476302080389254116971337749325993704356474,-720176753420928013523508782196472637682056000006532456908804590983/619097283805829692227836593473944658835497356064088079543726207470,-130804650307867633292666708990907606643998316852405448963319576732/37781889140614864466685374280688679599141148165778548402713141343,26871375041247870139421845955683074647269896005629474691121905151/9716728743415238188035903014485133863446311947417854345193842529,8130348408128711394963703564313265894736659266248224385235756853/4294130985185313789215420039416686148281173353134385103179908322,95096154724982529329422692092319141647037779480024442689683814209/102947408277732472412468145741566284339903277972710001999571530218,172102655637378257179573506749127218066030153403287591032947363878/464079263610981969433069159292219299855855060878807619856500074839,12135700195808414024417138537911438613761780714194650029760273838/42224829137429842035666225554386894130682075432538911748760743495,4280606710979465931919904503255987875266030354673977254821899743/10900051733201711724605635701792972052809556966939173700078349402,4558375746562455851288112098477120995969096704859215388581683639/12802707511311096003349105922431031445129596808469122511995766217,25421539024405215280847007434736209170556266576141528793613902631/96839879208010989100053569118058921961369454053084694007329961375,-128827175062649831061371891033359936888880309343364154165733072634/499530456093486296310616369439602733272796294509385023531387139119,-546320152775622174352160040360339150671377209946090533163524903758/182538897554150931202536364475327045775735345277068865839029687417,-2586875501921656398137375270481254010722557876159591318902402823686/2358204712205364896200233759994384452534328122989549166479500992529,-117912571093156786852671389607473316798725397857436658438638370432/99193875315248383173670490154844813207083712822620930963404766761,376867976999263979045130617569091966796527798224668136516605818507/180280360550870784534147542463839501111598581839428366924274151341,14448832955600937812901604024877166435817871020775437163019351222/6928281305052668527890962314427088233458499776365435691992823481,-1141940246715108502392974552747034861224862988149820206930752500601/5757150224268200412553338722175459398563676742964664993269298842344,-232949931929435664950686705774191591661802362903478887309526421137/1333809151871369162123678483334405121328087547314323348604943936946,-136261586978077251960515853513902020475204843506133957229710589398/794728299627891278910233365834490242518199398826692026434823503471,2579519421456364036314095036763991906583013617274084493096265115/1668025991233036055168226762667709005173444192804013897140618434,273883391270033019621763586565897098534957377345237779089449112118/152063029523763279675053734126455957510856821644227440866371237747,5130675235165766937793244386416970253965949994106513318902022610814/3438787955383849496035276616481550750135677521597119969105437040147,850454721148392134370038023843390821817565825721685893928867580/2134822307280467898652091331734659338248555414463008624147135771,135902369838049766020682618784019912447703317776356689312050886520/205341689154368060740071830388883131853267140349722547824354587627,58503474013426129164579262260833930206443527287860967033417296600/42510993109456229013224852872449214479998794887737723744824939703,97108841979323182501721695639773451962213718103966418028054364782/70134994640913041568299895670790265036658102424916959577748053515,35388655050996416175435221700439018194186297225344540375075882056/17741597642895841466839864888177614774838094951869813975511770071,55869906085793502480018152470786963878728144712843817561765925090/37012012804059715601890861501988999362972597485874013452857029757,-77203944718659219796599238514003143900448731291560120708055551991/68421558060905802568141709194295758401818213667563776227538494232,-368112711715979477667943706923849256860206327762120515179747666489/315257203916935759159780956619031721441676054224953613761282646626,-19855760373400842827548179038495356398868462601028963982973551766/7511668152648281793574193025149011285931630895204225132520772687,79781477191458306128576772811078609888604564492465024829603845714/40577430092622621997795781766229502548488122112021473671005728437,29078136852179485637539504938399572747472023415489521982372240672/13302654887667760089866354864319834027695118627008958124296763277,-1460335016826132343014769012303996181995831471545266037087581791553/2784861622267363984246022569839253469228061035998831967758844164102,6511389473143618366863256159232638564672921411051956546021773171/6195673089132177679880103645536235552394146552398910954395914178,-5282215675565939777424225774563844868127138543247800811073458209950/6507169763504117344877759368065626260856043599748183744980784634359,676414271738486379309391303070597785690135762068005400574818886/978822159911012329153393397499021283268274617243629508909208325,42241873884867544727560280121185880178302970230203316884658342634/42309573244589364296697391113046614068221296235277188023465721789,-2786893221293806967544254680747868071779304959983930227038268379689/416738680734012477220916699247017824129622731451627982766667263056,-17655013720546199042466236014569104733870565513638862962203494921/12684222591981715146836576535779279564418345133481901257455269960,-507117807269491311336525194467161264061671581027181772598759686587/56305122728022872608127416857617579060493661465962058138543654408,-2446697602179950694940461670160825137129808459378515675219393132135/2423633499407201837274454377457730108299289999195767634464695811496,-41423722245949370854363046518889367445272640595284157136134462895475/37467259713039501937871601821598940704860712700638154898978683632896,-491293033329024563896287620882857701314420597381642910147082266661/37366402730571941389574124056937433326821761477182612703187589560,393190841913355612699423506122916713637374362042436837030412709/18005622349418961678987675069651086584780027858846570633625893856,-952633566018665061008266909648811733777187143964074396003237477107/2088728661722779996576908938209652853783436976686450896039843996680,-1016616050228998024741462472642802838094348910353848502168329976617/2442085064354757562037576244034351652229738959822560219817843991108,-28900938235751565194529004912528547295383546819303960553029071687435/36742951430606214553608841353451699124476246814682774213449874976896,-61161074693802825622951287704375098826642576357408302572813856169/173173437632299117080180872092114640248079485868826350100562272466,-1720010323059949082805535817411266544558446336752156527259099361384/4456922014437369509048763204645835359478798522585887982603576419635,-1940974971530794645111918569550112010566920891526225981343106275437/5712404289878419029540155317709732051714576760292024230263715169906,-320535714792325487410127167095548748906652535803995173852235488/1665235993139914977268925433385327164956504132013581694825262009,-1414928725323038832054621922562846183751084593644127006145991733317/24508532584230420517156347250889163357270996051024372276845991508146,372882225049354514072544824881860739011136648312660051471066381114/1478970519812628174886498232268131710460694414021707934155847067301,1103861311624100897512603700587934042150250339529227726590658424/6941704322446448369820955812977412796504075826774661878067332909,-19363489559505149561471946726526478653265157829552546162128317024/106586908523529464626008139594384235094991026303629613343385967433,-3592568888760267308767402421856336609126801233346849649103980472/23578051979493968443013701862771407140313305367230221554213634653,18826656607040470311153156712092975386593286593711125609964010072/13852463050313207185505533219764417135692446465393763002977053447,16382558067502571372881253414067609260143865556628115752150086710/35924189527770397338000690297863890641956482022938275401261724833,-33075326770358647517012921556861004580826110554675476475855328948/2107070697560290595210998815851534970630591930588971673358792729,-92329554743694449738004489520153316311984641237850515308310020728/257230068698546106470889419819269168523947518329521057860560226837,-275571811203765890091404767164030009735402804738004614367723692/5884674860243445071396492521994566824649847346629251266284255851,-896825999190161884979514079838213979317066036481409305220806824/125440335086769631152503690436548933151061173945647366980636690933,-6770438495005325822991817689719673613718898781288996084771941866/48137914145736013275624194204907131073808695470886499106284670489,-25404058921238851471599281438539931564569498895364697207253681003/166249624321220389212977005761592856950356048431982645956571462454,-402354751154243578975776872401367363885612771747878757915913818/1691028954066880161310296109789986060660571820609318200431090283,-708366579749450286405773967457572569511876790256810657444561257/176323038075744957250735074275988171185900581809064133855394283118,12276521723198550510154591887666610039820647826823004012846555408/8368197941153307812758097631317958838084490513219391695796076789,896084862772881037643094401738693498640051523130431996314865442/7514015601763963535223509057626554544466086259291880808349166817,1551955054227558901827102173961705252360217973204729295588433113/6186088456901897260303101780875056744383433716483130489671709816,-2887964956831340549982485729781832483374351957537174158781596268775/21263276376978331781215736660990825252189626642020864162361038722343,-3820974241513976116068311561853982836427151684528398055627480882/11379169576469876891649865240369128367899691122126228482527947107,-2081677356380165574433603214494490042244919276579643546110225001848/4760520935342512595296587109585435774465856175647862776680848290275,-58646541422614024586904366188793437933631161122401288304849396336/141092994036875026343165832405903089028116986109331944145460195369,-96490246406593446999303708368839479583516979688734568883970080034/280345206459587705393503856757077597577119127432930513973110802121,-4457497669753487144214987433943738253828366422674456254207034726/12548256810706299524270087524469214649897277245263305948789294005,-216473906053282770506294379651062104117180989368868704756071153424/333969610280303498104846744013234206763238463177251232943590943351,-1244238468658662216898818454291758358009845124024239008156489968/3384833448237418868016900651751018884052528160604648157446753445,-75009831812007707039837941729917475752786573319586349132891374276/58348777293406756698446039576506267152670782769305503334671734019,-31480105396967235367255789029128007727265073694301779973693011843/71399641587632954611722515060614713621114974535120281103119514607,-121926076179134527037091022540629056953620693272237342762674614536/319442070580961760610088384933945040541539273876659294423851596643,-158281949625445832137903509443572442229434467905409716178565490254/432161266247013340863895742611823874808336465977257662661384384253,-1082045591807132471323400279673457690151473228348712561202926904210/1791511971403006798479989510785574716511044294569839696332606017013,227909336030542118602457102828195454092820242393027044511747615061/1881830340700605297870220925434909018911953128771261515199676804270,866995209997280105079108377393880868757717223236426555868339368640/1211463341832048087875806047023460496512048214394270756272709725183,320432417038136344404285572989301584243637048207531927271800202838/426556445981277890303243169110079750193552496021679705780698803557,274595554341797068212656166050903595653946666366631304746959545217/373959760599640456509531175816354166058066990321393209317290132182,65698572776040008180375953646458129712851455927050951312595032389/50615976758211731567170219069394623591601833178441293596954582094,25027168589679945362024195235557681187616139317519840948718582251/30185199529253395044738692387256979388032594218739070373634886202,149843643150290197952556615171539064037485913593853595110707628750/79150555404679459152766908742395959432549753112539066931517262389,1688851219697809282968854562311768525400973749656422179330928773611/4732279739645027347018117021117392439354930420278706838096450403650,-29285199197883793909424163442883655476299816272094317491139675887/61264502233316616236887514320099675385647136902603373025938153820,443033559572911698536359849206296677435970088967177540706408600161/1114220204768327894597918052258522416718476556650028580918826798894,431611023175645041445652808121146520176825397331444219094666051112/987835708853246709228690670440697739636634073373446661013490603769,117238879565953732224094102396611342968131250350905656326397978569/759571937504264526789842806471229850479400313540387215647740730064,185923880259578746115200116260272901134750204365423302048974998281/173701944993100184558368883509898533162016425834773158726845127398,-557524045325016275915528766039072446368605509552930934584790883927/343368568977510258524442182391057079833264089593407240059102681680,-1903748256640652576493765397226781103137350244803556013774218028537/158670909594650944483624942469655729154549917080899773820584282192,-1211703298317012378937496637073486681813618241576590412646717384403/379924942019746007366797057740758542311814260914590565291384719188,840512184604145214623039322300083113877429821463005649529003564133/5243760455413381867959345147907854634323326083431025025599594870068,-5445815912826530876524509691299745962758099681852718579231059058563/1486825323892651714855164506816618969062344553570998305862048060220,-818143839531200053088362640170127627250040487395107394328541028043/1286820707963576144966779179655229387529831848120619627049308307640,-92781842502722280857666488153866475126113329641091884322262948865/186588330459901175585919887862974217672716758404570487569927909611,62938857295550756710210549822853208367137838655583906834782097562/61134732331948248649658096112795707272465739903621632722654189877,-904494842736794223844440227409009452360696490538901589304078236418/14458151603568769323296701461527438366476870412919641150260459337,18316978512144320231883127061160166104152545206885593302286592406/47462782437957304161562990464497674213174319211479332983182467723,54259659103744361987537916659273226923623743487238730013615235003/48972287972342125713415627871171965362610239239049923273670743342,11533665407884357759707296118878258310307085305998469996423040253/6774206954527524326896212803406021439749693799803878573334577106,32350470595632759192394881291879475466851853815029128943962997276/184334561712745202740186290417833697395114249782448513434321070893,22900460651653992772262326838069609944880947913855834230480405953/18268254254600305288598211219142845522537917019685950787247899357,36423079551942572190438316037269546923958758390273986083923499254/14284555229584179385540731602745585142692149940699455493452253017,49526839254335319906980771081102290977827744380951799461213086668/28550394730879747346746544769568205283113782507878453807393511507,111906161641057070630164443926550606525202138968883484991134671244/107588342942367286846431418417168754474696536142643730706709152903,2491798429793410746549111621937725669221475593127958907115856164/896990003768201571851295370923224554268716507572407047284916309,1151887516870601014524562783478219764281868263992930155527509772/386447202221029941686034566834328792682958295311064111327480419,-1009194325657353501018805900065521797319787270070669207544393816408/1868385390994557338692050899659692124640392245687479981891112512981,-1271252144498678566181038050200344928863451782039145946658343391240/2658542454294180040069395234342505056762062539877619920565006058531,-28933637599912938011169272211361874095066232688546565363477756920/117570517994403597825825939505849198555926000359383578600398228449,183594187128487014493241107033498509944367088257552424655090144128/356797900062913115076755956832223365281785342668391879251556474577,506677247696141944392437800982637504828853777072197168809480543120/148586529403311413886718717581774839475831973170842400845404104291,-2393556516366147069713634340447567541461652988347263222029306581656/637435429984741384684784636308724381007416269626339123311270540429,-3646225106404682354749132433720795026455708256122695583853242068552/2858648826613789212280993585965163733069814386826948890398225742103,-700529544166889540628295253370657200652833621053729393306284984296/613286675123837814981799998739094331689580336639273565815430857507,-1982117328524202820069546113331852383219027516810877692070624053448/1613577391265812579470133068625187286440883704450194835559185165295,-414278139984652662525822153034159824594614523545793950151265148922/318668352959081445081627049016419295906478561935366831138967420883,-65869489139067871932073798752489114333096536570782688857983100898/20242642671627400320083058146389960954406738106441848852425302047,3871970594572464707664635347315202229650263446152357854882699274/2181802874321613588316286400332104726628849024663862009436679791,498555157029731903686997625630357786212601951264720430325702069586/74965908364918899414468629796154222136003417560811752829276437541,261097742951776275167820248228084155565639834879783670214542927153/50806888320706695452274271040320195401759273461644110567483298858,251102237602964617523657844717377445734310266878741061808476239323/74424999030986487657471859822999491577765434937453405328581565438,1892874771638315525624174066639454335104509699729970369705614075582/308317959727275901693939766464622712284876858826612688563724882847,737556933733515775318567828056108025235092870889173391420275545954/134737476699728966489513727949301301963437670583495920446479792039,1625594312770371613626134768209007121863733592470949983596233814002/561891860160844938631186769436331131073905938771558186784082316161,232234358695172410713686893243973430176871575238498979733430646813/88929019965831196341468125310845487236407439410452503242021569964,80731329217657836603868789189215693359733910561414324650507883866/25553272915137935145305536017703932493372299100357962066161562527,73527155616785229844564081186610765436773644644139059110104045275/10791512284278912626840848583443697135021091820204146104302680478,50870341041232397118368810654775541010836251645680449697820358591/5374460790593738308181814920920629742493163409103756053874284499,301754620071552605431368916527357475477072849629779033884986976890/92356691508455317417757679645446020668298957705592851941539410063,429760608582554683227076482923117605707928995777708850388825600782/130311711113157401172847438434042870462908631225169351812728791805,328693741231014120493728741967740808222104553074363301329972827646/83700058745064284659147020765594323206598664621917813681324736869,1679566820874515578225505722661704858145012678485861209934564547605/150376364656404430831010939657581863207221595090904921929472187709,105135948027344838652232589797898380973842613153748560011790163473/17088291152985469917951306224990386070582795250448634518600092800,125676269093503000480987430213997913127515641882718019499992525411/75095985517259004459011744865026677188258840836245786439008266200,5324950223313859255467593509934545725415914356764801319627115950761/423205196977550409648630619150250392220523181413786828301865617956,15043433695685737079072184748297592299164117142512694974416840954/9412129458645284817335457159664086889422764716666977049651975567,50353808672159384623028268564784234736854634296395027538521624460/2062610523279371616312415973597443619469998240159124933350862511,12880216600919846608329289867171462732606012171504497720085287082/3056988153840058490033600732326793055808698422600182451905848341,-1140807021412794426224114586609953968573155447202822148758932068213/11937419188443279226450214701394191991346476496604232641423609819868,1295596766628450549994452766627469407693920795230443228969918877222/240350393117219634511746339844876384740251000644628553356695878705,1698244925998923792492470143843751028998705660052115428723543318278/38667775046935490629670153824669175847638191701333058006857800323,2191674392885765900702287870332023014505649964424607849150559949708/576890769800529505176834719625187511522257528609978528890180877675,60766392700490347887052914129089885403597254432763620457587474932/3638237869730078212343504452809752512137730895696261356455274111,158507606292299127271488108231352607212860786238421341236038048044/40619294930592854217439932821706993022630835876877889206551039345,67560282967210927950330160743317654365707589005233744907311171305/15959740013139960491730632706263547638539738397851995406129741202,-5806789468126843067109055836811203194170546166932319967156277531403/5779154781774498426383980523401319684840705256492799721457989286824,-1014332278443672014596330866382994655668703835993104741648225527140/1010905445438899245789116168134163312857852481951393414200824885497,-1424631898772611616518148399810556748344260129327671620730808083428/1442385447488472983736704164312704655809662537044560914294236624835,-22786806088878794600014793279163018866556155960302753931299026809/23069959300095230802237248409529391820253952261181158025039297300,75842539152898077685765251767745123191484591279414409279994415868/13136871462047470025667203068808325915325108875580013238417438593,105412434767796981072927525493527697552351364575321915020305626172/14396204255129867368900340265485550489229563559052041743489905317,149682369877111117248781609094794074035278225271531939108866789884/78582851087326741755391800656251343525785024262697279259526255603,178460612119584727692280761942176481112614256822093575468962735794/183020785499580803906908391036238404909426837133172741913164758479,-1170679992470227069959591489488913548932578369286444589060727641282/46428282232277197400149386148472464478403127478815792437364428295,-111172123377368238215628095123472602546922865777146975873166801911/4317905544234115098886554626807339891050177756489131849441945803,-290601310014939907655920936271864800924054205852870962710024903048/689832504729870406074924335936008360092055817596643310762042709399,1000215343735033835444201279687211769200073441734307881556539499764/137807043129281275102003754741345557025659561561199536414579485637,-262234922054215844838953756679059054688744143734742038125089491804/475243260834226803700981625844396024911115892625244913164619029317,-190263776893029775350276277199642485660769323724429337220233021163/7776390595109143703792278343380323066143085697758103033735439993,4841703913469882145758605863452921943156944031593031093968294873/178388945159400659530031490525759945279114834248713645611358007,-129385263531293842012129488164446651821502323715496941636595865103/40254657920131065782081662838281164739007867123999469822585426953,-187388293529293604443963099110851922676434725831587936154490343672/59296296482330318683818438504187695004795090410529594922386214327,-180996195058072027139348154293886592191897756808787871802643834849/1641167515722805796605479630327269166283359335117831705438944147400,-575331405979470512487534901965879608856216921821462642318749298329/3532957481420951357862438524911428002652721814880476489929362966956,38941631776181995801515472517579919458182929358423355533130658092/33777592045054700033169417492591623948163757312197004052285115979,442419141905989462209137813678970674514123564291771689675311136104/163055398014793721914382753433284239626526527529109946390725256669,1181330197076979199813117453760931876146323257973070910310886259308/437762876373148168218194827246786646689216448345646327263367656249,85644989639923199092794297209769218472571810404996121652818535704/148138574282267406972298325792332343727631720368725083189616743309,-583585471610209183956610402948827383495863354585282642492205083507/526951012400929502546820363104541930694754898396413733428688268240,-9974062088947623384425672602185513335266056068965731366864028083583/9353691144833786110958445017224181342222747127880871227279133762320,-28516208426382218810220199799336064499918986487755495340441216050011/9069298113333835586065693485742730337333844703024140091543088805776,-771921267315743756487345859582010117782373854137903723795758579/118589469712256092326151320304344344254150163912166901810405934,-504915399427543494582574234729642475169123284791656386417084783432/524981816354283626024462035755507390892743988613059609776779555003,-10927242012409171148842069300934691809956621068920016949573993583087/7538355105858393737437394211846376371378666298037220843562878893648,-58867849180734716700255677516956953872456547563072116039182983465/42721304645458208039666994288013553370455988199817975658811966349,-2528465314533958769225724477754466134533161090961079208835455226975/1624621303683283290517433740729519205548727108306606788674134678179,-26827228879510929662698105325892528401310156643017724613864939012/22190416672887541109891621218380920629435558888781377177229826053,-28491762499711459462065997830773484196058390371698004161278438352/4567448182423311864510403113133798139299926971860176017481149857,-708401900389756028961092711175050549410076123775757827916367490281/109230219791917190758854893010656055507878414463342319966640067296,-4846716479761773196495580952674485108158212191060607174816607036424/1554138208401135339123762902686840747121647154045065770406843435759,-1220206083918218393672965641257205955814707476024189064181260887353/352456543961289530713254888588493844498197677733497856055711165168,-469386237560126890256186803056459351862786735257155753191175097323/1988122415011390265499172224378732954160098754794386617017269202720,-30123805570916442669922112585156900559579886896681149499839348978/127931616619185286585446566384430169957346140162152847901111060747,-2473533276853770310814128797970745479890084105833647503381359329273/11223289110421631012251988055650206315122354006669941254894443002800,-126883455269022323483446335454000426086726658747921649127951890660927/186672856090287133974692933432369771660566793199324757241630772688080,-12859189442288586564474758396492723878730899043447146965125553582979/12996096371137128176786301641954782238385080124040440414729587608364,-16812818144325949922871341939922488241502302202905752352080736735603/17194276407089531205515096400727356692523458302413566707674185084780,-7285520987980643804942131625800872981465468275034574702137305011966/7425445217870348094327163130296409192870668103034131216412943240505,-34074876029479393507408562617779693278338581239371129423497677369607/48855672461508709799257105541972651914574505344421818590688661784576,-697620960534605817485798211881385959850687660323515957496231350383/2900680083737126755231433268418647883157075274245308997866536631264,9222734998316674747894715550879722159272589596434895437583367001/161963360968431836802010890771943936934765911414016908454969069306,-1585465994585993546615735345670611366955969217444188021313926472/348894987144462706706526968809518887020464438344693273595902415623,-258721651539340173229779259889205691181409723798300848072687168967/1054946962044311240569043225133533950411583337989829020716130003840,-2676644530708485953888016734344738349425538429124884309043827622757/560558476168443538392957522004084755493373775109173088048406373952,-577312311647916049950671485253996214524898083342568994287384953707/137952957572467082701854863956149289424559862408853554609774659227,-19125841644369951968279039761487143541902403596032889835258065649/7772452692833670789103882557205506768092412799183690203697998664,-288224095166743044526937256945414509669869331475974529420750717698/437163417013314693333872447266457531616232126893210757388492500981,-261624394228058564644317791062515415382924822694746430763866321221/83006442499824936305259066680867226004122532048510409900142890112,-635311092895167943475220711150592565017799648667895375680804255872/988653992271931245227754576688089925725438108560275333079645494339,-200366694625662423429897079549236679524640511163807733129006860725/162404780894834625415606513112858379761321230443277865151588935016,-87552954243537618716512214722436292004707863573338460642529944962/153710117397953019323221344444221486041262050369908325231282691257,-1030978781559686758444135593211405203644304021008363454736736829514/1055008146660778261692342398965775282323495245900470242333864037975,-1842928181502681088301587574051052985196578785058592440469419652389/1592428384754173611181701941242124192197095832601603182497909019928,-226695463061314197121879732699525435260544008063746228925539731441/70574774405942708592206890707698590588874795316622388941241054759,-1480212615011687715316653794409563942911921501427040206208136995208/1734769102387013047689531145281025046772752448658389290038257046197,-104201405913130534750512848052800860479814114530228306183776085164/48460748707019692371420166227092256471008576417758150773991003381,-16238938999157208934149301705612741541055871037049288181665409139/5057220600318485653095143528769881692108678253765645359703856677,-541109325369410126856258463705352192513341976453244501225411983867/2460920687807307081861225860036345706627949756576835160129887040440,-11799508494353887799078579100518228248779397655667102211020738528/60538773950446430567975377786581712013768619718591240154710675183,35505089229649087152755863865736276487940401863989260217840343899/441096899369425472284464278116788279042947354204975445908916178864,-2822007149702541122332855249786676428626304774103357995859048581657/14798303946991254090603562365822735544966686813242284904950336432424,24214734473762252186745176619994540175824824092277810402242783168/402418232587154172451793640618243601613458248771701160515242877713,-11425060492950268075662498025590043228776590589582151100731582626/105509258826278223624488857074591266175016526562968756905585797089,3893209311127048119226502148713783920615375029024431826514075404/63470097919206942205021811762877658172784593163817039885020205687,-21246203496593147941578343724234496756822203562864290479529184154877/70711375887511501282913526567930303253499256817516144032027494766288,64219050229981058610325589572741206183371654331880196575526985887/658750636380457959447301028144384734873873624710597943242355607016,-3129077624931042029436388317975432208448116426917086402679911892296/3499722326979631132154766108172046322684185904243161596376535294237,-150661325965666271118708275490318635964063412652261709500403793036/145163001966735856117777574212130883466357208491784732470799668387,3800288647362307024998879797042053297420768445006808884885482405096/38340815593260964020107109551427848376197179479219669698502234478553,75134691013974332955854702962763144195088523174977674325451824464/553375227911579137010059732463016384994656216282843354947844213227,-34056436976914512037093942019163150509373677265447760637020645696168/33471542172149555583176933792310350853754721456767355439597364396235,-3877387992946029027305357479887520310966140111672463453613302529092/3396718018343913515818983476476156542365101994323902329138082211265,-6397170896277822760131415798838127893693039596857985992625405355384/51155310708064588450712403872200751670044308963107690007940162082563,-66828505423335034935815345653425322522612517526997363927764997817600/133193060062468157118019292743641598683255345593790954321095573841377,-53742724560691909741573876961848171799268814477143012541432191973408/105832924792712293620993791992282358917488220584255443038171130223763,-20364824992160584093095562041913821247826498652857464487918216601592/32287299762579402307528517539927531531658252495393411935041933850421,68827457171635993852672425752480960157645228393903141278397757768/991342834999244959957957432925855133779657128447716003399934197989,3798111690582883669611784892281471866517084531753528547821591912/18110946629691270077622265805758405700218791053451999324987203041,-2402006154406399106197498232923127987093730610428926472861153006328/10744691558668979230259562753491846512757708967038333837772544808791,-19285865360665125802018121445701021846498091982373818339906338857/82634399501488315486687009533193672040045656055490239905922765444,-144587037124382532623905159101767152373327518298038408745786363048/1030228856479141582852547563793408845937063187775791010630111249627,-4205518770856611681436109418329641975620625584481255654012405204/46805326806988201754658699913542855793053164713634606045916072331,5825925617082495298090784450330334335885881211789819958228354108/233525060362725744107185650932736812971924063028815401195921926089,105731395978190959183242947937504223529093980016055700791628111568/891154282558566027546402554064892057503201688734928821685078303019,673461966356248948335786225457913161109142491160772715064328108256/3168820026537127873203558760630860562046063281585696203343386717289,2888289150022217794646194664080401699239460317816545978169342066084/15110223789877169249493387109583257612233102031549180473037342795147},{1920789298024249307524679586114779727237744779394173135177302675/53822083579557422774652612413796211449942129145925359703869462059,-112199475883312638890184345406414995195980517759666900609979669430/2717212121600571431220572555198598635712684347893134971613128915157,-654970542543200386344406962552850678866867812146444930314151719926/8726011457487992717220082440211410125284871600331145994492277477003,-301321527851057529273343374306837168766075074772533382957399133438/3601308321472551687137074914777767697298558679588374521323657411589,-30920325122223642004886554451998897958846115087794554297491723/136026111384811731588420046833552519184078292554431552829941419,-62065709576594423407989947735104098539213511764742152244472727474/611073924557569869510231347409391962444578680605022610715360282283,-3033079753179371993465989901975305757077519459024508429884745898410/2903891701645797639027841751618425348089316611606464083930517677003,-86291555321522705387107332967143453995597435661693780399816582403/98544861419165339008684619769467213194427963768343213063728687725,-33719419233962397955949456655245808259286915314131296838795295888/13325212700458212094265010815753470526675274245535590565189557201,-117177810528330647600029493200811236175930886423479133544509857012/53903317496956616607059278251220107004101243959290743801672499591,-3240556591491785323596887369956548687582507316411400584642143564291/1337727499707328484126440532876695219263029201491161509166840724748,-378394035499863022750965332574543496851274069566382190792824715336/101241540015561674842940457771878501325436867963345124040466461101,-14874686470625011566222578047342385983500882404877662491454633949/12637305016373594128924431122926200710746831434657807245021729528,-150716822023738305016640814836439697389566146097935297609999288195/221878233699638723719363747729255903520632703018370452972633531864,-968843409750866300627100198073609195705830016163878305840034909918/454541894996366620912279566307989308686841094453896101107721441547,-71579411822404376679211995716443675950379492640071728626853333440/98057557914721568921705207724373213122491048688897640348941050713,-59390017015201187735119135712754417328519428452533379064225865160/106263943165269297082022235560005883185015625675000285511276304807,-1396581002842412222375848938347312341534081446219879011319958615100/1227298018203246961367613975268346121879450177284307232283906211931,-89260737759545797887785100768595866849192721930818912606730101302/438658573056983981691943145494676817997939872166948581867105315279,-37376108162932510289662103426413550266859289762498991616663404734592/28493719245338958984308782266910027825293358160569621407031572584109,-134962395908639384153262556992272063017562586081514342999341407240/80397096923550340340633364029382949269608100159829544422130628619,-532666819169943353901003675762971825141477507212341472328870040976/339595391993400434144576437973132228704909654279638269039772828497,-7339746079065313016620410398631265330631137812288633813841918108636/3696040733659904016883159931309194726622496336143641115068208697591,-668055130288578845901398815008694419873512344716494998650620578316/187156207987193687367030620788862830707070216879730243503855624095,-40986859988614845090664474716327737996564722013609793301643107446/177373217882008010412363878479714643734896062706717440999951076833,-14427132467459180783827667334843388409129445939830396106811498173130/200373375047299518441721193973256107519008578396539415575315846499,-3004065859069310996720619009031393079819956480250133790834239840/48329357514700365364043131079378865104880621038177782630130977,-209084466755379918862152292892820355736895269088778206165733568147/47742076512068834271862197786004779227467149271002356936688817051,-371834288091431478879062968888720456157572263578053304273207565995/1244416607042545611455002299143986970327029994272482373744093431,-612813978470711254673303760945462436877197516904757944797914375990/279594003131945258188157154554085617549379569265633728802798063251,-11417840484579852627263152243279827120051386539781038262002319682366/535606377326462265516516522731547102297930464898110766656709967939,-21808957905309461218253148784405004463993386270845907713069532220796/7943750797078767536821659607066168602065528081026337317264079614491,-5350962595108291349405712313862690102114827570102434589423980398582/2815006540480116342700459381568140544996940980620124609182119756073,-880289696903813457069843420849656253724781714203414989935242345977/238196315837520615199980942133377426750561523567012054261608752698,-831437693745839746944499778358273370118775920442747492794806022145/83123322584114587989638128429965440804760908657288331882849202567,-218440777962930765480510436207712640049264975328662015584884592987/57438854262097994080409884531535656600885741550452767000497754727,-2881587777129959768048605681153547659355172453045624609068027594291/241803820445404624928396803548090921968383930505120774788822430842,-295058861140931996441304791449310015065383450487560963442950201963/45880572280769768097956620988467861597631964405251147011353075692,-394188350078392748786235278609563775331278719265738017123599716221/24051189557317115437577853593959596226497947942155738046724617270,-3224238869914824331350678670375247786582797028621198178036072381982/994631045053627604399929800183477177954071853005165057174474151961,12250406201225554478918492292061988300223960878219213821552375839/7913999443651601159800809174346862563346441858632701376166766163,11999630505263447204131305983716229725763591277592667806462039334/8385324455816298083247113879798581811592253330241790924524741577,654394797503760055101991967013547232547311827696695688949866529017/688677736294274961598952876479350855204777355062811593885893102006,6886750446321638253541421708490949162114730607354847288659718720/3264992882051121630235994394058554734157512856505568270863615191,700466552836847262322934255241750969196727060826717674172626440/416627792389801152137272654874976687972684165311593179674882563,29535419780913697303306875651635719147143377560002698262518465112/286630604774214162366010085526307714771377529668461579775057229,-43607443082557924324282976169611209604958384891429842329815680192/5399512815335496791820562043289825591874262673908618165261648197,-237850913893884586761944776254514962079373548263419727037165480/38722848707738091185110397490763323322409810028371769166876057,-28565306944946308436880141263750235838294858275524534791099798168/8813403716030780307608992331329689982827538892743621711208833055,38863869741053741958524718386501402760360834789784657619927311266/95227814315263177982312701191122722986094234583330534758076348003,-3513880975323650072439326458787965980067524643597270084805862867064/5884088044253046018885960315755544973674194437630179633332755669413,743353476072111284722348454738922475507004424398009919719033193193/4249560483017067389544201744066276060055715840829778735987837466604,-336672727267901382763005834112355127256452025994887600646670224056/424849979777398654118101906847435088145339601451556614603828781077,-227967909336015495568975373913115138192256609787625054945103472227/414507077868099716410538800072873732882187060664723571560556138394,-205575823276691768301834998099538723300799082429867860525204640354/167839595133247708759668302413110023501755656610590582524854108013,1745062297820244728432815881734177672159857008232908101819871007/295345651583267134874146140442301134835727970968073512087884494,-4545995789850580285815440251565353731471004902463297151811765083/1966662553678028196545436070095618407516956232942958484012734845,-1395171727566774996703461362220996538984147814552688337887404423429/508024038206197243908108823545924953943552877111858007367790833956,-1363297599550409575901472231599713277695917972419286380830421883230/101758817772075637091898068085294977154533161876585941746649980811,-53509421982931532394777238030273209387789681152760557792201498155/34914169082423609009071540595403543823179766819497970432181476622,-3770423466921426898842101507131086321280089836204504860935486326804/2341307720041092907482392919020566408743519708890981397693769804123,-1002378960646700691051837195479210604109443210429044710787746259/1087799107842787697814697451800870444237164594753442893941878268,-3724050984404401726584945528322184742311793231169558397004629513264/3381661504430423794038520688101898578113725412356423763055915262027,2323197274194176035208179009126117778380322950124338015974113923/483363473321927317554194636035712003366300019676879426988031795,-32279564444259006449950498144481878723486573669316380627048017143/33150314070122260865003706927310251560374186817785294961052707513,-391077570004904467410496605784369626923614918323788257280667998956/325827269230159107782569548637203474954484562116419504281638758951,-34136864236080387808016857886416327036631197111709081398269876194/31739792607104028340576225765302643705326855678106122105130881053,-1114929615907536142568659289608328583235443090283542274006734697495/458667716723470545329712182922136530767208858381499599118955959678,3285835386506515885737692055234162921581693533459860026041923742/565408397713150774457692089532633206701640947913787605129592263,-20264253818200121551246270468545896037519975239970287610526199234/20239084403957930650576567571792289410783335982555991323377655481,-5477677777444304082528739726831722729393755499424210684622601797560/5022196846064239523238374895940873916922459909649592582354936819641,-154123347900804924910345640287316128473721925809135896767600555464/47818953722738133792359099844574081671344098583103981992501878355,-15525149620070027654579878797049962471925484938022757073344034461848/4642350095194457536963348875720711048209435706947245040853093364063,51004819631385601658393963586407332037284474090681218166460297122/6069680611077259303976572997262101733851169107673555818616098749,1753871568270261624033857134051628215057339955727979592642569058/141354278416493320587185293076135798943974970952683387144101457,11048999750096724768035020801540459038674735850712145882841567279/2016046736839909502309592048314383901071662336855197367538483402,1047971747122299492059715937201747863916071595805579032870408029092/59634207065050813807104797948538322466634636608210338295033493705,-14752963251439177021713812372314106974203071196148889569415337894/6029179691361920265873390289657664995913303105539419296824809761,-85636389601812512008545366275755758436500788124715197334011356514/57335026124267953701467850163607943389082613918780203728972985643,90896520324037389963747568870171434011452506768406387908079073287/104136020417614295778332752417326819846663488429921496249143743076,18560986453449116270396905191317923878312812639342847100988207109/9282885739891956356882207964425053970039699528495209199162257972,765736413775278253001904130125972292363945835416591027633996869561/666938475262424937659040900894580250021725857633177402840015630154,2614488058345002212556844674922884439461984853155108712758871703591/9570363120806857728491959815534374473717093956997020588256373668924,716512527996873235865118160335734649530372350286583243717442933255/31097435482368094012721279911095412388371904954278499942234511684,222411081326319722565134464290047640813577697018484802984658459956/30734275899813946413772110573171755895700796878746545521065411697,-4182286102110972165841785020198557892891992863988663012097322304984/149145890386799657841347161080384475789783145556907857936775091567,3248762003380524826965120820259396386486401737679131583274739367577/622123561675530642408543075445576182089112091833230869617241161406,-8836567039007438690979268822370087569909502843995329340692283643968/3598144090461457043588678679056973091694269892463540140058121766397,-3602148215672446554837532257901875772528205078197687716532863550/1524754587531868979402238151040194627058485668874662996852178237,-149550713511441306192089141072462115731028474371158626086304793006/61909728380582969222783659347394465883549735606408807954372620747,564590318698012227418511708922298347101131214030042909476754169780/37781889140614864466685374280688679599141148165778548402713141343,-1950158797847345123191336254023702465349372363685408376338399467/1388104106202176884005129002069304837635187421059693477884834647,-1743039625779977838688064875910305980971534222766319480285155699/2147065492592656894607710019708343074140586676567192551589954161,407147128584751074097070475359633125912845273950790544771405518/51473704138866236206234072870783142169951638986355000999785765109,270269744854457021207982646889030696131758696873632082889695607828/464079263610981969433069159292219299855855060878807619856500074839,30736821796797075766004717604213865257053908366910737924411347324/42224829137429842035666225554386894130682075432538911748760743495,2894333576571486354842106942485750620250364256587752834401594538/5450025866600855862302817850896486026404778483469586850039174701,7530464129442517103977835027935341848165494422491782563863511044/12802707511311096003349105922431031445129596808469122511995766217,11078410817020749124184627251327700606030538834821120740646795792/19367975841602197820010713823611784392273890810616938801465992275,150879457711411438646519086339536179202836816991094608629273804060/499530456093486296310616369439602733272796294509385023531387139119,267673139504537234663641790494576846633656058527632903840659127136/182538897554150931202536364475327045775735345277068865839029687417,144848478652932525844490412242686174587179624273471507617562360772/2358204712205364896200233759994384452534328122989549166479500992529,-62865058047291709024411187622112704119241706698406923846716488476/99193875315248383173670490154844813207083712822620930963404766761,-12185681113227589935878881393007372108845131812908773632398916451/180280360550870784534147542463839501111598581839428366924274151341,-1645022288028103825296568449226008116132185208131515825830655610/20784843915158005583672886943281264700375499329096307075978470443,194360673361509194963356262350987248191637186310091209487258883295/159920839563005567015370520060429427737879909526796249813036078954,153136511711970386998232330696208818442122406573456031416077356561/121255377442851742011243498484945920120735231574029395327722176086,1011981704174687402837694802657493948815225409233015921828693819878/794728299627891278910233365834490242518199398826692026434823503471,-6029340804103415152362997754871186715293723161237530820320542736/14178220925480806468929927482675526543974275638834118125695256689,-30389640211232917345707901777291317628517576377528112591696365702/152063029523763279675053734126455957510856821644227440866371237747,-1153478720523061361459332843279258121997783536943312925464687111214/3438787955383849496035276616481550750135677521597119969105437040147,28066888012621021089756262520608893589469602367239019096702908424/57640202296572633263606465956835802132710996190501232851972665817,-325654494519457525214342989747245107287225067631667884633186706118/616025067463104182220215491166649395559801421049167643473063762881,-56751524901361957248455692233478160005341609830140334016622946191/170043972437824916052899411489796857919995179550950894979299758812,-4708250068151334704534031367088646543156120247130683694105092750/14026998928182608313659979134158053007331620484983391915549610703,-165474766595953155163246408966237672849465599522553258132943338/1971288626988426829648873876464179419426454994652201552834641119,-60150860576742575245164312472220672569609506557131865171443807934/111036038412179146805672584505966998088917792457622040358571089271,1926406852439198080865172728922696768305806375467165106034965147/2443627073603778663147918185510562800064936202412992008126374794,683460469395452122874251586358416847792687255721765922794058267615/315257203916935759159780956619031721441676054224953613761282646626,111013649171169218417713486408587444821234330213503149867791088458/22535004457944845380722579075447033857794892685612675397562318061,-2330147785520164575300826441483890997945776143109591787561522441/40577430092622621997795781766229502548488122112021473671005728437,13835368245556839690154017235039826360420996960524221581332494921/53210619550671040359465419457279336110780474508035832497187053108,-4912917355135217151460380372425936512412133927194659428908344807476/1392430811133681992123011284919626734614030517999415983879422082051,-272640647327867228880126343149362492420473393719788951564353252/3097836544566088839940051822768117776197073276199455477197957089,-12998911785883186904335139961660855011645240088381224018369090451128/6507169763504117344877759368065626260856043599748183744980784634359,-410949919082978838087293368451352169692870125911201593192325288/978822159911012329153393397499021283268274617243629508909208325,-3091111051102178144409818467329931411948924969562178373177717400/42309573244589364296697391113046614068221296235277188023465721789,282225978657488890650823336161774160453884408438519935895942002083/138912893578004159073638899749005941376540910483875994255555754352,6211433246842707730045821102166964277327188816601319537464048793/7927639119988571966772860334862049727761465708426188285909543725,92669821864405596456054108458396800991730783257741484562047063781/7038140341002859076015927107202197382561707683245257267317956801,450373918058911750534293101047405390297947361834649569324602799363/605908374851800459318613594364432527074822499798941908616173952874,5833597588514123027220579494511262942268183627266442159806274799133/9366814928259875484467900455399735176215178175159538724744670908224,971127082722376828899485371611196962380928227995229154066800840063/37366402730571941389574124056937433326821761477182612703187589560,1177374978457636935401828806520755713649937830758413791172656190341/288089957590703386863802801114417385356480445741545130138014301696,691462181805569673565741103437756794721633273115047394633475719851/522182165430694999144227234552413213445859244171612724009960999170,274498241764623348183438286722834238944471747581796591632131132100/203507088696229796836464687002862637685811579985213351651486999259,1424800038818394545340797342267120222448239901723259175305598711073/1530956309608592273067035056393820796853176950611782258893744790704,-5309936931011564945344427675392881811942312515467449018534034254/39357599461886162972768380020935145510927155879278715931945971015,-1486207489398452683330405681785040583947298143847546508448883569524/4456922014437369509048763204645835359478798522585887982603576419635,-388641503734803911412682135108512052686550540269421412704914665952/2856202144939209514770077658854866025857288380146012115131857584953,2407386760486156696251863521595590689262699000002305116368292676/4995707979419744931806776300155981494869512396040745084475786027,628036247935569312402363899479974526964738887950861217459801177468/12254266292115210258578173625444581678635498025512186138422995754073,282077708141121959470438120418742311863259074186239784226640543144/1478970519812628174886498232268131710460694414021707934155847067301,21919288017453091291738637162534280555731730408558721609783240123/180484312383607657615344851137412732709105971496141208829750655634,-34888960259838839885852997444584928863254745004308487293767777538/532934542617647323130040697971921175474955131518148066716929837165,-10801962721456832622995145903576328322243171386612328701152470812/117890259897469842215068509313857035701566526836151107771068173265,-4549087613476557743550237057541835333913296133520993878362388036/13852463050313207185505533219764417135692446465393763002977053447,5061106724497830705500869825238257179278116144115285274072123432/35924189527770397338000690297863890641956482022938275401261724833,65432281503305112520627809846220991940467427627895371275514188312/2107070697560290595210998815851534970630591930588971673358792729,151416579702222566938830881039500110281168326817654172132185968697/514460137397092212941778839638538337047895036659042115721120453674,13627390998410868913618567131661901181884335546457012365271273197/17654024580730335214189477565983700473949542039887753798852767553,114079940980963234181053955862988318775564842736231657167099278767/250880670173539262305007380873097866302122347891294733961273381866,81479241516701256700570670538585956314126040560872206136644901617/192551656582944053102496776819628524295234781883545996425138681956,34998258138191965333121988236548012370810604838633196464294524314/83124812160610194606488502880796428475178024215991322978285731227,-965869060130945478098977728111166820440768394416326450822748013/59186013392340805645860363842649512123120013721326137015088159905,23199774188021989242702937498891835452511184838931316755716433920/88161519037872478625367537137994085592950290904532066927697141559,1084974651627643692993002279985113325424876927131713597510166651/16736395882306615625516195262635917676168981026438783391592153578,9061515890575970002761240694011979404571140120140501832553228909/30056062407055854140894036230506218177864345037167523233396667268,915725215316692086745427547067883153890514595837904301807858617/4639566342676422945227326335656292558287575287362347867253782362,2395807163565150112998142750263177374220328498430269020923408356136/21263276376978331781215736660990825252189626642020864162361038722343,-697777951489310360244788065134113566926256513772421701513203344/56895847882349384458249326201845641839498455610631142412639735535,268369260112794647711279623278475354316451487746444512086708179268/4760520935342512595296587109585435774465856175647862776680848290275,-41945817615312982638643709952285396631371486181984247011513964364/141092994036875026343165832405903089028116986109331944145460195369,-263334557127514748650607565486171116113724420075004491421946303032/1962416445217113937754526997299543183039833892030513597811775614847,6754752328641842479670633562752387029916077670924077896373876629/62741284053531497621350437622346073249486386226316529743946470025,175638970213362272474348962245421892729552617436962550711177850168/333969610280303498104846744013234206763238463177251232943590943351,1999446251543322311615751717605297691924913201541943420693211491/6769666896474837736033801303502037768105056321209296314893506890,100948988056067392602171735331345428841930868070775937086087113456/58348777293406756698446039576506267152670782769305503334671734019,18070722347137118928259966527174547073148686405476190782954345866/71399641587632954611722515060614713621114974535120281103119514607,92780829031465771105899569351970137187216628692184356985823790500/319442070580961760610088384933945040541539273876659294423851596643,41898932510025914875709422683216340453140834872601508752283209072/144053755415671113621298580870607958269445488659085887553794794751,-2958825425534754650665608775438026513365996934300032084722510114216/1791511971403006798479989510785574716511044294569839696332606017013,-1098961118157895257422377078306129510355214901439464246399533612604/940915170350302648935110462717454509455976564385630757599838402135,118956202608961605693518559267104999721018341198450358436298233160/1211463341832048087875806047023460496512048214394270756272709725183,27024492929038484704346522606860252606544599446340269948056135810/426556445981277890303243169110079750193552496021679705780698803557,35906431050657436245401573933058042536168987851002387110949735836/560939640899460684764296763724531249087100485482089813975935198273,-2688435461535172851277355848661189347970266548966624515965283580/25307988379105865783585109534697311795800916589220646798477291047,-25758190859064620346936780988384759637371258122501249173353584428/45277799293880092567108038580885469082048891328108605560452329303,-7004837906458701811952181810694761771019158341182331159187631094/79150555404679459152766908742395959432549753112539066931517262389,-11003166987462598260970608355014179757505889877408552098722028076164/2366139869822513673509058510558696219677465210139353419048225201825,5530378431370429147414892793573962063584418886291732106196072473/5105375186109718019740626193341639615470594741883614418828179485,311310055846210284596201327779120755988564187905827339809070444924/557110102384163947298959026129261208359238278325014290459413399447,1034143175095471798090610344677740966979701296598467274993186863536/987835708853246709228690670440697739636634073373446661013490603769,114599832001645276454974734272735238450956943093527868452647678475/31648830729344355282910116936301243769975013064182800651989197086,1408268309263464022934978994277466955415277260783968830430148729847/173701944993100184558368883509898533162016425834773158726845127398,255976810165848520797837145727599078489878036954761391474406266897/85842142244377564631110545597764269958316022398351810014775670420,205212196926731777596579474519533306649394336999167661250222764357/13222575799554245373635411872471310762879159756741647818382023516,10736560219460548645582479794589376427476244259541479711796571637/3517823537219870438581454238340356873257539452912875604549858511,4845141341923684635773659364830473828428795073442111928151134253955/1310940113853345466989836286976963658580831520857756256399898717517,704972869388253317550008659812301795252602479882510732108317937103/371706330973162928713791126704154742265586138392749576465512015055,1480078534676771539462561501179391536423502149524512474845935388487/643410353981788072483389589827614693764915924060309813524654153820,350919244777131282955610575137044687411331823211175060461506286508/186588330459901175585919887862974217672716758404570487569927909611,33596197623321259165936172928468745800915864744165199596766501800/61134732331948248649658096112795707272465739903621632722654189877,-165945060926169589850510796924105723258787961739554493374599821384/14458151603568769323296701461527438366476870412919641150260459337,28034585231162615416501861437162084440421032704365413028484768861/47462782437957304161562990464497674213174319211479332983182467723,3924604223470756815306110193759335303279704781753704425728195194/24486143986171062856707813935585982681305119619524961636835371671,-144290007501752281447258290082130143417519452456366605991754488/3387103477263762163448106401703010719874846899901939286667288553,705824226444882250534175826403208568549530360999679884781520913628/184334561712745202740186290417833697395114249782448513434321070893,30989800372539307967792076281708255910647134684286399708592571128/18268254254600305288598211219142845522537917019685950787247899357,-628832205791514023026782242799532038652739217034237991041301310/14284555229584179385540731602745585142692149940699455493452253017,93740420305329839075451042017583016112618727271346203756865328017/28550394730879747346746544769568205283113782507878453807393511507,666500194301188989711033741481881735040496819298842812381287307397/430353371769469147385725673668675017898786144570574922826836611612,2792765242650479800152394604916438797009417508687813257910225417/3587960015072806287405181483692898217074866030289628189139665236,836417729482969848410431380934927945852042817796887720651321229/772894404442059883372069133668657585365916590622128222654960838,-4338710788364713741229022728898658933199442748678064433257136529708/1868385390994557338692050899659692124640392245687479981891112512981,-7292905738856607988976212737009607917008730865529602847205547556668/2658542454294180040069395234342505056762062539877619920565006058531,-310009290386825753285243437303018286178454227998610980906259837396/117570517994403597825825939505849198555926000359383578600398228449,-1958876171992846441699877120954504031275556398254401351762412286006/356797900062913115076755956832223365281785342668391879251556474577,-776196935965548553520323328034457006763476002369624727395350074751/99057686268874275924479145054516559650554648780561600563602736194,-2817611746187921012943518942033077155031020854567629050484521033548/637435429984741384684784636308724381007416269626339123311270540429,-183104417755261882746486274236574580309407088448752908074287896236/105875882467177378232629392072783841965548680993590699644378731189,-3607242789140875376858075345648970768927674619544829588261381436124/1839860025371513444945399996217282995068741009917820697446292572521,-93233266629348236780494567824701515626105357190787551664942661012/76837018631705360927149193744056537449565890688104515979008817395,-308243320683485241557996436619354998294532081740181657720383650880/318668352959081445081627049016419295906478561935366831138967420883,20421318485969121199071441898252331329868640526662479747595106752/20242642671627400320083058146389960954406738106441848852425302047,-178168954855888647206644425550431430639495786945519834274000306/82022664448180961966777684223011455888302594912175263512657135,-39883379296300997525289856622812890132349887794447604266845457316/10709415480702699916352661399450603162286202508687393261325205363,17980774339972581259122323978228950653281766322194920198154014820/25403444160353347726137135520160097700879636730822055283741649429,33984840526842667733245686897982990821853190669367616189211557780/111637498546479731486207789734499237366648152406180107992872348157,844651197202038889280095235717096909430033040908658864848543926040/308317959727275901693939766464622712284876858826612688563724882847,123183056979787335167591765065074333841961540173079136032902802120/134737476699728966489513727949301301963437670583495920446479792039,192815674060260321167811456116285642903122642657575333250476865414/561891860160844938631186769436331131073905938771558186784082316161,-256292145375467827555482246606246822854969461608224652828157943/66696764974373397256101093983134115427305579557839377431516177473,621209835566669344586436546888500372956645500551801990350037038/25553272915137935145305536017703932493372299100357962066161562527,5055377981875884747048700288824157160094861064440877040055353820/5395756142139456313420424291721848567510545910102073052151340239,23918920635036202710638668035595043039891204595594178297401744515/10748921581187476616363629841841259484986326818207512107748568998,3137177738154330338801919668887603778584158025851105976878191118/92356691508455317417757679645446020668298957705592851941539410063,10404408184485122271616575943709112123124598789686913503668479626/130311711113157401172847438434042870462908631225169351812728791805,-9705227930724822657973521873742277655309258344906576056757032614/83700058745064284659147020765594323206598664621917813681324736869,1402501679631836817443667632736267560109309012296567966433884730617/21482337808057775833001562808225980458174513584414988847067455387,6689693750079797739707657422165471160374498170460141599379763617793/136706329223883759343610449799923088564662362003589076148800742400,4844794502330643709900902934345252483819465322026524035230211172043/300383942069036017836046979460106708753035363344983145756033064800,7818548959890832453930035722257892287284109821815472419167651708675/105801299244387602412157654787562598055130795353446707075466404489,162098007549642852329916359704221524640592930462182562488024016987/18824258917290569634670914319328173778845529433333954099303951134,141540800673948485757925548986379325435858345366452848370939868963/2062610523279371616312415973597443619469998240159124933350862511,19821673825811099262838057788844929576368223014389045065266123755/12227952615360233960134402929307172223234793690400729807623393364,3825837690016543361380634745687444590607204163964022596281762253504/2984354797110819806612553675348547997836619124151058160355902454967,27396520907085532435580516254599115725980440427187816144178133252/16023359541147975634116422656325092316016733376308570223779725247,1550552883921705319477670596824365159217120877490879831667525967964/38667775046935490629670153824669175847638191701333058006857800323,802060736662776353886980884878319193314669214152816902675727621404/576890769800529505176834719625187511522257528609978528890180877675,339654942944656583671583280291482543891133294702710820071897035786/25467665088110547486404531169668267584964116269873829495186918777,305991158299072217472024287873395212858906395233890124513817012062/284335064514149979522079529751948951158415851138145224445857275415,3343083448235446321760975173796658587005664333894459819215193104/3285828826234697748297483204230730396169946140734234348320829071,15126595990020027948257800636810181162523660084886003408759442629977/5779154781774498426383980523401319684840705256492799721457989286824,2772511662808727582450717755391979380631022325783929818731636978824/1010905445438899245789116168134163312857852481951393414200824885497,3929961413225482763115788167469245305623808408740178854166573577168/1442385447488472983736704164312704655809662537044560914294236624835,154085504375187580249098789923126910198743519803955098726093160383/59981894180247600085816845864776418732660275879071010865102172980,12338735678063608308963898966983555499442240589011034957104941443/691414287476182632929852793095175048175005730293684907285128347,1126126095744794769721303907544886985229977859585732937263271629553/86377225530779204213402041592913302935377381354312250460939431902,1481657128297755273674442411030998874054086395333179557342144418697/314331404349306967021567202625005374103140097050789117038105022412,775820936645810837268291162975375366634813581576839324403533754182/183020785499580803906908391036238404909426837133172741913164758479,1551321984727607724178798645086391699072934527255947019327008392042/46428282232277197400149386148472464478403127478815792437364428295,1932289037940419746557944136575855289158603298451171943827917061379/34543244353872920791092437014458719128401422051913054795535566424,4185768940352309211680095040472573493163997441947388279792246567394/689832504729870406074924335936008360092055817596643310762042709399,3442684140538939658031608714587493878217639805498411757371913359467/551228172517125100408015018965382228102638246244798145658317942548,1289218159499212467010551067048945281880202334371779679720045361202/475243260834226803700981625844396024911115892625244913164619029317,503337306120600116628542209572688118179334462811073390741593255983/15552781190218287407584556686760646132286171395516206067470879986,73253792761054301517911486175063172055892981342160344416058311/356777890318801319060062981051519890558229668497427291222716014,114011660717575149615248887575530788927920646865682955872276310303/40254657920131065782081662838281164739007867123999469822585426953,161247192864086267977311501250481846187307473232525406756619436477/59296296482330318683818438504187695004795090410529594922386214327,16967512087380901687025737835934102144883430000470236616708915797153/6564670062891223186421918521309076665133437340471326821755776589600,25708744704545121115836686415241266794511154227174112400400104048459/14131829925683805431449754099645712010610887259521905959717451867824,165888753422193553313994557896209289587228134419302491316920267547/33777592045054700033169417492591623948163757312197004052285115979,276319521299194548493823679878070910382735717905643008692856623768/54351799338264573971460917811094746542175509176369982130241752223,70358678044926496910132458400900071541980203754396911320546825970/437762876373148168218194827246786646689216448345646327263367656249,34557644645092798994586603415903918889830983880565823484638815226/148138574282267406972298325792332343727631720368725083189616743309,312982189679544519140299564693542648356237123509513895818994241867/658688765501161878183525453880677413368443622995517166785860335300,232286934380453463174111975946207358834577082551478309533615467743/467684557241689305547922250861209067111137356394043561363956688116,-707048274692842783390245444986649092287115617868481644096788458407/2267324528333458896516423371435682584333461175756035022885772201444,35361130056586170892612391222371757238850801217523045425167656065/11384589092376584863310526749217057048398415735568022573798969664,-2427543833271626713009657719107581787383634543911719156689973948482/3674872714479985382171234250288551736249207920291417268437456885021,-60414927464036661248130584386519581088858254467688165053474034027/1884588776464598434359348552961594092844666574509305210890719723412,-160508596341001757583830401463126956199345256864719623382648344976/213606523227291040198334971440067766852279940999089878294059831745,-1398588816575169949323401740023034425335253601990977348707783776380/1624621303683283290517433740729519205548727108306606788674134678179,-116239856307568832320590978460148510779035599895736503150283478487/155332916710212787769241348528666444406048912221469640240608782371,14188050574995238919394731816470904789925741618158932529312054535/4567448182423311864510403113133798139299926971860176017481149857,82276677282864607819907273200054178503551246517526132715920103245/27307554947979297689713723252664013876969603615835579991660016824,-598401373622060243095908983837630080481267310287229795397436130872/1554138208401135339123762902686840747121647154045065770406843435759,-26106079416442312719052977959216182438979114650756972250228614157/176228271980644765356627444294246922249098838866748928027855582584,3668815921798925094320793840209025540510026988222111188760974774543/1988122415011390265499172224378732954160098754794386617017269202720,236027763232279738171702356228386952801245162324079444668507047794/127931616619185286585446566384430169957346140162152847901111060747,85797286240269480193706067704593513086327845236972995650495171084/140291113880270387653149850695627578939029425083374265686180537535,60198549386283213040726810141989391121086174945914919459785947527/1296339278404771763713145371058123414309491619439755258622435921445,-377993042746938843588635477050660861044233889925326168064516587117/12996096371137128176786301641954782238385080124040440414729587608364,-465294590025674785740683803741904728132694319304039827494663724003/17194276407089531205515096400727356692523458302413566707674185084780,-11313622719265873541074674894646958485826725673980481445923340712/322845444255232525840311440447669964907420352305831792017954053935,135520020158793616273729658237908386132543612563864360826606664279/4580219293266441543680353644559936116991359876039545492877062042304,107772222091911860710899602886270443277230859617411723191750309767/181292505233570422201964579276165492697317204640331812366658539454,132079267895832826882698129662941466965922856532561431815845710247/161963360968431836802010890771943936934765911414016908454969069306,1015820613564893166664203371844570701138098838141336990287316656826/1744474935722313533532634844047594435102322191723466367979512078115,900502515215775861349966530768967107415783649305918896341007021667/1054946962044311240569043225133533950411583337989829020716130003840,224473881464062844657232960853218283423417772621893342387707657565/140139619042110884598239380501021188873343443777293272012101593488,424035158572441102285406977561396388015354793388717535526287989600/137952957572467082701854863956149289424559862408853554609774659227,18899508870336561148445895321112372233014773546973973413081930350/6800896106229461940465897237554818422080861199285728928235748831,738786004883089554656842879214500305441373629295489463360369319018/437163417013314693333872447266457531616232126893210757388492500981,1442510641611479011795223294029791607928035446888073843996270510513/664051539998599490442072533446937808032980256388083279201143120896,1674666949849735983629296339079465272591135134742447782339259518012/988653992271931245227754576688089925725438108560275333079645494339,598189713297263353437394724545657473563364455373624836703647812735/324809561789669250831213026225716759522642460886555730303177870032,266843226027921984230874752336617108637979298179788320092305735994/153710117397953019323221344444221486041262050369908325231282691257,1910197551616046565147798566614229726262660327476089575324498979429/844006517328622609353873919172620225858796196720376193867091230380,3950106067169700620126110942634028184066830166873535293367208159691/1592428384754173611181701941242124192197095832601603182497909019928,199743096113841134643495126610853760187941690334931015282627030227/70574774405942708592206890707698590588874795316622388941241054759,260859679333317571979190966814643499112321913357422348967895326922/578256367462337682563177048427008348924250816219463096679419015399,79790639341394665291160807093254541220669871856346364648461037158/48460748707019692371420166227092256471008576417758150773991003381,186030215596058693180396709467698765786950639593799951340960518423/65743867804140313490236865874008461997412817298953389676150136801,1178758217528610484918991547907577825069893906289719718037871913301/615230171951826770465306465009086426656987439144208790032471760110,112905459460520702186469149258401369187631453162931456826198254796/60538773950446430567975377786581712013768619718591240154710675183,83726871007866871712022566640106764548243631986271935711193086589/110274224842356368071116069529197069760736838551243861477229044716,244189556133533253820426095082539522563550126022874744943526153585/160851129858600587941343069193725386358333552317850922879894961222,528156457983197477502326564250086215722068937417473807590305367642/1207254697761462517355380921854730804840374746315103481545728633139,214193873483234337829308328023517985179916491447360802122396668646/316527776478834670873466571223773798525049579688906270716757391267,2163012150440637351894077776700664490138100362790144111931295764/63470097919206942205021811762877658172784593163817039885020205687,2259544558406219912117703495632241947484102897852111174535023766600/4419460992969468830182095410495643953343703551094759002001718422893,-1741979462279856319961526518792193831457017135833869316842557836/82343829547557244930912628518048091859234203088824742905294450877,-786835486981789894820480797634559138798327873297097060828291294942/1166574108993210377384922036057348774228061968081053865458845098079,-114355401553866771654880867444706043092007104833073846112866246991/145163001966735856117777574212130883466357208491784732470799668387,-2729483521936959030759392352774892007140230106763948997381468400204/38340815593260964020107109551427848376197179479219669698502234478553,-1780700380862799451536595342795535244863799717355508544253320656/50306838901052648819096339314819671363150565116622123177076746657,-30168330187197644898964335140757455739868867977318246596522277821464/33471542172149555583176933792310350853754721456767355439597364396235,-3169954449680486444984926558548351230324883097394289826558456124091/3396718018343913515818983476476156542365101994323902329138082211265,-12359681220853533634142369084817564347221854178666074728703237031492/51155310708064588450712403872200751670044308963107690007940162082563,-74850562517664013718055700463935470573343920663583704081545694801012/133193060062468157118019292743641598683255345593790954321095573841377,-60853559505568339047072106812186192817987752186417704053967143588572/105832924792712293620993791992282358917488220584255443038171130223763,-21495532219502022232620416561531924146382095895817072182435423167352/32287299762579402307528517539927531531658252495393411935041933850421,-100493183832169359595343506502353586019111724360013741254150847452/991342834999244959957957432925855133779657128447716003399934197989,610690563451805270209696027965109211302810245382519327670276722/18110946629691270077622265805758405700218791053451999324987203041,-1542137507872719587129006880509683757461611406401867261639889588918/10744691558668979230259562753491846512757708967038333837772544808791,-49452656274722247955626899183804650186612529583368088503287866093/330537598005953261946748038132774688160182624221960959623691061776,-160589523849322739350951019483127784081432422243625256317328732667/1030228856479141582852547563793408845937063187775791010630111249627,-723668920619177717456954041380236576857637120053118352309253827/7878124314047519107219781173566619291900037625067210918619536927,-280572959908274605072184041794045893669346004160852489148328850518/6305176629793595090894012575183893950241949701778015832289892004403,-13848975386459367815415433423657661149546935904612768420935517292/2673462847675698082639207662194676172509605066204786465055234909057,116037576082778798235242806780166659884576633549719867458161122460/3168820026537127873203558760630860562046063281585696203343386717289,438745330863324158208463175725958177435286335589517223253781463820/15110223789877169249493387109583257612233102031549180473037342795147}};
linealitydesired = map(QQ^5, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{59,60,61,62,69,70,74,75,76,78,79,81,82,83,84,85,86,87,88,89,90,93,95,96,98,99,101,102,124,125,126,130,131,134,135,136,153,155,159,161,168,169,171,189,190,191,192,193,195,197,198},{266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333},{0,1,5,6,13,14,15,16,17,32,40,41,43,44,45,46,47,217,218,219,220,221,222,223,224,225,226,227,228,237,238,239,240,241,242,264,265,311,313,316,317,324,325},{8,9,10,33,37,38,91,94,99,100,101,102,104,112,113,114,116,120,121,138,145,146,149,151,154,156,160,162,164,165,166,168,170,194,199,201,202,204,206,207,208,210,211,212,213,214,215,216,223,226,227,228,249,250,251,252,253,254,255,256,257},{56,57,59,60,64,65,69,70,71,72,77,78,88,89,91,92,93,94,96,97,98,99,102,104,108,109,110,114,115,116,120,123,125,126,138,139,141,142,143,144,145,146,147,149,151,152,153,154,155,156,157,158,159,160,161,162,163,168,169,170,171,172,174,175,176,177,178,194,195,196,199,204,205,206,212,213,215},{42,51,55,80,81,82,83,86,105,106,117,118,127,128,129,130,131,132,133,134,135,136,183,184,185,186,187,188,189,190,191,229,230,231,232,236,243,246,260,261,266,267,268,269,271,276,278,279,281,282,283,284,286,287,290,291,293,295,297,299,300,305,308,312},{55,61,62,63,64,65,66,67,68,69,70,79,80,81,82,100,101,102,127,128,129,130,131,137,160,161,162,163,164,165,166,167,168,169,170,209,210,212,213,214,266,268,269,271,272,273,275,276,277,278,292,293},{0,2,5,15,16,17,18,19,20,21,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,265,284,285,286,287,288,289,290,307,309,311,322,323,324,325,331,332},{11,12,13,14,15,17,20,22,23,25,26,28,30,31,32,33,34,35,36,37,38,39,46,47,48,58,71,72,77,87,88,89,91,92,103,104,108,109,115,116,122,123,124,125,171,172,176,177,178,179,196,199,205,206,208,215,216,217,218,222,223,224,226,228},{95,96,97,98,103,104,115,120,121,123,126,133,134,135,147,150,151,152,153,155,156,157,158,173,174,175,176,178,182,183,184,188,190,191,192,194,195,196,197,198,199,200,201,202,203,217,218,219,220,221,222,223,224,225,226,227,229,230,231,232,233,234,235,238,239,240,241,242},{19,21,22,23,25,28,29,30,31,50,51,52,53,54,57,58,60,62,65,67,70,72,82,85,86,87,89,122,124,127,131,136,137,138,139,141,159,161,162,163,171,172,179,180,185,186,187,189,193,204,205,209,210,211,212,268,271,273,277,282,283,284,285,286,318,319,321,322,323},{105,106,107,117,118,119,127,128,129,130,131,132,133,134,135,136,137,139,140,141,142,143,144,148,149,150,152,153,154,155,157,158,159,160,161,163,164,166,167,169,170,180,181,182,183,184,185,186},{103,106,107,109,110,111,113,114,115,118,119,120,121,132,133,140,142,143,146,147,148,150,156,157,158,173,174,178,181,182,184,200,203,221,229,230,234,235,236,237,239,241,243,244,245,246,247,248,260,261,262,263},{0,1,2,3,4,5,6,7,8,9,10,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,298,299,300,301,302,303,304,305,306,307,308,309,310,326,327,329,330,331,332,333},{2,3,5,6,7,8,10,11,12,13,14,16,18,24,33,37,41,43,49,73,74,75,84,90,91,92,93,94,95,96,97,194,195,196,197,198,199,200,201,202,203,216,224,225,226,227,228,233,234,235,240,242,247,248,249,250,254,257,262,263,264,265,280,288,289,294,296,298,306,307,309,310},{2,3,18,19,23,24,25,26,27,34,35,49,50,55,56,57,58,59,60,61,62,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,268,277,278,283,285,289,291,294,295,296,297,309,310,318,323,328,330,331},{40,41,42,43,44,45,49,50,51,52,53,73,74,76,83,84,85,86,90,187,188,189,190,191,192,193,197,198,219,220,225,231,232,233,238,240,279,280,283,284,285,288,289,290,296,297},{4,25,26,27,28,29,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,258,259,272,273,274,275,276,277,278,291,292,301,303,304,315,318,319,327,328,329},{17,20,21,22,31,32,39,40,42,45,46,48,51,53,54,103,105,106,107,108,109,110,122,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,218,219,221,222,229,232,236,237,238,239,281,282,286,287,311,312,313,316,320,321,322,324},{4,7,8,9,11,26,27,28,29,30,34,36,37,38,56,57,58,63,64,65,66,67,71,72,204,205,206,207,208,209,210,211,212,213,214,215,216,255,256,257,259,270,274,302,303,314,315,326,327},{0,1,40,41,42,229,230,231,232,233,234,235,236,237,238,239,240,241,242,260,261,262,263,264,265,279,280,281,287,288,290,305,306,307,308,311,313,317,325,332,333},{44,45,46,47,48,52,53,54,122,123,124,125,126,135,136,141,142,147,155,158,159,171,172,173,175,176,177,179,180,181,182,183,185,187,188,189,191,192,193,217,218,219,220},{1,6,9,10,14,32,33,36,38,39,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,202,203,207,208,221,222,223,227,228,235,236,237,241,242,245,246,248,253,254,255,261,263,264,267,270,281,299,302,308,312,313,314,316,317,320,326,333},{0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333},{111,112,113,121,140,143,144,145,146,148,149,150,151,152,154,156,157,164,165,166,167,200,201,202,203,244,245,247,248,249,252,253,254},{29,30,31,36,39,66,67,105,107,108,110,111,112,113,114,116,117,119,127,128,137,138,139,140,141,142,143,144,145,146,147,172,173,174,175,177,179,180,181,186,204,205,206,207,208,209,211,266,267,270,271,272,273,274,282,312,314,315,319,320,321},{3,4,7,11,12,24,27,34,35,55,56,59,61,63,64,68,69,71,73,74,75,76,77,78,79,80,90,91,92,93,94,95,96,97,98,99,100,101,102,213,214,215,216,250,251,256,257,258,259,269,275,276,291,294,295,298,304,310,328,329,330},{12,13,15,16,18,19,20,21,22,23,24,35,43,44,47,48,49,50,52,54,75,77,78,84,85,87,88,92,93,122,123,124,125,126,192,193,195,196,198,217,220,224,225},{63,66,68,100,111,112,117,118,119,128,129,132,137,138,139,140,144,145,148,154,160,162,163,164,165,167,207,209,210,211,214,243,244,245,246,251,252,253,255,256,258,259,266,267,270,272,274,292,293,299,300,301,302,303},{68,73,76,79,80,81,83,90,94,95,97,98,99,100,101,129,130,132,133,134,148,149,150,151,152,153,165,166,167,168,169,170,190,194,197,200,201,230,231,233,234,243,244,247,249,250,251,252,258,260,262,269,275,279,280,292,293,294,295,296,297,298,300,301,304,305,306}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 0, nvert: 1
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0},{0}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0},{0}};
linealitydesired = matrix {{1,0},{0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 0, nvert: 1
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{3},{4}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0},{0}};
linealitydesired = matrix {{1,0},{0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 5
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0,1,1},{0,0,1,1,1},{0,0,0,30,17},{0,0,0,30,18}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,0,0,0},{-1,0,1,0,0},{-2/5,2/5,2/5,-1,1},{13/30,-13/30,-13/30,1,-17/18}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2,3,4},{0,2,3,4},{0,1,3,4},{0,1,2,3},{0,1,2,4}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,0,5,5},{0,0,1,5},{0,3,4,7}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,-1,-1},{15,-1,5,-15/13},{-20,0,0,20/13}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2,3},{0,1,2},{0,2,3},{0,1,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 20
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-5893824803542749/9007199254740992,-8336256585135037/576460752303423488,6676055022820731/9007199254740992,-7774491979135649/18014398509481984,-8837125318412973/18014398509481984,2041186725311453/2251799813685248,447237842295375/1125899906842624,5929682463775873/9007199254740992,-1250347875345753/2251799813685248,6037951376718463/36893488147419103232,-7891351382266659/9007199254740992,5468648969921955/18014398509481984,6408225952981007/9007199254740992,4263440673641337/4503599627370496,-8376623249315085/72057594037927936,7143276462562655/9007199254740992,-2569051385835735/4503599627370496,-3561113318952163/9007199254740992,-8526728224895343/9007199254740992,-7363997880300083/36028797018963968},{-8114747938182745/18014398509481984,4241161366284735/4503599627370496,-5327353035212833/9007199254740992,6948856066649071/9007199254740992,-3922612757441565/4503599627370496,-5833386496543437/36028797018963968,-1354041004966145/2251799813685248,6606600509367423/9007199254740992,7143294476961165/9007199254740992,-1948268457799545/2251799813685248,-8412417859153425/18014398509481984,6464917265090347/18014398509481984,2536058014965619/9007199254740992,-356265129822491/1125899906842624,-2940801017077033/4503599627370496,-8709493304973293/18014398509481984,5754204207895009/9007199254740992,-7533837629447479/18014398509481984,-1199623832742679/4503599627370496,-1316451710676297/4503599627370496},{5470855733739367/9007199254740992,-3027022431943041/9007199254740992,1429960435684543/4503599627370496,-8421947475964941/18014398509481984,3863901130539387/144115188075855872,878199675537433/2251799813685248,-780559383816227/1125899906842624,-3047153522277387/18014398509481984,-1127953548272705/4503599627370496,-4516380843112973/9007199254740992,-4315565335728523/36028797018963968,7950114350204589/9007199254740992,724920788119785/1125899906842624,8744477266878707/144115188075855872,6740924871853375/9007199254740992,6675163310094511/18014398509481984,2324794156445669/4503599627370496,7366033507331655/9007199254740992,3266875140897539/18014398509481984,-4207379865479829/4503599627370496}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},{7049156336128381985657590708316/15794471156813001887650763849405,-111656999500010048066777502024796/308466946789187315271798556173347,77650168578180119957580702109735371/44633706066889118624941573902174208,4217919518352371119021549875291393563/794052333203099241805581390074613760,385711029548361351265888907770357/68407672307605878141710568131720,-54608146164793088346246963639269/104619497834299694159523469007496,-1283299537396392633404955502356487/1144193588295058163982451574964864,-530892914506354031847434226045695/108349217757100597600329594620384,-4925574073462061653444730027465353/662670909177883454331748851964384,21614929833024049899595318973633/12560901312182408739673700306756,-32360244881183466918081619497601/49149061581711255394792279137040,-155445303486043794584959433148139/41796018936163541604708298686336,-1109025757044122910427096330535451/354281461051321239789580395106112,-536515158949749525649997551576729/130808074615691395495533701051264,-33354846227773184371277963105263/246093972077108733020521301214688,-11569859543881930454070439656091/59781046882115435350615058088902,-9454230877931308327092725348273/43880544040252422802984021324618,-2645831034546530432522685612153/6721481125450579010140354287578,-749976185733024901628279990582/5376201954683022465928250315189,41449818924228293213031208925012/49507227436424874911951454349831,328265196254139506763963585032652/392195030268000236426678107769951,-1116002514116245985589544383782/6277742080129084145769799623743,232269470273208567903435155787513/122456594024782672088014754691364,518561844119686887575135702747/318844550869879479630077267566,1465335441644569842961532505350328793/1130176479451534450350414727752345600,607890765598884000670353466576619875/519716701068804336671837661348593664,3188594840349446773340736214692155/64946609631826179747635853684736,-37243997006312075977193526241499/18472551182208751177546322492989,364369608071737316782795756091395/525832544160743786129959226694292,29853783170469018142946610911963/52423985272604790131969888857817,88037216064962297837669856896863/64630916375103897215727962350272,20959285824131949589984119883048/36621818349216834000682182697419,-118282833755918112389744324167941/1112521997662388331161672761253369,128095431572231427510512089337805/121382162526016457789908522521901,-541033414936349619113137335460764/1979667209958184152318084616838845,197978118093653662858216689618692/534248873256585953930731510928145},{-24447342888890552829155640785524/15794471156813001887650763849405,-41907974631408368257361638551076/308466946789187315271798556173347,28862064287099089618870078032962461/89267412133778237249883147804348416,-43214790436456353799264065242922599/49628270825193702612848836879663360,-70915643279081553017505125782454/59856713269155143373996747115255,95594401473475451912671349431787/52309748917149847079761734503748,1505417549956348893449060445937951/572096794147529081991225787482432,-307673476609236595845505235592629/147748933305137178545903992664160,-4365495691763086558043025573236933/1325341818355766908663497703928768,-247276315622436685006846070060933/25121802624364817479347400613512,-283910328888985118411413907271821/98298123163422510789584558274080,500946488098331109618857095715735/62694028404245312407062448029504,78048273650641672884629044019357/88570365262830309947395098776528,-105334230975646998655378506943969/130808074615691395495533701051264,97907820417109929150323228823889/123046986038554366510260650607344,17609223315773469910741025921799/29890523441057717675307529044451,8288838132922896679304471405381/21940272020126211401492010662309,-199579882207640943452648424339/3360740562725289505070177143789,-4012743752639443177323324726838/5376201954683022465928250315189,-16057336166939009332390188785384/49507227436424874911951454349831,-126817530646323311029072823970600/392195030268000236426678107769951,-7556025911996101246007975063984/6277742080129084145769799623743,-4774870284273754870617358001322/4373449786599381146000526953263,-15101761003048231189154012042753/10203025627836143348162472562112,2961080117378738008235579232300721/3139379109587595695417818688200960,93169311027229134260161083912685873/86619450178134056111972943558098944,46764799411752367804162584056630841/714412705950087977223994390532096,-19495352085866093651410237467220/18472551182208751177546322492989,-275494928028814366873356591415595/131458136040185946532489806673573,-99216991019069294011321343744065/52423985272604790131969888857817,-116041781857805905443823820667337/64630916375103897215727962350272,-6855569028775964457268718518928/36621818349216834000682182697419,855450185877186377128897584029216/1112521997662388331161672761253369,40055830726427636701252193462048/121382162526016457789908522521901,12167061516588609743161182976432/1979667209958184152318084616838845,-158114729052040998304042201257808/534248873256585953930731510928145}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{18,19,21,22,23},{6,7,8,11,12,13},{2,3,4,30,31,33},{11,12,14,15},{3,4,19,20,22,24},{0,1,34,35},{2,5,26,32,33},{1,5,6,7,27,32,34},{12,13,15,16,17},{2,3,24,25,26},{14,15,16,20,24,25},{7,8,9,10,27,28,29},{0,1,27,29},{31,32,33,34,35},{4,9,22,23,28,30},{0,28,29,30,31,35},{8,10,13,17,18,21},{9,10,21,23},{16,17,18,19,20},{5,6,11,14,25,26}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 5
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,-1,-1,0,0},{0,1,-1,0,0},{0,0,0,1,-1}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,-1,-1,-1,-1},{0,0,-2,-2,2,2},{1,-1,-1,1,-1,1}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{2,3,4,5},{0,1,2,3},{0,1,4,5},{1,2,4},{0,3,5}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 42
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{33,34,19,9,9,1,1,1,1,1,4,10,4,9,1,1,1,1,1,1,1,1,1,9,4,4,4,10,34,19,10,35,20,20,10,4,4,10,4,10,4,4},{4,1,1,31,16,4,4,34,10,19,1,1,1,4,4,4,4,10,10,20,35,20,10,4,1,1,1,1,4,4,1,1,1,1,1,9,19,31,34,16,19,9},{1,4,31,1,25,33,9,1,1,25,10,4,34,1,34,19,9,16,1,1,1,25,31,1,35,20,10,4,1,1,19,4,4,31,34,16,1,1,1,25,25,31},{31,30,15,25,15,15,30,25,33,15,30,33,15,34,15,25,31,25,34,31,25,15,15,35,15,25,31,34,31,34,25,30,33,15,15,25,31,25,25,15,15,15}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,-1,1,1,-1,1,-1,0,0,1,0,-1,0,0},{0,-3,1,0,-3,4/3,-3,0,0,8/3,1,-2,1,1},{1,-6,0,0,-5,1,-6,1,0,5,0,-10/3,1,5/2},{0,-10,0,0,-15/2,0,-9,12/5,1,8,0,-5,0,9/2}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,9,12,13},{9,10,12,13},{8,9,10,13},{0,7,9,13},{7,8,9,13},{2,3,8,9},{2,3,5,9},{0,3,7,9},{0,3,5,9},{3,7,8,9},{2,5,9,10},{5,9,10,12},{2,8,9,10},{0,5,9,12},{2,3,6,8},{1,2,3,6},{1,2,3,5},{1,3,4,6},{0,1,3,5},{0,1,3,4},{0,3,4,7},{3,4,7,8},{3,4,6,8},{0,1,5,12},{2,6,8,10},{1,2,6,10},{1,2,5,10},{1,5,10,12},{0,11,12,13},{0,1,11,12},{1,6,10,11},{10,11,12,13},{1,10,11,12},{8,10,11,13},{6,8,10,11},{1,4,6,11},{0,1,4,11},{0,7,11,13},{0,4,7,11},{7,8,11,13},{4,7,8,11},{4,6,8,11}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-1,0,0,1},{0,-1,1,0}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,-1,-1},{1,-1,-1,1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{0,3},{1,2},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: -1, dim: -1, nvert: 0
-- Checking normal_fan + several booleans
TEST ///
verticesP = map(QQ^0, QQ^0, 0);
raysP = map(QQ^0, QQ^0, 0);
linealityP = map(QQ^0, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = map(QQ^0, QQ^0, 0);
linealitydesired = map(QQ^0, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0},{0,0,1}};
raysP = matrix {{1},{1}};
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,-1,0},{0,-1,1,1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,3},{2,3},{0,1},{1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(not isPure computed)
assert(not isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 100
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{8938870641194527/9007199254740992,7661775887661821/18014398509481984,-2029812884452529/2251799813685248,-5774821686989111/9007199254740992,3950156772762563/4503599627370496,-3112027874909659/4503599627370496,-6830051108479037/18014398509481984,-713509792563935/1125899906842624,8720464073665567/9007199254740992,-5281551427002475/9007199254740992,2091352321560733/2251799813685248,2792506488546977/4503599627370496,-4212959825418141/4503599627370496,8960073588240187/9007199254740992,-105265167365321/281474976710656,2032701943613487/2251799813685248,-4282044142982079/72057594037927936,-3210255886382237/18014398509481984,-2250419460399459/2251799813685248,8228761066349257/72057594037927936,-4509319198897257/9007199254740992,-6482688469219951/9007199254740992,7699245836561543/36028797018963968,3105988547809355/4503599627370496,6052819884787437/18014398509481984,2036050369936437/2251799813685248,-8682192484032173/9007199254740992,-6647060848419719/18014398509481984,4024218468634671/9007199254740992,-7352937039615261/36028797018963968,-8848771627049353/9007199254740992,8955209700642627/9007199254740992,7993285856232563/9007199254740992,-6082498606331809/9007199254740992,8503291492434507/9007199254740992,-1614725113997045/4503599627370496,-8490330132706935/36028797018963968,-4263183968462577/4503599627370496,6287781684546611/18014398509481984,8018866302116027/9007199254740992,-3232319020956725/4503599627370496,7009222316054345/9007199254740992,-1486764337784567/4503599627370496,-8147498114672983/9007199254740992,-8013876313728901/9007199254740992,8585266012851905/18014398509481984,-3831928275344833/4503599627370496,-5671959471499969/9007199254740992,5718706835632075/9007199254740992,-4570108786667503/36028797018963968,4349648577708463/9007199254740992,-8849357095000911/9007199254740992,-3523169591371641/36028797018963968,-6707418090625739/9007199254740992,-2486995800625045/18014398509481984,-1007176013465883/9007199254740992,-4431834767308347/4503599627370496,3840327488649879/9007199254740992,-7423634546565723/9007199254740992,6230189652511797/18014398509481984,-2444756539719937/4503599627370496,-4534485313615003/9007199254740992,6160203714302459/36028797018963968,-4191599252385523/4503599627370496,-1125134294905971/1125899906842624,111612709565123/1125899906842624,-2069575165562583/4503599627370496,-8197992473695061/72057594037927936,-4486994855544381/4503599627370496,1976699682247135/2251799813685248,-3284574287433105/9007199254740992,6284845337589565/18014398509481984,5520746610411377/9007199254740992,-2747736204651287/9007199254740992,4158831061496775/4503599627370496,4218999152518445/4503599627370496,4497010861115653/4503599627370496,-7618984917787961/18446744073709551616,-1350062074695363/2251799813685248,-8578997002170605/9007199254740992,-2715749838657851/72057594037927936,-2331202778715417/4503599627370496,1120326702303753/2251799813685248,7315322975527463/9007199254740992,-2702466021196959/4503599627370496,2610691667990403/4503599627370496,-7383390380295541/9007199254740992,9001470676014977/9007199254740992,-2494778020781141/4503599627370496,-5572213746952967/36028797018963968,-3678711312422061/9007199254740992,4717700753655689/18014398509481984,-2240203044644769/2251799813685248,3533668382822967/18014398509481984,-6010540091485683/18014398509481984,-9005650016469177/9007199254740992,-6977668295625137/144115188075855872,-4233649362106281/4503599627370496,-6550053312446159/18014398509481984,6961505777282429/72057594037927936},{-8858616495834785/72057594037927936,2037982414176579/2251799813685248,7799333834680225/18014398509481984,-6912385916866625/9007199254740992,-8652099431322083/18014398509481984,-6510817952492507/9007199254740992,-260459491999485/281474976710656,-3483804527748721/4503599627370496,2254583038254963/9007199254740992,-7296218705908157/9007199254740992,3339103871721307/9007199254740992,-55208079719563/70368744177664,-6366630706822613/18014398509481984,-3680773961051397/36028797018963968,-2088404715604619/2251799813685248,-3875509608938897/9007199254740992,8991283533657865/9007199254740992,8863021016270353/9007199254740992,2522109466199727/72057594037927936,-2237068539304119/2251799813685248,3898577046230289/4503599627370496,-781668395224467/1125899906842624,-8799132951956475/9007199254740992,407646697971161/562949953421312,-2120884676117215/2251799813685248,-7694580107347587/18014398509481984,-2397725448811307/9007199254740992,-4185803119665097/4503599627370496,8058245777257755/9007199254740992,4408812366013229/4503599627370496,3363828633675571/18014398509481984,-1932728787285303/18014398509481984,8303520820163607/18014398509481984,6643259810334219/9007199254740992,-5940914441246535/18014398509481984,-4204173302545141/4503599627370496,-8753529502129721/9007199254740992,5807103489118103/18014398509481984,-8440709472012567/9007199254740992,-4102112727789671/9007199254740992,6272010078651559/9007199254740992,-5656890427146787/9007199254740992,-8502219635723193/9007199254740992,-960072864963215/2251799813685248,-8223735049165111/18014398509481984,3959258547609479/4503599627370496,-4732328445245389/9007199254740992,6997035575462681/9007199254740992,3479440539709799/4503599627370496,4467219549580597/4503599627370496,-7887343178598299/9007199254740992,-209854231836583/1125899906842624,-4482013874356509/4503599627370496,-3005832995696263/4503599627370496,-1115118289334699/1125899906842624,-8950715108214511/9007199254740992,-1601561092286241/9007199254740992,-4073740050137237/4503599627370496,5100912045948645/9007199254740992,-8451383003129435/9007199254740992,-1891135792926723/2251799813685248,-7782553422468643/9007199254740992,2218639809628919/2251799813685248,3294175961838659/9007199254740992,-1327981826442291/36028797018963968,-4481414895606069/4503599627370496,3999908037846125/4503599627370496,-8948715509979959/9007199254740992,3091177109354859/36028797018963968,-4314178227043293/9007199254740992,8386963514059527/9007199254740992,-4220629455583553/4503599627370496,-3558478713170151/4503599627370496,-8577853087865253/9007199254740992,6912629111246503/18014398509481984,-98474020602223/281474976710656,3896377488172281/72057594037927936,-1,7208812844340151/9007199254740992,5488356721891329/18014398509481984,-4500402071635063/4503599627370496,-1926648927788353/2251799813685248,-7813285986325819/9007199254740992,-2627530626997141/4503599627370496,-3602650018315401/4503599627370496,3669699609567693/4503599627370496,-644872682442995/1125899906842624,80293101496519/2251799813685248,3749467366167679/4503599627370496,-2224706158326987/2251799813685248,-8221717436532049/9007199254740992,-8692838993551277/9007199254740992,-1825903404124075/18014398509481984,-2208051846904971/2251799813685248,4245525354323657/4503599627370496,2671376772249295/144115188075855872,-8996633810015181/9007199254740992,6143108050116961/18014398509481984,8390701501750245/9007199254740992,-4482531788313657/4503599627370496}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},{-2188461188525912/14140286817867423,130712475584800/1127701346693573,-355054787422635/1084520833466344,587593650582284/1392242788805315,-324376266760987/695445854458552,111941472337921/226603118850774,-3562617521227706/4741173514913545,1169981139995326/1858023076666481,1424209338960391/1409743776957277,-497323499651269/380518139715788,1039439801196365/696328559985517,131658231506549/74057192272480,-536829075582563/279457364077594,1392873292753147/586458743476186,63833629501/23888658893,17736976772436/6431140267885,1736155670749835/425175833620792,5905912464942611/928534156772736,1085547654181385/116445071965296,1789764463902089785/86293868776812544,309233723661887/13345066415824,-4858173430352927/454755475973368,140584365967997/15996785876416,-97389630847209/15035385871756,729529096438492/145295131178227,-1556047714452035/435432031172192,225792470917847/75633452142060,-269756610480238/100349206897069,-19095262420051/7475975381436,29969954320275/11991584607812,527371516365085/225972614902942,-12764443716279/6988344249368,127920243815831/75957711315231,392038347562601/268324465798735,123380615391443/90918669277355,151573149058781/118845490566680,66743346477631/55223138630817,-382139435581641/371249731682660,-958996504652273/1171098032702914,337986144834901/426342265924283,-1391233982488786/2402490257217065,89081200629388/181050709819797,556843072326598/1313952212883107,512545666391782/1571179809199999,-52629065245451/159373383613387,167164610968738/718891594118643,14312439615783/77272762406423,161048722674768/2323824981805859,-63554797941456/2372842160150159,73210515542544/7983304078018459,-73835014690864/1220081584169997,194285287924764/1377218780448407,-500872336157636/3636480157996283,-269774624878748/1062264044107879,-59069212712592/168002280499429,-168200438883032/445243873560357,-175964644640620/403660637000969,700039526078470/1240921841325667,280466170394125/426653014298571,112364810702894/120840585201605,258632719400633/257470790696771,149744687610069/133855988124706,-205269567415920/176887882564231,-271711172718517/211777268877470,-410692257219170/290121887995207,5677688050226/3551313486163,-96047368533005/59643872025044,427887000596471/219582007031703,93080397098493/37830236869912,-854576043692061/387147438367277,20906710270171/8164525724464,255921552424956/93873030632911,2500614685898213/702705657057872,-932425266850787/181585136975580,598222145702877/88486725478576,1749990728805119/222153562418936,72219208927413/7607223142004,7115010069861427/521696980834608,229204324592873965/4365729430777856,60569211628481/5956761107136,-16602451571586997/933794361137512,631909070915609/132297742653636,667559565565874/209300289082417,27327842538884/10124091962329,-9163348061021183/2890518327237440,-386661049607521/187367758897122,509321089058584/260136921676175,-1857500659109707/1158235752167144,64266366682577/50323222236238,-493270259986635/436533911881022,306100659473118/401829173152505,12970366926828/23742977235497,112067573127487/212065499253622,26787410583600/56439110530207,-95494326498764/234421367803889,130586374795234/361422877295737,696926638016032/2981008253830271,19455550390240/184683613519209,165588351099160/4965463584995701,-59591630269368/1326998240283673}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,96},{84,85},{40,56},{36,61},{7,91},{60,61},{30,68},{35,36},{0,2},{33,34},{2,94},{8,88},{42,43},{97,98},{29,68},{5,93},{21,80},{23,73},{48,50},{17,18},{31,66},{59,60},{16,81},{6,89},{15,82},{3,93},{43,45},{29,70},{12,85},{25,73},{52,53},{1,97},{4,6},{37,62},{95,96},{70,71},{24,72},{44,54},{13,14},{5,92},{37,38},{8,90},{26,71},{41,42},{41,57},{12,87},{57,58},{62,63},{9,89},{21,23},{11,86},{45,46},{76,77},{39,59},{74,75},{22,76},{46,51},{13,86},{38,40},{15,83},{33,65},{32,67},{80,84},{55,56},{47,49},{18,79},{31,69},{22,75},{50,52},{91,92},{28,69},{14,83},{10,88},{26,72},{4,94},{3,95},{0,99},{19,78},{63,64},{44,53},{20,78},{32,65},{10,11},{7,90},{34,35},{9,87},{39,58},{98,99},{64,66},{24,74},{30,67},{16,82},{47,51},{17,81},{25,27},{48,49},{20,77},{54,55},{27,28},{19,79}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 3, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{2,-2,5,0},{3,3,4,2},{4,-4,-3,0},{5,5,-2,-4}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,-1,1},{26/11,-13/2,26/5,0},{-1/11,-1/2,9/5,-1/2},{0,0,0,0}};
linealitydesired = matrix {{32/13},{-9},{-16/13},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,3},{1,2,3},{0,1,2},{0,2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,1/2},{0,0,11/2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,0,1},{-1/11,1,-1/11}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,1},{0,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 8
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{3/2,-1/2,1/2,1/2,1/2,1/2,1/2,1/2},{1/2,1/2,3/2,-1/2,1/2,1/2,1/2,1/2},{1/2,1/2,1/2,1/2,3/2,-1/2,1/2,1/2},{1/2,1/2,1/2,1/2,1/2,1/2,3/2,-1/2}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1},{-1,-1,-1,-1,1,1,1,1,1,1,1,1,-1,-1,-1,-1},{-1,-1,1,1,1,1,-1,-1,1,1,-1,-1,1,1,-1,-1},{1,-1,1,-1,1,-1,-1,1,-1,1,-1,1,-1,1,-1,1}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{8,9,10,11,12,13,14,15},{0,1,2,3,4,5,6,7},{0,1,2,3,12,13,14,15},{4,5,6,7,8,9,10,11},{0,1,6,7,10,11,14,15},{2,3,4,5,8,9,12,13},{1,3,5,6,8,10,12,14},{0,2,4,7,9,11,13,15}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{3/2,-1/2,1/2,1/2},{1/2,1/2,3/2,-1/2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,-1,-1},{1,-1,-1,1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{2,3},{0,1},{1,2},{0,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0},{0,0,1},{0,0,0}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1,0},{-1,0,1},{0,0,0}};
linealitydesired = matrix {{0},{0},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,2},{0,1}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 34
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-141107669636816/852499196892797,242204629003591/1107058290551282,44630442426268/257869071754123,59636831020547/819949493021808,190042602361641/732329581405274,77396499850483/592700394783092,129995915951581/386944372487040,6415357351317/86347832010262,152636081600261/792653602968322,124533588363182/845227810158513,-179333736783140/726690094215533,-175871070841811/946605133928333,-235983331587437/1051060227737314,-30781402590618/170840293363175,13428705700065/117005868283588,-250750931109671/839831780157461,199584473593991/648703017812436,84675642060140/796045561284077,-7840544963498/798611994829517,-144029025488557/539256313403543,-123147573126275/651924197036766,-104880674664035/661705399130448,39936676325872/931663354197177,-36516458869741/248134104104504,-114930606804473/619214483797836,32019259648079/730651758274049,-78205360464697/665649325096871,127994385490649/644260544936409,-97401627023455/390462501434113,223135133747833/898540741029911,-280144054234336/869997165696847,-242101447001546/506903457637433,39524632270770/563476664205757,-2675239748492/52224709301583},{-17212653813406/852499196892797,-20592069376333/553529145275641,-59967548241431/257869071754123,12012331978873/136658248836968,105411074365785/732329581405274,25205210974013/296350197391546,241987746737/16122682186960,-74261323897411/345391328041048,-58197415963312/396326801484161,37634649409996/845227810158513,176859170622062/726690094215533,170950390156010/946605133928333,-718811371226/525530113868657,25317875501163/683361173452700,12941859272209/468023473134352,30504945826574/839831780157461,-21058147025467/216234339270812,103587714824030/796045561284077,47283524903465/798611994829517,-95954628662133/539256313403543,26950725359311/325962098518383,-56713048958521/220568466376816,-2923878293687/931663354197177,31151225696801/248134104104504,-16863640757863/619214483797836,-153877127603299/730651758274049,201918514904464/665649325096871,-33438069709349/214753514978803,-2284358790857/390462501434113,-124227309021370/898540741029911,-155707328185941/869997165696847,137503900086458/506903457637433,9424707550377/563476664205757,-19076199383996/52224709301583},{36687461546604/852499196892797,141712696303345/1107058290551282,144293060365252/773607215262369,139848622502533/409974746510904,116243425674202/366164790702637,-135895991459319/296350197391546,15186640681011/128981457495680,34424519005823/172695664020524,59780189246667/396326801484161,-236987386080358/845227810158513,69269223394307/726690094215533,-222669213562825/946605133928333,-187585134227057/1051060227737314,62883127877829/341680586726350,-242932492938393/468023473134352,11582399709950/64602444627497,-17406994771836/54058584817703,-100325004149251/796045561284077,85915351715793/798611994829517,-39821943224486/539256313403543,107890743035485/325962098518383,25526499553279/165426349782612,-257414757684842/931663354197177,174971550708915/496268208209008,-105424492315163/619214483797836,-243463708308996/730651758274049,165234880889607/665649325096871,-28777686036253/214753514978803,278106977377713/780925002868226,29778400787664/128362963004273,-145967002618518/869997165696847,47775724887295/506903457637433,105950876817945/563476664205757,-3520718743567/44764036544214},{-209332956306847/852499196892797,-125100211857919/553529145275641,-210166785692498/773607215262369,12080446976163/273316497673936,-43648456549485/366164790702637,11595656960537/592700394783092,-14723104640533/193472186243520,23135793505241/86347832010262,138828518805721/792653602968322,-195118737654863/845227810158513,-121381178341474/726690094215533,233750289738925/946605133928333,-38296717266885/525530113868657,244150052984781/683361173452700,-5650805508839/58502934141794,-12345636517252/64602444627497,22440287478693/108117169635406,-156667595359458/796045561284077,-205625173411703/798611994829517,-105062021913097/539256313403543,-1275460892347/651924197036766,-21537510636667/165426349782612,-278919045887222/931663354197177,-106409434888547/496268208209008,-162141321164273/619214483797836,-176491005909273/730651758274049,-142759524570675/665649325096871,-42146662825256/214753514978803,-122436997511345/780925002868226,-228182104853282/898540741029911,180541496197356/869997165696847,67367763533538/506903457637433,281077018078255/563476664205757,-7069601768717/24103711985346}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,-1,1,1,-1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,-1,-1,1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},{-2616442788498099475124221988081114180248695610787616972181/1841908549163110414937091850269931734557593140838848118517,-165221548693795732867885983387887931014098178815538075723/91612771839146544721800172447830904448721306987087292811,26852387171580038533544763454248207863193626482754143121/41322573061808548478858702401175715780658228003588133185,79753403754030157556452615449790665458522182017960469897/116239402882697580550818964973091353812341631138036779273,161124345279465450863992184250090229218748220571811904902/178752420802239968578019317958815711233980955818560978383,104691732413517784774006860258690333763486568989867391143/77773413847666145236965071847167014061927576418126378355,34797567531251600067960609715084554063732458822847323861/30078457983805193084141835977252851300039093059977183367,7260068457410596058232435927685266986450937532904255875/6235438844567605674227633371319858669206174531191179217,459565999914181882016629651210099942759406784904944332915/1031089343590400297314220836359893780188647583553303341269,84159980188107363291409513290980571028030426213662342233/935719275599745042041985609539305226117932920673509948027,6268009765221899282827506740538485609920979806166359075/3541142131373380464457747317482743950045268034318790534,973631143212949081983516156188788552523656610183903417/802396027835625276813438196976262234798657393660641721,48934549539108083937879560226070817367099882078465939563/57924847483458264675806034450547294775221880289123227019,3731916533294288305391996670559843656925348682011942525807/193650996264455585435228154089800301466457240840671025110,2628687755451060653085989967342336206135006457027156271807/1839606586044365797718197556427732584851890456473381334519,390003005153628350964247228754280133586373387634068923729/50246434348340658353683896784711389177174030610981753513,310077529612529846084000324396868506023896222703190383847/22230999946073910205642799089066788634007582320164810510,584669860643403552050872356710339407986467341320751405757/3749770093938976458841283125065351669247365445460586789,-1230925187454407136999572989528370046044123229884855842349/1323213033339034631559627424611302971285692744215087229031,-4496694746075260645947264653215643637419111900032147869869/4330954250345134811306413485413578179222990975672859305071,-6226681448054132860570296995323199336820681015856806311/963023475217177970158179598926779011244207614149635749,50717195708537069842943763378344610949992417544338420037/142176621433947895306592285801548405685974595428457267361,73138361835429116917974752173975147329301417494563358917/234980180132739837839317854266304670399641539779695413409,654028552942987854785280501789793071908639360731161694427/2807320318499757283895884519584998421461159813636850467247,390938480859042511145937484613707001005540706007857668471/1170482953735114015482141226128124275948889873755126136171,84170960612231546457081252813167917523615039361676425739/77483197063152736220257219426708194386128085390590373485,-143312607032894813490956262483214142514205029688187696821/63016828262252050460733451404781885589614524452019171119,-8919407415988496454509908645101358218257840658214435963/1816330554187872460763181410161571874201917827696795377,1394814228389758567065559800769652991502074383364276979/250295146153033431122156675395672307331804596665129839,34992623145813703089157897969356943845127796799913990223/272917025652859463851048051644758585853404629534713243,43919727226904267740684661747699425230149841892436018502/14549856281392472782099537635935317753856923903335755507,-95733481728453832247236760295954704212640978909695151713/54056503164938613412698897455238337857040954379071180936,30278074210569211112632235442180418308273198113880581375/34625141876612374293719699155609926191960563288025414973,330705416733359940382824245359953079355118735544980971221/1238636713974857906637580511195898389899098564706004457261,444162987501906972797985619604800187717511604724830816067/1684827453400074917620183976891086357293302308189308430491,-7126765464702028510426888885486237828452438639584488255/6723513394094831094277439094066052976926072121698192237,9359100296583473479021273308740864264619654444334990735/18092856348580998975447153736185643746164260355394289471,11451398470374731669188248452730822760889784571774231427/475841303286404999614241112210796466031450008955896367,2432306916400936980621127142158272683319807803235377797903/114119584798717562229943267000483749086624037761228389057,-14105680950549208432608832968252334453319350748286679450/28041698960335031787010046710506860062807411009045291737,-20912561986415223161612037032729994271048759814965636738/347247562471605399573828567370080500687012432525250217,135871508277929831512625846018007958397864884030814066618/134455040870980152308793593850058018755590712025855063857,843827540796395680681805245042742353050068005944547434607/353572804629111997697062098471486335039970859812125761233,-29615931628159905502992866393550929251466206098237247215/6687671170419459329512173183173972887868715797779754579,-1175935360181629699986029956957737607433472349940065104153/76400521371069918706761639676768981954371351132668503918,20298660677508907828944922358758111731449353403328023429/41252470189306288962509282653856228255148020183336742177,-1378143640290455936926380523070715851661983625557908262569/231088771342377013621434674777521542755096042495430720018,-820024665406922176178019092565437530001395780870857887157/169803355848454667103832869295435591380123109822323831122,-907549776249171527996313349191301047697111267097332718793/53684768416620963922676447720723692489324984685503701160,-713262637177810585800681224151149341447123581672162723491/47844504908195737630917634137252526944144085384339918694,-254105712972440518268549775194027780800917178188683885837/10900991847674432228096165913402496051282866031125679847,-1482605268341277973588535343699459099582575106060733909673/269433586780196860941864532534192330717347654052391341033,293791054222106402842839522349244968013536444874350150313/136784109037209177575443890130121282069441992432838678337,-1224036014960607856536571902792486585093918965962532349/600688404334476448095899574104095912550476842640275220,-196623814350819242478630621139554789112426115504426387543/30646805095567217363666866629987291747247579418458934198,-53811201529522236322228025162054404302657269324253997489/7784366124249991524071138054606485956634914144070440125,253430624438562736581690067266226666572240769420851121599/543561401919766669386122248878489212330428522708109563447,333098822702004141071964097275724506674318548254067574851/358619758781991354347125375110709950980048905162865945162,563705221635791849387966733503269953354095287750697823/1031028437686632605618380165609367565806225821292666431,124472226920058682307223391698627300657316645637870063746/378833360560641448017688059038294701901354668868495710447,-70716405311147258058477028376919024429329569811757927043/156981266895604055121225604555184629654239989253598242901,-95716292447977725938044416840402192802673732387675842769/187421227946285820321475633382258247331452775827728031311,-41376724049028732007778530166058189182700981110300395711/127158892681719989242457127385819657279126218343244128289,-197025091724804382010124331626791462708961004530071367583/99369551582484466871975429582347151610177900494711408933,-221129728378132987854629053095176424336798776000989191983/464791792411790064976534044021584565385583277059755950083,-63558879582491881768253972698207781860073455562670062897/125873246638237976816431167560592266851308814047164322138,-30192241252201754565679236906899376520706929876527509719/61050899333550365638226235781475869615597670344174039829,9252280297808613791278862300957272379726063074705420806209/9890625382602861169357302131920194509684980336682157816975,498247008755970334375171416361660988494501375470256799179/829749750018885828592939798330511255749791126909142202725,-1266788533829027063347460914304828301507005836329645080437/9470247765760601154877440633127622547551530052188570237155,17777243298331260621749817375859443547576749032640581909/580825275531122161649245545588149313187538403385134817543,5283229654847697791133746431052177529499381996692835742324/8180204510033127303512236045146606217960203145050450372315,5853767695013559257745977584050901804012139239657274267281/11610702689066822030904660280838808280813328251279678237911,4844620851831656482687275990985921147146898721655813437/11991038345789184447658234887677048237851449432089395179,-182843341377075779664852413443777066779914802470695066785/1721708548623268660422519929728668768626125743172529447119,-4833922779056934971928897518142428206170044977863040111/18764676393645377006717105985274195792741458564955477932,13098683763631252836321324555870079865190777451141486906/1292394300803131962056261974024751355232975727844401358067,-345741078078671110359248744521957958502672851188149060013/3603248184555314006526444964537520713467075602250236809347,-127959236676173840261677688005436035933015959852509552797/275588320554986306238314468759726068616182784257190749542,-309591771252259919037883196213011307704318350476128220541/335816444542178288905578799807860147581666541092359790566,-28909415657552450907822454693285683699754149405410877143/261787589186945437826632067513357440387042281569443541985,14729803241870386860442504300575930563168957682464306535/70537135450126540595115823332979555267113659994041109251,64637120646643605084521033254294019998580555703546066871/115440595024605473270323730196260093439600616684820979378,684939686229082437664316665965004321274336479311326678833/623938218617996674099543768313960762176762643427339228471,362902573058854202892578185921705841769143610143525735813/468499856416653344992148311566754438743257775306498514947,-2097981426918627026077740478092861635444447676512322979/385783248359012461862179198147652662491073477261632368981,1477551374349420800527804703793190704303508165563965093/3835818787761208103268320150111326240463819606597589004,-1035278938800001462526247046371100065481600697935886015/206731908239612102144179340600612160861718810346814022569,-2301648450080325365667566134033995017495671479646829237/11638774567171364230812401053072531741975125816400438323,-128908264822478316483930589664284309907062303342537534404/83069903870038060546554272772814849953572058218419253129,-53324166223403668784121674171410413006592531666599038172/101334044368542812898627492678214975682716681624211614271,-35000655290532037727627706489225063876361004348826139581/75312833347987374832946443696343768409431699047414579987,416635774483870309362173010415735379687187331832723969761/477897479551275964401809221252552028591206497159106234843,-76442790361714686804928294010062681267812385716697105727/35159758004239945467332312098753012320507953725916157802,-2608632533613054903201007931584800132738873049912860547/7499090055247331946795790693922231488728422814878724326,-11364660265079599959475513188981182426440942749630828714721/2565947023554217731124062179600761423717408869670335471787,-659150145000108645576234273217500899518590173988646470527/6429439603099888572059130389979693647071385753355909645321,124393483938934175171762767196597245578124305721343646567/34602087696913680096702773322779297513077068656438025181,913641090137156144682721685461495787873395013504420917761/778346521989262419262835380486763290917243784608904610833,785886668314920722373017887720742709359066236099936247071/681577714069105883092053061651924164127538013420789909731,911407318688409075427077729573069482806932880367559903904/695973115656437202991091535920575021478461072266976222399,476809673132059115250164251462534129203631329376694594984/315452455652537150611975392975656407168394230710621941565,1225541371843059244705604512672153546865195871824423616174/327968626687718519121860494737990554301502669394503386391,-791267505515653408421743208837866084881435620627964092081/4275918516087753793118248869756677915006750558458650333699,-647957900641656442024788371884192629573887025694842176295/2702056659431570181358138470638177549452281379453477346203,-1112809702312470460200186085048306355018539943430267808094/5337867377393534682807408394460785606585989091966073535607,-269422584355850912779806296683568697187548112301125281235/232527036471176368681841866093664161520726051120235415338,-1538710826919508833345316394077412354113781443895784083106/994195136786083092323126055306526304474384002138998562421,-296807876105657212870026383165746546243127836111882915599/3658158692325459815546331757766629569813861177003260945495,550720796390896995854581132382470478685160774332757781704/1718265890242414743060188775065571827056444643368111955953,488077839721288781854394978790989072253588248896918317/645666684510335705891999638488631950502374196172986539262,-2348212662084379851592899206553116243131425181875776563902/295922987150630127611689954805360963126908326769270864387,-3236140756059988803951615651396558362796650576354029279013/22130287422291706148268542316699813831533346506114879103,19582714371881196731889308140451232391950414173892347459/135078170019699289631985539565033114491660591653374030019,-1063941974176402295732866547670604535247726777588250178867/166724519335523086391255632841086399311212318546717298911,-455689881955143876297708390061466662487795917656419482793/213667212672887086022740058768934564919847673581418415773,-496912358634428196510169667903739836268854673878550963461/84802589079435257940772566120968343043415985714337273795,-262962181289074179486241556585151180436385590412140393397/90879025725326488751803810885743416102755555991400661523,-7429550393745735007976410455690203281057282488415735784956/3509488090693313950898129413979420332879117822261774845347,-14405719494500896723500671515358836441715260887305164431861/5568566141529390353317573063447164781538848347574725561377,-4354622598190601585932112501308675328333484726326535327359/2115028745990147890119268083621021170569980199589004965209,322075465747080533750661312914347583976536082488626418839/613622898832922798411142680162988991837130107242052950524,274118384671137771000158846136929364990258001379706276311/725751245225436126422090185233146749144040596737770072080,-1159580644186707565358240580506371268768268009704405946143/968256041512246595246926023571793014521827578186057562409,-3800035992101096812948716698325255170334350574801119228563/3631411464446110531588923120796044043409094645403202579597,-1501231365648236079821721086086811344326311267457729317455/1142435889955967662549568397258926177035164615382110649529,-2731872027379765498410958020957161251805216147535910098673/2639714321142997167717451917070870182614578689181330210287,-5807462675684274752943140371467218434492794931801937387653/5574122837396033197143526898933214187129403007476704786087,-1696396604021625381456315710581895973142354183267466926207/109108300095690599261799469329978617782494631824171098513,80819281694618040173410767707199182756665506401876808623/108424784287004503115947893281942849345056330880832080093,1002813400346719346546139298561611094441980559936919328611/578698564098366768668032780524004751347810420637289863991,66977398738801356131986761390796821282751427302608782066/51838537794282671528592389839072480378939311433752283311,696482666962874046092214881915627578252867731740023580607/643668459094433942547526920364888351727221952375252410787,528715446670290035063216315456695532015186822071718597013/1011661682414034619572327223690927687709745390805442866225,-567666752290504741931988169835289789506438323149761158733/525360783208434516273158818560247135803839270766790267957,-224357629444708645906628667806963682170559746374296865433/217657748048371586798653840295269081413352876243039356739,-354219430324474759622085817194293592466728133514540226461/502629817715542445941233533010772812881892172866830045523,-1791351793502032443160074003363921511505065949856873214667/4235036479836644811143767147710308702656676689110466556853,1264360853864292570959249396467759415411468639634801910469/3495712614268372265210700414188351233397385210753176498829,-2629032187107416454683484136257497697356540996459319338703/2783293517986699141969154860335736057266269627917485152857,389526253138511149346320619357461904012928520214429950033/2447709385228470792734043414771192704958153173215477865993,63533028223321350743881130169677033746560468181143734015/2929190857606887771968806288737942758120772760402660633149,-374744575595487600558346760262007135773483598848419031843/623147475370012211788865678270399975566433112801260072563,-19413323407597773958372545400914201482442358925742077269/38533446526039835935613165734574138675739277642732870581,-21141249533346890425085091484791275954188910010321616937/85015755872360315729707095952094419713082088541887106159,75727179573771473683551193978582218099430479535032873209/1620261399307250012248247836337032326730120162658858366379,151458887439878013172624418442111372635488814904707932123/431050333330236443358429640276668039509679676735880085969,90775944730425549358259712610153347954005248819603083933/554403916579505713543181847276603771368883920923407483095,-733681893883016102673287914919037317777118148249068767081/1131922066373400548605205191594530801911111589977340484971,-936199002553961404692489635137319347674366829481446435829/961417566447146342848369443809516264911141632964566571137,1075630363697717299506751054224534888641236774603192110073/1768264487955292724491111337146253463821700134249582754459},{957826042905967566469828768742343536926267416474828700366/5525725647489331244811275550809795203672779422516544355551,187576085857994499261053807916509876450974558754618602991/274838315517439634165400517343492713346163920961261878433,-55078188441267171094498528464576105988080215032644775381/247935438370851290873152214407054294683949368021528799110,1810710840789856518795519738336883103265963730682206399/12915489209188620061202107219232372645815736793115197697,-37867725902105353683245495472067214106392744305636774151/238336561069653291437359090611754281645307941091414637844,-55059330586308547302111208557496519416924119228698767499/466640483085996871421790431083002084371565458508758270130,2496379823210667763489013117654202163481429780127077201/10026152661268397694713945325750950433346364353325727789,7329413785812309866366173613580936200275351572333845255/18706316533702817022682900113959576007618523593573537651,188879308074288572742354190934294915084881331684621587685/343696447863466765771406945453297926729549194517767780423,116045660326532130631024443606415835523130189326074169647/311906425199915014013995203179768408705977640224503316009,-48347971122328294872304009622918379195876164035948905/2360761420915586976305164878321829300030178689545860356,125088186229144087456092865116813578273629034102281747853/26479068918575634134843460500216653748355693990801176793,961916041668185064998380346874375927736349833999595516663/212391107439346970477955459652006747509146894393451832403,2365579269618524226899372233938717197229517301501300102441/387301992528911170870456308179600602932914481681342050220,808909384642975195413299902300273608778077302376294479365/167236962367669617974381596038884780441080950588489212229,11108870426977174084711396766515515327014840287335372907175/1356653727405197775549465213187207507783698826496507344851,439485534155996509912530956690869644599978573148472434083/133385999676443461233856794534400731804045493920988863060,973741304608634707317604496653952692524515958501511093591/11249310281816929376523849375196055007742096336381760367,-48885344982858097908453201084487292266473201837327166961/1323213033339034631559627424611302971285692744215087229031,-366795256566876258129723438605597398151954745550100505101/4330954250345134811306413485413578179222990975672859305071,-207358720252350801272239406157912171047519373838344253660/18297446029126381433005412379608801213639944668843079231,5498831178732515522048336187195919843266859226465038217/15797402381549766145176920644616489520663843936495251929,83299201284804778555969281070051572771485485163777946193/234980180132739837839317854266304670399641539779695413409,4784533204518188517835090003482062079597927314853019407/13966767753730135740775544873557206076921193102670897847,413587776170029534696983212650587980394891322635084404923/1170482953735114015482141226128124275948889873755126136171,-80184736859625906276872776130200448938126231532034331317/154966394126305472440514438853416388772256170781180746970,-135831883594201102770268043116591986349562245344799533697/63016828262252050460733451404781885589614524452019171119,-64463246694616923871829721457409125032815196198509028662/9081652770939362303815907050807859371009589138483976885,-64111199633714181126291524471160954986577838773001819295/6507673799978869209176073560287479990626919513293375814,-70377647025825163825448692987067055674986033981228399875/181944683768572975900698701096505723902269753023142162,-1319187601386293583418405891298267946200049319566531721905/189148131658102146167293989267159130800140010743364821591,-113236212417601691865135358967554057635804038328830534663/108113006329877226825397794910476675714081908758142361872,3884139921073415265383183957742879419895661255021308155/11541713958870791431239899718536642063986854429341804991,162660473475413225204468808758676108636193717733756914143/412878904658285968879193503731966129966366188235334819087,902590482648131221175598585048340658963702255492033512103/1684827453400074917620183976891086357293302308189308430491,-14539949595233772502134219478992807157572432582704904255/6723513394094831094277439094066052976926072121698192237,269091840192692090669503992868936200449707885784773412655/669435684897496962091544688238868818608077633149588710427,-3534580121738126906395183972667638399266689176787981565/317227535524269999742827408140530977354300005970597578,-5950508225165034159428610935610835764637956969565374332455/228239169597435124459886534000967498173248075522456778114,-16001761874818552827781552058936316505385717643267499585/9347232986778343929003348903502286687602470336348430579,-71285848633954765188352531013755318591062988372738577461/694495124943210799147657134740161001374024865050500434,-75869300302133447033852399519924731676496631654057732705/44818346956993384102931197950019339585196904008618354619,-262120254416371206506884843327852847648952612192400503770/117857601543037332565687366157162111679990286604041920411,10189650769440246156147256601432683602537040878847485909/6687671170419459329512173183173972887868715797779754579,493807091777054621312362705051068521397543603957315036519/76400521371069918706761639676768981954371351132668503918,512672127375152552615787146690285301062013344905731203729/151259057360789726195867369730806170268876074005568054649,655240574215745469900950921974080826651149231416377211015/231088771342377013621434674777521542755096042495430720018,430675544683732116745866197715157180602525580790087070107/169803355848454667103832869295435591380123109822323831122,339664586644061379632078188620244389765473176176340707181/53684768416620963922676447720723692489324984685503701160,271548935477501151620592535368295426773020196264301189363/47844504908195737630917634137252526944144085384339918694,-517202878497885526844074613683454284937211619884882719065/21801983695348864456192331826804992102565732062251359694,-2030377954965201567851761272268758107123124781458818903755/269433586780196860941864532534192330717347654052391341033,-512744437837326419980058348361502755089318410815330949855/45594703012403059191814630043373760689813997477612892779,-2444226478438208404770493638251502064558526940868050058/150172101083619112023974893526023978137619210660068805,-124579595479402635987675979250684787707524392132159849160/15323402547783608681833433314993645873623789709229467099,-89470670290164846634693407722811316875217162006612940087/7784366124249991524071138054606485956634914144070440125,674995597868464367268774111174524221133492842648613060329/543561401919766669386122248878489212330428522708109563447,545503822503467619049283729868001106162436045900032632814/537929638172987031520688062666064926470073357744298917743,1918773614992731747605106492274077140146057710567184871/2062056875373265211236760331218735131612451642585332862,411750775552334215838139288375815346264019990325589788974/378833360560641448017688059038294701901354668868495710447,-95461954847874481953257855788536266242465004432450083933/156981266895604055121225604555184629654239989253598242901,-110416253924761627665159334560460087562625161217548559209/187421227946285820321475633382258247331452775827728031311,-34525471600537314739826620518247391505727291948545320231/127158892681719989242457127385819657279126218343244128289,-307440539272780448150233738154809810508642472130102800655/99369551582484466871975429582347151610177900494711408933,-244766120398264886920366071135824747070402803144924191697/464791792411790064976534044021584565385583277059755950083,-24840108501831226827527838564544023983838232292941389767/62936623319118988408215583780296133425654407023582161069,-445741835360430788134431359257027957171278376632562817/61050899333550365638226235781475869615597670344174039829,-7678164344409086078082595464345801358655325129034498708867/9890625382602861169357302131920194509684980336682157816975,-238653231605395177302575880458948097188336974153589629191/829749750018885828592939798330511255749791126909142202725,3455217111519439672631753824895723484535646439172894329953/9470247765760601154877440633127622547551530052188570237155,-913859027284862908097619297045052457413649624849784908387/580825275531122161649245545588149313187538403385134817543,-5150811657791784787938353484168681965447901948192310391542/8180204510033127303512236045146606217960203145050450372315,-2900742247453559423037634255722545888064963799165453604717/11610702689066822030904660280838808280813328251279678237911,-34382843455865267465925132930076810228883200402226197273/155883498495259397819557053539801627092068842617162137327,351597057577965837969333789689136263564862388567961862811/1721708548623268660422519929728668768626125743172529447119,25522913395537669802787261184593736521532827337739123027/121970396558694950543661188904282272652819480672210606558,851845080943707502246952225258086266871425713220961514422/1292394300803131962056261974024751355232975727844401358067,2995682244826255803611494614787569522249975015972679390145/3603248184555314006526444964537520713467075602250236809347,-24521953320550915534824955141068674240792262510818271527/45931386759164384373052411459954344769363797376198458257,-347162462460589471213176815495297679808350432041831179925/167908222271089144452789399903930073790833270546179895283,-10285421554512125909842628273457847908104932181919219337/29087509909660604202959118612595271154115809063271504665,-5562006138279368877765175048750098358764555542026069393/70537135450126540595115823332979555267113659994041109251,-42298113717531196125226833045379709064405337890846202463/115440595024605473270323730196260093439600616684820979378,-78664281811029075103286400220202685942729926087724829967/623938218617996674099543768313960762176762643427339228471,-195088291416473283570889329053676659682878064034990168990/468499856416653344992148311566754438743257775306498514947,-134095992419217640762289955902041975062174829835728811493/385783248359012461862179198147652662491073477261632368981,-2720412127398087313250069642148886872524902908623516467/3835818787761208103268320150111326240463819606597589004,-9308060420603026998395866683245141718019133744118697969/22970212026623566904908815622290240095746534482979335841,-5488843720077085189025952748616493293553809300116565131/11638774567171364230812401053072531741975125816400438323,59428725569704848406316635314544388947572773271622539668/83069903870038060546554272772814849953572058218419253129,-118663164335936747404745543451856583267964569066317874687/202668088737085625797254985356429951365433363248423228542,-45652713116490121464004749118214626289292021852025397591/75312833347987374832946443696343768409431699047414579987,-1890516746502500067264889405403948567350791011594019289095/477897479551275964401809221252552028591206497159106234843,-286285659607131027851109594156513188766294882999331973721/70319516008479890934664624197506024641015907451832315604,5229278833617000849982460982382088728069412960721497199/14998180110494663893591581387844462977456845629757448652,-506900766635273132138162459328620815980533252671877362308/2565947023554217731124062179600761423717408869670335471787,247793477064415049188183388031441542172121765320527821993/584494509372717142914466399089063058824671432123264513211,-120128202012508457204481013532937936333854811066415050721/207612526181482080580216639936675785078462411938628151086,-4033576903529261486343066154977290538752710065657970777133/4670079131935574515577012282920579745503462707653427664998,-1447953222853382739813387659423232551095751636588401721079/1363155428138211766184106123303848328255076026841579819462,-2562636645909985094863035698660297900220391333824344547170/695973115656437202991091535920575021478461072266976222399,-30597847779149667366744616813537818821224235523051837742/45064636521791021515996484710808058166913461530088848795,-4927201955382716157504101469833754042875928522002501365045/327968626687718519121860494737990554301502669394503386391,4134542900270747002978668693502078907964772644563995667059/4275918516087753793118248869756677915006750558458650333699,2583794462432938783964242075238687380389294570060672961829/2702056659431570181358138470638177549452281379453477346203,5304830855258527951724848071236654571382237453551922787158/5337867377393534682807408394460785606585989091966073535607,254932437342661382255295999353524732686908143625862211933/232527036471176368681841866093664161520726051120235415338,1288580282738498322827179150750633313844056203371472088442/994195136786083092323126055306526304474384002138998562421,710574396512392149499274183964726647777604304830164776585/731631738465091963109266351553325913962772235400652189099,1882580359378488037947365069238664627348903043279716951876/1718265890242414743060188775065571827056444643368111955953,1034161183155326580167736373684634486868486054764225728173/645666684510335705891999638488631950502374196172986539262,1190980989084832099176443201844391775914903192582422757254/295922987150630127611689954805360963126908326769270864387,508004261209972028276235158976752407181753357160381146317/7376762474097235382756180772233271277177782168704959701,906947253972429479350783460829870389683933375994352972049/945547190137895027423898776955231801441624141573618210133,419668443951145250619473348089575941808044446773970563553/166724519335523086391255632841086399311212318546717298911,158089319074498420385576649529482563856255984690759652499/213667212672887086022740058768934564919847673581418415773,-392680575333526578752217775386275207680680556826952542411/84802589079435257940772566120968343043415985714337273795,1714877541846135597774352691771401847308867892090523129/90879025725326488751803810885743416102755555991400661523,1415121520635568123006491529546330125464187251756595880259/7018976181386627901796258827958840665758235644523549690694,1458892257096551677102093723989010450066955622641684853922/5568566141529390353317573063447164781538848347574725561377,774862240736590875209236930608430607819741925322300645327/2115028745990147890119268083621021170569980199589004965209,-2649548979597187587427043427072722687526472800909741348605/1227245797665845596822285360325977983674260214484105901048,-1523506178855722887011137088192063939003728764096445202113/1451502490450872252844180370466293498288081193475540144160,930916044635565844871400280158608700502867158167790826645/2904768124536739785740778070715379043565482734558172687227,-211789077212410899032511539738713488890678204373778318825/3631411464446110531588923120796044043409094645403202579597,102736003642038279481897776282615377934766773262881333671/1142435889955967662549568397258926177035164615382110649529,-51682314853813530070607359081864437578744781377337946315/879904773714332389239150639023623394204859563060443403429,-349799760171748392921229622671074841400625869335378445205/5574122837396033197143526898933214187129403007476704786087,-2921523287825210293617400420288421529478579883957537866045/109108300095690599261799469329978617782494631824171098513,-1058735919529058994836390011104892999237280856755985466945/108424784287004503115947893281942849345056330880832080093,-1180984507852192184889139966201915870030086293351164986515/192899521366122256222677593508001583782603473545763287997,-686720739211671662523592040829325793795162822950524731075/103677075588565343057184779678144960757878622867504566622,-3710756162363943646815791922345960152164352751518091194945/1287336918188867885095053840729776703454443904750504821574,-2191908975493420365873433814541422570599071236836029390667/2023323364828069239144654447381855375419490781610885732450,-1117592654604380126595115643788878398857819256762836142240/525360783208434516273158818560247135803839270766790267957,-21418347673813923223642654888361938951886901477098697257/217657748048371586798653840295269081413352876243039356739,7812190959973983384753469566304206939977615293100132323/502629817715542445941233533010772812881892172866830045523,370119206207588353207618733932142147263114454885660217379/4235036479836644811143767147710308702656676689110466556853,-2342559530841174007185838914160246049817378233097114066253/3495712614268372265210700414188351233397385210753176498829,807404352648729598230267433157526306684284707097223558635/2783293517986699141969154860335736057266269627917485152857,-1396084952412703023064838804342670511248512363641440548905/2447709385228470792734043414771192704958153173215477865993,682398718040971005387698774930841944365274792180995422707/2929190857606887771968806288737942758120772760402660633149,203727723466859721005034989964039369650365412381541755969/623147475370012211788865678270399975566433112801260072563,114611306705981449011317949426158597985940183436353356671/346801018734358523420518491611167248081653498784595835229,28242893319553028657386521611958126673544445235287757507/85015755872360315729707095952094419713082088541887106159,514407039125616595169071251550422604283890088426658438053/1620261399307250012248247836337032326730120162658858366379,7933478265342130461797355828067008792935251173610778599/47894481481137382595381071141852004389964408526208898441,-1276778347261458920513815970229408677521563402372685442327/4989635249215551421888636625489433942319955288310667347855,-23426375605225618539295862526740549187705878228068546959/377307355457800182868401730531510267303703863325780161657,203771970734271679747860257824882010660577535442318314067/961417566447146342848369443809516264911141632964566571137,-336586468215888890670274644929709081165401920929744397691/1768264487955292724491111337146253463821700134249582754459},{-3108127158509915663968868765479398450103776319937291439401/5525725647489331244811275550809795203672779422516544355551,-358391819292130613796068287046424627575532192733385197061/274838315517439634165400517343492713346163920961261878433,-16885863808032730848495927398975976499718111357564084039/24793543837085129087315221440705429468394936802152879911,15247073294548111089996865001582504785697611585832137278/64577446045943100306010536096161863229078683965575988485,-84594220754837162846188720346299988779069909320163069597/595841402674133228593397726529385704113269852728536594610,-261338330997343215837607971360054172380993220896519044816/1166601207714992178554476077707505210928913646271895675325,10966775291511851187411114110939822312413471554862264277/50130763306341988473569726628754752166731821766628638945,5316065881445249266115600118812300231704300162108547015/18706316533702817022682900113959576007618523593573537651,158583250618310613868014216672044570179295881212901826777/343696447863466765771406945453297926729549194517767780423,402497756829732988061628772519582660064543026108386579271/935719275599745042041985609539305226117932920673509948027,-566857271711242081884493497176439907446903986013050503/2360761420915586976305164878321829300030178689545860356,-28210121631289540190549642438693113493644734067874749673/8826356306191878044947820166738884582785231330267058931,-2174131137724179487187396246287864646962410245727271143947/637173322318040911433866378956020242527440683180355497209,-492148089173085295998145000038445706673266421852350432175/25820132835260744724697087211973373528860965445422803348,-5036878560527552667307831268388075645079698924482361943795/613202195348121932572732518809244194950630152157793778173,-414322380591191681157284033960864823833073369874175184877/150739303045021975061051690354134167531522091832945260539,-137194038527370337395497335972023676618361196209934107879/26677199935288692246771358906880146360809098784197772612,-2365454977525604690941648437467682864563497744930575885157/56246551409084646882619246875980275038710481681908801835,2870412022094298005930071661660923683269039948818144865555/1323213033339034631559627424611302971285692744215087229031,543017100041954637139797175811345854563369612263986696155/227944960544480779542442815021767272590683735561729437109,1239051855941530694300533446282713720198932529301875356168/18297446029126381433005412379608801213639944668843079231,114949346560915095332895357551546297489437935602339852797/78987011907748830725884603223082447603319219682476259645,116096421426136416644449517578768936373530395364981126987/78326726710913279279772618088768223466547179926565137803,3882110182751898812149628191872065042651370717246031289371/2807320318499757283895884519584998421461159813636850467247,1829090953761518536877173872948889451666931424487223641771/1170482953735114015482141226128124275948889873755126136171,-79839748440731938644483621832340192026247262276269505618/387415985315763681101286097133540971930640426952951867425,1378486571154111210720438169172186310095204594326104547663/63016828262252050460733451404781885589614524452019171119,441196706957109795179562508211002585229338414605814152554/9081652770939362303815907050807859371009589138483976885,-847587384676311157164547180457486993441267411833496143/6507673799978869209176073560287479990626919513293375814,57195468039918264412575029648330679707208393011659074981/181944683768572975900698701096505723902269753023142162,-184909745663688973909171218975745388766927373139834803751/567444394974306438501881967801477392400420032230094464773,1186417038539711000859579232851845730978624151513262129883/108113006329877226825397794910476675714081908758142361872,10140927163374467380985162099327644694045112460825641931/11541713958870791431239899718536642063986854429341804991,1687341521185908219283887130600660418747980586846547298493/1238636713974857906637580511195898389899098564706004457261,417237842713053798242903105857629580779933463751007561781/561609151133358305873394658963695452431100769396436143497,152271959448905008654104965205449644058816132127686721045/6723513394094831094277439094066052976926072121698192237,1518365693061863619525559036916775409042801108437626446515/669435684897496962091544688238868818608077633149588710427,-222327313297555421224071815018629895810661831489163811/317227535524269999742827408140530977354300005970597578,24952850105524462670991461421869821384036935868197832153/228239169597435124459886534000967498173248075522456778114,128104265192517867328414490963177936045866410684785749825/9347232986778343929003348903502286687602470336348430579,472245938331701109919580306156298538862252237192572399111/694495124943210799147657134740161001374024865050500434,187466540621283311209138356074828220252322795160664197593/44818346956993384102931197950019339585196904008618354619,265389077211170940739756738739597673690268863872348834972/117857601543037332565687366157162111679990286604041920411,10238845467963681531050395006304308600735788807924279233/6687671170419459329512173183173972887868715797779754579,156764245766492315092223056614207623369453125909089526879/38200260685534959353380819838384490977185675566334251959,-973141460196776955632192617008504222206696005058804568401/453777172082369178587602109192418510806628222016704163947,154158663157330367290079791554714592625135680933260929113/115544385671188506810717337388760771377548021247715360009,78906001853398322945638899538025298311375480465053488041/84901677924227333551916434647717795690061554911161915561,30603336332038976909457072921726571040766611805827176247/13421192104155240980669111930180923122331246171375925290,52053041522796159835442833992226641784159871857012911569/23922252454097868815458817068626263472072042692169959347,-126797456880821827889473382119007030030537096166758896466/10900991847674432228096165913402496051282866031125679847,-914257313501796835203070284706322669381383295601207129599/269433586780196860941864532534192330717347654052391341033,-471189330018234663600275875383073186981566353241240347231/136784109037209177575443890130121282069441992432838678337,-561059162416277981961095018221810589082038222033574047/300344202167238224047949787052047956275238421320137610,-48416413252719607171626575249599293426489972121913552052/15323402547783608681833433314993645873623789709229467099,-18415370720161282202729898687120802816898550736615696819/7784366124249991524071138054606485956634914144070440125,1564685747829765013484900966097262433127322504727863736113/543561401919766669386122248878489212330428522708109563447,202063887134449330415143268827741964764426412036155785749/537929638172987031520688062666064926470073357744298917743,2281888699403503164757943708961380176762148093249117111/2062056875373265211236760331218735131612451642585332862,148156429306328625381866596888764520784722308622011374489/378833360560641448017688059038294701901354668868495710447,1152822336127208881262904704495614089378279398174589248939/156981266895604055121225604555184629654239989253598242901,1373517097277733687681811341035206908348289506839720253439/187421227946285820321475633382258247331452775827728031311,410786835263654664320853284754759392239153828189014826481/127158892681719989242457127385819657279126218343244128289,-51458843187855908459410804174581164957924522496026337519/99369551582484466871975429582347151610177900494711408933,352936785693977713046740837315776584990468020844055169387/464791792411790064976534044021584565385583277059755950083,51301586964312000608930542648605026384277566147074635418/62936623319118988408215583780296133425654407023582161069,126806966241558862547870546052627690524216224890423288803/61050899333550365638226235781475869615597670344174039829,-4675279992502562518773407964986379035846990386856309692501/9890625382602861169357302131920194509684980336682157816975,58820958796747873692366781609301382815713880190054474283/829749750018885828592939798330511255749791126909142202725,-15258653963563466165044869347633037197157715538183249797643/9470247765760601154877440633127622547551530052188570237155,-385673610234949237338480142307185731019924719551643457625/580825275531122161649245545588149313187538403385134817543,-3267517763352706790449570835002603317745023460313212049416/8180204510033127303512236045146606217960203145050450372315,922632418025760380854852469683224788859311200945640017561/11610702689066822030904660280838808280813328251279678237911,31445391592831185769272855848134495290896571927823745285/155883498495259397819557053539801627092068842617162137327,1176236961161665633927133429308430209750373792891074881187/1721708548623268660422519929728668768626125743172529447119,1354967124466806877225483848915653946946769569779692417/1705879672149579727883373271388563253885587142268679812,375309285093695861366628749656332170779177538395288167797/1292394300803131962056261974024751355232975727844401358067,306507718382855641674748663893425250675520792709154192275/1201082728185104668842148321512506904489025200750078936449,34408824686195367793109400932427171192922795441859195958/45931386759164384373052411459954344769363797376198458257,-33511664169580974451653813371126039855671223905471393694/167908222271089144452789399903930073790833270546179895283,180264728706226754339457083278431147938005367608387413995/52357517837389087565326413502671488077408456313888708397,126875921219524273852311795260208567365815516634119227371/70537135450126540595115823332979555267113659994041109251,132158757145163401247063714105633933043728737364822622619/115440595024605473270323730196260093439600616684820979378,68561059066537371885959079360918335624790966180960263353/623938218617996674099543768313960762176762643427339228471,31467683777439435966648159853632385272476281437215538454/42590896037877576817468028324250403522114343209681683177,1280396033690592573124607592494230050900378423392398573635/385783248359012461862179198147652662491073477261632368981,134468009125478360886924817201128780566511527308912618343/49865644240895705342488161951447241126029654885768657052,238617624094122304899784441468735793200027900055077377157/68910636079870700714726446866870720287239603448938007523,58483907180848659186075791573487044528345935689674422445/11638774567171364230812401053072531741975125816400438323,255046551792909583465442895205814554590345251774859916343/83069903870038060546554272772814849953572058218419253129,1500702043186077238823859652211886664379020885205096824927/202668088737085625797254985356429951365433363248423228542,565042909480277676726325610287855624481101057136632371433/75312833347987374832946443696343768409431699047414579987,-732028170001499899482392542596335106218855697791687561877/477897479551275964401809221252552028591206497159106234843,-34559373843597170901261822002791711176722486663585676708/17579879002119972733666156049376506160253976862958078901,-6854999334096893025726873450329919727924671487902853074/3749545027623665973397895346961115744364211407439362163,-3934346441141975453564770363279298012058156160987758810129/2565947023554217731124062179600761423717408869670335471787,-3847202399671424954832541912270102646454981787237690891947/2143146534366629524019710129993231215690461917785303215107,-10986035474482606576794295694457475750388564591906477903/12212501540087181210600978819804457945791906584625185358,-1427201084030823074767983454931699494457454302398096174024/2335039565967787257788506141460289872751731353826713832499,-399787311451610629736072470076588503612755076166010977425/681577714069105883092053061651924164127538013420789909731,-1027700333322278789973490030984253736040693217039992687044/695973115656437202991091535920575021478461072266976222399,-4603478760014105454812401405982729444242718946881039452/3004309101452734767733098980720537211127564102005923253,-1465382883616514455117305725787484919008154409085240278383/327968626687718519121860494737990554301502669394503386391,827755962804532716493926056214747935058552071649470301688/4275918516087753793118248869756677915006750558458650333699,757415480267177808131061133318641511441180948316297077755/2702056659431570181358138470638177549452281379453477346203,782683126346900604627484163958938605844612790117588429269/5337867377393534682807408394460785606585989091966073535607,9314157715766085614419392325772276885999074760566822456/10569410748689834940083721186075643705487547778192518879,1423723854109342285131308874342277662357613550409679461907/994195136786083092323126055306526304474384002138998562421,189671936016599837080722165215566944874326538318298648059/731631738465091963109266351553325913962772235400652189099,667434640597674447763173706345828758721881407710385766611/1718265890242414743060188775065571827056444643368111955953,504511163968613549317276283680385465814857167394135461978/322833342255167852945999819244315975251187098086493269631,1677386253187307808794545640795652002863176806839091133629/295922987150630127611689954805360963126908326769270864387,2307971535226508615569511302144782729385535214498719105951/22130287422291706148268542316699813831533346506114879103,1400196198251578439571161865679846729016318196868581858973/945547190137895027423898776955231801441624141573618210133,571907338558509481172536275439103827341974414148423570709/166724519335523086391255632841086399311212318546717298911,171941785153254594209339886438740799292056388129196531215/213667212672887086022740058768934564919847673581418415773,-210502992359126442169557534477563595448945853115864908531/84802589079435257940772566120968343043415985714337273795,-408063851775317768118107841637749858939145405806272224404/454395128626632443759019054428717080513777779957003307615,-2456373380597859357065144172032571564468830071743872216492/3509488090693313950898129413979420332879117822261774845347,-3128087462284039821698542057992418810818651889740182626327/5568566141529390353317573063447164781538848347574725561377,520364665246711555031299350525017756624575792535449870567/2115028745990147890119268083621021170569980199589004965209,-399156076351045708044678024007728536449671946949956915333/613622898832922798411142680162988991837130107242052950524,-81367909248768358617356994177778224147269373121083522077/181437811306359031605522546308286687286010149184442518020,1031042526632784935167129568515627853649671478375918662677/2904768124536739785740778070715379043565482734558172687227,8166339172721562670461318598068796525283990777006266668109/3631411464446110531588923120796044043409094645403202579597,1934429580612463486090400159779452608538099641060157607783/1142435889955967662549568397258926177035164615382110649529,5914983497617293682708166616315176519070866181945602123479/2639714321142997167717451917070870182614578689181330210287,12595736461783922317172688168054189665155599426100521467129/5574122837396033197143526898933214187129403007476704786087,-283587163104062772965766949491486792849662237097791256841/109108300095690599261799469329978617782494631824171098513,57041303509595530238398382419976918665036430154201561599/108424784287004503115947893281942849345056330880832080093,195307198077271584091673525465968021476827987442531394853/578698564098366768668032780524004751347810420637289863991,54561766786470124677686556853967888068851713930937986947/34559025196188447685728259892714986919292874289168188874,-228290245201333995527332014397400553615192381646079054124/643668459094433942547526920364888351727221952375252410787,-328168371692130534088630676879334329965343592671521911756/1011661682414034619572327223690927687709745390805442866225,1941397644166100935526827394494867228999725121342997205256/525360783208434516273158818560247135803839270766790267957,501511258359526641734434979743238052298514592002155629805/217657748048371586798653840295269081413352876243039356739,259523673041475751531828898634994040910646129721984891149/167543272571847481980411177670257604293964057622276681841,1289350512830777197690026804105020875742088462185105662831/1411678826612214937047922382570102900885558896370155518951,-290682239925786095594749270296491937119939195720462002717/1165237538089457421736900138062783744465795070251058832943,813769057584890556423734282811956832802502247589577467759/2783293517986699141969154860335736057266269627917485152857,-962156757517766428874428434242407988292374871169945512379/2447709385228470792734043414771192704958153173215477865993,608929556410107574024716632079846294684896321479443619459/976396952535629257322935429579314252706924253467553544383,163918814482738939184299384461380888809813169263376788945/623147475370012211788865678270399975566433112801260072563,8207086941937570683309659998664893503073281164464855279/38533446526039835935613165734574138675739277642732870581,8976379442898740807683137806908568516012539502001062992/28338585290786771909902365317364806571027362847295702053,221966277105853444269345791323461243289681085323562866069/540087133102416670749415945445677442243373387552952788793,42572897182735322666063721010336799408647045166918600431/143683444443412147786143213425556013169893225578626695323,-3680772135488957299422044375053676081520275598795339489/8529291024300087900664336111947750328752060321898576663,-170849761061793756822883983550255235019552212493423425010/377307355457800182868401730531510267303703863325780161657,-50311118271567282249726550740148595491940928214523167651/320472522149048780949456481269838754970380544321522190379,-90647531879309397854811049447664429259931104541260717251/589421495985097574830370445715417821273900044749860918153}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{80,85,87,88},{18,19,126,127,135,136},{3,4,5,6,10,20,21,24,25,26,27,28,29,32,35,36,37,38,39,40,41,42},{30,50,51,52,53,54,55,102,116,121,128,129,130,132},{0,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,148,149},{0,1,11,12,43,44,45,46,47,48,49,115,118,119,120,123,139,142,143,149},{137,138,139,140,141,142,143,144,145,146,147,148,149,150},{2,5,10,13,16,25,28,30,37,38,97,98,99,100,101,102,121,122,132,133},{2,4,5,25,122,133,138,140,147,150},{9,18,23,33,34,112,113,114,115,123,124,125,126,136,137,139,141,142,144,145},{44,46,49,65,66,75,89,106,107,111},{1,12,14,45,47,48,69,94,95,96,105,117,118,119},{77,103,104,108},{67,69,70,71,92,93,94,96,98,99,100,101},{8,9,11,15,34,43,44,45,46,47,103,104,105,106,107,108,109,110,111,112,113,114,115,142,143,144},{62,64,65,66,73,74,75,78,80,81,82,85,86,87},{0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,143,144,145,146,147,148,149,150},{43,114,115,120,123,125},{26,27,31,35,39,40,60,61,90,91},{57,58,59,68,72,73,74,76,81,82,83,84},{51,52,53,54,55,63,70,79,92,93},{37,38,42,67,68,83,84,97,98,99},{18,19,22,23,24,26,31,33,35,36,56,89,90,91,107,110,111,112,113,124,126,127},{20,29,39,40,41,53,55,60,61,62,63,64,78,79,80,86,87,88,128,129,131,134},{56,58,59,60,61,62,66,74,75,76,77,80,81,85,88,89,90,91,104,106,107,108,109,110},{7,8,15,17,21,22,24,32,33,34,36,56,57,58,59,109,110,113},{19,20,27,31,40,43,44,48,49,50,54,55,61,62,63,64,65,66,89,90,95,111,112,114,116,117,119,120,124,125,127,128,134,135},{3,6,7,8,9,21,22,23,32,33,34,141,145,146},{28,29,30,38,41,42,52,53,67,68,70,71,72,73,78,79,82,84,86,92,99,100,102,129,130,131},{3,4,18,19,20,21,22,23,24,25,26,27,28,29,30,31,130,131,132,133,134,135,136,137,138,141,146,150},{11,12,13,14,15,16,17,45,57,59,67,68,69,71,72,76,77,83,96,97,98,101,103,105,108,109},{46,47,48,49,50,51,54,63,64,65,69,70,71,72,73,74,75,76,77,78,79,93,94,95,103,104,105,106},{0,1,2,13,14,50,51,52,92,93,94,95,96,100,101,102,116,117,118,121,122,140,147,148},{6,7,10,16,17,32,35,36,37,39,41,42,56,57,58,60,81,82,83,84,85,86,87,88,91,97}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 40
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-70553834818408/321583120292975,-65041243453808/704784466955939,253774218055484/861277886511155,141712696303345/687155318502663,77526447775018/205060441795105,-258224033970472/760312662001261,190042602361641/645032668306304,58758250451871/534718127350102,-4140004316292/16617751384265,-59762842142214/113557570177715,45376458276352/273431998497845,-93875015566524/256948456535459,6415357351317/63212038505021,802849150513/60165594224876,138828518805721/642065767772423,-118493693040179/395318490729174,-1634970773405/7370603268746,-80877491656797/256911354362174,125274940162378/638534508150441,264271870111863/1051153529088350,15318686906754/70376476366309,62883127877829/332297701143427,-56613927026389/540529897243633,154260661960369/589080849047790,-199584473593991/514061292940278,-115725428345677/385251909233361,-156667595359458/639239300457749,217285353475376/426200527174267,-225973699917529/792573907676860,77194347057635/395227287914986,-123147573126275/650648736144419,197551219571435/671000577942099,-86150042546668/537429548519097,128707378842421/404392844307369,-39775926739231/595105156754916,109927211378032/504283876993363,32019259648079/554160752364776,209954867643863/567609787280452,-5710380982827/17488859230798,-89102468638626/596888044355651},{-112039613897281/321583120292975,-167243039815593/704784466955939,-149420838064159/861277886511155,-250200423715838/687155318502663,-144293060365252/615181325385315,-186150042097234/760312662001261,81978572240511/322516334153152,146206466821547/534718127350102,13632567363443/113000709413002,3316684173813/45423028071086,135895991459319/273431998497845,-88067309644836/256948456535459,84076362705759/505696308040168,-21805154514323/77355764003412,-215592286868467/642065767772423,-195118737654863/790636981458348,-69269223394307/405383179781030,71682084814381/770734063086522,-201434060641948/638534508150441,235983331587437/1051153529088350,-44344772009827/351882381831545,244150052984781/664595402286854,-242932492938393/540529897243633,-24751143226759/117816169809558,21209220503927/514061292940278,-42337821030070/385251909233361,92763024586519/639239300457749,17637754560562/426200527174267,-85915351715793/792573907676860,86574487859884/197613643957493,-182810563832898/650648736144419,104880674664035/671000577942099,78369443881260/179143182839699,-139459522943611/404392844307369,58323850236305/198368385584972,-126790852135895/504283876993363,62400328402201/554160752364776,-78205360464697/567609787280452,76091176659127/218610740384975,-134863094380837/596888044355651},{120645940803984/321583120292975,268628163629472/704784466955939,242204629003591/861277886511155,-53783623734892/229051772834221,210166785692498/615181325385315,279697245005066/760312662001261,58546070115237/645032668306304,-147951778645197/534718127350102,-53712337127274/282501773532505,104615570553391/454230280710860,11595656960537/546863996995690,-45559922043033/256948456535459,232599010500581/505696308040168,18945270867313/77355764003412,-124533588363182/642065767772423,-179197120939987/790636981458348,-60690589170737/202691589890515,222669213562825/770734063086522,-260780315467757/638534508150441,-274730352323299/1051153529088350,123125610362472/351882381831545,-240964270746155/664595402286854,45206444070712/540529897243633,-15057119622935/58908084904779,-42191830790164/257030646470139,-278982517269629/770503818466722,-132133150278052/639239300457749,-183436874174831/426200527174267,-205625173411703/792573907676860,19910971612243/197613643957493,128909113114276/650648736144419,99214768415533/671000577942099,-39936676325872/537429548519097,33236494550532/134797614769123,-106409434888547/595105156754916,-105424492315163/504283876993363,-54069364001375/138540188091194,120342018519089/283804893640226,466878432441/437221480769950,244928095845539/596888044355651},{-18343730773302/321583120292975,-203872020057066/704784466955939,-215878201387921/861277886511155,-44630442426268/229051772834221,9380712000837/205060441795105,36241340928489/760312662001261,-58121712837101/161258167076576,181801631431487/534718127350102,248655889239319/565003547065010,-77396499850483/454230280710860,-172723440563811/546863996995690,29446209281066/256948456535459,34424519005823/126424077010042,-27667969777535/60165594224876,163111373735053/642065767772423,44833434195785/197659245364587,-62404692753987/202691589890515,-233750289738925/770734063086522,51045191878358/638534508150441,276167975065751/1051153529088350,-107818564925476/351882381831545,26857411400130/332297701143427,11516296071067/31795876308449,-80246637362138/294540424523895,34813989543672/85676882156713,58464934148533/256834606155574,257675530233720/639239300457749,-7840544963498/426200527174267,-55011936526367/158514781535372,-105062021913097/395227287914986,-215781486070970/650648736144419,269353915291096/671000577942099,176234498002777/537429548519097,-36516458869741/404392844307369,91316081472741/198368385584972,162141321164273/504283876993363,-60865927077249/138540188091194,-19382761066857/283804893640226,-14181272444858/43722148076995,-127994385490649/596888044355651}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,-1,1,-1,-1,-1,1,1,1,-1,1,1,1,1,1,1,1,-1,1,1,1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,1,1,-1,1,-1,1,-1,1,1,-1,-1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,-1,-1,-1,-1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},{29016843044265011206723152467175124595335480672946108065/7685851136230719477999790870530414828369605785767204108,-6632822246134303798879210140551265307405426990691230497/85319682187247876111459002741345796729148684908910120863,230982735000254888814764268018067048050541637734385989841/42150463808372376090781235414152582524236477197216279449,770388248799788912431306457226123270396210962637390436289/95023483407637910705112652712718039931049720135430748999,945809507472382669791324110789978108871210489157901868011/987377519175179015435285027829991671324094653440075240257,48555601455629253799781372297526608527451217501234479109/9455145256792728943437744943087343466651282005649301904,147895629467340270969284777167377280406199673420374402907/93828075650468876841447532361921114906304995481695689681,6218349363863333239516221914560505538614495407496995313869/7920596849628955608065972140332226368667538601026521370663,126436890898002260942051245177396324391538725994586258237/139747023612503558510583996064617207200924081674937161058,7303058932826732021261164075713334269998467201481138667/9587192903014336483440353147345567890917404105798249183,1969310571192788911193765670756309476730249782539934856983/651933842672833479172954635442696826491436222712872650757,5691856790488779594179064311469910338805286788928271271633/106574011301214665358773511853046869748956846653022580449,1375113117248229921836110056528221745244617783256009898919/22337784823004765756265414796693567234964091804652126567,205928311277327994394219786830708250830081571052058376255/42059949340074939700227703255145058101957307170641372667,3623544116368711469572288073957511881868248218921528423/4272319842938998090933854040456098129665098664674915371,947081546959678683246053654692711134786086693961622614607/3548201670659420605076467051502572757819828433706246624281,-885331894926828436027265881280563121025112241989599566453/158356864633076013365749590215948133482209274088405773455,-934920680252188323580092786217271114399122716678997334673/148926850633199793810702119564612396953665992931359065595,-537238961858107809558744674411935266569838904484128947911/3643170188193648695670739504683945830499954697412535245,-143667638110441084896566304235849022989029107718172910623/24836803711180603186951596664809453532818716881188991405,-809002240119061630704394301349138605628997848968261973887/7173249869378537416969726878520008950881032489599786119,1002599219022508362291782395985401119929970188028342522793/210421302818234594511970735666046491655549587340761412887,89713199440135411201055674823478462864762419223138050009/51463962769746020097800100875624524959915602444004233901,327009346085924990137112885192609516377075632644949037265/32988045194437078593510553488334424894629585758304148474,69103171496998330165531602994642335357481250060122091875/30860434111013560842460886773065657588975261311593782604,5079841128014444197579763150977959734950698817170132642589/886167984567195608228825747240298536777243866784983546345,47329131467868350692736030722901827506465118323630302439/35518867173936612957603843002367127869080379204925716581,89414106103418051516392123429739209652019120496043796387/52059966922283900261056532933506974958096515508836591673,10874590227132024202076002277200355265480690970659137561/6887656153044025557609857004620913000891308462882097164,75908460542567871880603171276015322628181973936926202759/18576528200309973536607953006798946869150276310296280629,994601306340613921259763413247272944841508853698992597637/278624008473919955090434747867847897251746781717214145767,97268539759661542238499748491839009709800347906662681057/25788572169070619364511079527001177840753401318099648123,2342809245785545252895403065006713546183011064815651236093/531337391232905889799779312531300596544514278816961863974,1003089802081890657761315702420883581193742470312708568991/1155204084674292355667097212998419304460440424943674589335,2756891121483962367722175233452971291974377745977601619897/518692671899060294840384237322631130292137418889243995149,958766072443481469046801143402201348457809781516926444821/225770806378827716966494728455063992787996334227766603331,442273192856916511944614759978891594787596385785989133901/145036533070062240041579569005072194569904616417455960923,1046712751953877236088020169539647875373462931531887157281/636286276082714521969317301196725218804499400383989207753,-54071679823418852866161373524927135359269128562670006981/15178678232307592115956065968859161215887277062005032155,-31334536155728177694414555489086821669830750509030122261/8308765594029755105398426969320777145346017991653605179,-191200570080010679747549966015234059506110500018644049714/58767520456792252737788881098039705620474437720124566943,-686895274768793970683248199481896867461811840059513223213/454106702566811329299287678460269230153859082803458704139,-1428769026949769465972503634215257637555944069409972143697/1317999831419539057872370935887217553730489012684530165551,-28887712822715904283478716004670589611283261682771241745/21253197948626652187596898172144304265120047450384569617,-1887306472084602014518443204606532222308800521163034930497/1389764858001820076560030054393026678188829973225212096677,-830652263918748249012924727085725701603492122181524861845/848012074173206207511924816827885028570039409332994724411,-12539624402847667344895838472119171998073989104715886825557/12417261469552668514649009637726942595935010601654800618731,1559341991698673928835275322631701915969842387051882667/788251132894237615903140103996668526014682406591031461,282912173609643461767007898086079870910269256018967824655/47979949289709774005855551566341219654466946271849987647,-134528187282670720150876696084826613530340394407381159531/1057158750379781168425075915374077322870073892193494339149,-17276826521316925590281384313301617751707669619231476257/162324116822856452398321352660669795526816373456727031955,-3573735899591881016593471708753994848282714330247871646647/5342622852650211961989170643334068467935742166543166948033,-1,-85773829345551851693830216766966004521706830938680316441/82733765551021506783386210429197173000929535760404780881,1097892300913111726486607729939755743392552092621474659455/838071344307033068344427195016135492796518140904710371163,1077481347846873651747703775066162071044481912221774093999/647282269942358748903777079634705648292450377848021934633,556987783215337406826731349248030835858513754232910000931/600439365548495871736705252096912637698688348813132787113,1175187023864799152268149569031771757041317475855232165949/2245712918528776853307021232942022666650160676716974545493,-157544107185631929747937315417586226624144791956213989333/179247499248370589658835238374959899438831188576414669397,-3944074399971394491727125058432682141191436844867262081557/4778934841967820096230561387332610678701427361240650432809,-2882918547066180206660061187646558399059254529780613552603/4454105350335299570154194233575292586487105550486517251455,1613283037201216279510591035480042003790595461971898523/2072149856773479789439039576455596983858533675008206498,-14848764240999400673429491199640734360179340205200230149/24411446737264515834659563868198183531740338620874829189,-1438986185062111991234712819134965969233009022720367919263/6616827044864597466401075329740942596256116669613886814287,1050832411443330922888398529733715458440446362887874330/45619856450793102064226759542831857733662482536593744871,111293982948827374606869456955105744139732898942183474403/1650768180300876874898765860928642807983831647160968852973,-242330826154889934363419807879684376868343983239357222247/1052552640838702409901668988119126323949237213981885060583,2112366505073601451685956567361672416625237994271993688/104245791346094585681868137528446441672013383708640547813,362964273131522741650849804199736107239829684077367839403/1182275126666513858736635625217747165520609174963126916011,237387234712170171421548957581020502987537649599962408335/338032389299334119157052178858776350230876852801939991989,76269954474787310383038772417930296041267285559054242132/164097220937203268636325354158482540313699885536647331593,905297019970717677972947653241370659392885126320885213313/672173911974524293230933159093237718830866988842746143313,1304789409650835113798673616830160080276167749419002505655/1841309971768483506134688223483446808033891044383962742453,1358808870369846422332168141943359604039821727295170599881/1727231497083076151093330468488283385524913116774143158761,95372681935631465083500707060849142737905963450195759123/192287050160712795956096002299664840902939646793435286553,155167291775530689979004350644766345537514681574703717789/232886374404039775448715347697963354098242199694831638149,7432033572176520456467217667213649039625934926270671601/18457836867311649853809055774373912649164832436377929215,7371751247779275690022691510810357846742049017905028883/13027154225297348541785603528998058198038678812980826349,1,246341080356499612183177003626266517135679562913564203923/1011621733436955784855215083293393501086451246428814255177,7052827056034822238059680966038801558703499306493361682/108133181187626552629399697804746411790058320023665462627,398608307604782250461233188270587805486398625250114417581/1456786476304530475236283457710894177317253254107881141399,443200375960261501273776909938843704804576765035461783517/243139718518745619338685989831249512898488788162294824173,78669453582687628153253091924361188557428601127708216917/169365311020296111380938914744507158434243094444430189415,56475431891969138182519828009055204148261258527809098542/119467346583973845080973757241242267514667155917151506433,88811940627027433551322169244220463494596095984014278199/66032116502259990424189871407864650306225202025951126431,-4039495262286960839221444544331050049393622610920708262611/10177514814018476070466627762830869910830897542361839792639,-484264864916978760416614175723405099665185155799465923937/198655653995855347041149119742178502201261163969556789895,-6841414902107652536668463291595021831769312674469243635715/3210959410618696979503816457515154347989090611131333894639,-4116237277115930411486733359920440100416746606815222614129/7480754879060763696201108787035060810981059708926702590893,-821604810924751739297106631856137350515118172740764017507/1539530309023392318697236994377283035668568027048371409679,111459504441090377174297011178880693447327463291355554345/98093456020263509253596338085963087275966995629276233971,1732701394154682817688379250523258921611289334729582186067/41963100129805009119315850492662513509810874850023874903,-1173753237387477209646740114926147983046432894038686409519/2183533100469306191254833894212991941107672217865689849755,17548480128516824334363526231182410071278654256972564979/264119037502975720943841199572158711799601722867780100857,5205265936624668192949746992066685251973703917781879896/38316795901435663722200348489870462850410311154871514361,-1436770203544170605065169343347286169656686282481589042471/1782348795553046586284976007346320267646411866668317187979,-1923874465926653821274967572137081497998725423203882019/4399559230823786790231096919692554630400919539353846780,-1510840521731932063727046870422742847997574436134326014039/369678866940339247777968215943201290945365077598172131297,-1116158417790050252115870485673479658848787687623859342029/325520989102759799225348168786035350124653885786291712253,-3674170656531427098416997937965816895836307646157694056957/1238247279989507976204612997559873440651361913997047869789,-10722391526037175826650178820306139286854693747314783957143/3541952972989974828427245853898815608255912126407481679931,-181156881337525725809902447220437602112717756152691858034/54602769622774103974772500775736725341679707387733534063,1716821568742083916300967319823147611942765181695585954445/293045151238449967866965730208442818305718362244629054689,4333743024850641453723533078857584440202963321837881794993/699656261136496985674671817199540752020140803548230540975,768983994787386085172004886600296261463894686220814047031/231025769317694198231505803672422614225354882354057442021,1869449535308591068641005074447826079165583401245944246519/523672681215981784027132331870838102060221729185004478011,1407172923296437915717541490940229987762017023780012936079/40488162128680176709477269772740469548634416138432825785,1618355529203126312200152236326471538653047737182634900627/249069965021975547866668122575929736221842915922005581683,198200683982690346740789469334200883165735532079322818719/12302602457560878001147832101563330412394345017496080961,21576305639257497575284668177872124105486029021167283827/5744981976636814772013721613280706589496926403445417451,632265877206134600651897827224110735371881527466129284839/50518499985227509708400338291924928005595523730861009967,1524062256094214725088409281078944651951442427218024049539/62833404450103991354952663163867703094697770905156293541,-10340882726674291750982239997990576186725219382776976137/564051395289157477551890061314610470000304424662500061,-699636163972615053942222998185303132270389010382427476885/5100340705825993581703232712693925890974680500476238411,-125019433200146568823442567903110651913351628470459508877/15530209114292507822600887003280640473550139289932684801,-709647922140062979563029784756158709311652002308158458805/116957370658304184646266911583141887531532489807600776194,8272952073996065456727817126921749283095379199564132161/96114862144384939908054387296632951580274811974714516020,-14061003471416720049286702669931454863710057167466121129/601172098104062469398383807791737277747777846790255593571,-1192577720049708797733466206448145969214491409839890961793/466385323568436781542016579341617369816460288905039255683,-991187384583336210825895054928744235154193729757974770367/427979062763824904994795911410008320555316780445066206967,52381334310847375807665883185567340643346929188848210195/201120177926980943698387314106449801623942253774583770587,2258123040190753368814117083067506580872124466629169168605/2237574302371115856950275304450776268055771139475524806779,-49410480635715956074455403827069768891481984672957561118/1197758792252433092282769267570641045810893888909518476893,-17898404407987184019224660246459323647203673903414276376603/9349742455379431736199963528646043146309508812121683597029,-230482330580760341584153373278389939546258603979419396254/126985680559987100245704467247513842677379655255029870653,-30189859535729663404124222062906365479548437589445310838/16227086674808854034856169647432510599881345938496490741,-58091891328039459289144427008189483673332322817152357966/3057462175896467192891268587807785927240998142223998201,-106425759387485047410648418515790656884781913991205689897/73660185210665869268466041895273387351698123313382396968,-470165585735756015822905940689531771865324030610633111/7492459131614491643984588196368117796651236429202241667,248490612712989356204264799059703677426035411304836123031/1130775833868764613752393045968083895982722895197480393775,2938612569431966516877088887199021231484693776550312071473/9736616760815255142167584841329487610607256884812888876997,-5099419566663626272308758814619186752753633633070442052551/7334078286893567390637823059915363814310210208611531351461,-392494628214269418175459321459542604182960046684314000337/140386374429265576930295772168135363047451728875641986147,-495750954590906881669142630017133256607426938664288350023/465002737547111388394263831140185841581112617089852287105,-69786145079324555942010751996582165381032986142698077347/139156584310964702509984800015317574790062189056315282053,-3723298228016029060138508748423663280684821937580891391/381528133064420341396193660041916970871230020602444890385,11271486529557484996180272426565738662996812885886298293/5633609502427017694494180074622498788149451220539020981,-650389438690357115131474101645817696134092078103259497667/50512288323721838382479497348998421388531661973137730077,-633999925518450337421095630321130518102593448385157607/801056154199061572232948653764807737474443445028660561,84376250629373610918992319575313795160645946221677890993/18262671390292173210092572434187028245697430016397196265,614644414702045925297867408675648732316606878338549371727/32576989988612829565423895066829411539800777701913708057,152108465104553751371124407307509641277262515097559567939/39215346587357169093278099705158750186022915044109085215,1561524188948956389037518647892686760076603832706325537071/501723839668850010525115022554295428668868943280826514351,1,-892713317388761916864726611991264069165604971803742101059/78916931772519297132170470539397951179773771664065829903,-2231733853634361085997552820004405698335086639174315359851/2032906010998798372686154811081186563057378806332752061533,-58337228132896060029879130750631158354034687892030033749/339731336710123617618458985335162150483975218747495037707,-32399004121859577598633606399800265994232294275577777415/94181337417173503973107538967464570971905972445789454703,179356436801299067357322994021943136616395732101491835501/553900512647143632659241302119321974884595644438893213569,49790939815800862443060079745435074003703713530074526629/32716436768926040802308916426515155608433203472481266437,-1350614442790445600646403122295400383518715010667636413/539947208694495567850242782426704817942777422145373345543,-55011373728536029782969768802481303078246891839794400357/60190037382967533615667349479140458658634816129266343305,-11626522242256175248117090670910968202543110917800245567753/12843861511506218025958691623026509226577435649609518333779,-124293661740674770265034433140871694894660606479146579379/161002363388897981949771834987107058524405389335113998633,-4275802822453921792836066203295461987288706794537235906511/4855439957606106162370701468866460488668344223624284901761,-2154702544010549636398101680755801973064955362641080278517/1370126260814978781526090856430288174005658881779181495789,-81108855520404142115230377344625033109401150123929829979/140742111164623701373848965131315597633574505031880670611,33858454250119149929183721366757952912342381285784099271/526321733544589895369377733139622702663496558784539820471,-11277165005682929609258193582356388736897978986341458283/19444383504453504391787383204390985046852919883758541041,43397857137384691679888534016543255671572268059609478549/30312733796019299019623272800663952036383985661613139341,1695975649520759725417289623027257406665682584193480095107/1932105109777102835254355580276370786867720987086805930535,2809595168160242548305477594137610772046902106735276073914/3221592685212636744674078715989912836481135048893126686995,1301510456145301847595086738683365707840299908171720235411/2153052960520629789786534961824164869528745099417581412251,1648255236960688716552116269210344664031460495251799246857/4071813729568196584218843888088763875303370508702946794721,2203029534467542470487880282777352206416892325053965653689/10628850234672168034149815972612898636587065847455198771473,-270963391888151846158202153871495486466637262899306758907/538874445285073445501210024509475444603028186585297321089,228617305473300314371866581992823348313671021522302288977/3134027163031966126770903144345160689337627699077775991885,877813205095504046843948820579680555108955983184609681359/3200795438781913237009900040802376195537458801014937435395,-32704370471580708086486044229423650110660401333545455420/74445699101484794287057358616031174380394688581977608257,-163238712946337679123480679249681694442025693253569399489/7025830548539164500260194675478905247774140005549586486287,240262595995667855481765534693608175070296908828382185263/330343993893680785256584040039921664003292856842609951603,161071934832146209971151007012374703512913242231392679631/375232544751566189127584010661061376364094315443312161211,1357817843993774496498401617055813384965385192032869178387/1944046521091083057646184268600592692306225527561021988985,3898836605070480180487724588632817065752143893659734162199/12524375967254985702526528788411538818162734191476989954111,-459532438144048565400630030817998514432143195158619117889/3307544982605772998477250236876791782403818194680917416639,2062650665004419153098822139679787347195785829442864730/6973114491814356087255933978833158108014223746996369521},{-63776695096996938581755959160427826876712999010492488427/15371702272461438955999581741060829656739211571534408216,-373200978823639163755044092012733873745842038840610771213/426598410936239380557295013706728983645743424544550604315,-529516726931764492327219892214879154969587052366830835607/42150463808372376090781235414152582524236477197216279449,-1388419015912891257912652621681987761044918275571682303527/95023483407637910705112652712718039931049720135430748999,-7530574817421900516463276133656743100543519880550240288409/4936887595875895077176425139149958356620473267200376201285,-71011903857941830276032692745192925168558768706117259579/18910290513585457886875489886174686933302564011298603808,-23744411442029689878582930371067408418522550206539790996/93828075650468876841447532361921114906304995481695689681,-3084818798837907402948592974712045434034519195701910547623/7920596849628955608065972140332226368667538601026521370663,-22840970705896712707875945237566012309215752474224345747/69873511806251779255291998032308603600462040837468580529,-284199017734601143546475781044939318369229663067364127/9587192903014336483440353147345567890917404105798249183,98788680788696274446231732321514597062852999020923389908/651933842672833479172954635442696826491436222712872650757,-432986724494445439393404696473858999152932933232843876441/106574011301214665358773511853046869748956846653022580449,-121067768535013860656947058093171588140335431076028649367/22337784823004765756265414796693567234964091804652126567,-188457146160309543449244592123397942313629607466238580943/42059949340074939700227703255145058101957307170641372667,-50275023967596455828530357429696120134610973135957371/4272319842938998090933854040456098129665098664674915371,525645854584467170778754464362289321045880975003242341087/3548201670659420605076467051502572757819828433706246624281,-1707724753732938520746834173125920903666833127361458976299/158356864633076013365749590215948133482209274088405773455,-1930554787277520200629813376534638642779904736548286021079/148926850633199793810702119564612396953665992931359065595,-889020298078548041931072582339121857231375527414421996433/3643170188193648695670739504683945830499954697412535245,-11941752583452497636237733454822081241414982885180027383/1079861030920895790737025941948237110122552907877782235,-380397468725461022717025588215679138927520074760134195967/7173249869378537416969726878520008950881032489599786119,661648454929024206580640463593391383922977306782563288164/210421302818234594511970735666046491655549587340761412887,529974114401264337030817971220029216351304560263988721106/154391888309238060293400302626873574879746807332012701703,152511137516820393613745375042276282006986288189478171207/16494022597218539296755276744167212447314792879152074237,15274426441422935294590334030182964259372600448527074298/7715108527753390210615221693266414397243815327898445651,5209012554345604403873603500040760398678840036080458626377/886167984567195608228825747240298536777243866784983546345,344001460120562655089754281235915446495006788989786636203/35518867173936612957603843002367127869080379204925716581,617555685359927069919224801024173964198382181724210521793/52059966922283900261056532933506974958096515508836591673,18846480608324506210090002925313803589097378048733911188/1721914038261006389402464251155228250222827115720524291,96911876219550802321214508202706911296492483957807680349/18576528200309973536607953006798946869150276310296280629,1273963424150320118048584421993038529852853544449431105151/278624008473919955090434747867847897251746781717214145767,141398822468630817010463107537446772314477029591505234767/25788572169070619364511079527001177840753401318099648123,206251002396827014379802446067098390111116465866786242915/265668695616452944899889656265650298272257139408480931987,5648598759485367693596562585850714736270172656936329378229/1155204084674292355667097212998419304460440424943674589335,2766350778028973607522752268553875727221554433373758693985/518692671899060294840384237322631130292137418889243995149,754763930378076681278522395970918353370965529941024119889/225770806378827716966494728455063992787996334227766603331,444744191109600796555864460335876172735192420748972845153/145036533070062240041579569005072194569904616417455960923,1644701345451478742371956741465473174867099156374776816379/636286276082714521969317301196725218804499400383989207753,4385065524498501790199428095109264831706262311889768024941/2565196621259983067596575148737198245484949823478850434195,422774851047058675433061300522510405207093417909785641027/149557780692535591897171685447773988616228323849764893222,69931245074699087606040408975202969711059362764059836962/58767520456792252737788881098039705620474437720124566943,1855415855658651722150118842048607467981307702466621576999/454106702566811329299287678460269230153859082803458704139,2165405593800837828479983823696770654276502862810060465529/1317999831419539057872370935887217553730489012684530165551,66104916197667463318207065550235110352795597291052748669/21253197948626652187596898172144304265120047450384569617,2825951672879753721018071664475580846978320918823138490821/1389764858001820076560030054393026678188829973225212096677,1296232713053976416979623949523919776893491984620125232940/848012074173206207511924816827885028570039409332994724411,17601718612913276895235755501049342355908775832719822739613/12417261469552668514649009637726942595935010601654800618731,19035165611255971839643439910731398518210815768317925569/788251132894237615903140103996668526014682406591031461,197656687109864147350454613444115831307162935024579685839/47979949289709774005855551566341219654466946271849987647,102234945639031793159274254836728838190257700235629726829/1057158750379781168425075915374077322870073892193494339149,698433370392633143493726306461559370578705463887217215659/324648233645712904796642705321339591053632746913454063910,6990729473637642028094114461490536044574976444433490228313/5342622852650211961989170643334068467935742166543166948033,1,334258433217425592321050925818811967862397715263356800001/82733765551021506783386210429197173000929535760404780881,-254048891515045724570678494195620194118902673813037113269/838071344307033068344427195016135492796518140904710371163,1075284854578109643214016722256276864481648736912710233155/647282269942358748903777079634705648292450377848021934633,291436451662939705201099425935392236229352236614439957775/600439365548495871736705252096912637698688348813132787113,-482574168870032749555319203549031974233659548962067075464/2245712918528776853307021232942022666650160676716974545493,220277213354151063190442313563770141200990638137357696525/179247499248370589658835238374959899438831188576414669397,5202107096978613978963616635761523822677634274107529383083/4778934841967820096230561387332610678701427361240650432809,853028879320766350356341837461263096982897581455031031477/4454105350335299570154194233575292586487105550486517251455,-3017833733154192628454539493143350356479683950077546047/21286630346854837836964679285407496288728573206902484934,48076473324446311559386780909962240994124372413770555005/24411446737264515834659563868198183531740338620874829189,3503503839117760891767251489456198609861639424833280261697/6616827044864597466401075329740942596256116669613886814287,40653951380691163926601653645856836188049792850990256709/91239712901586204128453519085663715467324965073187489742,-156950657169190603452444642923097653281291550622935075357/1650768180300876874898765860928642807983831647160968852973,551324958080092840071773678672690995555161395597539713193/1052552640838702409901668988119126323949237213981885060583,82944657540751606060726255383264625695716846391156694313/208491582692189171363736275056892883344026767417281095626,-167286222557368050896465208497638074236285578270490801628/1182275126666513858736635625217747165520609174963126916011,236550547873795799793476080388072202622379212809507874099/338032389299334119157052178858776350230876852801939991989,351612943106919224676123941992107136289096895550190112653/328194441874406537272650708316965080627399771073294663186,182312481103518332530532280768237863110405533968570588733/672173911974524293230933159093237718830866988842746143313,73762206407646149455596157170522914032481766192352062741/1841309971768483506134688223483446808033891044383962742453,-233140696826976034700470004430731040696301141388952206067/1727231497083076151093330468488283385524913116774143158761,-217049003231544478937684860179013794391937273544633105781/192287050160712795956096002299664840902939646793435286553,-185224103297310413413081866399581135754691180192512488164/232886374404039775448715347697963354098242199694831638149,-12678417136820280322724858683417459115391586510056368294/11074702120386989912285433464624347589498899461826757529,-23524326708458701726965881755218602572127395984230014723/26054308450594697083571207057996116396077357625961652698,-1,-161453384653935994644528273469855822453032546028502157319/1011621733436955784855215083293393501086451246428814255177,-13782750091866511896920346287695143121340098192001400541/108133181187626552629399697804746411790058320023665462627,-229407780588998239305206287884303773144614146853719725433/1456786476304530475236283457710894177317253254107881141399,102135452601238036270938278934113441532858660397458701469/243139718518745619338685989831249512898488788162294824173,-158962855566990732708275569962312628059678019844227535639/169365311020296111380938914744507158434243094444430189415,-444049349363557059306010863335500147915322888069841624827/477869386335895380323895028964969070058668623668606025732,-73943258178384389946525718187912287040350351937381286697/66032116502259990424189871407864650306225202025951126431,-9082433443750915725680974474688104169998076755776014571419/10177514814018476070466627762830869910830897542361839792639,-440785615662438762272220333088733212923592964053234054017/198655653995855347041149119742178502201261163969556789895,-5095119717758112099565382508327270164390191080103103930155/3210959410618696979503816457515154347989090611131333894639,-6422433312961656888275331741273593080532021484421004767337/7480754879060763696201108787035060810981059708926702590893,-4508002889242205429872403258424856154439389098594867515307/1539530309023392318697236994377283035668568027048371409679,-831988849719707678202653572371582504184086827753726665919/98093456020263509253596338085963087275966995629276233971,-3310792521381596324461757124424189248205725326924361851221/41963100129805009119315850492662513509810874850023874903,-26146259929138440018512728687417570173157472123776000347/8912380001915535474509526098828538535133355991288529999,-181075561104177519847961654130499678827970673590278781471/88039679167658573647947066524052903933200574289260033619,-45326205072402292502696774111289008208876993654387739886/38316795901435663722200348489870462850410311154871514361,-2065444910986266384290691581376180901208003854872780674159/1782348795553046586284976007346320267646411866668317187979,-21527775194531073365260839795302340723735831951924098849/13198677692471360370693290759077663891202758618061540340,-696001221774251098899913178158515196852995982530720454919/369678866940339247777968215943201290945365077598172131297,-1274025141489108750746776255196136073519047264182432066689/325520989102759799225348168786035350124653885786291712253,-3347659764106563830186774552496486881145504096683028662437/1238247279989507976204612997559873440651361913997047869789,-7206196540474027882728787867933135147237056332774511589263/3541952972989974828427245853898815608255912126407481679931,-177026636087570222123781470696307659838517355082736224302/54602769622774103974772500775736725341679707387733534063,67595597672014423688421129464104457707019448400982650729/293045151238449967866965730208442818305718362244629054689,158898301747959513895817571030928993819227423170506521773/699656261136496985674671817199540752020140803548230540975,514081603695123078483576606939577629956277641532330504515/693077307953082594694517411017267842676064647062172326063,425690252386445899142786544080142409802218167272202385130/523672681215981784027132331870838102060221729185004478011,-70956971162744608364469574567694047659340183874305886191/40488162128680176709477269772740469548634416138432825785,42317675072818260287763890103591077103183438786638237038/249069965021975547866668122575929736221842915922005581683,264488166915322429941606211384808977900896929459189970869/24605204915121756002295664203126660824788690034992161922,420466081118071481108874671061023993214041660949524207611/155114513369193998844370483558579077916417012893026271177,195391540287922489790350438447624130960288808545328139949/50518499985227509708400338291924928005595523730861009967,2589029124205006959622830637672985076248235583302248866897/62833404450103991354952663163867703094697770905156293541,-534688460714646165980870116663613222687949815523551397403/7332668138759047208174570797089936110003957520612500793,-2425932660746105550259816932266617946739649459983633588413/5100340705825993581703232712693925890974680500476238411,-559424042580196333542676050997096637709123645927936744995/15530209114292507822600887003280640473550139289932684801,-1495422223038944648837456873334375355166697112282245743089/116957370658304184646266911583141887531532489807600776194,-1187383556910277062247174926703489168784655754544382953683/480574310721924699540271936483164757901374059873572580100,-1476555986963573657981291267546133390418410420395956697513/601172098104062469398383807791737277747777846790255593571,-419429794897964948919026647456561731086008978859775625545/466385323568436781542016579341617369816460288905039255683,-369059692409672755033148500609103724992557116251039156039/427979062763824904994795911410008320555316780445066206967,-552225887158636235508947898982738884036348685499560156681/201120177926980943698387314106449801623942253774583770587,16276590048789033011419944265384007088931946000847301583/37924988175781624694072462787301292678911375245347878081,861630980554593011192875346558802484860632066972625685064/1197758792252433092282769267570641045810893888909518476893,-1334328500938663148710166492972786404824932468509942807241/9349742455379431736199963528646043146309508812121683597029,9790679533916866647454690718618641346059921280441282414/126985680559987100245704467247513842677379655255029870653,1614861986529340856492696569442047222626329290049605246/16227086674808854034856169647432510599881345938496490741,-37391035655384122739589730629979740058296591201226454794/3057462175896467192891268587807785927240998142223998201,12078886800623634125808166260887614947402659932518145933/73660185210665869268466041895273387351698123313382396968,172474325654921596372476029526418189072345697294168443933/262236069606507207539460586872884122882793275022078458345,-271146036236162185774765835062935860491610421811707817667/1130775833868764613752393045968083895982722895197480393775,-6914339218935062173048260460850153872426827392533573083/885146978255932285651598621939044328237023353164808079727,-4674779845530296770341013772066299652468002515575223938055/7334078286893567390637823059915363814310210208611531351461,-2468721744170593115555729228937119651663516627922832770995/421159123287796730790887316504406089142355186626925958441,-986323207068764560388197531651162451845384165082435006909/465002737547111388394263831140185841581112617089852287105,-503384660443247519632496251366425372513820332160864993387/1530722427420611727609832800168493322690684079619468102583,-181342279173516618438122015794638799581652949273390125453/381528133064420341396193660041916970871230020602444890385,-21736629153041349730770638446523569356166487911631556645/5633609502427017694494180074622498788149451220539020981,-2626576735796381938102430949189271645178120162621886225499/50512288323721838382479497348998421388531661973137730077,-164112826029904755899703230488886660664509747084059505977/10413730004587800439028332498942500587167764785372587293,-27450796212594060137367326960887875133215358399884136541/3652534278058434642018514486837405649139486003279439253,-3087372317856290604034724786665400825600956912379994334601/32576989988612829565423895066829411539800777701913708057,-171898655406075125804450581675393816116939512751924915437/39215346587357169093278099705158750186022915044109085215,-1761482778690079136902225739715788670119252130776735136207/501723839668850010525115022554295428668868943280826514351,-1,8589974375927000089618290166268336934057490056670601720755/78916931772519297132170470539397951179773771664065829903,21133502279831754058687598373419054755866218486257572318595/2032906010998798372686154811081186563057378806332752061533,3907671429637499094727231251556879237972758048853481558188/339731336710123617618458985335162150483975218747495037707,1626745958645453548624272680694189305362970345727078316480/94181337417173503973107538967464570971905972445789454703,1858989537495220710973431044368532207230753114548354413915/553900512647143632659241302119321974884595644438893213569,616584330739525381888672307933459316942987576505581080047/196298620613556244813853498559090933650599220834887598622,616098529508637362495350758641755973210535765448613132605/539947208694495567850242782426704817942777422145373345543,13984616622813848420983474280283207283777917909962198545/12038007476593506723133469895828091731726963225853268661,-154290476641842823773072834790432590840706491681165758675/12843861511506218025958691623026509226577435649609518333779,-168386003928233839895869825094952395302193090009289903231/1771025997277877801447490184858177643768459282686253984963,460146520708565510446726687826020934025266633216302749923/4855439957606106162370701468866460488668344223624284901761,5952382438339471075396687661990868968064658457780361483095/4110378782444936344578272569290864522016976645337544487367,764917122040842696007763209644111649507103031729009470351/1548163222810860715112338616444471573969319555350687376721,153121626720137494759651491828750364840044612159046886891/526321733544589895369377733139622702663496558784539820471,-25014725880261756349175315960612960556364378871473509687/213888218548988548309661215248300835515382118721343951451,244077889776943053871866722671839994980908765800030884707/90938201388057897058869818401991856109151956984839418023,84898564425044893818288564975058493230976910935236359235/386421021955420567050871116055274157373544197417361186107,134749602451126747141235384411372698314360303226373084105/644318537042527348934815743197982567296227009778625337399,237065607775063524860660935161637298708906419117281828703/2153052960520629789786534961824164869528745099417581412251,40046663726815453931097336044309022807783313113680516603/4071813729568196584218843888088763875303370508702946794721,53892595037393482281264134401794140721912770594792412137/3542950078224056011383271990870966212195688615818399590491,-1413426828465657573332587839372073179743587282553671038823/5927618898135807900513310269604229890633310052438270531979,-75047090039623505235827549138529303232500067331609066389/626805432606393225354180628869032137867525539815555198377,-52215557510439692981355949755889210658113855162097194243/640159087756382647401980008160475239107491760202987487079,-211330599471399784284932179789936481742992662697156950127/818902690116332737157630944776342918184341574401753690827,3596810322080054321819637456379921068107655498378268860029/7025830548539164500260194675478905247774140005549586486287,245764375019755852228016965461428577994168535130507074323/330343993893680785256584040039921664003292856842609951603,9272338167550094468852961701674585452714420631932444571/375232544751566189127584010661061376364094315443312161211,36949451848258988081809183254776729560881218971405300060/388809304218216611529236853720118538461245105512204397797,-136966815300202580841164593093026391006497275596862304405/12524375967254985702526528788411538818162734191476989954111,-675451401325307877856584716125216817826160363788595256345/3307544982605772998477250236876791782403818194680917416639,-67592294482034271498248741813250759090153027813592126919/780988823083207881772664605629313708097593059663593386352},{1067064324871733948227099412222187894519207249541284985/3842925568115359738999895435265207414184802892883602054,-267210646927158243174581061550813327421982440996798193751/426598410936239380557295013706728983645743424544550604315,-61185025125707171640224370636923775568645759656671783907/14050154602790792030260411804717527508078825732405426483,-753832010932736469955158473510146650633608282528500856405/95023483407637910705112652712718039931049720135430748999,-10460662480034506298377325727337093557784593408992722643013/4936887595875895077176425139149958356620473267200376201285,-5201303844553313317919026433218485823842088114366567885/4727572628396364471718872471543671733325641002824650952,-62085287329761761280802786390967996625724133569597099964/93828075650468876841447532361921114906304995481695689681,-10376981285350737896463878993016998899013826102578305923771/7920596849628955608065972140332226368667538601026521370663,-329201102450425325037039194630829371981839162210262007899/279494047225007117021167992129234414401848163349874322116,9156276782705545351902392964706785647169775209313073083/9587192903014336483440353147345567890917404105798249183,-118772020974737522791458745321920207557117443038583525069/651933842672833479172954635442696826491436222712872650757,1059863435332493715782502934007130382447596804026321971129/106574011301214665358773511853046869748956846653022580449,253315963741730125319586972684677932509394233665638264247/22337784823004765756265414796693567234964091804652126567,10091645074074850808935800153683276183784641578164011421/6008564191439277100032529036449294014565329595805910381,4142850218731641683399809080978690312718517876279840551/4272319842938998090933854040456098129665098664674915371,638448270901157048275816939071572251049259379146005165099/394244630073268956119607450166952528646647603745138513809,1735362300372313336753881492844355914528715695595678578783/158356864633076013365749590215948133482209274088405773455,2468705240706765635685021413401245124058807997254837128563/148926850633199793810702119564612396953665992931359065595,1528410716143149716578282738791657509504499593566025646741/3643170188193648695670739504683945830499954697412535245,12271746499334377753156209491076601871132710297704153911/1079861030920895790737025941948237110122552907877782235,3791933370211430904775998419849030706381724041432659232229/7173249869378537416969726878520008950881032489599786119,1661931905815563216886882023094343129525057272610242981292/210421302818234594511970735666046491655549587340761412887,563031200017571586874336297447297543651566245337709220221/308783776618476120586800605253747149759493614664025403406,-341344775190795222117319951227362046276748182028426158791/32988045194437078593510553488334424894629585758304148474,-61443377612836371040094754468556334236880435092619455201/5445958960767098972198980018776292515701516702045961636,-5724667991275519957048407390774018832096765506802383658913/886167984567195608228825747240298536777243866784983546345,-293195421406237864949158887613013071321219726530382304403/35518867173936612957603843002367127869080379204925716581,-1752781342463988171469651621284896487658289459706626417795/156179900766851700783169598800520924874289546526509775019,-12934118705859514711746698966455598483307675883335433891/1215468732890122157225268883168396411921995611096840676,-180486585913538738972509477611307795226104115431982021789/18576528200309973536607953006798946869150276310296280629,-6345858715643120202298311221270840662159372498008869141161/835872025421759865271304243603543691755240345151642437301,-226203225475553249489244009603572284386611366635957184755/25788572169070619364511079527001177840753401318099648123,-173579252999630537003980446253239502707582846734387805267/531337391232905889799779312531300596544514278816961863974,716141303280370913840382613764339898943059284822111375023/1155204084674292355667097212998419304460440424943674589335,-2960873253013120016420767556124519612800713443804378200529/518692671899060294840384237322631130292137418889243995149,-619956102292703942636630381704850059370108635666179941475/225770806378827716966494728455063992787996334227766603331,-267426848129096229673133099355449993688418768541393982837/145036533070062240041579569005072194569904616417455960923,166592883067986158905874992266435178625632267130966203073/636286276082714521969317301196725218804499400383989207753,221111481047939365983085110624984216173011707889629368671/513039324251996613519315029747439649096989964695770086839,107964508122006980609584002326593948170778644870827011264/74778890346267795948585842723886994308114161924882446611,-110468431693636640954682126917170189638248728303475605567/58767520456792252737788881098039705620474437720124566943,-724765890327603355830772902712705494457450476338741196489/454106702566811329299287678460269230153859082803458704139,-256397950520117156590888180630152338307140090975230610933/1317999831419539057872370935887217553730489012684530165551,-69754372952399149127745109396143020675223621677031878911/63759593845879956562790694516432912795360142351153708851,-795381863395082926266016360641965205605442070719818552585/1389764858001820076560030054393026678188829973225212096677,123477205387007869819512026911602904473398513219255100987/848012074173206207511924816827885028570039409332994724411,588572982187750797929522899383194094524468715613985326711/12417261469552668514649009637726942595935010601654800618731,-16907326775911802204420968811988695667858972694167225239/788251132894237615903140103996668526014682406591031461,575516617057732574443777872373617422139837148864895886431/47979949289709774005855551566341219654466946271849987647,3460609904855617974412622189841279515315757287769238579153/1057158750379781168425075915374077322870073892193494339149,133279489430153525467784441985356506545032633537785276733/324648233645712904796642705321339591053632746913454063910,1381249545541927698491961449240827013548161522015633028109/5342622852650211961989170643334068467935742166543166948033,-1,-197408648066696726702298419377579936951718744900894046041/82733765551021506783386210429197173000929535760404780881,-141279551161383269124453698400457960241961671676328872215/838071344307033068344427195016135492796518140904710371163,-1784085038716365764361524777874981740169805894222855014603/647282269942358748903777079634705648292450377848021934633,-699136309541633274275815187562177436272617570992954413993/600439365548495871736705252096912637698688348813132787113,-1348748737603754290893369528616251882749676619018824252098/2245712918528776853307021232942022666650160676716974545493,-22586933221936496320103894949608693220180608017756422069/179247499248370589658835238374959899438831188576414669397,-76042251734249801094252592994008032791705101981558813455/4778934841967820096230561387332610678701427361240650432809,-641303398212631009005180189721534119837160886236183595501/4454105350335299570154194233575292586487105550486517251455,86245948609130167641362577997358029198254532476715855893/234152933815403216206611472139482459176014305275927334274,-28686280045731902737248869130959718367475935779411510437/24411446737264515834659563868198183531740338620874829189,797857148626054943521399718154721850564913768402904240415/6616827044864597466401075329740942596256116669613886814287,9691447710572872556278833232673776176223397290587931829/91239712901586204128453519085663715467324965073187489742,2574401634943391608418345249434171431373462022435166147005/1650768180300876874898765860928642807983831647160968852973,335515633557357030704815589812035424258840945655095569925/3157657922516107229705006964357378971847711641945655181749,21198853460777704324513857494570774140562042935157801987/625474748076567514091208825170678650032080302251843286878,-377381409098286197983872965646607391206758190270555923298/1182275126666513858736635625217747165520609174963126916011,-296590690324782000875738340210821276893681377749515516887/338032389299334119157052178858776350230876852801939991989,71918676649773890925294982873345140989626593841527504805/328194441874406537272650708316965080627399771073294663186,543937750344157427802394223533714765206026701695322421413/672173911974524293230933159093237718830866988842746143313,969231920810293674951087435705376323669262580097342766031/1841309971768483506134688223483446808033891044383962742453,673490556818741946963146397491870936321813913759085406099/1727231497083076151093330468488283385524913116774143158761,111350797485023167340059830313212789414836584975082560717/192287050160712795956096002299664840902939646793435286553,183072073850642095646764697142465646391871443632133168974/232886374404039775448715347697963354098242199694831638149,747292232817619596149478085815917153268972663107647832/651453065905117053663849027330843975852876438930985737,26783344411237107696861280596106499154063974359979153333/26054308450594697083571207057996116396077357625961652698,1,1575656347750676909064024856192008951939199223768770273443/1011621733436955784855215083293393501086451246428814255177,356007130825022204832232847976488301581348509778608090714/180221968646044254382332829674577352983430533372775771045,2215401974549505081775780330649957494258755124358065695781/1456786476304530475236283457710894177317253254107881141399,18187178175129842361143543640730927349147217520877758395/10571292109510679101681999557880413604282121224447601051,211256644829520093847738655153034477311204669997278888967/169365311020296111380938914744507158434243094444430189415,591469926536687863763683631451517587280177973010930443057/477869386335895380323895028964969070058668623668606025732,10960949223804953056437657119344451031179991338923887865/9433159500322855774884267343980664329460743146564446633,-8870291073259552214600038965693466597515409188528868020381/10177514814018476070466627762830869910830897542361839792639,48945713187474991683116363081061879098377610717116988301/198655653995855347041149119742178502201261163969556789895,-469346557162806022663305091584654497537534560248348915453/3210959410618696979503816457515154347989090611131333894639,-6409756143782284447481148136883676199924670593071616060815/7480754879060763696201108787035060810981059708926702590893,328396015292282204237874341129780678362267159393400286963/1539530309023392318697236994377283035668568027048371409679,-55540615663639846787178751072036350819393959093458767017/98093456020263509253596338085963087275966995629276233971,-1896165404876291587468899230140629189702917372146501843795/41963100129805009119315850492662513509810874850023874903,138746107660536572687810722446541105112056625972536089/639394758556165795389409632273204082315570195568283997,-4643673306114137194246405438621737986777136981669455366891/792357112508927162831523598716476135398805168603340302571,-132380387483397439515712191823754241902625865986030572537/76633591802871327444400696979740925700820622309743028722,-4444518426163790439638724058079647305423114527848611319513/1782348795553046586284976007346320267646411866668317187979,-86088168905343279102705521659836932891994360681374727547/19798016538707040556039936138616495836804137927092310510,6698028943432657034750947560067844817248659306486162374333/369678866940339247777968215943201290945365077598172131297,3712473350425588177322764420584478632340397605579605354837/325520989102759799225348168786035350124653885786291712253,566899401349783027235971273538159214798566398613588791181/1238247279989507976204612997559873440651361913997047869789,-265721992112858895832662213231058217305105502430996476701/3541952972989974828427245853898815608255912126407481679931,72345928387813974694091553261517986746351864573675152657/109205539245548207949545001551473450683359414775467068126,410172508515886545084953017025317293131305610547675013302/293045151238449967866965730208442818305718362244629054689,963554005416463273879880614746542838619522274162472027537/699656261136496985674671817199540752020140803548230540975,1025355252357101497673561566593342132033371764396914090806/693077307953082594694517411017267842676064647062172326063,969476640432699545808756560182262677706287781844611984238/523672681215981784027132331870838102060221729185004478011,278705938886114249548459953078450129275273837061490686951/40488162128680176709477269772740469548634416138432825785,397464632543025628704529031795012416571407985219710560358/249069965021975547866668122575929736221842915922005581683,619671429999793128082976467918003071646691740586809044837/24605204915121756002295664203126660824788690034992161922,168157138665652951101198496636957082354440723916252245057/155114513369193998844370483558579077916417012893026271177,13348457048530116283621860716118382006408857656527292007/50518499985227509708400338291924928005595523730861009967,1363473969886669082218140932164881617781627754597992388371/62833404450103991354952663163867703094697770905156293541,234563340295592781167520676921188672419573360861840990071/7332668138759047208174570797089936110003957520612500793,35377453207161710546191994929574027280384929548502834623/221753943731564938334923161421475038738029586977227757,489049824399723747599913401048949455398838422341764401839/15530209114292507822600887003280640473550139289932684801,309662461166606742157049532822045940958538032108891185191/58478685329152092323133455791570943765766244903800388097,-3584688869460052048455304922740688344086632334048071193161/480574310721924699540271936483164757901374059873572580100,-4468062780241735461973413002761942219277732118172403357609/601172098104062469398383807791737277747777846790255593571,-408873311398892549921040052937005226106066156707436927211/466385323568436781542016579341617369816460288905039255683,-328987239631673774547075143804275613306617759573987092697/427979062763824904994795911410008320555316780445066206967,-1951190699330264070532300012073946128159631579477625131693/201120177926980943698387314106449801623942253774583770587,-13673926010735406809104058395353047287343153720640881143799/2237574302371115856950275304450776268055771139475524806779,-2451340179610564951228279251334676627573908826313149475443/1197758792252433092282769267570641045810893888909518476893,-6591477793132578908022305945958961827660544782812695071527/9349742455379431736199963528646043146309508812121683597029,-125664131429567590331519738132275530132676736383367517725/126985680559987100245704467247513842677379655255029870653,-19978029505865328191808516428070100743077003054857228093/16227086674808854034856169647432510599881345938496490741,-90283038017653630749371704840564565650512757747268522273/3057462175896467192891268587807785927240998142223998201,-2713758156050670484969255894027086722063367925911399690/3069174383777744552852751745636391139654088471390933207,-435681382648138542924062022763164617946025782037511961653/262236069606507207539460586872884122882793275022078458345,1438717749845507274173299459040259275522353925967637957379/1130775833868764613752393045968083895982722895197480393775,11582285523717812653889368031560292496871186968169304753597/9736616760815255142167584841329487610607256884812888876997,-734371726282452318849739266941026436475725221836907134423/7334078286893567390637823059915363814310210208611531351461,979635503906157376809211373465283507636463702691011080277/421159123287796730790887316504406089142355186626925958441,579848875983936963253336811011504469127787648188854756953/465002737547111388394263831140185841581112617089852287105,-61324217362293802777961792630598269640575524279609643989/1530722427420611727609832800168493322690684079619468102583,23091059351315483429173939320302280564600630888727180977/29348317928032333953553358464762843913171540046341914645,10925022622406393393568752143317209155246188924791234629/5633609502427017694494180074622498788149451220539020981,817848741488064815674144709758829694055841182386515203471/50512288323721838382479497348998421388531661973137730077,57340192468622213616166904682061137080903019295506633853/10413730004587800439028332498942500587167764785372587293,26833296602977106524646175362160751527034449110664412221/18262671390292173210092572434187028245697430016397196265,-197338815616515144613883045883255525521308498375006122951/32576989988612829565423895066829411539800777701913708057,3605887819329099200882457723191662123109456925459355203/3016565122104397622559853823473750014309455003393006555,687973388256730100839259056285162473887055238909990535311/501723839668850010525115022554295428668868943280826514351,1,-3194191600641701112759008045945113436158266675255401231599/78916931772519297132170470539397951179773771664065829903,-546389372090577987812101800536234780050152478772855352311/2032906010998798372686154811081186563057378806332752061533,-321283490328156942567413916017882847415182237147721646/48533048101446231088351283619308878640567888392499291101,-781809901742254317368639781003529467230196487030178711050/94181337417173503973107538967464570971905972445789454703,-510508106519996090845110368253767690121082870997726786911/184633504215714544219747100706440658294865214812964404523,160057210209769345959055331871738738707145752122937749496/98149310306778122406926749279545466825299610417443799311,-288631554689102575578583573886596978611327831260981525905/179982402898165189283414260808901605980925807381791115181,-20512739683358037750591982814841358366990091918359487267/20063345794322511205222449826380152886211605376422114435,-1064985392571656307407841362782211828472886098832486155335/4281287170502072675319563874342169742192478549869839444593,-302502547605673878914632915657820466976139912435658491521/1771025997277877801447490184858177643768459282686253984963,-651551578514109230371648292538372499285060898237139291691/1618479985868702054123567156288820162889448074541428300587,3887715024054411825987654951944226588594323913338634038489/4110378782444936344578272569290864522016976645337544487367,1584493493319373588106006649698679256105510066799453490181/1548163222810860715112338616444471573969319555350687376721,390352377456098969152724129416422400324562578403409283019/350881155696393263579585155426415135108997705856359880314,19276581363663813268629657310647003656865295468368894583/213888218548988548309661215248300835515382118721343951451,127821399272656754347174081457307280671530021363366966723/90938201388057897058869818401991856109151956984839418023,-102670089629480397158953748406898737665850164923994289011/1932105109777102835254355580276370786867720987086805930535,-166939793547455527691299833088944220235540602232391521572/3221592685212636744674078715989912836481135048893126686995,976213829960174303662176024560920947659113283527865849611/2153052960520629789786534961824164869528745099417581412251,2370145803304996130639661733509694174702384823908460698371/4071813729568196584218843888088763875303370508702946794721,8304355576242246169798840897053949676028257150661352528883/10628850234672168034149815972612898636587065847455198771473,-278655766194466015693111121870807695305752283376694727193/5927618898135807900513310269604229890633310052438270531979,1542310370585983162221178219743973039541185077145009679187/3134027163031966126770903144345160689337627699077775991885,1353333074962856422416162160851575483881123129953239913629/3200795438781913237009900040802376195537458801014937435395,-61217473544149265708093962904221581112458857539863666399/1637805380232665474315261889552685836368683148803507381654,-2838174433345522947195099257375601956131969493149538960885/2341943516179721500086731558492968415924713335183195495429,-236675471409454182003366623993631725897033782107562545703/330343993893680785256584040039921664003292856842609951603,-189435862254370129535768841144365349943041735519417571687/375232544751566189127584010661061376364094315443312161211,-375614621948814761301364535310355607951896055647345638236/1944046521091083057646184268600592692306225527561021988985,-7304814443060087690712373378778263889081868002183148864143/12524375967254985702526528788411538818162734191476989954111,-640920442198066002289322267200650197093779522826880520987/3307544982605772998477250236876791782403818194680917416639,203172498138812954816526014067659604928660611059404416455/780988823083207881772664605629313708097593059663593386352}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,2,3,5,12,13,54,61,73,74,75,78,85,91,92,103,104,107,108,140,141,142},{13,76,77,78,83,84,85,113,115,137,139,140,142,143},{9,130,131,136,144,164,165,167,168},{10,11,14,21,22,32,103,104,105,106,107,108,109,110,111,112,160,161,162,163},{0,1,2,3,4,5,6,7,8,172,173,174,175,176},{54,57,61,68,74,86,90,91,92,95},{15,16,17,18,19,20,130,131,134,135,136,157,158,159,165,166,167,169},{26,27,28,40,41,47,123,125,126,128,129,145,148,149,151,152},{24,27,28,29,31,47,52,53,62,94,97,117,118,121},{60,61,63,64,65,66,67,68,72,73,74,75,76,77,79,81,83,84,86,87,88,89,90,93},{18,19,20,38,39,98,99,100,101,102,119,120,124,153,154,156,157,159},{35,36,37,54,56,57,61,64,67,68,69,70,71,72,73,103,104,105,110,111},{1,2,3,4,86,87,88,89,90,91,92,93,94,95,96,97,100,101,102,114,116,117,118,119,120,127,132,133,138,141},{9,11,12,13,14,15,17,18,20,21,48,49,79,80,81,82,83,84,85,98,99,106,107,108,109,115,130,131,137,143,144},{6,8,10,23,32,161,162,171,172,173},{34,35,36,55,56,69},{33,37,48,50,70,71,82,105,106,109,110,112},{16,17,18,19,65,76,79,80,83,87,93,99,100,102,113,114,115,116},{22,23,25,26,32,33,34,35,36,37,110,111,112,147,148,149,150,160,161,171},{128,129,151,152,155,170},{16,17,113,114,115,116,130,133,134,136,137,138,139,144},{38,39,40,41,42,43,44,45,46,124,125,128,145,146,152,153,155,156},{3,4,5,6,7,8,10,11,12,23,24,25,29,30,32,34,35,54,55,56,57,92,94,95,104,107,111,117,121,122},{9,14,15,21,22,131,150,158,160,163,164,165},{29,30,31,52,55,56,57,58,59,60,62,66,67,68,69,86,89,94,95,96,97},{25,26,27,30,31,33,34,36,37,41,42,43,45,46,47,50,51,53,55,58,59,62,63,64,66,67,69,70,145,146,147,148},{42,43,44,52,53,58,62},{145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176},{48,49,50,51,63,64,65,70,71,72,79,80,81,82},{16,19,102,116,120,132,133,134,135,154,159,166},{71,72,73,75,77,78,81,82,84,85,103,105,106,108},{1,4,7,117,118,119,120,121,122,123,124,125,126,127,128,129,132,135,153,154,155,166,169,170,174,175},{38,40,42,44,46,52,58,59,60,88,89,96,101,119,124,125,126,127},{0,5,6,9,10,11,12,13,14,142,143,144,162,163,164,168,173,176},{24,28,40,41,43,44,47,52,53,96,97,118,121,122,123,126,127},{7,8,23,24,25,26,27,28,29,30,31,122,123,129,149,151,170,171,172,174},{15,20,21,22,33,39,45,48,49,50,51,98,109,112,146,147,150,156,157,158},{0,1,2,132,133,134,135,136,137,138,139,140,141,142,143,144,167,168,169,175,176},{38,39,45,46,49,51,59,60,63,65,66,80,87,88,98,99,100,101},{74,75,76,77,78,90,91,93,113,114,138,139,140,141}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 3, nvert: 29
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{61947507911705/303239389519673,-1,201020490250925/715145170532099,138829983820855/272721311099659,1,-1,-155297148808763/191538489737252,203736008364671/378329834562611,1,1,62925988433329/73981602346039,127806921798509/309312754903917,-291123699554855/314315013475929,4529609669861/7090149607345,-1,12612312043525/172474035998403,-41013627424232/103280421605823,-138443488942961/490185630626583,-4981693075533/238731982814458,34368989023233/54724013075657,-90876947838529/244063816906069,-17941553902405/226208499082376,-4883726915410/245867204194261,70354234875843/112692055905913,1,-173639664577767/208915173698891,-65566825209967/517514225045025,-53157148644423/197186174132980,-88147833849041/345966060077593},{162131719882857/303239389519673,-11475663481277/220808619788124,1,1,-41676404499452/146759797345701,-384737245047159/504010907088253,-17372726776439/95769244868626,1,-112356614035257/475959876898231,34827364317835/316347657825691,16757801089623/73981602346039,-1,10377289217231/104771671158643,-1,-48599894492143/183999116008438,-1,-43449469476593/206560843211646,-1,-17184749583835/34104568973494,-138492539405915/383068091529599,1,-1,200660760123549/245867204194261,45371193469834/112692055905913,348212991218747/612479291774851,157958574650771/208915173698891,-115227840537813/172504741681675,-23998365415069/39437234826596,1},{-1,-38941844083579/55202154947031,283388767756257/715145170532099,111370439894983/272721311099659,10156708561058/48919932448567,12437160852691/504010907088253,1,-86643868134197/378329834562611,16686085750467/43269079718021,-180021984191261/316347657825691,1,154519755202951/309312754903917,1,-13061178320737/163073440968935,99922753302679/183999116008438,-55082797881262/57491345332801,-1,-1640226895267/163395210208861,-1,-1,-155374272886415/244063816906069,143707809658063/226208499082376,1,-1,-97128231307411/612479291774851,-1,1,1,85596912064347/345966060077593}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,-1,0,-1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,0,-1,0,-1,-1,0,-1,-1,-1,-1,-1,-1,-1,-1,-1},{353935021904882448602340355165326919593290/844802613568466557821173167909315722476039,1667414844358044999255011895887472620254666/3502709990713139546500268477820394077869335,-8490618007202726632050534/1736171867694355132288436419,1,1376193064831999792363983609518487532804342/1509942813576186322526760706909325551481979,-174347903175926829932728511782025376806939/57583955073960217899820746649818733948677,-14353183209056470741969547674/4512623831589311039898589159,-3387162251661863775410123876469722195909675/53340799791869140510086972477145007881624,-933572766401747338028178500037405824762353/69370563955706954098653508449455313716424,1325250462321211409859645371/1033935467895876033927458234,15039133641440993656707654680331292011066496/16736046038290108770763271139174744272805453,214718850531305339282828101953993264945532/313661065581930927083361077720787434999017,1581258461769124492281677073663803109021073/531123618510032023096607853276995055114105,5110202664317163660526539536/4032932571054478756605883875,580752157425523460157713578381789769574027/1096720278044868824917571158310766172099214,6949168318858735463986192633/16883968614405400923204641298,0,-1176376262964266490502628289029633394436696/7028351671546765195780540967047179816038505,-2245229150482721527941314928028295034719456/10313326995020581549192233791558230820222235,1702765212314625046748838278/3791391803200007097094967039,-180509708688328022688672667062281459533648/185637438868355138099245008718491580113447,-53343129337639427070318795641171522344523/31697269671957404014928093831680808186238,10160781049930684972369556609946101989379449/7314375441742344628321638928234606999446665,13136711408776807798661662013348733774575416/4267409047216721967246800794931557418752035,2916141834624510844442146783/1213306737427104359969741919,-70042741393012373157191521265/55416384261455948927720018148,-32798080129275064013184664673/7013742662535241526749153148,627132020395988315179137646137676420033811/163187217025400668888208107945059247618527,-1,565173008923275601775660193/123980057600692015179507677,0,18707916464521243945100704469/17123310638969372233053046848,-2261820398555073906580640837/1532144408509310585189645544,0,85025577606717573444967997225304531079382/129222426211608502942687482730011892229475,1887211442880633522995000372184277794604100/2657763251905268255668993697360941188319409,14082938304572337476393696578250175124563/24902052516788045297663950025565255446455,-8432448549995697907036856646562833512985/77355908003634268212714393704382255610709,-1574784579335597828998151380569934716258330/1630894049457305182990723513278212997244447,-1495508933768087203029831515379574129653513/2143424625832024179026918443367045662901192,-106360590726309426783778412820197407830909/98746090338325467352382825975675709393394,-336727292536956878494031448040446389297770/693542817107384318190260997155268975848327,0},{538732823887497808222500573857652617739022/2534407840705399673463519503727947167428117,239693136313077941887198450929790370357966/700541998142627909300053695564078815573867,102779312172661244654974473671123066490554/118342399704289719865777425757818852153085,0,15911788285429808128231439734/24694910026208915756328004899,42053024241997055541036863759/18818044894032559987886543986,497510783700903996148615601575908911851603/200111274977939950094413998966610183665493,-22230510397702704040425595035/1179937968764660340521371477,-5524365194874427959614620441/1534528215649905905308928127,1352908706273410955142948045293297226053849/104591870722768622429201541689255583929292,14653182618540086816181315884389873854624280/16736046038290108770763271139174744272805453,526539027648568404607372755903334599304257/313661065581930927083361077720787434999017,3340031269823034785741346262/8905966487841064688211509715,-7533866719887882704560715066066424907329623/7929935089074667819059646827753363869451000,-559281641211351799818595800313176246416469/1096720278044868824917571158310766172099214,-693592953814246323136464749222317495562381/1419542669137399708108628972010782313835182,0,-199903645625321985519197399351636147312044/7028351671546765195780540967047179816038505,-247376254386000117207574382235446164640777/10313326995020581549192233791558230820222235,2448468439350115064959412502093045436200481/1356282605153870738467569412884842534689816,-16825762490820194591063337159893870253391/61879146289451712699748336239497193371149,-4963321407186937635576125434/37322667050865727958179210519,-7090750472779804766129325517608815759262093/7314375441742344628321638928234606999446665,-22522401927443499161723723221/71556603095601247548540631905,-1030109271482314156498572961844347731191183/500493211604500093251573298807616469383235,-2239877779542033526076208323495970159796517/3607179189032485021942305051808969316097102,342229348725807269699791379343663293940749/77755704826430569153339229006126545996349,-34460563417189337670235197769/9496976603507491583042041195,0,352590777746542781353165251056286290460650/6270848887291908780912019900155755262963,1,-265602503379144613012305446789788027114905/147253812145418553469856279133537732714176,-20901506361148040342260461321581760233351/15450802195271891467870041377496544710234,-1,-349985506751102750209059314889546955640339/473815562775897844123187436676710271508075,-5691302266012246111276914718/14619028613650597316427477007,-758095477722863649497616635332061971891/4980410503357609059532790005113051089291,-12466879602806586768418495855427789096805/77355908003634268212714393704382255610709,445168767848548859217528328264384671908390/698954592624559364138881505690662713104763,-179486069830570463361446890174945981189275/535856156458006044756729610841761415725298,-759906627037533536447673696/16441097354234575352307804859,376067070282809360783364054663467163607144/693542817107384318190260997155268975848327,0}};
linealitydesired = map(QQ^3, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{6,26,30},{10,11,16,17,18,19},{7,8,28},{7,28,32,39,40},{0,36,42},{10,12,13,14,16,22,23},{13,14,15,33},{5,28,38,40},{34,35,36,37,42},{0,1,2,41,42},{31,32,33,34,37,39},{3,27,31,34,35},{15,17,18,20,25,33},{0,1,3,4,35,36},{14,15,16,17},{3,4,9,10,11,12,29},{9,11,19,30},{3,12,23},{9,29,30},{1,2,4,29,30},{5,6,21,26,28},{3,22,23,24,27},{7,8,25,32,33},{2,5,6,30,38,41},{37,38,39,40,41,42},{18,19,20,21,26,30},{24,27,31,33},{13,22,24,33},{8,20,21,25,28}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1,0,1},{0,0,1,1},{0,0,0,0}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,-1},{1,0,-1,0},{0,0,0,0}};
linealitydesired = matrix {{0},{0},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{0,3},{1,2},{2,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 1, nvert: 2
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{2,-2},{3,3}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1},{0,0}};
linealitydesired = matrix {{0},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0},{1}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,-1,1,-1},{3/2,3/2,-1/2,-1/2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,-1},{1,0,-1,0}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{2,3},{1,2},{0,3},{0,1}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{2,1,-1,-2,-1,1},{0,1,1,0,-1,-1}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,1,0,-1,-1},{-1,1,-1,1,1,-1}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{4,5},{0,5},{0,2},{1,2},{1,3},{3,4}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 4
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{1,-1,1,-1},{0,0,2,2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,0,-1},{1,0,-1,0}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,3},{0,1},{2,3},{1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 2, nvert: 3
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{2,0,1},{0,2,1},{0,0,1}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,0,1},{0,0,0},{-1,1,-1}};
linealitydesired = matrix {{1},{1},{0}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{1,2},{0,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 1, nvert: 2
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1},{0,0}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1},{0,0}};
linealitydesired = matrix {{0},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1},{0}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 4, dim: 4, nvert: 14
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{9,7,8,3,3,7,2,5,2,5,4,5,9,5},{0,7,5,6,4,0,3,3,5,0,6,2,5,1},{9,8,1,3,2,3,2,9,8,0,2,7,9,7},{0,7,2,3,6,5,3,1,2,8,6,9,6,0}};
raysP = map(QQ^4, QQ^0, 0);
linealityP = map(QQ^4, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,-1,-1,1,1,1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,-1,-1,-1,-1,0,1,1,-1,0,-1,-1,-1,-1,1,-1,-1,-1},{5,-23/5,17/3,20/3,252/97,18/13,-47/6,-50/33,-110/171,18/17,-16/31,-17/47,-1/2,-1/2,-1/2,13/89,-1/2,-1/2,13/44,189/190,162/185,-23/18,-41/42,-31/14,-1,-23/32,-85/28,-50/7,-109/142,-10,1,6/37,-5/37,-7/36,-1,-63/164,19/180,-123/56,25/39,24/13,30/37,3/16,-24/13},{9/2,-3/10,-4/3,4/3,-68/97,-17/13,29/6,-2/11,-46/171,-1,17/31,4/47,1/2,1/28,11/6,-10/89,-15/76,3/8,-1/44,-51/190,-57/185,17/6,157/42,6/7,0,37/32,-6/7,-6/7,113/142,2,1,-131/37,-119/37,1/4,-8/5,81/164,11/36,-5/7,-1/13,-92/13,-17/74,13/64,-67/104},{5,49/5,-2,2,-28/97,-2/13,-109/6,-13/33,-127/171,-2/17,70/31,-10/47,-1/6,-9/28,-1/6,-34/89,-51/76,-13/8,-19/44,-21/190,-18/185,11/18,13/42,11/2,2,109/32,31/14,27/7,-143/142,1,1,-32/37,-35/37,-49/36,2/5,-121/164,-13/36,47/28,-29/39,-20/13,-25/37,-5/32,20/13}};
linealitydesired = map(QQ^4, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1,2,3,4,5,39,40,41,42},{6,7,8,26,27,28,29,32,33,34,35,37},{0,1,21,22,23,24,25,26,27,28,29,30,35,36,37,41,42},{7,10,11,12,13,21,23,25,27,29},{11,12,13,14,15,16,17,18},{0,2,3,30,36,38,40,41},{10,11,12,14,15,18,19,20,21,22,25,30},{1,5,9,24,26,31,34,37,39,42},{7,8,9,10,11,13,15,16,20,23,24,26,27,31,32,34},{2,3,4,6,14,17,18,19,22,28,30,33,35,36,38},{6,7,8,12,13,14,16,17,21,22,28,29},{2,4,5,6,8,9,15,16,17,18,19,20,31,32,33,38,39,40},{31,32,33,34,35,36,37,38,39,40,41,42},{0,1,3,4,5,9,10,19,20,23,24,25,30}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 1, dim: 1, nvert: 2
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,1}};
raysP = map(QQ^1, QQ^0, 0);
linealityP = map(QQ^1, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{-1,1}};
linealitydesired = map(QQ^1, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1},{0}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,0,1,3/2,5/2,5/2},{0,1/2,5/2,5/2,0,1/2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,1,0,-1,-1},{1,0,-1/2,-1,-1/2,0}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{1,2},{2,3},{3,4},{0,5},{4,5}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 3, dim: 1, nvert: 2
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0},{0},{0}};
raysP = matrix {{1},{0},{0}};
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1},{0},{0}};
linealitydesired = matrix {{0,0},{1,0},{0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 3, dim: 0, nvert: 1
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0},{0},{0}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0},{0},{0}};
linealitydesired = matrix {{1,0,0},{0,1,0},{0,0,1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 5
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{-3/2,2,1/2,4},{0,4,4,0}};
raysP = matrix {{0},{-1}};
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,1,-1,-1},{-1,0,-1/2,0,-1/2}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{1,2},{0,4},{0,2},{3,4},{1,3}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(not isPure computed)
assert(not isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 2, dim: 2, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,0,1,3/2,5/2,5/2},{0,1/2,5/2,5/2,0,1/2}};
raysP = map(QQ^2, QQ^0, 0);
linealityP = map(QQ^2, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,1,0,-1,-1},{1,0,-1/2,-1,-1/2,0}};
linealitydesired = map(QQ^2, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{0,1},{1,2},{2,3},{3,4},{0,5},{4,5}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

-- Test ambDim: 7, dim: 7, nvert: 21
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{0,-2/3,1/3,-1/3,1/3,-1/3,2/3},{0,-2/3,1/3,-1/3,1/3,-1/3,2/3},{0,1/3,-2/3,-1/3,1/3,2/3,-1/3},{0,1/3,-2/3,-1/3,1/3,2/3,-1/3},{0,1/3,1/3,2/3,1/3,2/3,2/3},{0,1/3,1/3,2/3,-2/3,-1/3,-1/3},{0,1/3,1/3,2/3,-2/3,-1/3,-1/3}};
raysP = matrix {{0,1,-1,1,0,0,1,1,0,1,1,1,0,0},{0,1,1/2,-2,0,0,1,1,1,0,1,1,0,0},{0,-2,1/2,1,0,1,1,1,0,0,1,1,0,0},{0,1,1/2,1,1,0,-2,1,0,0,1,1,0,0},{0,1,1/2,1,0,0,1,1,0,0,1,-2,1,0},{0,1,1/2,1,0,0,1,-2,0,0,1,1,0,1},{1,1,1/2,1,0,0,1,1,0,0,-2,1,0,0}};
linealityP = map(QQ^7, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{0,1,1,0,1,0,0,1,1,1,1,1,0,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,0},{1,0,0,1,0,1,0,1,1,1,1,1,0,0,1,1,0,0,1,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,1},{0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,0,0,1,1,1,1,0,1,1,0,0,1,1,1,0,0,1,1,0,0},{0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,0,0,1,1,1,0,0,1,1,0,0,0,1,1,0,0,1,1},{0,0,1,1,1,1,1,0,0,1,0,0,1,0,0,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0},{1,1,0,0,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,1,0,1,1,1,1,0,0,1,1,1,1,0,0,0,0},{1,1,1,1,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,0,0,0,0,1,1,1,1}};
linealitydesired = map(QQ^7, QQ^0, 0);
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{2,3,4,5,15,16,17,18,23,24,25,26,27,28,29,30,31,32,33,34},{2,3,4,5,7,8,9,10,11,15,16,17,18,27,28,29,30,31,32,33,34},{12,13,14,15,16,17,18,19,20,23,24,25,26,27,28,29,30,31,32,33,34},{7,8,13,14,15,16,17,18,27,28,29,30,31,32,33,34},{0,1,2,3,4,5,6,21,22,23,24,25,26,27,28,29,30,31,32,33,34},{0,1,2,3,4,5,10,11,27,28,29,30,31,32,33,34},{19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(not isSimplicial computed)
assert(not isComplete computed)
///

-- Test ambDim: 3, dim: 2, nvert: 6
-- Checking normal_fan + several booleans
TEST ///
verticesP = matrix {{46544002/2147483647,545267103/2147483647,685763911/2147483647,2053499339/2147483647,35971982/2147483647,16793300/2147483647},{160667466/2147483647,41918660/2147483647,1439690497/2147483647,51524704/2147483647,1362882672/2147483647,720386802/2147483647},{1940272179/2147483647,1560297884/2147483647,22029239/2147483647,42459604/2147483647,748628993/2147483647,1410303545/2147483647}};
raysP = map(QQ^3, QQ^0, 0);
linealityP = map(QQ^3, QQ^0, 0);
verticesP = promote(verticesP, QQ);
raysP = promote(raysP, QQ);
linealityP = promote(linealityP, QQ);
P = convexHull(verticesP,raysP,linealityP);
raysdesired = matrix {{1,1,1,1,-1,-1},{-649791929/76807825,-3196447/107082645,14875351/279859668,498723101/118748806,53865437/343073,-1367735428/1388165793},{0,0,0,0,0,0}};
linealitydesired = matrix {{1},{1},{1}};
raysdesired = promote(raysdesired, QQ);
linealitydesired = promote(linealitydesired, QQ);
maxConesdesired = {{2,3},{3,4},{0,5},{4,5},{0,1},{1,2}};
desired = fan (raysdesired ,linealitydesired ,maxConesdesired);
computed = normalFan P;
assert(computed == desired)
assert(isPolytopal computed)
assert(not isSmooth computed)
assert(isPure computed)
assert(isSimplicial computed)
assert(isComplete computed)
///

